
;;; company-terraform-data.el --- Terraform documentation as elisp lists and hashes

;; THIS FILE WAS AUTOMATICALLY GENERATED. DO NOT EDIT.

;;; Code:

(defconst company-terraform-toplevel-keywords '(
    ("resource" "Defines a new resource")
    ("variable" "Defines a variable or module input")
    ("data" "Defines a new data source")
    ("output" "Defines an output value or module output")
    ))

(defconst company-terraform-interpolation-extra '(
    ("module." "References a module")
    ("var." "References a variable")
    ("data." "References a data source")
    ("count." "Resource index metadata")
    ))

(defconst company-terraform-resource-extra '(
    ("count" "count (int) - The number of identical resources to create. This doesn't apply to all resources.")
    ("depends_on" "depends_on (list of strings) - Explicit dependencies that this resource has. These dependencies will be created before this resource.")
    ("provider" "provider (string) - The name of a specific provider to use for this resource. The name is in the format of TYPE.ALIAS, for example, aws.west. Where west is set using the alias attribute in a provider.")
    ("lifecycle" "Customizes the lifecycle behavior of the resource.")
    ))

(defconst company-terraform-data-extra '(
    ("count" "count (int) - The number of identical resources to create. This doesn't apply to all resources.")
    ("depends_on" "depends_on (list of strings) - Explicit dependencies that this resource has. These dependencies will be created before this resource.")
    ("provider" "provider (string) - The name of a specific provider to use for this resource. The name is in the format of TYPE.ALIAS, for example, aws.west. Where west is set using the alias attribute in a provider.")
    ))

(defconst company-terraform-count-extra '(
    ("index" "index (int) - Current counted resource index.")
    ))

(defconst company-terraform-resource-arguments-hash
      (make-hash-table :test 'equal))
(defconst company-terraform-data-arguments-hash
      (make-hash-table :test 'equal))
(defconst company-terraform-resource-attributes-hash
      (make-hash-table :test 'equal))
(defconst company-terraform-data-attributes-hash
  (make-hash-table :test 'equal))
(defconst company-terraform-resources-list '(
    ("alicloud_disk" "Provides a ECS disk resource.\n\n NOTE: One of size or snapshot_id is required when specifying an ECS disk. If all of them be specified, size must more than the size of snapshot which snapshot_id represents. Currently, alicloud_disk doesn't resize disk.")
    ("alicloud_disk_attachment" "Provides an Alicloud ECS Disk Attachment as a resource, to attach and detach disks from ECS Instances.")
    ("alicloud_instance" "Provides a ECS instance resource.\n\n NOTE: You can launch an ECS instance for a VPC network via specifying parameter vswitch_id. One instance can only belong to one VSwitch. \n\n NOTE: If a VSwitchId is specified for creating an instance, SecurityGroupId and VSwitchId must belong to one VPC. \n\n NOTE: Several instance types have outdated in some regions and availability zones, such as ecs.t1.*, ecs.s2.*, ecs.n1.* and so on. If you want to keep them, you should set is_outdated to true. For more about the upgraded instance type, refer to alicloud_instance_types datasource. \n\n NOTE: At present, 'PrePaid' instance cannot be deleted and must wait it to be outdated and release it automatically. \n\n NOTE: The resource supports Spot Instance from version 1.5.4.")
    ("alicloud_security_group" "Provides a security group resource.\n\n NOTE: alicloud_security_group is used to build and manage a security group, and alicloud_security_group_rule can define ingress or egress rules for it. \n\n NOTE: From version 1.7.2, alicloud_security_group has supported to segregate different ECS instance in which the same security group.")
    ("alicloud_security_group_rule" "Provides a security group rule resource. Represents a single ingress or egress group rule, which can be added to external Security Groups.\n\n NOTE: nic_type should set to intranet when security group type is vpc or specifying the source_security_group_id. In this situation it does not distinguish between intranet and internet, the rule is effective on them both.")
    ("alicloud_eip" "Provides an elastic IP resource.\n\n NOTE: The resource only support to create PayByTraffic elastic IP for international account. Otherwise, you will happened error COMMODITY.INVALID_COMPONENT. Your account is international if you can use it to login in International Web Console.")
    ("alicloud_eip_association" "Provides an Alicloud EIP Association resource for associating Elastic IP to ECS Instance, SLB Instance or Nat Gateway.\n\n NOTE: alicloud_eip_association is useful in scenarios where EIPs are either  pre-existing or distributed to customers or users and therefore cannot be changed. \n\n NOTE: From version 1.7.1, the resource support to associate EIP to SLB Instance or Nat Gateway. \n\n NOTE: One EIP can only be associated with ECS or SLB instance which in the VPC.")
    ("alicloud_key_pair" "Provides a key pair resource.")
    ("alicloud_key_pair_attachment" "Provides a key pair attachment resource to bind key pair for several ECS instances.")
    ("alicloud_slb" "Provides an Application Load Balancer resource.\n\n NOTE: Resource alicloud_slb has deprecated 'listener' filed from terraform-alicloud-provider version 1.3.0 . You can create new listeners for Load Balancer by resource alicloud_slb_listener. If you have had several listeners in one load balancer, you can import them via the specified listener ID. In the alicloud_slb_listener, listener ID is consist of load balancer ID and frontend port, and its format is \":\", like \"lb-hr2fwnf32t:8080\". \n\n NOTE: At present, to avoid some unnecessary regulation confusion, SLB can not support alicloud international account to create \"paybybandwidth\" instance.")
    ("alicloud_slb_attachment" "Add a group of backend servers (ECS instance) to the Server Load Balancer or remove them from it.")
    ("alicloud_slb_listener" "Provides an Application Load Balancer Listener resource.")
    ("alicloud_slb_rule" "A forwarding rule is configured in HTTP/HTTPS listener and it used to listen a list of backend servers which in one specified virtual backend server group. You can add forwarding rules to a listener to forward requests based on the domain names or the URL in the request.\n\n NOTE: One virtual backend server group can be attached in multiple forwarding rules. \n\n NOTE: At least one \"Domain\" or \"Url\" must be specified when creating a new rule. \n\n NOTE: Having the same 'Domain' and 'Url' rule can not be created repeatedly in the one listener. \n\n NOTE: Rule only be created in the HTTP or HTTPS listener. \n\n NOTE: Only rule's virtual server group can be modified.")
    ("alicloud_slb_server_group" "A virtual server group contains several ECS instances. The virtual server group can help you to define multiple listening dimension, and to meet the personalized requirements of domain name and URL forwarding.\n\n NOTE: One ECS instance can be added into multiple virtual server groups. \n\n NOTE: One virtual server group can be attached with multiple listeners in one load balancer. \n\n NOTE: One Classic and Internet load balancer, its virtual server group can add Classic and VPC ECS instances. \n\n NOTE: One Classic and Intranet load balancer, its virtual server group can only add Classic ECS instances. \n\n NOTE: One VPC load balancer, its virtual server group can only add the same VPC ECS instances.")
    ("alicloud_vpc" "Provides a VPC resource.\n\n NOTE: Terraform will auto build a router and a route table while it uses alicloud_vpc to build a vpc resource.")
    ("alicloud_vswitch" "Provides a VPC switch resource.")
    ("alicloud_route_entry" "Provides a route entry resource. A route entry represents a route item of one VPC route table.")
    ("alicloud_nat_gateway" "Provides a resource to create a VPC NAT Gateway.\n\n NOTE: From version 1.7.1, the resource deprecates bandwidth packages. And if you want to add public IP, you can use resource 'alicloud_eip_association' to bind several elastic IPs for one Nat Gateway. \n\n NOTE: Resource bandwidth packages will not be supported since 00:00 on November 4, 2017, and public IP can be replaced be elastic IPs. If a Nat Gateway has already bought some bandwidth packages, it can not bind elastic IP and you have to submit the work order to solve.")
    ("alicloud_router_interface" "Provides a VPC router interface resource to connect two VPCs by connecting the router interfaces .\n\n NOTE: Only one pair of connected router interfaces can exist between two routers. Up to 5 router interfaces can be created for each router and each account.")
    ("alicloud_forward_entry" "Provides a forward resource.")
    ("alicloud_snat_entry" "Provides a snat resource.")
    ("alicloud_db_account" "Provides an RDS account resource and used to manage databases. A RDS instance supports multiple database account.")
    ("alicloud_db_account_privilege" "Provides an RDS account privilege resource and used to grant several database some access privilege. A database can be granted by multiple account.")
    ("alicloud_db_backup_policy" "Provides an RDS instance backup policy resource and used to configure instance backup policy.\n\n NOTE: Each DB instance has a backup policy and it will be set default values when destroying the resource.")
    ("alicloud_db_connection" "Provides an RDS connection resource to allocate an Internet connection string for RDS instance.\n\n NOTE: Each RDS instance will allocate a intranet connnection string automatically and its prifix is RDS instance ID.  To avoid unnecessary conflict, please specified a internet connection prefix before applying the resource.")
    ("alicloud_db_database" "Provides an RDS database resource. A DB database deployed in a DB instance. A DB instance can own multiple databases.\n\n NOTE: At present, it does not support creating 'PostgreSQL' and 'PPAS' database. You have to login RDS instance to create manually.")
    ("alicloud_db_instance" "Provides an RDS instance resource. A DB instance is an isolated database environment in the cloud. A DB instance can contain multiple user-created databases.")
    ("alicloud_ess_attachment" "Attaches several ECS instances to a specified scaling group or remove them from it.\n\n NOTE: ECS instances can be attached or remove only when the scaling group is active and it has no scaling activity in progress. \n\n NOTE: There are two types ECS instances in a scaling group: \"AutoCreated\" and \"Attached\". The total number of them can not larger than the scaling group \"MaxSize\".")
    ("alicloud_ess_scaling_group" "Provides a ESS scaling group resource which is a collection of ECS instances with the same application scenarios.\n\nIt defines the maximum and minimum numbers of ECS instances in the group, and their associated Server Load Balancer instances, RDS instances, and other attributes.\n\n NOTE: You can launch an ESS scaling group for a VPC network via specifying parameter vswitch_ids.")
    ("alicloud_ess_scaling_configuration" "Provides a ESS scaling configuration resource.\n\n NOTE: Several instance types have outdated in some regions and availability zones, such as ecs.t1.*, ecs.s2.*, ecs.n1.* and so on. If you want to keep them, you should set is_outdated to true. For more about the upgraded instance type, refer to alicloud_instance_types datasource.")
    ("alicloud_ess_scaling_rule" "Provides a ESS scaling rule resource.")
    ("alicloud_ess_schedule" "Provides a ESS schedule resource.")
    ("alicloud_oss_bucket" "Provides a resource to create a oss bucket and set its attribution.\n\n NOTE: The bucket namespace is shared by all users of the OSS system. Please set bucket name as unique as possible.")
    ("alicloud_oss_bucket_object" "Provides a resource to put a object(content or file) to a oss bucket.")
    ("alicloud_container_cluster" "NOTE: This resource name has been replaced by alicloud_cs_swarm from version 1.8.2. Please update it.")
    ("alicloud_cs_application" "This resource use an orchestration template to define and deploy a multi-container application. An application is created by using an orchestration template. Each application can contain one or more services.\n\n NOTE: Application orchestration template must be a valid Docker Compose YAML template. \n\n NOTE: At present, this resource only support swarm cluster.")
    ("alicloud_cs_swarm" "This resource will help you to manager a Swarm Cluster.\n\n NOTE: Swarm cluster only supports VPC network and you can specify a VPC network by filed vswitch_id.")
    ("alicloud_cs_kubernetes" "This resource will help you to manager a Kubernetes Cluster. The cluster is same as container service created by web console.\n\n NOTE: Kubernetes cluster only supports VPC network and it can access internet while creating kubernetes cluster. A Nat Gateway and configuring a SNAT for it can ensure one VPC network access internet. If there is no nat gateway in the VPC, you can set new_nat_gateway to \"true\" to create one automatically. \n\n NOTE: If there is no specified vswitch_id, the resource will create a new VPC and VSwitch while creating kubernetes cluster. \n\n NOTE: Each kubernetes cluster contains 3 master nodes and those number cannot be changed at now. \n\n NOTE: Creating kubernetes cluster need to install several packages and it will cost more than 30 minutes. Please be patient.")
    ("alicloud_cms_alarm" "This resource provides a alarm rule resource and it can be used to monitor several cloud services according different metrics. Details for alarm rule.")
    ("alicloud_dns" "Provides a DNS resource.\n\n NOTE: The domain name which you want to add must be already registered and had not added by another account. Every domain name can only exist in a unique group.")
    ("alicloud_dns_group" "Provides a DNS Group resource.")
    ("alicloud_dns_record" "Provides a DNS Record resource.")
    ("alicloud_ram_access_key" "Provides a RAM User access key resource.\n\n NOTE:  You should set the secret_file if you want to get the access key.")
    ("alicloud_ram_account_alias" "Provides a RAM cloud account alias.")
    ("alicloud_ram_alias" "NOTE: This resource has been deprecated from v1.3.2. New resource alicloud_ram_account_alias will replace.")
    ("alicloud_ram_group" "Provides a RAM Group resource.\n\n NOTE: When you want to destroy this resource forcefully(means remove all the relationships associated with it automatically and then destroy it) without set force  with true at beginning, you need add force = true to configuration file and run terraform plan, then you can delete resource forcefully.")
    ("alicloud_ram_group_membership" "Provides a RAM Group membership resource.")
    ("alicloud_ram_group_policy_attachment" "Provides a RAM Group Policy attachment resource.")
    ("alicloud_ram_login_profile" "Provides a RAM User Login Profile resource.")
    ("alicloud_ram_policy" "Provides a RAM Policy resource.\n\n NOTE: When you want to destroy this resource forcefully(means remove all the relationships associated with it automatically and then destroy it) without set force  with true at beginning, you need add force = true to configuration file and run terraform plan, then you can delete resource forcefully.")
    ("alicloud_ram_role" "Provides a RAM Role resource.\n\n NOTE: When you want to destroy this resource forcefully(means remove all the relationships associated with it automatically and then destroy it) without set force  with true at beginning, you need add force = true to configuration file and run terraform plan, then you can delete resource forcefully.")
    ("alicloud_ram_role_policy_attachment" "Provides a RAM Role attachment resource.")
    ("alicloud_ram_user" "Provides a RAM User resource.\n\n NOTE: When you want to destroy this resource forcefully(means release all the relationships associated with it automatically and then destroy it) without set force  with true at beginning, you need add force = true to configuration file and run terraform plan, then you can delete resource forcefully.")
    ("alicloud_ram_user_policy_attachment" "Provides a RAM User Policy attachment resource.")
    ("alicloud_ram_role_attachment" "Provides a RAM role attachment resource to bind role for several ECS instances.")
    ("alicloud_cdn_domain" "Provides a CDN Accelerated Domain resource.")
    ("alicloud_kms_key" "A kms key can help user to protect data security in the transmission process.")
    ("alicloud_ots_table" "Provides an OTS table resource.\n\n NOTE: Before creating an OTS table, OTS_INSTANCE_NAME needs to be passed by Environment Variable, or by setting the argument ots_instance_name under provider alicloud.")
    ("aws_acm_certificate" "The ACM certificate resource allows requesting and management of certificates from the Amazon Certificate Manager.\n\nIt deals with requesting certificates and managing their attributes and life-cycle. This resource does not deal with validation of a certificate but can provide inputs for other resources implementing the validation. It does not wait for a certificate to be issued. Use a aws_acm_certificate_validation resource for this.\n\nMost commonly, this resource is used to together with aws_route53_record and aws_acm_certificate_validation to request a DNS validated certificate, deploy the required validation records and wait for validation to complete.\n\nDomain validation through E-Mail is also supported but should be avoided as it requires a manual step outside of Terraform.")
    ("aws_acm_certificate_validation" "This resource represents a successful validation of an ACM certificate in concert with other resources.\n\nMost commonly, this resource is used to together with aws_route53_record and aws_acm_certificate to request a DNS validated certificate, deploy the required validation records and wait for validation to complete.\n\n WARNING: This resource implements a part of the validation workflow. It does not represent a real-world entity in AWS, therefore changing or deleting this resource on its own has no immediate effect.")
    ("aws_acmpca_certificate_authority" "Provides a resource to manage AWS Certificate Manager Private Certificate Authorities (ACM PCA Certificate Authorities).\n\n NOTE: Creating this resource will leave the certificate authority in a PENDING_CERTIFICATE status, which means it cannot yet issue certificates. To complete this setup, you must fully sign the certificate authority CSR available in the certificate_signing_request attribute and import the signed certificate outside of Terraform. Terraform can support another resource to manage that workflow automatically in the future.")
    ("aws_api_gateway_account" "Provides a settings of an API Gateway Account. Settings is applied region-wide per provider block.\n\n Note: As there is no API method for deleting account settings or resetting it to defaults, destroying this resource will keep your account settings intact")
    ("aws_api_gateway_api_key" "Provides an API Gateway API Key.\n\n Warning: Since the API Gateway usage plans feature was launched on August 11, 2016, usage plans are now required to associate an API key with an API stage.")
    ("aws_api_gateway_authorizer" "Provides an API Gateway Authorizer.")
    ("aws_api_gateway_base_path_mapping" "Connects a custom domain name registered via aws_api_gateway_domain_name with a deployed API so that its methods can be called via the custom domain name.")
    ("aws_api_gateway_client_certificate" "Provides an API Gateway Client Certificate.")
    ("aws_api_gateway_deployment" "Provides an API Gateway Deployment.\n\n Note: Depends on having aws_api_gateway_integration inside your rest api (which in turn depends on aws_api_gateway_method). To avoid race conditions you might need to add an explicit depends_on = [\"aws_api_gateway_integration.name\"].")
    ("aws_api_gateway_documentation_part" "Provides a settings of an API Gateway Documentation Part.")
    ("aws_api_gateway_documentation_version" "Provides a resource to manage an API Gateway Documentation Version.")
    ("aws_api_gateway_domain_name" "Registers a custom domain name for use with AWS API Gateway.\n\nThis resource just establishes ownership of and the TLS settings for a particular domain name. An API can be attached to a particular path under the registered domain name using the aws_api_gateway_base_path_mapping resource.\n\nInternally API Gateway creates a CloudFront distribution to route requests on the given hostname. In addition to this resource it's necessary to create a DNS record corresponding to the given domain name which is an alias (either Route53 alias or traditional CNAME) to the Cloudfront domain name exported in the cloudfront_domain_name attribute.\n\n Note: All arguments including the private key will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_api_gateway_gateway_response" "Provides an API Gateway Gateway Response for a REST API Gateway.")
    ("aws_api_gateway_integration" "Provides an HTTP Method Integration for an API Gateway Integration.")
    ("aws_api_gateway_integration_response" "Provides an HTTP Method Integration Response for an API Gateway Resource.\n\n Note: Depends on having aws_api_gateway_integration inside your rest api. To ensure this you might need to add an explicit depends_on for clean runs.")
    ("aws_api_gateway_method" "Provides a HTTP Method for an API Gateway Resource.")
    ("aws_api_gateway_method_response" "Provides an HTTP Method Response for an API Gateway Resource.")
    ("aws_api_gateway_method_settings" "Provides an API Gateway Method Settings, e.g. logging or monitoring.")
    ("aws_api_gateway_model" "Provides a Model for a API Gateway.")
    ("aws_api_gateway_resource" "Provides an API Gateway Resource.")
    ("aws_api_gateway_rest_api" "Provides an API Gateway REST API.")
    ("aws_api_gateway_stage" "Provides an API Gateway Stage.")
    ("aws_api_gateway_usage_plan" "Provides an API Gateway Usage Plan.")
    ("aws_api_gateway_usage_plan_key" "Provides an API Gateway Usage Plan Key.")
    ("aws_api_gateway_vpc_link" "Provides an API Gateway VPC Link.")
    ("aws_appautoscaling_policy" "Provides an Application AutoScaling Policy resource.")
    ("aws_appautoscaling_scheduled_action" "Provides an Application AutoScaling ScheduledAction resource.")
    ("aws_appautoscaling_target" "Provides an Application AutoScaling ScalableTarget resource. To manage policies which get attached to the target, see the aws_appautoscaling_policy resource.")
    ("aws_appsync_datasource" "Provides an AppSync DataSource.")
    ("aws_appsync_graphql_api" "Provides an AppSync GraphQL API.")
    ("aws_athena_database" "Provides an Athena database.")
    ("aws_athena_named_query" "Provides an Athena Named Query resource.")
    ("aws_batch_compute_environment" "Creates a AWS Batch compute environment. Compute environments contain the Amazon ECS container instances that are used to run containerized batch jobs.\n\nFor information about AWS Batch, see What is AWS Batch? . For information about compute environment, see Compute Environments .\n\n Note: To prevent a race condition during environment deletion, make sure to set depends_on to the related aws_iam_role_policy_attachment;    otherwise, the policy may be destroyed too soon and the compute environment will then get stuck in the DELETING state, see Troubleshooting AWS Batch .")
    ("aws_batch_job_definition" "Provides a Batch Job Definition resource.")
    ("aws_batch_job_queue" "Provides a Batch Job Queue resource.")
    ("aws_cloud9_environment_ec2" "Provides a Cloud9 EC2 Development Environment.")
    ("aws_budgets_budget" "Provides a budgets budget resource. Budgets use the cost visualisation provided by Cost Explorer to show you the status of your budgets, to provide forecasts of your estimated costs, and to track your AWS usage, including your free tier usage.")
    ("aws_cloudformation_stack" "Provides a CloudFormation Stack resource.")
    ("aws_cloudfront_distribution" "Creates an Amazon CloudFront web distribution.\n\nFor information about CloudFront distributions, see the Amazon CloudFront Developer Guide. For specific information about creating CloudFront web distributions, see the POST Distribution page in the Amazon CloudFront API Reference.\n\n NOTE: CloudFront distributions take about 15 minutes to a deployed state after creation or modification. During this time, deletes to resources will be blocked. If you need to delete a distribution that is enabled and you do not want to wait, you need to use the retain_on_delete flag.")
    ("aws_cloudfront_origin_access_identity" "Creates an Amazon CloudFront origin access identity.\n\nFor information about CloudFront distributions, see the Amazon CloudFront Developer Guide. For more information on generating origin access identities, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.")
    ("aws_cloudtrail" "Provides a CloudTrail resource.")
    ("aws_cloudwatch_dashboard" "Provides a CloudWatch Dashboard resource.")
    ("aws_cloudwatch_event_permission" "Provides a resource to create a CloudWatch Events permission to support cross-account events in the current account default event bus.")
    ("aws_cloudwatch_event_rule" "Provides a CloudWatch Event Rule resource.")
    ("aws_cloudwatch_event_target" "Provides a CloudWatch Event Target resource.")
    ("aws_cloudwatch_log_destination" "Provides a CloudWatch Logs destination resource.")
    ("aws_cloudwatch_log_destination_policy" "Provides a CloudWatch Logs destination policy resource.")
    ("aws_cloudwatch_log_group" "Provides a CloudWatch Log Group resource.")
    ("aws_cloudwatch_log_metric_filter" "Provides a CloudWatch Log Metric Filter resource.")
    ("aws_cloudwatch_log_resource_policy" "Provides a resource to manage a CloudWatch log resource policy.")
    ("aws_cloudwatch_log_stream" "Provides a CloudWatch Log Stream resource.")
    ("aws_cloudwatch_log_subscription_filter" "Provides a CloudWatch Logs subscription filter resource.")
    ("aws_cloudwatch_metric_alarm" "Provides a CloudWatch Metric Alarm resource.")
    ("aws_codebuild_project" "Provides a CodeBuild Project resource.")
    ("aws_codecommit_repository" "Provides a CodeCommit Repository Resource.\n\n NOTE on CodeCommit Availability: The CodeCommit is not yet rolled out in all regions - available regions are listed the AWS Docs.")
    ("aws_codecommit_trigger" "Provides a CodeCommit Trigger Resource.\n\n NOTE on CodeCommit: The CodeCommit is not yet rolled out in all regions - available regions are listed the AWS Docs.")
    ("aws_codedeploy_app" "Provides a CodeDeploy application to be used as a basis for deployments")
    ("aws_codedeploy_deployment_config" "Provides a CodeDeploy deployment config for an application")
    ("aws_codedeploy_deployment_group" "Provides a CodeDeploy Deployment Group for a CodeDeploy Application")
    ("aws_codepipeline" "Provides a CodePipeline.\n\n NOTE on aws_codepipeline: - the GITHUB_TOKEN environment variable must be set if the GitHub provider is specified.")
    ("aws_cognito_identity_pool" "Provides an AWS Cognito Identity Pool.")
    ("aws_cognito_identity_pool_roles_attachment" "Provides an AWS Cognito Identity Pool Roles Attachment.")
    ("aws_cognito_user_group" "Provides a Cognito User Group resource.")
    ("aws_cognito_user_pool" "Provides a Cognito User Pool resource.")
    ("aws_cognito_user_pool_client" "Provides a Cognito User Pool Client resource.")
    ("aws_cognito_user_pool_domain" "Provides a Cognito User Pool Domain resource.")
    ("aws_config_config_rule" "Provides an AWS Config Rule.\n\n Note: Config Rule requires an existing Configuration Recorder to be present. Use of depends_on is recommended (as shown below) to avoid race conditions.")
    ("aws_config_configuration_recorder" "Provides an AWS Config Configuration Recorder. Please note that this resource does not start the created recorder automatically.\n\n Note: Starting the Configuration Recorder requires a delivery channel (while delivery channel creation requires Configuration Recorder). This is why aws_config_configuration_recorder_status is a separate resource.")
    ("aws_config_configuration_recorder_status" "Manages status (recording / stopped) of an AWS Config Configuration Recorder.\n\n Note: Starting Configuration Recorder requires a Delivery Channel to be present. Use of depends_on (as shown below) is recommended to avoid race conditions.")
    ("aws_config_delivery_channel" "Provides an AWS Config Delivery Channel.\n\n Note: Delivery Channel requires a Configuration Recorder to be present. Use of depends_on (as shown below) is recommended to avoid race conditions.")
    ("aws_dms_certificate" "Provides a DMS (Data Migration Service) certificate resource. DMS certificates can be created, deleted, and imported.\n\n Note: All arguments including the PEM encoded certificate will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_dms_endpoint" "Provides a DMS (Data Migration Service) endpoint resource. DMS endpoints can be created, updated, deleted, and imported.\n\n Note: All arguments including the password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_dms_replication_instance" "Provides a DMS (Data Migration Service) replication instance resource. DMS replication instances can be created, updated, deleted, and imported.")
    ("aws_dms_replication_subnet_group" "Provides a DMS (Data Migration Service) replication subnet group resource. DMS replication subnet groups can be created, updated, deleted, and imported.")
    ("aws_dms_replication_task" "Provides a DMS (Data Migration Service) replication task resource. DMS replication tasks can be created, updated, deleted, and imported.")
    ("aws_devicefarm_project" "Provides a resource to manage AWS Device Farm Projects.  Please keep in mind that this feature is only supported on the \"us-west-2\" region. This resource will error if you try to create a project in another region.\n\nFor more information about Device Farm Projects, see the AWS Documentation on Device Farm Projects.")
    ("aws_directory_service_directory" "Provides a Simple or Managed Microsoft directory in AWS Directory Service.\n\n Note: All arguments including the password and customer username will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_directory_service_conditional_forwarder" "Provides a conditional forwarder for managed Microsoft AD in AWS Directory Service.")
    ("aws_dx_connection" "Provides a Connection of Direct Connect.")
    ("aws_dx_connection_association" "Associates a Direct Connect Connection with a LAG.")
    ("aws_dx_lag" "Provides a Direct Connect LAG.")
    ("aws_dynamodb_global_table" "Provides a resource to manage a DynamoDB Global Table. These are layered on top of existing DynamoDB Tables.\n\n Note: There are many restrictions before you can properly create DynamoDB Global Tables in multiple regions. See the AWS DynamoDB Global Table Requirements for more information.")
    ("aws_dynamodb_table" "Provides a DynamoDB table resource\n\n Note: It is recommended to use lifecycle ignore_changes for read_capacity and/or write_capacity if there's autoscaling policy attached to the table.")
    ("aws_dynamodb_table_item" "Provides a DynamoDB table item resource\n\n Note: This resource is not meant to be used for managing large amounts of data in your table, it is not designed to scale.   You should perform regular backups of all data in the table, see AWS docs for more.")
    ("aws_dax_cluster" "Provides a DAX Cluster resource.")
    ("aws_dax_parameter_group" "Provides a DAX Parameter Group resource.")
    ("aws_dax_subnet_group" "Provides a DAX Subnet Group resource.")
    ("aws_alb" "Provides a Load Balancer resource.\n\n Note: aws_alb is known as aws_lb. The functionality is identical.")
    ("aws_alb_listener" "Provides a Load Balancer Listener resource.\n\n Note: aws_alb_listener is known as aws_lb_listener. The functionality is identical.")
    ("aws_alb_listener_certificate" "Provides a Load Balancer Listener Certificate resource.\n\nThis resource is for additional certificates and does not replace the default certificate on the listener.\n\n Note: aws_alb_listener_certificate is known as aws_lb_listener_certificate. The functionality is identical.")
    ("aws_alb_listener_rule" "Provides a Load Balancer Listener Rule resource.\n\n Note: aws_alb_listener_rule is known as aws_lb_listener_rule. The functionality is identical.")
    ("aws_alb_target_group" "Provides a Target Group resource for use with Load Balancer resources.\n\n Note: aws_alb_target_group is known as aws_lb_target_group. The functionality is identical.")
    ("aws_alb_target_group_attachment" "Provides the ability to register instances and containers with a LB target group\n\n Note: aws_alb_target_group_attachment is known as aws_lb_target_group_attachment. The functionality is identical.")
    ("aws_ami" "The AMI resource allows the creation and management of a completely-custom Amazon Machine Image (AMI).\n\nIf you just want to duplicate an existing AMI, possibly copying it to another region, it's better to use aws_ami_copy instead.\n\nIf you just want to share an existing AMI with another AWS account, it's better to use aws_ami_launch_permission instead.")
    ("aws_ami_copy" "The \"AMI copy\" resource allows duplication of an Amazon Machine Image (AMI), including cross-region copies.\n\nIf the source AMI has associated EBS snapshots, those will also be duplicated along with the AMI.\n\nThis is useful for taking a single AMI provisioned in one region and making it available in another for a multi-region deployment.\n\nCopying an AMI can take several minutes. The creation of this resource will block until the new AMI is available for use on new instances.")
    ("aws_ami_from_instance" "The \"AMI from instance\" resource allows the creation of an Amazon Machine Image (AMI) modelled after an existing EBS-backed EC2 instance.\n\nThe created AMI will refer to implicitly-created snapshots of the instance's EBS volumes and mimick its assigned block device configuration at the time the resource is created.\n\nThis resource is best applied to an instance that is stopped when this instance is created, so that the contents of the created image are predictable. When applied to an instance that is running, the instance will be stopped before taking the snapshots and then started back up again, resulting in a period of downtime.\n\nNote that the source instance is inspected only at the initial creation of this resource. Ongoing updates to the referenced instance will not be propagated into the generated AMI. Users may taint or otherwise recreate the resource in order to produce a fresh snapshot.")
    ("aws_ami_launch_permission" "Adds launch permission to Amazon Machine Image (AMI) from another AWS account.")
    ("aws_app_cookie_stickiness_policy" "Provides an application cookie stickiness policy, which allows an ELB to wed its sticky cookie's expiration to a cookie generated by your application.")
    ("aws_autoscaling_attachment" "Provides an AutoScaling Attachment resource.\n\n NOTE on AutoScaling Groups and ASG Attachments: Terraform currently provides both a standalone ASG Attachment resource (describing an ASG attached to an ELB), and an AutoScaling Group resource with load_balancers defined in-line. At this time you cannot use an ASG with in-line load balancers in conjunction with an ASG Attachment resource. Doing so will cause a conflict and will overwrite attachments.")
    ("aws_autoscaling_group" "Provides an AutoScaling Group resource.\n\n Note: You must specify either launch_configuration or launch_template.")
    ("aws_autoscaling_lifecycle_hook" "Provides an AutoScaling Lifecycle Hook resource.\n\n NOTE: Terraform has two types of ways you can add lifecycle hooks - via the initial_lifecycle_hook attribute from the aws_autoscaling_group resource, or via this one. Hooks added via this resource will not be added until the autoscaling group has been created, and depending on your capacity settings, after the initial instances have been launched, creating unintended behavior. If you need hooks to run on all instances, add them with initial_lifecycle_hook in aws_autoscaling_group, but take care to not duplicate those hooks with this resource.")
    ("aws_autoscaling_notification" "Provides an AutoScaling Group with Notification support, via SNS Topics. Each of the notifications map to a Notification Configuration inside Amazon Web Services, and are applied to each AutoScaling Group you supply.")
    ("aws_autoscaling_policy" "Provides an AutoScaling Scaling Policy resource.\n\n NOTE: You may want to omit desired_capacity attribute from attached aws_autoscaling_group when using autoscaling policies. It's good practice to pick either manual or dynamic (policy-based) scaling.")
    ("aws_autoscaling_schedule" "Provides an AutoScaling Schedule resource.")
    ("aws_snapshot_create_volume_permission" "Adds permission to create volumes off of a given EBS Snapshot.")
    ("aws_ebs_snapshot" "Creates a Snapshot of an EBS Volume.")
    ("aws_ebs_volume" "Manages a single EBS volume.")
    ("aws_eip" "Provides an Elastic IP resource.\n\n Note: EIP may require IGW to exist prior to association. Use depends_on to set an explicit dependency on the IGW.")
    ("aws_eip_association" "Provides an AWS EIP Association as a top level resource, to associate and disassociate Elastic IPs from AWS Instances and Network Interfaces.\n\n NOTE: aws_eip_association is useful in scenarios where EIPs are either pre-existing or distributed to customers or users and therefore cannot be changed.")
    ("aws_elb" "Provides an Elastic Load Balancer resource, also known as a \"Classic Load Balancer\" after the release of Application/Network Load Balancers.\n\n NOTE on ELB Instances and ELB Attachments: Terraform currently provides both a standalone ELB Attachment resource (describing an instance attached to an ELB), and an ELB resource with instances defined in-line. At this time you cannot use an ELB with in-line instances in conjunction with a ELB Attachment resources. Doing so will cause a conflict and will overwrite attachments.")
    ("aws_elb_attachment" "Provides an Elastic Load Balancer Attachment resource.\n\n NOTE on ELB Instances and ELB Attachments: Terraform currently provides both a standalone ELB Attachment resource (describing an instance attached to an ELB), and an Elastic Load Balancer resource with instances defined in-line. At this time you cannot use an ELB with in-line instances in conjunction with an ELB Attachment resource. Doing so will cause a conflict and will overwrite attachments.")
    ("aws_instance" "Provides an EC2 instance resource. This allows instances to be created, updated, and deleted. Instances also support provisioning.")
    ("aws_key_pair" "Provides an EC2 key pair resource. A key pair is used to control login access to EC2 instances.\n\nCurrently this resource requires an existing user-supplied key pair. This key pair's public key will be registered with AWS to allow logging-in to EC2 instances.\n\nWhen importing an existing key pair the public key material may be in any format supported by AWS. Supported formats (per the AWS documentation) are:\n\n OpenSSH public key format (the format in ~/.ssh/authorized_keys)  Base64 encoded DER format  SSH public key file format as specified in RFC4716")
    ("aws_launch_configuration" "Provides a resource to create a new launch configuration, used for autoscaling groups.")
    ("aws_launch_template" "Provides an EC2 launch template resource. Can be used to create instances or auto scaling groups.")
    ("aws_lb_cookie_stickiness_policy" "Provides a load balancer cookie stickiness policy, which allows an ELB to control the sticky session lifetime of the browser.")
    ("aws_lb_ssl_negotiation_policy" "Provides a load balancer SSL negotiation policy, which allows an ELB to control the ciphers and protocols that are supported during SSL negotiations between a client and a load balancer.")
    ("aws_load_balancer_backend_server_policy" "Attaches a load balancer policy to an ELB backend server.")
    ("aws_load_balancer_listener_policy" "Attaches a load balancer policy to an ELB Listener.")
    ("aws_load_balancer_policy" "Provides a load balancer policy, which can be attached to an ELB listener or backend server.")
    ("aws_placement_group" "Provides an EC2 placement group. Read more about placement groups in AWS Docs.")
    ("aws_proxy_protocol_policy" "Provides a proxy protocol policy, which allows an ELB to carry a client connection information to a backend.")
    ("aws_spot_datafeed_subscription" "Note: There is only a single subscription allowed per account. \n\nTo help you understand the charges for your Spot instances, Amazon EC2 provides a data feed that describes your Spot instance usage and pricing. This data feed is sent to an Amazon S3 bucket that you specify when you subscribe to the data feed.")
    ("aws_spot_fleet_request" "Provides an EC2 Spot Fleet Request resource. This allows a fleet of Spot instances to be requested on the Spot market.")
    ("aws_spot_instance_request" "Provides an EC2 Spot Instance Request resource. This allows instances to be requested on the spot market.\n\nTerraform always creates Spot Instance Requests with a persistent type, which means that for the duration of their lifetime, AWS will launch an instance with the configured details if and when the spot market will accept the requested price.\n\nOn destruction, Terraform will make an attempt to terminate the associated Spot Instance if there is one present.\n\n NOTE: Because their behavior depends on the live status of the spot market, Spot Instance Requests have a unique lifecycle that makes them behave differently than other Terraform resources. Most importantly: there is no guarantee that a Spot Instance exists to fulfill the request at any given point in time. See the AWS Spot Instance documentation for more information.")
    ("aws_volume_attachment" "Provides an AWS EBS Volume Attachment as a top level resource, to attach and detach volumes from AWS Instances.\n\n NOTE on EBS block devices: If you use ebs_block_device on an aws_instance, Terraform will assume management over the full set of non-root EBS block devices for the instance, and treats additional block devices as drift. For this reason, ebs_block_device cannot be mixed with external aws_ebs_volume + aws_ebs_volume_attachment resources for a given instance.")
    ("aws_lb" "Provides a Load Balancer resource.\n\n Note: aws_alb is known as aws_lb. The functionality is identical.")
    ("aws_lb_listener" "Provides a Load Balancer Listener resource.\n\n Note: aws_alb_listener is known as aws_lb_listener. The functionality is identical.")
    ("aws_lb_listener_certificate" "Provides a Load Balancer Listener Certificate resource.\n\nThis resource is for additional certificates and does not replace the default certificate on the listener.\n\n Note: aws_alb_listener_certificate is known as aws_lb_listener_certificate. The functionality is identical.")
    ("aws_lb_listener_rule" "Provides a Load Balancer Listener Rule resource.\n\n Note: aws_alb_listener_rule is known as aws_lb_listener_rule. The functionality is identical.")
    ("aws_lb_target_group" "Provides a Target Group resource for use with Load Balancer resources.\n\n Note: aws_alb_target_group is known as aws_lb_target_group. The functionality is identical.")
    ("aws_lb_target_group_attachment" "Provides the ability to register instances and containers with a LB target group\n\n Note: aws_alb_target_group_attachment is known as aws_lb_target_group_attachment. The functionality is identical.")
    ("aws_ecr_lifecycle_policy" "Provides an ECR lifecycle policy.")
    ("aws_ecr_repository" "Provides an EC2 Container Registry Repository.\n\n NOTE on ECR Availability: The EC2 Container Registry is not yet rolled out in all regions - available regions are listed the AWS Docs.")
    ("aws_ecr_repository_policy" "Provides an ECR repository policy.\n\nNote that currently only one policy may be applied to a repository.\n\n NOTE on ECR Availability: The EC2 Container Registry is not yet rolled out in all regions - available regions are listed the AWS Docs.")
    ("aws_ecs_cluster" "Provides an ECS cluster.")
    ("aws_ecs_service" "Note: To prevent a race condition during service deletion, make sure to set depends_on to the related aws_iam_role_policy; otherwise, the policy may be destroyed too soon and the ECS service will then get stuck in the DRAINING state. \n\nProvides an ECS service - effectively a task that is expected to run until an error occurs or a user terminates it (typically a webserver or a database).\n\nSee ECS Services section in AWS developer guide.")
    ("aws_ecs_task_definition" "Provides an ECS task definition to be used in aws_ecs_service.")
    ("aws_efs_file_system" "Provides an Elastic File System (EFS) resource.")
    ("aws_efs_mount_target" "Provides an Elastic File System (EFS) mount target.")
    ("aws_elasticache_cluster" "Provides an ElastiCache Cluster resource, which manages a Memcached cluster or Redis instance. For working with Redis (Cluster Mode Enabled) replication groups, see the aws_elasticache_replication_group resource.\n\n Note: When you change an attribute, such as node_type, by default it is applied in the next maintenance window. Because of this, Terraform may report a difference in its planning phase because the actual modification has not yet taken place. You can use the apply_immediately flag to instruct the service to apply the change immediately. Using apply_immediately can result in a brief downtime as the server reboots. See the AWS Docs on Modifying an ElastiCache Cache Cluster for more information.")
    ("aws_elasticache_parameter_group" "Provides an ElastiCache parameter group resource.")
    ("aws_elasticache_replication_group" "Provides an ElastiCache Replication Group resource. For working with Memcached or single primary Redis instances (Cluster Mode Disabled), see the aws_elasticache_cluster resource.")
    ("aws_elasticache_security_group" "Provides an ElastiCache Security Group to control access to one or more cache clusters.\n\n NOTE: ElastiCache Security Groups are for use only when working with an ElastiCache cluster outside of a VPC. If you are using a VPC, see the ElastiCache Subnet Group resource.")
    ("aws_elasticache_subnet_group" "Provides an ElastiCache Subnet Group resource.\n\n NOTE: ElastiCache Subnet Groups are only for use when working with an ElastiCache cluster inside of a VPC. If you are on EC2 Classic, see the ElastiCache Security Group resource.")
    ("aws_elastic_beanstalk_application" "Provides an Elastic Beanstalk Application Resource. Elastic Beanstalk allows you to deploy and manage applications in the AWS cloud without worrying about the infrastructure that runs those applications.\n\nThis resource creates an application that has one configuration template named default, and no application versions")
    ("aws_elastic_beanstalk_application_version" "Provides an Elastic Beanstalk Application Version Resource. Elastic Beanstalk allows you to deploy and manage applications in the AWS cloud without worrying about the infrastructure that runs those applications.\n\nThis resource creates a Beanstalk Application Version that can be deployed to a Beanstalk Environment.\n\n NOTE on Application Version Resource:  When using the Application Version resource with multiple  Elastic Beanstalk Environments it is possible that an error may be returned when attempting to delete an Application Version while it is still in use by a different environment. To work around this you can:  Create each environment in a separate AWS account Create your aws_elastic_beanstalk_application_version resources with a unique names in your  Elastic Beanstalk Application. For example <revision>-<environment>.")
    ("aws_elastic_beanstalk_configuration_template" "Provides an Elastic Beanstalk Configuration Template, which are associated with a specific application and are used to deploy different versions of the application with the same configuration settings.")
    ("aws_elastic_beanstalk_environment" "Provides an Elastic Beanstalk Environment Resource. Elastic Beanstalk allows you to deploy and manage applications in the AWS cloud without worrying about the infrastructure that runs those applications.\n\nEnvironments are often things such as development, integration, or production.")
    ("aws_emr_cluster" "Provides an Elastic MapReduce Cluster, a web service that makes it easy to process large amounts of data efficiently. See Amazon Elastic MapReduce Documentation for more information.")
    ("aws_emr_instance_group" "Provides an Elastic MapReduce Cluster Instance Group configuration. See Amazon Elastic MapReduce Documentation for more information.\n\n NOTE: At this time, Instance Groups cannot be destroyed through the API nor web interface. Instance Groups are destroyed when the EMR Cluster is destroyed. Terraform will resize any Instance Group to zero when destroying the resource.")
    ("aws_emr_security_configuration" "Provides a resource to manage AWS EMR Security Configurations")
    ("aws_elasticsearch_domain" "")
    ("aws_elasticsearch_domain_policy" "Allows setting policy to an ElasticSearch domain while referencing domain attributes (e.g. ARN)")
    ("aws_elastictranscoder_pipeline" "Provides an Elastic Transcoder pipeline resource.")
    ("aws_elastictranscoder_preset" "Provides an Elastic Transcoder preset resource.")
    ("aws_gamelift_alias" "Provides a Gamelift Alias resource.")
    ("aws_gamelift_build" "Provides an Gamelift Build resource.")
    ("aws_gamelift_fleet" "Provides a Gamelift Fleet resource.")
    ("aws_glacier_vault" "Provides a Glacier Vault Resource. You can refer to the Glacier Developer Guide for a full explanation of the Glacier Vault functionality\n\n NOTE: When removing a Glacier Vault, the Vault must be empty.")
    ("aws_glue_catalog_database" "Provides a Glue Catalog Database Resource. You can refer to the Glue Developer Guide for a full explanation of the Glue Data Catalog functionality")
    ("aws_glue_catalog_table" "Provides a Glue Catalog Table Resource. You can refer to the Glue Developer Guide for a full explanation of the Glue Data Catalog functionality.")
    ("aws_glue_connection" "Provides a Glue Connection resource.")
    ("aws_glue_job" "Provides a Glue Job resource.")
    ("aws_guardduty_detector" "Provides a resource to manage a GuardDuty detector.\n\n NOTE: Deleting this resource is equivalent to \"disabling\" GuardDuty for an AWS region, which removes all existing findings. You can set the enable attribute to false to instead \"suspend\" monitoring and feedback reporting while keeping existing data. See the Suspending or Disabling Amazon GuardDuty documentation for more information.")
    ("aws_guardduty_ipset" "Provides a resource to manage a GuardDuty IPSet.\n\n Note: Currently in GuardDuty, users from member accounts cannot upload and further manage IPSets. IPSets that are uploaded by the master account are imposed on GuardDuty functionality in its member accounts. See the GuardDuty API Documentation")
    ("aws_guardduty_member" "Provides a resource to manage a GuardDuty member.\n\n NOTE: Currently after using this resource, you must manually invite and accept member account invitations before GuardDuty will begin sending cross-account events. More information for how to accomplish this via the AWS Console or API can be found in the GuardDuty User Guide. Terraform implementation of member invitation and acceptance resources can be tracked in Github.")
    ("aws_guardduty_threatintelset" "Provides a resource to manage a GuardDuty ThreatIntelSet.\n\n Note: Currently in GuardDuty, users from member accounts cannot upload and further manage ThreatIntelSets. ThreatIntelSets that are uploaded by the master account are imposed on GuardDuty functionality in its member accounts. See the GuardDuty API Documentation")
    ("aws_iam_access_key" "Provides an IAM access key. This is a set of credentials that allow API requests to be made as an IAM user.")
    ("aws_iam_account_alias" "Note: There is only a single account alias per AWS account. \n\nManages the account alias for the AWS Account.")
    ("aws_iam_account_password_policy" "Note: There is only a single policy allowed per AWS account. An existing policy will be lost when using this resource as an effect of this limitation. \n\nManages Password Policy for the AWS Account. See more about Account Password Policy in the official AWS docs.")
    ("aws_iam_group" "Provides an IAM group.")
    ("aws_iam_group_membership" "Provides a top level resource to manage IAM Group membership for IAM Users. For more information on managing IAM Groups or IAM Users, see IAM Groups or IAM Users\n\n Note: aws_iam_group_membership will conflict with itself if used more than once with the same group. To non-exclusively manage the users in a group, see the aws_iam_user_group_membership resource.")
    ("aws_iam_group_policy" "Provides an IAM policy attached to a group.")
    ("aws_iam_group_policy_attachment" "Attaches a Managed IAM Policy to an IAM group")
    ("aws_iam_instance_profile" "Provides an IAM instance profile.\n\n NOTE: Either role or roles (deprecated) must be specified.")
    ("aws_iam_openid_connect_provider" "Provides an IAM OpenID Connect provider.")
    ("aws_iam_policy" "Provides an IAM policy.")
    ("aws_iam_policy_attachment" "Attaches a Managed IAM Policy to user(s), role(s), and/or group(s)\n\n WARNING: The aws_iam_policy_attachment resource creates exclusive attachments of IAM policies. Across the entire AWS account, all of the users/roles/groups to which a single policy is attached must be declared by a single aws_iam_policy_attachment resource. This means that even any users/roles/groups that have the attached policy via some mechanism other than Terraform will have that attached policy revoked by Terraform. Consider aws_iam_role_policy_attachment, aws_iam_user_policy_attachment, or aws_iam_group_policy_attachment instead. These resources do not enforce exclusive attachment of an IAM policy.")
    ("aws_iam_role" "Provides an IAM role.")
    ("aws_iam_role_policy" "Provides an IAM role policy.")
    ("aws_iam_role_policy_attachment" "Attaches a Managed IAM Policy to an IAM role")
    ("aws_iam_saml_provider" "Provides an IAM SAML provider.")
    ("aws_iam_server_certificate" "Provides an IAM Server Certificate resource to upload Server Certificates. Certs uploaded to IAM can easily work with other AWS services such as:\n\n AWS Elastic Beanstalk  Elastic Load Balancing  CloudFront  AWS OpsWorks  \n\nFor information about server certificates in IAM, see Managing Server Certificates in AWS Documentation.\n\n Note: All arguments including the private key will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_iam_service_linked_role" "Provides an IAM service-linked role.")
    ("aws_iam_user" "Provides an IAM user.")
    ("aws_iam_user_group_membership" "Provides a resource for adding an IAM User to IAM Groups. This resource can be used multiple times with the same user for non-overlapping groups.\n\nTo exclusively manage the users in a group, see the aws_iam_group_membership resource.")
    ("aws_iam_user_login_profile" "Provides one-time creation of a IAM user login profile, and uses PGP to encrypt the password for safe transport to the user. PGP keys can be obtained from Keybase.")
    ("aws_iam_user_policy" "Provides an IAM policy attached to a user.")
    ("aws_iam_user_policy_attachment" "Attaches a Managed IAM Policy to an IAM user")
    ("aws_iam_user_ssh_key" "Uploads an SSH public key and associates it with the specified IAM user.")
    ("aws_iot_certificate" "Creates and manages an AWS IoT certificate.")
    ("aws_iot_policy" "Provides an IoT policy.")
    ("aws_iot_topic_rule" "")
    ("aws_iot_thing" "Creates and manages an AWS IoT Thing.")
    ("aws_iot_thing_type" "Creates and manages an AWS IoT Thing Type.")
    ("aws_inspector_assessment_target" "Provides a Inspector assessment target")
    ("aws_inspector_assessment_template" "Provides a Inspector assessment template")
    ("aws_inspector_resource_group" "Provides a Inspector resource group")
    ("aws_kinesis_stream" "Provides a Kinesis Stream resource. Amazon Kinesis is a managed service that scales elastically for real-time processing of streaming big data.\n\nFor more details, see the Amazon Kinesis Documentation.")
    ("aws_kinesis_firehose_delivery_stream" "Provides a Kinesis Firehose Delivery Stream resource. Amazon Kinesis Firehose is a fully managed, elastic service to easily deliver real-time data streams to destinations such as Amazon S3 and Amazon Redshift.\n\nFor more details, see the Amazon Kinesis Firehose Documentation.")
    ("aws_kms_alias" "Provides an alias for a KMS customer master key. AWS Console enforces 1-to-1 mapping between aliases & keys, but API (hence Terraform too) allows you to create as many aliases as the account limits allow you.")
    ("aws_kms_grant" "Provides a resource-based access control mechanism for a KMS customer master key.")
    ("aws_kms_key" "Provides a KMS customer master key.")
    ("aws_lambda_alias" "Creates a Lambda function alias. Creates an alias that points to the specified Lambda function version.\n\nFor information about Lambda and how to use it, see What is AWS Lambda? For information about function aliases, see CreateAlias in the API docs.")
    ("aws_lambda_event_source_mapping" "Provides a Lambda event source mapping. This allows Lambda functions to get events from Kinesis and DynamoDB.\n\nFor information about Lambda and how to use it, see What is AWS Lambda? For information about event source mappings, see CreateEventSourceMapping in the API docs.")
    ("aws_lambda_function" "Provides a Lambda Function resource. Lambda allows you to trigger execution of code in response to events in AWS. The Lambda Function itself includes source code and runtime configuration.\n\nFor information about Lambda and how to use it, see What is AWS Lambda?")
    ("aws_lambda_permission" "Creates a Lambda permission to allow external sources invoking the Lambda function (e.g. CloudWatch Event Rule, SNS or S3).")
    ("aws_lightsail_domain" "Creates a domain resource for the specified domain (e.g., example.com). You cannot register a new domain name using Lightsail. You must register a domain name using Amazon Route 53 or another domain name registrar. If you have already registered your domain, you can enter its name in this parameter to manage the DNS records for that domain.\n\n Note: Lightsail is currently only supported in a limited number of AWS Regions, please see \"Regions and Availability Zones in Amazon Lightsail\" for more details")
    ("aws_lightsail_instance" "Provides a Lightsail Instance. Amazon Lightsail is a service to provide easy virtual private servers with custom software already setup. See What is Amazon Lightsail? for more information.\n\n Note: Lightsail is currently only supported in a limited number of AWS Regions, please see \"Regions and Availability Zones in Amazon Lightsail\" for more details")
    ("aws_lightsail_key_pair" "Provides a Lightsail Key Pair, for use with Lightsail Instances. These key pairs are seperate from EC2 Key Pairs, and must be created or imported for use with Lightsail.\n\n Note: Lightsail is currently only supported in a limited number of AWS Regions, please see \"Regions and Availability Zones in Amazon Lightsail\" for more details")
    ("aws_lightsail_static_ip" "Allocates a static IP address.\n\n Note: Lightsail is currently only supported in a limited number of AWS Regions, please see \"Regions and Availability Zones in Amazon Lightsail\" for more details")
    ("aws_lightsail_static_ip_attachment" "Provides a static IP address attachment - relationship between a Lightsail static IP & Lightsail instance.\n\n Note: Lightsail is currently only supported in a limited number of AWS Regions, please see \"Regions and Availability Zones in Amazon Lightsail\" for more details")
    ("aws_mq_broker" "Provides an MQ Broker Resource. This resources also manages users for the broker.\n\nFor more information on Amazon MQ, see Amazon MQ documentation.\n\nChanges to an MQ Broker can occur when you change a parameter, such as configuration or user, and are reflected in the next maintenance window. Because of this, Terraform may report a difference in its planning phase because a modification has not yet taken place. You can use the apply_immediately flag to instruct the service to apply the change immediately (see documentation below).\n\n Note: using apply_immediately can result in a brief downtime as the broker reboots. \n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_mq_configuration" "Provides an MQ Configuration Resource.\n\nFor more information on Amazon MQ, see Amazon MQ documentation.")
    ("aws_media_store_container" "Provides a MediaStore Container.")
    ("aws_opsworks_application" "Provides an OpsWorks application resource.")
    ("aws_opsworks_custom_layer" "Provides an OpsWorks custom layer resource.")
    ("aws_opsworks_ganglia_layer" "Provides an OpsWorks Ganglia layer resource.")
    ("aws_opsworks_haproxy_layer" "Provides an OpsWorks haproxy layer resource.")
    ("aws_opsworks_instance" "Provides an OpsWorks instance resource.")
    ("aws_opsworks_java_app_layer" "Provides an OpsWorks Java application layer resource.")
    ("aws_opsworks_memcached_layer" "Provides an OpsWorks memcached layer resource.")
    ("aws_opsworks_mysql_layer" "Provides an OpsWorks MySQL layer resource.\n\n Note: All arguments including the root password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_opsworks_nodejs_app_layer" "Provides an OpsWorks NodeJS application layer resource.")
    ("aws_opsworks_permission" "Provides an OpsWorks permission resource.")
    ("aws_opsworks_php_app_layer" "Provides an OpsWorks PHP application layer resource.")
    ("aws_opsworks_rails_app_layer" "Provides an OpsWorks Ruby on Rails application layer resource.")
    ("aws_opsworks_rds_db_instance" "Provides an OpsWorks RDS DB Instance resource.\n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_opsworks_stack" "Provides an OpsWorks stack resource.")
    ("aws_opsworks_static_web_layer" "Provides an OpsWorks static web server layer resource.")
    ("aws_opsworks_user_profile" "Provides an OpsWorks User Profile resource.")
    ("aws_organizations_account" "Provides a resource to create a member account in the current organization.\n\n Note: Account management must be done from the organization's master account. \n\n WARNING: Deleting this Terraform resource will only remove an AWS account from an organization. Terraform will not close the account. The member account must be prepared to be a standalone account beforehand. See the AWS Organizations documentation for more information.")
    ("aws_organizations_organization" "Provides a resource to create an organization.")
    ("aws_organizations_policy" "Provides a resource to manage an AWS Organizations policy.")
    ("aws_organizations_policy_attachment" "Provides a resource to attach an AWS Organizations policy to an organization account, root, or unit.")
    ("aws_db_event_subscription" "Provides a DB event subscription resource.")
    ("aws_db_instance" "Provides an RDS instance resource.  A DB instance is an isolated database environment in the cloud.  A DB instance can contain multiple user-created databases.\n\nChanges to a DB instance can occur when you manually change a parameter, such as allocated_storage, and are reflected in the next maintenance window. Because of this, Terraform may report a difference in its planning phase because a modification has not yet taken place. You can use the apply_immediately flag to instruct the service to apply the change immediately (see documentation below).\n\nWhen upgrading the major version of an engine, allow_major_version_upgrade must be set to true.\n\n Note: using apply_immediately can result in a brief downtime as the server reboots. See the AWS Docs on RDS Maintenance for more information. \n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_db_option_group" "Provides an RDS DB option group resource.")
    ("aws_db_parameter_group" "Provides an RDS DB parameter group resource.")
    ("aws_db_security_group" "Provides an RDS security group resource. This is only for DB instances in the EC2-Classic Platform. For instances inside a VPC, use the aws_db_instance.vpc_security_group_ids attribute instead.")
    ("aws_db_snapshot" "Creates a Snapshot of an DB Instance.")
    ("aws_db_subnet_group" "Provides an RDS DB subnet group resource.")
    ("aws_rds_cluster" "Provides an RDS Cluster Resource. A Cluster Resource defines attributes that are applied to the entire cluster of RDS Cluster Instances. Use the RDS Cluster resource and RDS Cluster Instances to create and use Amazon Aurora, a MySQL-compatible database engine.\n\nFor more information on Amazon Aurora, see Aurora on Amazon RDS in the Amazon RDS User Guide.\n\nChanges to a RDS Cluster can occur when you manually change a parameter, such as port, and are reflected in the next maintenance window. Because of this, Terraform may report a difference in its planning phase because a modification has not yet taken place. You can use the apply_immediately flag to instruct the service to apply the change immediately (see documentation below).\n\n Note: using apply_immediately can result in a brief downtime as the server reboots. See the AWS Docs on RDS Maintenance for more information. \n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_rds_cluster_instance" "Provides an RDS Cluster Resource Instance. A Cluster Instance Resource defines attributes that are specific to a single instance in a RDS Cluster, specifically running Amazon Aurora.\n\nUnlike other RDS resources that support replication, with Amazon Aurora you do not designate a primary and subsequent replicas. Instead, you simply add RDS Instances and Aurora manages the replication. You can use the count meta-parameter to make multiple instances and join them all to the same RDS Cluster, or you may specify different Cluster Instance resources with various instance_class sizes.\n\nFor more information on Amazon Aurora, see Aurora on Amazon RDS in the Amazon RDS User Guide.")
    ("aws_rds_cluster_parameter_group" "Provides an RDS DB cluster parameter group resource.")
    ("aws_redshift_cluster" "Provides a Redshift Cluster Resource.\n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_redshift_parameter_group" "Provides a Redshift Cluster parameter group resource.")
    ("aws_redshift_security_group" "Creates a new Amazon Redshift security group. You use security groups to control access to non-VPC clusters")
    ("aws_redshift_subnet_group" "Creates a new Amazon Redshift subnet group. You must provide a list of one or more subnets in your existing Amazon Virtual Private Cloud (Amazon VPC) when creating Amazon Redshift subnet group.")
    ("aws_waf_byte_match_set" "Provides a WAF Byte Match Set Resource")
    ("aws_waf_geo_match_set" "Provides a WAF Geo Match Set Resource")
    ("aws_waf_ipset" "Provides a WAF IPSet Resource")
    ("aws_waf_rate_based_rule" "Provides a WAF Rate Based Rule Resource")
    ("aws_waf_regex_match_set" "Provides a WAF Regex Match Set Resource")
    ("aws_waf_regex_pattern_set" "Provides a WAF Regex Pattern Set Resource")
    ("aws_waf_rule" "Provides a WAF Rule Resource")
    ("aws_waf_rule_group" "Provides a WAF Rule Group Resource")
    ("aws_waf_size_constraint_set" "Provides a WAF Size Constraint Set Resource")
    ("aws_waf_sql_injection_match_set" "Provides a WAF SQL Injection Match Set Resource")
    ("aws_waf_web_acl" "Provides a WAF Web ACL Resource")
    ("aws_waf_xss_match_set" "Provides a WAF XSS Match Set Resource")
    ("aws_wafregional_byte_match_set" "Provides a WAF Regional Byte Match Set Resource for use with Application Load Balancer.")
    ("aws_wafregional_geo_match_set" "Provides a WAF Regional Geo Match Set Resource")
    ("aws_wafregional_ipset" "Provides a WAF Regional IPSet Resource for use with Application Load Balancer.")
    ("aws_wafregional_rate_based_rule" "Provides a WAF Rate Based Rule Resource")
    ("aws_wafregional_regex_match_set" "Provides a WAF Regional Regex Match Set Resource")
    ("aws_wafregional_regex_pattern_set" "Provides a WAF Regional Regex Pattern Set Resource")
    ("aws_wafregional_rule" "Provides an WAF Regional Rule Resource for use with Application Load Balancer.")
    ("aws_wafregional_rule_group" "Provides a WAF Regional Rule Group Resource")
    ("aws_wafregional_size_constraint_set" "Provides a WAF Regional Size Constraint Set Resource for use with Application Load Balancer.")
    ("aws_wafregional_sql_injection_match_set" "Provides a WAF Regional SQL Injection Match Set Resource for use with Application Load Balancer.")
    ("aws_wafregional_web_acl" "Provides a WAF Regional Web ACL Resource for use with Application Load Balancer.")
    ("aws_wafregional_web_acl_association" "Provides a resource to create an association between a WAF Regional WebACL and Application Load Balancer.\n\n Note: An Application Load Balancer can only be associated with one WAF Regional WebACL.")
    ("aws_wafregional_xss_match_set" "Provides a WAF Regional XSS Match Set Resource for use with Application Load Balancer.")
    ("aws_route53_delegation_set" "Provides a Route53 Delegation Set resource.")
    ("aws_route53_health_check" "Provides a Route53 health check.")
    ("aws_route53_query_log" "Provides a Route53 query logging configuration resource.\n\n NOTE: There are restrictions on the configuration of query logging. Notably, the CloudWatch log group must be in the us-east-1 region, a permissive CloudWatch log resource policy must be in place, and the Route53 hosted zone must be public. See Configuring Logging for DNS Queries for additional details.")
    ("aws_route53_record" "Provides a Route53 record resource.")
    ("aws_route53_zone" "Provides a Route53 Hosted Zone resource.")
    ("aws_route53_zone_association" "Provides a Route53 private Hosted Zone to VPC association resource.")
    ("aws_s3_bucket" "Provides a S3 bucket resource.")
    ("aws_s3_bucket_metric" "Provides a S3 bucket metrics configuration resource.")
    ("aws_s3_bucket_notification" "Provides a S3 bucket notification resource.")
    ("aws_s3_bucket_object" "Provides a S3 bucket object resource.")
    ("aws_s3_bucket_policy" "Attaches a policy to an S3 bucket resource.")
    ("aws_secretsmanager_secret" "Provides a resource to manage AWS Secrets Manager secret metadata. To manage a secret value, see the aws_secretsmanager_secret_version resource.")
    ("aws_secretsmanager_secret_version" "Provides a resource to manage AWS Secrets Manager secret version including its secret value. To manage secret metadata, see the aws_secretsmanager_secret resource.\n\n NOTE: If the AWSCURRENT staging label is present on this version during resource deletion, that label cannot be removed and will be skipped to prevent errors when fully deleting the secret. That label will leave this secret version active even after the resource is deleted from Terraform unless the secret itself is deleted. Move the AWSCURRENT staging label before or after deleting this resource from Terraform to fully trigger version deprecation if necessary.")
    ("aws_ses_active_receipt_rule_set" "Provides a resource to designate the active SES receipt rule set")
    ("aws_ses_domain_identity" "Provides an SES domain identity resource")
    ("aws_ses_domain_identity_verification" "Represents a successful verification of an SES domain identity.\n\nMost commonly, this resource is used together with aws_route53_record and aws_ses_domain_identity to request an SES domain identity, deploy the required DNS verification records, and wait for verification to complete.\n\n WARNING: This resource implements a part of the verification workflow. It does not represent a real-world entity in AWS, therefore changing or deleting this resource on its own has no immediate effect.")
    ("aws_ses_domain_dkim" "Provides an SES domain DKIM generation resource.\n\nDomain ownership needs to be confirmed first using ses_domain_identity Resource")
    ("aws_ses_domain_mail_from" "Provides an SES domain MAIL FROM resource.\n\n NOTE: For the MAIL FROM domain to be fully usable, this resource should be paired with the aws_ses_domain_identity resource. To validate the MAIL FROM domain, a DNS MX record is required. To pass SPF checks, a DNS TXT record may also be required. See the Amazon SES MAIL FROM documentation for more information.")
    ("aws_ses_receipt_filter" "Provides an SES receipt filter resource")
    ("aws_ses_receipt_rule" "Provides an SES receipt rule resource")
    ("aws_ses_receipt_rule_set" "Provides an SES receipt rule set resource")
    ("aws_ses_configuration_set" "Provides an SES configuration set resource")
    ("aws_ses_event_destination" "Provides an SES event destination")
    ("aws_ses_identity_notification_topic" "Resource for managing SES Identity Notification Topics")
    ("aws_ses_template" "Provides a resource to create a SES template.")
    ("aws_servicecatalog_portfolio" "Provides a resource to create a Service Catalog Portfolio.")
    ("aws_service_discovery_private_dns_namespace" "Provides a Service Discovery Private DNS Namespace resource.")
    ("aws_service_discovery_public_dns_namespace" "Provides a Service Discovery Public DNS Namespace resource.")
    ("aws_service_discovery_service" "Provides a Service Discovery Service resource.")
    ("aws_sfn_activity" "Provides a Step Function Activity resource")
    ("aws_sfn_state_machine" "Provides a Step Function State Machine resource")
    ("aws_simpledb_domain" "Provides a SimpleDB domain resource")
    ("aws_sns_platform_application" "Provides an SNS platform application resource")
    ("aws_sns_topic" "Provides an SNS topic resource")
    ("aws_sns_topic_policy" "Provides an SNS topic policy resource\n\n NOTE: If a Principal is specified as just an AWS account ID rather than an ARN, AWS silently converts it to the ARN for the root user, causing future terraform plans to differ. To avoid this problem, just specify the full ARN, e.g. arn:aws:iam::123456789012:root")
    ("aws_sns_topic_subscription" "Provides a resource for subscribing to SNS topics. Requires that an SNS topic exist for the subscription to attach to. This resource allows you to automatically place messages sent to SNS topics in SQS queues, send them as HTTP(S) POST requests to a given endpoint, send SMS messages, or notify devices / applications. The most likely use case for Terraform users will probably be SQS queues.\n\n NOTE: If the SNS topic and SQS queue are in different AWS regions, it is important for the \"aws_sns_topic_subscription\" to use an AWS provider that is in the same region of the SNS topic. If the \"aws_sns_topic_subscription\" is using a provider with a different region than the SNS topic, terraform will fail to create the subscription. \n\n NOTE: Setup of cross-account subscriptions from SNS topics to SQS queues requires Terraform to have access to BOTH accounts. \n\n NOTE: If SNS topic and SQS queue are in different AWS accounts but the same region it is important for the \"aws_sns_topic_subscription\" to use the AWS provider of the account with the SQS queue. If \"aws_sns_topic_subscription\" is using a Provider with a different account than the SNS topic, terraform creates the subscriptions but does not keep state and tries to re-create the subscription at every apply. \n\n NOTE: If SNS topic and SQS queue are in different AWS accounts and different AWS regions it is important to recognize that the subscription needs to be initiated from the account with the SQS queue but in the region of the SNS topic.")
    ("aws_ssm_activation" "Registers an on-premises server or virtual machine with Amazon EC2 so that it can be managed using Run Command.")
    ("aws_ssm_association" "Associates an SSM Document to an instance or EC2 tag.")
    ("aws_ssm_document" "Provides an SSM Document resource\n\n NOTE on updating SSM documents: Only documents with a schema version of 2.0 or greater can update their content once created, see SSM Schema Features. To update a document with an older schema version you must recreate the resource.")
    ("aws_ssm_maintenance_window" "Provides an SSM Maintenance Window resource")
    ("aws_ssm_maintenance_window_target" "Provides an SSM Maintenance Window Target resource")
    ("aws_ssm_maintenance_window_task" "Provides an SSM Maintenance Window Task resource")
    ("aws_ssm_patch_baseline" "Provides an SSM Patch Baseline resource\n\n NOTE on Patch Baselines: The approved_patches and approval_rule are  both marked as optional fields, but the Patch Baseline requires that at least one of them is specified.")
    ("aws_ssm_patch_group" "Provides an SSM Patch Group resource")
    ("aws_ssm_parameter" "Provides an SSM Parameter resource.")
    ("aws_ssm_resource_data_sync" "Provides a SSM resource data sync.")
    ("aws_sqs_queue" "")
    ("aws_sqs_queue_policy" "Allows you to set a policy of an SQS Queue while referencing ARN of the queue within the policy.")
    ("aws_customer_gateway" "Provides a customer gateway inside a VPC. These objects can be connected to VPN gateways via VPN connections, and allow you to establish tunnels between your network and the VPC.")
    ("aws_default_network_acl" "Provides a resource to manage the default AWS Network ACL. VPC Only.\n\nEach VPC created in AWS comes with a Default Network ACL that can be managed, but not destroyed. This is an advanced resource, and has special caveats to be aware of when using it. Please read this document in its entirety before using this resource.\n\nThe aws_default_network_acl behaves differently from normal resources, in that Terraform does not create this resource, but instead attempts to \"adopt\" it into management. We can do this because each VPC created has a Default Network ACL that cannot be destroyed, and is created with a known set of default rules.\n\nWhen Terraform first adopts the Default Network ACL, it immediately removes all rules in the ACL. It then proceeds to create any rules specified in the configuration. This step is required so that only the rules specified in the configuration are created.\n\nThis resource treats its inline rules as absolute; only the rules defined inline are created, and any additions/removals external to this resource will result in diffs being shown. For these reasons, this resource is incompatible with the aws_network_acl_rule resource.\n\nFor more information about Network ACLs, see the AWS Documentation on Network ACLs.")
    ("aws_default_route_table" "Provides a resource to manage a Default VPC Routing Table.\n\nEach VPC created in AWS comes with a Default Route Table that can be managed, but not destroyed. This is an advanced resource, and has special caveats to be aware of when using it. Please read this document in its entirety before using this resource. It is recommended you do not use both aws_default_route_table to manage the default route table and use the aws_main_route_table_association, due to possible conflict in routes.\n\nThe aws_default_route_table behaves differently from normal resources, in that Terraform does not create this resource, but instead attempts to \"adopt\" it into management. We can do this because each VPC created has a Default Route Table that cannot be destroyed, and is created with a single route.\n\nWhen Terraform first adopts the Default Route Table, it immediately removes all defined routes. It then proceeds to create any routes specified in the configuration. This step is required so that only the routes specified in the configuration present in the Default Route Table.\n\nFor more information about Route Tables, see the AWS Documentation on Route Tables.\n\nFor more information about managing normal Route Tables in Terraform, see our documentation on aws_route_table.\n\n NOTE on Route Tables and Routes: Terraform currently provides both a standalone Route resource and a Route Table resource with routes defined in-line. At this time you cannot use a Route Table with in-line routes in conjunction with any Route resources. Doing so will cause a conflict of rule settings and will overwrite routes.")
    ("aws_default_security_group" "Provides a resource to manage the default AWS Security Group.\n\nFor EC2 Classic accounts, each region comes with a Default Security Group. Additionally, each VPC created in AWS comes with a Default Security Group that can be managed, but not destroyed. This is an advanced resource, and has special caveats to be aware of when using it. Please read this document in its entirety before using this resource.\n\nThe aws_default_security_group behaves differently from normal resources, in that Terraform does not create this resource, but instead \"adopts\" it into management. We can do this because these default security groups cannot be destroyed, and are created with a known set of default ingress/egress rules.\n\nWhen Terraform first adopts the Default Security Group, it immediately removes all ingress and egress rules in the Security Group. It then proceeds to create any rules specified in the configuration. This step is required so that only the rules specified in the configuration are created.\n\nThis resource treats its inline rules as absolute; only the rules defined inline are created, and any additions/removals external to this resource will result in diff shown. For these reasons, this resource is incompatible with the aws_security_group_rule resource.\n\nFor more information about Default Security Groups, see the AWS Documentation on Default Security Groups.")
    ("aws_default_subnet" "Provides a resource to manage a default AWS VPC subnet in the current region.\n\nThe aws_default_subnet behaves differently from normal resources, in that Terraform does not create this resource, but instead \"adopts\" it into management.")
    ("aws_default_vpc" "Provides a resource to manage the default AWS VPC in the current region.\n\nFor AWS accounts created after 2013-12-04, each region comes with a Default VPC. This is an advanced resource, and has special caveats to be aware of when using it. Please read this document in its entirety before using this resource.\n\nThe aws_default_vpc behaves differently from normal resources, in that Terraform does not create this resource, but instead \"adopts\" it into management.")
    ("aws_default_vpc_dhcp_options" "Provides a resource to manage the default AWS DHCP Options Set in the current region.\n\nEach AWS region comes with a default set of DHCP options. This is an advanced resource, and has special caveats to be aware of when using it. Please read this document in its entirety before using this resource.\n\nThe aws_default_vpc_dhcp_options behaves differently from normal resources, in that Terraform does not create this resource, but instead \"adopts\" it into management.")
    ("aws_egress_only_internet_gateway" "[IPv6 only] Creates an egress-only Internet gateway for your VPC. An egress-only Internet gateway is used to enable outbound communication over IPv6 from instances in your VPC to the Internet, and prevents hosts outside of your VPC from initiating an IPv6 connection with your instance.")
    ("aws_flow_log" "Provides a VPC/Subnet/ENI Flow Log to capture IP traffic for a specific network interface, subnet, or VPC. Logs are sent to a CloudWatch Log Group.")
    ("aws_internet_gateway" "Provides a resource to create a VPC Internet Gateway.")
    ("aws_main_route_table_association" "Provides a resource for managing the main routing table of a VPC.")
    ("aws_nat_gateway" "Provides a resource to create a VPC NAT Gateway.")
    ("aws_network_acl" "Provides an network ACL resource. You might set up network ACLs with rules similar to your security groups in order to add an additional layer of security to your VPC.\n\n NOTE on Network ACLs and Network ACL Rules: Terraform currently provides both a standalone Network ACL Rule resource and a Network ACL resource with rules defined in-line. At this time you cannot use a Network ACL with in-line rules in conjunction with any Network ACL Rule resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("aws_network_acl_rule" "Creates an entry (a rule) in a network ACL with the specified rule number.\n\n NOTE on Network ACLs and Network ACL Rules: Terraform currently provides both a standalone Network ACL Rule resource and a Network ACL resource with rules defined in-line. At this time you cannot use a Network ACL with in-line rules in conjunction with any Network ACL Rule resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("aws_network_interface" "Provides an Elastic network interface (ENI) resource.")
    ("aws_network_interface_attachment" "Attach an Elastic network interface (ENI) resource with EC2 instance.")
    ("aws_route" "Provides a resource to create a routing table entry (a route) in a VPC routing table.\n\n NOTE on Route Tables and Routes: Terraform currently provides both a standalone Route resource and a Route Table resource with routes defined in-line. At this time you cannot use a Route Table with in-line routes in conjunction with any Route resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("aws_route_table" "Provides a resource to create a VPC routing table.\n\n NOTE on Route Tables and Routes: Terraform currently provides both a standalone Route resource and a Route Table resource with routes defined in-line. At this time you cannot use a Route Table with in-line routes in conjunction with any Route resources. Doing so will cause a conflict of rule settings and will overwrite rules. \n\n NOTE on gateway_id and nat_gateway_id: The AWS API is very forgiving with these two attributes and the aws_route_table resource can be created with a NAT ID specified as a Gateway ID attribute. This will lead to a permanent diff between your configuration and statefile, as the API returns the correct parameters in the returned route table. If you're experiencing constant diffs in your aws_route_table resources, the first thing to check is whether or not you're specifying a NAT ID instead of a Gateway ID, or vice-versa. \n\n NOTE on propagating_vgws and the aws_vpn_gateway_route_propagation resource: If the propagating_vgws argument is present, it's not supported to also define route propagations using aws_vpn_gateway_route_propagation, since this resource will delete any propagating gateways not explicitly listed in propagating_vgws. Omit this argument when defining route propagation using the separate resource.")
    ("aws_route_table_association" "Provides a resource to create an association between a subnet and routing table.")
    ("aws_security_group" "Provides a security group resource.\n\n NOTE on Security Groups and Security Group Rules: Terraform currently provides both a standalone Security Group Rule resource (a single ingress or egress rule), and a Security Group resource with ingress and egress rules defined in-line. At this time you cannot use a Security Group with in-line rules in conjunction with any Security Group Rule resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("aws_network_interface_sg_attachment" "This resource attaches a security group to an Elastic Network Interface (ENI). It can be used to attach a security group to any existing ENI, be it a secondary ENI or one attached as the primary interface on an instance.\n\n NOTE on instances, interfaces, and security groups: Terraform currently provides the capability to assign security groups via the aws_instance and the aws_network_interface resources. Using this resource in conjunction with security groups provided in-line in those resources will cause conflicts, and will lead to spurious diffs and undefined behavior - please use one or the other.")
    ("aws_security_group_rule" "Provides a security group rule resource. Represents a single ingress or egress group rule, which can be added to external Security Groups.\n\n NOTE on Security Groups and Security Group Rules: Terraform currently provides both a standalone Security Group Rule resource (a single ingress or egress rule), and a Security Group resource with ingress and egress rules defined in-line. At this time you cannot use a Security Group with in-line rules in conjunction with any Security Group Rule resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("aws_subnet" "Provides an VPC subnet resource.")
    ("aws_vpc" "Provides an VPC resource.")
    ("aws_vpc_dhcp_options" "Provides a VPC DHCP Options resource.")
    ("aws_vpc_dhcp_options_association" "Provides a VPC DHCP Options Association resource.")
    ("aws_vpc_endpoint" "Provides a VPC Endpoint resource.\n\n NOTE on VPC Endpoints and VPC Endpoint Associations: Terraform provides both standalone VPC Endpoint Associations for Route Tables - (an association between a VPC endpoint and a single route_table_id) and Subnets - (an association between a VPC endpoint and a single subnet_id) and a VPC Endpoint resource with route_table_ids and subnet_ids attributes. Do not use the same resource ID in both a VPC Endpoint resource and a VPC Endpoint Association resource. Doing so will cause a conflict of associations and will overwrite the association.")
    ("aws_vpc_endpoint_connection_notification" "Provides a VPC Endpoint connection notification resource. Connection notifications notify subscribers of VPC Endpoint events.")
    ("aws_vpc_endpoint_route_table_association" "Provides a resource to create an association between a VPC endpoint and routing table.\n\n NOTE on VPC Endpoints and VPC Endpoint Route Table Associations: Terraform provides both a standalone VPC Endpoint Route Table Association (an association between a VPC endpoint and a single route_table_id) and a VPC Endpoint resource with a route_table_ids attribute. Do not use the same route table ID in both a VPC Endpoint resource and a VPC Endpoint Route Table Association resource. Doing so will cause a conflict of associations and will overwrite the association.")
    ("aws_vpc_endpoint_service" "Provides a VPC Endpoint Service resource. Service consumers can create an Interface VPC Endpoint to connect to the service.\n\n NOTE on VPC Endpoint Services and VPC Endpoint Service Allowed Principals: Terraform provides both a standalone VPC Endpoint Service Allowed Principal resource and a VPC Endpoint Service resource with an allowed_principals attribute. Do not use the same principal ARN in both a VPC Endpoint Service resource and a VPC Endpoint Service Allowed Principal resource. Doing so will cause a conflict and will overwrite the association.")
    ("aws_vpc_endpoint_service_allowed_principal" "Provides a resource to allow a principal to discover a VPC endpoint service.\n\n NOTE on VPC Endpoint Services and VPC Endpoint Service Allowed Principals: Terraform provides both a standalone VPC Endpoint Service Allowed Principal resource and a VPC Endpoint Service resource with an allowed_principals attribute. Do not use the same principal ARN in both a VPC Endpoint Service resource and a VPC Endpoint Service Allowed Principal resource. Doing so will cause a conflict and will overwrite the association.")
    ("aws_vpc_endpoint_subnet_association" "Provides a resource to create an association between a VPC endpoint and a subnet.\n\n NOTE on VPC Endpoints and VPC Endpoint Subnet Associations: Terraform provides both a standalone VPC Endpoint Subnet Association (an association between a VPC endpoint and a single subnet_id) and a VPC Endpoint resource with a subnet_ids attribute. Do not use the same subnet ID in both a VPC Endpoint resource and a VPC Endpoint Subnet Association resource. Doing so will cause a conflict of associations and will overwrite the association.")
    ("aws_vpc_peering_connection" "Provides a resource to manage a VPC peering connection.\n\n NOTE on VPC Peering Connections and VPC Peering Connection Options: Terraform provides both a standalone VPC Peering Connection Options and a VPC Peering Connection resource with accepter and requester attributes. Do not manage options for the same VPC peering connection in both a VPC Peering Connection resource and a VPC Peering Connection Options resource. Doing so will cause a conflict of options and will overwrite the options. Using a VPC Peering Connection Options resource decouples management of the connection options from management of the VPC Peering Connection and allows options to be set correctly in cross-account scenarios. \n\n Note: For cross-account (requester's AWS account differs from the accepter's AWS account) or inter-region VPC Peering Connections use the aws_vpc_peering_connection resource to manage the requester's side of the connection and use the aws_vpc_peering_connection_accepter resource to manage the accepter's side of the connection.")
    ("aws_vpc_peering_connection_accepter" "Provides a resource to manage the accepter's side of a VPC Peering Connection.\n\nWhen a cross-account (requester's AWS account differs from the accepter's AWS account) or an inter-region VPC Peering Connection is created, a VPC Peering Connection resource is automatically created in the accepter's account. The requester can use the aws_vpc_peering_connection resource to manage its side of the connection and the accepter can use the aws_vpc_peering_connection_accepter resource to \"adopt\" its side of the connection into management.")
    ("aws_vpc_peering_connection_options" "Provides a resource to manage VPC peering connection options.\n\n NOTE on VPC Peering Connections and VPC Peering Connection Options: Terraform provides both a standalone VPC Peering Connection Options and a VPC Peering Connection resource with accepter and requester attributes. Do not manage options for the same VPC peering connection in both a VPC Peering Connection resource and a VPC Peering Connection Options resource. Doing so will cause a conflict of options and will overwrite the options. Using a VPC Peering Connection Options resource decouples management of the connection options from management of the VPC Peering Connection and allows options to be set correctly in cross-account scenarios. \n\nBasic usage:\n\nresource \"aws_vpc\" \"foo\" {   cidr_block = \"10.0.0.0/16\" }  resource \"aws_vpc\" \"bar\" {   cidr_block = \"10.1.0.0/16\" }  resource \"aws_vpc_peering_connection\" \"foo\" {   vpc_id        = \"${aws_vpc.foo.id}\"   peer_vpc_id   = \"${aws_vpc.bar.id}\"   auto_accept   = true }  resource \"aws_vpc_peering_connection_options\" \"foo\" {   vpc_peering_connection_id = \"${aws_vpc_peering_connection.foo.id}\"    accepter {     allow_remote_vpc_dns_resolution = true   }    requester {     allow_vpc_to_remote_classic_link = true     allow_classic_link_to_remote_vpc = true   } } \n\nBasic cross-account usage:\n\nprovider \"aws\" {   alias = \"requester\"    # Requester's credentials. }  provider \"aws\" {   alias = \"accepter\"    # Accepter's credentials. }  resource \"aws_vpc\" \"main\" {   provider = \"aws.requester\"    cidr_block = \"10.0.0.0/16\"    enable_dns_support   = true   enable_dns_hostnames = true }  resource \"aws_vpc\" \"peer\" {   provider = \"aws.accepter\"    cidr_block = \"10.1.0.0/16\"    enable_dns_support   = true   enable_dns_hostnames = true }  data \"aws_caller_identity\" \"peer\" {   provider = \"aws.accepter\" }  # Requester's side of the connection. resource \"aws_vpc_peering_connection\" \"peer\" {   provider = \"aws.requester\"    vpc_id        = \"${aws_vpc.main.id}\"   peer_vpc_id   = \"${aws_vpc.peer.id}\"   peer_owner_id = \"${data.aws_caller_identity.peer.account_id}\"   auto_accept   = false    tags {     Side = \"Requester\"   } }  # Accepter's side of the connection. resource \"aws_vpc_peering_connection_accepter\" \"peer\" {   provider = \"aws.accepter\"    vpc_peering_connection_id = \"${aws_vpc_peering_connection.peer.id}\"   auto_accept               = true    tags {     Side = \"Accepter\"   } }  resource \"aws_vpc_peering_connection_options\" \"requester\" {   provider = \"aws.requester\"    # As options can't be set until the connection has been accepted   # create an explicit dependency on the accepter.   vpc_peering_connection_id = \"${aws_vpc_peering_connection_accepter.peer.id}\"    requester {     allow_remote_vpc_dns_resolution = true   } }  resource \"aws_vpc_peering_connection_options\" \"accepter\" {   provider = \"aws.accepter\"    vpc_peering_connection_id = \"${aws_vpc_peering_connection_accepter.peer.id}\"    accepter {     allow_remote_vpc_dns_resolution = true   } }")
    ("aws_vpn_connection" "Provides a VPN connection connected to a VPC. These objects can be connected to customer gateways, and allow you to establish tunnels between your network and the VPC.\n\n Note: All arguments including tunnel1_preshared_key and tunnel2_preshared_key will be stored in the raw state as plain-text. Read more about sensitive data in state. \n\n Note: The CIDR blocks in the arguments tunnel1_inside_cidr and tunnel2_inside_cidr must have a prefix of /30 and be a part of a specific range. Read more about this in the AWS documentation.")
    ("aws_vpn_connection_route" "Provides a static route between a VPN connection and a customer gateway.")
    ("aws_vpn_gateway" "Provides a resource to create a VPC VPN Gateway.")
    ("aws_vpn_gateway_attachment" "Provides a Virtual Private Gateway attachment resource, allowing for an existing hardware VPN gateway to be attached and/or detached from a VPC.\n\n Note: The aws_vpn_gateway resource can also automatically attach the Virtual Private Gateway it creates to an existing VPC by setting the vpc_id attribute accordingly.")
    ("aws_vpn_gateway_route_propagation" "Requests automatic route propagation between a VPN gateway and a route table.\n\n Note: This resource should not be used with a route table that has the propagating_vgws argument set. If that argument is set, any route propagation not explicitly listed in its value will be removed.")
    ("azurerm_resource_group" "Creates a new resource group on Azure.")
    ("azurerm_app_service" "Manages an App Service (within an App Service Plan).\n\n Note: When using Slots - the app_settings, connection_string and site_config blocks on the azurerm_app_service resource will be overwritten when promoting a Slot using the azurerm_app_service_active_slot resource.")
    ("azurerm_app_service_plan" "Create an App Service Plan component.")
    ("azurerm_app_service_active_slot" "Promotes an App Service Slot to Production within an App Service.\n\n Note: When using Slots - the app_settings, connection_string and site_config blocks on the azurerm_app_service resource will be overwritten when promoting a Slot using the azurerm_app_service_active_slot resource.")
    ("azurerm_app_service_custom_hostname_binding" "Manages a Hostname Binding within an App Service.")
    ("azurerm_app_service_slot" "Manages an App Service Slot (within an App Service).\n\n Note: When using Slots - the app_settings, connection_string and site_config blocks on the azurerm_app_service resource will be overwritten when promoting a Slot using the azurerm_app_service_active_slot resource.")
    ("azurerm_function_app" "Manages a Function App.")
    ("azurerm_role_assignment" "Assigns a given Principal (User or Application) to a given Role.")
    ("azurerm_role_definition" "Manages a custom Role Definition, used to assign Roles to Users/Principals.")
    ("azurerm_automation_account" "Creates a new Automation Account.")
    ("azurerm_automation_credential" "Creates a new Automation Credential.")
    ("azurerm_automation_runbook" "Creates a new Automation Runbook.")
    ("azurerm_automation_schedule" "Creates a new Automation Schedule.")
    ("azurerm_application_insights" "Create an Application Insights component.")
    ("azurerm_cdn_profile" "Create a CDN Profile to create a collection of CDN Endpoints.")
    ("azurerm_cdn_endpoint" "A CDN Endpoint is the entity within a CDN Profile containing configuration information regarding caching behaviors and origins. The CDN Endpoint is exposed using the URL format .azureedge.net by default, but custom domains can also be created.")
    ("azurerm_availability_set" "Manages an availability set for virtual machines.")
    ("azurerm_managed_disk" "Create a managed disk.")
    ("azurerm_snapshot" "Manages a Disk Snapshot.")
    ("azurerm_image" "Create a custom virtual machine image that can be used to create virtual machines.")
    ("azurerm_virtual_machine" "Create a virtual machine.")
    ("azurerm_virtual_machine_extension" "Creates a new Virtual Machine Extension to provide post deployment configuration and run automated tasks.\n\n Please Note: The CustomScript extensions for Linux & Windows require that the commandToExecute returns a 0 exit code to be classified as successfully deployed. You can achieve this by appending exit 0 to the end of your commandToExecute.")
    ("azurerm_virtual_machine_scale_set" "Create a virtual machine scale set.\n\n Note: All arguments including the administrator login and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_container_group" "Create as an Azure Container Group instance.")
    ("azurerm_container_registry" "Create as an Azure Container Registry instance.\n\n Note: All arguments including the access key will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_container_service" "Creates an Azure Container Service Instance\n\n Note: All arguments including the client secret will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_kubernetes_cluster" "Creates a managed Kubernetes Cluster (AKS)\n\n Note: All arguments including the client secret will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_cosmosdb_account" "Creates a new CosmosDB (formally DocumentDB) Account.")
    ("azurerm_mysql_configuration" "Sets a MySQL Configuration value on a MySQL Server.")
    ("azurerm_mysql_database" "Creates a MySQL Database within a MySQL Server")
    ("azurerm_mysql_firewall_rule" "Creates a Firewall Rule for a MySQL Server")
    ("azurerm_mysql_server" "Manages a MySQL Server.")
    ("azurerm_postgresql_configuration" "Sets a PostgreSQL Configuration value on a PostgreSQL Server.")
    ("azurerm_postgresql_database" "Creates a PostgreSQL Database within a PostgreSQL Server")
    ("azurerm_postgresql_firewall_rule" "Creates a Firewall Rule for a PostgreSQL Server")
    ("azurerm_postgresql_server" "Create a PostgreSQL Server.")
    ("azurerm_sql_database" "Allows you to manage an Azure SQL Database")
    ("azurerm_sql_active_directory_administrator" "Allows you to set a user or group as the AD administrator for an Azure SQL server")
    ("azurerm_sql_elasticpool" "Allows you to manage an Azure SQL Elastic Pool.")
    ("azurerm_sql_firewall_rule" "Allows you to manage an Azure SQL Firewall Rule")
    ("azurerm_sql_server" "Manages a SQL Azure Database Server.\n\n Note: All arguments including the administrator login and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_sql_virtual_network_rule" "Allows you to add, update, or remove an Azure SQL server to a subnet of a virtual network.")
    ("azurerm_dns_a_record" "Enables you to manage DNS A Records within Azure DNS.")
    ("azurerm_dns_aaaa_record" "Enables you to manage DNS AAAA Records within Azure DNS.")
    ("azurerm_dns_cname_record" "Enables you to manage DNS CNAME Records within Azure DNS.")
    ("azurerm_dns_mx_record" "Enables you to manage DNS MX Records within Azure DNS.")
    ("azurerm_dns_ns_record" "Enables you to manage DNS NS Records within Azure DNS.")
    ("azurerm_dns_ptr_record" "Enables you to manage DNS PTR Records within Azure DNS.")
    ("azurerm_dns_srv_record" "Enables you to manage DNS SRV Records within Azure DNS.")
    ("azurerm_dns_txt_record" "Enables you to manage DNS TXT Records within Azure DNS.")
    ("azurerm_dns_zone" "Enables you to manage DNS zones within Azure DNS. These zones are hosted on Azure's name servers to which you can delegate the zone from the parent domain.")
    ("azurerm_key_vault" "Manages a Key Vault.")
    ("azurerm_key_vault_certificate" "Manages a Key Vault Certificate.")
    ("azurerm_key_vault_key" "Manages a Key Vault Key.")
    ("azurerm_key_vault_secret" "Manages a Key Vault Secret.\n\n Note: All arguments including the secret value will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_lb" "Create a LoadBalancer Resource.")
    ("azurerm_lb_backend_address_pool" "Create a LoadBalancer Backend Address Pool.\n\n NOTE: When using this resource, the LoadBalancer needs to have a FrontEnd IP Configuration Attached")
    ("azurerm_lb_rule" "Create a LoadBalancer Rule.\n\n NOTE When using this resource, the LoadBalancer needs to have a FrontEnd IP Configuration Attached")
    ("azurerm_lb_nat_rule" "Create a LoadBalancer NAT Rule.\n\n NOTE When using this resource, the LoadBalancer needs to have a FrontEnd IP Configuration Attached")
    ("azurerm_lb_nat_pool" "Create a LoadBalancer NAT pool.\n\n NOTE When using this resource, the LoadBalancer needs to have a FrontEnd IP Configuration Attached")
    ("azurerm_lb_probe" "Create a LoadBalancer Probe Resource.\n\n NOTE When using this resource, the LoadBalancer needs to have a FrontEnd IP Configuration Attached")
    ("azurerm_management_lock" "Manages a Management Lock which is scoped to a Subscription, Resource Group or Resource.")
    ("azurerm_eventgrid_topic" "Manages an EventGrid Topic\n\n Note: at this time EventGrid Topic's are only available in a limited number of regions.")
    ("azurerm_eventhub" "Creates a new Event Hubs as a nested resource within a Event Hubs namespace.")
    ("azurerm_eventhub_authorization_rule" "Creates a new Event Hubs authorization Rule within an Event Hub.")
    ("azurerm_eventhub_consumer_group" "Creates a new Event Hubs Consumer Group as a nested resource within an Event Hub.")
    ("azurerm_eventhub_namespace" "Create an EventHub Namespace.")
    ("azurerm_iothub" "Creates a new IotHub")
    ("azurerm_servicebus_namespace" "Create a ServiceBus Namespace.")
    ("azurerm_servicebus_queue" "Create and manage a ServiceBus Queue.")
    ("azurerm_servicebus_subscription" "Create a ServiceBus Subscription.")
    ("azurerm_servicebus_subscription_rule" "Create a ServiceBus Subscription Rule.")
    ("azurerm_servicebus_topic" "Create a ServiceBus Topic.\n\nNote Topics can only be created in Namespaces with an SKU of standard or higher.")
    ("azurerm_servicebus_topic_authorization_rule" "Creates a new ServiceBus Topic authorization Rule within a ServiceBus Topic.")
    ("azurerm_metric_alertrule" "Manages a metric-based alert rule in Azure Monitor.")
    ("azurerm_application_gateway" "Creates a new application gateway based on a previously created virtual network with configured subnets.")
    ("azurerm_application_security_group" "Create an Application Security Group.\n\n Note: Application Security Groups are currently in Public Preview on an opt-in basis. More information, including how you can register for the Preview, and which regions Application Security Groups are available in are available here")
    ("azurerm_express_route_circuit" "Manages an ExpressRoute circuit.")
    ("azurerm_express_route_circuit_authorization" "Creates an ExpressRoute Circuit Authorization.")
    ("azurerm_express_route_circuit_peering" "Creates an ExpressRoute Circuit Peering.")
    ("azurerm_local_network_gateway" "Creates a new local network gateway connection over which specific connections can be configured.")
    ("azurerm_network_interface" "Manages a Network Interface located in a Virtual Network, usually attached to a Virtual Machine.")
    ("azurerm_network_security_group" "Manages a network security group that contains a list of network security rules.  Network security groups enable inbound or outbound traffic to be enabled or denied.\n\n NOTE on Network Security Groups and Network Security Rules: Terraform currently provides both a standalone Network Security Rule resource, and allows for Network Security Rules to be defined in-line within the Network Security Group resource. At this time you cannot use a Network Security Group with in-line Network Security Rules in conjunction with any Network Security Rule resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("azurerm_network_security_rule" "Manages a Network Security Rule.\n\n NOTE on Network Security Groups and Network Security Rules: Terraform currently provides both a standalone Network Security Rule resource, and allows for Network Security Rules to be defined in-line within the Network Security Group resource. At this time you cannot use a Network Security Group with in-line Network Security Rules in conjunction with any Network Security Rule resources. Doing so will cause a conflict of rule settings and will overwrite rules.")
    ("azurerm_network_watcher" "Manages a Network Watcher.")
    ("azurerm_packet_capture" "Configures Packet Capturing against a Virtual Machine using a Network Watcher.")
    ("azurerm_public_ip" "Create a Public IP Address.")
    ("azurerm_route" "Manages a Route within a Route Table.")
    ("azurerm_route_table" "Manages a Route Table")
    ("azurerm_subnet" "Manages a subnet. Subnets represent network segments within the IP space defined by the virtual network.\n\n NOTE on Virtual Networks and Subnet's: Terraform currently provides both a standalone Subnet resource, and allows for Subnets to be defined in-line within the Virtual Network resource. At this time you cannot use a Virtual Network with in-line Subnets in conjunction with any Subnet resources. Doing so will cause a conflict of Subnet configurations and will overwrite Subnet's.")
    ("azurerm_traffic_manager_endpoint" "Creates a Traffic Manager Endpoint.")
    ("azurerm_traffic_manager_profile" "Creates a Traffic Manager Profile to which multiple endpoints can be attached.")
    ("azurerm_virtual_network" "Creates a new virtual network including any configured subnets. Each subnet can optionally be configured with a security group to be associated with the subnet.\n\n NOTE on Virtual Networks and Subnet's: Terraform currently provides both a standalone Subnet resource, and allows for Subnets to be defined in-line within the Virtual Network resource. At this time you cannot use a Virtual Network with in-line Subnets in conjunction with any Subnet resources. Doing so will cause a conflict of Subnet configurations and will overwrite Subnet's.")
    ("azurerm_virtual_network_gateway" "Creates a new Virtual Network Gateway to establish secure, cross-premises connectivity.\n\n Note: Please be aware that provisioning a Virtual Network Gateway takes a long time (between 30 minutes and 1 hour)")
    ("azurerm_virtual_network_gateway_connection" "Creates a new connection in an existing Virtual Network Gateway.")
    ("azurerm_virtual_network_peering" "Creates a new virtual network peering which allows resources to access other resources in the linked virtual network.")
    ("azurerm_policy_assignment" "Configured the specified Policy Definition at the specified Scope.")
    ("azurerm_policy_definition" "Creates a policy for all of the resource groups under the subscription.")
    ("azurerm_log_analytics_solution" "Creates a new Log Analytics (formally Operational Insights) Solution.")
    ("azurerm_log_analytics_workspace" "Creates a new Log Analytics (formally Operational Insights) Workspace.")
    ("azurerm_recovery_services_vault" "Create an Recovery Services Vault.")
    ("azurerm_redis_cache" "Manages a Redis Cache.")
    ("azurerm_redis_firewall_rule" "Manages a Firewall Rule associated with a Premium Redis Cache.\n\n Note: Redis Firewall Rules can only be assigned to a Redis Cache with a Premium SKU.")
    ("azurerm_search_service" "Allows you to manage an Azure Search Service")
    ("azurerm_scheduler_job_collection" "Create an Scheduler Job Collection.")
    ("azurerm_storage_account" "Create an Azure Storage Account.")
    ("azurerm_storage_container" "Create an Azure Storage Container.")
    ("azurerm_storage_blob" "Create an Azure Storage Blob.")
    ("azurerm_storage_queue" "Create an Azure Storage Queue.")
    ("azurerm_storage_share" "Create an Azure Storage File Share.")
    ("azurerm_storage_table" "Create an Azure Storage Table.")
    ("azurerm_template_deployment" "Create a template deployment of resources\n\n Note on ARM Template Deployments: Due to the way the underlying Azure API is designed, Terraform can only manage the deployment of the ARM Template - and not any resources which are created by it. This means that when deleting the azurerm_template_deployment resource, Terraform will only remove the reference to the deployment, whilst leaving any resources created by that ARM Template Deployment. One workaround for this is to use a unique Resource Group for each ARM Template Deployment, which means deleting the Resource Group would contain any resources created within it - however this isn't ideal. More information.")
    ("bitbucket_default_reviewers" "Provides support for setting up default reviewers for your repository.")
    ("bitbucket_hook" "Provides a Bitbucket hook resource.\n\nThis allows you to manage your webhooks on a repository.")
    ("bitbucket_repository" "Provides a Bitbucket repository resource.\n\nThis resource allows you manage your repositories such as scm type, if it is private, how to fork the repository and other options.")
    ("clc_server" "Manages a CLC server.\n\nResources and Documentation:\n\n Datacenter / Capability Map  Hyperscale and Bare Metal Servers  REST API")
    ("clc_group" "Manages a CLC server group. Either provisions or resolves to an existing group.\n\nSee also Complete API documentation.")
    ("clc_public_ip" "Manages a CLC public ip (for an existing server).\n\nSee also Complete API documentation.")
    ("clc_load_balancer" "Manages a CLC load balancer. Manage connected backends with clc_load_balancer_pool\n\nSee also Complete API documentation.")
    ("clc_load_balancer_pool" "Manages a CLC load balancer pool. Manage related frontend with clc_load_balancer\n\nSee also Complete API documentation.")
    ("chef_data_bag" "A data bag is a collection of configuration objects that are stored as JSON in Chef Server and can be retrieved and used in Chef recipes.\n\nThis resource creates the data bag itself. Inside each data bag is a collection of items which can be created using the chef_data_bag_item resource.")
    ("chef_data_bag_item" "A data bag is a collection of configuration objects that are stored as JSON in Chef Server and can be retrieved and used in Chef recipes.\n\nThis resource creates objects within an existing data bag. To create the data bag itself, use the chef_data_bag resource.")
    ("chef_environment" "An environment is a container for Chef nodes that share a set of attribute values and may have a set of version constraints for which cookbook versions may be used on its nodes.")
    ("chef_node" "A node is a computer whose configuration is managed by Chef.\n\nAlthough this resource allows a node to be registered, it does not actually configure the computer in question to interact with Chef. In most cases it is better to use the chef provisioner to configure the Chef client on a computer and have it register itself with the Chef server.")
    ("chef_role" "A role is a set of standard configuration that can apply across multiple nodes that perform the same function.")
    ("circonus_check" "The circonus_check resource creates and manages a Circonus Check.\n\n NOTE regarding cirocnus_check vs a Circonus Check Bundle: The circonus_check resource is implemented in terms of a Circonus Check Bundle. The circonus_check creates a higher-level abstraction over the implementation of a Check Bundle.  As such, the naming and structure does not map 1:1 with the underlying Circonus API.")
    ("circonus_contact_group" "The circonus_contact_group resource creates and manages a Circonus Contact Group.")
    ("circonus_graph" "The circonus_graph resource creates and manages a Circonus Graph.\n\nhttps://login.circonus.com/resources/api/calls/graph).")
    ("circonus_metric" "The circonus_metric resource creates and manages a single metric resource that will be instantiated only once a referencing circonus_check has been created.")
    ("circonus_metric_cluster" "The circonus_metric_cluster resource creates and manages a Circonus Metric Cluster.")
    ("circonus_rule_set" "The circonus_rule_set resource creates and manages a Circonus Rule Set.")
    ("cloudflare_load_balancer" "Provides a Cloudflare Load Balancer resource. This sits in front of a number of defined pools of origins and provides various options for geographically-aware load balancing. Note that the load balancing feature must be enabled in your Clouflare account before you can use this resource.")
    ("cloudflare_load_balancer_pool" "Provides a Cloudflare Load Balancer pool resource. This provides a pool of origins that can be used by a Cloudflare Load Balancer. Note that the load balancing feature must be enabled in your Clouflare account before you can use this resource.")
    ("cloudflare_page_rule" "Provides a Cloudflare page rule resource.")
    ("cloudflare_rate_limit" "Provides a Cloudflare rate limit resource for a given zone. This can be used to limit the traffic you receive zone-wide, or matching more specific types of requests/responses.")
    ("cloudflare_record" "Provides a Cloudflare record resource.")
    ("cloudflare_load_balancer_monitor" "If you're using Cloudflare's Load Balancing to load-balance across multiple origin servers or data centers, you configure one of these Monitors to actively check the availability of those servers over HTTP(S).")
    ("cloudflare_zone_settings_override" "Provides a resource which customizes CloudFlare zone settings. Note that after destroying this resource Zone Settings will be reset to their initial values.")
    ("cloudscale_server" "Provides a cloudscale.ch Server resource. This can be used to create, modify, and delete servers.")
    ("cloudscale_floating_ip" "Provides a cloudscale.ch Floating IP to represent a publicly-accessible static IP address or IP network that can be assigned to one of your cloudscale.ch servers. Floating IPs can be moved between servers. Possible use cases include: High-availability, non-disruptive maintenance, multiple IPs per server, or re-using the same IP after replacing a server.")
    ("cloudstack_affinity_group" "Creates an affinity group.")
    ("cloudstack_disk" "Creates a disk volume from a disk offering. This disk volume will be attached to a virtual machine if the optional parameters are configured.")
    ("cloudstack_egress_firewall" "Creates egress firewall rules for a given network.")
    ("cloudstack_firewall" "Creates firewall rules for a given IP address.")
    ("cloudstack_instance" "Creates and automatically starts a virtual machine based on a service offering, disk offering, and template.")
    ("cloudstack_ipaddress" "Acquires and associates a public IP.")
    ("cloudstack_loadbalancer_rule" "Creates a loadbalancer rule.")
    ("cloudstack_network" "Creates a network.")
    ("cloudstack_network_acl" "Creates a Network ACL for the given VPC.")
    ("cloudstack_network_acl_rule" "Creates network ACL rules for a given network ACL.")
    ("cloudstack_nic" "Creates an additional NIC to add a VM to the specified network.")
    ("cloudstack_port_forward" "Creates port forwards.")
    ("cloudstack_private_gateway" "Creates a private gateway for the given VPC.\n\nNOTE: private gateway can only be created using a ROOT account!")
    ("cloudstack_secondary_ipaddress" "Assigns a secondary IP to a NIC.")
    ("cloudstack_security_group" "Creates a security group.")
    ("cloudstack_security_group_rule" "Authorizes and revokes both ingress and egress rulea for a given security group.")
    ("cloudstack_ssh_keypair" "Creates or registers an SSH key pair.")
    ("cloudstack_static_nat" "Enables static NAT for a given IP address")
    ("cloudstack_static_route" "Creates a static route for the given private gateway or VPC.")
    ("cloudstack_template" "Registers an existing template into the CloudStack cloud.")
    ("cloudstack_vpc" "Creates a VPC.")
    ("cloudstack_vpn_gateway" "Creates a site to site VPN local gateway.")
    ("cloudstack_vpn_customer_gateway" "Creates a site to site VPN local customer gateway.")
    ("cloudstack_vpn_connection" "Creates a site to site VPN connection.")
    ("cobbler_distro" "Manages a distribution within Cobbler.")
    ("cobbler_kickstart_file" "Manages a Kickstart File within Cobbler.")
    ("cobbler_repo" "Manages a repo within Cobbler.")
    ("cobbler_profile" "Manages a Profile within Cobbler.")
    ("cobbler_snippet" "Manages a Snippet within Cobbler.")
    ("cobbler_system" "Manages a System within Cobbler.")
    ("consul_agent_service" "Provides access to the agent service data in Consul. This can be used to define a service associated with a particular agent. Currently, defining health checks for an agent service is not supported.")
    ("consul_catalog_entry" "Registers a node or service with the Consul Catalog. Currently, defining health checks is not supported.")
    ("consul_keys" "The consul_keys resource writes sets of individual values into Consul. This is a powerful way to expose infrastructure details to clients.\n\nThis resource manages individual keys, and thus it can create, update and delete the keys explicitly given. However, it is not able to detect and remove additional keys that have been added by non-Terraform means. To manage all keys sharing a common prefix, and thus have Terraform remove errant keys not present in the configuration, consider using the consul_key_prefix resource instead.")
    ("consul_key_prefix" "Allows Terraform to manage a \"namespace\" of Consul keys that share a common name prefix.\n\nLike consul_keys, this resource can write values into the Consul key/value store, but unlike consul_keys this resource can detect and remove extra keys that have been added some other way, thus ensuring that rogue data added outside of Terraform will be removed on the next run.\n\nThis resource is thus useful in the case where Terraform is exclusively managing a set of related keys.\n\nTo avoid accidentally clobbering matching data that existed in Consul before a consul_key_prefix resource was created, creation of a key prefix instance will fail if any matching keys are already present in the key/value store. If any conflicting data is present, you must first delete it manually.\n\n Warning After this resource is instantiated, Terraform takes control over all keys with the given path prefix, and will remove any matching keys that are not present in the configuration. It will also delete all keys under the given prefix when a consul_key_prefix resource is destroyed, even if those keys were created outside of Terraform.")
    ("consul_node" "Provides access to Node data in Consul. This can be used to define a node. Currently, defining health checks is not supported.")
    ("consul_prepared_query" "Allows Terraform to manage a Consul prepared query.\n\nManaging prepared queries is done using Consul's REST API. This resource is useful to provide a consistent and declarative way of managing prepared queries in your Consul cluster using Terraform.")
    ("consul_service" "A high-level resource for creating a Service in Consul. Currently, defining health checks for a service is not supported.\n\nMost users should not use this resource. When using Consul with compute instances, it's better to install the Consul Agent on these machines and register services via the agent. This ensures that services get assigned to the appropriate Consul \"nodes\" and allows service health to integrate with general node health as reported by the agent.\n\nTo register a non-compute resource, such as a hosted database, as a service, as described in Consul's External Services guide, use consul_catalog_entry instead, which can create an arbitrary service record in the Consul catalog.")
    ("datadog_downtime" "Provides a Datadog downtime resource. This can be used to create and manage Datadog downtimes.")
    ("datadog_monitor" "Provides a Datadog monitor resource. This can be used to create and manage Datadog monitors.")
    ("datadog_timeboard" "Provides a Datadog timeboard resource. This can be used to create and manage Datadog timeboards.")
    ("datadog_user" "Provides a Datadog user resource. This can be used to create and manage Datadog users.")
    ("digitalocean_certificate" "Provides a DigitalOcean Certificate resource that allows you to manage certificates for configuring TLS termination in Load Balancers. Certificates created with this resource can be referenced in your Load Balancer configuration via their ID.")
    ("digitalocean_domain" "Provides a DigitalOcean domain resource.")
    ("digitalocean_droplet" "Provides a DigitalOcean Droplet resource. This can be used to create, modify, and delete Droplets. Droplets also support provisioning.")
    ("digitalocean_firewall" "Provides a DigitalOcean Cloud Firewall resource. This can be used to create, modify, and delete Firewalls.")
    ("digitalocean_floating_ip" "Provides a DigitalOcean Floating IP to represent a publicly-accessible static IP addresses that can be mapped to one of your Droplets.")
    ("digitalocean_loadbalancer" "Provides a DigitalOcean Load Balancer resource. This can be used to create, modify, and delete Load Balancers.")
    ("digitalocean_record" "Provides a DigitalOcean DNS record resource.")
    ("digitalocean_ssh_key" "Provides a DigitalOcean SSH key resource to allow you to manage SSH keys for Droplet access. Keys created with this resource can be referenced in your droplet configuration via their ID or fingerprint.")
    ("digitalocean_tag" "Provides a DigitalOcean Tag resource. A Tag is a label that can be applied to a droplet resource in order to better organize or facilitate the lookups and actions on it. Tags created with this resource can be referenced in your droplet configuration via their ID or name.")
    ("digitalocean_volume" "Provides a DigitalOcean Block Storage volume which can be attached to a Droplet in order to provide expanded storage.")
    ("dns_a_record_set" "Creates a A type DNS record set.")
    ("dns_aaaa_record_set" "Creates a AAAA type DNS record set.")
    ("dns_cname_record" "Creates a CNAME type DNS record.")
    ("dns_ptr_record" "Creates a PTR type DNS record.")
    ("dme_record" "Provides a DNSMadeEasy record resource.")
    ("dnsimple_record" "Provides a DNSimple record resource.")
    ("docker_container" "Manages the lifecycle of a Docker container.")
    ("docker_image" "Note: The initial (current) version of this resource can only pull public images from the official Docker Hub Registry. \n\nPulls a Docker image to a given Docker host from a Docker Registry.\n\nThis resource will not pull new layers of the image automatically unless used in conjunction with docker_registry_image data source to update the pull_triggers field.")
    ("docker_network" "Manages a Docker Network. This can be used alongside docker_container to create virtual networks within the docker environment.")
    ("docker_volume" "Creates and destroys a volume in Docker. This can be used alongside docker_container to prepare volumes that can be shared across containers.")
    ("dyn_record" "Provides a Dyn DNS record resource.")
    ("fastly_service_v1" "Provides a Fastly Service, representing the configuration for a website, app, API, or anything else to be served through Fastly. A Service encompasses Domains and Backends.\n\nThe Service resource requires a domain name that is correctly set up to direct traffic to the Fastly service. See Fastly's guide on Adding CNAME Records on their documentation site for guidance.")
    ("github_branch_protection" "Protects a GitHub branch.\n\nThis resource allows you to configure branch protection for repositories in your organization. When applied, the branch will be protected from forced pushes and deletion. Additional constraints, such as required status checks or restrictions on users and teams, can also be configured.")
    ("github_membership" "Provides a GitHub membership resource.\n\nThis resource allows you to add/remove users from your organization. When applied, an invitation will be sent to the user to become part of the organization. When destroyed, either the invitation will be cancelled or the user will be removed.")
    ("github_organization_webhook" "This resource allows you to create and manage webhooks for Github organization.")
    ("github_repository" "This resource allows you to create and manage repositories within your Github organization.\n\nThis resource cannot currently be used to manage personal repositories, outside of organizations.")
    ("github_repository_collaborator" "Provides a GitHub repository collaborator resource.\n\nThis resource allows you to add/remove collaborators from repositories in your organization. Collaborators can have explicit (and differing levels of) read, write, or administrator access to specific repositories in your organization, without giving the user full organization membership.\n\nWhen applied, an invitation will be sent to the user to become a collaborator on a repository. When destroyed, either the invitation will be cancelled or the collaborator will be removed from the repository.\n\nFurther documentation on GitHub collaborators:\n\n Adding outside collaborators to repositories in your organization  Converting an organization member to an outside collaborator")
    ("github_repository_deploy_key" "Provides a GitHub repository deploy key resource.\n\nA deploy key is an SSH key that is stored on your server and grants access to a single GitHub repository. This key is attached directly to the repository instead of to a personal user account.\n\nThis resource allows you to add/remove repository deploy keys.\n\nFurther documentation on GitHub repository deploy keys: - About deploy keys")
    ("github_repository_webhook" "This resource allows you to create and manage webhooks for repositories within your Github organization.\n\nThis resource cannot currently be used to manage webhooks for personal repositories, outside of organizations.")
    ("github_team" "Provides a GitHub team resource.\n\nThis resource allows you to add/remove teams from your organization. When applied, a new team will be created. When destroyed, that team will be removed.")
    ("github_team_membership" "Provides a GitHub team membership resource.\n\nThis resource allows you to add/remove users from teams in your organization. When applied, the user will be added to the team. If the user hasn't accepted their invitation to the organization, they won't be part of the team until they do. When destroyed, the user will be removed from the team.")
    ("github_team_repository" "This resource manages relationships between teams and repositories in your Github organization.\n\nCreating this resource grants a particular team permissions on a particular repository.\n\nThe repository and the team must both belong to the same organization on Github. This resource does not actually create any repositories; to do that, see github_repository.")
    ("github_issue_label" "Provides a GitHub issue label resource.\n\nThis resource allows you to create and manage issue labels within your Github organization.\n\nIssue labels are keyed off of their \"name\", so pre-existing issue labels result in a 422 HTTP error if they exist outside of Terraform. Normally this would not be an issue, except new repositories are created with a \"default\" set of labels, and those labels easily conflict with custom ones.\n\nThis resource will first check if the label exists, and then issue an update, otherwise it will create.")
    ("gitlab_deploy_key" "This resource allows you to create and manage deploy keys for your GitLab projects.")
    ("gitlab_group" "This resource allows you to create and manage GitLab groups. Note your provider will need to be configured with admin-level access for this resource to work.")
    ("gitlab_label" "This resource allows you to create and manage labels for your GitLab projects. For further information on labels, consult the gitlab documentation.")
    ("gitlab_project_hook" "This resource allows you to create and manage hooks for your GitLab projects. For further information on hooks, consult the gitlab documentation.")
    ("gitlab_project" "This resource allows you to create and manage projects within your GitLab group or within your user.")
    ("gitlab_user" "This resource allows you to create and manage GitLab users. Note your provider will need to be configured with admin-level access for this resource to work.")
    ("google_bigquery_dataset" "Creates a dataset resource for Google BigQuery. For more information see the official documentation and API.")
    ("google_bigquery_table" "Creates a table resource in a dataset for Google BigQuery. For more information see the official documentation and API.")
    ("google_bigtable_instance" "Creates a Google Bigtable instance. For more information see the official documentation and API.")
    ("google_bigtable_table" "Creates a Google Bigtable table inside an instance. For more information see the official documentation and API.")
    ("google_cloudfunctions_function" "Creates a new Cloud Function. For more information see the official documentation and API.")
    ("google_folder" "Allows management of a Google Cloud Platform folder. For more information see  the official documentation and  API.\n\nA folder can contain projects, other folders, or a combination of both. You can use folders to group projects under an organization in a hierarchy. For example, your organization might contain multiple departments, each with its own set of Cloud Platform resources. Folders allows you to group these resources on a per-department basis. Folders are used to group resources that share common IAM policies.\n\nFolders created live inside an Organization. See the Organization documentation for more details.\n\nThe service account used to run Terraform when creating a google_folder resource must have roles/resourcemanager.folderCreator. See the Access Control for Folders Using IAM doc for more information.")
    ("google_folder_iam_binding" "Allows creation and management of a single binding within IAM policy for an existing Google Cloud Platform folder.\n\n Note: This resource must not be used in conjunction with    google_folder_iam_policy or they will fight over what your policy    should be.")
    ("google_folder_iam_member" "Allows creation and management of a single member for a single binding within the IAM policy for an existing Google Cloud Platform folder.\n\n Note: This resource must not be used in conjunction with    google_folder_iam_policy or they will fight over what your policy    should be. Similarly, roles controlled by google_folder_iam_binding    should not be assigned to using google_folder_iam_member.")
    ("google_folder_iam_policy" "Allows creation and management of the IAM policy for an existing Google Cloud Platform folder.")
    ("google_folder_organization_policy" "Allows management of Organization policies for a Google Folder. For more information see the official documentation and API.")
    ("google_organization_policy" "Allows management of Organization policies for a Google Organization. For more information see the official documentation and API.")
    ("google_organization_iam_binding" "Allows creation and management of a single binding within IAM policy for an existing Google Cloud Platform Organization.\n\n Note: This resource must not be used in conjunction with    google_organization_iam_member for the same role or they will fight over    what your policy should be.")
    ("google_organization_iam_custom_role" "Allows management of a customized Cloud IAM organization role. For more information see the official documentation and API.")
    ("google_organization_iam_member" "Allows creation and management of a single member for a single binding within the IAM policy for an existing Google Cloud Platform Organization.\n\n Note: This resource must not be used in conjunction with    google_organization_iam_binding for the same role or they will fight over    what your policy should be.")
    ("google_organization_iam_policy" "Allows management of the entire IAM policy for an existing Google Cloud Platform Organization.\n\n Warning: New organizations have several default policies which will,    without extreme caution, be overwritten by use of this resource.    The safest alternative is to use multiple google_organization_iam_binding    resources.  It is easy to use this resource to remove your own access to    an organization, which will require a call to Google Support to have    fixed, and can take multiple days to resolve.  If you do use this resource,    the best way to be sure that you are not making dangerous changes is to start    by importing your existing policy, and examining the diff very closely. \n\n Note: This resource must not be used in conjunction with    google_organization_iam_member or google_organization_iam_binding    or they will fight over what your policy should be.")
    ("google_project" "Allows creation and management of a Google Cloud Platform project.\n\nProjects created with this resource must be associated with an Organization. See the Organization documentation for more details.\n\nThe service account used to run Terraform when creating a google_project resource must have roles/resourcemanager.projectCreator. See the Access Control for Organizations Using IAM doc for more information.\n\nNote that prior to 0.8.5, google_project functioned like a data source, meaning any project referenced by it had to be created and managed outside Terraform. As of 0.8.5, google_project functions like any other Terraform resource, with Terraform creating and managing the project. To replicate the old behavior, either:\n\n Use the project ID directly in whatever is referencing the project, using the google_project_iam_policy to replace the old policy_data property.  Use the import functionality to import your pre-existing project into Terraform, where it can be referenced and used just like always, keeping in mind that Terraform will attempt to undo any changes made outside Terraform.  \n\n It's important to note that any project resources that were added to your Terraform config prior to 0.8.5 will continue to function as they always have, and will not be managed by Terraform. Only newly added projects are affected.")
    ("google_project_iam_binding" "Three different resources help you manage your IAM policy for a project. Each of these resources serves a different use case:\n\n google_project_iam_policy: Authoritative. Sets the IAM policy for the project and replaces any existing policy already attached.  google_project_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the project are preserved.  google_project_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the project are preserved.  \n\n Note: google_project_iam_policy cannot be used in conjunction with google_project_iam_binding and google_project_iam_member or they will fight over what your policy should be. \n\n Note: google_project_iam_binding resources can be used in conjunction with google_project_iam_member resources only if they do not grant privilege to the same role.")
    ("google_project_iam_member" "Three different resources help you manage your IAM policy for a project. Each of these resources serves a different use case:\n\n google_project_iam_policy: Authoritative. Sets the IAM policy for the project and replaces any existing policy already attached.  google_project_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the project are preserved.  google_project_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the project are preserved.  \n\n Note: google_project_iam_policy cannot be used in conjunction with google_project_iam_binding and google_project_iam_member or they will fight over what your policy should be. \n\n Note: google_project_iam_binding resources can be used in conjunction with google_project_iam_member resources only if they do not grant privilege to the same role.")
    ("google_project_iam_policy" "Three different resources help you manage your IAM policy for a project. Each of these resources serves a different use case:\n\n google_project_iam_policy: Authoritative. Sets the IAM policy for the project and replaces any existing policy already attached.  google_project_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the project are preserved.  google_project_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the project are preserved.  \n\n Note: google_project_iam_policy cannot be used in conjunction with google_project_iam_binding and google_project_iam_member or they will fight over what your policy should be. \n\n Note: google_project_iam_binding resources can be used in conjunction with google_project_iam_member resources only if they do not grant privilege to the same role.")
    ("google_project_iam_custom_role" "Allows management of a customized Cloud IAM project role. For more information see the official documentation and API.")
    ("google_project_organization_policy" "Allows management of Organization policies for a Google Project. For more information see the official documentation and API.")
    ("google_project_service" "Allows management of a single API service for an existing Google Cloud Platform project.\n\nFor a list of services available, visit the API library page or run gcloud services list.\n\n Note: This resource must not be used in conjunction with    google_project_services or they will fight over which services should be enabled.")
    ("google_project_services" "Allows management of enabled API services for an existing Google Cloud Platform project. Services in an existing project that are not defined in the config will be removed.\n\nFor a list of services available, visit the API library page or run gcloud services list.\n\n Note: This resource attempts to be the authoritative source on which APIs are enabled, which can     lead to conflicts when certain APIs or actions enable other APIs. To just ensure that a specific     API is enabled, use the google_project_service resource.")
    ("google_project_usage_export_bucket" "Sets up a usage export bucket for a particular project.  A usage export bucket is a pre-configured GCS bucket which is set up to receive daily and monthly reports of the GCE resources used.\n\nFor more information see the Docs and for further details, the API Documentation.")
    ("google_service_account" "Allows management of a Google Cloud Platform service account")
    ("google_service_account_iam_binding" "When managing IAM roles, you can treat a service account either as a resource or as an identity. This resource is to add iam policy bindings to a service account resource to configure permissions for who can edit the service account. To configure permissions for a service account to act as an identity that can manage other GCP resources, use the google_project_iam set of resources.\n\nThree different resources help you manage your IAM policy for a service account. Each of these resources serves a different use case:\n\n google_service_account_iam_policy: Authoritative. Sets the IAM policy for the service account and replaces any existing policy already attached.  google_service_account_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the service account are preserved.  google_service_account_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the service account are preserved.  \n\n Note: google_service_account_iam_policy cannot be used in conjunction with google_service_account_iam_binding and google_service_account_iam_member or they will fight over what your policy should be. \n\n Note: google_service_account_iam_binding resources can be used in conjunction with google_service_account_iam_member resources only if they do not grant privilege to the same role.")
    ("google_service_account_iam_member" "When managing IAM roles, you can treat a service account either as a resource or as an identity. This resource is to add iam policy bindings to a service account resource to configure permissions for who can edit the service account. To configure permissions for a service account to act as an identity that can manage other GCP resources, use the google_project_iam set of resources.\n\nThree different resources help you manage your IAM policy for a service account. Each of these resources serves a different use case:\n\n google_service_account_iam_policy: Authoritative. Sets the IAM policy for the service account and replaces any existing policy already attached.  google_service_account_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the service account are preserved.  google_service_account_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the service account are preserved.  \n\n Note: google_service_account_iam_policy cannot be used in conjunction with google_service_account_iam_binding and google_service_account_iam_member or they will fight over what your policy should be. \n\n Note: google_service_account_iam_binding resources can be used in conjunction with google_service_account_iam_member resources only if they do not grant privilege to the same role.")
    ("google_service_account_iam_policy" "When managing IAM roles, you can treat a service account either as a resource or as an identity. This resource is to add iam policy bindings to a service account resource to configure permissions for who can edit the service account. To configure permissions for a service account to act as an identity that can manage other GCP resources, use the google_project_iam set of resources.\n\nThree different resources help you manage your IAM policy for a service account. Each of these resources serves a different use case:\n\n google_service_account_iam_policy: Authoritative. Sets the IAM policy for the service account and replaces any existing policy already attached.  google_service_account_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the service account are preserved.  google_service_account_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the service account are preserved.  \n\n Note: google_service_account_iam_policy cannot be used in conjunction with google_service_account_iam_binding and google_service_account_iam_member or they will fight over what your policy should be. \n\n Note: google_service_account_iam_binding resources can be used in conjunction with google_service_account_iam_member resources only if they do not grant privilege to the same role.")
    ("google_service_account_key" "Creates and manages service account key-pairs, which allow the user to establish identity of a service account outside of GCP. For more information, see the official documentation and API.")
    ("google_compute_address" "Creates a static IP address resource for Google Compute Engine. For more information see the official documentation for external and internal static IP reservations, as well as the API.")
    ("google_compute_autoscaler" "A Compute Engine Autoscaler automatically adds or removes virtual machines from a managed instance group based on increases or decreases in load. This allows your applications to gracefully handle increases in traffic and reduces cost when the need for resources is lower. You just define the autoscaling policy and the autoscaler performs automatic scaling based on the measured load. For more information, see the official documentation and API")
    ("google_compute_backend_bucket" "Backend buckets allow you to use Google Cloud Storage buckets with HTTP(S) load balancing.\n\nAn HTTP(S) load balancer can direct traffic to specified URLs to a backend bucket rather than a backend service. It can send requests for static content to a Cloud Storage bucket and requests for dynamic content a virtual machine instance.\n\nTo get more information about BackendBucket, see:\n\n API documentation  How-to Guides   Using a Cloud Storage bucket as a load balancer backend")
    ("google_compute_backend_service" "A Backend Service defines a group of virtual machines that will serve traffic for load balancing. For more information see the official documentation and the API.\n\nFor internal load balancing, use a google_compute_region_backend_service.")
    ("google_compute_disk" "Creates a new persistent disk within GCE, based on another disk. For more information see the official documentation and API.\n\n Note: All arguments including the disk encryption key will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("google_compute_firewall" "Manages a firewall resource within GCE. For more information see the official documentation and API.")
    ("google_compute_forwarding_rule" "Manages a Forwarding Rule within GCE. This binds an ip and port range to a target pool. For more information see the official documentation and API.")
    ("google_compute_global_address" "Represents a Global Address resource. Global addresses are used for HTTP(S) load balancing.\n\nTo get more information about GlobalAddress, see:\n\n API documentation  How-to Guides   Reserving a Static External IP Address")
    ("google_compute_global_forwarding_rule" "Manages a Global Forwarding Rule within GCE. This binds an ip and port to a target HTTP(s) proxy. For more information see the official documentation and API.")
    ("google_compute_health_check" "Manages a health check within GCE. This is used to monitor instances behind load balancers. Timeouts or HTTP errors cause the instance to be removed from the pool. For more information, see the official documentation and API.")
    ("google_compute_http_health_check" "An HttpHealthCheck resource. This resource defines a template for how individual VMs should be checked for health, via HTTP.\n\n Note: google_compute_http_health_check is a legacy health check. The newer google_compute_health_check should be preferred for all uses except Network Load Balancers which still require the legacy version. \n\nTo get more information about HttpHealthCheck, see:\n\n API documentation  How-to Guides   Adding Health Checks")
    ("google_compute_https_health_check" "An HttpsHealthCheck resource. This resource defines a template for how individual VMs should be checked for health, via HTTPS.\n\n Note: google_compute_https_health_check is a legacy health check. The newer google_compute_health_check should be preferred for all uses except Network Load Balancers which still require the legacy version. \n\nTo get more information about HttpsHealthCheck, see:\n\n API documentation  How-to Guides   Adding Health Checks")
    ("google_compute_image" "Creates a bootable VM image resource for Google Compute Engine from an existing tarball. For more information see the official documentation and API.")
    ("google_compute_instance" "Manages a VM instance resource within GCE. For more information see the official documentation and API.")
    ("google_compute_instance_group" "Creates a group of dissimilar Compute Engine virtual machine instances. For more information, see the official documentation and API")
    ("google_compute_instance_group_manager" "The Google Compute Engine Instance Group Manager API creates and manages pools of homogeneous Compute Engine virtual machine instances from a common instance template. For more information, see the official documentation and API\n\n Note: Use google_compute_region_instance_group_manager to create a regional (multi-zone) instance group manager.")
    ("google_compute_instance_template" "Manages a VM instance template resource within GCE. For more information see the official documentation and API.")
    ("google_compute_network_peering" "Manages a network peering within GCE. For more information see the official documentation and API.\n\n Note: Both network must create a peering with each other for the peering to be functional. \n\n Note: Subnets IP ranges across peered VPC networks cannot overlap.")
    ("google_compute_network" "Manages a network within GCE. For more information see the official documentation and API.")
    ("google_compute_project_metadata" "Manages metadata common to all instances for a project in GCE. For more information see the official documentation and API.\n\n Note:  If you want to manage only single key/value pairs within the project metadata rather than the entire set, then use google_compute_project_metadata_item.")
    ("google_compute_project_metadata_item" "Manages a single key/value pair on metadata common to all instances for a project in GCE. Using google_compute_project_metadata_item lets you manage a single key/value setting in Terraform rather than the entire project metadata map.")
    ("google_compute_region_autoscaler" "A Compute Engine Regional Autoscaler automatically adds or removes virtual machines from a managed instance group based on increases or decreases in load. This allows your applications to gracefully handle increases in traffic and reduces cost when the need for resources is lower. You just define the autoscaling policy and the autoscaler performs automatic scaling based on the measured load. For more information, see the official documentation and API")
    ("google_compute_region_backend_service" "A Region Backend Service defines a regionally-scoped group of virtual machines that will serve traffic for load balancing. For more information see the official documentation and API.")
    ("google_compute_region_instance_group_manager" "The Google Compute Engine Regional Instance Group Manager API creates and manages pools of homogeneous Compute Engine virtual machine instances from a common instance template. For more information, see the official documentation and API\n\n Note: Use google_compute_instance_group_manager to create a single-zone instance group manager.")
    ("google_compute_route" "Manages a network route within GCE. For more information see the official documentation and API.")
    ("google_compute_router" "Manages a Cloud Router resource. For more information see the official documentation and API.")
    ("google_compute_router_interface" "Manages a Cloud Router interface. For more information see the official documentation and API.")
    ("google_compute_router_peer" "Manages a Cloud Router BGP peer. For more information see the official documentation and API.")
    ("google_compute_security_policy" "A Security Policy defines an IP blacklist or whitelist that protects load balanced Google Cloud services by denying or permitting traffic from specified IP ranges. For more information see the official documentation and the API.\n\n Note: This entire resource is in Beta")
    ("google_compute_shared_vpc_host_project" "Enables the Google Compute Engine Shared VPC feature for a project, assigning it as a Shared VPC host project.\n\nFor more information, see, the Project API documentation, where the Shared VPC feature is referred to by its former name \"XPN\".")
    ("google_compute_shared_vpc_service_project" "Enables the Google Compute Engine Shared VPC feature for a project, assigning it as a Shared VPC service project associated with a given host project.\n\nFor more information, see, the Project API documentation, where the Shared VPC feature is referred to by its former name \"XPN\".")
    ("google_compute_snapshot" "Creates a new snapshot of a disk within GCE. For more information see the official documentation and API.")
    ("google_compute_ssl_certificate" "Creates an SSL certificate resource necessary for HTTPS load balancing in GCE. For more information see the official documentation and API.")
    ("google_compute_ssl_policy" "Manages an SSL Policy within GCE, for use with Target HTTPS and Target SSL Proxies. For more information see the official documentation and API.")
    ("google_compute_subnetwork" "Manages a subnetwork within GCE. For more information see the official documentation and API.")
    ("google_compute_subnetwork_iam_binding" "Three different resources help you manage your IAM policy for GCE subnetwork. Each of these resources serves a different use case:\n\n google_compute_subnetwork_iam_policy: Authoritative. Sets the IAM policy for the subnetwork and replaces any existing policy already attached.  google_compute_subnetwork_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the subnetwork are preserved.  google_compute_subnetwork_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the subnetwork are preserved.  \n\n Note: google_compute_subnetwork_iam_policy cannot be used in conjunction with google_compute_subnetwork_iam_binding and google_compute_subnetwork_iam_member or they will fight over what your policy should be. \n\n Note: google_compute_subnetwork_iam_binding resources can be used in conjunction with google_compute_subnetwork_iam_member resources only if they do not grant privilege to the same role. \n\n Note: These entire resources are in Beta")
    ("google_compute_subnetwork_iam_member" "Three different resources help you manage your IAM policy for GCE subnetwork. Each of these resources serves a different use case:\n\n google_compute_subnetwork_iam_policy: Authoritative. Sets the IAM policy for the subnetwork and replaces any existing policy already attached.  google_compute_subnetwork_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the subnetwork are preserved.  google_compute_subnetwork_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the subnetwork are preserved.  \n\n Note: google_compute_subnetwork_iam_policy cannot be used in conjunction with google_compute_subnetwork_iam_binding and google_compute_subnetwork_iam_member or they will fight over what your policy should be. \n\n Note: google_compute_subnetwork_iam_binding resources can be used in conjunction with google_compute_subnetwork_iam_member resources only if they do not grant privilege to the same role. \n\n Note: These entire resources are in Beta")
    ("google_compute_subnetwork_iam_policy" "Three different resources help you manage your IAM policy for GCE subnetwork. Each of these resources serves a different use case:\n\n google_compute_subnetwork_iam_policy: Authoritative. Sets the IAM policy for the subnetwork and replaces any existing policy already attached.  google_compute_subnetwork_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the subnetwork are preserved.  google_compute_subnetwork_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the subnetwork are preserved.  \n\n Note: google_compute_subnetwork_iam_policy cannot be used in conjunction with google_compute_subnetwork_iam_binding and google_compute_subnetwork_iam_member or they will fight over what your policy should be. \n\n Note: google_compute_subnetwork_iam_binding resources can be used in conjunction with google_compute_subnetwork_iam_member resources only if they do not grant privilege to the same role. \n\n Note: These entire resources are in Beta")
    ("google_compute_target_http_proxy" "Represents a TargetHttpProxy resource, which is used by one or more global forwarding rule to route incoming HTTP requests to a URL map.\n\nTo get more information about TargetHttpProxy, see:\n\n API documentation  How-to Guides   Official Documentation")
    ("google_compute_target_https_proxy" "Represents a TargetHttpsProxy resource, which is used by one or more global forwarding rule to route incoming HTTPS requests to a URL map.\n\nTo get more information about TargetHttpsProxy, see:\n\n API documentation  How-to Guides   Official Documentation")
    ("google_compute_target_ssl_proxy" "Represents a TargetSslProxy resource, which is used by one or more global forwarding rule to route incoming SSL requests to a backend service.\n\nTo get more information about TargetSslProxy, see:\n\n API documentation  How-to Guides   Setting Up SSL proxy for Google Cloud Load Balancing")
    ("google_compute_target_tcp_proxy" "Represents a TargetTcpProxy resource, which is used by one or more global forwarding rule to route incoming TCP requests to a Backend service.\n\nTo get more information about TargetTcpProxy, see:\n\n API documentation  How-to Guides   Setting Up TCP proxy for Google Cloud Load Balancing")
    ("google_compute_target_pool" "Manages a Target Pool within GCE. This is a collection of instances used as target of a network load balancer (Forwarding Rule). For more information see the official documentation and API.")
    ("google_compute_url_map" "Manages a URL Map resource within GCE. For more information see the official documentation and API.")
    ("google_compute_vpn_gateway" "Represents a VPN gateway running in GCP. This virtual device is managed by Google, but used only by you.\n\nTo get more information about VpnGateway, see:\n\n API documentation")
    ("google_compute_vpn_tunnel" "Manages a VPN Tunnel to the GCE network. For more info, read the documentation.\n\n Note: All arguments including the shared_secret will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("google_container_cluster" "Creates a Google Kubernetes Engine (GKE) cluster. For more information see the official documentation and API.\n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("google_container_node_pool" "Manages a Node Pool resource within GKE. For more information see the official documentation and API.")
    ("google_dataflow_job" "Creates a job on Dataflow, which is an implementation of Apache Beam running on Google Compute Engine. For more information see the official documentation for Beam and Dataflow.")
    ("google_dataproc_cluster" "Manages a Cloud Dataproc cluster resource within GCP. For more information see the official dataproc documentation.\n\n Warning: Due to limitations of the API, all arguments except labels,cluster_config.worker_config.num_instances and cluster_config.preemptible_worker_config.num_instances are non-updateable. Changing others will cause recreation of the whole cluster!")
    ("google_dataproc_job" "Manages a job resource within a Dataproc cluster within GCE. For more information see the official dataproc documentation.\n\n Note: This resource does not support 'update' and changing any attributes will cause the resource to be recreated.")
    ("google_dns_managed_zone" "Manages a zone within Google Cloud DNS. For more information see the official documentation and API.")
    ("google_dns_record_set" "Manages a set of DNS records within Google Cloud DNS. For more information see the official documentation and API.\n\n Note: The Google Cloud DNS API requires NS records be present at all times. To accommodate this, when creating NS records, the default records Google automatically creates will be silently overwritten.  Also, when destroying NS records, Terraform will not actually remove NS records, but will report that it did.")
    ("google_endpoints_service" "This resource creates and rolls out a Cloud Endpoints service using OpenAPI or gRPC.  View the relevant docs for OpenAPI and gRPC.")
    ("google_pubsub_topic" "Creates a topic in Google's pubsub queueing system. For more information see the official documentation and API.")
    ("google_pubsub_topic_iam_binding" "Three different resources help you manage your IAM policy for pubsub topic. Each of these resources serves a different use case:\n\n google_pubsub_topic_iam_policy: Authoritative. Sets the IAM policy for the topic and replaces any existing policy already attached.  google_pubsub_topic_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the topic are preserved.  google_pubsub_topic_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the topic are preserved.  \n\n Note: google_pubsub_topic_iam_policy cannot be used in conjunction with google_pubsub_topic_iam_binding and google_pubsub_topic_iam_member or they will fight over what your policy should be. \n\n Note: google_pubsub_topic_iam_binding resources can be used in conjunction with google_pubsub_topic_iam_member resources only if they do not grant privilege to the same role.")
    ("google_pubsub_topic_iam_member" "Three different resources help you manage your IAM policy for pubsub topic. Each of these resources serves a different use case:\n\n google_pubsub_topic_iam_policy: Authoritative. Sets the IAM policy for the topic and replaces any existing policy already attached.  google_pubsub_topic_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the topic are preserved.  google_pubsub_topic_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the topic are preserved.  \n\n Note: google_pubsub_topic_iam_policy cannot be used in conjunction with google_pubsub_topic_iam_binding and google_pubsub_topic_iam_member or they will fight over what your policy should be. \n\n Note: google_pubsub_topic_iam_binding resources can be used in conjunction with google_pubsub_topic_iam_member resources only if they do not grant privilege to the same role.")
    ("google_pubsub_topic_iam_policy" "Three different resources help you manage your IAM policy for pubsub topic. Each of these resources serves a different use case:\n\n google_pubsub_topic_iam_policy: Authoritative. Sets the IAM policy for the topic and replaces any existing policy already attached.  google_pubsub_topic_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the topic are preserved.  google_pubsub_topic_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the topic are preserved.  \n\n Note: google_pubsub_topic_iam_policy cannot be used in conjunction with google_pubsub_topic_iam_binding and google_pubsub_topic_iam_member or they will fight over what your policy should be. \n\n Note: google_pubsub_topic_iam_binding resources can be used in conjunction with google_pubsub_topic_iam_member resources only if they do not grant privilege to the same role.")
    ("google_pubsub_subscription" "Creates a subscription in Google's pubsub queueing system. For more information see the official documentation and API.")
    ("google_pubsub_subscription_iam_binding" "Three different resources help you manage your IAM policy for pubsub subscription. Each of these resources serves a different use case:\n\n google_pubsub_subscription_iam_policy: Authoritative. Sets the IAM policy for the subscription and replaces any existing policy already attached.  google_pubsub_subscription_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the subscription are preserved.  google_pubsub_subscription_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the subscription are preserved.  \n\n Note: google_pubsub_subscription_iam_policy cannot be used in conjunction with google_pubsub_subscription_iam_binding and google_pubsub_subscription_iam_member or they will fight over what your policy should be. \n\n Note: google_pubsub_subscription_iam_binding resources can be used in conjunction with google_pubsub_subscription_iam_member resources only if they do not grant privilege to the same role.")
    ("google_pubsub_subscription_iam_member" "Three different resources help you manage your IAM policy for pubsub subscription. Each of these resources serves a different use case:\n\n google_pubsub_subscription_iam_policy: Authoritative. Sets the IAM policy for the subscription and replaces any existing policy already attached.  google_pubsub_subscription_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the subscription are preserved.  google_pubsub_subscription_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the subscription are preserved.  \n\n Note: google_pubsub_subscription_iam_policy cannot be used in conjunction with google_pubsub_subscription_iam_binding and google_pubsub_subscription_iam_member or they will fight over what your policy should be. \n\n Note: google_pubsub_subscription_iam_binding resources can be used in conjunction with google_pubsub_subscription_iam_member resources only if they do not grant privilege to the same role.")
    ("google_pubsub_subscription_iam_policy" "Three different resources help you manage your IAM policy for pubsub subscription. Each of these resources serves a different use case:\n\n google_pubsub_subscription_iam_policy: Authoritative. Sets the IAM policy for the subscription and replaces any existing policy already attached.  google_pubsub_subscription_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the subscription are preserved.  google_pubsub_subscription_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the subscription are preserved.  \n\n Note: google_pubsub_subscription_iam_policy cannot be used in conjunction with google_pubsub_subscription_iam_binding and google_pubsub_subscription_iam_member or they will fight over what your policy should be. \n\n Note: google_pubsub_subscription_iam_binding resources can be used in conjunction with google_pubsub_subscription_iam_member resources only if they do not grant privilege to the same role.")
    ("google_runtimeconfig_config" "Manages a RuntimeConfig resource in Google Cloud. For more information, see the official documentation, or the JSON API.")
    ("google_runtimeconfig_variable" "Manages a RuntimeConfig variable in Google Cloud. For more information, see the official documentation, or the JSON API.")
    ("google_sourcerepo_repository" "For more information, see the official documentation and API")
    ("google_spanner_database" "Creates a Google Spanner Database within a Spanner Instance. For more information, see the official documentation, or the JSON API.")
    ("google_spanner_database_iam_binding" "Three different resources help you manage your IAM policy for a Spanner database. Each of these resources serves a different use case:\n\n google_spanner_database_iam_policy: Authoritative. Sets the IAM policy for the database and replaces any existing policy already attached.  \n\n Warning: It's entirely possibly to lock yourself out of your database using google_spanner_database_iam_policy. Any permissions granted by default will be removed unless you include them in your config. \n\n google_spanner_database_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the database are preserved.  google_spanner_database_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the database are preserved.  \n\n Note: google_spanner_database_iam_policy cannot be used in conjunction with google_spanner_database_iam_binding and google_spanner_database_iam_member or they will fight over what your policy should be. \n\n Note: google_spanner_database_iam_binding resources can be used in conjunction with google_spanner_database_iam_member resources only if they do not grant privilege to the same role.")
    ("google_spanner_database_iam_member" "Three different resources help you manage your IAM policy for a Spanner database. Each of these resources serves a different use case:\n\n google_spanner_database_iam_policy: Authoritative. Sets the IAM policy for the database and replaces any existing policy already attached.  \n\n Warning: It's entirely possibly to lock yourself out of your database using google_spanner_database_iam_policy. Any permissions granted by default will be removed unless you include them in your config. \n\n google_spanner_database_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the database are preserved.  google_spanner_database_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the database are preserved.  \n\n Note: google_spanner_database_iam_policy cannot be used in conjunction with google_spanner_database_iam_binding and google_spanner_database_iam_member or they will fight over what your policy should be. \n\n Note: google_spanner_database_iam_binding resources can be used in conjunction with google_spanner_database_iam_member resources only if they do not grant privilege to the same role.")
    ("google_spanner_database_iam_policy" "Three different resources help you manage your IAM policy for a Spanner database. Each of these resources serves a different use case:\n\n google_spanner_database_iam_policy: Authoritative. Sets the IAM policy for the database and replaces any existing policy already attached.  \n\n Warning: It's entirely possibly to lock yourself out of your database using google_spanner_database_iam_policy. Any permissions granted by default will be removed unless you include them in your config. \n\n google_spanner_database_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the database are preserved.  google_spanner_database_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the database are preserved.  \n\n Note: google_spanner_database_iam_policy cannot be used in conjunction with google_spanner_database_iam_binding and google_spanner_database_iam_member or they will fight over what your policy should be. \n\n Note: google_spanner_database_iam_binding resources can be used in conjunction with google_spanner_database_iam_member resources only if they do not grant privilege to the same role.")
    ("google_spanner_instance" "Creates and manages a Google Spanner Instance. For more information, see the official documentation, or the JSON API.")
    ("google_spanner_instance_iam_binding" "Three different resources help you manage your IAM policy for a Spanner instance. Each of these resources serves a different use case:\n\n google_spanner_instance_iam_policy: Authoritative. Sets the IAM policy for the instance and replaces any existing policy already attached.  \n\n Warning: It's entirely possibly to lock yourself out of your instance using google_spanner_instance_iam_policy. Any permissions granted by default will be removed unless you include them in your config. \n\n google_spanner_instance_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the instance are preserved.  google_spanner_instance_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the instance are preserved.  \n\n Note: google_spanner_instance_iam_policy cannot be used in conjunction with google_spanner_instance_iam_binding and google_spanner_instance_iam_member or they will fight over what your policy should be. \n\n Note: google_spanner_instance_iam_binding resources can be used in conjunction with google_spanner_instance_iam_member resources only if they do not grant privilege to the same role.")
    ("google_spanner_instance_iam_member" "Three different resources help you manage your IAM policy for a Spanner instance. Each of these resources serves a different use case:\n\n google_spanner_instance_iam_policy: Authoritative. Sets the IAM policy for the instance and replaces any existing policy already attached.  \n\n Warning: It's entirely possibly to lock yourself out of your instance using google_spanner_instance_iam_policy. Any permissions granted by default will be removed unless you include them in your config. \n\n google_spanner_instance_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the instance are preserved.  google_spanner_instance_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the instance are preserved.  \n\n Note: google_spanner_instance_iam_policy cannot be used in conjunction with google_spanner_instance_iam_binding and google_spanner_instance_iam_member or they will fight over what your policy should be. \n\n Note: google_spanner_instance_iam_binding resources can be used in conjunction with google_spanner_instance_iam_member resources only if they do not grant privilege to the same role.")
    ("google_spanner_instance_iam_policy" "Three different resources help you manage your IAM policy for a Spanner instance. Each of these resources serves a different use case:\n\n google_spanner_instance_iam_policy: Authoritative. Sets the IAM policy for the instance and replaces any existing policy already attached.  \n\n Warning: It's entirely possibly to lock yourself out of your instance using google_spanner_instance_iam_policy. Any permissions granted by default will be removed unless you include them in your config. \n\n google_spanner_instance_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the instance are preserved.  google_spanner_instance_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the instance are preserved.  \n\n Note: google_spanner_instance_iam_policy cannot be used in conjunction with google_spanner_instance_iam_binding and google_spanner_instance_iam_member or they will fight over what your policy should be. \n\n Note: google_spanner_instance_iam_binding resources can be used in conjunction with google_spanner_instance_iam_member resources only if they do not grant privilege to the same role.")
    ("google_sql_database" "Creates a new Google SQL Database on a Google SQL Database Instance. For more information, see the official documentation, or the JSON API. Postgres support for google_sql_database is in Beta.")
    ("google_sql_database_instance" "Creates a new Google SQL Database Instance. For more information, see the official documentation, or the JSON API. Postgres support for google_sql_database_instance is in Beta.\n\n NOTE on google_sql_database_instance: - Second-generation instances include a default 'root'@'%' user with no password. This user will be deleted by Terraform on instance creation. You should use google_sql_user to define a custom user with a restricted host and strong password.")
    ("google_sql_user" "Creates a new Google SQL User on a Google SQL User Instance. For more information, see the official documentation, or the JSON API.\n\n Note: All arguments including the username and password will be stored in the raw state as plain-text. Read more about sensitive data in state. Passwords will not be retrieved when running \"terraform import\".")
    ("google_logging_billing_account_sink" "Manages a billing account logging sink. For more information see the official documentation and Exporting Logs in the API.\n\nNote that you must have the \"Logs Configuration Writer\" IAM role (roles/logging.configWriter) granted to the credentials used with terraform.")
    ("google_logging_organization_sink" "Manages a organization-level logging sink. For more information see the official documentation and Exporting Logs in the API.\n\nNote that you must have the \"Logs Configuration Writer\" IAM role (roles/logging.configWriter) granted to the credentials used with terraform.")
    ("google_logging_folder_sink" "Manages a folder-level logging sink. For more information see the official documentation and Exporting Logs in the API.\n\nNote that you must have the \"Logs Configuration Writer\" IAM role (roles/logging.configWriter) granted to the credentials used with terraform.")
    ("google_logging_project_sink" "Manages a project-level logging sink. For more information see the official documentation, Exporting Logs in the API and API.\n\nNote that you must have the \"Logs Configuration Writer\" IAM role (roles/logging.configWriter) granted to the credentials used with terraform.")
    ("google_storage_bucket" "Creates a new bucket in Google cloud storage service (GCS). Once a bucket has been created, its location can't be changed. ACLs can be applied using the google_storage_bucket_acl resource. For more information see the official documentation and API.")
    ("google_storage_bucket_acl" "Creates a new bucket ACL in Google cloud storage service (GCS). For more information see  the official documentation  and  API.")
    ("google_storage_bucket_iam_binding" "Two different resources help you manage your IAM policy for storage bucket. Each of these resources serves a different use case:\n\n google_storage_bucket_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the storage bucket are preserved.  google_storage_bucket_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the storage bucket are preserved.  \n\n Note: google_storage_bucket_iam_binding resources can be used in conjunction with google_storage_bucket_iam_member resources only if they do not grant privilege to the same role.")
    ("google_storage_bucket_iam_member" "Two different resources help you manage your IAM policy for storage bucket. Each of these resources serves a different use case:\n\n google_storage_bucket_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the storage bucket are preserved.  google_storage_bucket_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the storage bucket are preserved.  \n\n Note: google_storage_bucket_iam_binding resources can be used in conjunction with google_storage_bucket_iam_member resources only if they do not grant privilege to the same role.")
    ("google_storage_bucket_object" "Creates a new object inside an existing bucket in Google cloud storage service (GCS).  ACLs can be applied using the google_storage_object_acl resource.  For more information see  the official documentation  and  API.")
    ("google_storage_default_object_acl" "Creates a new default object ACL in Google Cloud Storage service (GCS). For more information see the official documentation  and  API.")
    ("google_storage_notification" "Creates a new notification configuration on a specified bucket, establishing a flow of event notifications from GCS to a Cloud Pub/Sub topic.  For more information see  the official documentation  and  API.")
    ("google_storage_object_acl" "Creates a new object ACL in Google cloud storage service (GCS). For more information see  the official documentation  and  API.")
    ("google_kms_key_ring" "Allows creation of a Google Cloud Platform KMS KeyRing. For more information see the official documentation and  API.\n\nA KeyRing is a grouping of CryptoKeys for organizational purposes. A KeyRing belongs to a Google Cloud Platform Project and resides in a specific location.\n\n Note: KeyRings cannot be deleted from Google Cloud Platform. Destroying a Terraform-managed KeyRing will remove it from state but will not delete the resource on the server.")
    ("google_kms_key_ring_iam_binding" "Three different resources help you manage your IAM policy for KMS key ring. Each of these resources serves a different use case:\n\n google_kms_key_ring_iam_policy: Authoritative. Sets the IAM policy for the key ring and replaces any existing policy already attached.  google_kms_key_ring_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the key ring are preserved.  google_kms_key_ring_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the key ring are preserved.  \n\n Note: google_kms_key_ring_iam_policy cannot be used in conjunction with google_kms_key_ring_iam_binding and google_kms_key_ring_iam_member or they will fight over what your policy should be. \n\n Note: google_kms_key_ring_iam_binding resources can be used in conjunction with google_kms_key_ring_iam_member resources only if they do not grant privilege to the same role.")
    ("google_kms_key_ring_iam_member" "Three different resources help you manage your IAM policy for KMS key ring. Each of these resources serves a different use case:\n\n google_kms_key_ring_iam_policy: Authoritative. Sets the IAM policy for the key ring and replaces any existing policy already attached.  google_kms_key_ring_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the key ring are preserved.  google_kms_key_ring_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the key ring are preserved.  \n\n Note: google_kms_key_ring_iam_policy cannot be used in conjunction with google_kms_key_ring_iam_binding and google_kms_key_ring_iam_member or they will fight over what your policy should be. \n\n Note: google_kms_key_ring_iam_binding resources can be used in conjunction with google_kms_key_ring_iam_member resources only if they do not grant privilege to the same role.")
    ("google_kms_key_ring_iam_policy" "Three different resources help you manage your IAM policy for KMS key ring. Each of these resources serves a different use case:\n\n google_kms_key_ring_iam_policy: Authoritative. Sets the IAM policy for the key ring and replaces any existing policy already attached.  google_kms_key_ring_iam_binding: Authoritative for a given role. Updates the IAM policy to grant a role to a list of members. Other roles within the IAM policy for the key ring are preserved.  google_kms_key_ring_iam_member: Non-authoritative. Updates the IAM policy to grant a role to a new member. Other members for the role for the key ring are preserved.  \n\n Note: google_kms_key_ring_iam_policy cannot be used in conjunction with google_kms_key_ring_iam_binding and google_kms_key_ring_iam_member or they will fight over what your policy should be. \n\n Note: google_kms_key_ring_iam_binding resources can be used in conjunction with google_kms_key_ring_iam_member resources only if they do not grant privilege to the same role.")
    ("google_kms_crypto_key" "Allows creation of a Google Cloud Platform KMS CryptoKey. For more information see the official documentation and API.\n\nA CryptoKey is an interface to key material which can be used to encrypt and decrypt data. A CryptoKey belongs to a Google Cloud KMS KeyRing.\n\n Note: CryptoKeys cannot be deleted from Google Cloud Platform. Destroying a Terraform-managed CryptoKey will remove it from state and delete all CryptoKeyVersions, rendering the key unusable, but will not delete the resource on the server.")
    ("google_kms_crypto_key_iam_binding" "Allows creation and management of a single binding within IAM policy for an existing Google Cloud KMS crypto key.")
    ("google_kms_crypto_key_iam_member" "Allows creation and management of a single member for a single binding within the IAM policy for an existing Google Cloud KMS crypto key.\n\n Note: This resource must not be used in conjunction with    google_kms_crypto_key_iam_policy or they will fight over what your policy    should be. Similarly, roles controlled by google_kms_crypto_key_iam_binding    should not be assigned to using google_kms_crypto_key_iam_member.")
    ("google_cloudiot_registry" "Creates a device registry in Google's Cloud IoT Core platform. For more information see the official documentation and API.")
    ("grafana_alert_notification" "The alert notification resource allows an alert notification channel to be created on a Grafana server.")
    ("grafana_dashboard" "The dashboard resource allows a dashboard to be created on a Grafana server.")
    ("grafana_data_source" "The data source resource allows a data source to be created on a Grafana server.")
    ("heroku_addon" "Provides a Heroku Add-On resource. These can be attach services to a Heroku app.")
    ("heroku_addon_attachment" "Attaches a Heroku Addon Resource to an additional Heroku App.")
    ("heroku_app" "Provides a Heroku App resource. This can be used to create and manage applications on Heroku.")
    ("heroku_app_feature" "Provides a Heroku App Feature resource. This can be used to create and manage App Features on Heroku.")
    ("heroku_cert" "Provides a Heroku SSL certificate resource. It allows to set a given certificate for a Heroku app.")
    ("heroku_domain" "Provides a Heroku App resource. This can be used to create and manage applications on Heroku.")
    ("heroku_drain" "Provides a Heroku Drain resource. This can be used to create and manage Log Drains on Heroku.")
    ("heroku_pipeline" "Provides a Heroku Pipeline resource.\n\nA pipeline is a group of Heroku apps that share the same codebase. Once a pipeline is created, and apps are added to different stages using heroku_pipeline_coupling, you can promote app slugs to the next stage.")
    ("heroku_pipeline_coupling" "Provides a Heroku Pipeline Coupling resource.\n\nA pipeline is a group of Heroku apps that share the same codebase. Once a pipeline is created using heroku_pipeline, and apps are added to different stages using heroku_pipeline_coupling, you can promote app slugs to the downstream stages.")
    ("heroku_space" "Provides a Heroku Space resource for running apps in isolated, highly available, secure app execution environments.")
    ("icinga2_checkcommand" "Configures an Icinga2 checkcommand resource. This allows checkcommands to be configured, updated, and deleted.")
    ("icinga2_host" "Configures an Icinga2 host resource. This allows hosts to be configured, updated, and deleted.")
    ("icinga2_hostgroup" "Configures an Icinga2 hostgroup resource. This allows hostgroup to be configured, updated, and deleted.")
    ("icinga2_service" "Configures an Icinga2 service resource. This allows service to be configured, updated, and deleted.")
    ("influxdb_database" "The database resource allows a database to be created on an InfluxDB server.")
    ("influxdb_user" "The user resource allows a user to be created on an InfluxDB server.")
    ("influxdb_continuous_query" "The continuous_query resource allows a continuous query to be created on an InfluxDB server.")
    ("kubernetes_config_map" "The resource provides mechanisms to inject containers with configuration data while keeping containers agnostic of Kubernetes. Config Map can be used to store fine-grained information like individual properties or coarse-grained information like entire config files or JSON blobs.")
    ("kubernetes_horizontal_pod_autoscaler" "Horizontal Pod Autoscaler automatically scales the number of pods in a replication controller, deployment or replica set based on observed CPU utilization.")
    ("kubernetes_limit_range" "Limit Range sets resource usage limits (e.g. memory, cpu, storage) for supported kinds of resources in a namespace.\n\nRead more in the official docs.")
    ("kubernetes_namespace" "Kubernetes supports multiple virtual clusters backed by the same physical cluster. These virtual clusters are called namespaces. Read more about namespaces at https://kubernetes.io/docs/user-guide/namespaces/")
    ("kubernetes_persistent_volume" "The resource provides a piece of networked storage in the cluster provisioned by an administrator. It is a resource in the cluster just like a node is a cluster resource. Persistent Volumes have a lifecycle independent of any individual pod that uses the PV.\n\nMore info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/")
    ("kubernetes_persistent_volume_claim" "This resource allows the user to request for and claim to a persistent volume.")
    ("kubernetes_pod" "A pod is a group of one or more containers, the shared storage for those containers, and options about how to run the containers. Pods are always co-located and co-scheduled, and run in a shared context.\n\nRead more at https://kubernetes.io/docs/concepts/workloads/pods/pod/")
    ("kubernetes_replication_controller" "A Replication Controller ensures that a specified number of pod “replicas” are running at any one time. In other words, a Replication Controller makes sure that a pod or homogeneous set of pods are always up and available. If there are too many pods, it will kill some. If there are too few, the Replication Controller will start more.")
    ("kubernetes_resource_quota" "A resource quota provides constraints that limit aggregate resource consumption per namespace. It can limit the quantity of objects that can be created in a namespace by type, as well as the total amount of compute resources that may be consumed by resources in that project.")
    ("kubernetes_secret" "The resource provides mechanisms to inject containers with sensitive information, such as passwords, while keeping containers agnostic of Kubernetes. Secrets can be used to store sensitive information either as individual properties or coarse-grained entries like entire files or JSON blobs. The resource will by default create a secret which is available to any pod in the specified (or default) namespace.\n\n Read more about security properties and risks involved with using Kubernetes secrets: https://kubernetes.io/docs/user-guide/secrets/#security-properties \n\n Note: All arguments including the secret data will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("kubernetes_service" "A Service is an abstraction which defines a logical set of pods and a policy by which to access them - sometimes called a micro-service.")
    ("kubernetes_service_account" "A service account provides an identity for processes that run in a Pod.\n\nRead more at https://kubernetes.io/docs/admin/service-accounts-admin/")
    ("kubernetes_storage_class" "Storage class is the foundation of dynamic provisioning, allowing cluster administrators to define abstractions for the underlying storage platform.\n\nRead more at http://blog.kubernetes.io/2017/03/dynamic-provisioning-and-storage-classes-kubernetes.html")
    ("librato_alert" "Provides a Librato Alert resource. This can be used to create and manage alerts on Librato.")
    ("librato_metric" "Provides a Librato Metric resource. This can be used to create and manage metrics on Librato.")
    ("librato_service" "Provides a Librato Service resource. This can be used to create and manage notification services on Librato.")
    ("librato_space" "Provides a Librato Space resource. This can be used to create and manage spaces on Librato.")
    ("librato_space_chart" "Provides a Librato Space Chart resource. This can be used to create and manage charts in Librato Spaces.")
    ("file" "Generates a local file with the given content.\n\n Note When working with local files, Terraform will detect the resource as having been deleted each time a configuration is applied on a new machine where the file is not present and will generate a diff to re-create it. This may cause \"noise\" in diffs in environments where configurations are routinely applied by many different users or within automation systems.")
    ("logentries_log" "Provides a Logentries log resource.")
    ("logentries_logset" "Provides a Logentries logset resource. A logset is a collection of logentries_log resources.")
    ("logicmonitor_collector" "Provides a LogicMonitor collector resource. This can be used to create and manage LogicMonitor collectors.\n\nNote: This resource will only create the collector device in your account. See Downloading a Collector Installer for information on how to download and install an existing collector.")
    ("logicmonitor_collectorgroup" "Provides a LogicMonitor collector group resource. This can be used to create and manage LogicMonitor collector groups")
    ("logicmonitor_device" "Provides a LogicMonitor device resource. This can be used to create and manage LogicMonitor devices")
    ("logicmonitor_devicegroup" "Provides a LogicMonitor device group resource. This can be used to create and manage LogicMonitor device groups")
    ("mailgun_domain" "Provides a Mailgun App resource. This can be used to create and manage applications on Mailgun.")
    ("mysql_database" "The mysql_database resource creates and manages a database on a MySQL server.\n\n Caution: The mysql_database resource can completely delete your database just as easily as it can create it. To avoid costly accidents, consider setting prevent_destroy on your database resources as an extra safety measure.")
    ("mysql_grant" "The mysql_grant resource creates and manages privileges given to a user on a MySQL server.")
    ("mysql_user" "The mysql_user resource creates and manages a user on a MySQL server.\n\n Note: The password for the user is provided in plain text, and is obscured by an unsalted hash in the state Read more about sensitive data in state. Care is required when using this resource, to avoid disclosing the password.")
    ("newrelic_alert_channel" "")
    ("newrelic_alert_condition" "")
    ("newrelic_alert_policy" "")
    ("newrelic_alert_policy_channel" "")
    ("newrelic_nrql_alert_condition" "")
    ("newrelic_dashboard" "")
    ("nomad_acl_policy" "Manages an ACL policy registered in Nomad.")
    ("nomad_acl_token" "Manages an ACL token in Nomad.\n\n Warning: this resource will store any tokens it creates in   Terraform's state file. Take care to   protect your state file.")
    ("nomad_job" "Manages a job registered in Nomad.\n\nThis can be used to initialize your cluster with system jobs, common services, and more. In day to day Nomad use it is common for developers to submit jobs to Nomad directly, such as for general app deployment. In addition to these apps, a Nomad cluster often runs core system services that are ideally setup during infrastructure creation. This resource is ideal for the latter type of job, but can be used to manage any job within Nomad.")
    ("nomad_namespace" "Provisions a namespace within a Nomad cluster.\n\n Enterprise Only! This API endpoint and functionality only exists in Nomad Enterprise. This is not present in the open source version of Nomad.")
    ("nomad_quota_specification" "Manages a quota specification in a Nomad cluster.")
    ("nomad_sentinel_policy" "Manages a Sentinel policy registered in Nomad.\n\n Enterprise Only! This API endpoint and functionality only exists in    Nomad Enterprise. This is not present in the open source version of Nomad.")
    ("ns1_zone" "Provides a NS1 DNS Zone resource. This can be used to create, modify, and delete zones.")
    ("ns1_record" "Provides a NS1 Record resource. This can be used to create, modify, and delete records.")
    ("ns1_monitoringjob" "Provides a NS1 Monitoring Job resource. This can be used to create, modify, and delete monitoring jobs.")
    ("ns1_notifylist" "Provides a NS1 Notify List resource. This can be used to create, modify, and delete notify lists.")
    ("ns1_datasource" "Provides a NS1 Data Source resource. This can be used to create, modify, and delete data sources.")
    ("ns1_datafeed" "Provides a NS1 Data Feed resource. This can be used to create, modify, and delete data feeds.")
    ("ns1_apikey" "Provides a NS1 Api Key resource. This can be used to create, modify, and delete api keys.")
    ("ns1_team" "Provides a NS1 Team resource. This can be used to create, modify, and delete teams.")
    ("ns1_user" "Provides a NS1 User resource. Creating a user sends an invitation email to the user's email address. This can be used to create, modify, and delete users.")
    ("docs-oneandone-datasource-instance-size" "Fetches a predefined instance type for 1&1 servers")
    ("oneandone_block_storage" "Manages a Block Storage on 1&1")
    ("oneandone_firewall_policy" "Manages a Firewall Policy on 1&1")
    ("oneandone_loadbalancer" "Manages a Load Balancer on 1&1")
    ("oneandone_monitoring_policy" "Manages a Monitoring Policy on 1&1")
    ("oneandone_private_network" "Manages a Private Network on 1&1")
    ("oneandone_public_ip" "Manages a Public IP on 1&1")
    ("oneandone_server" "Manages a Server on 1&1")
    ("oneandone_shared_storage" "Manages a Shared Storage on 1&1")
    ("oneandone_ssh_key" "Manages SSH Keys on 1&1")
    ("oneandone_vpn" "Manages a VPN on 1&1")
    ("openstack_blockstorage_volume_v1" "Manages a V1 volume resource within OpenStack.")
    ("openstack_blockstorage_volume_v2" "Manages a V2 volume resource within OpenStack.")
    ("openstack_blockstorage_volume_attach_v2" "This resource is experimental and may be removed in the future! Feedback is requested if you find this resource useful or if you find any problems with it.\n\nCreates a general purpose attachment connection to a Block Storage volume using the OpenStack Block Storage (Cinder) v2 API. Depending on your Block Storage service configuration, this resource can assist in attaching a volume to a non-OpenStack resource such as a bare-metal server or a remote virtual machine in a different cloud provider.\n\nThis does not actually attach a volume to an instance. Please use the openstack_compute_volume_attach_v2 resource for that.")
    ("openstack_blockstorage_volume_v3" "Manages a V3 volume resource within OpenStack.")
    ("openstack_blockstorage_volume_attach_v3" "This resource is experimental and may be removed in the future! Feedback is requested if you find this resource useful or if you find any problems with it.\n\nCreates a general purpose attachment connection to a Block Storage volume using the OpenStack Block Storage (Cinder) v3 API. Depending on your Block Storage service configuration, this resource can assist in attaching a volume to a non-OpenStack resource such as a bare-metal server or a remote virtual machine in a different cloud provider.\n\nThis does not actually attach a volume to an instance. Please use the openstack_compute_volume_attach_v3 resource for that.")
    ("openstack_compute_flavor_v2" "Manages a V2 flavor resource within OpenStack.")
    ("openstack_compute_floatingip_v2" "Manages a V2 floating IP resource within OpenStack Nova (compute) that can be used for compute instances.\n\nPlease note that managing floating IPs through the OpenStack Compute API has been deprecated. Unless you are using an older OpenStack environment, it is recommended to use the openstack_networking_floatingip_v2 resource instead, which uses the OpenStack Networking API.")
    ("openstack_compute_floatingip_associate_v2" "Associate a floating IP to an instance. This can be used instead of the floating_ip options in openstack_compute_instance_v2.")
    ("openstack_compute_instance_v2" "Manages a V2 VM instance resource within OpenStack.")
    ("openstack_compute_keypair_v2" "Manages a V2 keypair resource within OpenStack.\n\n Important Security Notice The private key generated by this resource will be stored unencrypted in your Terraform state file. Use of this resource for production deployments is not recommended. Instead, generate a private key file outside of Terraform and distribute it securely to the system where Terraform will be run.")
    ("openstack_compute_secgroup_v2" "Manages a V2 security group resource within OpenStack.\n\nPlease note that managing security groups through the OpenStack Compute API has been deprecated. Unless you are using an older OpenStack environment, it is recommended to use the openstack_networking_secgroup_v2 and openstack_networking_secgroup_rule_v2 resources instead, which uses the OpenStack Networking API.")
    ("openstack_compute_servergroup_v2" "Manages a V2 Server Group resource within OpenStack.")
    ("openstack_compute_volume_attach_v2" "Attaches a Block Storage Volume to an Instance using the OpenStack Compute (Nova) v2 API.")
    ("openstack_db_instance_v1" "Manages a V1 DB instance resource within OpenStack.")
    ("openstack_db_database_v1" "Manages a V1 DB database resource within OpenStack.")
    ("openstack_db_user_v1" "Manages a V1 DB user resource within OpenStack.")
    ("openstack_db_configuration_v1" "Manages a V1 DB configuration resource within OpenStack.")
    ("openstack_dns_recordset_v2" "Manages a DNS record set in the OpenStack DNS Service.")
    ("openstack_dns_zone_v2" "Manages a DNS zone in the OpenStack DNS Service.")
    ("openstack_identity_project_v3" "Manages a V3 Project resource within OpenStack Keystone.\n\nNote: You must have admin privileges in your OpenStack cloud to use this resource.")
    ("openstack_identity_role_v3" "Manages a V3 Role resource within OpenStack Keystone.\n\nNote: You must have admin privileges in your OpenStack cloud to use this resource.")
    ("openstack_identity_role_assignment_v3" "Manages a V3 Role assignment within OpenStack Keystone.\n\nNote: You must have admin privileges in your OpenStack cloud to use this resource.")
    ("openstack_identity_user_v3" "Manages a V3 User resource within OpenStack Keystone.\n\nNote: You must have admin privileges in your OpenStack cloud to use this resource.")
    ("openstack_images_image_v2" "Manages a V2 Image resource within OpenStack Glance.")
    ("openstack_networking_floatingip_v2" "Manages a V2 floating IP resource within OpenStack Neutron (networking) that can be used for load balancers. These are similar to Nova (compute) floating IP resources, but only compute floating IPs can be used with compute instances.")
    ("openstack_networking_floatingip_associate_v2" "Associates a floating IP to a port. This is useful for situations where you have a pre-allocated floating IP or are unable to use the openstack_networking_floatingip_v2 resource to create a floating IP.")
    ("openstack_networking_network_v2" "Manages a V2 Neutron network resource within OpenStack.")
    ("openstack_networking_port_v2" "Manages a V2 port resource within OpenStack.")
    ("openstack_networking_router_interface_v2" "Manages a V2 router interface resource within OpenStack.")
    ("openstack_networking_router_route_v2" "Creates a routing entry on a OpenStack V2 router.")
    ("openstack_networking_router_v2" "Manages a V2 router resource within OpenStack.")
    ("openstack_networking_subnet_v2" "Manages a V2 Neutron subnet resource within OpenStack.")
    ("openstack_networking_subnet_route_v2" "Creates a routing entry on a OpenStack V2 subnet.")
    ("openstack_networking_subnetpool_v2" "Manages a V2 Neutron subnetpool resource within OpenStack.")
    ("openstack_networking_secgroup_v2" "Manages a V2 neutron security group resource within OpenStack. Unlike Nova security groups, neutron separates the group from the rules and also allows an admin to target a specific tenant_id.")
    ("openstack_networking_secgroup_rule_v2" "Manages a V2 neutron security group rule resource within OpenStack. Unlike Nova security groups, neutron separates the group from the rules and also allows an admin to target a specific tenant_id.")
    ("openstack_lb_member_v1" "Manages a V1 load balancer member resource within OpenStack.")
    ("openstack_lb_monitor_v1" "Manages a V1 load balancer monitor resource within OpenStack.")
    ("openstack_lb_pool_v1" "Manages a V1 load balancer pool resource within OpenStack.")
    ("openstack_lb_vip_v1" "Manages a V1 load balancer vip resource within OpenStack.")
    ("openstack_lb_loadbalancer_v2" "Manages a V2 loadbalancer resource within OpenStack.")
    ("openstack_lb_listener_v2" "Manages a V2 listener resource within OpenStack.")
    ("openstack_lb_pool_v2" "Manages a V2 pool resource within OpenStack.")
    ("openstack_lb_member_v2" "Manages a V2 member resource within OpenStack.")
    ("openstack_lb_monitor_v2" "Manages a V2 monitor resource within OpenStack.")
    ("openstack_fw_firewall_v1" "Manages a v1 firewall resource within OpenStack.")
    ("openstack_fw_policy_v1" "Manages a v1 firewall policy resource within OpenStack.")
    ("openstack_fw_rule_v1" "Manages a v1 firewall rule resource within OpenStack.")
    ("openstack_objectstorage_container_v1" "Manages a V1 container resource within OpenStack.")
    ("openstack_objectstorage_object_v1" "Manages a V1 container object resource within OpenStack.")
    ("openstack_vpnaas_ipsec_policy_v2" "Manages a V2 Neutron IPSec policy resource within OpenStack.")
    ("openstack_vpnaas_ike_policy_v2" "Manages a V2 Neutron IKE policy resource within OpenStack.")
    ("openstack_vpnaas_service_v2" "Manages a V2 Neutron VPN service resource within OpenStack.")
    ("openstack_vpnaas_endpoint_group_v2" "Manages a V2 Neutron Endpoint Group resource within OpenStack.")
    ("opentelekomcloud_blockstorage_volume_v2" "Manages a V2 volume resource within OpenTelekomCloud.")
    ("opentelekomcloud_compute_floatingip_v2" "Manages a V2 floating IP resource within OpenTelekomCloud Nova (compute) that can be used for compute instances. These are similar to Neutron (networking) floating IP resources, but only networking floating IPs can be used with load balancers.")
    ("opentelekomcloud_compute_floatingip_associate_v2" "Associate a floating IP to an instance. This can be used instead of the floating_ip options in opentelekomcloud_compute_instance_v2.")
    ("opentelekomcloud_compute_instance_v2" "Manages a V2 VM instance resource within OpenTelekomCloud.")
    ("opentelekomcloud_compute_keypair_v2" "Manages a V2 keypair resource within OpenTelekomCloud.")
    ("opentelekomcloud_compute_secgroup_v2" "Manages a V2 security group resource within OpenTelekomCloud.")
    ("opentelekomcloud_compute_servergroup_v2" "Manages a V2 Server Group resource within OpenTelekomCloud.")
    ("opentelekomcloud_compute_volume_attach_v2" "Attaches a Block Storage Volume to an Instance using the OpenTelekomCloud Compute (Nova) v2 API.")
    ("opentelekomcloud_dns_recordset_v2" "Manages a DNS record set in the OpenTelekomCloud DNS Service.")
    ("opentelekomcloud_dns_zone_v2" "Manages a DNS zone in the OpenTelekomCloud DNS Service.")
    ("opentelekomcloud_images_image_v2" "Manages a V2 Image resource within OpenTelekomCloud Glance.")
    ("opentelekomcloud_networking_floatingip_v2" "Manages a V2 floating IP resource within OpenTelekomCloud Neutron (networking) that can be used for load balancers. These are similar to Nova (compute) floating IP resources, but only compute floating IPs can be used with compute instances.")
    ("opentelekomcloud_networking_network_v2" "Manages a V2 Neutron network resource within OpenTelekomCloud.")
    ("opentelekomcloud_networking_port_v2" "Manages a V2 port resource within OpenTelekomCloud.")
    ("opentelekomcloud_networking_router_interface_v2" "Manages a V2 router interface resource within OpenTelekomCloud.")
    ("opentelekomcloud_networking_router_route_v2" "Creates a routing entry on a OpenTelekomCloud V2 router.")
    ("opentelekomcloud_networking_router_v2" "Manages a V2 router resource within OpenTelekomCloud.")
    ("opentelekomcloud_networking_subnet_v2" "Manages a V2 Neutron subnet resource within OpenTelekomCloud.")
    ("opentelekomcloud_networking_secgroup_v2" "Manages a V2 neutron security group resource within OpenTelekomCloud. Unlike Nova security groups, neutron separates the group from the rules and also allows an admin to target a specific tenant_id.")
    ("opentelekomcloud_networking_secgroup_rule_v2" "Manages a V2 neutron security group rule resource within OpenTelekomCloud. Unlike Nova security groups, neutron separates the group from the rules and also allows an admin to target a specific tenant_id.")
    ("opentelekomcloud_lb_loadbalancer_v2" "Manages a V2 loadbalancer resource within OpenTelekomCloud.")
    ("opentelekomcloud_lb_listener_v2" "Manages a V2 listener resource within OpenTelekomCloud.")
    ("opentelekomcloud_lb_pool_v2" "Manages a V2 pool resource within OpenTelekomCloud.")
    ("opentelekomcloud_lb_member_v2" "Manages a V2 member resource within OpenTelekomCloud.")
    ("opentelekomcloud_lb_monitor_v2" "Manages a V2 monitor resource within OpenTelekomCloud.")
    ("opentelekomcloud_fw_firewall_group_v2" "Manages a v1 firewall group resource within OpenTelekomCloud.")
    ("opentelekomcloud_fw_policy_v2" "Manages a v1 firewall policy resource within OpenTelekomCloud.")
    ("opentelekomcloud_fw_rule_v2" "Manages a v2 firewall rule resource within OpenTelekomCloud.")
    ("opsgenie_team" "Manages a Team within OpsGenie.")
    ("opsgenie_user" "Manages a User within OpsGenie.")
    ("opc_compute_acl" "The opc_compute_acl resource creates and manages an ACL in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_image_list" "The opc_compute_image_list resource creates and manages an Image List in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_image_list_entry" "The opc_compute_image_list_entry resource creates and manages an Image List Entry in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_instance" "The opc_compute_instance resource creates and manages an instance in an Oracle Cloud Infrastructure Compute Classic identity domain.\n\n Caution: The opc_compute_instance resource can completely delete your instance just as easily as it can create it. To avoid costly accidents, consider setting prevent_destroy on your instance resources as an extra safety measure.")
    ("opc_compute_ip_address_association" "The opc_compute_ip_address_association resource creates and manages an IP address association between an IP address reservation and a virtual NIC in an Oracle Cloud Infrastructure Compute Classic identity domain, for an IP Network.")
    ("opc_compute_ip_address_prefix_set" "The opc_compute_ip_address_prefix_set resource creates and manages an IP address prefix set in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_ip_address_reservation" "The opc_compute_ip_address_reservation resource creates and manages an IP address reservation in an Oracle Cloud Infrastructure Compute Classic identity domain, for an IP Network.")
    ("opc_compute_ip_association" "The opc_compute_ip_association resource creates and manages an association between an IP address and an instance in an Oracle Cloud Infrastructure Compute Classic identity domain, for the Shared Network.")
    ("opc_compute_ip_network" "The opc_compute_ip_network resource creates and manages an IP Network in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_ip_network_exchange" "The opc_compute_ip_network_exchange resource creates and manages an IP network exchange in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_ip_reservation" "The opc_compute_ip_reservation resource creates and manages an IP reservation in an Oracle Cloud Infrastructure Compute Classic identity domain for the Shared Network.")
    ("opc_compute_machine_image" "The opc_compute_machine_image resource creates and manages a machine image template of a virtual hard disk of a specific size with an installed operating system.\n\nBefore performing this creating the Machine Image, you must upload your machine image file to Oracle Cloud Infrastructure Object Storage Classic compute_images container")
    ("opc_compute_orchestrated_instance" "The opc_compute_orchestrated_instance resource creates and manages an orchestration containing a number of instances in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_route" "The opc_compute_route resource creates and manages a route for an IP Network in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_sec_rule" "The opc_compute_sec_rule resource creates and manages a sec rule in an Oracle Cloud Infrastructure Compute Classic identity domain, which joins together a source security list (or security IP list), a destination security list (or security IP list), and a security application.")
    ("opc_compute_security_application" "The opc_compute_security_application resource creates and manages a security application in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_security_association" "The opc_compute_security_association resource creates and manages an association between an instance and a security list in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_security_ip_list" "The opc_compute_security_ip_list resource creates and manages a security IP list in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_security_list" "The opc_compute_security_list resource creates and manages a security list in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_security_protocol" "The opc_compute_security_protocol resource creates and manages a security protocol in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_security_rule" "The opc_compute_security_rule resource creates and manages a security rule in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_ssh_key" "The opc_compute_ssh_key resource creates and manages an SSH key in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_storage_volume_attachment" "The opc_compute_storage_volume_attachment resource creates and manages a storage volume attachment in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_storage_volume" "The opc_compute_storage_volume resource creates and manages a storage volume in an Oracle Cloud Infrastructure Compute Classic identity domain.\n\n Caution: The opc_compute_storage_volume resource can completely delete your storage volume just as easily as it can create it. To avoid costly accidents, consider setting prevent_destroy on your storage volume resources as an extra safety measure.")
    ("opc_compute_storage_volume_snapshot" "The opc_compute_storage_volume_snapshot resource creates and manages a storage volume snapshot in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_compute_vnic_set" "The opc_compute_vnic_set resource creates and manages a virtual NIC set in an Oracle Cloud Infrastructure Compute Classic identity domain.")
    ("opc_storage_container" "Creates and manages a Container in the Oracle Cloud Infrastructure Storage Classic service. storage_endpoint must be set in the provider or environment to manage these resources.")
    ("opc_storage_object" "Creates and manages a Object in an Oracle Cloud Infrastructure Storage Classic container. storage_endpoint must be set in the provider or environment to manage these resources.")
    ("oraclepaas_database_service_instance" "The oraclepaas_database_service_instance resource creates and manages a an Oracle Database Cloud Service instance on the Oracle Cloud Platform.")
    ("oraclepaas_java_service_instance" "The oraclepaas_java_service_instance resource creates and manages an Oracle Java Cloud Service instance on the Oracle Cloud Platform.")
    ("oraclepaas_database_access_rule" "The oraclepaas_database_access_rule resource creates and manages a Database Access Rule for an Oracle Database Cloud service instance.")
    ("oraclepaas_java_access_rule" "The oraclepaas_java_access_rule resource creates and manages an Access Rule for an Java Cloud service instance.")
    ("ovh_vrack_publiccloud_attachment" "Attach an existing PublicCloud project to an existing VRack.")
    ("ovh_publiccloud_private_network" "Creates a private network in a public cloud project.")
    ("ovh_publiccloud_private_network_subnet" "Creates a subnet in a private network of a public cloud project.")
    ("ovh_publiccloud_user" "Creates a user in a public cloud project.")
    ("packet_device" "Provides a Packet device resource. This can be used to create, modify, and delete devices.\n\n Note: All arguments including the root_password and user_data will be stored in  the raw state as plain-text. Read more about sensitive data in state.")
    ("packet_project" "Provides a Packet Project resource to allow you manage devices in your projects.")
    ("packet_organization" "Provides a resource to manage organization resource in Packet.")
    ("packet_ssh_key" "Provides a Packet SSH key resource to allow you manage SSH keys on your account. All SSH keys on your account are loaded on all new devices, they do not have to be explicitly declared on device creation.")
    ("packet_volume" "Provides a Packet Block Storage Volume resource to allow you to manage block volumes on your account. Once created by Terraform, they must then be attached and mounted using the api and packet_block_attach and packet_block_detach scripts.")
    ("packet_volume_attachment" "Provides attachment of Packet Block Storage Volume to Devices.\n\nDevice and volume must be in the same location (facility).\n\nOnce attached by Terraform, they must then be mounted using the packet_block_attach and packet_block_detach scripts.")
    ("pagerduty_addon" "With add-ons, third-party developers can write their own add-ons to PagerDuty's UI. Given a configuration containing a src parameter, that URL will be embedded in an iframe on a page that's available to users from a drop-down menu.")
    ("pagerduty_escalation_policy" "An escalation policy determines what user or schedule will be notified first, second, and so on when an incident is triggered. Escalation policies are used by one or more services.")
    ("pagerduty_extension" "An extension can be associated with a service.")
    ("pagerduty_maintenance_window" "A maintenance window is used to temporarily disable one or more services for a set period of time. No incidents will be triggered and no notifications will be received while a service is disabled by a maintenance window.\n\nMaintenance windows are specified to start at a certain time and end after they have begun. Once started, a maintenance window cannot be deleted; it can only be ended immediately to re-enable the service.")
    ("pagerduty_schedule" "A schedule determines the time periods that users are on call. Only on-call users are eligible to receive notifications from incidents.")
    ("pagerduty_service" "A service represents something you monitor (like a web service, email service, or database service). It is a container for related incidents that associates them with escalation policies.")
    ("pagerduty_service_integration" "A service integration is an integration that belongs to a service.")
    ("pagerduty_team" "A team is a collection of users and escalation policies that represent a group of people within an organization.\n\nThe account must have the teams ability to use the following resource.")
    ("pagerduty_team_membership" "A team membership manages memberships within a team.")
    ("pagerduty_user" "A user is a member of a PagerDuty account that have the ability to interact with incidents and other data on the account.")
    ("pagerduty_user_contact_method" "A contact method is a contact method for a PagerDuty user (email, phone or SMS).")
    ("panos_panorama_address_group" "This resource allows you to add/update/delete Panorama address groups.\n\nAddress groups are either statically defined or dynamically defined, so only static_addresses or dynamic_match should be defined within a given address group.")
    ("panos_panorama_address_object" "This resource allows you to add/update/delete address objects on Panorama.")
    ("panos_panorama_administrative_tag" "This resource allows you to add/update/delete Panorama administrative tags.")
    ("panos_panorama_device_group" "This resource allows you to add/update/delete Panorama device groups.\n\nThis resource has some overlap with the panos_panorama_device_group_entry resource.  If you want to use this resource with the other one, then make sure that your panos_panorama_device_group spec does not define any device blocks, and just stays as \"computed\".\n\nThis is the appropriate resource to use if terraform destroy should delete the device group.")
    ("panos_panorama_device_group_entry" "This resource allows you to add/update/delete a specific device in a Panorama device group.\n\nThis resource has some overlap with the panos_panorama_device_group resource.  If you want to use this resource with the other one, then make sure that your panos_panorama_device_group spec does not define any device blocks, and just stays as \"computed\".\n\nThis is the appropriate resource to use if you have a pre-existing device group in Panorama and don't want Terraform to delete it on terraform destroy.\n\nAn interesting side effect of the underlying XML API - if the device group does not already exist, then this resource can actually create it.  However, since only the single entry for the specific serial number is deleted, then a terraform destroy would not remove the device group itself in this situation.")
    ("panos_panorama_nat_policy" "This resource allows you to add/update/delete Panorama NAT policies.\n\nThe prefix sat stands for \"Source Address Translation\" while the prefix \"dat\" stands for \"Destination Address Translation\".  The order of the params in this resource and their naming matches how the params are presented in the GUI.  Thus, having a GUI window open while creating your resource definition will simplify the process.\n\nNote that while many of the params for this resource are optional in an absolute sense, depending on what type of NAT you wish to configure, certain params may become necessary to correctly configure the NAT policy.")
    ("panos_panorama_security_policies" "This resource allows you to add/update/delete Panorama security policies.\n\nThis resource manages the full set of security policies, enforcing both the contents of individual rules as well as their ordering.  Rules are defined in a rule config block.  As this manages the full set of security policies for a given rulebase, any extraneous rules are removed on terraform apply.\n\nFor each security policy, there are three styles of profile settings:\n\n None (the default)  Group  Profiles  \n\nThe Profile Setting is implicitly chosen based on what params are configured for the security policy.  If you want a Profile Setting of Group, then the group param should be set to the desired Group Profile.  If you want a Profile Setting of Profiles, then you will need to specify one or more of the following params:\n\n virus  spyware  vulnerability  url_filtering  file_blocking  wildfire_analysis  data_filtering  \n\nIf the group param and none of the Profiles params are specified, then the Profile Setting is set to None.")
    ("panos_panorama_service_group" "This resource allows you to add/update/delete Panorama service groups.")
    ("panos_panorama_service_object" "This resource allows you to add/update/delete Panorama service objects.")
    ("panos_address_group" "This resource allows you to add/update/delete address groups.\n\nAddress groups are either statically defined or dynamically defined, so only static_addresses or dynamic_match should be defined within a given address group.")
    ("panos_address_object" "This resource allows you to add/update/delete address objects.")
    ("panos_administrative_tag" "This resource allows you to add/update/delete administrative tags.")
    ("panos_dag_tags" "This resource allows you to add and remove dynamic address group tags.\n\nThe ip field should be unique in the panos_dag_tags block, and there should only be one panos_dag_tags block defined in a given plan.\n\nNote - Tags are only removed during terraform destroy.  Updating an applied terraform plan to have alternative tags will leave behind the old tags from the previously published plan(s).")
    ("panos_ethernet_interface" "This resource allows you to add/update/delete ethernet interfaces.")
    ("panos_general_settings" "This resource allows you to update the general device settings, such as DNS or the hostname.\n\nAll params are optional for this resource.  If any options are not specified, then whatever is already configured on the firewall is left as-is.  The general device settings will always exist on the firewall, so terraform destroy does not remove config from the firewall.")
    ("panos_management_profile" "This resource allows you to add/update/delete interface management profiles.")
    ("panos_nat_policy" "This resource allows you to add/update/delete NAT policies.\n\nThe prefix sat stands for \"Source Address Translation\" while the prefix \"dat\" stands for \"Destination Address Translation\".  The order of the params in this resource and their naming matches how the params are presented in the GUI.  Thus, having a GUI window open while creating your resource definition will simplify the process.\n\nNote that while many of the params for this resource are optional in an absolute sense, depending on what type of NAT you wish to configure, certain params may become necessary to correctly configure the NAT policy.")
    ("panos_security_policies" "This resource allows you to add/update/delete security policies.\n\nThis resource manages the full set of security policies, enforcing both the contents of individual rules as well as their ordering.  Rules are defined in a rule config block.\n\nFor each security policy, there are three styles of profile settings:\n\n None (the default)  Group  Profiles  \n\nThe Profile Setting is implicitly chosen based on what params are configured for the security policy.  If you want a Profile Setting of Group, then the group param should be set to the desired Group Profile.  If you want a Profile Setting of Profiles, then you will need to specify one or more of the following params:\n\n virus  spyware  vulnerability  url_filtering  file_blocking  wildfire_analysis  data_filtering  \n\nIf the group param and none of the Profiles params are specified, then the Profile Setting is set to None.")
    ("panos_service_group" "This resource allows you to add/update/delete service groups.")
    ("panos_service_object" "This resource allows you to add/update/delete service objects.")
    ("panos_virtual_router" "This resource allows you to add/update/delete virtual routers.\n\nNote - The default virtual router may be configured with this resource, however it will not be deleted from the firewall.  It will only be unexported from the vsys that it is currently imported in, and any interfaces imported into the virtual router will be removed.")
    ("panos_zone" "This resource allows you to add/update/delete zones.")
    ("postgresql_database" "The postgresql_database resource creates and manages database objects within a PostgreSQL server instance.")
    ("postgresql_extension" "The postgresql_extension resource creates and manages an extension on a PostgreSQL server.")
    ("postgresql_role" "The postgresql_role resource creates and manages a role on a PostgreSQL server.\n\nWhen a postgresql_role resource is removed, the PostgreSQL ROLE will automatically run a REASSIGN OWNED and DROP OWNED to the CURRENT_USER (normally the connected user for the provider).  If the specified PostgreSQL ROLE owns objects in multiple PostgreSQL databases in the same PostgreSQL Cluster, one PostgreSQL provider per database must be created and all but the final postgresql_role must specify a skip_drop_role.\n\n Note: All arguments including role name and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("postgresql_schema" "The postgresql_schema resource creates and manages schema objects within a PostgreSQL database.")
    ("powerdns_record" "Provides a PowerDNS record resource.")
    ("profitbricks_datacenter" "Manages a Virtual Data Center on ProfitBricks")
    ("profitbricks_firewall" "Manages a Firewall Rules on ProfitBricks")
    ("profitbricks_group" "Manages groups and group priviliages on ProfitBricks")
    ("profitbricks_ipblock" "Manages a IP Blocks on ProfitBricks")
    ("profitbricks_ipfailover" "Manages Ip Failover groups on ProfitBricks")
    ("profitbricks_lan" "Manages a LANs on ProfitBricks")
    ("profitbricks_loadbalancer" "Manages a Load Balancers on ProfitBricks")
    ("profitbricks_nic" "Manages a NICs on ProfitBricks")
    ("profitbricks_server" "Manages a Servers on ProfitBricks")
    ("profitbricks_share" "Manages shares and list shares permissions granted to the group members for each shared resource.")
    ("profitbricks_snapshot" "Manages snapshots on ProfitBricks.")
    ("profitbricks_user" "Manages users and list users and groups associated.")
    ("profitbricks_volume" "Manages a Volumes on ProfitBricks")
    ("rabbitmq_binding" "The rabbitmq_binding resource creates and manages a binding relationship between a queue an exchange.")
    ("rabbitmq_exchange" "The rabbitmq_exchange resource creates and manages an exchange.")
    ("rabbitmq_permissions" "The rabbitmq_permissions resource creates and manages a user's set of permissions.")
    ("rabbitmq_policy" "The rabbitmq_policy resource creates and manages policies for exchanges and queues.")
    ("rabbitmq_queue" "The rabbitmq_queue resource creates and manages a queue.")
    ("rabbitmq_user" "The rabbitmq_user resource creates and manages a user.\n\n Note: All arguments including username and password will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("rabbitmq_vhost" "The rabbitmq_vhost resource creates and manages a vhost.")
    ("rancher_certificate" "Provides a Rancher Certificate resource. This can be used to create certificates for rancher environments and retrieve their information.")
    ("rancher_environment" "Provides a Rancher Environment resource. This can be used to create and manage environments on rancher.")
    ("rancher_host" "Provides a Rancher Host resource. This can be used to manage and delete hosts on Rancher.")
    ("rancher_registration_token" "Provides a Rancher Registration Token resource. This can be used to create registration tokens for rancher environments and retrieve their information.")
    ("rancher_registry_credential" "Provides a Rancher Registy Credential resource. This can be used to create registry credentials for rancher environments and retrieve their information.")
    ("rancher_registry" "Provides a Rancher Registy resource. This can be used to create registries for rancher environments and retrieve their information")
    ("rancher_secret" "Provides a Rancher Secret resource. This can be used to create secrets for rancher environments and retrieve their information.")
    ("rancher_stack" "Provides a Rancher Stack resource. This can be used to create and manage stacks on rancher.")
    ("rancher_volume" "Provides a Rancher Volume resource. This can be used to create volumes for rancher environments and retrieve their information.")
    ("random_id" "The resource random_id generates random numbers that are intended to be used as unique identifiers for other resources.\n\nUnlike other resources in the \"random\" provider, this resource does use a cryptographic random number generator in order to minimize the chance of collisions, making the results of this resource when a 32-byte identifier is requested of equivalent uniqueness to a type-4 UUID.\n\nThis resource can be used in conjunction with resources that have, the create_before_destroy lifecycle flag set, to avoid conflicts with unique names during the brief period where both the old and new resources exist concurrently.")
    ("random_pet" "The resource random_pet generates random pet names that are intended to be used as unique identifiers for other resources.\n\nThis resource can be used in conjunction with resources that have the create_before_destroy lifecycle flag set, to avoid conflicts with unique names during the brief period where both the old and new resources exist concurrently.")
    ("random_shuffle" "The resource random_shuffle generates a random permutation of a list of strings given as an argument.")
    ("random_string" "The resource random_string generates a random permutation of alphanumeric characters and optionally special characters.  This resource does not provide any guarantee that the random string will contain specific characters. ie. if length = 4 and special = true, output could be 'Aa0#' or '1111'")
    ("random_integer" "The resource random_integer generates random values from a given range, described by the min and max attributes of a given resource.\n\nThis resource can be used in conjunction with resources that have the create_before_destroy lifecycle flag set, to avoid conflicts with unique names during the brief period where both the old and new resources exist concurrently.")
    ("rundeck_project" "The project resource allows Rundeck projects to be managed by Terraform. In Rundeck a project is the container object for a set of jobs and the configuration for which servers those jobs can be run on.")
    ("rundeck_private_key" "The private key resource allows SSH private keys to be stored into Rundeck's key store. The key store is where Rundeck keeps credentials that are needed to access the nodes on which it runs commands.")
    ("rundeck_public_key" "The public key resource allows SSH public keys to be stored into Rundeck's key store. The key store is where Rundeck keeps credentials that are needed to access the nodes on which it runs commands.\n\nThis resource also allows the retrieval of an existing public key from the store, so that it may be used in the configuration of other resources such as aws_key_pair.")
    ("rundeck_job" "The job resource allows Rundeck jobs to be managed by Terraform. In Rundeck a job is a particular named set of steps that can be executed against one or more of the nodes configured for its associated project.\n\nEach job belongs to a project. A project can be created with the rundeck_project resource.")
    ("scaleway_ip" "Provides IPs for servers. This allows IPs to be created, updated and deleted. For additional details please refer to API documentation.")
    ("scaleway_server" "Provides servers. This allows servers to be created, updated and deleted. For additional details please refer to API documentation.")
    ("scaleway_security_group" "Provides security groups. This allows security groups to be created, updated and deleted. For additional details please refer to API documentation.")
    ("scaleway_security_group_rule" "Provides security group rules. This allows security group rules to be created, updated and deleted. For additional details please refer to API documentation.")
    ("scaleway_volume" "Provides volumes. This allows volumes to be created, updated and deleted. For additional details please refer to API documentation.")
    ("scaleway_token" "Provides Tokens for scaleway API access. For additional details please refer to API documentation.")
    ("scaleway_user_data" "Provides user data for servers. For additional details please refer to API documentation.")
    ("scaleway_volume_attachment" "This allows volumes to be attached to servers.\n\nWarning: Attaching volumes requires the servers to be powered off. This will lead to downtime if the server is already in use.")
    ("virtual_guest" "Provides virtual guest resource. This allows virtual guests to be created, updated and deleted. For additional details please refer to API documentation.")
    ("ssh_key" "Provides SSK keys. This allows SSH keys to be created, updated and deleted. For additional details please refer to API documentation.")
    ("statuscake_test" "The test resource allows StatusCake tests to be managed by Terraform.")
    ("aws_group" "Provides a Spotinst AWS group resource.")
    ("template_dir" "Renders a directory containing templates into a separate directory of corresponding rendered files.\n\ntemplate_dir is similar to template_file but it walks a given source directory and treats every file it encounters as a template, rendering it to a corresponding file in the destination directory.\n\n Note When working with local files, Terraform will detect the resource as having been deleted each time a configuration is applied on a new machine where the destination dir is not present and will generate a diff to create it. This may cause \"noise\" in diffs in environments where configurations are routinely applied by many different users or within automation systems.")
    ("tls_private_key" "Generates a secure private key and encodes it as PEM. This resource is primarily intended for easily bootstrapping throwaway development environments.\n\n Important Security Notice The private key generated by this resource will be stored unencrypted in your Terraform state file. Use of this resource for production deployments is not recommended. Instead, generate a private key file outside of Terraform and distribute it securely to the system where Terraform will be run. \n\nThis is a logical resource, so it contributes only to the current Terraform state and does not create any external managed resources.")
    ("tls_self_signed_cert" "Generates a self-signed TLS certificate in PEM format, which is the typical format used to configure TLS server software.\n\nSelf-signed certificates are generally not trusted by client software such as web browsers. Therefore clients are likely to generate trust warnings when connecting to a server that has a self-signed certificate. Self-signed certificates are usually used only in development environments or apps deployed internally to an organization.\n\nThis resource is intended to be used in conjunction with a Terraform provider that has a resource that requires a TLS certificate, such as:\n\n aws_iam_server_certificate to register certificates for use with AWS Elastic Load Balancer, Elastic Beanstalk, CloudFront or OpsWorks.  heroku_cert to register certificates for applications deployed on Heroku.")
    ("tls_locally_signed_cert" "Generates a TLS certificate using a Certificate Signing Request (CSR) and signs it with a provided certificate authority (CA) private key.\n\nLocally-signed certificates are generally only trusted by client software when setup to use the provided CA. They are normally used in development environments or when deployed internally to an organization.")
    ("tls_cert_request" "Generates a Certificate Signing Request (CSR) in PEM format, which is the typical format used to request a certificate from a certificate authority.\n\nThis resource is intended to be used in conjunction with a Terraform provider for a particular certificate authority in order to provision a new certificate. This is a logical resource, so it contributes only to the current Terraform state and does not create any external managed resources.\n\n Compatibility Note From Terraform 0.7.0 to 0.7.4 this resource was converted to a data source, and the resource form of it was deprecated. This turned out to be a design error since a cert request includes a random number in the form of the signature nonce, and so the data source form of this resource caused non-convergent configuration. The data source form is no longer supported as of Terraform 0.7.5 and any users should return to using the resource form.")
    ("triton_fabric" "The triton_fabric resource represents an fabric for a Triton account. The fabric is a logical set of interconnected switches.")
    ("triton_firewall_rule" "The triton_firewall_rule resource represents a rule for the Triton cloud firewall.")
    ("triton_instance_template" "The triton_instance_template resource represents a Triton Service Group instance template.\n\n NOTE:  Triton Service Groups are in Preview and only supported in specific regions at this time. They will become Generally Available in the near future.")
    ("triton_key" "The triton_key resource represents an SSH key for a Triton account.")
    ("triton_machine" "The triton_machine resource represents a virtual machine or infrastructure container running in Triton.\n\n Note: Starting with Triton 0.2.0, Please note that when you want to specify the networks that you want the machine to be attached to, use the networks parameter and not the nic parameter.")
    ("triton_service_group" "The triton_service_group resource represents a Triton Service Group.\n\n NOTE:  Triton Service Groups are in Preview and only supported in specific regions at this time. They will become Generally Available in the near future.")
    ("triton_snapshot" "The triton_snapshot resource represents a snapshot of a Triton machine. Snapshots are not usable with other instances; they are a point-in-time snapshot of the current instance. Snapshots can also only be taken of instances that are not of brand kvm.")
    ("triton_vlan" "The triton_vlan resource represents an Triton VLAN. A VLAN provides a low level way to segregate and subdivide the network. Traffic on one VLAN cannot, on its own, reach another VLAN.")
    ("ultradns_dirpool" "Provides an UltraDNS Directional Controller pool resource.")
    ("ultradns_probe_http" "Provides an UltraDNS HTTP probe")
    ("ultradns_probe_ping" "Provides an UltraDNS ping probe")
    ("ultradns_record" "Provides an UltraDNS record resource.")
    ("ultradns_tcpool" "Provides an UltraDNS Traffic Controller pool resource.")
    ("vault_approle_auth_backend_role" "Manages an AppRole auth backend role in a Vault server. See the Vault documentation for more information.")
    ("vault_approle_auth_backend_login" "Logs into Vault using the AppRole auth backend. See the Vault documentation for more information.")
    ("vault_approle_auth_backend_role_secret_id" "Manages an AppRole auth backend SecretID in a Vault server. See the Vault documentation for more information.")
    ("vault_auth_backend" "")
    ("vault_aws_auth_backend_cert" "Manages a certificate to be used with an AWS Auth Backend in Vault.\n\nThis resource sets the AWS public key and the type of document that can be verified against the key that Vault can then use to verify the instance identity documents making auth requests.\n\nFor more information, see the Vault docs.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_aws_auth_backend_client" "Configures the client used by an AWS Auth Backend in Vault.\n\nThis resource sets the access key and secret key that Vault will use when making API requests on behalf of an AWS Auth Backend. It can also be used to override the URLs Vault uses when making those API requests.\n\nFor more information, see the Vault docs.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_aws_auth_backend_identity_whitelist" "Configures the periodic tidying operation of the whitelisted identity entries.\n\nFor more information, see the Vault docs.")
    ("vault_aws_auth_backend_login" "Logs into a Vault server using an AWS auth backend. Login can be accomplished using a signed identity request from IAM or using ec2 instance metadata. For more information, see the Vault documentation.")
    ("vault_aws_auth_backend_role" "Manages an AWS auth backend role in a Vault server. Roles constrain the instances or principals that can perform the login operation against the backend. See the Vault documentation for more information.")
    ("vault_aws_auth_backend_sts_role" "Manages an STS role in a Vault server. STS roles are mappings between account IDs and STS ARNs. When a login attempt is made from an EC2 instance in the account ID specified, the associated STS role will be used to verify the request. For more information, see the Vault documentation.\n\n Important All data provided in the resource configuration will be  written in cleartext to state and plan files generated by Terraform, and will  appear in the console output when Terraform runs. Protect these artifacts  accordingly. See the main provider documentation for more  details.")
    ("vault_aws_secret_backend" "Creates an AWS Secret Backend for Vault. AWS secret backends can then issue AWS access keys and secret keys, once a role has been added to the backend.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_aws_secret_backend_role" "Creates a role on an AWS Secret Backend for Vault. Roles are used to map credentials to the policies that generated them.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_database_secret_backend_connection" "Creates a Database Secret Backend connection in Vault. Database secret backend connections can be used to generate dynamic credentials for the database.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_database_secret_backend_role" "Creates a Database Secret Backend role in Vault. Database secret backend roles can be used to generate dynamic credentials for the database.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_generic_secret" "Writes and manages arbitrary data at a given path in Vault.\n\nThis resource is primarily intended to be used with Vault's \"generic\" secret backend, but it is also compatible with any other Vault endpoint that supports the vault write command to create and the vault delete command to delete.\n\n Important All data provided in the resource configuration will be written in cleartext to state and plan files generated by Terraform, and will appear in the console output when Terraform runs. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_okta_auth_backend" "Provides a resource for managing an Okta auth backend within Vault.")
    ("vault_okta_auth_backend_user" "Provides a resource to create a user in an Okta auth backend within Vault.")
    ("vault_okta_auth_backend_group" "Provides a resource to create a group in an Okta auth backend within Vault.")
    ("vault_mount" "")
    ("vault_okta_auth_backend" "Provides a resource for managing an Okta auth backend within Vault.")
    ("vault_okta_auth_backend_group" "Provides a resource to create a group in an Okta auth backend within Vault.")
    ("vault_okta_auth_backend_user" "Provides a resource to create a user in an Okta auth backend within Vault.")
    ("vault_policy" "")
    ("vcd_dnat" "Provides a vCloud Director DNAT resource. This can be used to create, modify, and delete destination NATs to map an external IP/port to an internal IP/port.")
    ("vcd_firewall_rules" "Provides a vCloud Director Firewall resource. This can be used to create, modify, and delete firewall settings and rules.")
    ("vcd_network" "Provides a vCloud Director VDC Network. This can be used to create, modify, and delete internal networks for vApps to connect.")
    ("vcd_snat" "Provides a vCloud Director SNAT resource. This can be used to create, modify, and delete source NATs to allow vApps to send external traffic.")
    ("vcd_edgegateway_vpn" "Provides a vCloud Director IPsec VPN. This can be used to create, modify, and delete VPN settings and rules.")
    ("vcd_vapp" "Provides a vCloud Director vApp resource. This can be used to create, modify, and delete vApps.")
    ("vcd_vapp_vm" "Provides a vCloud Director VM resource. This can be used to create, modify, and delete VMs within a vApp.\n\n Note: There is known bug with this implementation, that to use the vcd_vapp_vm resource, you must set the paralellism parameter to 1. We are working on this.")
    ("nsxt_dhcp_relay_profile" "This resource can be used to configure a NSX DHCP relay profile on the NSX manager. A DHCP relay profile is a type of template that can be used to define a remote DHCP server where DHCP packets can be relayed for DHCP requests of machines attached to NSX logical topologies. The DHCP relay profile can be used in a DHCP relay service and later consumed by a router link port.")
    ("nsxt_dhcp_relay_service" "This resource provides a way to configure the DHCP relay service on the NSX manager. The DHCP relay service uses a DHCP relay profile and later consumed by a router link port to provide DHCP addresses to virtual machines connected to a logical switch.")
    ("nsxt_firewall_section" "This resource provides a way to configure a firewall section on the NSX manager. A firewall section is a collection of firewall rules that are grouped together.")
    ("nsxt_ip_set" "This resources provides a way to configure an IP set in NSX. An IP set is a collection of IP addresses. It is often used in the configuration of the NSX firewall.")
    ("nsxt_logical_port" "This resource provides a resource to configure a logical port on a logical switch in the NSX system. Like physical switches a logical switch can have one or more ports which can be connected to virtual machines or logical routers.")
    ("nsxt_logical_router_downlink_port" "This resource provides a means to define a downlink port on a logical router to connect a logical router to a logical switch. The result of this is to provide a default gateway to virtual machines running on the logical switch.")
    ("nsxt_logical_router_link_port_on_tier0" "This resource provides the ability to configure a logical router link port on a tier 0 logical router. This port can then be used to connect the tier 0 logical router to another logical router.")
    ("nsxt_logical_router_link_port_on_tier1" "This resource provides the ability to configure a logical router link port on a tier 1 logical router. This port can then be used to connect the tier 1 logical router to another logical router.")
    ("nsxt_logical_switch" "This resource provides a method to create a logical switch in NSX. Virtual machines can then be connected to the appropriate logical switch for the desired topology and network connectivity.")
    ("nsxt_logical_tier1_router" "This resource provides a method for the management of a tier 1 logical router. A tier 1 logical router is often used for tenants, users and applications. There can be many tier 1 logical routers connected to a common tier 0 provider router.")
    ("nsxt_nat_rule" "This resource provides a means to configure a NAT rule in NSX. NAT provides network address translation between one IP address space and another IP address space. NAT rules can be destination NAT or source NAT rules.")
    ("nsxt_ns_group" "This resource provides a method to create and manage a network and security (NS) group in NSX. A NS group is used to group other objects into collections for application of other settings.")
    ("nsxt_static_route" "This resource provides a means to configure static routes in NSX to determine where IP traffic is routed.")
    ("nsxt_vm_tags" "This resource provides a means to configure tags that are applied to objects such as virtual machines. A virtual machine is not directly managed by NSX however, NSX allows attachment of tags to a virtual machine. This tagging enables tag based grouping of objects. Deletion of nsxt_vm_tags resource will remove all tags from the virtual machine and is equivalent to update operation with empty tag set.")
    ("nsxt_algorithm_type_ns_service" "This resource provides a way to configure a networking and security service which can be used with the NSX firewall. A networking and security service is an object that contains the TCP/UDP algorithm, source ports and destination ports in a single entity.")
    ("nsxt_ether_type_ns_service" "This resource provides a way to configure a networking and security service which can be used within NSX. This specific service is for the layer 2 Ethernet protocol.")
    ("nsxt_icmp_type_ns_service" "This resource provides a way to configure a networking and security service which can be used within NSX. This specific service is for the ICMP protocol.")
    ("nsxt_igmp_type_ns_service" "This resource provides a way to configure a networking and security service which can be used within NSX. This specific service is for the IGMP protocol.")
    ("nsxt_ip_protocol_ns_service" "This resource provides a way to configure a networking and security service which can be used within NSX. This specific service is for the IP protocol.")
    ("nsxt_l4_port_set_ns_service" "This resource provides a way to configure a networking and security service which can be used within NSX. This specific service is for configuration of layer 4 ports.")
    ("vsphere_license" "Provides a VMware vSphere license resource. This can be used to add and remove license keys.")
    ("vsphere_compute_cluster" "A note on the naming of this resource: VMware refers to clusters of hosts in the UI and documentation as clusters, HA clusters, or DRS clusters. All of these refer to the same kind of resource (with the latter two referring to specific features of clustering). In Terraform, we use vsphere_compute_cluster to differentiate host clusters from datastore clusters, which are clusters of datastores that can be used to distribute load and ensure fault tolerance via distribution of virtual machines. Datastore clusters can also be managed through Terraform, via the vsphere_datastore_cluster resource. \n\nThe vsphere_compute_cluster resource can be used to create and manage clusters of hosts allowing for resource control of compute resources, load balancing through DRS, and high availability through vSphere HA.\n\nFor more information on vSphere clusters and DRS, see this page. For more information on vSphere HA, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_compute_cluster_host_group" "The vsphere_compute_cluster_host_group resource can be used to manage groups of hosts in a cluster, either created by the vsphere_compute_cluster resource or looked up by the vsphere_compute_cluster data source.\n\nThis resource mainly serves as an input to the vsphere_compute_cluster_vm_host_rule resource - see the documentation for that resource for further details on how to use host groups.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_compute_cluster_vm_affinity_rule" "The vsphere_compute_cluster_vm_affinity_rule resource can be used to manage VM affinity rules in a cluster, either created by the vsphere_compute_cluster resource or looked up by the vsphere_compute_cluster data source.\n\nThis rule can be used to tell a set to virtual machines to run together on a single host within a cluster. When configured, DRS will make a best effort to ensure that the virtual machines run on the same host, or prevent any operation that would keep that from happening, depending on the value of the mandatory flag.\n\n Keep in mind that this rule can only be used to tell VMs to run together on a non-specific host - it can't be used to pin VMs to a host. For that, see the vsphere_compute_cluster_vm_host_rule resource. \n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_compute_cluster_vm_anti_affinity_rule" "The vsphere_compute_cluster_vm_anti_affinity_rule resource can be used to manage VM anti-affinity rules in a cluster, either created by the vsphere_compute_cluster resource or looked up by the vsphere_compute_cluster data source.\n\nThis rule can be used to tell a set to virtual machines to run on different hosts within a cluster, useful for preventing single points of failure in application cluster scenarios. When configured, DRS will make a best effort to ensure that the virtual machines run on different hosts, or prevent any operation that would keep that from happening, depending on the value of the mandatory flag.\n\n Keep in mind that this rule can only be used to tell VMs to run separately on non-specific hosts - specific hosts cannot be specified with this rule. For that, see the vsphere_compute_cluster_vm_host_rule resource. \n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_compute_cluster_vm_dependency_rule" "The vsphere_compute_cluster_vm_dependency_rule resource can be used to manage VM dependency rules in a cluster, either created by the vsphere_compute_cluster resource or looked up by the vsphere_compute_cluster data source.\n\nA virtual machine dependency rule applies to vSphere HA, and allows user-defined startup orders for virtual machines in the case of host failure. Virtual machines are supplied via groups, which can be managed via the vsphere_compute_cluster_vm_group resource.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections.")
    ("vsphere_compute_cluster_vm_group" "The vsphere_compute_cluster_vm_group resource can be used to manage groups of virtual machines in a cluster, either created by the vsphere_compute_cluster resource or looked up by the vsphere_compute_cluster data source.\n\nThis resource mainly serves as an input to the vsphere_compute_cluster_vm_dependency_rule and vsphere_compute_cluster_vm_host_rule resources. See the individual resource documentation pages for more information.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_compute_cluster_vm_host_rule" "The vsphere_compute_cluster_vm_host_rule resource can be used to manage VM-to-host rules in a cluster, either created by the vsphere_compute_cluster resource or looked up by the vsphere_compute_cluster data source.\n\nThis resource can create both affinity rules, where virtual machines run on specified hosts, or anti-affinity rules, where virtual machines run on hosts outside of the ones specified in the rule. Virtual machines and hosts are supplied via groups, which can be managed via the vsphere_compute_cluster_vm_group and vsphere_compute_cluster_host_group resources.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_drs_vm_override" "The vsphere_drs_vm_override resource can be used to add a DRS override to a cluster for a specific virtual machine. With this resource, one can enable or disable DRS and control the automation level for a single virtual machine without affecting the rest of the cluster.\n\nFor more information on vSphere clusters and DRS, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_dpm_host_override" "The vsphere_dpm_host_override resource can be used to add a DPM override to a cluster for a particular host. This allows you to control the power management settings for individual hosts in the cluster while leaving any unspecified ones at the default power management settings.\n\nFor more information on DPM within vSphere clusters, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: vSphere DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_ha_vm_override" "The vsphere_ha_vm_override resource can be used to add an override for vSphere HA settings on a cluster for a specific virtual machine. With this resource, one can control specific HA settings so that they are different than the cluster default, accommodating the needs of that specific virtual machine, while not affecting the rest of the cluster.\n\nFor more information on vSphere HA, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections.")
    ("vsphere_custom_attribute" "The vsphere_custom_attribute resource can be used to create and manage custom attributes, which allow users to associate user-specific meta-information with  vSphere managed objects. Custom attribute values must be strings and are stored  on the vCenter Server and not the managed object.\n\nFor more information about custom attributes, click here.\n\n NOTE: Custom attributes are unsupported on direct ESXi connections  and require vCenter.")
    ("vsphere_datacenter" "Provides a VMware vSphere datacenter resource. This can be used as the primary container of inventory objects such as hosts and virtual machines.")
    ("vsphere_folder" "The vsphere_folder resource can be used to manage vSphere inventory folders. The resource supports creating folders of the 5 major types - datacenter folders, host and cluster folders, virtual machine folders, datastore folders, and network folders.\n\nPaths are always relative to the specific type of folder you are creating. Subfolders are discovered by parsing the relative path specified in path, so foo/bar will create a folder named bar in the parent folder foo, as long as that folder exists.")
    ("vsphere_tag" "The vsphere_tag resource can be used to create and manage tags, which allow you to attach metadata to objects in the vSphere inventory to make these objects more sortable and searchable.\n\nFor more information about tags, click here.\n\n NOTE: Tagging support is unsupported on direct ESXi connections and requires vCenter 6.0 or higher.")
    ("vsphere_tag_category" "The vsphere_tag_category resource can be used to create and manage tag categories, which determine how tags are grouped together and applied to specific objects.\n\nFor more information about tags, click here. For more information about tag categories specifically, click here.\n\n NOTE: Tagging support is unsupported on direct ESXi connections and requires vCenter 6.0 or higher.")
    ("vsphere_distributed_port_group" "The vsphere_distributed_port_group resource can be used to manage vSphere distributed virtual port groups. These port groups are connected to distributed virtual switches, which can be managed by the vsphere_distributed_virtual_switch resource.\n\nDistributed port groups can be used as networks for virtual machines, allowing VMs to use the networking supplied by a distributed virtual switch (DVS), with a set of policies that apply to that individual newtork, if desired.\n\nFor an overview on vSphere networking concepts, see this page. For more information on vSphere DVS portgroups, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections.")
    ("vsphere_distributed_virtual_switch" "The vsphere_distributed_virtual_switch resource can be used to manage VMware Distributed Virtual Switches.\n\nAn essential component of a distributed, scalable VMware datacenter, the vSphere Distributed Virtual Switch (DVS) provides centralized management and monitoring of the networking configuration of all the hosts that are associated with the switch. In addition to adding port groups (see the vsphere_distributed_port_group resource) that can be used as networks for virtual machines, a DVS can be configured to perform advanced high availability, traffic shaping, network monitoring, and more.\n\nFor an overview on vSphere networking concepts, see this page. For more information on vSphere DVS, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections.")
    ("vsphere_host_port_group" "The vsphere_host_port_group resource can be used to manage vSphere standard port groups on an ESXi host. These port groups are connected to standard virtual switches, which can be managed by the vsphere_host_virtual_switch resource.\n\nFor an overview on vSphere networking concepts, see this page.")
    ("vsphere_host_virtual_switch" "The vsphere_host_virtual_switch resource can be used to manage vSphere standard switches on an ESXi host. These switches can be used as a backing for standard port groups, which can be managed by the vsphere_host_port_group resource.\n\nFor an overview on vSphere networking concepts, see this page.")
    ("vsphere_datastore_cluster" "The vsphere_datastore_cluster resource can be used to create and manage datastore clusters. This can be used to create groups of datastores with a shared management interface, allowing for resource control and load balancing through Storage DRS.\n\nFor more information on vSphere datastore clusters and Storage DRS, see this page.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: Storage DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_datastore_cluster_vm_anti_affinity_rule" "The vsphere_datastore_cluster_vm_anti_affinity_rule resource can be used to manage VM anti-affinity rules in a datastore cluster, either created by the vsphere_datastore_cluster resource or looked up by the vsphere_datastore_cluster data source.\n\nThis rule can be used to tell a set to virtual machines to run on different datastores within a cluster, useful for preventing single points of failure in application cluster scenarios. When configured, Storage DRS will make a best effort to ensure that the virtual machines run on different datastores, or prevent any operation that would keep that from happening, depending on the value of the mandatory flag.\n\n NOTE: This resource requires vCenter and is not available on direct ESXi connections. \n\n NOTE: Storage DRS requires a vSphere Enterprise Plus license.")
    ("vsphere_file" "The vsphere_file resource can be used to upload files (such as virtual disk files) from the host machine that Terraform is running on to a target datastore.  The resource can also be used to copy files between datastores, or from one location to another on the same datastore.\n\nUpdates to destination parameters such as datacenter, datastore, or destination_file will move the managed file a new destination based on the values of the new settings.  If any source parameter is changed, such as source_datastore, source_datacenter or source_file), the resource will be re-created. Depending on if destination parameters are being changed as well, this may result in the destination file either being overwritten or deleted at the old location.")
    ("vsphere_nas_datastore" "The vsphere_nas_datastore resource can be used to create and manage NAS datastores on an ESXi host or a set of hosts. The resource supports mounting NFS v3 and v4.1 shares to be used as datastores.\n\n NOTE: Unlike vsphere_vmfs_datastore, a NAS datastore is only mounted on the hosts you choose to mount it on. To mount on multiple hosts, you must specify each host that you want to add in the host_system_ids argument.")
    ("vsphere_storage_drs_vm_override" "The vsphere_storage_drs_vm_override resource can be used to add a Storage DRS override to a datastore cluster for a specific virtual machine. With this resource, one can enable or disable Storage DRS, and control the automation level and disk affinity for a single virtual machine without affecting the rest of the datastore cluster.\n\nFor more information on vSphere datastore clusters and Storage DRS, see this page.")
    ("vsphere_vmfs_datastore" "The vsphere_vmfs_datastore resource can be used to create and manage VMFS datastores on an ESXi host or a set of hosts. The resource supports using any SCSI device that can generally be used in a datastore, such as local disks, or disks presented to a host or multiple hosts over Fibre Channel or iSCSI. Devices can be specified manually, or discovered using the vsphere_vmfs_disks data source.")
    ("vsphere_virtual_disk" "The vsphere_virtual_disk resource can be used to create virtual disks outside of any given vsphere_virtual_machine resource. These disks can be attached to a virtual machine by creating a disk sub-resource with the attach parameter.")
    ("vsphere_virtual_machine" "The vsphere_virtual_machine resource can be used to manage the complex lifecycle of a virtual machine. It supports management of disk, network interface, and CDROM devices, creation from scratch or cloning from template, and migration through both host and storage vMotion.\n\nFor more details on working with virtual machines in vSphere, see this page.")
    ("vsphere_virtual_machine_snapshot" "The vsphere_virtual_machine_snapshot resource can be used to manage snapshots for a virtual machine.\n\nFor more information on managing snapshots and how they work in VMware, see here.\n\n NOTE: A snapshot in VMware differs from traditional disk snapshots, and can contain the actual running state of the virtual machine, data for all disks that have not been set to be independent from the snapshot (including ones that have been attached via the attach parameter to the vsphere_virtual_machine disk sub-resource), and even the configuration of the virtual machine at the time of the snapshot. Virtual machine, disk activity, and configuration changes post-snapshot are not included in the original state. Use this resource with care! Neither VMware nor HashiCorp recommends retaining snapshots for a extended period of time and does NOT recommend using them as as backup feature. For more information on the limitation of virtual machine snapshots, see here.")
   ))

(puthash "alicloud_disk" '(
    ("availability_zone" "availability_zone - (Required, Forces new resource) The Zone to create the disk in.")
    ("name" "name - (Optional) Name of the ECS disk. This name can have a string of 2 to 128 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin or end with a hyphen, and must not begin with http:// or https://. Default value is null.")
    ("description" "description - (Optional) Description of the disk. This description can have a string of 2 to 256 characters, It cannot begin with http:// or https://. Default value is null.")
    ("category" "category - (Optional, Forces new resource) Category of the disk. Valid values are cloud, cloud_efficiency and cloud_ssd. Default is cloud_efficiency.")
    ("size" "size - (Required) The size of the disk in GiBs, and it value range: 20 ~ 32768.")
    ("snapshot_id" "snapshot_id - (Optional) A snapshot to base the disk off of. If it is specified, size will be invalid and the disk size is equals to the snapshot size.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("encrypted" "encrypted - (Optional) If true, the disk will be encrypted")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_disk_attachment" '(
    ("instance_id" "instance_id - (Required, Forces new resource) ID of the Instance to attach to.")
    ("disk_id" "disk_id - (Required, Forces new resource) ID of the Disk to be attached.")
    ("device_name" "device_name - (Deprecated) The device name has been deprecated, and when attaching disk, it will be allocated automatically by system according to default order from /dev/xvdb to /dev/xvdz.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_instance" '(
    ("image_id" "image_id - (Required) The Image to use for the instance. ECS instance's image can be replaced via changing 'image_id'. When it is changed, the instance will reboot to make the change take effect.")
    ("instance_type" "instance_type - (Required) The type of instance to start.")
    ("io_optimized" "io_optimized - (Deprecated) It has been deprecated on instance resource. All the launched alicloud instances will be I/O optimized.")
    ("is_outdated" "is_outdated - (Optional) Whether to use outdated instance type. Default to false.")
    ("security_groups" "security_groups - (Required)  A list of security group ids to associate with.")
    ("availability_zone" "availability_zone - (Optional) The Zone to start the instance in. It is ignored and will be computed when set vswitch_id.")
    ("instance_name" "instance_name - (Optional) The name of the ECS. This instance_name can have a string of 2 to 128 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin or end with a hyphen, and must not begin with http:// or https://. If not specified,  Terraform will autogenerate a default name is ECS-Instance.")
    ("allocate_public_ip" "allocate_public_ip - (Deprecated) It has been deprecated from version \"1.7.0\". Setting \"internet_max_bandwidth_out\" larger than 0 can allocate a public ip address for an instance.")
    ("system_disk_category" "system_disk_category - (Optional) Valid values are cloud_efficiency, cloud_ssd and cloud. cloud only is used to some none I/O optimized instance. Default to cloud_efficiency.")
    ("system_disk_size" "system_disk_size - (Optional) Size of the system disk, value range: 40GB ~ 500GB. Default is 40GB. ECS instance's system disk can be reset when replacing system disk.")
    ("description" "description - (Optional) Description of the instance, This description can have a string of 2 to 256 characters, It cannot begin with http:// or https://. Default value is null.")
    ("internet_charge_type" "internet_charge_type - (Optional) Internet charge type of the instance, Valid values are PayByBandwidth, PayByTraffic. Default is PayByTraffic. At present, 'PrePaid' instance cannot change the value to \"PayByBandwidth\" from \"PayByTraffic\".")
    ("internet_max_bandwidth_in" "internet_max_bandwidth_in - (Optional) Maximum incoming bandwidth from the public network, measured in Mbps (Mega bit per second). Value range: [1, 200]. If this value is not specified, then automatically sets it to 200 Mbps.")
    ("internet_max_bandwidth_out" "internet_max_bandwidth_out - (Optional) Maximum outgoing bandwidth to the public network, measured in Mbps (Mega bit per second). Value range:  [0, 100]. Default to 0 Mbps.")
    ("host_name" "host_name - (Optional) Host name of the ECS, which is a string of at least two characters. “hostname” cannot start or end with “.” or “-“. In addition, two or more consecutive “.” or “-“ symbols are not allowed. On Windows, the host name can contain a maximum of 15 characters, which can be a combination of uppercase/lowercase letters, numerals, and “-“. The host name cannot contain dots (“.”) or contain only numeric characters. On other OSs such as Linux, the host name can contain a maximum of 30 characters, which can be segments separated by dots (“.”), where each segment can contain uppercase/lowercase letters, numerals, or “_“. When it is changed, the instance will reboot to make the change take effect.")
    ("password" "password - (Optional) Password to an instance is a string of 8 to 30 characters. It must contain uppercase/lowercase letters and numerals, but cannot contain special symbols. When it is changed, the instance will reboot to make the change take effect.")
    ("vswitch_id" "vswitch_id - (Optional) The virtual switch ID to launch in VPC. If you want to create instances in VPC network, this parameter must be set.")
    ("instance_charge_type" "instance_charge_type - (Optional) Valid values are PrePaid, PostPaid, The default is PostPaid.")
    ("period_unit" "period_unit - (Optional) The duration unit that you will buy the resource. It is valid when instance_charge_type is 'PrePaid'. Valid value: [\"Week\", \"Month\"]. Default to \"Month\".")
    ("period" "period - (Optional) The duration that you will buy the resource, in month. It is valid when instance_charge_type is set as PrePaid. Default to 1. Valid values:  [1-9, 12, 24, 36, 48, 60] when period_unit in \"Month\"  [1-3] when period_unit in \"Week\"")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("user_data" "user_data - (Optional) User-defined data to customize the startup behaviors of an ECS instance and to pass data into an ECS instance.")
    ("key_name" "key_name - (Optional, Force new resource) The name of key pair that can login ECS instance successfully without password. If it is specified, the password would be invalid.")
    ("role_name" "role_name - (Optional, Force new resource) Instance RAM role name. The name is provided and maintained by RAM. You can use alicloud_ram_role to create a new one.")
    ("include_data_disks" "include_data_disks - (Optional) Whether to change instance disks charge type when changing instance charge type.")
    ("dry_run" "dry_run - (Optional) Whether to pre-detection. When it is true, only pre-detection and not actually modify the payment type operation. It is valid when instance_charge_type is 'PrePaid'. Default to false.")
    ("private_ip" "private_ip - (Optional) Instance private IP address can be specified when you creating new instance. It is valid when vswitch_id is specified.")
    ("spot_strategy" "spot_strategy - (Optional, Force New) The spot strategy of a Pay-As-You-Go instance, and it takes effect only when parameter instance_charge_type is 'PostPaid'. Value range:  NoSpot: A regular Pay-As-You-Go instance.  SpotWithPriceLimit: A price threshold for a spot instance  SpotAsPriceGo: A price that is based on the highest Pay-As-You-Go instance   Default to NoSpot.")
    ("spot_price_limit" "spot_price_limit - (Optional, Float, Force New) The hourly price threshold of a instance, and it takes effect only when parameter 'spot_strategy' is 'SpotWithPriceLimit'. Three decimals is allowed at most.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_security_group" '(
    ("name" "name - (Optional) The name of the security group. Defaults to null.")
    ("description" "description - (Optional, Forces new resource) The security group description. Defaults to null.")
    ("vpc_id" "vpc_id - (Optional, Forces new resource) The VPC ID.")
    ("inner_access" "inner_access - (Optional) Whether to allow both machines to access each other on all ports in the same security group. Combining security group rules, the policy can define multiple application scenario. Default to true. It is valid from verison 1.7.2.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_security_group_rule" '(
    ("type" "type - (Required) The type of rule being created. Valid options are ingress (inbound) or egress (outbound).")
    ("ip_protocol" "ip_protocol - (Required) The protocol. Can be tcp, udp, icmp, gre or all.")
    ("port_range" "port_range - (Required) The range of port numbers relevant to the IP protocol. Default to \"-1/-1\". When the protocol is tcp or udp, each side port number range from 1 to 65535 and '-1/-1' will be invalid. For example, 1/200 means that the range of the port numbers is 1-200. Other protocols' 'port_range' can only be \"-1/-1\", and other values will be invalid.")
    ("security_group_id" "security_group_id - (Required) The security group to apply this rule to.")
    ("nic_type" "nic_type - (Optional, Forces new resource) Network type, can be either internet or intranet, the default value is internet.")
    ("policy" "policy - (Optional, Forces new resource) Authorization policy, can be either accept or drop, the default value is accept.")
    ("priority" "priority - (Optional, Forces new resource) Authorization policy priority, with parameter values: 1-100, default value: 1.")
    ("cidr_ip" "cidr_ip - (Optional, Forces new resource) The target IP address range. The default value is 0.0.0.0/0 (which means no restriction will be applied). Other supported formats include 10.159.6.18/12. Only IPv4 is supported.")
    ("source_security_group_id" "source_security_group_id - (Optional, Forces new resource) The target security group ID within the same region. If this field is specified, the nic_type can only select intranet.")
    ("source_group_owner_account" "source_group_owner_account - (Optional, Forces new resource) The Alibaba Cloud user account Id of the target security group when security groups are authorized across accounts.  This parameter is invalid if cidr_ip has already been set.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_eip" '(
    ("bandwidth" "bandwidth - (Optional) Maximum bandwidth to the elastic public network, measured in Mbps (Mega bit per second). If this value is not specified, then automatically sets it to 5 Mbps.")
    ("internet_charge_type" "internet_charge_type - (Optional, Forces new resource) Internet charge type of the EIP, Valid values are PayByBandwidth, PayByTraffic. Default is PayByBandwidth. From version 1.7.1, default to PayByTraffic.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_eip_association" '(
    ("allocation_id" "allocation_id - (Optional, Forces new resource) The allocation EIP ID.")
    ("instance_id" "instance_id - (Optional, Forces new resource) The ID of the ECS or SLB instance or Nat Gateway.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_key_pair" '(
    ("key_name" "key_name - (Force new resource) The key pair's name. It is the only in one Alicloud account.")
    ("key_name_prefix" "key_name_prefix - (Force new resource) The key pair name's prefix. It is conflict with key_name. If it is specified, terraform will using it to build the only key name.")
    ("public_key" "public_key - (Force new resource) You can import an existing public key and using Alicloud key pair to manage it.")
    ("key_file" "key_file - (Force new resource) The name of file to save your new key pair's private key. Strongly suggest you to specified it when you creating key pair, otherwise, you wouldn't get its private key ever.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_key_pair_attachment" '(
    ("key_name" "key_name - (Required, Force new resource) The name of key pair used to bind.")
    ("instance_ids" "instance_ids - (Required, Force new resource) The list of ECS instance's IDs.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_slb" '(
    ("name" "name - (Optional) The name of the SLB. This name must be unique within your AliCloud account, can have a maximum of 80 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\"/\",\".\",\"_\", and must not begin or end with a hyphen. If not specified, Terraform will autogenerate a name beginning with tf-lb.")
    ("internet" "internet - (Optional, Forces New Resource) If true, the SLB addressType will be internet, false will be intranet, Default is false. If load balancer launched in VPC, this value must be \"false\".")
    ("internet_charge_type" "internet_charge_type - (Optional, Forces New Resource) Valid values are paybybandwidth, paybytraffic. If this value is \"paybybandwidth\", then argument \"internet\" must be \"true\". Default is \"paybytraffic\". If load balancer launched in VPC, this value must be \"paybytraffic\".")
    ("bandwidth" "bandwidth - (Optional) Valid value is between 1 and 1000, If argument \"internet_charge_type\" is \"paybytraffic\", then this value will be ignore.")
    ("listener" "listener - (Deprecated) The field has been deprecated from terraform-alicloud-provider version 1.3.0, and use resource alicloud_slb_listener to replace.")
    ("vswitch_id" "vswitch_id - (Required for a VPC SLB, Forces New Resource) The VSwitch ID to launch in.")
    ("specification" "specification - (Optional) The specification of the Server Load Balancer instance. Default to empty string indicating it is \"Shared-Performance\" instance. Launching \"Performance-guaranteed\" instance, it is must be specified and it valid values are: \"slb.s1.small\", \"slb.s2.small\", \"slb.s2.medium\", \"slb.s3.small\", \"slb.s3.medium\" and \"slb.s3.large\".")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_slb_attachment" '(
    ("load_balancer_id" "load_balancer_id - (Required) ID of the load balancer.")
    ("instance_ids" "instance_ids - (Required) A list of instance ids to added backend server in the SLB.")
    ("weight" "weight - (Optional) Weight of the instances. Valid value range: [0-100]. Default to 100.")
    ("slb_id" "slb_id - (Deprecated) It has been deprecated from provider version 1.6.0. New field 'load_balancer_id' replaces it.")
    ("instances" "instances - (Deprecated) It has been deprecated from provider version 1.6.0. New field 'instance_ids' replaces it. ## Attributes Reference")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_slb_listener" '(
    ("load_balancer_id" "load_balancer_id - (Required, ForceNew) The Load Balancer ID which is used to launch a new listener.")
    ("frontend_port" "frontend_port - (Required, ForceNew) Port used by the Server Load Balancer instance frontend. Valid value range: [1-65535].")
    ("backend_port" "backend_port - (Required, ForceNew) Port used by the Server Load Balancer instance backend. Valid value range: [1-65535].")
    ("protocol" "protocol - (Required, ForceNew) The protocol to listen on. Valid values are [http, https, tcp, udp].")
    ("bandwidth" "bandwidth - (Required) Bandwidth peak of Listener. For the public network instance charged per traffic consumed, the Bandwidth on Listener can be set to -1, indicating the bandwidth peak is unlimited. Valid values are [-1, 1-1000] in Mbps.")
    ("scheduler" "scheduler - (Optinal) Scheduling algorithm, Valid values are wrr and wlc.  Default to \"wrr\".")
    ("sticky_session" "sticky_session - (Optinal) Whether to enable session persistence, Valid values are on and off. Default to off.")
    ("sticky_session_type" "sticky_session_type - (Optinal) Mode for handling the cookie. If sticky_session is \"on\", it is mandatory. Otherwise, it will be ignored. Valid values are insert and server. insert means it is inserted from Server Load Balancer; server means the Server Load Balancer learns from the backend server.")
    ("cookie_timeout" "cookie_timeout - (Optinal) Cookie timeout. It is mandatory when sticky_session is \"on\" and sticky_session_type is \"insert\". Otherwise, it will be ignored. Valid value range: [1-86400] in seconds.")
    ("cookie" "cookie - (Optinal) The cookie configured on the server. It is mandatory when sticky_session is \"on\" and sticky_session_type is \"server\". Otherwise, it will be ignored. Valid value：String in line with RFC 2965, with length being 1- 200. It only contains characters such as ASCII codes, English letters and digits instead of the comma, semicolon or spacing, and it cannot start with $.")
    ("persistence_timeout" "persistence_timeout - (Optinal) Timeout of connection persistence. Valid value range: [0-3600] in seconds. Default to 0 and means closing it.")
    ("health_check" "health_check - (Optinal) Whether to enable health check. Valid values areon and off. TCP and UDP listener's HealthCheck is always on, so it will be ignore when launching TCP or UDP listener.")
    ("health_check_type" "health_check_type - (Optinal) Type of health check. Valid values are: tcp and http. Default to tcp . TCP supports TCP and HTTP health check mode, you can select the particular mode depending on your application.")
    ("health_check_domain" "health_check_domain - (Optinal) Domain name used for health check. When it used to launch TCP listener, health_check_type must be \"http\". Its length is limited to 1-80 and only characters such as letters, digits, ‘-‘ and ‘.’ are allowed. When it is not set or empty,  Server Load Balancer uses the private network IP address of each backend server as Domain used for health check.")
    ("health_check_uri" "health_check_uri - (Optinal) URI used for health check. When it used to launch TCP listener, health_check_type must be \"http\". Its length is limited to 1-80 and it must start with /. Only characters such as letters, digits, ‘-’, ‘/’, ‘.’, ‘%’, ‘?’, #’ and ‘&’ are allowed.")
    ("health_check_connect_port" "health_check_connect_port - (Optinal) Port used for health check. Valid value range: [1-65535]. Default to \"None\" means the backend server port is used.")
    ("healthy_threshold" "healthy_threshold - (Optinal) Threshold determining the result of the health check is success. It is required when health_check is on. Valid value range: [1-10] in seconds. Default to 3.")
    ("unhealthy_threshold" "unhealthy_threshold - (Optinal) Threshold determining the result of the health check is fail. It is required when health_check is on. Valid value range: [1-10] in seconds. Default to 3.")
    ("health_check_timeout" "health_check_timeout - (Optinal) Maximum timeout of each health check response. It is required when health_check is on. Valid value range: [1-300] in seconds. Default to 5. Note: If health_check_timeout < health_check_interval, its will be replaced by health_check_interval.")
    ("health_check_interval" "health_check_interval - (Optinal) Time interval of health checks. It is required when health_check is on. Valid value range: [1-50] in seconds. Default to 2.")
    ("health_check_http_code" "health_check_http_code - (Optinal) Regular health check HTTP status code. Multiple codes are segmented by “,”. It is required when health_check is on. Default to http_2xx.  Valid values are: http_2xx,  http_3xx, http_4xx and http_5xx.")
    ("ssl_certificate_id" "ssl_certificate_id - (Optinal) Security certificate ID.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_slb_rule" '(
    ("load_balancer_id" "load_balancer_id - (Required, ForceNew) The Load Balancer ID which is used to launch the new forwarding rule.")
    ("name" "name - (Optional, ForceNew) Name of the forwarding rule. Our plugin provides a default name: \"tf-slb-rule\".")
    ("frontend_port" "frontend_port - (Required, ForceNew) The listener frontend port which is used to launch the new forwarding rule. Valid range: [1-65535].")
    ("domain" "domain - (Optional, ForceNew) Domain name of the forwarding rule. It can contain letters a-z, numbers 0-9, hyphens (-), and periods (.), and wildcard characters. The following two domain name formats are supported:   Standard domain name: www.test.com  Wildcard domain name: .test.com. wildcard () must be the first character in the format of (*.)")
    ("url" "url - (Optional, ForceNew) Domain of the forwarding rule. It must be 2-80 characters in length. Only letters a-z, numbers 0-9, and characters '-' '/' '?' '%' '#' and '&' are allowed. URLs must be started with the character '/', but cannot be '/' alone.")
    ("server_group_id" "server_group_id - (Required) ID of a virtual server group that will be forwarded.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_slb_server_group" '(
    ("load_balancer_id" "load_balancer_id - (Required, ForceNew) The Load Balancer ID which is used to launch a new virtual server group.")
    ("name" "name - (Optional) Name of the virtual server group. Our plugin provides a default name: \"tf-server-group\".")
    ("servers" "servers - (Required) A list of ECS instances to be added. At most 20 ECS instances can be supported in one resource. It contains three sub-fields as Block server follows.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_vpc" '(
    ("cidr_block" "cidr_block - (Required, Forces new resource) The CIDR block for the VPC.")
    ("name" "name - (Optional) The name of the VPC. Defaults to null.")
    ("description" "description - (Optional) The VPC description. Defaults to null.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_vswitch" '(
    ("availability_zone" "availability_zone - (Required, Forces new resource) The AZ for the switch.")
    ("vpc_id" "vpc_id - (Required, Forces new resource) The VPC ID.")
    ("cidr_block" "cidr_block - (Required, Forces new resource) The CIDR block for the switch.")
    ("name" "name - (Optional) The name of the switch. Defaults to null.")
    ("description" "description - (Optional) The switch description. Defaults to null.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_route_entry" '(
    ("router_id" "router_id - (Deprecated) This argument has beeb deprecated. Please use other arguments to launch a custom route entry.")
    ("route_table_id" "route_table_id - (Required, Forces new resource) The ID of the route table.")
    ("destination_cidrblock" "destination_cidrblock - (Required, Forces new resource) The RouteEntry's target network segment.")
    ("nexthop_type" "nexthop_type - (Required, Forces new resource) The next hop type. Available value is Instance and RouterInterface. Instance points to ECS Instance.")
    ("nexthop_id" "nexthop_id - (Required, Forces new resource) The route entry's next hop. ECS instance ID or VPC router interface ID.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_nat_gateway" '(
    ("vpc_id" "vpc_id - (Required, Forces New Resorce) The VPC ID.")
    ("spec" "spec - (Deprecated) It has been deprecated from provider version 1.7.1, and new field 'specification' can replace it.")
    ("specification" "specification - (Optional) The specification of the nat gateway. Valid values are Small, Middle and Large. Default to Small. Details refer to Nat Gateway Specification.")
    ("name" "name - (Optional) Name of the nat gateway. The value can have a string of 2 to 128 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin or end with a hyphen, and must not begin with http:// or https://. Defaults to null.")
    ("description" "description - (Optional) Description of the nat gateway, This description can have a string of 2 to 256 characters, It cannot begin with http:// or https://. Defaults to null.")
    ("bandwidth_packages" "bandwidth_packages - (Deprecated) It has been deprecated from provider version 1.7.1. Resource 'alicloud_eip_association' can bind several elastic IPs for one Nat Gateway.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_router_interface" '(
    ("opposite_region" "opposite_region - (Required, Force New) The Region of peer side. At present, optional value: cn-beijing, cn-hangzhou, cn-shanghai, cn-shenzhen, cn-hongkong, ap-southeast-1, us-east-1, us-west-1.")
    ("router_type" "router_type - (Required, Forces New) Router Type. Optional value: VRouter, VBR.")
    ("opposite_router_type" "opposite_router_type - (Optional, Force New) Peer router type. Optional value: VRouter, VBR. Default to VRouter.")
    ("router_id" "router_id - (Required, Force New) Router ID. When router_type is VBR, the VBR specified by the router_id must be in the access point specified by access_point_id.")
    ("opposite_router_id" "opposite_router_id - (Optional) Peer router ID. When opposite_router_type is VBR, the opposite_router_id must be in the access point specified by opposite_access_point_id.")
    ("role" "role - (Required, Force New) The role the router interface plays. Optional value: InitiatingSide, AcceptingSide.")
    ("specification" "specification - (Optional) Specification of router interfaces. If role is AcceptingSide, the value can be ignore or must be Negative. For more about the specification, refer to Router interface specification.")
    ("access_point_id" "access_point_id - (Optional, Force New) Access point ID. Required when router_type is VBR. Prohibited when router_type is VRouter.")
    ("opposite_access_point_id" "opposite_access_point_id - (Optional, Force New) Access point ID of peer side. Required when opposite_router_type is VBR. Prohibited when opposite_router_type is VRouter.")
    ("opposite_interface_id" "opposite_interface_id - (Optional) Peer router interface ID.")
    ("opposite_interface_owner_id" "opposite_interface_owner_id - (Optional) Peer account ID. Log on to the Alibaba Cloud console, select User Info > Account Management to check your account ID.")
    ("name" "name - (Optional) Name of the router interface. Length must be 2-80 characters long. Only Chinese characters, English letters, numbers, period (.), underline (_), or dash (-) are permitted.                                                 If it is not specified, the default value is interface ID. The name cannot start with http:// and https://.")
    ("description" "description - (Optional) Description of the router interface. It can be 2-256 characters long or left blank. It cannot start with http:// and https://.")
    ("health_check_source_ip" "health_check_source_ip - (Optional) Used as the Packet Source IP of health check for disaster recovery or ECMP. It is only valid when router_type is VRouter and opposite_router_type is VBR. The IP must be an unused IP in the local VPC. It and health_check_target_ip must be specified at the same time.")
    ("health_check_target_ip" "health_check_target_ip - (Optional) Used as the Packet Target IP of health check for disaster recovery or ECMP. It is only valid when router_type is VRouter and opposite_router_type is VBR. The IP must be an unused IP in the local VPC. It and health_check_source_ip must be specified at the same time.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_forward_entry" '(
    ("forward_table_id" "forward_table_id - (Required, Forces new resource) The value can get from alicloud_nat_gateway Attributes \"forward_table_ids\".")
    ("external_ip" "external_ip - (Required, Forces new resource) The external ip address, the ip must along bandwidth package public ip which alicloud_nat_gateway argument bandwidth_packages.")
    ("external_port" "external_port - (Required) The external port, valid value is 1~65535|any.")
    ("ip_protocol" "ip_protocol - (Required) The ip protocal, valid value is tcp|udp|any.")
    ("internal_ip" "internal_ip - (Required) The internal ip, must a private ip.")
    ("internal_port" "internal_port - (Required) The internal port, valid value is 1~65535|any.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_snat_entry" '(
    ("snat_table_id" "snat_table_id - (Required, Forces new resource) The value can get from alicloud_nat_gateway Attributes \"snat_table_ids\".")
    ("source_vswitch_id" "source_vswitch_id - (Required, Forces new resource) The vswitch ID.")
    ("snat_ip" "snat_ip - (Required) The SNAT ip address, the ip must along bandwidth package public ip which alicloud_nat_gateway argument bandwidth_packages.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_db_account" '(
    ("instance_id" "instance_id - (Required) The Id of instance in which account belongs.")
    ("name" "name - (Required) Operation account requiring a uniqueness check. It may consist of lower case letters, numbers, and underlines, and must start with a letter and have no more than 16 characters.")
    ("password" "password - (Required) Operation password. It may consist of letters, digits, or underlines, with a length of 6 to 32 characters.")
    ("description" "description - (Optional) Database description. It cannot begin with https://. It must start with a Chinese character or English letter. It can include Chinese and English characters, underlines (_), hyphens (-), and numbers. The length may be 2-256 characters.")
    ("type" "type - Privilege type of account.  Normal: Common privilege.  Super: High privilege.   Default to Normal. It is is valid for MySQL 5.5/5.6 only.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_db_account_privilege" '(
    ("instance_id" "instance_id - (Required) The Id of instance in which account belongs.")
    ("account_name" "account_name - (Required) A specified account name.")
    ("privilege" "privilege - The privilege of one account access database. Valid values: [\"ReadOnly\", \"ReadWrite\"]. Default to \"ReadOnly\".")
    ("db_names" "db_names - (Optional) List of specified database name.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_db_backup_policy" '(
    ("instance_id" "instance_id - (Required) The Id of instance that can run database.")
    ("backup_period" "backup_period - (Optional) DB Instance backup period. Valid values: [Monday, Tuesday, Wednesday, Thursday, Friday, Saturday, Sunday]. Default to [\"Tuesday\", \"Thursday\", \"Saturday\"].")
    ("backup_time" "backup_time - (Optional) DB instance backup time, in the format of HH:mmZ- HH:mmZ. Time setting interval is one hour. Default to \"02:00Z-03:00Z\". China time is 8 hours behind it.")
    ("retention_period" "retention_period - (Optional) Instance backup retention days. Valid values: [7-730]. Default to 7.")
    ("log_backup" "log_backup - (Optional) Whether to backup instance log. Default to true.")
    ("log_retention_period" "log_retention_period - (Optional) Instance log backup retention days. Valid values: [7-730]. Default to 7. It can be larger than 'retention_period'.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_db_connection" '(
    ("instance_id" "instance_id - (Required) The Id of instance that can run database.")
    ("connection_prefix" "connection_prefix - (Optional) Prefix of an Internet connection string. It must be checked for uniqueness. It may consist of lowercase letters, numbers, and underlines, and must start with a letter and have no more than 30 characters. Default to  + 'tf'.")
    ("port" "port - (Optional) Internet connection port. Valid value: [3001-3999]. Default to 3306.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_db_database" '(
    ("instance_id" "instance_id - (Required) The Id of instance that can run database.")
    ("name" "name - (Required) Name of the database requiring a uniqueness check. It may consist of lower case letters, numbers, and underlines, and must start with a letter                   and have no more than 64 characters.")
    ("character_set" "character_set - (Required) Character set. The value range is limited to the following:  MySQL: [ utf8, gbk, latin1, utf8mb4 ] (included in versions 5.5 and 5.6).  SQLServer: [ Chinese_PRC_CI_AS, Chinese_PRC_CS_AS, SQL_Latin1_General_CP1_CI_AS, SQL_Latin1_General_CP1_CS_AS, Chinese_PRC_BIN ]")
    ("description" "description - (Optional) Database description. It cannot begin with https://. It must start with a Chinese character or English letter. It can include Chinese and English characters, underlines (_), hyphens (-), and numbers. The length may be 2-256 characters.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_db_instance" '(
    ("engine" "engine - (Required) Database type. Value options: MySQL, SQLServer, PostgreSQL, and PPAS.")
    ("engine_version" "engine_version - (Required) Database version. Value options:    5.5/5.6/5.7 for MySQL  2008r2/2012 for SQLServer  9.4 for PostgreSQL  9.3 for PPAS")
    ("db_instance_class" "db_instance_class - (Deprecated) It has been deprecated from version 1.5.0 and use 'instance_type' to replace.")
    ("instance_type" "instance_type - (Required) DB Instance type. For details, see Instance type table.")
    ("db_instance_storage" "db_instance_storage - (Deprecated) It has been deprecated from version 1.5.0 and use 'instance_storage' to replace.")
    ("instance_storage" "instance_storage - (Required) User-defined DB instance storage space. Value range:  [5, 2000] for MySQL/PostgreSQL/PPAS HA dual node edition;  [20,1000] for MySQL 5.7 basic single node edition;  [10, 2000] for SQL Server 2008R2;  [20,2000] for SQL Server 2012 basic single node edition Increase progressively at a rate of 5 GB. For details, see Instance type table.")
    ("instance_name" "instance_name - (Optional) The name of DB instance. It a string of 2 to 256 characters.")
    ("instance_charge_type" "instance_charge_type - (Optional) Valid values are Prepaid, Postpaid, Default to Postpaid.")
    ("period" "period - (Optional) The duration that you will buy DB instance (in month). It is valid when instance_charge_type is PrePaid. Valid values: [1~9], 12, 24, 36. Default to 1.")
    ("zone_id" "zone_id - (Optional) The Zone to launch the DB instance. From version 1.8.1, it supports multiple zone. If it is a multi-zone and vswitch_id is specified, the vswitch must in the one of them. The multiple zone ID can be retrieved by setting multi to \"true\" in the data source alicloud_zones.")
    ("multi_az" "multi_az - (Optional) It has been deprecated from version 1.8.1, and zone_id can support multiple zone.")
    ("db_instance_net_type" "db_instance_net_type - (Deprecated) It has been deprecated from version 1.5.0. If you want to set public connection, please use new resource alicloud_db_connection. Default to Intranet.")
    ("allocate_public_connection" "allocate_public_connection - (Deprecated) It has been deprecated from version 1.5.0. If you want to allocate public connection string, please use new resource alicloud_db_connection.")
    ("instance_network_type" "instance_network_type - (Deprecated) It has been deprecated from version 1.5.0. If you want to create instances in VPC network, this parameter must be set.")
    ("vswitch_id" "vswitch_id - (Optional) The virtual switch ID to launch DB instances in one VPC.")
    ("master_user_name" "master_user_name - (Deprecated) It has been deprecated from version 1.5.0. New resource alicloud_db_account field 'name' replaces it.")
    ("master_user_password" "master_user_password  - (Deprecated) It has been deprecated from version 1.5.0. New resource alicloud_db_account field 'password' replaces it.")
    ("preferred_backup_period" "preferred_backup_period  - (Deprecated) It has been deprecated from version 1.5.0. New resource alicloud_db_backup_policy field 'backup_period' replaces it.")
    ("preferred_backup_time" "preferred_backup_time - (Deprecated) It has been deprecated from version 1.5.0. New resource alicloud_db_backup_policy field 'backup_time' replaces it.")
    ("backup_retention_period" "backup_retention_period - (Deprecated) It has been deprecated from version 1.5.0. New resource alicloud_db_backup_policy field 'retention_period' replaces it.")
    ("security_ips" "security_ips - (Optional) List of IP addresses allowed to access all databases of an instance. The list contains up to 1,000 IP addresses, separated by commas. Supported formats include 0.0.0.0/0, 10.23.12.24 (IP), and 10.23.12.24/24 (Classless Inter-Domain Routing (CIDR) mode. /24 represents the length of the prefix in an IP address. The range of the prefix length is [1,32]).")
    ("db_mappings" "db_mappings - (Deprecated) It has been deprecated from version 1.5.0. New resource alicloud_db_database replaces it.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ess_attachment" '(
    ("scaling_group_id" "scaling_group_id - (Required) ID of the scaling group of a scaling configuration.")
    ("instance_ids" "instance_ids - (Required) ID of the ECS instance to be attached to the scaling group. You can input up to 20 IDs.")
    ("force" "force - (Optional) Whether to remove forcibly \"AutoCreated\" ECS instances in order to release scaling group capacity \"MaxSize\" for attaching ECS instances. Default to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ess_scaling_group" '(
    ("min_size" "min_size - (Required) Minimum number of ECS instances in the scaling group. Value range: [0, 100].")
    ("max_size" "max_size - (Required) Maximum number of ECS instances in the scaling group. Value range: [0, 100].")
    ("scaling_group_name" "scaling_group_name - (Optional) Name shown for the scaling group, which must contain 2-40 characters (English or Chinese). If this parameter is not specified, the default value is ScalingGroupId.")
    ("default_cooldown" "default_cooldown - (Optional) Default cool-down time (in seconds) of the scaling group. Value range: [0, 86400]. The default value is 300s.")
    ("vswitch_id" "vswitch_id - (Deprecated) It has been deprecated from version 1.7.1 and new field 'vswitch_ids' replaces it.")
    ("vswitch_ids" "vswitch_ids - (Optional) List of virtual switch IDs in which the ecs instances to be launched.")
    ("removal_policies" "removal_policies - (Optional) RemovalPolicy is used to select the ECS instances you want to remove from the scaling group when multiple candidates for removal exist. Optional values:   OldestInstance: removes the first ECS instance attached to the scaling group.  NewestInstance: removes the first ECS instance attached to the scaling group.  OldestScalingConfiguration: removes the ECS instance with the oldest scaling configuration.  Default values: OldestScalingConfiguration and OldestInstance. You can enter up to two removal policies.")
    ("db_instance_ids" "db_instance_ids - (Optional) If an RDS instance is specified in the scaling group, the scaling group automatically attaches the Intranet IP addresses of its ECS instances to the RDS access whitelist.   The specified RDS instance must be in running status.  The specified RDS instance’s whitelist must have room for more IP addresses.")
    ("loadbalancer_ids" "loadbalancer_ids - (Optional) If a Server Load Balancer instance is specified in the scaling group, the scaling group automatically attaches its ECS instances to the Server Load Balancer instance.   The Server Load Balancer instance must be enabled.  At least one listener must be configured for each Server Load Balancer and it HealthCheck must be on. Otherwise, creation will failed.  The Server Load Balancer instance attached with VPC-type ECS instances cannot be attached to the scaling group.  The default weight of an ECS instance attached to the Server Load Balancer instance is 50.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ess_scaling_configuration" '(
    ("scaling_group_id" "scaling_group_id - (Required) ID of the scaling group of a scaling configuration.")
    ("image_id" "image_id - (Required) ID of an image file, indicating the image resource selected when an instance is enabled.")
    ("instance_type" "instance_type - (Required) Resource type of an ECS instance.")
    ("instance_name" "instance_name - (Optional) Name of an ECS instance. Default to \"ESS-Instance\". It is valid from version 1.7.1.")
    ("io_optimized" "io_optimized - (Deprecated) It has been deprecated on instance resource. All the launched alicloud instances will be I/O optimized.")
    ("is_outdated" "is_outdated - (Optional) Whether to use outdated instance type. Default to false.")
    ("security_group_id" "security_group_id - (Required) ID of the security group to which a newly created instance belongs.")
    ("scaling_configuration_name" "scaling_configuration_name - (Optional) Name shown for the scheduled task. If this parameter value is not specified, the default value is ScalingConfigurationId.")
    ("internet_charge_type" "internet_charge_type - (Optional) Network billing type, Values: PayByBandwidth or PayByTraffic. Default to PayByBandwidth.")
    ("internet_max_bandwidth_in" "internet_max_bandwidth_in - (Optional) Maximum incoming bandwidth from the public network, measured in Mbps (Mega bit per second). The value range is [1,200].")
    ("internet_max_bandwidth_out" "internet_max_bandwidth_out - (Optional) Maximum outgoing bandwidth from the public network, measured in Mbps (Mega bit per second). The value range for PayByBandwidth is [0,100].")
    ("system_disk_category" "system_disk_category - (Optional) Category of the system disk. The parameter value options are cloud_efficiency, cloud_ssd and cloud. cloud only is used to some no I/O optimized instance. Default to cloud_efficiency.")
    ("enable" "enable - (Optional) Whether enable the specified scaling group(make it active) to which the current scaling configuration belongs.")
    ("active" "active - (Optional) Whether active current scaling configuration in the specified scaling group. Default to false.")
    ("substitute" "substitute - (Optional) The another scaling configuration which will be active automatically and replace current configuration when setting active to 'false'. It is invalid when active is 'true'")
    ("user_data" "user_data - (Optional) User-defined data to customize the startup behaviors of the ECS instance and to pass data into the ECS instance.")
    ("key_name" "key_name - (Optional) The name of key pair that can login ECS instance successfully without password. If it is specified, the password would be invalid.")
    ("role_name" "role_name - (Optional) Instance RAM role name. The name is provided and maintained by RAM. You can use alicloud_ram_role to create a new one.")
    ("force_delete" "force_delete - (Optional) The last scaling configuration will be deleted forcibly with deleting its scaling group. Default to false.")
    ("data_disk" "data_disk - (Optional) DataDisk mappings to attach to ecs instance. See Block datadisk below for details.")
    ("instance_ids" "instance_ids - (Deprecated) It has been deprecated from version 1.6.0. New resource alicloud_ess_attachment replaces it.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource. It will be applied for ECS instances finally.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ess_scaling_rule" '(
    ("scaling_group_id" "scaling_group_id - (Required) ID of the scaling group of a scaling rule.")
    ("adjustment_type" "adjustment_type - (Required) Adjustment mode of a scaling rule. Optional values:   QuantityChangeInCapacity: It is used to increase or decrease a specified number of ECS instances.  PercentChangeInCapacity: It is used to increase or decrease a specified proportion of ECS instances.  TotalCapacity: It is used to adjust the quantity of ECS instances in the current scaling group to a specified value.")
    ("adjustment_value" "adjustment_value - (Required) Adjusted value of a scaling rule. Value range:   QuantityChangeInCapacity：(0, 100] U (-100, 0]  PercentChangeInCapacity：[0, 10000] U [-10000, 0]  TotalCapacity：[0, 100]")
    ("scaling_rule_name" "scaling_rule_name - (Optional) Name shown for the scaling rule, which is a string containing 2 to 40 English or Chinese characters.")
    ("cooldown" "cooldown - (Optional) Cool-down time of a scaling rule. Value range: [0, 86,400], in seconds. The default value is empty.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ess_schedule" '(
    ("scheduled_action" "scheduled_action - (Required) Operations performed when the scheduled task is triggered. Fill in the unique identifier of the scaling rule.")
    ("launch_time" "launch_time - (Required) Operations performed when the scheduled task is triggered. Fill in the unique identifier of the scaling rule.")
    ("scheduled_task_name" "scheduled_task_name - (Optional) Display name of the scheduled task, which must be 2-40 characters (English or Chinese) long.")
    ("description" "description - (Optional) Description of the scheduled task, which is 2-200 characters (English or Chinese) long.")
    ("launch_expiration_time" "launch_expiration_time - (Optional) Time period within which the failed scheduled task is retried. The default value is 600s. Value range: [0, 21600]")
    ("recurrence_type" "recurrence_type - (Optional) Type of the scheduled task to be repeated. RecurrenceType, RecurrenceValue and RecurrenceEndTime must be specified. Optional values:   Daily: Recurrence interval by day for a scheduled task.  Weekly: Recurrence interval by week for a scheduled task.  Monthly: Recurrence interval by month for a scheduled task.")
    ("recurrence_value" "recurrence_value - (Optional) Value of the scheduled task to be repeated. RecurrenceType, RecurrenceValue and RecurrenceEndTime must be specified.   Daily: Only one value in the range [1,31] can be filled.  Weekly: Multiple values can be filled. The values of Sunday to Saturday are 0 to 6 in sequence. Multiple values shall be separated by a comma “,”.  Monthly: In the format of A-B. The value range of A and B is 1 to 31, and the B value must be greater than the A value.")
    ("recurrence_end_time" "recurrence_end_time - (Optional) End time of the scheduled task to be repeated. The date format follows the ISO8601 standard and uses UTC time. It is in the format of YYYY-MM-DDThh:mmZ. A time point 90 days after creation or modification cannot be entered. RecurrenceType, RecurrenceValue and RecurrenceEndTime must be specified.")
    ("task_enabled" "task_enabled - (Optional) Whether to enable the scheduled task. The default value is true.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_oss_bucket" '(
    ("bucket" "bucket - (Optional, Forces New Resorce) The name of the bucket. If omitted, Terraform will assign a random and unique name.")
    ("acl" "acl - (Optional) The canned ACL to apply. Defaults to \"private\".")
    ("core_rule" "core_rule - (Optional) A rule of Cross-Origin Resource Sharing (documented below). The items of core rule are no more than 10 for every OSS bucket.")
    ("website" "website - (Optional) A website object(documented below).")
    ("logging" "logging - (Optional) A Settings of bucket logging (documented below).")
    ("logging_isenable" "logging_isenable - (Optional) The flag of using logging enable container. Defaults true.")
    ("referer_config" "referer_config - (Optional) The configuration of referer (documented below).")
    ("lifecycle_rule" "lifecycle_rule - (Optional) A configuration of object lifecycle management (documented below).")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_oss_bucket_object" '(
    ("bucket" "bucket - (Required) The name of the bucket to put the file in.")
    ("key" "key - (Required) The name of the object once it is in the bucket.")
    ("source" "source - (Required) The path to the source file being uploaded to the bucket.")
    ("content" "content - (Required unless source given) The literal content being uploaded to the bucket.")
    ("acl" "acl - (Optional) The canned ACL to apply. Defaults to \"private\".")
    ("content_type" "content_type - (Optional) A standard MIME type describing the format of the object data, e.g. application/octet-stream. All Valid MIME Types are valid for this input.")
    ("cache_control" "cache_control - (Optional) Specifies caching behavior along the request/reply chain. Read RFC2616 Cache-Control for further details.")
    ("content_disposition" "content_disposition - (Optional) Specifies presentational information for the object. Read RFC2616 Content-Disposition for further details.")
    ("content_encoding" "content_encoding - (Optional) Specifies what content encodings have been applied to the object and thus what decoding mechanisms must be applied to obtain the media-type referenced by the Content-Type header field. Read RFC2616 Content-Encoding for further details.")
    ("content_md5" "content_md5 - (Optional) The MD5 value of the content. Read MD5 for computing method.")
    ("expires" "expires - (Optional) Specifies expire date for the the request/response. Read RFC2616 Expires for further details.")
    ("server_side_encryption" "server_side_encryption - (Optional) Specifies server-side encryption of the object in OSS. At present, it valid value is \"AES256\".")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_container_cluster" '(

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_cs_application" '(
    ("cluster_name" "cluster_name - (Required, Force new resource) The swarm cluster's name.")
    ("name" "name - (Required, Force new resource) The application name. It should be 1-64 characters long, and can contain numbers, English letters and hyphens, but cannot start with hyphens.")
    ("description" "description - The description of application.")
    ("version" "version - The application deploying version. Each updating, it must be different with current. Default to \"1.0\"")
    ("template" "template - The application deployment template and it must be Docker Compose format.")
    ("environment" "environment - A key/value map used to replace the variable parameter in the Compose template.")
    ("latest_image" "latest_image - Whether to use latest docker image while each updating application. Default to false.")
    ("blue_green" "blue_green - Wherther to use \"Blue Green\" method when release a new version. Default to false.")
    ("blue_green_confirm" "blue_green_confirm - Whether to confirm a \"Blue Green\" application. Default to false. It will be ignored when blue_green is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_cs_swarm" '(
    ("name" "name - The container cluster's name. It is the only in one Alicloud account.")
    ("name_prefix" "name_prefix - The container cluster name's prefix. It is conflict with name. If it is specified, terraform will using it to build the only cluster name. Default to 'Terraform-Creation'.")
    ("size" "size - Field 'size' has been deprecated from provider version 1.9.1. New field 'node_number' replaces it.")
    ("node_number" "node_number - The ECS node number of the container cluster. Its value choices are 1~50, and default to 1.")
    ("cidr_block" "cidr_block - (Required, Force new resource) The CIDR block for the Container. It can not be same as the CIDR used by the VPC. Valid value:   192.168.0.0/16  172.19-30.0.0/16  10.0.0.0/16")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_cs_kubernetes" '(
    ("name" "name - The kubernetes cluster's name. It is the only in one Alicloud account.")
    ("name_prefix" "name_prefix - The kubernetes cluster name's prefix. It is conflict with name. If it is specified, terraform will using it to build the only cluster name. Default to \"Terraform-Creation\".")
    ("availability_zone" "availability_zone - (Force new resource) The Zone where new kubernetes cluster will be located. If it is not be specified, the value will be vswitch's zone.")
    ("vswitch_id" "vswitch_id - (Force new resource) The vswitch where new kubernetes cluster will be located. If it is not specified, a new VPC and VSwicth will be built. It must be in the zone which availability_zone specified.")
    ("new_nat_gateway" "new_nat_gateway - (Force new resource) Whether to create a new nat gateway while creating kubernetes cluster. Default to true.")
    ("master_instance_type" "master_instance_type - (Required, Force new resource) The instance type of master node.")
    ("worker_instance_type" "worker_instance_type - (Required, Force new resource) The instance type of worker node.")
    ("worker_number" "worker_number - The worker node number of the kubernetes cluster. Its valid value range [1~50]. Default to 3.")
    ("password" "password - (Required, Force new resource) The password of ssh login cluster node.")
    ("pod_cidr" "pod_cidr - (Required, Force new resource) The CIDR block for the pod network. It will be allocated automatically when vswitch_id is not specified. It cannot be duplicated with the VPC CIDR and CIDR used by Kubernetes cluster in VPC, cannot be modified after creation. Maximum number of hosts allowed in the cluster: 256. Refer to Plan Kubernetes CIDR blocks under VPC.")
    ("service_cidr" "service_cidr - (Required, Force new resource) The CIDR block for the service network.  It will be allocated automatically when vswitch_id is not specified. It cannot be duplicated with the VPC CIDR and CIDR used by Kubernetes cluster in VPC, cannot be modified after creation.")
    ("enable_ssh" "enable_ssh - (Force new resource) Whether to allow to SSH login kubernetes. Default to false.")
    ("master_disk_category" "master_disk_category - (Force new resource) The system disk category of master node. Its valid value are cloud_ssd and cloud_efficiency. Default to cloud_efficiency.")
    ("master_disk_size" "master_disk_size - (Force new resource) The system disk size of master node. Its valid value range [20~32768] in GB. Default to 20.")
    ("worker_disk_category" "worker_disk_category - (Force new resource) The system disk category of worker node. Its valid value are cloud_ssd and cloud_efficiency. Default to cloud_efficiency.")
    ("worker_disk_size" "worker_disk_size - (Force new resource) The system disk size of worker node. Its valid value range [20~32768] in GB. Default to 20.")
    ("install_cloud_monitor" "install_cloud_monitor - (Force new resource) Whether to install cloud monitor for the kubernetes' node.")
    ("is_outdated" "is_outdated - (Optional) Whether to use outdated instance type. Default to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_cms_alarm" '(
    ("name" "name - (Required) The alarm rule name.")
    ("project" "project - (Required, ForceNew) Monitor project name, such as \"acs_ecs_dashboard\" and \"acs_rds_dashboard\". For more information, see Metrics Reference.")
    ("metric" "metric - (Required, ForceNew) Name of the monitoring metrics corresponding to a project, such as \"CPUUtilization\" and \"networkin_rate\". For more information, see Metrics Reference.")
    ("dimensions" "dimensions - (Required, ForceNew) Map of the resources associated with the alarm rule, such as \"instanceId\", \"device\" and \"port\". Each key's value is a string and it uses comma to split multiple items. For more information, see Metrics Reference.")
    ("period" "period - Index query cycle, which must be consistent with that defined for metrics. Default to 300, in seconds.")
    ("statistics" "statistics - Statistical method. It must be consistent with that defined for metrics. Valid values: [\"Average\", \"Minimum\", \"Maximum\"]. Default to \"Average\".")
    ("operator" "operator - Alarm comparison operator. Valid values: [\"<=\", \"<\", \">\", \">=\", \"==\", \"!=\"]. Default to \"==\".")
    ("threshold" "threshold - (Required) Alarm threshold value, which must be a numeric value currently.")
    ("triggered_count" "triggered_count - Number of consecutive times it has been detected that the values exceed the threshold. Default to 3.")
    ("contact_groups" "contact_groups - (Required) List contact groups of the alarm rule, which must have been created on the console.")
    ("start_time" "start_time - Start time of the alarm effective period. Default to 0 and it indicates the time 00:00. Valid value range: [0, 24].")
    ("end_time" "end_time - End time of the alarm effective period. Default value 24 and it indicates the time 24:00. Valid value range: [0, 24].")
    ("silence_time" "silence_time - Notification silence period in the alarm state, in seconds. Valid value range: [300, 86400]. Default to 86400")
    ("notify_type" "notify_type - Notification type. Valid value [0, 1]. The value 0 indicates TradeManager+email, and the value 1 indicates that TradeManager+email+SMS")
    ("enabled" "enabled - Whether to enable alarm rule. Default to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_dns" '(
    ("name" "name - (Required) Name of the domain. This name without suffix can have a string of 1 to 63 characters, must contain only alphanumeric characters or \"-\", and must not begin or end with \"-\", and \"-\" must not in the 3th and 4th character positions at the same time. Suffix .sh and .tel are not supported.")
    ("group_id" "group_id - (Optional) Id of the group in which the domain will add. If not supplied, then use default group.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_dns_group" '(
    ("name" "name - (Required) Name of the domain group.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_dns_record" '(
    ("name" "name - (Required) Name of the domain. This name without suffix can have a string of 1 to 63 characters, must contain only alphanumeric characters or \"-\", and must not begin or end with \"-\", and \"-\" must not in the 3th and 4th character positions at the same time. Suffix .sh and .tel are not supported.")
    ("host_record" "host_record - (Required) Host record for the domain record. This host_record can have at most 253 characters, and each part split with \".\" can have at most 63 characters, and must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"*\",\"@\",  and must not begin or end with \"-\".")
    ("type" "type - (Required) The type of domain record. Valid values are A,NS,MX,TXT,CNAME,SRV,AAAA,REDIRECT_URL and FORWORD_URL.")
    ("value" "value - (Required) The value of domain record.")
    ("ttl" "ttl - (Optional) The effective time of domain record. Its scope depends on the edition of the cloud resolution. Free is [600, 86400], Basic is [120, 86400], Standard is [60, 86400], Ultimate is [10, 86400], Exclusive is [1, 86400]. Default value is 600.")
    ("priority" "priority - (Optional) The priority of domain record. Valid values are [1-10]. When the type is MX, this parameter is required.")
    ("routing" "routing - (Optional) The parsing line of domain record. Valid values are default, telecom, unicom, mobile, oversea and edu. When the type is FORWORD_URL, this parameter must be default. Default value is default.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_access_key" '(
    ("user_name" "user_name - (Required, Forces new resource) Name of the RAM user. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin with a hyphen.")
    ("secret_file" "secret_file - (Optional, Forces new resource) The name of file that can save access key id and access key secret. Strongly suggest you to specified it when you creating access key, otherwise, you wouldn't get its secret ever.")
    ("status" "status - (Optional) Status of access key. It must be Active or Inactive. Default value is Active.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_account_alias" '(
    ("account_alias" "account_alias - (Required, Forces new resource) Alias of cloud account. This name can have a string of 3 to 32 characters, must contain only alphanumeric characters or hyphens, such as \"-\", and must not begin with a hyphen.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_alias" '(

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_group" '(
    ("name" "name - (Required) Name of the RAM group. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("comments" "comments - (Optional) Comment of the RAM group. This parameter can have a string of 1 to 128 characters.")
    ("force" "force - (Optional) This parameter is used for resource destroy. Default value is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_group_membership" '(
    ("group_name" "group_name - (Required, Forces new resource) Name of the RAM group. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("user_names" "user_names - (Required) Set of user name which will be added to group. Each name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin with a hyphen.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_group_policy_attachment" '(
    ("group_name" "group_name - (Required, Forces new resource) Name of the RAM group. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("policy_name" "policy_name - (Required, Forces new resource) Name of the RAM policy. This name can have a string of 1 to 128 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("policy_type" "policy_type - (Required, Forces new resource) Type of the RAM policy. It must be Custom or System.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_login_profile" '(
    ("user_name" "user_name - (Required, Forces new resource) Name of the RAM user. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin with a hyphen.")
    ("password" "password - (Required) Password of the RAM user.")
    ("mfa_bind_required" "mfa_bind_required - (Optional) This parameter indicates whether the MFA needs to be bind when the user first logs in. Default value is false.")
    ("password_reset_required" "password_reset_required - (Optional) This parameter indicates whether the password needs to be reset when the user first logs in. Default value is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_policy" '(
    ("name" "name - (Required, Forces new resource) Name of the RAM policy. This name can have a string of 1 to 128 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("statement" "statement - (Optional,  Type: list, Conflicts with document) Statements of the RAM policy document. It is required when the document is not specified.   resource - (Required, Type: list) List of specific objects which will be authorized. The format of each item in this list is acs:${service}:${region}:${account_id}:${relative_id}, such as acs:ecs:*:*:instance/inst-002 and acs:oss:*:1234567890000:mybucket. The ${service} can be ecs, oss, ots and so on, the ${region} is the region info which can use * replace when it is not supplied, the ${account_id} refers to someone's Alicloud account id or you can use * to replace, the ${relative_id} is the resource description section which related to the ${service}.  action - (Required, Type: list) List of operations for the resource. The format of each item in this list is ${service}:${action_name}, such as oss:ListBuckets and ecs:Describe*. The ${service} can be ecs, oss, ots and so on, the ${action_name} refers to the name of an api interface which related to the ${service}.  effect - (Required) This parameter indicates whether or not the action is allowed. Valid values are Allow and Deny.")
    ("version" "version - (Optional, Conflicts with document) Version of the RAM policy document. Valid value is 1. Default value is 1.")
    ("document" "document - (Optional, Conflicts with statement and version) Document of the RAM policy. It is required when the statement is not specified.")
    ("description" "description - (Optional, Forces new resource) Description of the RAM policy. This name can have a string of 1 to 1024 characters.")
    ("force" "force - (Optional) This parameter is used for resource destroy. Default value is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_role" '(
    ("name" "name - (Required, Forces new resource) Name of the RAM role. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\", \"_\", and must not begin with a hyphen.")
    ("services" "services - (Optional, Type: list, Conflicts with document) List of services which can assume the RAM role. The format of each item in this list is ${service}.aliyuncs.com or ${account_id}@${service}.aliyuncs.com, such as ecs.aliyuncs.com and 1234567890000@ots.aliyuncs.com. The ${service} can be ecs, log, apigateway and so on, the ${account_id} refers to someone's Alicloud account id.")
    ("ram_users" "ram_users - (Optional, Type: list, Conflicts with document) List of ram users who can assume the RAM role. The format of each item in this list is acs:ram::${account_id}:root or acs:ram::${account_id}:user/${user_name}, such as acs:ram::1234567890000:root and acs:ram::1234567890001:user/Mary. The ${user_name} is the name of a RAM user which must exists in the Alicloud account indicated by the ${account_id}.")
    ("version" "version - (Optional, Conflicts with document) Version of the RAM role policy document. Valid value is 1. Default value is 1.")
    ("document" "document - (Optional, Conflicts with services, ram_users and version) Authorization strategy of the RAM role. It is required when the services and ram_users are not specified.")
    ("description" "description - (Optional, Forces new resource) Description of the RAM role. This name can have a string of 1 to 1024 characters.")
    ("force" "force - (Optional) This parameter is used for resource destroy. Default value is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_role_policy_attachment" '(
    ("role_name" "role_name - (Required, Forces new resource) Name of the RAM Role. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\", \"_\", and must not begin with a hyphen.")
    ("policy_name" "policy_name - (Required, Forces new resource) Name of the RAM policy. This name can have a string of 1 to 128 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("policy_type" "policy_type - (Required, Forces new resource) Type of the RAM policy. It must be Custom or System.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_user" '(
    ("name" "name - (Required) Name of the RAM user. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin with a hyphen.")
    ("display_name" "display_name - (Optional) Name of the RAM user which for display. This name can have a string of 1 to 12 characters or Chinese characters, must contain only alphanumeric characters or Chinese characters or hyphens, such as \"-\",\".\", and must not end with a hyphen.")
    ("mobile" "mobile - (Optional) Phone number of the RAM user. This number must contain an international area code prefix, just look like this: 86-18600008888.")
    ("email" "email - (Optional) Email of the RAM user.")
    ("comments" "comments - (Optional) Comment of the RAM user. This parameter can have a string of 1 to 128 characters.")
    ("force" "force - (Optional) This parameter is used for resource destroy. Default value is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_user_policy_attachment" '(
    ("user_name" "user_name - (Required, Forces new resource) Name of the RAM user. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\",\".\",\"_\", and must not begin with a hyphen.")
    ("policy_name" "policy_name - (Required, Forces new resource) Name of the RAM policy. This name can have a string of 1 to 128 characters, must contain only alphanumeric characters or hyphen \"-\", and must not begin with a hyphen.")
    ("policy_type" "policy_type - (Required, Forces new resource) Type of the RAM policy. It must be Custom or System.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ram_role_attachment" '(
    ("role_name" "role_name - (Required, Forces new resource) The name of role used to bind. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as \"-\", \"_\", and must not begin with a hyphen.")
    ("instance_ids" "instance_ids - (Required, Forces new resource) The list of ECS instance's IDs.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_cdn_domain" '(
    ("domain_name" "domain_name - (Required) Name of the accelerated domain. This name without suffix can have a string of 1 to 63 characters, must contain only alphanumeric characters or \"-\", and must not begin or end with \"-\", and \"-\" must not in the 3th and 4th character positions at the same time. Suffix .sh and .tel are not supported.")
    ("cdn_type" "cdn_type - (Required) Cdn type of the accelerated domain. Valid values are web, download, video, liveStream.")
    ("source_type" "source_type - (Optional) Source type of the accelerated domain. Valid values are ipaddr, domain, oss. You must set this parameter when cdn_type value is not liveStream.")
    ("source_port" "source_port - (Optional) Source port of the accelerated domain. Valid values are 80 and 443. Default value is 80. You must use 80 when the source_type is oss.")
    ("sources" "sources - (Optional, Type: list) Sources of the accelerated domain. It's a list of domain names or IP address and consists of at most 20 items. You must set this parameter when cdn_type value is not liveStream.")
    ("scope" "scope - (Optional) Scope of the accelerated domain. Valid values are domestic, overseas, global. Default value is domestic. This parameter's setting is valid Only for the international users and domestic L3 and above users .")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_kms_key" '(
    ("description" "description - (Optional) The description of the key as viewed in Alicloud console. Default to \"From Terraform\".")
    ("key_usage" "key_usage - (Optional) Specifies the usage of CMK. Currently, default to 'ENCRYPT/DECRYPT', indicating that CMK is used for encryption and decryption.")
    ("deletion_window_in_days" "deletion_window_in_days - (Optional) Duration in days after which the key is deleted after destruction of the resource, must be between 7 and 30 days. Defaults to 30 days.")
    ("is_enabled" "is_enabled - (Optional) Specifies whether the key is enabled. Defaults to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_ots_table" '(
    ("table_name" "table_name - (Required, ForceNew) The table name of the OTS instance. If changed, a new table would be created.")
    ("primary_key" "primary_key - (Required, Type: List) The property of TableMeta which indicates the structure information of a table. It describes the attribute value of primary key. The number of primary_key should not be less than one and not be more than four.   name - (Required) Name for primary key.  type - (Required, Type: list) Type for primary key. Only Integer, String or Binary is allowed.")
    ("time_to_live" "time_to_live - (Required) The retention time of data stored in this table (unit: second).")
    ("max_version" "max_version - (Required) The maximum number of versions stored in this table.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_acm_certificate" '(
    ("domain_name" "domain_name - (Required) A domain name for which the certificate should be issued")
    ("subject_alternative_names" "subject_alternative_names - (Optional) A list of domains that should be SANs in the issued certificate")
    ("validation_method" "validation_method - (Required) Which method to use for validation. DNS or EMAIL are valid, NONE can be used for certificates that were imported into ACM and then into Terraform.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_acm_certificate_validation" '(
    ("certificate_arn" "certificate_arn - (Required) The ARN of the certificate that is being validated.")
    ("validation_record_fqdns" "validation_record_fqdns - (Optional) List of FQDNs that implement the validation. Only valid for DNS validation method ACM certificates. If this is set, the resource can implement additional sanity checks and has an explicit dependency on the resource that is implementing the validation")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_acmpca_certificate_authority" '(
    ("certificate_authority_configuration" "certificate_authority_configuration - (Required) Nested argument containing algorithms and certificate subject information. Defined below.")
    ("enabled" "enabled - (Optional) Whether the certificate authority is enabled or disabled. Defaults to true.")
    ("revocation_configuration" "revocation_configuration - (Optional) Nested argument containing revocation configuration. Defined below.")
    ("tags" "tags - (Optional) Specifies a key-value map of user-defined tags that are attached to the certificate authority.")
    ("type" "type - (Optional) The type of the certificate authority. Currently, this must be SUBORDINATE.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_account" '(
    ("cloudwatch_role_arn" "cloudwatch_role_arn - (Optional) The ARN of an IAM role for CloudWatch (to allow logging & monitoring). See more in AWS Docs. Logging & monitoring can be enabled/disabled and otherwise tuned on the API Gateway Stage level.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_api_key" '(
    ("name" "name - (Required) The name of the API key")
    ("description" "description - (Optional) The API key description. Defaults to \"Managed by Terraform\".")
    ("enabled" "enabled - (Optional) Specifies whether the API key can be used by callers. Defaults to true.")
    ("value" "value - (Optional) The value of the API key. If not specified, it will be automatically generated by AWS on creation.")
    ("stage_key" "stage_key - (Optional) A list of stage keys associated with the API key - see below")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_authorizer" '(
    ("authorizer_uri" "authorizer_uri - (Optional, required for type TOKEN/REQUEST) The authorizer's Uniform Resource Identifier (URI). This must be a well-formed Lambda function URI in the form of arn:aws:apigateway:{region}:lambda:path/{service_api}, e.g. arn:aws:apigateway:us-west-2:lambda:path/2015-03-31/functions/arn:aws:lambda:us-west-2:012345678912:function:my-function/invocations")
    ("name" "name - (Required) The name of the authorizer")
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("identity_source" "identity_source - (Optional) The source of the identity in an incoming request. Defaults to method.request.header.Authorization. For REQUEST type, this may be a comma-separated list of values, including headers, query string parameters and stage variables - e.g. \"method.request.header.SomeHeaderName,method.request.querystring.SomeQueryStringName,stageVariables.SomeStageVariableName\"")
    ("type" "type - (Optional) The type of the authorizer. Possible values are TOKEN for a Lambda function using a single authorization token submitted in a custom header, REQUEST for a Lambda function using incoming request parameters, or COGNITO_USER_POOLS for using an Amazon Cognito user pool. Defaults to TOKEN.")
    ("authorizer_credentials" "authorizer_credentials - (Optional) The credentials required for the authorizer. To specify an IAM Role for API Gateway to assume, use the IAM Role ARN.")
    ("authorizer_result_ttl_in_seconds" "authorizer_result_ttl_in_seconds - (Optional) The TTL of cached authorizer results in seconds. Defaults to 300.")
    ("identity_validation_expression" "identity_validation_expression - (Optional) A validation expression for the incoming identity. For TOKEN type, this value should be a regular expression. The incoming token from the client is matched against this expression, and will proceed if the token matches. If the token doesn't match, the client receives a 401 Unauthorized response.")
    ("provider_arns" "provider_arns - (Optional, required for type COGNITO_USER_POOLS) A list of the Amazon Cognito user pool ARNs. Each element is of this format: arn:aws:cognito-idp:{region}:{account_id}:userpool/{user_pool_id}.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_base_path_mapping" '(
    ("domain_name" "domain_name - (Required) The already-registered domain name to connect the API to.")
    ("api_id" "api_id - (Required) The id of the API to connect.")
    ("stage_name" "stage_name - (Optional) The name of a specific deployment stage to expose at the given path. If omitted, callers may select any stage by including its name as a path element after the base path.")
    ("base_path" "base_path - (Optional) Path segment that must be prepended to the path when accessing the API via this mapping. If omitted, the API is exposed at the root of the given domain.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_client_certificate" '(
    ("description" "description - (Optional) The description of the client certificate.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_deployment" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("stage_name" "stage_name - (Required) The name of the stage")
    ("description" "description - (Optional) The description of the deployment")
    ("stage_description" "stage_description - (Optional) The description of the stage")
    ("variables" "variables - (Optional) A map that defines variables for the stage")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_documentation_part" '(
    ("location" "location - (Required) The location of the targeted API entity of the to-be-created documentation part. See below.")
    ("properties" "properties - (Required) A content map of API-specific key-value pairs describing the targeted API entity. The map must be encoded as a JSON string, e.g., \"{ \\\"description\\\": \\\"The API does ...\\\" }\". Only Swagger-compliant key-value pairs can be exported and, hence, published.")
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated Rest API")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_documentation_version" '(
    ("version" "version - (Required) The version identifier of the API documentation snapshot.")
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated Rest API")
    ("description" "description - (Optional) The description of the API documentation version.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_domain_name" '(
    ("domain_name" "domain_name - (Required) The fully-qualified domain name to register")
    ("certificate_name" "certificate_name - (Optional) The unique name to use when registering this cert as an IAM server certificate. Conflicts with certificate_arn. Required if certificate_arn is not set.")
    ("certificate_body" "certificate_body - (Optional) The certificate issued for the domain name being registered, in PEM format. Conflicts with certificate_arn.")
    ("certificate_chain" "certificate_chain - (Optional) The certificate for the CA that issued the certificate, along with any intermediate CA certificates required to create an unbroken chain to a certificate trusted by the intended API clients. Conflicts with certificate_arn.")
    ("certificate_private_key" "certificate_private_key - (Optional) The private key associated with the domain certificate given in certificate_body. Conflicts with certificate_arn.")
    ("certificate_arn" "certificate_arn - (Optional) The ARN for an AWS-managed certificate. Conflicts with certificate_name, certificate_body, certificate_chain and certificate_private_key.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_gateway_response" '(
    ("rest_api_id" "rest_api_id - (Required) The string identifier of the associated REST API.")
    ("response_type" "response_type - (Required) The response type of the associated GatewayResponse.")
    ("status_code" "status_code - (Optional) The HTTP status code of the Gateway Response.")
    ("response_parameters" "response_parameters - (Optional) A map specifying the templates used to transform the response body.")
    ("response_templates" "response_templates - (Optional) A map specifying the parameters (paths, query strings and headers) of the Gateway Response.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_integration" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API.")
    ("resource_id" "resource_id - (Required) The API resource ID.")
    ("http_method" "http_method - (Required) The HTTP method (GET, POST, PUT, DELETE, HEAD, OPTION, ANY) when calling the associated resource.")
    ("integration_http_method" "integration_http_method - (Optional) The integration HTTP method (GET, POST, PUT, DELETE, HEAD, OPTION) specifying how API Gateway will interact with the back end. Required if type is AWS, AWS_PROXY, HTTP or HTTP_PROXY. Not all methods are compatible with all AWS integrations. e.g. Lambda function can only be invoked via POST.")
    ("type" "type - (Required) The integration input's type. Valid values are HTTP (for HTTP backends), MOCK (not calling any real backend), AWS (for AWS services), AWS_PROXY (for Lambda proxy integration) and HTTP_PROXY (for HTTP proxy integration). An HTTP or HTTP_PROXY integration with a connection_type of VPC_LINK is referred to as a private integration and uses a VpcLink to connect API Gateway to a network load balancer of a VPC.")
    ("connection_type" "connection_type - (Optional) The integration input's connectionType. Valid values are INTERNET (default for connections through the public routable internet), and VPC_LINK (for private connections between API Gateway and a network load balancer in a VPC).")
    ("connection_id" "connection_id - (Optional) The id of the VpcLink used for the integration. Required if connection_type is VPC_LINK")
    ("uri" "uri - (Optional) The input's URI (HTTP, AWS). Required if type is HTTP or AWS. For HTTP integrations, the URI must be a fully formed, encoded HTTP(S) URL according to the RFC-3986 specification . For AWS integrations, the URI should be of the form arn:aws:apigateway:{region}:{subdomain.service|service}:{path|action}/{service_api}. region, subdomain and service are used to determine the right endpoint. e.g. arn:aws:apigateway:eu-west-1:lambda:path/2015-03-31/functions/arn:aws:lambda:eu-west-1:012345678901:function:my-func/invocations")
    ("credentials" "credentials - (Optional) The credentials required for the integration. For AWS integrations, 2 options are available. To specify an IAM Role for Amazon API Gateway to assume, use the role's ARN. To require that the caller's identity be passed through from the request, specify the string arn:aws:iam::\\*:user/\\*.")
    ("request_templates" "request_templates - (Optional) A map of the integration's request templates.")
    ("request_parameters" "request_parameters - (Optional) A map of request query string parameters and headers that should be passed to the backend responder. For example: request_parameters = { \"integration.request.header.X-Some-Other-Header\" = \"method.request.header.X-Some-Header\" }")
    ("passthrough_behavior" "passthrough_behavior - (Optional) The integration passthrough behavior (WHEN_NO_MATCH, WHEN_NO_TEMPLATES, NEVER).  Required if request_templates is used.")
    ("cache_key_parameters" "cache_key_parameters - (Optional) A list of cache key parameters for the integration.")
    ("cache_namespace" "cache_namespace - (Optional) The integration's cache namespace.")
    ("request_parameters_in_json" "request_parameters_in_json - Deprecated, use request_parameters instead.")
    ("content_handling" "content_handling - (Optional) Specifies how to handle request payload content type conversions. Supported values are CONVERT_TO_BINARY and CONVERT_TO_TEXT. If this property is not defined, the request payload will be passed through from the method request to integration request without modification, provided that the passthroughBehaviors is configured to support payload pass-through.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_integration_response" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("resource_id" "resource_id - (Required) The API resource ID")
    ("http_method" "http_method - (Required) The HTTP method (GET, POST, PUT, DELETE, HEAD, OPTIONS, ANY)")
    ("status_code" "status_code - (Required) The HTTP status code")
    ("selection_pattern" "selection_pattern - (Optional) Specifies the regular expression pattern used to choose an integration response based on the response from the backend. Setting this to - makes the integration the default one. If the backend is an AWS Lambda function, the AWS Lambda function error header is matched. For all other HTTP and AWS backends, the HTTP status code is matched.")
    ("response_templates" "response_templates - (Optional) A map specifying the templates used to transform the integration response body")
    ("response_parameters" "response_parameters - (Optional) A map of response parameters that can be read from the backend response. For example: response_parameters = { \"method.response.header.X-Some-Header\" = \"integration.response.header.X-Some-Other-Header\" },")
    ("response_parameters_in_json" "response_parameters_in_json - Deprecated, use response_parameters instead.")
    ("content_handling" "content_handling - (Optional) Specifies how to handle request payload content type conversions. Supported values are CONVERT_TO_BINARY and CONVERT_TO_TEXT. If this property is not defined, the response payload will be passed through from the integration response to the method response without modification.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_method" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("resource_id" "resource_id - (Required) The API resource ID")
    ("http_method" "http_method - (Required) The HTTP Method (GET, POST, PUT, DELETE, HEAD, OPTIONS, ANY)")
    ("authorization" "authorization - (Required) The type of authorization used for the method (NONE, CUSTOM, AWS_IAM)")
    ("authorizer_id" "authorizer_id - (Optional) The authorizer id to be used when the authorization is CUSTOM")
    ("api_key_required" "api_key_required - (Optional) Specify if the method requires an API key")
    ("request_models" "request_models - (Optional) A map of the API models used for the request's content type where key is the content type (e.g. application/json) and value is either Error, Empty (built-in models) or aws_api_gateway_model's name.")
    ("request_validator_id" "request_validator_id - (Optional) The ID of a aws_api_gateway_request_validator")
    ("request_parameters" "request_parameters - (Optional) A map of request query string parameters and headers that should be passed to the integration. For example: hcl request_parameters = { \"method.request.header.X-Some-Header\" = true, \"method.request.querystring.some-query-param\"  = true, }  would define that the header X-Some-Header and the query string some-query-param must be provided on the request, or")
    ("request_parameters_in_json" "request_parameters_in_json - Deprecated, use request_parameters instead.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_method_response" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("resource_id" "resource_id - (Required) The API resource ID")
    ("http_method" "http_method - (Required) The HTTP Method (GET, POST, PUT, DELETE, HEAD, OPTIONS, ANY)")
    ("status_code" "status_code - (Required) The HTTP status code")
    ("response_models" "response_models - (Optional) A map of the API models used for the response's content type")
    ("response_parameters" "response_parameters - (Optional) A map of response parameters that can be sent to the caller. For example: response_parameters = { \"method.response.header.X-Some-Header\" = true } would define that the header X-Some-Header can be provided on the response.")
    ("response_parameters_in_json" "response_parameters_in_json - Deprecated, use response_parameters instead.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_method_settings" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the REST API")
    ("stage_name" "stage_name - (Required) The name of the stage")
    ("method_path" "method_path - (Required) Method path defined as {resource_path}/{http_method} for an individual method override, or */* for overriding all methods in the stage.")
    ("settings" "settings - (Required) The settings block, see below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_model" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("name" "name - (Required) The name of the model")
    ("description" "description - (Optional) The description of the model")
    ("content_type" "content_type - (Required) The content type of the model")
    ("schema" "schema - (Required) The schema of the model in a JSON form")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_resource" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("parent_id" "parent_id - (Required) The ID of the parent API resource")
    ("path_part" "path_part - (Required) The last path segment of this API resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_rest_api" '(
    ("name" "name - (Required) The name of the REST API")
    ("description" "description - (Optional) The description of the REST API")
    ("binary_media_types" "binary_media_types - (Optional) The list of binary media types supported by the RestApi. By default, the RestApi supports only UTF-8-encoded text payloads.")
    ("minimum_compression_size" "minimum_compression_size - (Optional) Minimum response size to compress for the REST API. Integer between -1 and 10485760 (10MB). Setting a value greater than -1 will enable compression, -1 disables compression (default).")
    ("body" "body - (Optional) An OpenAPI specification that defines the set of routes and integrations to create as part of the REST API.")
    ("policy" "policy - (Optional) JSON formatted policy document that controls access to the API Gateway")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_stage" '(
    ("rest_api_id" "rest_api_id - (Required) The ID of the associated REST API")
    ("stage_name" "stage_name - (Required) The name of the stage")
    ("deployment_id" "deployment_id - (Required) The ID of the deployment that the stage points to")
    ("access_log_settings" "access_log_settings - (Optional) Enables access logs for the API stage. Detailed below.")
    ("cache_cluster_enabled" "cache_cluster_enabled - (Optional) Specifies whether a cache cluster is enabled for the stage")
    ("cache_cluster_size" "cache_cluster_size - (Optional) The size of the cache cluster for the stage, if enabled. Allowed values include 0.5, 1.6, 6.1, 13.5, 28.4, 58.2, 118 and 237.")
    ("client_certificate_id" "client_certificate_id - (Optional) The identifier of a client certificate for the stage.")
    ("description" "description - (Optional) The description of the stage")
    ("documentation_version" "documentation_version - (Optional) The version of the associated API documentation")
    ("variables" "variables - (Optional) A map that defines the stage variables")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_usage_plan" '(
    ("name" "name - (Required) The name of the usage plan.")
    ("description" "description - (Optional) The description of a usage plan.")
    ("api_stages" "api_stages - (Optional) The associated API stages of the usage plan.")
    ("quota_settings" "quota_settings - (Optional) The quota settings of the usage plan.")
    ("throttle_settings" "throttle_settings - (Optional) The throttling limits of the usage plan.")
    ("product_code" "product_code - (Optional) The AWS Markeplace product identifier to associate with the usage plan as a SaaS product on AWS Marketplace.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_usage_plan_key" '(
    ("key_id" "key_id - (Required) The identifier of the API key resource.")
    ("key_type" "key_type - (Required) The type of the API key resource. Currently, the valid key type is API_KEY.")
    ("usage_plan_id" "usage_plan_id - (Required) The Id of the usage plan resource representing to associate the key to.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_api_gateway_vpc_link" '(
    ("name" "name - (Required) The name used to label and identify the VPC link.")
    ("description" "description - (Optional) The description of the VPC link.")
    ("target_arns" "target_arns - (Required, ForceNew) The list of network load balancer arns in the VPC targeted by the VPC link. Currently AWS only supports 1 target.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_appautoscaling_policy" '(
    ("name" "name - (Required) The name of the policy.")
    ("policy_type" "policy_type - (Optional) For DynamoDB, only TargetTrackingScaling is supported. For Amazon ECS, Spot Fleet, and Amazon RDS, both StepScaling and TargetTrackingScaling are supported. For any other service, only StepScaling is supported. Defaults to StepScaling.")
    ("resource_id" "resource_id - (Required) The resource type and unique identifier string for the resource associated with the scaling policy. Documentation can be found in the ResourceId parameter at: AWS Application Auto Scaling API Reference")
    ("scalable_dimension" "scalable_dimension - (Required) The scalable dimension of the scalable target. Documentation can be found in the ScalableDimension parameter at: AWS Application Auto Scaling API Reference")
    ("service_namespace" "service_namespace - (Required) The AWS service namespace of the scalable target. Documentation can be found in the ServiceNamespace parameter at: AWS Application Auto Scaling API Reference")
    ("step_scaling_policy_configuration" "step_scaling_policy_configuration - (Optional) Step scaling policy configuration, requires policy_type = \"StepScaling\" (default). See supported fields below.")
    ("target_tracking_scaling_policy_configuration" "target_tracking_scaling_policy_configuration - (Optional) A target tracking policy, requires policy_type = \"TargetTrackingScaling\". See supported fields below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_appautoscaling_scheduled_action" '(
    ("name" "name - (Required) The name of the scheduled action.")
    ("service_namespace" "service_namespace - (Required) The namespace of the AWS service. Documentation can be found in the parameter at: AWS Application Auto Scaling API Reference Example: ecs")
    ("resource_id" "resource_id - (Required) The identifier of the resource associated with the scheduled action. Documentation can be found in the parameter at: AWS Application Auto Scaling API Reference")
    ("scalable_dimension" "scalable_dimension - (Optional) The scalable dimension. Documentation can be found in the parameter at: AWS Application Auto Scaling API Reference Example: ecs:service:DesiredCount")
    ("scalable_target_action" "scalable_target_action - (Optional) The new minimum and maximum capacity. You can set both values or just one. See below")
    ("schedule" "schedule - (Optional) The schedule for this action. The following formats are supported: At expressions - at(yyyy-mm-ddThh:mm:ss), Rate expressions - rate(valueunit), Cron expressions - cron(fields). In UTC. Documentation can be found in the parameter at: AWS Application Auto Scaling API Reference")
    ("start_time" "start_time - (Optional) The date and time for the scheduled action to start. Specify the following format: 2006-01-02T15:04:05Z")
    ("end_time" "end_time - (Optional) The date and time for the scheduled action to end. Specify the following format: 2006-01-02T15:04:05Z")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_appautoscaling_target" '(
    ("max_capacity" "max_capacity - (Required) The max capacity of the scalable target.")
    ("min_capacity" "min_capacity - (Required) The min capacity of the scalable target.")
    ("resource_id" "resource_id - (Required) The resource type and unique identifier string for the resource associated with the scaling policy. Documentation can be found in the ResourceId parameter at: AWS Application Auto Scaling API Reference")
    ("role_arn" "role_arn - (Optional) The ARN of the IAM role that allows Application AutoScaling to modify your scalable target on your behalf.")
    ("scalable_dimension" "scalable_dimension - (Required) The scalable dimension of the scalable target. Documentation can be found in the ScalableDimension parameter at: AWS Application Auto Scaling API Reference")
    ("service_namespace" "service_namespace - (Required) The AWS service namespace of the scalable target. Documentation can be found in the ServiceNamespace parameter at: AWS Application Auto Scaling API Reference")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_appsync_datasource" '(
    ("api_id" "api_id - (Required) The API ID for the GraphQL API for the DataSource.")
    ("name" "name - (Required) A user-supplied name for the DataSource.")
    ("type" "type - (Required) The type of the DataSource. Valid values: AWS_LAMBDA, AMAZON_DYNAMODB and AMAZON_ELASTICSEARCH")
    ("description" "description - (Optional) A description of the DataSource.")
    ("service_role_arn" "service_role_arn - (Optional) The IAM service role ARN for the data source.")
    ("dynamodb_config" "dynamodb_config - (Optional) DynamoDB settings. See below")
    ("elasticsearch_config" "elasticsearch_config - (Optional) Amazon Elasticsearch settings. See below")
    ("lambda_config" "lambda_config - (Optional) AWS Lambda settings. See below")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_appsync_graphql_api" '(
    ("name" "name - (Required) A user-supplied name for the GraphqlApi.")
    ("authentication_type" "authentication_type - (Required) The authentication type. Valid values: API_KEY, AWS_IAM and AMAZON_COGNITO_USER_POOLS")
    ("user_pool_config" "user_pool_config - (Optional) The Amazon Cognito User Pool configuration. See below")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_athena_database" '(
    ("name" "name - (Required) Name of the database to create.")
    ("bucket" "bucket - (Required) Name of s3 bucket to save the results of the query execution.")
    ("force_destroy" "force_destroy - (Optional, Default: false) A boolean that indicates all tables should be deleted from the database so that the database can be destroyed without error. The tables are not recoverable.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_athena_named_query" '(
    ("name" "name - (Required) The plain language name for the query. Maximum length of 128.")
    ("database" "database - (Required) The database to which the query belongs.")
    ("query" "query - (Required) The text of the query itself. In other words, all query statements. Maximum length of 262144.")
    ("description" "description - (Optional) A brief explanation of the query. Maximum length of 1024.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_batch_compute_environment" '(
    ("compute_environment_name" "compute_environment_name - (Required) The name for your compute environment. Up to 128 letters (uppercase and lowercase), numbers, and underscores are allowed.")
    ("compute_resources" "compute_resources - (Optional) Details of the compute resources managed by the compute environment. This parameter is required for managed compute environments. See details below.")
    ("service_role" "service_role - (Required) The full Amazon Resource Name (ARN) of the IAM role that allows AWS Batch to make calls to other AWS services on your behalf.")
    ("state" "state - (Optional) The state of the compute environment. If the state is ENABLED, then the compute environment accepts jobs from a queue and can scale out automatically based on queues. Valid items are ENABLED or DISABLED. Defaults to ENABLED.")
    ("type" "type - (Required) The type of the compute environment. Valid items are MANAGED or UNMANAGED.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_batch_job_definition" '(
    ("name" "name - (Required) Specifies the name of the job definition.")
    ("container_properties" "container_properties - (Optional) A valid container properties provided as a single valid JSON document. This parameter is required if the type parameter is container.")
    ("parameters" "parameters - (Optional) Specifies the parameter substitution placeholders to set in the job definition.")
    ("retry_strategy" "retry_strategy - (Optional) Specifies the retry strategy to use for failed jobs that are submitted with this job definition. Maximum number of retry_strategy is 1.  Defined below.")
    ("timeout" "timeout - (Optional) Specifies the timeout for jobs so that if a job runs longer, AWS Batch terminates the job. Maximum number of timeout is 1. Defined below.")
    ("type" "type - (Required) The type of job definition.  Must be container")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_batch_job_queue" '(
    ("name" "name - (Required) Specifies the name of the job queue.")
    ("compute_environments" "compute_environments - (Required) Specifies the set of compute environments mapped to a job queue and their order.  The position of the compute environments in the list will dictate the order. You can associate up to 3 compute environments with a job queue.")
    ("priority" "priority - (Required) The priority of the job queue. Job queues with a higher priority are evaluated first when associated with the same compute environment.")
    ("state" "state - (Required) The state of the job queue. Must be one of: ENABLED or DISABLED")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloud9_environment_ec2" '(
    ("name" "name - (Required) The name of the environment.")
    ("instance_type" "instance_type - (Required) The type of instance to connect to the environment, e.g. t2.micro.")
    ("automatic_stop_time_minutes" "automatic_stop_time_minutes - (Optional) The number of minutes until the running instance is shut down after the environment has last been used.")
    ("description" "description - (Optional) The description of the environment.")
    ("owner_arn" "owner_arn - (Optional) The ARN of the environment owner. This can be ARN of any AWS IAM principal. Defaults to the environment's creator.")
    ("subnet_id" "subnet_id - (Optional) The ID of the subnet in Amazon VPC that AWS Cloud9 will use to communicate with the Amazon EC2 instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_budgets_budget" '(
    ("account_id" "account_id - (Optional) The ID of the target account for budget. Will use current user's account_id by default if omitted.")
    ("name" "name - (Optional) The name of a budget. Unique within accounts.")
    ("name_prefix" "name_prefix - (Optional) The prefix of the name of a budget. Unique within accounts.")
    ("budget_type" "budget_type - (Required) Whether this budget tracks monetary cost or usage.")
    ("cost_filters" "cost_filters - (Optional) Map of CostFilters key/value pairs to apply to the budget.")
    ("cost_types" "cost_types - (Optional) Object containing CostTypes The types of cost included in a budget, such as tax and subscriptions..")
    ("limit_amount" "limit_amount - (Required) The amount of cost or usage being measured for a budget.")
    ("limit_unit" "limit_unit - (Required) The unit of measurement used for the budget forecast, actual spend, or budget threshold, such as dollars or GB. See Spend  documentation.")
    ("time_period_end" "time_period_end - (Optional) The end of the time period covered by the budget. There are no restrictions on the end date. Format: 2017-01-01_12:00.")
    ("time_period_start" "time_period_start - (Required) The start of the time period covered by the budget. The start date must come before the end date. Format: 2017-01-01_12:00.")
    ("time_unit" "time_unit - (Required) The length of time until a budget resets the actual and forecasted spend. Valid values: MONTHLY, QUARTERLY, ANNUALLY.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudformation_stack" '(
    ("name" "name - (Required) Stack name.")
    ("template_body" "template_body - (Optional) Structure containing the template body (max size: 51,200 bytes).")
    ("template_url" "template_url - (Optional) Location of a file containing the template body (max size: 460,800 bytes).")
    ("capabilities" "capabilities - (Optional) A list of capabilities. Valid values: CAPABILITY_IAM or CAPABILITY_NAMED_IAM")
    ("disable_rollback" "disable_rollback - (Optional) Set to true to disable rollback of the stack if stack creation failed. Conflicts with on_failure.")
    ("notification_arns" "notification_arns - (Optional) A list of SNS topic ARNs to publish stack related events.")
    ("on_failure" "on_failure - (Optional) Action to be taken if stack creation fails. This must be one of: DO_NOTHING, ROLLBACK, or DELETE. Conflicts with disable_rollback.")
    ("parameters" "parameters - (Optional) A list of Parameter structures that specify input parameters for the stack.")
    ("policy_body" "policy_body - (Optional) Structure containing the stack policy body. Conflicts w/ policy_url.")
    ("policy_url" "policy_url - (Optional) Location of a file containing the stack policy. Conflicts w/ policy_body.")
    ("tags" "tags - (Optional) A list of tags to associate with this stack.")
    ("iam_role_arn" "iam_role_arn - (Optional) The ARN of an IAM role that AWS CloudFormation assumes to create the stack. If you don't specify a value, AWS CloudFormation uses the role that was previously associated with the stack. If no role is available, AWS CloudFormation uses a temporary session that is generated from your user credentials.")
    ("timeout_in_minutes" "timeout_in_minutes - (Optional) The amount of time that can pass before the stack status becomes CREATE_FAILED.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudfront_distribution" '(
    ("aliases" "aliases (Optional) - Extra CNAMEs (alternate domain names), if any, for this distribution.")
    ("cache_behavior" "cache_behavior (Optional) - Deprecated, use ordered_cache_behavior instead.")
    ("ordered_cache_behavior" "ordered_cache_behavior (Optional) - An ordered list of cache behaviors resource for this distribution. List from top to bottom     in order of precedence. The topmost cache behavior will have precedence 0.")
    ("comment" "comment (Optional) - Any comments you want to include about the distribution.")
    ("custom_error_response" "custom_error_response (Optional) - One or more custom error response elements (multiples allowed).")
    ("default_cache_behavior" "default_cache_behavior (Required) - The default cache behavior for this distribution (maximum one).")
    ("default_root_object" "default_root_object (Optional) - The object that you want CloudFront to return (for example, index.html) when an end user requests the root URL.")
    ("enabled" "enabled (Required) - Whether the distribution is enabled to accept end user requests for content.")
    ("is_ipv6_enabled" "is_ipv6_enabled (Optional) - Whether the IPv6 is enabled for the distribution.")
    ("http_version" "http_version (Optional) - The maximum HTTP version to support on the distribution. Allowed values are http1.1 and http2. The default is http2.")
    ("logging_config" "logging_config (Optional) - The logging configuration that controls how logs are written to your distribution (maximum one).")
    ("origin" "origin (Required) - One or more origins for this distribution (multiples allowed).")
    ("price_class" "price_class (Optional) - The price class for this distribution. One of PriceClass_All, PriceClass_200, PriceClass_100")
    ("restrictions" "restrictions (Required) - The restriction configuration for this distribution (maximum one).")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("viewer_certificate" "viewer_certificate (Required) - The SSL configuration for this distribution (maximum one).")
    ("web_acl_id" "web_acl_id (Optional) - If you're using AWS WAF to filter CloudFront requests, the Id of the AWS WAF web ACL that is associated with the distribution.")
    ("retain_on_delete" "retain_on_delete (Optional) - Disables the distribution instead of deleting it when destroying the resource through Terraform. If this is set, the distribution needs to be deleted manually afterwards. Default: false.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudfront_origin_access_identity" '(
    ("comment" "comment (Optional) - An optional comment for the origin access identity.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudtrail" '(
    ("name" "name - (Required) Specifies the name of the trail.")
    ("s3_bucket_name" "s3_bucket_name - (Required) Specifies the name of the S3 bucket designated for publishing log files.")
    ("s3_key_prefix" "s3_key_prefix - (Optional) Specifies the S3 key prefix that precedes the name of the bucket you have designated for log file delivery.")
    ("cloud_watch_logs_role_arn" "cloud_watch_logs_role_arn - (Optional) Specifies the role for the CloudWatch Logs endpoint to assume to write to a user’s log group.")
    ("cloud_watch_logs_group_arn" "cloud_watch_logs_group_arn - (Optional) Specifies a log group name using an Amazon Resource Name (ARN), that represents the log group to which CloudTrail logs will be delivered.")
    ("enable_logging" "enable_logging - (Optional) Enables logging for the trail. Defaults to true. Setting this to false will pause logging.")
    ("include_global_service_events" "include_global_service_events - (Optional) Specifies whether the trail is publishing events from global services such as IAM to the log files. Defaults to true.")
    ("is_multi_region_trail" "is_multi_region_trail - (Optional) Specifies whether the trail is created in the current region or in all regions. Defaults to false.")
    ("sns_topic_name" "sns_topic_name - (Optional) Specifies the name of the Amazon SNS topic defined for notification of log file delivery.")
    ("enable_log_file_validation" "enable_log_file_validation - (Optional) Specifies whether log file integrity validation is enabled. Defaults to false.")
    ("kms_key_id" "kms_key_id - (Optional) Specifies the KMS key ARN to use to encrypt the logs delivered by CloudTrail.")
    ("event_selector" "event_selector - (Optional) Specifies an event selector for enabling data event logging. Fields documented below. Please note the CloudTrail limits when configuring these.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the trail")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_dashboard" '(
    ("dashboard_name" "dashboard_name - (Required) The name of the dashboard.")
    ("dashboard_body" "dashboard_body - (Required) The detailed information about the dashboard, including what widgets are included and their location on the dashboard. You can read more about the body structure in the documentation.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_event_permission" '(
    ("principal" "principal - (Required) The 12-digit AWS account ID that you are permitting to put events to your default event bus. Specify * to permit any account to put events to your default event bus.")
    ("statement_id" "statement_id - (Required) An identifier string for the external account that you are granting permissions to.")
    ("action" "action - (Optional) The action that you are enabling the other account to perform. Defaults to events:PutEvents.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_event_rule" '(
    ("name" "name - (Optional) The rule's name. By default generated by Terraform.")
    ("name_prefix" "name_prefix - (Optional) The rule's name. Conflicts with name.")
    ("schedule_expression" "schedule_expression - (Required, if event_pattern isn't specified) The scheduling expression. For example, cron(0 20 * * ? *) or rate(5 minutes).")
    ("event_pattern" "event_pattern - (Required, if schedule_expression isn't specified) Event pattern described a JSON object. See full documentation of CloudWatch Events and Event Patterns for details.")
    ("description" "description - (Optional) The description of the rule.")
    ("role_arn" "role_arn - (Optional) The Amazon Resource Name (ARN) associated with the role that is used for target invocation.")
    ("is_enabled" "is_enabled - (Optional) Whether the rule should be enabled (defaults to true).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_event_target" '(
    ("rule" "rule - (Required) The name of the rule you want to add targets to.")
    ("target_id" "target_id - (Optional) The unique target assignment ID.  If missing, will generate a random, unique id.")
    ("arn" "arn - (Required) The Amazon Resource Name (ARN) associated of the target.")
    ("input" "input - (Optional) Valid JSON text passed to the target.")
    ("input_path" "input_path - (Optional) The value of the JSONPath that is used for extracting part of the matched event when passing it to the target.")
    ("role_arn" "role_arn - (Optional) The Amazon Resource Name (ARN) of the IAM role to be used for this target when the rule is triggered. Required if ecs_target is used.")
    ("run_command_targets" "run_command_targets - (Optional) Parameters used when you are using the rule to invoke Amazon EC2 Run Command. Documented below. A maximum of 5 are allowed.")
    ("ecs_target" "ecs_target - (Optional) Parameters used when you are using the rule to invoke Amazon ECS Task. Documented below. A maximum of 1 are allowed.")
    ("batch_target" "batch_target - (Optional) Parameters used when you are using the rule to invoke an Amazon Batch Job. Documented below. A maximum of 1 are allowed.")
    ("kinesis_target" "kinesis_target - (Optional) Parameters used when you are using the rule to invoke an Amazon Kinesis Stream. Documented below. A maximum of 1 are allowed.")
    ("sqs_target" "sqs_target - (Optional) Parameters used when you are using the rule to invoke an Amazon SQS Queue. Documented below. A maximum of 1 are allowed.")
    ("input_transformer" "input_transformer - (Optional) Parameters used when you are providing a custom input to a target based on certain event data.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_destination" '(
    ("name" "name - (Required) A name for the log destination")
    ("role_arn" "role_arn - (Required) The ARN of an IAM role that grants Amazon CloudWatch Logs permissions to put data into the target")
    ("target_arn" "target_arn - (Required) The ARN of the target Amazon Kinesis stream or Amazon Lambda resource for the destination")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_destination_policy" '(
    ("destination_name" "destination_name - (Required) A name for the subscription filter")
    ("access_policy" "access_policy - (Required) The policy document. This is a JSON formatted string.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the log group. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("retention_in_days" "retention_in_days - (Optional) Specifies the number of days you want to retain log events in the specified log group.")
    ("kms_key_id" "kms_key_id - (Optional) The ARN of the KMS Key to use when encrypting log data. Please note, after the AWS KMS CMK is disassociated from the log group, AWS CloudWatch Logs stops encrypting newly ingested data for the log group. All previously ingested data remains encrypted, and AWS CloudWatch Logs requires permissions for the CMK whenever the encrypted data is requested.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_metric_filter" '(
    ("name" "name - (Required) A name for the metric filter.")
    ("pattern" "pattern - (Required) A valid CloudWatch Logs filter pattern for extracting metric data out of ingested log events.")
    ("log_group_name" "log_group_name - (Required) The name of the log group to associate the metric filter with.")
    ("metric_transformation" "metric_transformation - (Required) A block defining collection of information needed to define how metric data gets emitted. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_resource_policy" '(
    ("policy_document" "policy_document - (Required) Details of the resource policy, including the identity of the principal that is enabled to put logs to this account. This is formatted as a JSON string. Maximum length of 5120 characters.")
    ("policy_name" "policy_name - (Required) Name of the resource policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_stream" '(
    ("name" "name - (Required) The name of the log stream. Must not be longer than 512 characters and must not contain :")
    ("log_group_name" "log_group_name - (Required) The name of the log group under which the log stream is to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_log_subscription_filter" '(
    ("name" "name - (Required) A name for the subscription filter")
    ("destination_arn" "destination_arn - (Required) The ARN of the destination to deliver matching log events to. Kinesis stream or Lambda function ARN.")
    ("filter_pattern" "filter_pattern - (Required) A valid CloudWatch Logs filter pattern for subscribing to a filtered stream of log events.")
    ("log_group_name" "log_group_name - (Required) The name of the log group to associate the subscription filter with")
    ("role_arn" "role_arn - (Optional) The ARN of an IAM role that grants Amazon CloudWatch Logs permissions to deliver ingested log events to the destination. If you use Lambda as a destination, you should skip this argument and use aws_lambda_permission resource for granting access from CloudWatch logs to the destination Lambda function.")
    ("distribution" "distribution - (Optional) The method used to distribute log data to the destination. By default log data is grouped by log stream, but the grouping can be set to random for a more even distribution. This property is only applicable when the destination is an Amazon Kinesis stream. Valid values are \"Random\" and \"ByLogStream\".")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cloudwatch_metric_alarm" '(
    ("alarm_name" "alarm_name - (Required) The descriptive name for the alarm. This name must be unique within the user's AWS account")
    ("comparison_operator" "comparison_operator - (Required) The arithmetic operation to use when comparing the specified Statistic and Threshold. The specified Statistic value is used as the first operand. Either of the following is supported: GreaterThanOrEqualToThreshold, GreaterThanThreshold, LessThanThreshold, LessThanOrEqualToThreshold.")
    ("evaluation_periods" "evaluation_periods - (Required) The number of periods over which data is compared to the specified threshold.")
    ("metric_name" "metric_name - (Required) The name for the alarm's associated metric. See docs for supported metrics.")
    ("namespace" "namespace - (Required) The namespace for the alarm's associated metric. See docs for the list of namespaces. See docs for supported metrics.")
    ("period" "period - (Required) The period in seconds over which the specified statistic is applied.")
    ("statistic" "statistic - (Optional) The statistic to apply to the alarm's associated metric. Either of the following is supported: SampleCount, Average, Sum, Minimum, Maximum")
    ("threshold" "threshold - (Required) The value against which the specified statistic is compared.")
    ("actions_enabled" "actions_enabled - (Optional) Indicates whether or not actions should be executed during any changes to the alarm's state. Defaults to true.")
    ("alarm_actions" "alarm_actions - (Optional) The list of actions to execute when this alarm transitions into an ALARM state from any other state. Each action is specified as an Amazon Resource Number (ARN).")
    ("alarm_description" "alarm_description - (Optional) The description for the alarm.")
    ("datapoints_to_alarm" "datapoints_to_alarm - (Optional) The number of datapoints that must be breaching to trigger the alarm.")
    ("dimensions" "dimensions - (Optional) The dimensions for the alarm's associated metric.  For the list of available dimensions see the AWS documentation here.")
    ("insufficient_data_actions" "insufficient_data_actions - (Optional) The list of actions to execute when this alarm transitions into an INSUFFICIENT_DATA state from any other state. Each action is specified as an Amazon Resource Number (ARN).")
    ("ok_actions" "ok_actions - (Optional) The list of actions to execute when this alarm transitions into an OK state from any other state. Each action is specified as an Amazon Resource Number (ARN).")
    ("unit" "unit - (Optional) The unit for the alarm's associated metric.")
    ("extended_statistic" "extended_statistic - (Optional) The percentile statistic for the metric associated with the alarm. Specify a value between p0.0 and p100.")
    ("treat_missing_data" "treat_missing_data - (Optional) Sets how this alarm is to handle missing data points. The following values are supported: missing, ignore, breaching and notBreaching. Defaults to missing.")
    ("evaluate_low_sample_count_percentiles" "evaluate_low_sample_count_percentiles - (Optional) Used only for alarms based on percentiles. If you specify ignore, the alarm state will not change during periods with too few data points to be statistically significant. If you specify evaluate or omit this parameter, the alarm will always be evaluated and possibly change state no matter how many data points are available. The following values are supported: ignore, and evaluate.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codebuild_project" '(
    ("name" "name - (Required) The projects name.")
    ("description" "description - (Optional) A short description of the project.")
    ("encryption_key" "encryption_key - (Optional) The AWS Key Management Service (AWS KMS) customer master key (CMK) to be used for encrypting the build project's build output artifacts.")
    ("service_role" "service_role - (Optional) The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that enables AWS CodeBuild to interact with dependent AWS services on behalf of the AWS account.")
    ("build_timeout" "build_timeout - (Optional) How long in minutes, from 5 to 480 (8 hours), for AWS CodeBuild to wait until timing out any related build that does not get marked as completed. The default is 60 minutes.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("artifacts" "artifacts - (Required) Information about the project's build output artifacts. Artifact blocks are documented below.")
    ("cache" "cache - (Optional) Information about the cache storage for the project. Cache blocks are documented below.")
    ("environment" "environment - (Required) Information about the project's build environment. Environment blocks are documented below.")
    ("source" "source - (Required) Information about the project's input source code. Source blocks are documented below.")
    ("vpc_config" "vpc_config - (Optional) Configuration for the builds to run inside a VPC. VPC config blocks are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codecommit_repository" '(
    ("repository_name" "repository_name - (Required) The name for the repository. This needs to be less than 100 characters.")
    ("description" "description - (Optional) The description of the repository. This needs to be less than 1000 characters")
    ("default_branch" "default_branch - (Optional) The default branch of the repository. The branch specified here needs to exist.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codecommit_trigger" '(
    ("repository_name" "repository_name - (Required) The name for the repository. This needs to be less than 100 characters.")
    ("name" "name - (Required) The name of the trigger.")
    ("destination_arn" "destination_arn - (Required) The ARN of the resource that is the target for a trigger. For example, the ARN of a topic in Amazon Simple Notification Service (SNS).")
    ("custom_data" "custom_data - (Optional) Any custom data associated with the trigger that will be included in the information sent to the target of the trigger.")
    ("branches" "branches - (Optional) The branches that will be included in the trigger configuration. If no branches are specified, the trigger will apply to all branches.")
    ("events" "events - (Required) The repository events that will cause the trigger to run actions in another service, such as sending a notification through Amazon Simple Notification Service (SNS). If no events are specified, the trigger will run for all repository events. Event types include: all, updateReference, createReference, deleteReference.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codedeploy_app" '(
    ("name" "name - (Required) The name of the application.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codedeploy_deployment_config" '(
    ("deployment_config_name" "deployment_config_name - (Required) The name of the deployment config.")
    ("minimum_healthy_hosts" "minimum_healthy_hosts - (Optional) A minimum_healthy_hosts block. Minimum Healthy Hosts are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codedeploy_deployment_group" '(
    ("app_name" "app_name - (Required) The name of the application.")
    ("deployment_group_name" "deployment_group_name - (Required) The name of the deployment group.")
    ("service_role_arn" "service_role_arn - (Required) The service role ARN that allows deployments.")
    ("autoscaling_groups" "autoscaling_groups - (Optional) Autoscaling groups associated with the deployment group.")
    ("deployment_config_name" "deployment_config_name - (Optional) The name of the group's deployment config. The default is \"CodeDeployDefault.OneAtATime\".")
    ("ec2_tag_filter" "ec2_tag_filter - (Optional) Tag filters associated with the deployment group. See the AWS docs for details.")
    ("ec2_tag_set" "ec2_tag_set - (Optional) Sets of Tag filters associated with the deployment group, which are referred to as tag groups in the document.  See the AWS docs for details.")
    ("on_premises_instance_tag_filter" "on_premises_instance_tag_filter - (Optional) On premise tag filters associated with the group. See the AWS docs for details.")
    ("trigger_configuration" "trigger_configuration - (Optional) Trigger Configurations for the deployment group (documented below).")
    ("auto_rollback_configuration" "auto_rollback_configuration - (Optional) The automatic rollback configuration associated with the deployment group (documented below).")
    ("alarm_configuration" "alarm_configuration - (Optional) Information about alarms associated with the deployment group (documented below).")
    ("deployment_style" "deployment_style - (Optional) Information about the type of deployment, either in-place or blue/green, you want to run and whether to route deployment traffic behind a load balancer (documented below).")
    ("load_balancer_info" "load_balancer_info - (Optional) Information about the load balancer to use in a blue/green deployment (documented below).")
    ("blue_green_deployment_config" "blue_green_deployment_config - (Optional) Information about blue/green deployment options for a deployment group (documented below).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_codepipeline" '(
    ("name" "name - (Required) The name of the pipeline.")
    ("role_arn" "role_arn - (Required) A service role Amazon Resource Name (ARN) that grants AWS CodePipeline permission to make calls to AWS services on your behalf.")
    ("artifact_store" "artifact_store (Required) An artifact_store block. Artifact stores are documented below.")
    ("stage" "stage (Required) A stage block. Stages are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cognito_identity_pool" '(
    ("identity_pool_name" "identity_pool_name (Required) - The Cognito Identity Pool name.")
    ("allow_unauthenticated_identities" "allow_unauthenticated_identities (Required) - Whether the identity pool supports unauthenticated logins or not.")
    ("developer_provider_name" "developer_provider_name (Optional) - The \"domain\" by which Cognito will refer to your users. This name acts as a placeholder that allows your backend and the Cognito service to communicate about the developer provider.")
    ("cognito_identity_providers" "cognito_identity_providers (Optional) - An array of Amazon Cognito Identity user pools and their client IDs.")
    ("openid_connect_provider_arns" "openid_connect_provider_arns (Optional) - A list of OpendID Connect provider ARNs.")
    ("saml_provider_arns" "saml_provider_arns (Optional) - An array of Amazon Resource Names (ARNs) of the SAML provider for your identity.")
    ("supported_login_providers" "supported_login_providers (Optional) - Key-Value pairs mapping provider names to provider app IDs.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cognito_identity_pool_roles_attachment" '(
    ("identity_pool_id" "identity_pool_id (Required) - An identity pool ID in the format REGION:GUID.")
    ("role_mapping" "role_mapping (Optional) - A List of Role Mapping.")
    ("roles" "roles (Required) - The map of roles associated with this pool. For a given role, the key will be either \"authenticated\" or \"unauthenticated\" and the value will be the Role ARN.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cognito_user_group" '(
    ("name" "name - (Required) The name of the user group.")
    ("user_pool_id" "user_pool_id - (Required) The user pool ID.")
    ("description" "description - (Optional) The description of the user group.")
    ("precedence" "precedence - (Optional) The precedence of the user group.")
    ("role_arn" "role_arn - (Optional) The ARN of the IAM role to be associated with the user group.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cognito_user_pool" '(
    ("admin_create_user_config" "admin_create_user_config (Optional) - The configuration for AdminCreateUser requests.")
    ("alias_attributes" "alias_attributes - (Optional) Attributes supported as an alias for this user pool. Possible values: phone_number, email, or preferred_username. Conflicts with username_attributes.")
    ("auto_verified_attributes" "auto_verified_attributes - (Optional) The attributes to be auto-verified. Possible values: email, phone_number.")
    ("device_configuration" "device_configuration (Optional) - The configuration for the user pool's device tracking.")
    ("email_configuration" "email_configuration (Optional) - The Email Configuration.")
    ("name" "name - (Required) The name of the user pool.")
    ("email_verification_subject" "email_verification_subject - (Optional) A string representing the email verification subject. NOTE: - If email_verification_subject and verification_message_template.email_subject are specified and the values are different, either one is prioritized and updated.")
    ("email_verification_message" "email_verification_message - (Optional) A string representing the email verification message. Must contain the {####} placeholder. NOTE: - If email_verification_message and verification_message_template.email_message are specified and the values are different, either one is prioritized and updated.")
    ("lambda_config" "lambda_config (Optional) - A container for the AWS Lambda triggers associated with the user pool.")
    ("mfa_configuration" "mfa_configuration - (Optional, Default: OFF) Set to enable multi-factor authentication. Must be one of the following values (ON, OFF, OPTIONAL)")
    ("password_policy" "password_policy (Optional) - A container for information about the user pool password policy.")
    ("schema" "schema (Optional) - A container with the schema attributes of a user pool. Maximum of 50 attributes.")
    ("sms_authentication_message" "sms_authentication_message - (Optional) A string representing the SMS authentication message.")
    ("sms_configuration" "sms_configuration (Optional) - The SMS Configuration.")
    ("sms_verification_message" "sms_verification_message - (Optional) A string representing the SMS verification message.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the User Pool.")
    ("username_attributes" "username_attributes - (Optional) Specifies whether email addresses or phone numbers can be specified as usernames when a user signs up. Conflicts with alias_attributes.")
    ("verification_message_template" "verification_message_template (Optional) - The verification message templates configuration.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cognito_user_pool_client" '(
    ("allowed_oauth_flows" "allowed_oauth_flows - (Optional) List of allowed OAuth flows (code, implicit, client_credentials).")
    ("allowed_oauth_flows_user_pool_client" "allowed_oauth_flows_user_pool_client - (Optional) Whether the client is allowed to follow the OAuth protocol when interacting with Cognito user pools.")
    ("allowed_oauth_scopes" "allowed_oauth_scopes - (Optional) List of allowed OAuth scopes (phone, email, openid, profile, and aws.cognito.signin.user.admin).")
    ("callback_urls" "callback_urls - (Optional) List of allowed callback URLs for the identity providers.")
    ("default_redirect_uri" "default_redirect_uri - (Optional) The default redirect URI. Must be in the list of callback URLs.")
    ("explicit_auth_flows" "explicit_auth_flows - (Optional) List of authentication flows (ADMIN_NO_SRP_AUTH, CUSTOM_AUTH_FLOW_ONLY, USER_PASSWORD_AUTH).")
    ("generate_secret" "generate_secret - (Optional) Should an application secret be generated. AWS JavaScript SDK requires this to be false.")
    ("logout_urls" "logout_urls - (Optional) List of allowed logout URLs for the identity providers.")
    ("name" "name - (Required) The name of the application client.")
    ("read_attributes" "read_attributes - (Optional) List of user pool attributes the application client can read from.")
    ("refresh_token_validity" "refresh_token_validity - (Optional) The time limit in days refresh tokens are valid for.")
    ("supported_identity_providers" "supported_identity_providers - (Optional) List of provider names for the identity providers that are supported on this client.")
    ("user_pool_id" "user_pool_id - (Required) The user pool the client belongs to.")
    ("write_attributes" "write_attributes - (Optional) List of user pool attributes the application client can write to.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_cognito_user_pool_domain" '(
    ("domain" "domain - (Required) The domain string.")
    ("user_pool_id" "user_pool_id - (Required) The user pool ID.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_config_config_rule" '(
    ("name" "name - (Required) The name of the rule")
    ("description" "description - (Optional) Description of the rule")
    ("input_parameters" "input_parameters - (Optional) A string in JSON format that is passed to the AWS Config rule Lambda function.")
    ("maximum_execution_frequency" "maximum_execution_frequency - (Optional) The maximum frequency with which AWS Config runs evaluations for a rule.")
    ("scope" "scope - (Optional) Scope defines which resources can trigger an evaluation for the rule as documented below.")
    ("source" "source - (Required) Source specifies the rule owner, the rule identifier, and the notifications that cause the function to evaluate your AWS resources as documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_config_configuration_recorder" '(
    ("name" "name - (Optional) The name of the recorder. Defaults to default. Changing it recreates the resource.")
    ("role_arn" "role_arn - (Required) Amazon Resource Name (ARN) of the IAM role. used to make read or write requests to the delivery channel and to describe the AWS resources associated with the account. See AWS Docs for more details.")
    ("recording_group" "recording_group - (Optional) Recording group - see below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_config_configuration_recorder_status" '(
    ("name" "name - (Required) The name of the recorder")
    ("is_enabled" "is_enabled - (Required) Whether the configuration recorder should be enabled or disabled.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_config_delivery_channel" '(
    ("name" "name - (Optional) The name of the delivery channel. Defaults to default. Changing it recreates the resource.")
    ("s3_bucket_name" "s3_bucket_name - (Required) The name of the S3 bucket used to store the configuration history.")
    ("s3_key_prefix" "s3_key_prefix - (Optional) The prefix for the specified S3 bucket.")
    ("sns_topic_arn" "sns_topic_arn - (Optional) The ARN of the SNS topic that AWS Config delivers notifications to.")
    ("snapshot_delivery_properties" "snapshot_delivery_properties - (Optional) Options for how AWS Config delivers configuration snapshots. See below")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dms_certificate" '(
    ("certificate_id" "certificate_id - (Required) The certificate identifier.  Must contain from 1 to 255 alphanumeric characters and hyphens.")
    ("certificate_pem" "certificate_pem - (Optional) The contents of the .pem X.509 certificate file for the certificate. Either certificate_pem or certificate_wallet must be set.")
    ("certificate_wallet" "certificate_wallet - (Optional) The contents of the Oracle Wallet certificate for use with SSL. Either certificate_pem or certificate_wallet must be set.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dms_endpoint" '(
    ("certificate_arn" "certificate_arn - (Optional, Default: empty string) The Amazon Resource Name (ARN) for the certificate.")
    ("database_name" "database_name - (Optional) The name of the endpoint database.")
    ("endpoint_id" "endpoint_id - (Required) The database endpoint identifier.  Must contain from 1 to 255 alphanumeric characters or hyphens.  Must begin with a letter  Must contain only ASCII letters, digits, and hyphens  Must not end with a hyphen  Must not contain two consecutive hyphens")
    ("endpoint_type" "endpoint_type - (Required) The type of endpoint. Can be one of source | target.")
    ("engine_name" "engine_name - (Required) The type of engine for the endpoint. Can be one of mysql | oracle | postgres | mariadb | aurora | redshift | sybase | sqlserver | dynamodb | mongodb | s3 | azuredb.")
    ("extra_connection_attributes" "extra_connection_attributes - (Optional) Additional attributes associated with the connection. For available attributes see Using Extra Connection Attributes with AWS Database Migration Service.")
    ("kms_key_arn" "kms_key_arn - (Optional) The Amazon Resource Name (ARN) for the KMS key that will be used to encrypt the connection parameters. If you do not specify a value for kms_key_arn, then AWS DMS will use your default encryption key. AWS KMS creates the default encryption key for your AWS account. Your AWS account has a different default encryption key for each AWS region.")
    ("password" "password - (Optional) The password to be used to login to the endpoint database.")
    ("port" "port - (Optional) The port used by the endpoint database.")
    ("server_name" "server_name - (Optional) The host name of the server.")
    ("ssl_mode" "ssl_mode - (Optional, Default: none) The SSL mode to use for the connection. Can be one of none | require | verify-ca | verify-full")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("username" "username - (Optional) The user name to be used to login to the endpoint database.")
    ("service_access_role" "service_access_role - (Optional) The Amazon Resource Name (ARN) used by the service access IAM role for dynamodb endpoints.")
    ("mongodb_settings" "mongodb_settings - (Optional) Settings for the source MongoDB endpoint. Available settings are auth_type (default: PASSWORD), auth_mechanism (default: DEFAULT), nesting_level (default: NONE), extract_doc_id (default: false), docs_to_investigate (default: 1000) and auth_source (default: admin). For more details, see Using MongoDB as a Source for AWS DMS.")
    ("s3_settings" "s3_settings - (Optional) Settings for the target S3 endpoint. Available settings are service_access_role_arn, external_table_definition, csv_row_delimiter (default: \\\\n), csv_delimiter (default: ,), bucket_folder, bucket_name and compression_type (default: NONE). For more details, see Using Amazon S3 as a Target for AWS Database Migration Service.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dms_replication_instance" '(
    ("allocated_storage" "allocated_storage - (Optional, Default: 50, Min: 5, Max: 6144) The amount of storage (in gigabytes) to be initially allocated for the replication instance.")
    ("apply_immediately" "apply_immediately - (Optional, Default: false) Indicates whether the changes should be applied immediately or during the next maintenance window. Only used when updating an existing resource.")
    ("auto_minor_version_upgrade" "auto_minor_version_upgrade - (Optional, Default: false) Indicates that minor engine upgrades will be applied automatically to the replication instance during the maintenance window.")
    ("availability_zone" "availability_zone - (Optional) The EC2 Availability Zone that the replication instance will be created in.")
    ("engine_version" "engine_version - (Optional) The engine version number of the replication instance.")
    ("kms_key_arn" "kms_key_arn - (Optional) The Amazon Resource Name (ARN) for the KMS key that will be used to encrypt the connection parameters. If you do not specify a value for kms_key_arn, then AWS DMS will use your default encryption key. AWS KMS creates the default encryption key for your AWS account. Your AWS account has a different default encryption key for each AWS region.")
    ("multi_az" "multi_az - (Optional) Specifies if the replication instance is a multi-az deployment. You cannot set the availability_zone parameter if the multi_az parameter is set to true.")
    ("preferred_maintenance_window" "preferred_maintenance_window - (Optional) The weekly time range during which system maintenance can occur, in Universal Coordinated Time (UTC).  Default: A 30-minute window selected at random from an 8-hour block of time per region, occurring on a random day of the week.  Format: ddd:hh24:mi-ddd:hh24:mi  Valid Days: mon, tue, wed, thu, fri, sat, sun  Constraints: Minimum 30-minute window.")
    ("publicly_accessible" "publicly_accessible - (Optional, Default: false) Specifies the accessibility options for the replication instance. A value of true represents an instance with a public IP address. A value of false represents an instance with a private IP address.")
    ("replication_instance_class" "replication_instance_class - (Required) The compute and memory capacity of the replication instance as specified by the replication instance class. Can be one of dms.t2.micro | dms.t2.small | dms.t2.medium | dms.t2.large | dms.c4.large | dms.c4.xlarge | dms.c4.2xlarge | dms.c4.4xlarge")
    ("replication_instance_id" "replication_instance_id - (Required) The replication instance identifier. This parameter is stored as a lowercase string.  Must contain from 1 to 63 alphanumeric characters or hyphens.  First character must be a letter.  Cannot end with a hyphen  Cannot contain two consecutive hyphens.")
    ("replication_subnet_group_id" "replication_subnet_group_id - (Optional) A subnet group to associate with the replication instance.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("vpc_security_group_ids" "vpc_security_group_ids - (Optional) A list of VPC security group IDs to be used with the replication instance. The VPC security groups must work with the VPC containing the replication instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dms_replication_subnet_group" '(
    ("replication_subnet_group_description" "replication_subnet_group_description - (Required) The description for the subnet group.")
    ("replication_subnet_group_id" "replication_subnet_group_id - (Required) The name for the replication subnet group. This value is stored as a lowercase string.  Must contain no more than 255 alphanumeric characters, periods, spaces, underscores, or hyphens.  Must not be \"default\".")
    ("subnet_ids" "subnet_ids - (Required) A list of the EC2 subnet IDs for the subnet group.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dms_replication_task" '(
    ("cdc_start_time" "cdc_start_time - (Optional) The Unix timestamp integer for the start of the Change Data Capture (CDC) operation.")
    ("migration_type" "migration_type - (Required) The migration type. Can be one of full-load | cdc | full-load-and-cdc.")
    ("replication_instance_arn" "replication_instance_arn - (Required) The Amazon Resource Name (ARN) of the replication instance.")
    ("replication_task_id" "replication_task_id - (Required) The replication task identifier.  Must contain from 1 to 255 alphanumeric characters or hyphens.  First character must be a letter.  Cannot end with a hyphen.  Cannot contain two consecutive hyphens.")
    ("replication_task_settings" "replication_task_settings - (Optional) An escaped JSON string that contains the task settings. For a complete list of task settings, see Task Settings for AWS Database Migration Service Tasks.")
    ("source_endpoint_arn" "source_endpoint_arn - (Required) The Amazon Resource Name (ARN) string that uniquely identifies the source endpoint.")
    ("table_mappings" "table_mappings - (Required) An escaped JSON string that contains the table mappings. For information on table mapping see Using Table Mapping with an AWS Database Migration Service Task to Select and Filter Data")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("target_endpoint_arn" "target_endpoint_arn - (Required) The Amazon Resource Name (ARN) string that uniquely identifies the target endpoint.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_devicefarm_project" '(
    ("name" "name - (Required) The name of the project")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_directory_service_directory" '(
    ("name" "name - (Required) The fully qualified name for the directory, such as corp.example.com")
    ("password" "password - (Required) The password for the directory administrator or connector user.")
    ("size" "size - (Required for SimpleAD and ADConnector) The size of the directory (Small or Large are accepted values).")
    ("vpc_settings" "vpc_settings - (Required for SimpleAD and MicrosoftAD) VPC related information about the directory. Fields documented below.")
    ("connect_settings" "connect_settings - (Required for ADConnector) Connector related information about the directory. Fields documented below.")
    ("alias" "alias - (Optional) The alias for the directory (must be unique amongst all aliases in AWS). Required for enable_sso.")
    ("description" "description - (Optional) A textual description for the directory.")
    ("short_name" "short_name - (Optional) The short name of the directory, such as CORP.")
    ("enable_sso" "enable_sso - (Optional) Whether to enable single-sign on for the directory. Requires alias. Defaults to false.")
    ("type" "type (Optional) - The directory type (SimpleAD, ADConnector or MicrosoftAD are accepted values). Defaults to SimpleAD.")
    ("edition" "edition - (Optional) The MicrosoftAD edition (Standard or Enterprise). Defaults to Enterprise (applies to MicrosoftAD type only).")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_directory_service_conditional_forwarder" '(
    ("directory_id" "directory_id - (Required) The id of directory.")
    ("dns_ips" "dns_ips - (Required) A list of forwarder IP addresses.")
    ("remote_domain_name" "remote_domain_name - (Required) The fully qualified domain name of the remote domain for which forwarders will be used.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dx_connection" '(
    ("name" "name - (Required) The name of the connection.")
    ("bandwidth" "bandwidth - (Required) The bandwidth of the connection. Available values: 1Gbps, 10Gbps. Case sensitive.")
    ("location" "location - (Required) The AWS Direct Connect location where the connection is located. See DescribeLocations for the list of AWS Direct Connect locations. Use locationCode.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dx_connection_association" '(
    ("connection_id" "connection_id - (Required) The ID of the connection.")
    ("lag_id" "lag_id - (Required) The ID of the LAG with which to associate the connection.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dx_lag" '(
    ("name" "name - (Required) The name of the LAG.")
    ("connections_bandwidth" "connections_bandwidth - (Required) The bandwidth of the individual physical connections bundled by the LAG. Available values: 1Gbps, 10Gbps. Case sensitive.")
    ("location" "location - (Required) The AWS Direct Connect location in which the LAG should be allocated. See DescribeLocations for the list of AWS Direct Connect locations. Use locationCode.")
    ("number_of_connections" "number_of_connections - (Deprecated) The number of physical connections initially provisioned and bundled by the LAG. Use aws_dx_connection and aws_dx_connection_association resources instead. Default connections will be removed as part of LAG creation automatically in future versions.")
    ("force_destroy" "force_destroy - (Optional, Default:false) A boolean that indicates all connections associated with the LAG should be deleted so that the LAG can be destroyed without error. These objects are not recoverable.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dynamodb_global_table" '(
    ("name" "name - (Required) The name of the global table. Must match underlying DynamoDB Table names in all regions.")
    ("replica" "replica - (Required) Underlying DynamoDB Table. At least 1 replica must be defined. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dynamodb_table" '(
    ("name" "name - (Required) The name of the table, this needs to be unique within a region.")
    ("hash_key" "hash_key - (Required, Forces new resource) The attribute to use as the hash key (the attribute must also be defined as an attribute record")
    ("range_key" "range_key - (Optional, Forces new resource) The attribute to use as the range key (must also be defined)")
    ("write_capacity" "write_capacity - (Required) The number of write units for this table")
    ("read_capacity" "read_capacity - (Required) The number of read units for this table")
    ("attribute" "attribute - (Required) Define an attribute, has two properties:   name - The name of the attribute  type - One of: S, N, or B for (S)tring, (N)umber or (B)inary data")
    ("ttl" "ttl - (Optional) Defines ttl, has two properties, and can only be specified once:   enabled - (Required) Indicates whether ttl is enabled (true) or disabled (false).  attribute_name - (Required) The name of the table attribute to store the TTL timestamp in.")
    ("local_secondary_index" "local_secondary_index - (Optional, Forces new resource) Describe an LSI on the table; these can only be allocated at creation so you cannot change this definition after you have created the resource.")
    ("global_secondary_index" "global_secondary_index - (Optional) Describe a GSO for the table; subject to the normal limits on the number of GSIs, projected attributes, etc.")
    ("stream_enabled" "stream_enabled - (Optional) Indicates whether Streams are to be enabled (true) or disabled (false).")
    ("stream_view_type" "stream_view_type - (Optional) When an item in the table is modified, StreamViewType determines what information is written to the table's stream. Valid values are KEYS_ONLY, NEW_IMAGE, OLD_IMAGE, NEW_AND_OLD_IMAGES.")
    ("server_side_encryption" "server_side_encryption - (Optional) Encrypt at rest options.")
    ("tags" "tags - (Optional) A map of tags to populate on the created table.")
    ("point_in_time_recovery" "point_in_time_recovery - (Optional) Point-in-time recovery options.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dynamodb_table_item" '(
    ("table_name" "table_name - (Required) The name of the table to contain the item.")
    ("hash_key" "hash_key - (Required) Hash key to use for lookups and identification of the item")
    ("range_key" "range_key - (Optional) Range key to use for lookups and identification of the item. Required if there is range key defined in the table.")
    ("item" "item - (Required) JSON representation of a map of attribute name/value pairs, one for each attribute. Only the primary key attributes are required; you can optionally provide other attribute name-value pairs for the item.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dax_cluster" '(
    ("cluster_name" "cluster_name – (Required) Group identifier. DAX converts this name to lowercase")
    ("iam_role_arn" "iam_role_arn - (Required) A valid Amazon Resource Name (ARN) that identifies an IAM role. At runtime, DAX will assume this role and use the role's permissions to access DynamoDB on your behalf")
    ("node_type" "node_type – (Required) The compute and memory capacity of the nodes. See Nodes for supported node types")
    ("replication_factor" "replication_factor – (Required) The number of nodes in the DAX cluster. A replication factor of 1 will create a single-node cluster, without any read replicas")
    ("availability_zones" "availability_zones - (Optional) List of Availability Zones in which the nodes will be created")
    ("description" "description – (Optional) Description for the cluster")
    ("notification_topic_arn" "notification_topic_arn – (Optional) An Amazon Resource Name (ARN) of an SNS topic to send DAX notifications to. Example: arn:aws:sns:us-east-1:012345678999:my_sns_topic")
    ("parameter_group_name" "parameter_group_name – (Optional) Name of the parameter group to associate with this DAX cluster")
    ("maintenance_window" "maintenance_window – (Optional) Specifies the weekly time range for when maintenance on the cluster is performed. The format is ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute period. Example: sun:05:00-sun:09:00")
    ("security_group_ids" "security_group_ids – (Optional) One or more VPC security groups associated with the cluster")
    ("subnet_group_name" "subnet_group_name – (Optional) Name of the subnet group to be used for the cluster")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dax_parameter_group" '(
    ("name" "name – (Required) The name of the parameter group.")
    ("description" "description - (Optional, ForceNew) A description of the parameter group.")
    ("parameters" "parameters – (Optional) The parameters of the parameter group.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_dax_subnet_group" '(
    ("name" "name – (Required) The name of the subnet group.")
    ("description" "description - (Optional) A description of the subnet group.")
    ("subnet_ids" "subnet_ids – (Required) A list of VPC subnet IDs for the subnet group.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_alb" '(
    ("name" "name - (Optional) The name of the LB. This name must be unique within your AWS account, can have a maximum of 32 characters, must contain only alphanumeric characters or hyphens, and must not begin or end with a hyphen. If not specified, Terraform will autogenerate a name beginning with tf-lb.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("internal" "internal - (Optional) If true, the LB will be internal.")
    ("load_balancer_type" "load_balancer_type - (Optional) The type of load balancer to create. Possible values are application or network. The default value is application.")
    ("security_groups" "security_groups - (Optional) A list of security group IDs to assign to the LB. Only valid for Load Balancers of type application.")
    ("access_logs" "access_logs - (Optional) An Access Logs block. Access Logs documented below. Only valid for Load Balancers of type application.")
    ("subnets" "subnets - (Optional) A list of subnet IDs to attach to the LB. Subnets cannot be updated for Load Balancers of type network. Changing this value  for load balancers of type network will force a recreation of the resource.")
    ("subnet_mapping" "subnet_mapping - (Optional) A subnet mapping block as documented below.")
    ("idle_timeout" "idle_timeout - (Optional) The time in seconds that the connection is allowed to be idle. Only valid for Load Balancers of type application. Default: 60.")
    ("enable_deletion_protection" "enable_deletion_protection - (Optional) If true, deletion of the load balancer will be disabled via the AWS API. This will prevent Terraform from deleting the load balancer. Defaults to false.")
    ("enable_cross_zone_load_balancing" "enable_cross_zone_load_balancing - (Optional) If true, cross-zone load balancing of the load balancer will be enabled. This is a network load balancer feature. Defaults to false.")
    ("enable_http2" "enable_http2 - (Optional) Indicates whether HTTP/2 is enabled in application load balancers. Defaults to true.")
    ("ip_address_type" "ip_address_type - (Optional) The type of IP addresses used by the subnets for your load balancer. The possible values are ipv4 and dualstack")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_alb_listener" '(
    ("load_balancer_arn" "load_balancer_arn - (Required, Forces New Resource) The ARN of the load balancer.")
    ("port" "port - (Required) The port on which the load balancer is listening.")
    ("protocol" "protocol - (Optional) The protocol for connections from clients to the load balancer. Valid values are TCP, HTTP and HTTPS. Defaults to HTTP.")
    ("ssl_policy" "ssl_policy - (Optional) The name of the SSL Policy for the listener. Required if protocol is HTTPS.")
    ("certificate_arn" "certificate_arn - (Optional) The ARN of the default SSL server certificate. Exactly one certificate is required if the protocol is HTTPS. For adding additional SSL certificates, see the aws_lb_listener_certificate resource.")
    ("default_action" "default_action - (Required) An Action block. Action blocks are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_alb_listener_certificate" '(
    ("listener_arn" "listener_arn - (Required, Forces New Resource) The ARN of the listener to which to attach the certificate.")
    ("certificate_arn" "certificate_arn - (Required, Forces New Resource) The ARN of the certificate to attach to the listener.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_alb_listener_rule" '(
    ("listener_arn" "listener_arn - (Required, Forces New Resource) The ARN of the listener to which to attach the rule.")
    ("priority" "priority - (Optional) The priority for the rule between 1 and 50000. Leaving it unset will automatically set the rule with next available priority after currently existing highest rule. A listener can't have multiple rules with the same priority.")
    ("action" "action - (Required) An Action block. Action blocks are documented below.")
    ("condition" "condition - (Required) A Condition block. Condition blocks are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_alb_target_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the target group. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name. Cannot be longer than 6 characters.")
    ("port" "port - (Required) The port on which targets receive traffic, unless overridden when registering a specific target.")
    ("protocol" "protocol - (Required) The protocol to use for routing traffic to the targets.")
    ("vpc_id" "vpc_id - (Required) The identifier of the VPC in which to create the target group.")
    ("deregistration_delay" "deregistration_delay - (Optional) The amount time for Elastic Load Balancing to wait before changing the state of a deregistering target from draining to unused. The range is 0-3600 seconds. The default value is 300 seconds.")
    ("proxy_protocol_v2" "proxy_protocol_v2 - (Optional) Boolean to enable / disable support for proxy protocol v2 on Network Load Balancers. See doc for more information.")
    ("stickiness" "stickiness - (Optional) A Stickiness block. Stickiness blocks are documented below. stickiness is only valid if used with Load Balancers of type Application")
    ("health_check" "health_check - (Optional) A Health Check block. Health Check blocks are documented below.")
    ("target_type" "target_type - (Optional) The type of target that you must specify when registering targets with this target group. The possible values are instance (targets are specified by instance ID) or ip (targets are specified by IP address). The default is instance. Note that you can't specify targets for a target group using both instance IDs and IP addresses. If the target type is ip, specify IP addresses from the subnets of the virtual private cloud (VPC) for the target group, the RFC 1918 range (10.0.0.0/8, 172.16.0.0/12, and 192.168.0.0/16), and the RFC 6598 range (100.64.0.0/10). You can't specify publicly routable IP addresses.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_alb_target_group_attachment" '(
    ("target_group_arn" "target_group_arn - (Required) The ARN of the target group with which to register targets")
    ("target_id" "target_id (Required) The ID of the target. This is the Instance ID for an instance, or the container ID for an ECS container. If the target type is ip, specify an IP address.")
    ("port" "port - (Optional) The port on which targets receive traffic.")
    ("availability_zone" "availability_zone - (Optional) The Availability Zone where the IP address of the target is to be registered.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ami" '(
    ("name" "name - (Required) A region-unique name for the AMI.")
    ("description" "description - (Optional) A longer, human-readable description for the AMI.")
    ("root_device_name" "root_device_name - (Optional) The name of the root device (for example, /dev/sda1, or /dev/xvda).")
    ("virtualization_type" "virtualization_type - (Optional) Keyword to choose what virtualization mode created instances will use. Can be either \"paravirtual\" (the default) or \"hvm\". The choice of virtualization type changes the set of further arguments that are required, as described below.")
    ("architecture" "architecture - (Optional) Machine architecture for created instances. Defaults to \"x86_64\".")
    ("ebs_block_device" "ebs_block_device - (Optional) Nested block describing an EBS block device that should be attached to created instances. The structure of this block is described below.")
    ("ephemeral_block_device" "ephemeral_block_device - (Optional) Nested block describing an ephemeral block device that should be attached to created instances. The structure of this block is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ami_copy" '(
    ("name" "name - (Required) A region-unique name for the AMI.")
    ("source_ami_id" "source_ami_id - (Required) The id of the AMI to copy. This id must be valid in the region given by source_ami_region.")
    ("source_ami_region" "source_ami_region - (Required) The region from which the AMI will be copied. This may be the same as the AWS provider region in order to create a copy within the same region.")
    ("encrypted" "encrypted - (Optional) Specifies whether the destination snapshots of the copied image should be encrypted. Defaults to false")
    ("kms_key_id" "kms_key_id - (Optional) The full ARN of the KMS Key to use when encrypting the snapshots of an image during a copy operation. If not specified, then the default AWS KMS Key will be used")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ami_from_instance" '(
    ("name" "name - (Required) A region-unique name for the AMI.")
    ("source_instance_id" "source_instance_id - (Required) The id of the instance to use as the basis of the AMI.")
    ("snapshot_without_reboot" "snapshot_without_reboot - (Optional) Boolean that overrides the behavior of stopping the instance before snapshotting. This is risky since it may cause a snapshot of an inconsistent filesystem state, but can be used to avoid downtime if the user otherwise guarantees that no filesystem writes will be underway at the time of snapshot.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ami_launch_permission" '(
    ("image_id" "image_id - (required) A region-unique name for the AMI.")
    ("account_id" "account_id - (required) An AWS Account ID to add launch permissions.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_app_cookie_stickiness_policy" '(
    ("name" "name - (Required) The name of the stickiness policy.")
    ("load_balancer" "load_balancer - (Required) The name of load balancer to which the policy should be attached.")
    ("lb_port" "lb_port - (Required) The load balancer port to which the policy should be applied. This must be an active listener on the load balancer.")
    ("cookie_name" "cookie_name - (Required) The application cookie whose lifetime the ELB's cookie should follow.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_autoscaling_attachment" '(
    ("autoscaling_group_name" "autoscaling_group_name - (Required) Name of ASG to associate with the ELB.")
    ("elb" "elb - (Optional) The name of the ELB.")
    ("alb_target_group_arn" "alb_target_group_arn - (Optional) The ARN of an ALB Target Group.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_autoscaling_group" '(
    ("name" "name - (Optional) The name of the auto scaling group. By default generated by Terraform.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("max_size" "max_size - (Required) The maximum size of the auto scale group.")
    ("min_size" "min_size - (Required) The minimum size of the auto scale group. (See also Waiting for Capacity below.)")
    ("availability_zones" "availability_zones - (Required only for EC2-Classic) A list of one or more availability zones for the group. This parameter should not be specified when using vpc_zone_identifier.")
    ("default_cooldown" "default_cooldown - (Optional) The amount of time, in seconds, after a scaling activity completes before another scaling activity can start.")
    ("launch_configuration" "launch_configuration - (Optional) The name of the launch configuration to use.")
    ("launch_template" "launch_template - (Optional) Launch template specification to use to launch instances. See Launch Template Specification below for more details.")
    ("initial_lifecycle_hook" "initial_lifecycle_hook - (Optional) One or more Lifecycle Hooks to attach to the autoscaling group before instances are launched. The syntax is exactly the same as the separate aws_autoscaling_lifecycle_hook resource, without the autoscaling_group_name attribute. Please note that this will only work when creating a new autoscaling group. For all other use-cases, please use aws_autoscaling_lifecycle_hook resource.")
    ("health_check_grace_period" "health_check_grace_period - (Optional, Default: 300) Time (in seconds) after instance comes into service before checking health.")
    ("health_check_type" "health_check_type - (Optional) \"EC2\" or \"ELB\". Controls how health checking is done.")
    ("desired_capacity" "desired_capacity - (Optional) The number of Amazon EC2 instances that should be running in the group. (See also Waiting for Capacity below.)")
    ("force_delete" "force_delete - (Optional) Allows deleting the autoscaling group without waiting for all instances in the pool to terminate.  You can force an autoscaling group to delete even if it's in the process of scaling a resource. Normally, Terraform drains all the instances before deleting the group.  This bypasses that behavior and potentially leaves resources dangling.")
    ("load_balancers" "load_balancers (Optional) A list of elastic load balancer names to add to the autoscaling group names. Only valid for classic load balancers. For ALBs, use target_group_arns instead.")
    ("vpc_zone_identifier" "vpc_zone_identifier (Optional) A list of subnet IDs to launch resources in.")
    ("target_group_arns" "target_group_arns (Optional) A list of aws_alb_target_group ARNs, for use with Application Load Balancing.")
    ("termination_policies" "termination_policies (Optional) A list of policies to decide how the instances in the auto scale group should be terminated. The allowed values are OldestInstance, NewestInstance, OldestLaunchConfiguration, ClosestToNextInstanceHour, Default.")
    ("suspended_processes" "suspended_processes - (Optional) A list of processes to suspend for the AutoScaling Group. The allowed values are Launch, Terminate, HealthCheck, ReplaceUnhealthy, AZRebalance, AlarmNotification, ScheduledActions, AddToLoadBalancer. Note that if you suspend either the Launch or Terminate process types, it can prevent your autoscaling group from functioning properly.")
    ("tag" "tag (Optional) A list of tag blocks. Tags documented below.")
    ("tags" "tags (Optional) A list of tag blocks (maps). Tags documented below.")
    ("placement_group" "placement_group (Optional) The name of the placement group into which you'll launch your instances, if any.")
    ("metrics_granularity" "metrics_granularity - (Optional) The granularity to associate with the metrics to collect. The only valid value is 1Minute. Default is 1Minute.")
    ("enabled_metrics" "enabled_metrics - (Optional) A list of metrics to collect. The allowed values are GroupMinSize, GroupMaxSize, GroupDesiredCapacity, GroupInServiceInstances, GroupPendingInstances, GroupStandbyInstances, GroupTerminatingInstances, GroupTotalInstances.")
    ("wait_for_capacity_timeout" "wait_for_capacity_timeout (Default: \"10m\") A maximum duration that Terraform should wait for ASG instances to be healthy before timing out.  (See also Waiting for Capacity below.) Setting this to \"0\" causes Terraform to skip all Capacity Waiting behavior.")
    ("min_elb_capacity" "min_elb_capacity - (Optional) Setting this causes Terraform to wait for this number of instances to show up healthy in the ELB only on creation. Updates will not wait on ELB instance number changes. (See also Waiting for Capacity below.)")
    ("wait_for_elb_capacity" "wait_for_elb_capacity - (Optional) Setting this will cause Terraform to wait for exactly this number of healthy instances in all attached load balancers on both create and update operations. (Takes precedence over min_elb_capacity behavior.) (See also Waiting for Capacity below.)")
    ("protect_from_scale_in" "protect_from_scale_in (Optional) Allows setting instance protection. The autoscaling group will not select instances with this setting for terminination during scale in events.")
    ("service_linked_role_arn" "service_linked_role_arn (Optional) The ARN of the service-linked role that the ASG will use to call other AWS services")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_autoscaling_lifecycle_hook" '(
    ("name" "name - (Required) The name of the lifecycle hook.")
    ("autoscaling_group_name" "autoscaling_group_name - (Required) The name of the Auto Scaling group to which you want to assign the lifecycle hook")
    ("default_result" "default_result - (Optional) Defines the action the Auto Scaling group should take when the lifecycle hook timeout elapses or if an unexpected failure occurs. The value for this parameter can be either CONTINUE or ABANDON. The default value for this parameter is ABANDON.")
    ("heartbeat_timeout" "heartbeat_timeout - (Optional) Defines the amount of time, in seconds, that can elapse before the lifecycle hook times out. When the lifecycle hook times out, Auto Scaling performs the action defined in the DefaultResult parameter")
    ("lifecycle_transition" "lifecycle_transition - (Required) The instance state to which you want to attach the lifecycle hook. For a list of lifecycle hook types, see describe-lifecycle-hook-types")
    ("notification_metadata" "notification_metadata - (Optional) Contains additional information that you want to include any time Auto Scaling sends a message to the notification target.")
    ("notification_target_arn" "notification_target_arn - (Optional) The ARN of the notification target that Auto Scaling will use to notify you when an instance is in the transition state for the lifecycle hook. This ARN target can be either an SQS queue or an SNS topic.")
    ("role_arn" "role_arn - (Optional) The ARN of the IAM role that allows the Auto Scaling group to publish to the specified notification target.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_autoscaling_notification" '(
    ("group_names" "group_names - (Required) A list of AutoScaling Group Names")
    ("notifications" "notifications - (Required) A list of Notification Types that trigger notifications. Acceptable values are documented in the AWS documentation here")
    ("topic_arn" "topic_arn - (Required) The Topic ARN for notifications to be sent through")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_autoscaling_policy" '(
    ("name" "name - (Required) The name of the policy.")
    ("autoscaling_group_name" "autoscaling_group_name - (Required) The name of the autoscaling group.")
    ("adjustment_type" "adjustment_type - (Optional) Specifies whether the adjustment is an absolute number or a percentage of the current capacity. Valid values are ChangeInCapacity, ExactCapacity, and PercentChangeInCapacity.")
    ("policy_type" "policy_type - (Optional) The policy type, either \"SimpleScaling\", \"StepScaling\" or \"TargetTrackingScaling\". If this value isn't provided, AWS will default to \"SimpleScaling.\"")
    ("estimated_instance_warmup" "estimated_instance_warmup - (Optional) The estimated time, in seconds, until a newly launched instance will contribute CloudWatch metrics. Without a value, AWS will default to the group's specified cooldown period.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_autoscaling_schedule" '(
    ("autoscaling_group_name" "autoscaling_group_name - (Required) The name or Amazon Resource Name (ARN) of the Auto Scaling group.")
    ("scheduled_action_name" "scheduled_action_name - (Required) The name of this scaling action.")
    ("start_time" "start_time - (Optional) The time for this action to start, in \"YYYY-MM-DDThh:mm:ssZ\" format in UTC/GMT only (for example, 2014-06-01T00:00:00Z ).                         If you try to schedule your action in the past, Auto Scaling returns an error message.")
    ("end_time" "end_time - (Optional) The time for this action to end, in \"YYYY-MM-DDThh:mm:ssZ\" format in UTC/GMT only (for example, 2014-06-01T00:00:00Z ).                       If you try to schedule your action in the past, Auto Scaling returns an error message.")
    ("recurrence" "recurrence - (Optional) The time when recurring future actions will start. Start time is specified by the user following the Unix cron syntax format.")
    ("min_size" "min_size - (Optional) The minimum size for the Auto Scaling group. Default 0. Set to -1 if you don't want to change the minimum size at the scheduled time.")
    ("max_size" "max_size - (Optional) The maximum size for the Auto Scaling group. Default 0. Set to -1 if you don't want to change the maximum size at the scheduled time.")
    ("desired_capacity" "desired_capacity - (Optional) The number of EC2 instances that should be running in the group. Default 0.  Set to -1 if you don't want to change the desired capacity at the scheduled time.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_snapshot_create_volume_permission" '(
    ("snapshot_id" "snapshot_id - (required) A snapshot ID")
    ("account_id" "account_id - (required) An AWS Account ID to add create volume permissions")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ebs_snapshot" '(
    ("volume_id" "volume_id - (Required) The Volume ID of which to make a snapshot.")
    ("description" "description - (Optional) A description of what the snapshot is.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the snapshot")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ebs_volume" '(
    ("availability_zone" "availability_zone - (Required) The AZ where the EBS volume will exist.")
    ("encrypted" "encrypted - (Optional) If true, the disk will be encrypted.")
    ("iops" "iops - (Optional) The amount of IOPS to provision for the disk.")
    ("size" "size - (Optional) The size of the drive in GiBs.")
    ("snapshot_id" "snapshot_id (Optional) A snapshot to base the EBS volume off of.")
    ("type" "type - (Optional) The type of EBS volume. Can be \"standard\", \"gp2\", \"io1\", \"sc1\" or \"st1\" (Default: \"standard\").")
    ("kms_key_id" "kms_key_id - (Optional) The ARN for the KMS encryption key. When specifying kms_key_id, encrypted needs to be set to true.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_eip" '(
    ("vpc" "vpc - (Optional) Boolean if the EIP is in a VPC or not.")
    ("instance" "instance - (Optional) EC2 instance ID.")
    ("network_interface" "network_interface - (Optional) Network interface ID to associate with.")
    ("associate_with_private_ip" "associate_with_private_ip - (Optional) A user specified primary or secondary private IP address to associate with the Elastic IP address. If no private IP address is specified, the Elastic IP address is associated with the primary private IP address.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_eip_association" '(
    ("allocation_id" "allocation_id - (Optional) The allocation ID. This is required for EC2-VPC.")
    ("allow_reassociation" "allow_reassociation - (Optional, Boolean) Whether to allow an Elastic IP to be re-associated. Defaults to true in VPC.")
    ("instance_id" "instance_id - (Optional) The ID of the instance. This is required for EC2-Classic. For EC2-VPC, you can specify either the instance ID or the network interface ID, but not both. The operation fails if you specify an instance ID unless exactly one network interface is attached.")
    ("network_interface_id" "network_interface_id - (Optional) The ID of the network interface. If the instance has more than one network interface, you must specify a network interface ID.")
    ("private_ip_address" "private_ip_address - (Optional) The primary or secondary private IP address to associate with the Elastic IP address. If no private IP address is specified, the Elastic IP address is associated with the primary private IP address.")
    ("public_ip" "public_ip - (Optional) The Elastic IP address. This is required for EC2-Classic.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elb" '(
    ("name" "name - (Optional) The name of the ELB. By default generated by Terraform.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("access_logs" "access_logs - (Optional) An Access Logs block. Access Logs documented below.")
    ("availability_zones" "availability_zones - (Required for an EC2-classic ELB) The AZ's to serve traffic in.")
    ("security_groups" "security_groups - (Optional) A list of security group IDs to assign to the ELB. Only valid if creating an ELB within a VPC")
    ("subnets" "subnets - (Required for a VPC ELB) A list of subnet IDs to attach to the ELB.")
    ("instances" "instances - (Optional) A list of instance ids to place in the ELB pool.")
    ("internal" "internal - (Optional) If true, ELB will be an internal ELB.")
    ("listener" "listener - (Required) A list of listener blocks. Listeners documented below.")
    ("health_check" "health_check - (Optional) A health_check block. Health Check documented below.")
    ("cross_zone_load_balancing" "cross_zone_load_balancing - (Optional) Enable cross-zone load balancing. Default: true")
    ("idle_timeout" "idle_timeout - (Optional) The time in seconds that the connection is allowed to be idle. Default: 60")
    ("connection_draining" "connection_draining - (Optional) Boolean to enable connection draining. Default: false")
    ("connection_draining_timeout" "connection_draining_timeout - (Optional) The time in seconds to allow for connections to drain. Default: 300")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elb_attachment" '(
    ("elb" "elb - (Required) The name of the ELB.")
    ("instance" "instance - (Required) Instance ID to place in the ELB pool.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_instance" '(
    ("ami" "ami - (Required) The AMI to use for the instance.")
    ("availability_zone" "availability_zone - (Optional) The AZ to start the instance in.")
    ("placement_group" "placement_group - (Optional) The Placement Group to start the instance in.")
    ("tenancy" "tenancy - (Optional) The tenancy of the instance (if the instance is running in a VPC). An instance with a tenancy of dedicated runs on single-tenant hardware. The host tenancy is not supported for the import-instance command.")
    ("ebs_optimized" "ebs_optimized - (Optional) If true, the launched EC2 instance will be  EBS-optimized.")
    ("disable_api_termination" "disable_api_termination - (Optional) If true, enables EC2 Instance  Termination Protection")
    ("instance_initiated_shutdown_behavior" "instance_initiated_shutdown_behavior - (Optional) Shutdown behavior for the instance. Amazon defaults this to stop for EBS-backed instances and terminate for instance-store instances. Cannot be set on instance-store instances. See Shutdown Behavior for more information.")
    ("instance_type" "instance_type - (Required) The type of instance to start. Updates to this field will trigger a stop/start of the EC2 instance.")
    ("key_name" "key_name - (Optional) The key name to use for the instance.")
    ("get_password_data" "get_password_data - (Optional) If true, wait for password data to become available and retrieve it. Useful for getting the administrator password for instances running Microsoft Windows. The password data is exported to the password_data attribute. See GetPasswordData for more information.")
    ("monitoring" "monitoring - (Optional) If true, the launched EC2 instance will have detailed monitoring enabled. (Available since v0.6.0)")
    ("security_groups" "security_groups - (Optional) A list of security group names to associate with. If you are creating Instances in a VPC, use vpc_security_group_ids instead.")
    ("vpc_security_group_ids" "vpc_security_group_ids - (Optional) A list of security group IDs to associate with.")
    ("subnet_id" "subnet_id - (Optional) The VPC Subnet ID to launch in.")
    ("associate_public_ip_address" "associate_public_ip_address - (Optional) Associate a public ip address with an instance in a VPC.  Boolean value.")
    ("private_ip" "private_ip - (Optional) Private IP address to associate with the  instance in a VPC.")
    ("source_dest_check" "source_dest_check - (Optional) Controls if traffic is routed to the instance when the destination address does not match the instance. Used for NAT or VPNs. Defaults true.")
    ("user_data" "user_data - (Optional) The user data to provide when launching the instance. Do not pass gzip-compressed data via this argument; see user_data_base64 instead.")
    ("user_data_base64" "user_data_base64 - (Optional) Can be used instead of user_data to pass base64-encoded binary data directly. Use this instead of user_data whenever the value is not a valid UTF-8 string. For example, gzip-encoded user data must be base64-encoded and passed via this argument to avoid corruption.")
    ("iam_instance_profile" "iam_instance_profile - (Optional) The IAM Instance Profile to launch the instance with. Specified as the name of the Instance Profile. Ensure your credentials have the correct permission to assign the instance profile according to the EC2 documentation, notably iam:PassRole.")
    ("ipv6_address_count" "ipv6_address_count- (Optional) A number of IPv6 addresses to associate with the primary network interface. Amazon EC2 chooses the IPv6 addresses from the range of your subnet.")
    ("ipv6_addresses" "ipv6_addresses - (Optional) Specify one or more IPv6 addresses from the range of the subnet to associate with the primary network interface")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("volume_tags" "volume_tags - (Optional) A mapping of tags to assign to the devices created by the instance at launch time.")
    ("root_block_device" "root_block_device - (Optional) Customize details about the root block device of the instance. See Block Devices below for details.")
    ("ebs_block_device" "ebs_block_device - (Optional) Additional EBS block devices to attach to the instance.  See Block Devices below for details.")
    ("ephemeral_block_device" "ephemeral_block_device - (Optional) Customize Ephemeral (also known as \"Instance Store\") volumes on the instance. See Block Devices below for details.")
    ("network_interface" "network_interface - (Optional) Customize network interfaces to be attached at instance boot time. See Network Interfaces below for more details.")
    ("credit_specification" "credit_specification - (Optional) Customize the credit specification of the instance. See Credit Specification below for more details.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_key_pair" '(
    ("key_name" "key_name - (Optional) The name for the key pair.")
    ("key_name_prefix" "key_name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with key_name.")
    ("public_key" "public_key - (Required) The public key material.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_launch_configuration" '(
    ("name" "name - (Optional) The name of the launch configuration. If you leave this blank, Terraform will auto-generate a unique name.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("image_id" "image_id - (Required) The EC2 image ID to launch.")
    ("instance_type" "instance_type - (Required) The size of instance to launch.")
    ("iam_instance_profile" "iam_instance_profile - (Optional) The IAM instance profile to associate  with launched instances.")
    ("key_name" "key_name - (Optional) The key name that should be used for the instance.")
    ("security_groups" "security_groups - (Optional) A list of associated security group IDS.")
    ("associate_public_ip_address" "associate_public_ip_address - (Optional) Associate a public ip address with an instance in a VPC.")
    ("vpc_classic_link_id" "vpc_classic_link_id - (Optional) The ID of a ClassicLink-enabled VPC. Only applies to EC2-Classic instances. (eg. vpc-2730681a)")
    ("vpc_classic_link_security_groups" "vpc_classic_link_security_groups - (Optional) The IDs of one or more security groups for the specified ClassicLink-enabled VPC (eg. sg-46ae3d11).")
    ("user_data" "user_data - (Optional) The user data to provide when launching the instance. Do not pass gzip-compressed data via this argument; see user_data_base64 instead.")
    ("user_data_base64" "user_data_base64 - (Optional) Can be used instead of user_data to pass base64-encoded binary data directly. Use this instead of user_data whenever the value is not a valid UTF-8 string. For example, gzip-encoded user data must be base64-encoded and passed via this argument to avoid corruption.")
    ("enable_monitoring" "enable_monitoring - (Optional) Enables/disables detailed monitoring. This is enabled by default.")
    ("ebs_optimized" "ebs_optimized - (Optional) If true, the launched EC2 instance will be EBS-optimized.")
    ("root_block_device" "root_block_device - (Optional) Customize details about the root block device of the instance. See Block Devices below for details.")
    ("ebs_block_device" "ebs_block_device - (Optional) Additional EBS block devices to attach to the instance.  See Block Devices below for details.")
    ("ephemeral_block_device" "ephemeral_block_device - (Optional) Customize Ephemeral (also known as \"Instance Store\") volumes on the instance. See Block Devices below for details.")
    ("spot_price" "spot_price - (Optional; Default: On-demand price) The maximum price to use for reserving spot instances.")
    ("placement_tenancy" "placement_tenancy - (Optional) The tenancy of the instance. Valid values are \"default\" or \"dedicated\", see AWS's Create Launch Configuration for more details")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_launch_template" '(
    ("name" "name - The name of the launch template. If you leave this blank, Terraform will auto-generate a unique name.")
    ("name_prefix" "name_prefix - Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("description" "description - Description of the launch template.")
    ("block_device_mappings" "block_device_mappings - Specify volumes to attach to the instance besides the volumes specified by the AMI. See Block Devices below for details.")
    ("credit_specification" "credit_specification - Customize the credit specification of the instance. See Credit  Specification below for more details.")
    ("disable_api_termination" "disable_api_termination - If true, enables EC2 Instance Termination Protection")
    ("ebs_optimized" "ebs_optimized - If true, the launched EC2 instance will be EBS-optimized.")
    ("elastic_gpu_specifications" "elastic_gpu_specifications - The elastic GPU to attach to the instance. See Elastic GPU below for more details.")
    ("iam_instance_profile" "iam_instance_profile - The IAM Instance Profile to launch the instance with. See Instance Profile below for more details.")
    ("image_id" "image_id - The AMI from which to launch the instance.")
    ("instance_initiated_shutdown_behavior" "instance_initiated_shutdown_behavior - Shutdown behavior for the instance. Can be stop or terminate. (Default: stop).")
    ("instance_market_options" "instance_market_options - The market (purchasing) option for the instance. See Market Options below for details.")
    ("instance_type" "instance_type - The type of the instance.")
    ("kernel_id" "kernel_id - The kernel ID.")
    ("key_name" "key_name - The key name to use for the instance.")
    ("monitoring" "monitoring - The monitoring option for the instance. See Monitoring below for more details.")
    ("network_interfaces" "network_interfaces - Customize network interfaces to be attached at instance boot time. See Network  Interfaces below for more details.")
    ("placement" "placement - The placement of the instance. See Placement below for more details.")
    ("ram_disk_id" "ram_disk_id - The ID of the RAM disk.")
    ("security_group_names" "security_group_names - A list of security group names to associate with. If you are creating Instances in a VPC, use vpc_security_group_ids instead.")
    ("vpc_security_group_ids" "vpc_security_group_ids - A list of security group IDs to associate with.")
    ("tag_specifications" "tag_specifications - The tags to apply to the resources during launch. See Tags below for more details.")
    ("user_data" "user_data - The Base64-encoded user data to provide when launching the instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_cookie_stickiness_policy" '(
    ("name" "name - (Required) The name of the stickiness policy.")
    ("load_balancer" "load_balancer - (Required) The load balancer to which the policy should be attached.")
    ("lb_port" "lb_port - (Required) The load balancer port to which the policy should be applied. This must be an active listener on the load balancer.")
    ("cookie_expiration_period" "cookie_expiration_period - (Optional) The time period after which the session cookie should be considered stale, expressed in seconds.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_ssl_negotiation_policy" '(
    ("name" "name - (Required) The name of the SSL negotiation policy.")
    ("load_balancer" "load_balancer - (Required) The load balancer to which the policy should be attached.")
    ("lb_port" "lb_port - (Required) The load balancer port to which the policy should be applied. This must be an active listener on the load balancer.")
    ("attribute" "attribute - (Optional) An SSL Negotiation policy attribute. Each has two properties:   name - The name of the attribute  value - The value of the attribute")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_load_balancer_backend_server_policy" '(
    ("load_balancer_name" "load_balancer_name - (Required) The load balancer to attach the policy to.")
    ("policy_names" "policy_names - (Required) List of Policy Names to apply to the backend server.")
    ("instance_port" "instance_port - (Required) The instance port to apply the policy to.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_load_balancer_listener_policy" '(
    ("load_balancer_name" "load_balancer_name - (Required) The load balancer to attach the policy to.")
    ("load_balancer_port" "load_balancer_port - (Required) The load balancer listener port to apply the policy to.")
    ("policy_names" "policy_names - (Required) List of Policy Names to apply to the backend server.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_load_balancer_policy" '(
    ("load_balancer_name" "load_balancer_name - (Required) The load balancer on which the policy is defined.")
    ("policy_name" "policy_name - (Required) The name of the load balancer policy.")
    ("policy_type_name" "policy_type_name - (Required) The policy type.")
    ("policy_attribute" "policy_attribute - (Optional) Policy attribute to apply to the policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_placement_group" '(
    ("name" "name - (Required) The name of the placement group.")
    ("strategy" "strategy - (Required) The placement strategy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_proxy_protocol_policy" '(
    ("load_balancer" "load_balancer - (Required) The load balancer to which the policy should be attached.")
    ("instance_ports" "instance_ports - (Required) List of instance ports to which the policy should be applied. This can be specified if the protocol is SSL or TCP.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_spot_datafeed_subscription" '(
    ("bucket" "bucket - (Required) The Amazon S3 bucket in which to store the Spot instance data feed.")
    ("prefix" "prefix - (Optional) Path of folder inside bucket to place spot pricing data.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_spot_fleet_request" '(
    ("iam_fleet_role" "iam_fleet_role - (Required) Grants the Spot fleet permission to terminate Spot instances on your behalf when you cancel its Spot fleet request using CancelSpotFleetRequests or when the Spot fleet request expires, if you set terminateInstancesWithExpiration.")
    ("replace_unhealthy_instances" "replace_unhealthy_instances - (Optional) Indicates whether Spot fleet should replace unhealthy instances. Default false.")
    ("launch_specification" "launch_specification - Used to define the launch configuration of the spot-fleet request. Can be specified multiple times to define different bids across different markets and instance types. Note: This takes in similar but not identical inputs as aws_instance.  There are limitations on what you can specify. See the list of officially supported inputs in the reference documentation. Any normal aws_instance parameter that corresponds to those inputs may be used and it have a additional parameter iam_instance_profile_arn takes aws_iam_instance_profile attribute arn as input.")
    ("spot_price" "spot_price - (Optional; Default: On-demand price) The maximum bid price per unit hour.")
    ("wait_for_fulfillment" "wait_for_fulfillment - (Optional; Default: false) If set, Terraform will wait for the Spot Request to be fulfilled, and will throw an error if the timeout of 10m is reached.")
    ("target_capacity" "target_capacity - The number of units to request. You can choose to set the target capacity in terms of instances or a performance characteristic that is important to your application workload, such as vCPUs, memory, or I/O.")
    ("allocation_strategy" "allocation_strategy - Indicates how to allocate the target capacity across the Spot pools specified by the Spot fleet request. The default is lowestPrice.")
    ("excess_capacity_termination_policy" "excess_capacity_termination_policy - Indicates whether running Spot instances should be terminated if the target capacity of the Spot fleet request is decreased below the current size of the Spot fleet.")
    ("terminate_instances_with_expiration" "terminate_instances_with_expiration - Indicates whether running Spot instances should be terminated when the Spot fleet request expires.")
    ("instance_interruption_behavior" "instance_interruption_behavior - (Optional) Indicates whether a Spot instance stops or terminates when it is interrupted. Default is terminate.")
    ("valid_until" "valid_until - (Optional) The end date and time of the request, in UTC RFC3339 format(for example, YYYY-MM-DDTHH:MM:SSZ). At this point, no new Spot instance requests are placed or enabled to fulfill the request. Defaults to 24 hours.")
    ("valid_from" "valid_from - (Optional) The start date and time of the request, in UTC RFC3339 format(for example, YYYY-MM-DDTHH:MM:SSZ). The default is to start fulfilling the request immediately.")
    ("load_balancers" "load_balancers (Optional) A list of elastic load balancer names to add to the Spot fleet.")
    ("target_group_arns" "target_group_arns (Optional) A list of aws_alb_target_group ARNs, for use with Application Load Balancing.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_spot_instance_request" '(
    ("spot_price" "spot_price - (Optional; Default: On-demand price) The maximum price to request on the spot market.")
    ("wait_for_fulfillment" "wait_for_fulfillment - (Optional; Default: false) If set, Terraform will wait for the Spot Request to be fulfilled, and will throw an error if the timeout of 10m is reached.")
    ("spot_type" "spot_type - (Optional; Default: \"persistent\") If set to \"one-time\", after the instance is terminated, the spot request will be closed. Also, Terraform can't manage one-time spot requests, just launch them.")
    ("launch_group" "launch_group - (Optional) A launch group is a group of spot instances that launch together and terminate together. If left empty instances are launched and terminated individually.")
    ("block_duration_minutes" "block_duration_minutes - (Optional) The required duration for the Spot instances, in minutes. This value must be a multiple of 60 (60, 120, 180, 240, 300, or 360). The duration period starts as soon as your Spot instance receives its instance ID. At the end of the duration period, Amazon EC2 marks the Spot instance for termination and provides a Spot instance termination notice, which gives the instance a two-minute warning before it terminates. Note that you can't specify an Availability Zone group or a launch group if you specify a duration.")
    ("instance_interruption_behaviour" "instance_interruption_behaviour - (Optional) Indicates whether a Spot instance stops or terminates when it is interrupted. Default is terminate as this is the current AWS behaviour.")
    ("valid_until" "valid_until - (Optional) The end date and time of the request, in UTC RFC3339 format(for example, YYYY-MM-DDTHH:MM:SSZ). At this point, no new Spot instance requests are placed or enabled to fulfill the request. The default end date is 7 days from the current date.")
    ("valid_from" "valid_from - (Optional) The start date and time of the request, in UTC RFC3339 format(for example, YYYY-MM-DDTHH:MM:SSZ). The default is to start fulfilling the request immediately.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_volume_attachment" '(
    ("device_name" "device_name - (Required) The device name to expose to the instance (for example, /dev/sdh or xvdh)")
    ("instance_id" "instance_id - (Required) ID of the Instance to attach to")
    ("volume_id" "volume_id - (Required) ID of the Volume to be attached")
    ("force_detach" "force_detach - (Optional, Boolean) Set to true if you want to force the volume to detach. Useful if previous attempts failed, but use this option only as a last resort, as this can result in data loss. See Detaching an Amazon EBS Volume from an Instance for more information.")
    ("skip_destroy" "skip_destroy - (Optional, Boolean) Set this to true if you do not wish to detach the volume from the instance to which it is attached at destroy time, and instead just remove the attachment from Terraform state. This is useful when destroying an instance which has volumes created by some other means attached.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb" '(
    ("name" "name - (Optional) The name of the LB. This name must be unique within your AWS account, can have a maximum of 32 characters, must contain only alphanumeric characters or hyphens, and must not begin or end with a hyphen. If not specified, Terraform will autogenerate a name beginning with tf-lb.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("internal" "internal - (Optional) If true, the LB will be internal.")
    ("load_balancer_type" "load_balancer_type - (Optional) The type of load balancer to create. Possible values are application or network. The default value is application.")
    ("security_groups" "security_groups - (Optional) A list of security group IDs to assign to the LB. Only valid for Load Balancers of type application.")
    ("access_logs" "access_logs - (Optional) An Access Logs block. Access Logs documented below. Only valid for Load Balancers of type application.")
    ("subnets" "subnets - (Optional) A list of subnet IDs to attach to the LB. Subnets cannot be updated for Load Balancers of type network. Changing this value  for load balancers of type network will force a recreation of the resource.")
    ("subnet_mapping" "subnet_mapping - (Optional) A subnet mapping block as documented below.")
    ("idle_timeout" "idle_timeout - (Optional) The time in seconds that the connection is allowed to be idle. Only valid for Load Balancers of type application. Default: 60.")
    ("enable_deletion_protection" "enable_deletion_protection - (Optional) If true, deletion of the load balancer will be disabled via the AWS API. This will prevent Terraform from deleting the load balancer. Defaults to false.")
    ("enable_cross_zone_load_balancing" "enable_cross_zone_load_balancing - (Optional) If true, cross-zone load balancing of the load balancer will be enabled. This is a network load balancer feature. Defaults to false.")
    ("enable_http2" "enable_http2 - (Optional) Indicates whether HTTP/2 is enabled in application load balancers. Defaults to true.")
    ("ip_address_type" "ip_address_type - (Optional) The type of IP addresses used by the subnets for your load balancer. The possible values are ipv4 and dualstack")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_listener" '(
    ("load_balancer_arn" "load_balancer_arn - (Required, Forces New Resource) The ARN of the load balancer.")
    ("port" "port - (Required) The port on which the load balancer is listening.")
    ("protocol" "protocol - (Optional) The protocol for connections from clients to the load balancer. Valid values are TCP, HTTP and HTTPS. Defaults to HTTP.")
    ("ssl_policy" "ssl_policy - (Optional) The name of the SSL Policy for the listener. Required if protocol is HTTPS.")
    ("certificate_arn" "certificate_arn - (Optional) The ARN of the default SSL server certificate. Exactly one certificate is required if the protocol is HTTPS. For adding additional SSL certificates, see the aws_lb_listener_certificate resource.")
    ("default_action" "default_action - (Required) An Action block. Action blocks are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_listener_certificate" '(
    ("listener_arn" "listener_arn - (Required, Forces New Resource) The ARN of the listener to which to attach the certificate.")
    ("certificate_arn" "certificate_arn - (Required, Forces New Resource) The ARN of the certificate to attach to the listener.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_listener_rule" '(
    ("listener_arn" "listener_arn - (Required, Forces New Resource) The ARN of the listener to which to attach the rule.")
    ("priority" "priority - (Optional) The priority for the rule between 1 and 50000. Leaving it unset will automatically set the rule with next available priority after currently existing highest rule. A listener can't have multiple rules with the same priority.")
    ("action" "action - (Required) An Action block. Action blocks are documented below.")
    ("condition" "condition - (Required) A Condition block. Condition blocks are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_target_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the target group. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name. Cannot be longer than 6 characters.")
    ("port" "port - (Required) The port on which targets receive traffic, unless overridden when registering a specific target.")
    ("protocol" "protocol - (Required) The protocol to use for routing traffic to the targets.")
    ("vpc_id" "vpc_id - (Required) The identifier of the VPC in which to create the target group.")
    ("deregistration_delay" "deregistration_delay - (Optional) The amount time for Elastic Load Balancing to wait before changing the state of a deregistering target from draining to unused. The range is 0-3600 seconds. The default value is 300 seconds.")
    ("proxy_protocol_v2" "proxy_protocol_v2 - (Optional) Boolean to enable / disable support for proxy protocol v2 on Network Load Balancers. See doc for more information.")
    ("stickiness" "stickiness - (Optional) A Stickiness block. Stickiness blocks are documented below. stickiness is only valid if used with Load Balancers of type Application")
    ("health_check" "health_check - (Optional) A Health Check block. Health Check blocks are documented below.")
    ("target_type" "target_type - (Optional) The type of target that you must specify when registering targets with this target group. The possible values are instance (targets are specified by instance ID) or ip (targets are specified by IP address). The default is instance. Note that you can't specify targets for a target group using both instance IDs and IP addresses. If the target type is ip, specify IP addresses from the subnets of the virtual private cloud (VPC) for the target group, the RFC 1918 range (10.0.0.0/8, 172.16.0.0/12, and 192.168.0.0/16), and the RFC 6598 range (100.64.0.0/10). You can't specify publicly routable IP addresses.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lb_target_group_attachment" '(
    ("target_group_arn" "target_group_arn - (Required) The ARN of the target group with which to register targets")
    ("target_id" "target_id (Required) The ID of the target. This is the Instance ID for an instance, or the container ID for an ECS container. If the target type is ip, specify an IP address.")
    ("port" "port - (Optional) The port on which targets receive traffic.")
    ("availability_zone" "availability_zone - (Optional) The Availability Zone where the IP address of the target is to be registered.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ecr_lifecycle_policy" '(
    ("repository" "repository - (Required) Name of the repository to apply the policy.")
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string. See more details about Policy Parameters in the official AWS docs.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ecr_repository" '(
    ("name" "name - (Required) Name of the repository.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ecr_repository_policy" '(
    ("repository" "repository - (Required) Name of the repository to apply the policy.")
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ecs_cluster" '(
    ("name" "name - (Required) The name of the cluster (up to 255 letters, numbers, hyphens, and underscores)")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ecs_service" '(
    ("name" "name - (Required) The name of the service (up to 255 letters, numbers, hyphens, and underscores)")
    ("task_definition" "task_definition - (Required) The family and revision (family:revision) or full ARN of the task definition that you want to run in your service.")
    ("desired_count" "desired_count - (Required) The number of instances of the task definition to place and keep running")
    ("launch_type" "launch_type - (Optional) The launch type on which to run your service. The valid values are EC2 and FARGATE. Defaults to EC2.")
    ("cluster" "cluster - (Optional) ARN of an ECS cluster")
    ("iam_role" "iam_role - (Optional) The ARN of IAM role that allows your Amazon ECS container agent to make calls to your load balancer on your behalf. This parameter is only required if you are using a load balancer with your service.")
    ("deployment_maximum_percent" "deployment_maximum_percent - (Optional) The upper limit (as a percentage of the service's desiredCount) of the number of running tasks that can be running in a service during a deployment.")
    ("deployment_minimum_healthy_percent" "deployment_minimum_healthy_percent - (Optional) The lower limit (as a percentage of the service's desiredCount) of the number of running tasks that must remain running and healthy in a service during a deployment.")
    ("placement_strategy" "placement_strategy - (Optional) Deprecated, use ordered_placement_strategy instead.")
    ("ordered_placement_strategy" "ordered_placement_strategy - (Optional) Service level strategy rules that are taken into consideration during task placement. List from top to bottom in order of precedence. The maximum number of ordered_placement_strategy blocks is 5. Defined below.")
    ("health_check_grace_period_seconds" "health_check_grace_period_seconds - (Optional) Seconds to ignore failing load balancer health checks on newly instantiated tasks to prevent premature shutdown, up to 7200. Only valid for services configured to use load balancers.")
    ("load_balancer" "load_balancer - (Optional) A load balancer block. Load balancers documented below.")
    ("placement_constraints" "placement_constraints - (Optional) rules that are taken into consideration during task placement. Maximum number of placement_constraints is 10. Defined below.")
    ("network_configuration" "network_configuration - (Optional) The network configuration for the service. This parameter is required for task definitions that use the awsvpc network mode to receive their own Elastic Network Interface, and it is not supported for other network modes.")
    ("service_registries" "service_registries - (Optional) The service discovery registries for the service. The maximum number of service_registries blocks is 1.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ecs_task_definition" '(
    ("family" "family - (Required) A unique name for your task definition.")
    ("container_definitions" "container_definitions - (Required) A list of valid container definitions provided as a single valid JSON document. Please note that you should only provide values that are part of the container definition document. For a detailed description of what parameters are available, see the Task Definition Parameters section from the official Developer Guide.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_efs_file_system" '(
    ("creation_token" "creation_token - (Optional) A unique name (a maximum of 64 characters are allowed) used as reference when creating the Elastic File System to ensure idempotent file system creation. By default generated by Terraform. See Elastic File System user guide for more information.")
    ("reference_name" "reference_name - DEPRECATED (Optional) A reference name used when creating the Creation Token which Amazon EFS uses to ensure idempotent file system creation. By default generated by Terraform.")
    ("performance_mode" "performance_mode - (Optional) The file system performance mode. Can be either \"generalPurpose\" or \"maxIO\" (Default: \"generalPurpose\").")
    ("tags" "tags - (Optional) A mapping of tags to assign to the file system.")
    ("encrypted" "encrypted - (Optional) If true, the disk will be encrypted.")
    ("kms_key_id" "kms_key_id - (Optional) The ARN for the KMS encryption key. When specifying kms_key_id, encrypted needs to be set to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_efs_mount_target" '(
    ("file_system_id" "file_system_id - (Required) The ID of the file system for which the mount target is intended.")
    ("subnet_id" "subnet_id - (Required) The ID of the subnet to add the mount target in.")
    ("ip_address" "ip_address - (Optional) The address (within the address range of the specified subnet) at which the file system may be mounted via the mount target.")
    ("security_groups" "security_groups - (Optional) A list of up to 5 VPC security group IDs (that must be for the same VPC as subnet specified) in effect for the mount target.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticache_cluster" '(
    ("cluster_id" "cluster_id – (Required) Group identifier. ElastiCache converts this name to lowercase")
    ("replication_group_id" "replication_group_id - (Optional) The ID of the replication group to which this cluster should belong. If this parameter is specified, the cluster is added to the specified replication group as a read replica; otherwise, the cluster is a standalone primary that is not part of any replication group.")
    ("engine" "engine – (Required unless replication_group_id is provided) Name of the cache engine to be used for this cache cluster. Valid values for this parameter are memcached or redis")
    ("engine_version" "engine_version – (Optional) Version number of the cache engine to be used. See Selecting a Cache Engine and Version in the AWS Documentation center for supported versions")
    ("maintenance_window" "maintenance_window – (Optional) Specifies the weekly time range for when maintenance on the cache cluster is performed. The format is ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute period. Example: sun:05:00-sun:09:00")
    ("node_type" "node_type – (Required unless replication_group_id is provided) The compute and memory capacity of the nodes. See Available Cache Node Types for supported node types")
    ("num_cache_nodes" "num_cache_nodes – (Required unless replication_group_id is provided) The initial number of cache nodes that the cache cluster will have. For Redis, this value must be 1. For Memcache, this value must be between 1 and 20. If this number is reduced on subsequent runs, the highest numbered nodes will be removed.")
    ("parameter_group_name" "parameter_group_name – (Required unless replication_group_id is provided) Name of the parameter group to associate with this cache cluster")
    ("port" "port – (Optional) The port number on which each of the cache nodes will accept connections. For Memcache the default is 11211, and for Redis the default port is 6379. Cannot be provided with replication_group_id.")
    ("subnet_group_name" "subnet_group_name – (Optional, VPC only) Name of the subnet group to be used for the cache cluster.")
    ("security_group_names" "security_group_names – (Optional, EC2 Classic only) List of security group names to associate with this cache cluster")
    ("security_group_ids" "security_group_ids – (Optional, VPC only) One or more VPC security groups associated with the cache cluster")
    ("apply_immediately" "apply_immediately - (Optional) Specifies whether any database modifications  are applied immediately, or during the next maintenance window. Default is  false. See Amazon ElastiCache Documentation for more information.  (Available since v0.6.0)")
    ("snapshot_arns" "snapshot_arns – (Optional) A single-element string list containing an Amazon Resource Name (ARN) of a Redis RDB snapshot file stored in Amazon S3. Example: arn:aws:s3:::my_bucket/snapshot1.rdb")
    ("snapshot_name" "snapshot_name - (Optional) The name of a snapshot from which to restore data into the new node group.  Changing the snapshot_name forces a new resource.")
    ("snapshot_window" "snapshot_window - (Optional, Redis only) The daily time range (in UTC) during which ElastiCache will begin taking a daily snapshot of your cache cluster. Example: 05:00-09:00")
    ("snapshot_retention_limit" "snapshot_retention_limit - (Optional, Redis only) The number of days for which ElastiCache will retain automatic cache cluster snapshots before deleting them. For example, if you set SnapshotRetentionLimit to 5, then a snapshot that was taken today will be retained for 5 days before being deleted. If the value of SnapshotRetentionLimit is set to zero (0), backups are turned off. Please note that setting a snapshot_retention_limit is not supported on cache.t1.micro or cache.t2.* cache nodes")
    ("notification_topic_arn" "notification_topic_arn – (Optional) An Amazon Resource Name (ARN) of an SNS topic to send ElastiCache notifications to. Example: arn:aws:sns:us-east-1:012345678999:my_sns_topic")
    ("az_mode" "az_mode - (Optional, Memcached only) Specifies whether the nodes in this Memcached node group are created in a single Availability Zone or created across multiple Availability Zones in the cluster's region. Valid values for this parameter are single-az or cross-az, default is single-az. If you want to choose cross-az, num_cache_nodes must be greater than 1")
    ("availability_zone" "availability_zone - (Optional) The Availability Zone for the cache cluster. If you want to create cache nodes in multi-az, use availability_zones")
    ("availability_zones" "availability_zones - (Optional, Memcached only) List of Availability Zones in which the cache nodes will be created. If you want to create cache nodes in single-az, use availability_zone")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticache_parameter_group" '(
    ("name" "name - (Required) The name of the ElastiCache parameter group.")
    ("family" "family - (Required) The family of the ElastiCache parameter group.")
    ("description" "description - (Optional) The description of the ElastiCache parameter group. Defaults to \"Managed by Terraform\".")
    ("parameter" "parameter - (Optional) A list of ElastiCache parameters to apply.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticache_replication_group" '(
    ("replication_group_id" "replication_group_id – (Required) The replication group identifier. This parameter is stored as a lowercase string.")
    ("replication_group_description" "replication_group_description – (Required) A user-created description for the replication group.")
    ("number_cache_clusters" "number_cache_clusters - (Required) The number of cache clusters this replication group will have. If Multi-AZ is enabled , the value of this parameter must be at least 2. Changing this number will force a new resource")
    ("node_type" "node_type - (Required) The compute and memory capacity of the nodes in the node group.")
    ("automatic_failover_enabled" "automatic_failover_enabled - (Optional) Specifies whether a read-only replica will be automatically promoted to read/write primary if the existing primary fails. If true, Multi-AZ is enabled for this replication group. If false, Multi-AZ is disabled for this replication group. Must be enabled for Redis (cluster mode enabled) replication groups. Defaults to false.")
    ("auto_minor_version_upgrade" "auto_minor_version_upgrade - (Optional) Specifies whether a minor engine upgrades will be applied automatically to the underlying Cache Cluster instances during the maintenance window. Defaults to true.")
    ("availability_zones" "availability_zones - (Optional) A list of EC2 availability zones in which the replication group's cache clusters will be created. The order of the availability zones in the list is not important.")
    ("engine" "engine - (Optional) The name of the cache engine to be used for the clusters in this replication group. e.g. redis")
    ("at_rest_encryption_enabled" "at_rest_encryption_enabled - (Optional) Whether to enable encryption at rest.")
    ("transit_encryption_enabled" "transit_encryption_enabled - (Optional) Whether to enable encryption in transit.")
    ("auth_token" "auth_token - (Optional) The password used to access a password protected server. Can be specified only if transit_encryption_enabled = true.")
    ("engine_version" "engine_version - (Optional) The version number of the cache engine to be used for the cache clusters in this replication group.")
    ("parameter_group_name" "parameter_group_name - (Optional) The name of the parameter group to associate with this replication group. If this argument is omitted, the default cache parameter group for the specified engine is used.")
    ("port" "port – (Optional) The port number on which each of the cache nodes will accept connections. For Memcache the default is 11211, and for Redis the default port is 6379.")
    ("subnet_group_name" "subnet_group_name - (Optional) The name of the cache subnet group to be used for the replication group.")
    ("security_group_names" "security_group_names - (Optional) A list of cache security group names to associate with this replication group.")
    ("security_group_ids" "security_group_ids - (Optional) One or more Amazon VPC security groups associated with this replication group. Use this parameter only when you are creating a replication group in an Amazon Virtual Private Cloud")
    ("snapshot_arns" "snapshot_arns – (Optional) A single-element string list containing an Amazon Resource Name (ARN) of a Redis RDB snapshot file stored in Amazon S3. Example: arn:aws:s3:::my_bucket/snapshot1.rdb")
    ("snapshot_name" "snapshot_name - (Optional) The name of a snapshot from which to restore data into the new node group. Changing the snapshot_name forces a new resource.")
    ("maintenance_window" "maintenance_window – (Optional) Specifies the weekly time range for when maintenance on the cache cluster is performed. The format is ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute period. Example: sun:05:00-sun:09:00")
    ("notification_topic_arn" "notification_topic_arn – (Optional) An Amazon Resource Name (ARN) of an SNS topic to send ElastiCache notifications to. Example: arn:aws:sns:us-east-1:012345678999:my_sns_topic")
    ("snapshot_window" "snapshot_window - (Optional, Redis only) The daily time range (in UTC) during which ElastiCache will begin taking a daily snapshot of your cache cluster. The minimum snapshot window is a 60 minute period. Example: 05:00-09:00")
    ("snapshot_retention_limit" "snapshot_retention_limit - (Optional, Redis only) The number of days for which ElastiCache will retain automatic cache cluster snapshots before deleting them. For example, if you set SnapshotRetentionLimit to 5, then a snapshot that was taken today will be retained for 5 days before being deleted. If the value of SnapshotRetentionLimit is set to zero (0), backups are turned off. Please note that setting a snapshot_retention_limit is not supported on cache.t1.micro or cache.t2.* cache nodes")
    ("apply_immediately" "apply_immediately - (Optional) Specifies whether any modifications are applied immediately, or during the next maintenance window. Default is false.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource")
    ("cluster_mode" "cluster_mode - (Optional) Create a native redis cluster. automatic_failover_enabled must be set to true. Cluster Mode documented below. Only 1 cluster_mode block is allowed.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticache_security_group" '(
    ("name" "name – (Required) Name for the cache security group. This value is stored as a lowercase string.")
    ("description" "description – (Optional) description for the cache security group. Defaults to \"Managed by Terraform\".")
    ("security_group_names" "security_group_names – (Required) List of EC2 security group names to be authorized for ingress to the cache security group")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticache_subnet_group" '(
    ("name" "name – (Required) Name for the cache subnet group. Elasticache converts this name to lowercase.")
    ("description" "description – (Optional) Description for the cache subnet group. Defaults to \"Managed by Terraform\".")
    ("subnet_ids" "subnet_ids – (Required) List of VPC Subnet IDs for the cache subnet group")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elastic_beanstalk_application" '(
    ("name" "name - (Required) The name of the application, must be unique within your account")
    ("description" "description - (Optional) Short description of the application")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elastic_beanstalk_application_version" '(
    ("name" "name - (Required) A unique name for the this Application Version.")
    ("application" "application - (Required) Name of the Beanstalk Application the version is associated with.")
    ("description" "description - (Optional) Short description of the Application Version.")
    ("bucket" "bucket - (Required) S3 bucket that contains the Application Version source bundle.")
    ("key" "key - (Required) S3 object that is the Application Version source bundle.")
    ("force_delete" "force_delete - (Optional) On delete, force an Application Version to be deleted when it may be in use by multiple Elastic Beanstalk Environments.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elastic_beanstalk_configuration_template" '(
    ("name" "name - (Required) A unique name for this Template.")
    ("application" "application – (Required) name of the application to associate with this configuration template")
    ("description" "description - (Optional) Short description of the Template")
    ("environment_id" "environment_id – (Optional) The ID of the environment used with this configuration template")
    ("setting" "setting – (Optional) Option settings to configure the new Environment. These override specific values that are set as defaults. The format is detailed below in Option Settings")
    ("solution_stack_name" "solution_stack_name – (Optional) A solution stack to base your Template off of. Example stacks can be found in the Amazon API documentation")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elastic_beanstalk_environment" '(
    ("name" "name - (Required) A unique name for this Environment. This name is used in the application URL")
    ("application" "application – (Required) Name of the application that contains the version to be deployed")
    ("cname_prefix" "cname_prefix - (Optional) Prefix to use for the fully qualified DNS name of the Environment.")
    ("description" "description - (Optional) Short description of the Environment")
    ("tier" "tier - (Optional) Elastic Beanstalk Environment tier. Valid values are Worker or WebServer. If tier is left blank WebServer will be used.")
    ("setting" "setting – (Optional) Option settings to configure the new Environment. These override specific values that are set as defaults. The format is detailed below in Option Settings")
    ("solution_stack_name" "solution_stack_name – (Optional) A solution stack to base your environment off of. Example stacks can be found in the Amazon API documentation")
    ("template_name" "template_name – (Optional) The name of the Elastic Beanstalk Configuration template to use in deployment")
    ("wait_for_ready_timeout" "wait_for_ready_timeout - (Default: 20m) The maximum duration that Terraform should wait for an Elastic Beanstalk Environment to be in a ready state before timing out.")
    ("poll_interval" "poll_interval – The time between polling the AWS API to check if changes have been applied. Use this to adjust the rate of API calls for any create or update action. Minimum 10s, maximum 180s. Omit this to use the default behavior, which is an exponential backoff")
    ("version_label" "version_label - (Optional) The name of the Elastic Beanstalk Application Version to use in deployment.")
    ("tags" "tags – (Optional) A set of tags to apply to the Environment.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_emr_cluster" '(
    ("name" "name - (Required) The name of the job flow")
    ("release_label" "release_label - (Required) The release label for the Amazon EMR release")
    ("master_instance_type" "master_instance_type - (Optional) The EC2 instance type of the master node. Exactly one of master_instance_type and instance_group must be specified.")
    ("scale_down_behavior" "scale_down_behavior - (Optional) The way that individual Amazon EC2 instances terminate when an automatic scale-in activity occurs or an instance group is resized.")
    ("service_role" "service_role - (Required) IAM role that will be assumed by the Amazon EMR service to access AWS resources")
    ("security_configuration" "security_configuration - (Optional) The security configuration name to attach to the EMR cluster. Only valid for EMR clusters with release_label 4.8.0 or greater")
    ("core_instance_type" "core_instance_type - (Optional) The EC2 instance type of the slave nodes. Cannot be specified if instance_groups is set")
    ("core_instance_count" "core_instance_count - (Optional) Number of Amazon EC2 instances used to execute the job flow. EMR will use one node as the cluster's master node and use the remainder of the nodes (core_instance_count-1) as core nodes. Cannot be specified if instance_groups is set. Default 1")
    ("instance_group" "instance_group - (Optional) A list of instance_group objects for each instance group in the cluster. Exactly one of master_instance_type and instance_group must be specified. If instance_group is set, then it must contain a configuration block for at least the MASTER instance group type (as well as any additional instance groups). Defined below")
    ("log_uri" "log_uri - (Optional) S3 bucket to write the log files of the job flow. If a value is not provided, logs are not created")
    ("applications" "applications - (Optional) A list of applications for the cluster. Valid values are: Flink, Hadoop, Hive, Mahout, Pig, and Spark. Case insensitive")
    ("termination_protection" "termination_protection - (Optional) Switch on/off termination protection (default is off)")
    ("keep_job_flow_alive_when_no_steps" "keep_job_flow_alive_when_no_steps - (Optional) Switch on/off run cluster with no steps or when all steps are complete (default is on)")
    ("ec2_attributes" "ec2_attributes - (Optional) Attributes for the EC2 instances running the job flow. Defined below")
    ("kerberos_attributes" "kerberos_attributes - (Optional) Kerberos configuration for the cluster. Defined below")
    ("ebs_root_volume_size" "ebs_root_volume_size - (Optional) Size in GiB of the EBS root device volume of the Linux AMI that is used for each EC2 instance. Available in Amazon EMR version 4.x and later.")
    ("custom_ami_id" "custom_ami_id - (Optional) A custom Amazon Linux AMI for the cluster (instead of an EMR-owned AMI). Available in Amazon EMR version 5.7.0 and later.")
    ("bootstrap_action" "bootstrap_action - (Optional) List of bootstrap actions that will be run before Hadoop is started on the cluster nodes. Defined below")
    ("configurations" "configurations - (Optional) List of configurations supplied for the EMR cluster you are creating")
    ("visible_to_all_users" "visible_to_all_users - (Optional) Whether the job flow is visible to all IAM users of the AWS account associated with the job flow. Default true")
    ("autoscaling_role" "autoscaling_role - (Optional) An IAM role for automatic scaling policies. The IAM role provides permissions that the automatic scaling feature requires to launch and terminate EC2 instances in an instance group.")
    ("step" "step - (Optional) List of steps to run when creating the cluster. Defined below. It is highly recommended to utilize the lifecycle configuration block with ignore_changes if other steps are being managed outside of Terraform.")
    ("tags" "tags - (Optional) list of tags to apply to the EMR Cluster")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_emr_instance_group" '(
    ("name" "name (Required) Human friendly name given to the instance group. Changing this forces a new resource to be created.")
    ("cluster_id" "cluster_id (Required) ID of the EMR Cluster to attach to. Changing this forces a new resource to be created.")
    ("instance_type" "instance_type (Required) The EC2 instance type for all instances in the instance group. Changing this forces a new resource to be created.")
    ("instance_count" "instance_count (Optional) Target number of instances for the instance group. Defaults to 0.")
    ("ebs_optimized" "ebs_optimized (Optional) Indicates whether an Amazon EBS volume is EBS-optimized. Changing this forces a new resource to be created.")
    ("ebs_config" "ebs_config (Optional) One or more ebs_config blocks as defined below. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_emr_security_configuration" '(
    ("name" "name - (Optional) The name of the EMR Security Configuration. By default generated by Terraform.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("configuration" "configuration - (Required) A JSON formatted Security Configuration")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticsearch_domain" '(
    ("domain_name" "domain_name - (Required) Name of the domain.")
    ("access_policies" "access_policies - (Optional) IAM policy document specifying the access policies for the domain")
    ("advanced_options" "advanced_options - (Optional) Key-value string pairs to specify advanced configuration options.")
    ("ebs_options" "ebs_options - (Optional) EBS related options, may be required based on chosen instance size. See below.")
    ("encrypt_at_rest" "encrypt_at_rest - (Optional) Encrypt at rest options. Only available for certain instance types. See below.")
    ("cluster_config" "cluster_config - (Optional) Cluster configuration of the domain, see below.")
    ("snapshot_options" "snapshot_options - (Optional) Snapshot related options, see below.")
    ("vpc_options" "vpc_options - (Optional) VPC related options, see below. Adding or removing this configuration forces a new resource (documentation).")
    ("log_publishing_options" "log_publishing_options - (Optional) Options for publishing slow logs to CloudWatch Logs.")
    ("elasticsearch_version" "elasticsearch_version - (Optional) The version of ElasticSearch to deploy. Defaults to 1.5")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elasticsearch_domain_policy" '(
    ("domain_name" "domain_name - (Required) Name of the domain.")
    ("access_policies" "access_policies - (Optional) IAM policy document specifying the access policies for the domain")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elastictranscoder_pipeline" '(
    ("aws_kms_key_arn" "aws_kms_key_arn - (Optional) The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.")
    ("content_config" "content_config - (Optional) The ContentConfig object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. (documented below)")
    ("content_config_permissions" "content_config_permissions - (Optional) The permissions for the content_config object. (documented below)")
    ("input_bucket" "input_bucket - (Required) The Amazon S3 bucket in which you saved the media files that you want to transcode and the graphics that you want to use as watermarks.")
    ("name" "name - (Optional, Forces new resource) The name of the pipeline. Maximum 40 characters")
    ("notifications" "notifications - (Optional) The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. (documented below)")
    ("output_bucket" "output_bucket - (Optional) The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files.")
    ("role" "role - (Required) The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to transcode jobs for this pipeline.")
    ("thumbnail_config" "thumbnail_config - (Optional) The ThumbnailConfig object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. (documented below)")
    ("thumbnail_config_permissions" "thumbnail_config_permissions - (Optional) The permissions for the thumbnail_config object. (documented below)")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_elastictranscoder_preset" '(
    ("audio" "audio - (Optional, Forces new resource) Audio parameters object (documented below).")
    ("audio_codec_options" "audio_codec_options - (Optional, Forces new resource) Codec options for the audio parameters (documented below)")
    ("container" "container - (Required, Forces new resource) The container type for the output file. Valid values are flac, flv, fmp4, gif, mp3, mp4, mpg, mxf, oga, ogg, ts, and webm.")
    ("description" "description - (Optional, Forces new resource) A description of the preset (maximum 255 characters)")
    ("name" "name - (Optional, Forces new resource) The name of the preset. (maximum 40 characters)")
    ("thumbnails" "thumbnails - (Optional, Forces new resource) Thumbnail parameters object (documented below)")
    ("video" "video - (Optional, Forces new resource) Video parameters object (documented below)")
    ("video_watermarks" "video_watermarks - (Optional, Forces new resource) Watermark parameters for the video parameters (documented below)")
    ("video_codec_options" "video_codec_options (Optional, Forces new resource) Codec options for the video parameters")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_gamelift_alias" '(
    ("name" "name - (Required) Name of the alias.")
    ("description" "description - (Optional) Description of the alias.")
    ("routing_strategy" "routing_strategy - (Required) Specifies the fleet and/or routing type to use for the alias.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_gamelift_build" '(
    ("name" "name - (Required) Name of the build")
    ("operating_system" "operating_system - (Required) Operating system that the game server binaries are built to run on. e.g. WINDOWS_2012 or AMAZON_LINUX.")
    ("storage_location" "storage_location - (Required) Information indicating where your game build files are stored. See below.")
    ("version" "version - (Optional) Version that is associated with this build.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_gamelift_fleet" '(
    ("build_id" "build_id - (Required) ID of the Gamelift Build to be deployed on the fleet.")
    ("ec2_instance_type" "ec2_instance_type - (Required) Name of an EC2 instance type. e.g. t2.micro")
    ("name" "name - (Required) The name of the fleet.")
    ("description" "description - (Optional) Human-readable description of the fleet.")
    ("ec2_inbound_permission" "ec2_inbound_permission - (Optional) Range of IP addresses and port settings that permit inbound traffic to access server processes running on the fleet. See below.")
    ("metric_groups" "metric_groups - (Optional) List of names of metric groups to add this fleet to. A metric group tracks metrics across all fleets in the group. Defaults to default.")
    ("new_game_session_protection_policy" "new_game_session_protection_policy - (Optional) Game session protection policy to apply to all instances in this fleet. e.g. FullProtection. Defaults to NoProtection.")
    ("resource_creation_limit_policy" "resource_creation_limit_policy - (Optional) Policy that limits the number of game sessions an individual player can create over a span of time for this fleet. See below.")
    ("runtime_configuration" "runtime_configuration - (Optional) Instructions for launching server processes on each instance in the fleet. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_glacier_vault" '(
    ("name" "name - (Required) The name of the Vault. Names can be between 1 and 255 characters long and the valid characters are a-z, A-Z, 0-9, '_' (underscore), '-' (hyphen), and '.' (period).")
    ("access_policy" "access_policy - (Optional) The policy document. This is a JSON formatted string. The heredoc syntax or file function is helpful here. Use the Glacier Developer Guide for more information on Glacier Vault Policy")
    ("notification" "notification - (Optional) The notifications for the Vault. Fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_glue_catalog_database" '(
    ("name" "name - (Required) The name of the database.")
    ("catalog_id" "catalog_id - (Optional) ID of the Glue Catalog to create the database in. If omitted, this defaults to the AWS Account ID.")
    ("description" "description - (Optional) Description of the database.")
    ("location_uri" "location_uri - (Optional) The location of the database (for example, an HDFS path).")
    ("parameters" "parameters - (Optional) A list of key-value pairs that define parameters and properties of the database.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_glue_catalog_table" '(
    ("name" "name - (Required) Name of the table. For Hive compatibility, this must be entirely lowercase.")
    ("database_name" "database_name - (Required) Name of the metadata database where the table metadata resides. For Hive compatibility, this must be all lowercase.")
    ("catalog_id" "catalog_id - (Optional) ID of the Glue Catalog and database to create the table in. If omitted, this defaults to the AWS Account ID plus the database name.")
    ("description" "description - (Optional) Description of the table.")
    ("owner" "owner - (Optional) Owner of the table.")
    ("retention" "retention - (Optional) Retention time for this table.")
    ("storage_descriptor" "storage_descriptor - (Optional) A storage descriptor object containing information about the physical storage of this table. You can refer to the Glue Developer Guide for a full explanation of this object.")
    ("partition_keys" "partition_keys - (Optional) A list of columns by which the table is partitioned. Only primitive types are supported as partition keys.")
    ("view_original_text" "view_original_text - (Optional) If the table is a view, the original text of the view; otherwise null.")
    ("view_expanded_text" "view_expanded_text - (Optional) If the table is a view, the expanded text of the view; otherwise null.")
    ("table_type" "table_type - (Optional) The type of this table (EXTERNAL_TABLE, VIRTUAL_VIEW, etc.).")
    ("parameters" "parameters - (Optional) Properties associated with this table, as a list of key-value pairs.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_glue_connection" '(
    ("catalog_id" "catalog_id – (Optional) The ID of the Data Catalog in which to create the connection. If none is supplied, the AWS account ID is used by default.")
    ("connection_properties" "connection_properties – (Required) A map of key-value pairs used as parameters for this connection.")
    ("connection_type" "connection_type – (Optional) The type of the connection. Defaults to JBDC.")
    ("description" "description – (Optional) Description of the connection.")
    ("match_criteria" "match_criteria – (Optional) A list of criteria that can be used in selecting this connection.")
    ("name" "name – (Required) The name of the connection.")
    ("physical_connection_requirements" "physical_connection_requirements - (Optional) A map of physical connection requirements, such as VPC and SecurityGroup. Defined below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_glue_job" '(
    ("allocated_capacity" "allocated_capacity – (Optional) The number of AWS Glue data processing units (DPUs) to allocate to this Job. At least 2 DPUs need to be allocated; the default is 10. A DPU is a relative measure of processing power that consists of 4 vCPUs of compute capacity and 16 GB of memory.")
    ("command" "command – (Required) The command of the job. Defined below.")
    ("connections" "connections – (Optional) The list of connections used for this job.")
    ("default_arguments" "default_arguments – (Optional) The map of default arguments for this job. You can specify arguments here that your own job-execution script consumes, as well as arguments that AWS Glue itself consumes. For information about how to specify and consume your own Job arguments, see the Calling AWS Glue APIs in Python topic in the developer guide. For information about the key-value pairs that AWS Glue consumes to set up your job, see the Special Parameters Used by AWS Glue topic in the developer guide.")
    ("description" "description – (Optional) Description of the job.")
    ("execution_property" "execution_property – (Optional) Execution property of the job. Defined below.")
    ("max_retries" "max_retries – (Optional) The maximum number of times to retry this job if it fails.")
    ("name" "name – (Required) The name you assign to this job. It must be unique in your account.")
    ("role" "role – (Required) The ARN of the IAM role associated with this job.")
    ("timeout" "timeout – (Optional) The job timeout in minutes. The default is 2880 minutes (48 hours).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_guardduty_detector" '(
    ("enable" "enable - (Optional) Enable monitoring and feedback reporting. Setting to false is equivalent to \"suspending\" GuardDuty. Defaults to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_guardduty_ipset" '(
    ("activate" "activate - (Required) Specifies whether GuardDuty is to start using the uploaded IPSet.")
    ("detector_id" "detector_id - (Required) The detector ID of the GuardDuty.")
    ("format" "format - (Required) The format of the file that contains the IPSet. Valid values: TXT | STIX | OTX_CSV | ALIEN_VAULT | PROOF_POINT | FIRE_EYE")
    ("location" "location - (Required) The URI of the file that contains the IPSet.")
    ("name" "name - (Required) The friendly name to identify the IPSet.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_guardduty_member" '(
    ("account_id" "account_id - (Required) AWS account ID for member account.")
    ("detector_id" "detector_id - (Required) The detector ID of the GuardDuty account where you want to create member accounts.")
    ("email" "email - (Required) Email address for member account.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_guardduty_threatintelset" '(
    ("activate" "activate - (Required) Specifies whether GuardDuty is to start using the uploaded ThreatIntelSet.")
    ("detector_id" "detector_id - (Required) The detector ID of the GuardDuty.")
    ("format" "format - (Required) The format of the file that contains the ThreatIntelSet. Valid values: TXT | STIX | OTX_CSV | ALIEN_VAULT | PROOF_POINT | FIRE_EYE")
    ("location" "location - (Required) The URI of the file that contains the ThreatIntelSet.")
    ("name" "name - (Required) The friendly name to identify the ThreatIntelSet.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_access_key" '(
    ("user" "user - (Required) The IAM user to associate with this access key.")
    ("pgp_key" "pgp_key - (Optional) Either a base-64 encoded PGP public key, or a keybase username in the form keybase:some_person_that_exists.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_account_alias" '(
    ("account_alias" "account_alias - (Required) The account alias")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_account_password_policy" '(
    ("allow_users_to_change_password" "allow_users_to_change_password - (Optional) Whether to allow users to change their own password")
    ("hard_expiry" "hard_expiry - (Optional) Whether users are prevented from setting a new password after their password has expired (i.e. require administrator reset)")
    ("max_password_age" "max_password_age - (Optional) The number of days that an user password is valid.")
    ("minimum_password_length" "minimum_password_length - (Optional) Minimum length to require for user passwords.")
    ("password_reuse_prevention" "password_reuse_prevention - (Optional) The number of previous passwords that users are prevented from reusing.")
    ("require_lowercase_characters" "require_lowercase_characters - (Optional) Whether to require lowercase characters for user passwords.")
    ("require_numbers" "require_numbers - (Optional) Whether to require numbers for user passwords.")
    ("require_symbols" "require_symbols - (Optional) Whether to require symbols for user passwords.")
    ("require_uppercase_characters" "require_uppercase_characters - (Optional) Whether to require uppercase characters for user passwords.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_group" '(
    ("name" "name - (Required) The group's name. The name must consist of upper and lowercase alphanumeric characters with no spaces. You can also include any of the following characters: =,.@-_.. Group names are not distinguished by case. For example, you cannot create groups named both \"ADMINS\" and \"admins\".")
    ("path" "path - (Optional, default \"/\") Path in which to create the group.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_group_membership" '(
    ("name" "name - (Required) The name to identify the Group Membership")
    ("users" "users - (Required) A list of IAM User names to associate with the Group")
    ("group" "group – (Required) The IAM Group name to attach the list of users to")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_group_policy" '(
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string. The heredoc syntax or file function is helpful here.")
    ("name" "name - (Optional) The name of the policy. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("group" "group - (Required) The IAM group to attach to the policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_group_policy_attachment" '(
    ("group" "group       (Required) - The group the policy should be applied to")
    ("policy_arn" "policy_arn  (Required) - The ARN of the policy you want to apply")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_instance_profile" '(
    ("name" "name - (Optional, Forces new resource) The profile's name. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("path" "path - (Optional, default \"/\") Path in which to create the profile.")
    ("roles" "roles - (Deprecated) A list of role names to include in the profile.  The current default is 1.  If you see an error message similar to Cannot exceed quota for InstanceSessionsPerInstanceProfile: 1, then you must contact AWS support and ask for a limit increase. WARNING: This is deprecated since version 0.9.3 (April 12, 2017), as >= 2 roles are not possible. See issue #11575.")
    ("role" "role - (Optional) The role name to include in the profile.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_openid_connect_provider" '(
    ("url" "url - (Required) The URL of the identity provider. Corresponds to the iss claim.")
    ("client_id_list" "client_id_list - (Required) A list of client IDs (also known as audiences). When a mobile or web app registers with an OpenID Connect provider, they establish a value that identifies the application. (This is the value that's sent as the client_id parameter on OAuth requests.)")
    ("thumbprint_list" "thumbprint_list - (Required) A list of server certificate thumbprints for the OpenID Connect (OIDC) identity provider's server certificate(s).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_policy" '(
    ("description" "description - (Optional) Description of the IAM policy.")
    ("name" "name - (Optional, Forces new resource) The name of the policy. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("path" "path - (Optional, default \"/\") Path in which to create the policy. See IAM Identifiers for more information.")
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string. The heredoc syntax, file function, or the aws_iam_policy_document data source are all helpful here.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_policy_attachment" '(
    ("name" "name        (Required) - The name of the attachment. This cannot be an empty string.")
    ("users" "users       (Optional) - The user(s) the policy should be applied to")
    ("roles" "roles       (Optional) - The role(s) the policy should be applied to")
    ("groups" "groups      (Optional) - The group(s) the policy should be applied to")
    ("policy_arn" "policy_arn  (Required) - The ARN of the policy you want to apply")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_role" '(
    ("name" "name - (Optional, Forces new resource) The name of the role. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("assume_role_policy" "assume_role_policy - (Required) The policy that grants an entity permission to assume the role.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_role_policy" '(
    ("name" "name - (Optional) The name of the role policy. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string. The heredoc syntax or file function is helpful here.")
    ("role" "role - (Required) The IAM role to attach to the policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_role_policy_attachment" '(
    ("role" "role        (Required) - The role the policy should be applied to")
    ("policy_arn" "policy_arn  (Required) - The ARN of the policy you want to apply")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_saml_provider" '(
    ("name" "name - (Required) The name of the provider to create.")
    ("saml_metadata_document" "saml_metadata_document - (Required) An XML document generated by an identity provider that supports SAML 2.0.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_server_certificate" '(
    ("name" "name - (Optional) The name of the Server Certificate. Do not include the path in this value. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("certificate_body" "certificate_body – (Required) The contents of the public key certificate in PEM-encoded format.")
    ("certificate_chain" "certificate_chain – (Optional) The contents of the certificate chain. This is typically a concatenation of the PEM-encoded public key certificates of the chain.")
    ("private_key" "private_key – (Required) The contents of the private key in PEM-encoded format.")
    ("path" "path - (Optional) The IAM path for the server certificate.  If it is not included, it defaults to a slash (/). If this certificate is for use with AWS CloudFront, the path must be in format /cloudfront/your_path_here. See IAM Identifiers for more details on IAM Paths.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_service_linked_role" '(
    ("aws_service_name" "aws_service_name - (Required, Forces new resource) The AWS service to which this role is attached. You use a string similar to a URL but without the http:// in front. For example: elasticbeanstalk.amazonaws.com. To find the full list of services that support service-linked roles, check the docs.")
    ("custom_suffix" "custom_suffix - (Optional, forces new resource) Additional string appended to the role name. Not all AWS services support custom suffixes.")
    ("description" "description - (Optional) The description of the role.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_user" '(
    ("name" "name - (Required) The user's name. The name must consist of upper and lowercase alphanumeric characters with no spaces. You can also include any of the following characters: =,.@-_.. User names are not distinguished by case. For example, you cannot create users named both \"TESTUSER\" and \"testuser\".")
    ("path" "path - (Optional, default \"/\") Path in which to create the user.")
    ("force_destroy" "force_destroy - (Optional, default false) When destroying this user, destroy even if it has non-Terraform-managed IAM access keys, login profile or MFA devices. Without force_destroy a user with non-Terraform-managed access keys and login profile will fail to be destroyed.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_user_group_membership" '(
    ("user" "user - (Required) The name of the IAM User to add to groups")
    ("groups" "groups - (Required) A list of IAM Groups to add the user to")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_user_login_profile" '(
    ("user" "user - (Required) The IAM user's name.")
    ("pgp_key" "pgp_key - (Required) Either a base-64 encoded PGP public key, or a keybase username in the form keybase:username.")
    ("password_reset_required" "password_reset_required - (Optional, default \"true\") Whether the user should be forced to reset the generated password on first login.")
    ("password_length" "password_length - (Optional, default 20) The length of the generated password.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_user_policy" '(
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string. The heredoc syntax or file function is helpful here.")
    ("name" "name - (Optional) The name of the policy. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("user" "user - (Required) IAM user to which to attach this policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_user_policy_attachment" '(
    ("user" "user        (Required) - The user the policy should be applied to")
    ("policy_arn" "policy_arn  (Required) - The ARN of the policy you want to apply")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iam_user_ssh_key" '(
    ("username" "username - (Required) The name of the IAM user to associate the SSH public key with.")
    ("encoding" "encoding - (Required) Specifies the public key encoding format to use in the response. To retrieve the public key in ssh-rsa format, use SSH. To retrieve the public key in PEM format, use PEM.")
    ("public_key" "public_key - (Required) The SSH public key. The public key must be encoded in ssh-rsa format or PEM format.")
    ("status" "status - (Optional) The status to assign to the SSH public key. Active means the key can be used for authentication with an AWS CodeCommit repository. Inactive means the key cannot be used. Default is active.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iot_certificate" '(
    ("active" "active - (Required)  Boolean flag to indicate if the certificate should be active")
    ("csr" "csr - (Required) The certificate signing request. Review the IoT API Reference Guide for more information on creating a certificate from a certificate signing request (CSR).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iot_policy" '(
    ("name" "name - (Required) The name of the policy.")
    ("policy" "policy - (Required) The policy document. This is a JSON formatted string. The heredoc syntax or file function is helpful here. Use the IoT Developer Guide for more information on IoT Policies")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iot_topic_rule" '(
    ("name" "name - (Required) The name of the rule.")
    ("description" "description - (Optional) The description of the rule.")
    ("enabled" "enabled - (Required) Specifies whether the rule is enabled.")
    ("sql" "sql - (Required) The SQL statement used to query the topic. For more information, see AWS IoT SQL Reference (http://docs.aws.amazon.com/iot/latest/developerguide/iot-rules.html#aws-iot-sql-reference) in the AWS IoT Developer Guide.")
    ("sql_version" "sql_version - (Required) The version of the SQL rules engine to use when evaluating the rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iot_thing" '(
    ("name" "name - (Required) The name of the thing.")
    ("attributes" "attributes - (Optional) Map of attributes of the thing.")
    ("thing_type_name" "thing_type_name - (Optional) The thing type name.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_iot_thing_type" '(
    ("name" "name - (Required, Forces New Resource) The name of the thing type.")
    ("description" "description - (Optional, Forces New Resource) The description of the thing type.")
    ("deprecated" "deprecated - (Optional, Defaults to false) Whether the thing type is deprecated. If true, no new things could be associated with this type.")
    ("searchable_attributes" "searchable_attributes - (Optional, Forces New Resource) A list of searchable thing attribute names.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_inspector_assessment_target" '(
    ("name" "name - (Required) The name of the assessment target.")
    ("resource_group_arn" "resource_group_arn (Required )- The resource group ARN stating tags for instance matching.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_inspector_assessment_template" '(
    ("name" "name - (Required) The name of the assessment template.")
    ("target_arn" "target_arn - (Required) The assessment target ARN to attach the template to.")
    ("duration" "duration - (Required) The duration of the inspector run.")
    ("rules_package_arns" "rules_package_arns - (Required) The rules to be used during the run.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_inspector_resource_group" '(
    ("tags" "tags - (Required) The tags on your EC2 Instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_kinesis_stream" '(
    ("name" "name - (Required) A name to identify the stream. This is unique to the AWS account and region the Stream is created in.")
    ("shard_count" "shard_count – (Required) The number of shards that the stream will use. Amazon has guidlines for specifying the Stream size that should be referenced when creating a Kinesis stream. See Amazon Kinesis Streams for more.")
    ("retention_period" "retention_period - (Optional) Length of time data records are accessible after they are added to the stream. The maximum value of a stream's retention period is 168 hours. Minimum value is 24. Default is 24.")
    ("shard_level_metrics" "shard_level_metrics - (Optional) A list of shard-level CloudWatch metrics which can be enabled for the stream. See Monitoring with CloudWatch for more. Note that the value ALL should not be used; instead you should provide an explicit list of metrics you wish to enable.")
    ("encryption_type" "encryption_type - (Optional) The encryption type to use. The only acceptable values are NONE or KMS. The default value is NONE.")
    ("kms_key_id" "kms_key_id - (Optional) The GUID for the customer-managed KMS key to use for encryption. You can also use a Kinesis-owned master key by specifying the alias aws/kinesis.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_kinesis_firehose_delivery_stream" '(
    ("name" "name - (Required) A name to identify the stream. This is unique to the AWS account and region the Stream is created in.")
    ("kinesis_source_configuration" "kinesis_source_configuration - (Optional) Allows the ability to specify the kinesis stream that is used as the source of the firehose delivery stream.")
    ("destination" "destination – (Required) This is the destination to where the data is delivered. The only options are s3 (Deprecated, use extended_s3 instead), extended_s3, redshift, and elasticsearch.")
    ("s3_configuration" "s3_configuration - (Optional, Deprecated, see/use extended_s3_configuration unless destination is redshift) Configuration options for the s3 destination (or the intermediate bucket if the destination is redshift). More details are given below.")
    ("extended_s3_configuration" "extended_s3_configuration - (Optional, only Required when destination is extended_s3) Enhanced configuration options for the s3 destination. More details are given below.")
    ("redshift_configuration" "redshift_configuration - (Optional) Configuration options if redshift is the destination. Using redshift_configuration requires the user to also specify a s3_configuration block. More details are given below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_kms_alias" '(
    ("name" "name - (Optional) The display name of the alias. The name must start with the word \"alias\" followed by a forward slash (alias/)")
    ("name_prefix" "name_prefix - (Optional) Creates an unique alias beginning with the specified prefix. The name must start with the word \"alias\" followed by a forward slash (alias/).  Conflicts with name.")
    ("target_key_id" "target_key_id - (Required) Identifier for the key for which the alias is for, can be either an ARN or key_id.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_kms_grant" '(
    ("name" "name - (Optional, Forces new resources) A friendly name for identifying the grant.")
    ("key_id" "key_id - (Required, Forces new resources) The unique identifier for the customer master key (CMK) that the grant applies to.")
    ("grantee_principal" "grantee_principal - (Required, Forces new resources) The principal that is given permission to perform the operations that the grant permits in ARN format. Note that due to eventual consistency issues around IAM principals, terraform's state may not always be refreshed to reflect what is true in AWS.")
    ("operations" "operations - (Required, Forces new resources) A list of operations that the grant permits. The permitted values are: Decrypt, Encrypt, GenerateDataKey, GenerateDataKeyWithoutPlaintext, ReEncryptFrom, ReEncryptTo, CreateGrant, RetireGrant, DescribeKey")
    ("retiree_principal" "retiree_principal - (Optional, Forces new resources) The principal that is given permission to retire the grant by using RetireGrant operation in ARN format. Note that due to eventual consistency issues around IAM principals, terraform's state may not always be refreshed to reflect what is true in AWS.")
    ("constraints" "constraints - (Optional, Forces new resources) A structure that you can use to allow certain operations in the grant only when the desired encryption context is present. For more information about encryption context, see Encryption Context.")
    ("grant_creation_tokens" "grant_creation_tokens - (Optional, Forces new resources) A list of grant tokens to be used when creating the grant. See Grant Tokens for more information about grant tokens.")
    ("retire_on_delete" "retire_on_delete -(Defaults to false, Forces new resources) If set to false (the default) the grants will be revoked upon deletion, and if set to true the grants will try to be retired upon deletion. Note that retiring grants requires special permissions, hence why we default to revoking grants. See RetireGrant for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_kms_key" '(
    ("description" "description - (Optional) The description of the key as viewed in AWS console.")
    ("key_usage" "key_usage - (Optional) Specifies the intended use of the key. Defaults to ENCRYPT_DECRYPT, and only symmetric encryption and decryption are supported.")
    ("policy" "policy - (Optional) A valid policy JSON document.")
    ("deletion_window_in_days" "deletion_window_in_days - (Optional) Duration in days after which the key is deleted after destruction of the resource, must be between 7 and 30 days. Defaults to 30 days.")
    ("is_enabled" "is_enabled - (Optional) Specifies whether the key is enabled. Defaults to true.")
    ("enable_key_rotation" "enable_key_rotation - (Optional) Specifies whether key rotation is enabled. Defaults to false.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the object.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lambda_alias" '(
    ("name" "name - (Required) Name for the alias you are creating. Pattern: (?!^[0-9]+$)([a-zA-Z0-9-_]+)")
    ("description" "description - (Optional) Description of the alias.")
    ("function_name" "function_name - (Required) The function ARN of the Lambda function for which you want to create an alias.")
    ("function_version" "function_version - (Required) Lambda function version for which you are creating the alias. Pattern: (\\$LATEST|[0-9]+).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lambda_event_source_mapping" '(
    ("batch_size" "batch_size - (Optional) The largest number of records that Lambda will retrieve from your event source at the time of invocation. Defaults to 100.")
    ("event_source_arn" "event_source_arn - (Required) The event source ARN - can either be a Kinesis or DynamoDB stream.")
    ("enabled" "enabled - (Optional) Determines if the mapping will be enabled on creation. Defaults to true.")
    ("function_name" "function_name - (Required) The name or the ARN of the Lambda function that will be subscribing to events.")
    ("starting_position" "starting_position - (Required) The position in the stream where AWS Lambda should start reading. Can be one of either TRIM_HORIZON or LATEST.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lambda_function" '(
    ("filename" "filename - (Optional) The path to the function's deployment package within the local filesystem. If defined, The s3_-prefixed options cannot be used.")
    ("s3_bucket" "s3_bucket - (Optional) The S3 bucket location containing the function's deployment package. Conflicts with filename. This bucket must reside in the same AWS region where you are creating the Lambda function.")
    ("s3_key" "s3_key - (Optional) The S3 key of an object containing the function's deployment package. Conflicts with filename.")
    ("s3_object_version" "s3_object_version - (Optional) The object version containing the function's deployment package. Conflicts with filename.")
    ("function_name" "function_name - (Required) A unique name for your Lambda Function.")
    ("dead_letter_config" "dead_letter_config - (Optional) Nested block to configure the function's dead letter queue. See details below.")
    ("handler" "handler - (Required) The function entrypoint in your code.")
    ("role" "role - (Required) IAM role attached to the Lambda Function. This governs both who / what can invoke your Lambda Function, as well as what resources our Lambda Function has access to. See Lambda Permission Model for more details.")
    ("description" "description - (Optional) Description of what your Lambda Function does.")
    ("memory_size" "memory_size - (Optional) Amount of memory in MB your Lambda Function can use at runtime. Defaults to 128. See Limits")
    ("runtime" "runtime - (Required) See Runtimes for valid values.")
    ("timeout" "timeout - (Optional) The amount of time your Lambda Function has to run in seconds. Defaults to 3. See Limits")
    ("reserved_concurrent_executions" "reserved_concurrent_executions - (Optional) The amount of reserved concurrent executions for this lambda function. Defaults to Unreserved Concurrency Limits. See Managing Concurrency")
    ("publish" "publish - (Optional) Whether to publish creation/change as new Lambda Function Version. Defaults to false.")
    ("vpc_config" "vpc_config - (Optional) Provide this to allow your function to access your VPC. Fields documented below. See Lambda in VPC")
    ("environment" "environment - (Optional) The Lambda environment's configuration settings. Fields documented below.")
    ("kms_key_arn" "kms_key_arn - (Optional) The ARN for the KMS encryption key.")
    ("source_code_hash" "source_code_hash - (Optional) Used to trigger updates. Must be set to a base64-encoded SHA256 hash of the package file specified with either filename or s3_key. The usual way to set this is ${base64sha256(file(\"file.zip\"))}, where \"file.zip\" is the local filename of the lambda function source archive.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the object.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lambda_permission" '(
    ("action" "action - (Required) The AWS Lambda action you want to allow in this statement. (e.g. lambda:InvokeFunction)")
    ("function_name" "function_name - (Required) Name of the Lambda function whose resource policy you are updating")
    ("principal" "principal - (Required) The principal who is getting this permission. e.g. s3.amazonaws.com, an AWS account ID, or any valid AWS service principal such as events.amazonaws.com or sns.amazonaws.com.")
    ("qualifier" "qualifier - (Optional) Query parameter to specify function version or alias name. The permission will then apply to the specific qualified ARN. e.g. arn:aws:lambda:aws-region:acct-id:function:function-name:2")
    ("source_account" "source_account - (Optional) This parameter is used for S3 and SES. The AWS account ID (without a hyphen) of the source owner.")
    ("source_arn" "source_arn - (Optional) When granting Amazon S3 or CloudWatch Events permission to invoke your function, you should specify this field with the Amazon Resource Name (ARN) for the S3 Bucket or CloudWatch Events Rule as its value.  This ensures that only events generated from the specified bucket or rule can invoke the function. API Gateway ARNs have a unique structure described here.")
    ("statement_id" "statement_id - (Optional) A unique statement identifier. By default generated by Terraform.")
    ("statement_id_prefix" "statement_id_prefix - (Optional) A statement identifier prefix. Terraform will generate a unique suffix. Conflicts with statement_id.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lightsail_domain" '(
    ("domain_name" "domain_name - (Required) The name of the Lightsail domain to manage")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lightsail_instance" '(
    ("name" "name - (Required) The name of the Lightsail Instance")
    ("availability_zone" "availability_zone - (Required) The Availability Zone in which to create your instance. At this time, must be in us-east-1, us-east-2, us-west-2, eu-west-1, eu-west-2, eu-central-1, ap-southeast-1, ap-southeast-2, ap-northeast-1, ap-south-1 regions")
    ("blueprint_id" "blueprint_id - (Required) The ID for a virtual private server image (see list below)")
    ("bundle_id" "bundle_id - (Required) The bundle of specification information (see list below)")
    ("key_pair_name" "key_pair_name - (Required) The name of your key pair. Created in the Lightsail console (cannot use aws_key_pair at this time)")
    ("user_data" "user_data - (Optional) launch script to configure server with additional user data")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lightsail_key_pair" '(
    ("name" "name - (Optional) The name of the Lightsail Key Pair. If omitted, a unique name will be generated by Terraform")
    ("pgp_key" "pgp_key – (Optional) An optional PGP key to encrypt the resulting private key material. Only used when creating a new key pair")
    ("public_key" "public_key - (Required) The public key material. This public key will be imported into Lightsail")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lightsail_static_ip" '(
    ("name" "name - (Required) The name for the allocated static IP")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_lightsail_static_ip_attachment" '(
    ("static_ip_name" "static_ip_name - (Required) The name of the allocated static IP")
    ("instance_name" "instance_name - (Required) The name of the Lightsail instance to attach the IP to")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_mq_broker" '(
    ("apply_immediately" "apply_immediately - (Optional) Specifies whether any broker modifications are applied immediately, or during the next maintenance window. Default is false.")
    ("auto_minor_version_upgrade" "auto_minor_version_upgrade - (Optional) Enables automatic upgrades to new minor versions for brokers, as Apache releases the versions.")
    ("broker_name" "broker_name - (Required) The name of the broker.")
    ("configuration" "configuration - (Optional) Configuration of the broker. See below.")
    ("deployment_mode" "deployment_mode - (Optional) The deployment mode of the broker. Supported: SINGLE_INSTANCE and ACTIVE_STANDBY_MULTI_AZ. Defaults to SINGLE_INSTANCE.")
    ("engine_type" "engine_type - (Required) The type of broker engine. Currently, Amazon MQ supports only ActiveMQ.")
    ("engine_version" "engine_version - (Required) The version of the broker engine. Currently, Amazon MQ supports only 5.15.0.")
    ("host_instance_type" "host_instance_type - (Required) The broker's instance type. e.g. mq.t2.micro or mq.m4.large")
    ("publicly_accessible" "publicly_accessible - (Optional) Whether to enable connections from applications outside of the VPC that hosts the broker's subnets.")
    ("security_groups" "security_groups - (Required) The list of security group IDs assigned to the broker.")
    ("subnet_ids" "subnet_ids - (Optional) The list of subnet IDs in which to launch the broker. A SINGLE_INSTANCE deployment requires one subnet. An ACTIVE_STANDBY_MULTI_AZ deployment requires two subnets.")
    ("maintenance_window_start_time" "maintenance_window_start_time - (Optional) Maintenance window start time. See below.")
    ("user" "user - (Optional) The list of all ActiveMQ usernames for the specified broker. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_mq_configuration" '(
    ("data" "data - (Required) The broker configuration in XML format. See official docs for supported parameters and format of the XML.")
    ("description" "description - (Optional) The description of the configuration.")
    ("engine_type" "engine_type - (Required) The type of broker engine.")
    ("engine_version" "engine_version - (Required) The version of the broker engine.")
    ("name" "name - (Required) The name of the configuration")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_media_store_container" '(
    ("name" "name - (Required) The name of the container. Must contain alphanumeric characters or underscores.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_application" '(
    ("name" "name - (Required) A human-readable name for the application.")
    ("short_name" "short_name - (Required) A short, machine-readable name for the application. This can only be defined on resource creation and ignored on resource update.")
    ("stack_id" "stack_id - (Required) The id of the stack the application will belong to.")
    ("type" "type - (Required) Opsworks application type. One of aws-flow-ruby, java, rails, php, nodejs, static or other.")
    ("description" "description - (Optional) A description of the app.")
    ("environment" "environment - (Optional) Object to define environment variables.  Object is described below.")
    ("enable_ssl" "enable_ssl - (Optional) Whether to enable SSL for the app. This must be set in order to let ssl_configuration.private_key, ssl_configuration.certificate and ssl_configuration.chain take effect.")
    ("ssl_configuration" "ssl_configuration - (Optional) The SSL configuration of the app. Object is described below.")
    ("app_source" "app_source - (Optional) SCM configuration of the app as described below.")
    ("data_source_arn" "data_source_arn - (Optional) The data source's ARN.")
    ("data_source_type" "data_source_type - (Optional) The data source's type one of AutoSelectOpsworksMysqlInstance, OpsworksMysqlInstance, or RdsDbInstance.")
    ("data_source_database_name" "data_source_database_name - (Optional) The database name.")
    ("domains" "domains -  (Optional) A list of virtual host alias.")
    ("document_root" "document_root - (Optional) Subfolder for the document root for application of type rails.")
    ("auto_bundle_on_deploy" "auto_bundle_on_deploy - (Optional) Run bundle install when deploying for application of type rails.")
    ("rails_env" "rails_env - (Required if type = rails) The name of the Rails environment for application of type rails.")
    ("aws_flow_ruby_settings" "aws_flow_ruby_settings - (Optional) Specify activity and workflow workers for your app using the aws-flow gem.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_custom_layer" '(
    ("name" "name - (Required) A human-readable name for the layer.")
    ("short_name" "short_name - (Required) A short, machine-readable name for the layer, which will be used to identify it in the Chef node JSON.")
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_ganglia_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("password" "password - (Required) The password to use for Ganglia.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("url" "url - (Optional) The URL path to use for Ganglia. Defaults to \"/ganglia\".")
    ("username" "username - (Optiona) The username to use for Ganglia. Defaults to \"opsworks\".")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_haproxy_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("stats_password" "stats_password - (Required) The password to use for HAProxy stats.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("healthcheck_method" "healthcheck_method - (Optional) HTTP method to use for instance healthchecks. Defaults to \"OPTIONS\".")
    ("healthcheck_url" "healthcheck_url - (Optional) URL path to use for instance healthchecks. Defaults to \"/\".")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("stats_enabled" "stats_enabled - (Optional) Whether to enable HAProxy stats.")
    ("stats_url" "stats_url - (Optional) The HAProxy stats URL. Defaults to \"/haproxy?stats\".")
    ("stats_user" "stats_user - (Optional) The username for HAProxy stats. Defaults to \"opsworks\".")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_instance" '(
    ("instance_type" "instance_type - (Required) The type of instance to start")
    ("stack_id" "stack_id - (Required) The id of the stack the instance will belong to.")
    ("layer_ids" "layer_ids - (Required) The ids of the layers the instance will belong to.")
    ("state" "state - (Optional) The desired state of the instance.  Can be either \"running\" or \"stopped\".")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Controls where to install OS and package updates when the instance boots.  Defaults to true.")
    ("auto_scaling_type" "auto_scaling_type - (Optional) Creates load-based or time-based instances.  If set, can be either: \"load\" or \"timer\".")
    ("availability_zone" "availability_zone - (Optional) Name of the availability zone where instances will be created by default.")
    ("ebs_optimized" "ebs_optimized - (Optional) If true, the launched EC2 instance will be EBS-optimized.")
    ("hostname" "hostname - (Optional) The instance's host name.")
    ("architecture" "architecture - (Optional) Machine architecture for created instances.  Can be either \"x86_64\" (the default) or \"i386\"")
    ("ami_id" "ami_id - (Optional) The AMI to use for the instance.  If an AMI is specified, os must be \"Custom\".")
    ("os" "os - (Optional) Name of operating system that will be installed.")
    ("root_device_type" "root_device_type - (Optional) Name of the type of root device instances will have by default.  Can be either \"ebs\" or \"instance-store\"")
    ("ssh_key_name" "ssh_key_name - (Optional) Name of the SSH keypair that instances will have by default.")
    ("agent_version" "agent_version - (Optional) The AWS OpsWorks agent to install.  Defaults to \"INHERIT\".")
    ("subnet_id" "subnet_id - (Optional) Subnet ID to attach to")
    ("tenancy" "tenancy - (Optional) Instance tenancy to use. Can be one of \"default\", \"dedicated\" or \"host\"")
    ("virtualization_type" "virtualization_type - (Optional) Keyword to choose what virtualization mode created instances will use. Can be either \"paravirtual\" or \"hvm\".")
    ("root_block_device" "root_block_device - (Optional) Customize details about the root block device of the instance. See Block Devices below for details.")
    ("ebs_block_device" "ebs_block_device - (Optional) Additional EBS block devices to attach to the instance.  See Block Devices below for details.")
    ("ephemeral_block_device" "ephemeral_block_device - (Optional) Customize Ephemeral (also known as \"Instance Store\") volumes on the instance. See Block Devices below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_java_app_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("app_server" "app_server - (Optional) Keyword for the application container to use. Defaults to \"tomcat\".")
    ("app_server_version" "app_server_version - (Optional) Version of the selected application container to use. Defaults to \"7\".")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("jvm_type" "jvm_type - (Optional) Keyword for the type of JVM to use. Defaults to openjdk.")
    ("jvm_options" "jvm_options - (Optional) Options to set for the JVM.")
    ("jvm_version" "jvm_version - (Optional) Version of JVM to use. Defaults to \"7\".")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_memcached_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("allocated_memory" "allocated_memory - (Optional) Amount of memory to allocate for the cache on each instance, in megabytes. Defaults to 512MB.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_mysql_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("root_password" "root_password - (Optional) Root password to use for MySQL.")
    ("root_password_on_all_instances" "root_password_on_all_instances - (Optional) Whether to set the root user password to all instances in the stack so they can access the instances in this layer.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_nodejs_app_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("nodejs_version" "nodejs_version - (Optional) The version of NodeJS to use. Defaults to \"0.10.38\".")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_permission" '(
    ("allow_ssh" "allow_ssh - (Optional) Whether the user is allowed to use SSH to communicate with the instance")
    ("allow_sudo" "allow_sudo - (Optional) Whether the user is allowed to use sudo to elevate privileges")
    ("user_arn" "user_arn - (Required) The user's IAM ARN to set permissions for")
    ("level" "level - (Optional) The users permission level. Mus be one of deny, show, deploy, manage, iam_only")
    ("stack_id" "stack_id - (Required) The stack to set the permissions for")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_php_app_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_rails_app_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("app_server" "app_server - (Optional) Keyword for the app server to use. Defaults to \"apache_passenger\".")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("bundler_version" "bundler_version - (Optional) When OpsWorks is managing Bundler, which version to use. Defaults to \"1.5.3\".")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("manage_bundler" "manage_bundler - (Optional) Whether OpsWorks should manage bundler. On by default.")
    ("passenger_version" "passenger_version - (Optional) The version of Passenger to use. Defaults to \"4.0.46\".")
    ("ruby_version" "ruby_version - (Optional) The version of Ruby to use. Defaults to \"2.0.0\".")
    ("rubygems_version" "rubygems_version - (Optional) The version of RubyGems to use. Defaults to \"2.2.2\".")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the layer.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_rds_db_instance" '(
    ("stack_id" "stack_id - (Required) The stack to register a db inatance for. Changing this will force a new resource.")
    ("rds_db_instance_arn" "rds_db_instance_arn - (Required) The db instance to register for this stack. Changing this will force a new resource.")
    ("db_user" "db_user - (Required) A db username")
    ("db_password" "db_password - (Required) A db password")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_stack" '(
    ("name" "name - (Required) The name of the stack.")
    ("region" "region - (Required) The name of the region where the stack will exist.")
    ("service_role_arn" "service_role_arn - (Required) The ARN of an IAM role that the OpsWorks service will act as.")
    ("default_instance_profile_arn" "default_instance_profile_arn - (Required) The ARN of an IAM Instance Profile that created instances will have by default.")
    ("agent_version" "agent_version - (Optional) If set to \"LATEST\", OpsWorks will automatically install the latest version.")
    ("berkshelf_version" "berkshelf_version - (Optional) If manage_berkshelf is enabled, the version of Berkshelf to use.")
    ("color" "color - (Optional) Color to paint next to the stack's resources in the OpsWorks console.")
    ("default_availability_zone" "default_availability_zone - (Optional) Name of the availability zone where instances will be created by default. This is required unless you set vpc_id.")
    ("configuration_manager_name" "configuration_manager_name - (Optional) Name of the configuration manager to use. Defaults to \"Chef\".")
    ("configuration_manager_version" "configuration_manager_version - (Optional) Version of the configuration manager to use. Defaults to \"11.4\".")
    ("custom_cookbooks_source" "custom_cookbooks_source - (Optional) When use_custom_cookbooks is set, provide this sub-object as described below.")
    ("custom_json" "custom_json - (Optional) User defined JSON passed to \"Chef\". Use a \"here doc\" for multiline JSON.")
    ("default_os" "default_os - (Optional) Name of OS that will be installed on instances by default.")
    ("default_root_device_type" "default_root_device_type - (Optional) Name of the type of root device instances will have by default.")
    ("default_ssh_key_name" "default_ssh_key_name - (Optional) Name of the SSH keypair that instances will have by default.")
    ("default_subnet_id" "default_subnet_id - (Optional) Id of the subnet in which instances will be created by default. Mandatory if vpc_id is set, and forbidden if it isn't.")
    ("hostname_theme" "hostname_theme - (Optional) Keyword representing the naming scheme that will be used for instance hostnames within this stack.")
    ("manage_berkshelf" "manage_berkshelf - (Optional) Boolean value controlling whether Opsworks will run Berkshelf for this stack.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("use_custom_cookbooks" "use_custom_cookbooks - (Optional) Boolean value controlling whether the custom cookbook settings are enabled.")
    ("use_opsworks_security_groups" "use_opsworks_security_groups - (Optional) Boolean value controlling whether the standard OpsWorks security groups apply to created instances.")
    ("vpc_id" "vpc_id - (Optional) The id of the VPC that this stack belongs to.")
    ("custom_json" "custom_json - (Optional) Custom JSON attributes to apply to the entire stack.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_static_web_layer" '(
    ("stack_id" "stack_id - (Required) The id of the stack the layer will belong to.")
    ("name" "name - (Optional) A human-readable name for the layer.")
    ("auto_assign_elastic_ips" "auto_assign_elastic_ips - (Optional) Whether to automatically assign an elastic IP address to the layer's instances.")
    ("auto_assign_public_ips" "auto_assign_public_ips - (Optional) For stacks belonging to a VPC, whether to automatically assign a public IP address to each of the layer's instances.")
    ("custom_instance_profile_arn" "custom_instance_profile_arn - (Optional) The ARN of an IAM profile that will be used for the layer's instances.")
    ("custom_security_group_ids" "custom_security_group_ids - (Optional) Ids for a set of security groups to apply to the layer's instances.")
    ("auto_healing" "auto_healing - (Optional) Whether to enable auto-healing for the layer.")
    ("install_updates_on_boot" "install_updates_on_boot - (Optional) Whether to install OS and package updates on each instance when it boots.")
    ("instance_shutdown_timeout" "instance_shutdown_timeout - (Optional) The time, in seconds, that OpsWorks will wait for Chef to complete after triggering the Shutdown event.")
    ("elastic_load_balancer" "elastic_load_balancer - (Optional) Name of an Elastic Load Balancer to attach to this layer")
    ("drain_elb_on_shutdown" "drain_elb_on_shutdown - (Optional) Whether to enable Elastic Load Balancing connection draining.")
    ("system_packages" "system_packages - (Optional) Names of a set of system packages to install on the layer's instances.")
    ("use_ebs_optimized_instances" "use_ebs_optimized_instances - (Optional) Whether to use EBS-optimized instances.")
    ("ebs_volume" "ebs_volume - (Optional) ebs_volume blocks, as described below, will each create an EBS volume and connect it to the layer's instances.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_opsworks_user_profile" '(
    ("user_arn" "user_arn - (Required) The user's IAM ARN")
    ("allow_self_management" "allow_self_management - (Optional) Whether users can specify their own SSH public key through the My Settings page")
    ("ssh_username" "ssh_username - (Required) The ssh username, with witch this user wants to log in")
    ("ssh_public_key" "ssh_public_key - (Optional) The users public key")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_organizations_account" '(
    ("name" "name - (Required) A friendly name for the member account.")
    ("email" "email - (Required) The email address of the owner to assign to the new member account. This email address must not already be associated with another AWS account.")
    ("iam_user_access_to_billing" "iam_user_access_to_billing - (Optional) If set to ALLOW, the new account enables IAM users to access account billing information if they have the required permissions. If set to DENY, then only the root user of the new account can access account billing information.")
    ("role_name" "role_name - (Optional) The name of an IAM role that Organizations automatically preconfigures in the new member account. This role trusts the master account, allowing users in the master account to assume the role, as permitted by the master account administrator. The role has administrator permissions in the new member account.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_organizations_organization" '(
    ("feature_set" "feature_set - (Optional) Specify \"ALL\" (default) or \"CONSOLIDATED_BILLING\".")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_organizations_policy" '(
    ("content" "content - (Required) The policy content to add to the new policy. For example, if you create a service control policy (SCP), this string must be JSON text that specifies the permissions that admins in attached accounts can delegate to their users, groups, and roles. For more information about the SCP syntax, see the [Service Control Policy Syntax documentation]((https://docs.aws.amazon.com/organizations/latest/userguide/orgs_reference_scp-syntax.html).")
    ("name" "name - (Required) The friendly name to assign to the policy.")
    ("description" "description - (Optional) A description to assign to the policy.")
    ("type" "type - (Optional) The type of policy to create. Currently, the only valid value is SERVICE_CONTROL_POLICY (SCP).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_organizations_policy_attachment" '(
    ("policy_id" "policy_id - (Required) The unique identifier (ID) of the policy that you want to attach to the target.")
    ("target_id" "target_id - (Required) The unique identifier (ID) of the root, organizational unit, or account number that you want to attach the policy to.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_event_subscription" '(
    ("name" "name - (Optional) The name of the DB event subscription. By default generated by Terraform.")
    ("name_prefix" "name_prefix - (Optional) The name of the DB event subscription. Conflicts with name.")
    ("sns_topic" "sns_topic - (Required) The SNS topic to send events to.")
    ("source_ids" "source_ids - (Optional) A list of identifiers of the event sources for which events will be returned. If not specified, then all sources are included in the response. If specified, a source_type must also be specified.")
    ("source_type" "source_type - (Optional) The type of source that will be generating the events.")
    ("event_categories" "event_categories - (Optional) A list of event categories for a SourceType that you want to subscribe to. See http://docs.aws.amazon.com/AmazonRDS/latest/UserGuide//USER_Events.html")
    ("enabled" "enabled - (Optional) A boolean flag to enable/disable the subscription. Defaults to true.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_instance" '(
    ("allocated_storage" "allocated_storage - (Required unless a snapshot_identifier or replicate_source_db is provided) The allocated storage in gigabytes.")
    ("allow_major_version_upgrade" "allow_major_version_upgrade - (Optional) Indicates that major version upgrades are allowed. Changing this parameter does not result in an outage and the change is asynchronously applied as soon as possible.")
    ("apply_immediately" "apply_immediately - (Optional) Specifies whether any database modifications are applied immediately, or during the next maintenance window. Default is false. See Amazon RDS Documentation for more information. for more information.")
    ("auto_minor_version_upgrade" "auto_minor_version_upgrade - (Optional) Indicates that minor engine upgrades will be applied automatically to the DB instance during the maintenance window. Defaults to true.")
    ("availability_zone" "availability_zone - (Optional) The AZ for the RDS instance.")
    ("backup_retention_period" "backup_retention_period - (Optional) The days to retain backups for. Must be 1 or greater to be a source for a Read Replica.")
    ("backup_window" "backup_window - (Optional) The daily time range (in UTC) during which automated backups are created if they are enabled. Example: \"09:46-10:16\". Must not overlap with maintenance_window.")
    ("character_set_name" "character_set_name - (Optional) The character set name to use for DB encoding in Oracle instances. This can't be changed. See Oracle Character Sets Supported in Amazon RDS for more information.")
    ("copy_tags_to_snapshot" "copy_tags_to_snapshot – (Optional, boolean) On delete, copy all Instance tags to the final snapshot (if final_snapshot_identifier is specified). Default is false.")
    ("db_subnet_group_name" "db_subnet_group_name - (Optional) Name of DB subnet group. DB instance will be created in the VPC associated with the DB subnet group. If unspecified, will be created in the default VPC, or in EC2 Classic, if available. When working with read replicas, it needs to be specified only if the source database specifies an instance in another AWS Region. See DBSubnetGroupName in API action CreateDBInstanceReadReplica for additonal read replica contraints.")
    ("enabled_cloudwatch_logs_exports" "enabled_cloudwatch_logs_exports - (Optional) Name list of enable log type for exporting to cloudwatch logs. If omitted, any logs will not be exported to cloudwatch logs. Either of the following is supported: audit, error, general, slowquery.")
    ("engine" "engine - (Required unless a snapshot_identifier or replicate_source_db is provided) The database engine to use.  For supported values, see the Engine parameter in API action CreateDBInstance.")
    ("engine_version" "engine_version - (Optional) The engine version to use. If auto_minor_version_upgrade is enabled, you can provide a prefix of the version such as 5.7 (for 5.7.10) and this attribute will ignore differences in the patch version automatically (e.g. 5.7.17).")
    ("final_snapshot_identifier" "final_snapshot_identifier - (Optional) The name of your final DB snapshot when this DB instance is deleted. If omitted, no final snapshot will be made.")
    ("iam_database_authentication_enabled" "iam_database_authentication_enabled - (Optional) Specifies whether or mappings of AWS Identity and Access Management (IAM) accounts to database accounts is enabled.")
    ("identifier" "identifier - (Optional, Forces new resource) The name of the RDS instance, if omitted, Terraform will assign a random, unique identifier.")
    ("identifier_prefix" "identifier_prefix - (Optional, Forces new resource) Creates a unique identifier beginning with the specified prefix. Conflicts with identifer.")
    ("instance_class" "instance_class - (Required) The instance type of the RDS instance.")
    ("iops" "iops - (Optional) The amount of provisioned IOPS. Setting this implies a storage_type of \"io1\".")
    ("kms_key_id" "kms_key_id - (Optional) The ARN for the KMS encryption key. If creating an encrypted replica, set this to the destination KMS ARN.")
    ("license_model" "license_model - (Optional, but required for some DB engines, i.e. Oracle SE1) License model information for this DB instance.")
    ("maintenance_window" "maintenance_window - (Optional) The window to perform maintenance in. Syntax: \"ddd:hh24:mi-ddd:hh24:mi\". Eg: \"Mon:00:00-Mon:03:00\". See RDS Maintenance Window docs for more information.")
    ("monitoring_interval" "monitoring_interval - (Optional) The interval, in seconds, between points when Enhanced Monitoring metrics are collected for the DB instance. To disable collecting Enhanced Monitoring metrics, specify 0. The default is 0. Valid Values: 0, 1, 5, 10, 15, 30, 60.")
    ("monitoring_role_arn" "monitoring_role_arn - (Optional) The ARN for the IAM role that permits RDS to send enhanced monitoring metrics to CloudWatch Logs. You can find more information on the AWS Documentation what IAM permissions are needed to allow Enhanced Monitoring for RDS Instances.")
    ("multi_az" "multi_az - (Optional) Specifies if the RDS instance is multi-AZ")
    ("name" "name - (Optional) The name of the database to create when the DB instance is created. If this parameter is not specified, no database is created in the DB instance. Note that this does not apply for Oracle or SQL Server engines. See the AWS documentation for more details on what applies for those engines.")
    ("option_group_name" "option_group_name - (Optional) Name of the DB option group to associate.")
    ("parameter_group_name" "parameter_group_name - (Optional) Name of the DB parameter group to associate.")
    ("password" "password - (Required unless a snapshot_identifier or replicate_source_db is provided) Password for the master DB user. Note that this may show up in logs, and it will be stored in the state file.")
    ("port" "port - (Optional) The port on which the DB accepts connections.")
    ("publicly_accessible" "publicly_accessible - (Optional) Bool to control if instance is publicly accessible. Default is false.")
    ("replicate_source_db" "replicate_source_db - (Optional) Specifies that this resource is a Replicate database, and to use this value as the source database. This correlates to the identifier of another Amazon RDS Database to replicate. Note that if you are creating a cross-region replica of an encrypted database you will also need to specify a kms_key_id. See DB Instance Replication and Working with PostgreSQL and MySQL Read Replicas for more information on using Replication.")
    ("security_group_names" "security_group_names - (Optional/Deprecated) List of DB Security Groups to associate. Only used for DB Instances on the EC2-Classic Platform.")
    ("skip_final_snapshot" "skip_final_snapshot - (Optional) Determines whether a final DB snapshot is created before the DB instance is deleted. If true is specified, no DBSnapshot is created. If false is specified, a DB snapshot is created before the DB instance is deleted, using the value from final_snapshot_identifier. Default is false.")
    ("snapshot_identifier" "snapshot_identifier - (Optional) Specifies whether or not to create this database from a snapshot. This correlates to the snapshot ID you'd find in the RDS console, e.g: rds:production-2015-06-26-06-05.")
    ("storage_encrypted" "storage_encrypted - (Optional) Specifies whether the DB instance is encrypted. Note that if you are creating a cross-region read replica this field is ignored and you should instead declare kms_key_id with a valid ARN. The default is false if not specified.")
    ("storage_type" "storage_type - (Optional) One of \"standard\" (magnetic), \"gp2\" (general purpose SSD), or \"io1\" (provisioned IOPS SSD). The default is \"io1\" if iops is specified, \"standard\" if not. Note that this behaviour is different from the AWS web console, where the default is \"gp2\".")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("timezone" "timezone - (Optional) Time zone of the DB instance. timezone is currently only supported by Microsoft SQL Server. The timezone can only be set on creation. See MSSQL User Guide for more information.")
    ("username" "username - (Required unless a snapshot_identifier or replicate_source_db is provided) Username for the master DB user.")
    ("vpc_security_group_ids" "vpc_security_group_ids - (Optional) List of VPC security groups to associate.")
    ("s3_import" "s3_import - (Optional) Restore from a Percona Xtrabackup in S3.  See Importing Data into an Amazon RDS MySQL DB Instance")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_option_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the option group. If omitted, Terraform will assign a random, unique name. Must be lowercase, to match as it is stored in AWS.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name. Must be lowercase, to match as it is stored in AWS.")
    ("option_group_description" "option_group_description - (Optional) The description of the option group. Defaults to \"Managed by Terraform\".")
    ("engine_name" "engine_name - (Required) Specifies the name of the engine that this option group should be associated with.")
    ("major_engine_version" "major_engine_version - (Required) Specifies the major version of the engine that this option group should be associated with.")
    ("option" "option - (Optional) A list of Options to apply.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_parameter_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the DB parameter group. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("family" "family - (Required) The family of the DB parameter group.")
    ("description" "description - (Optional) The description of the DB parameter group. Defaults to \"Managed by Terraform\".")
    ("parameter" "parameter - (Optional) A list of DB parameters to apply. Note that parameters may differ from a family to an other. Full list of all parameters can be discovered via aws rds describe-db-parameters after initial creation of the group.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_security_group" '(
    ("name" "name - (Required) The name of the DB security group.")
    ("description" "description - (Optional) The description of the DB security group. Defaults to \"Managed by Terraform\".")
    ("ingress" "ingress - (Required) A list of ingress rules.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_snapshot" '(
    ("db_instance_identifier" "db_instance_identifier - (Required) The DB Instance Identifier from which to take the snapshot.")
    ("db_snapshot_identifier" "db_snapshot_identifier - (Required) The Identifier for the snapshot.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_db_subnet_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the DB subnet group. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("description" "description - (Optional) The description of the DB subnet group. Defaults to \"Managed by Terraform\".")
    ("subnet_ids" "subnet_ids - (Required) A list of VPC subnet IDs.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_rds_cluster" '(
    ("cluster_identifier" "cluster_identifier - (Optional, Forces new resources) The cluster identifier. If omitted, Terraform will assign a random, unique identifier.")
    ("cluster_identifier_prefix" "cluster_identifier_prefix - (Optional, Forces new resource) Creates a unique cluster identifier beginning with the specified prefix. Conflicts with cluster_identifer.")
    ("database_name" "database_name - (Optional) Name for an automatically created database on cluster creation. There are different naming restrictions per database engine: RDS Naming Constraints")
    ("master_password" "master_password - (Required unless a snapshot_identifier is provided) Password for the master DB user. Note that this may show up in logs, and it will be stored in the state file. Please refer to the RDS Naming Constraints")
    ("master_username" "master_username - (Required unless a snapshot_identifier is provided) Username for the master DB user. Please refer to the RDS Naming Constraints")
    ("final_snapshot_identifier" "final_snapshot_identifier - (Optional) The name of your final DB snapshot when this DB cluster is deleted. If omitted, no final snapshot will be made.")
    ("skip_final_snapshot" "skip_final_snapshot - (Optional) Determines whether a final DB snapshot is created before the DB cluster is deleted. If true is specified, no DB snapshot is created. If false is specified, a DB snapshot is created before the DB cluster is deleted, using the value from final_snapshot_identifier. Default is false.")
    ("availability_zones" "availability_zones - (Optional) A list of EC2 Availability Zones that instances in the DB cluster can be created in")
    ("backtrack_window" "backtrack_window - (Optional) The target backtrack window, in seconds. Only available for aurora or aurora-mysql engines. To disable backtracking, set this value to 0. Defaults to 0. Must be between 0 and 259200 (72 hours)")
    ("backup_retention_period" "backup_retention_period - (Optional) The days to retain backups for. Default 1")
    ("preferred_backup_window" "preferred_backup_window - (Optional) The daily time range during which automated backups are created if automated backups are enabled using the BackupRetentionPeriod parameter.Time in UTC Default: A 30-minute window selected at random from an 8-hour block of time per region. e.g. 04:00-09:00")
    ("preferred_maintenance_window" "preferred_maintenance_window - (Optional) The weekly time range during which system maintenance can occur, in (UTC) e.g. wed:04:00-wed:04:30")
    ("port" "port - (Optional) The port on which the DB accepts connections")
    ("vpc_security_group_ids" "vpc_security_group_ids - (Optional) List of VPC security groups to associate with the Cluster")
    ("snapshot_identifier" "snapshot_identifier - (Optional) Specifies whether or not to create this cluster from a snapshot. You can use either the name or ARN when specifying a DB cluster snapshot, or the ARN when specifying a DB snapshot.")
    ("storage_encrypted" "storage_encrypted - (Optional) Specifies whether the DB cluster is encrypted. The default is false if not specified.")
    ("replication_source_identifier" "replication_source_identifier - (Optional) ARN of a source DB cluster or DB instance if this DB cluster is to be created as a Read Replica.")
    ("apply_immediately" "apply_immediately - (Optional) Specifies whether any cluster modifications  are applied immediately, or during the next maintenance window. Default is  false. See Amazon RDS Documentation for more information.")
    ("db_subnet_group_name" "db_subnet_group_name - (Optional) A DB subnet group to associate with this DB instance. NOTE: This must match the db_subnet_group_name specified on every aws_rds_cluster_instance in the cluster.")
    ("db_cluster_parameter_group_name" "db_cluster_parameter_group_name - (Optional) A cluster parameter group to associate with the cluster.")
    ("kms_key_id" "kms_key_id - (Optional) The ARN for the KMS encryption key. When specifying kms_key_id, storage_encrypted needs to be set to true.")
    ("iam_roles" "iam_roles - (Optional) A List of ARNs for the IAM roles to associate to the RDS Cluster.")
    ("iam_database_authentication_enabled" "iam_database_authentication_enabled - (Optional) Specifies whether or mappings of AWS Identity and Access Management (IAM) accounts to database accounts is enabled.")
    ("engine" "engine - (Optional) The name of the database engine to be used for this DB cluster. Defaults to aurora. Valid Values: aurora,aurora-mysql,aurora-postgresql")
    ("engine_version" "engine_version - (Optional) The database engine version.")
    ("source_region" "source_region - (Optional) The source region for an encrypted replica DB cluster.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_rds_cluster_instance" '(
    ("identifier" "identifier - (Optional, Forces new resource) The indentifier for the RDS instance, if omitted, Terraform will assign a random, unique identifier.")
    ("identifier_prefix" "identifier_prefix - (Optional, Forces new resource) Creates a unique identifier beginning with the specified prefix. Conflicts with identifer.")
    ("cluster_identifier" "cluster_identifier - (Required) The identifier of the aws_rds_cluster in which to launch this instance.")
    ("engine" "engine - (Optional) The name of the database engine to be used for the RDS instance. Defaults to aurora. Valid Values: aurora, aurora-mysql, aurora-postgresql.")
    ("engine_version" "engine_version - (Optional) The database engine version.")
    ("instance_class" "instance_class - (Required) The instance class to use. For details on CPU and memory, see Scaling Aurora DB Instances. Aurora currently supports the below instance classes.   db.t2.small  db.t2.medium  db.r3.large  db.r3.xlarge  db.r3.2xlarge  db.r3.4xlarge  db.r3.8xlarge  db.r4.large  db.r4.xlarge  db.r4.2xlarge  db.r4.4xlarge  db.r4.8xlarge  db.r4.16xlarge")
    ("publicly_accessible" "publicly_accessible - (Optional) Bool to control if instance is publicly accessible. Default false. See the documentation on Creating DB Instances for more details on controlling this property.")
    ("db_subnet_group_name" "db_subnet_group_name - (Required if publicly_accessible = false, Optional otherwise) A DB subnet group to associate with this DB instance. NOTE: This must match the db_subnet_group_name of the attached aws_rds_cluster.")
    ("db_parameter_group_name" "db_parameter_group_name - (Optional) The name of the DB parameter group to associate with this instance.")
    ("apply_immediately" "apply_immediately - (Optional) Specifies whether any database modifications  are applied immediately, or during the next maintenance window. Default isfalse.")
    ("monitoring_role_arn" "monitoring_role_arn - (Optional) The ARN for the IAM role that permits RDS to send enhanced monitoring metrics to CloudWatch Logs. You can find more information on the AWS Documentation what IAM permissions are needed to allow Enhanced Monitoring for RDS Instances.")
    ("monitoring_interval" "monitoring_interval - (Optional) The interval, in seconds, between points when Enhanced Monitoring metrics are collected for the DB instance. To disable collecting Enhanced Monitoring metrics, specify 0. The default is 0. Valid Values: 0, 1, 5, 10, 15, 30, 60.")
    ("promotion_tier" "promotion_tier - (Optional) Default 0. Failover Priority setting on instance level. The reader who has lower tier has higher priority to get promoter to writer.")
    ("availability_zone" "availability_zone - (Optional, Computed) The EC2 Availability Zone that the DB instance is created in. See docs about the details.")
    ("preferred_backup_window" "preferred_backup_window - (Optional) The daily time range during which automated backups are created if automated backups are enabled. Eg: \"04:00-09:00\"")
    ("preferred_maintenance_window" "preferred_maintenance_window - (Optional) The window to perform maintenance in. Syntax: \"ddd:hh24:mi-ddd:hh24:mi\". Eg: \"Mon:00:00-Mon:03:00\".")
    ("auto_minor_version_upgrade" "auto_minor_version_upgrade - (Optional) Indicates that minor engine upgrades will be applied automatically to the DB instance during the maintenance window. Default true.")
    ("performance_insights_enabled" "performance_insights_enabled - (Optional) Specifies whether Performance Insights is enabled or not.")
    ("performance_insights_kms_key_id" "performance_insights_kms_key_id - (Optional) The ARN for the KMS key to encrypt Performance Insights data. When specifying performance_insights_kms_key_id, performance_insights_enabled needs to be set to true.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_rds_cluster_parameter_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the DB cluster parameter group. If omitted, Terraform will assign a random, unique name.")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("family" "family - (Required) The family of the DB cluster parameter group.")
    ("description" "description - (Optional) The description of the DB cluster parameter group. Defaults to \"Managed by Terraform\".")
    ("parameter" "parameter - (Optional) A list of DB parameters to apply. Note that parameters may differ from a family to an other. Full list of all parameters can be discovered via aws rds describe-db-cluster-parameters after initial creation of the group.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_redshift_cluster" '(
    ("cluster_identifier" "cluster_identifier - (Required) The Cluster Identifier. Must be a lower case string.")
    ("database_name" "database_name - (Optional) The name of the first database to be created when the cluster is created. If you do not provide a name, Amazon Redshift will create a default database called dev.")
    ("node_type" "node_type - (Required) The node type to be provisioned for the cluster.")
    ("cluster_type" "cluster_type - (Optional) The cluster type to use. Either single-node or multi-node.")
    ("master_password" "master_password - (Required unless a snapshot_identifier is provided) Password for the master DB user. Note that this may show up in logs, and it will be stored in the state file. Password must contain at least 8 chars and contain at least one uppercase letter, one lowercase letter, and one number.")
    ("master_username" "master_username - (Required unless a snapshot_identifier is provided) Username for the master DB user.")
    ("cluster_security_groups" "cluster_security_groups - (Optional) A list of security groups to be associated with this cluster.")
    ("vpc_security_group_ids" "vpc_security_group_ids - (Optional) A list of Virtual Private Cloud (VPC) security groups to be associated with the cluster.")
    ("cluster_subnet_group_name" "cluster_subnet_group_name - (Optional) The name of a cluster subnet group to be associated with this cluster. If this parameter is not provided the resulting cluster will be deployed outside virtual private cloud (VPC).")
    ("availability_zone" "availability_zone - (Optional) The EC2 Availability Zone (AZ) in which you want Amazon Redshift to provision the cluster. For example, if you have several EC2 instances running in a specific Availability Zone, then you might want the cluster to be provisioned in the same zone in order to decrease network latency.")
    ("preferred_maintenance_window" "preferred_maintenance_window - (Optional) The weekly time range (in UTC) during which automated cluster maintenance can occur.                                           Format: ddd:hh24:mi-ddd:hh24:mi")
    ("cluster_parameter_group_name" "cluster_parameter_group_name - (Optional) The name of the parameter group to be associated with this cluster.")
    ("automated_snapshot_retention_period" "automated_snapshot_retention_period - (Optional) The number of days that automated snapshots are retained. If the value is 0, automated snapshots are disabled. Even if automated snapshots are disabled, you can still create manual snapshots when you want with create-cluster-snapshot. Default is 1.")
    ("port" "port - (Optional) The port number on which the cluster accepts incoming connections.                   The cluster is accessible only via the JDBC and ODBC connection strings. Part of the connection string requires the port on which the cluster will listen for incoming connections. Default port is 5439.")
    ("cluster_version" "cluster_version - (Optional) The version of the Amazon Redshift engine software that you want to deploy on the cluster.                              The version selected runs on all the nodes in the cluster.")
    ("allow_version_upgrade" "allow_version_upgrade - (Optional) If true , major version upgrades can be applied during the maintenance window to the Amazon Redshift engine that is running on the cluster. Default is true")
    ("number_of_nodes" "number_of_nodes - (Optional) The number of compute nodes in the cluster. This parameter is required when the ClusterType parameter is specified as multi-node. Default is 1.")
    ("publicly_accessible" "publicly_accessible - (Optional) If true, the cluster can be accessed from a public network. Default is true.")
    ("encrypted" "encrypted - (Optional) If true , the data in the cluster is encrypted at rest.")
    ("enhanced_vpc_routing" "enhanced_vpc_routing - (Optional) If true , enhanced VPC routing is enabled.")
    ("kms_key_id" "kms_key_id - (Optional) The ARN for the KMS encryption key. When specifying kms_key_id, encrypted needs to be set to true.")
    ("elastic_ip" "elastic_ip - (Optional) The Elastic IP (EIP) address for the cluster.")
    ("skip_final_snapshot" "skip_final_snapshot - (Optional) Determines whether a final snapshot of the cluster is created before Amazon Redshift deletes the cluster. If true , a final cluster snapshot is not created. If false , a final cluster snapshot is created before the cluster is deleted. Default is false.")
    ("final_snapshot_identifier" "final_snapshot_identifier - (Optional) The identifier of the final snapshot that is to be created immediately before deleting the cluster. If this parameter is provided, skip_final_snapshot must be false.")
    ("snapshot_identifier" "snapshot_identifier - (Optional) The name of the snapshot from which to create the new cluster.")
    ("snapshot_cluster_identifier" "snapshot_cluster_identifier - (Optional) The name of the cluster the source snapshot was created from.")
    ("owner_account" "owner_account - (Optional) The AWS customer account used to create or copy the snapshot. Required if you are restoring a snapshot you do not own, optional if you own the snapshot.")
    ("iam_roles" "iam_roles - (Optional) A list of IAM Role ARNs to associate with the cluster. A Maximum of 10 can be associated to the cluster at any time.")
    ("logging" "logging - (Optional) Logging, documented below.")
    ("snapshot_copy" "snapshot_copy - (Optional) Configuration of automatic copy of snapshots from one region to another. Documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_redshift_parameter_group" '(
    ("name" "name - (Required) The name of the Redshift parameter group.")
    ("family" "family - (Required) The family of the Redshift parameter group.")
    ("description" "description - (Optional) The description of the Redshift parameter group. Defaults to \"Managed by Terraform\".")
    ("parameter" "parameter - (Optional) A list of Redshift parameters to apply.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_redshift_security_group" '(
    ("name" "name - (Required) The name of the Redshift security group.")
    ("description" "description - (Optional) The description of the Redshift security group. Defaults to \"Managed by Terraform\".")
    ("ingress" "ingress - (Optional) A list of ingress rules.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_redshift_subnet_group" '(
    ("name" "name - (Required) The name of the Redshift Subnet group.")
    ("description" "description - (Optional) The description of the Redshift Subnet group. Defaults to \"Managed by Terraform\".")
    ("subnet_ids" "subnet_ids - (Required) An array of VPC subnet IDs.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_byte_match_set" '(
    ("name" "name - (Required) The name or description of the Byte Match Set.")
    ("byte_match_tuples" "byte_match_tuples - Specifies the bytes (typically a string that corresponds with ASCII characters) that you want to search for in web requests, the location in requests that you want to search, and other settings.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_geo_match_set" '(
    ("name" "name - (Required) The name or description of the GeoMatchSet.")
    ("geo_match_constraint" "geo_match_constraint - (Optional) The GeoMatchConstraint objects which contain the country that you want AWS WAF to search for.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_ipset" '(
    ("name" "name - (Required) The name or description of the IPSet.")
    ("ip_set_descriptors" "ip_set_descriptors - (Optional) Specifies the IP address type (IPV4 or IPV6) and the IP address range (in CIDR format) that web requests originate from.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_rate_based_rule" '(
    ("metric_name" "metric_name - (Required) The name or description for the Amazon CloudWatch metric of this rule.")
    ("name" "name - (Required) The name or description of the rule.")
    ("rate_key" "rate_key - (Required) Valid value is IP.")
    ("rate_limit" "rate_limit - (Required) The maximum number of requests, which have an identical value in the field specified by the RateKey, allowed in a five-minute period. Minimum value is 2000.")
    ("predicates" "predicates - (Optional) One of ByteMatchSet, IPSet, SizeConstraintSet, SqlInjectionMatchSet, or XssMatchSet objects to include in a rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_regex_match_set" '(
    ("name" "name - (Required) The name or description of the Regex Match Set.")
    ("regex_match_tuple" "regex_match_tuple - (Required) The regular expression pattern that you want AWS WAF to search for in web requests, the location in requests that you want AWS WAF to search, and other settings. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_regex_pattern_set" '(
    ("name" "name - (Required) The name or description of the Regex Pattern Set.")
    ("regex_pattern_strings" "regex_pattern_strings - (Optional) A list of regular expression (regex) patterns that you want AWS WAF to search for, such as B[a@]dB[o0]t.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_rule" '(
    ("metric_name" "metric_name - (Required) The name or description for the Amazon CloudWatch metric of this rule.")
    ("name" "name - (Required) The name or description of the rule.")
    ("predicates" "predicates - (Optional) One of ByteMatchSet, IPSet, SizeConstraintSet, SqlInjectionMatchSet, or XssMatchSet objects to include in a rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_rule_group" '(
    ("name" "name - (Required) A friendly name of the rule group")
    ("metric_name" "metric_name - (Required) A friendly name for the metrics from the rule group")
    ("activated_rule" "activated_rule - (Optional) A list of activated rules, see below")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_size_constraint_set" '(
    ("name" "name - (Required) The name or description of the Size Constraint Set.")
    ("size_constraints" "size_constraints - (Optional) Specifies the parts of web requests that you want to inspect the size of.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_sql_injection_match_set" '(
    ("name" "name - (Required) The name or description of the SizeConstraintSet.")
    ("sql_injection_match_tuples" "sql_injection_match_tuples - (Optional) The parts of web requests that you want AWS WAF to inspect for malicious SQL code and, if you want AWS WAF to inspect a header, the name of the header.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_web_acl" '(
    ("default_action" "default_action - (Required) The action that you want AWS WAF to take when a request doesn't match the criteria in any of the rules that are associated with the web ACL.")
    ("metric_name" "metric_name - (Required) The name or description for the Amazon CloudWatch metric of this web ACL.")
    ("name" "name - (Required) The name or description of the web ACL.")
    ("rules" "rules - (Required) The rules to associate with the web ACL and the settings for each rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_waf_xss_match_set" '(
    ("name" "name - (Required) The name or description of the SizeConstraintSet.")
    ("xss_match_tuples" "xss_match_tuples - (Optional) The parts of web requests that you want to inspect for cross-site scripting attacks.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_byte_match_set" '(
    ("name" "name - (Required) The name or description of the ByteMatchSet.")
    ("byte_match_tuple" "byte_match_tuple - (Optional)Settings for the ByteMatchSet, such as the bytes (typically a string that corresponds with ASCII characters) that you want AWS WAF to search for in web requests. ByteMatchTuple documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_geo_match_set" '(
    ("name" "name - (Required) The name or description of the Geo Match Set.")
    ("geo_match_constraint" "geo_match_constraint - (Optional) The Geo Match Constraint objects which contain the country that you want AWS WAF to search for.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_ipset" '(
    ("name" "name - (Required) The name or description of the IPSet.")
    ("ip_set_descriptor" "ip_set_descriptor - (Optional) The IP address type and IP address range (in CIDR notation) from which web requests originate.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_rate_based_rule" '(
    ("metric_name" "metric_name - (Required) The name or description for the Amazon CloudWatch metric of this rule.")
    ("name" "name - (Required) The name or description of the rule.")
    ("rate_key" "rate_key - (Required) Valid value is IP.")
    ("rate_limit" "rate_limit - (Required) The maximum number of requests, which have an identical value in the field specified by the RateKey, allowed in a five-minute period. Minimum value is 2000.")
    ("predicate" "predicate - (Optional) One of ByteMatchSet, IPSet, SizeConstraintSet, SqlInjectionMatchSet, or XssMatchSet objects to include in a rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_regex_match_set" '(
    ("name" "name - (Required) The name or description of the Regex Match Set.")
    ("regex_match_tuple" "regex_match_tuple - (Required) The regular expression pattern that you want AWS WAF to search for in web requests, the location in requests that you want AWS WAF to search, and other settings. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_regex_pattern_set" '(
    ("name" "name - (Required) The name or description of the Regex Pattern Set.")
    ("regex_pattern_strings" "regex_pattern_strings - (Optional) A list of regular expression (regex) patterns that you want AWS WAF to search for, such as B[a@]dB[o0]t.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_rule" '(
    ("name" "name - (Required) The name or description of the rule.")
    ("metric_name" "metric_name - (Required) The name or description for the Amazon CloudWatch metric of this rule.")
    ("predicate" "predicate - (Optional) The objects to include in a rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_rule_group" '(
    ("name" "name - (Required) A friendly name of the rule group")
    ("metric_name" "metric_name - (Required) A friendly name for the metrics from the rule group")
    ("activated_rule" "activated_rule - (Optional) A list of activated rules, see below")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_size_constraint_set" '(
    ("name" "name - (Required) The name or description of the Size Constraint Set.")
    ("size_constraints" "size_constraints - (Optional) Specifies the parts of web requests that you want to inspect the size of.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_sql_injection_match_set" '(
    ("name" "name - (Required) The name or description of the SizeConstraintSet.")
    ("sql_injection_match_tuple" "sql_injection_match_tuple - (Optional) The parts of web requests that you want AWS WAF to inspect for malicious SQL code and, if you want AWS WAF to inspect a header, the name of the header.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_web_acl" '(
    ("default_action" "default_action - (Required) The action that you want AWS WAF Regional to take when a request doesn't match the criteria in any of the rules that are associated with the web ACL.")
    ("metric_name" "metric_name - (Required) The name or description for the Amazon CloudWatch metric of this web ACL.")
    ("name" "name - (Required) The name or description of the web ACL.")
    ("rule" "rule - (Required) The rules to associate with the web ACL and the settings for each rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_web_acl_association" '(
    ("web_acl_id" "web_acl_id - (Required) The ID of the WAF Regional WebACL to create an association.")
    ("resource_arn" "resource_arn - (Required) Application Load Balancer ARN to associate with.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_wafregional_xss_match_set" '(
    ("name" "name - (Required) The name of the set")
    ("xss_match_tuple" "xss_match_tuple - (Optional) The parts of web requests that you want to inspect for cross-site scripting attacks.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route53_delegation_set" '(
    ("reference_name" "reference_name - (Optional) This is a reference name used in Caller Reference (helpful for identifying single delegation set amongst others)")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route53_health_check" '(
    ("reference_name" "reference_name - (Optional) This is a reference name used in Caller Reference (helpful for identifying single health_check set amongst others)")
    ("fqdn" "fqdn - (Optional) The fully qualified domain name of the endpoint to be checked.")
    ("ip_address" "ip_address - (Optional) The IP address of the endpoint to be checked.")
    ("port" "port - (Optional) The port of the endpoint to be checked.")
    ("type" "type - (Required) The protocol to use when performing health checks. Valid values are HTTP, HTTPS, HTTP_STR_MATCH, HTTPS_STR_MATCH, TCP, CALCULATED and CLOUDWATCH_METRIC.")
    ("failure_threshold" "failure_threshold - (Required) The number of consecutive health checks that an endpoint must pass or fail.")
    ("request_interval" "request_interval - (Required) The number of seconds between the time that Amazon Route 53 gets a response from your endpoint and the time that it sends the next health-check request.")
    ("resource_path" "resource_path - (Optional) The path that you want Amazon Route 53 to request when performing health checks.")
    ("search_string" "search_string - (Optional) String searched in the first 5120 bytes of the response body for check to be considered healthy.")
    ("measure_latency" "measure_latency - (Optional) A Boolean value that indicates whether you want Route 53 to measure the latency between health checkers in multiple AWS regions and your endpoint and to display CloudWatch latency graphs in the Route 53 console.")
    ("invert_healthcheck" "invert_healthcheck - (Optional) A boolean value that indicates whether the status of health check should be inverted. For example, if a health check is healthy but Inverted is True , then Route 53 considers the health check to be unhealthy.")
    ("enable_sni" "enable_sni - (Optional) A boolean value that indicates whether Route53 should send the fqdn to the endpoint when performing the health check. This defaults to AWS' defaults: when the type is \"HTTPS\" enable_sni defaults to true, when type is anything else enable_sni defaults to false.")
    ("child_healthchecks" "child_healthchecks - (Optional) For a specified parent health check, a list of HealthCheckId values for the associated child health checks.")
    ("child_health_threshold" "child_health_threshold - (Optional) The minimum number of child health checks that must be healthy for Route 53 to consider the parent health check to be healthy. Valid values are integers between 0 and 256, inclusive")
    ("cloudwatch_alarm_name" "cloudwatch_alarm_name - (Optional) The name of the CloudWatch alarm.")
    ("cloudwatch_alarm_region" "cloudwatch_alarm_region - (Optional) The CloudWatchRegion that the CloudWatch alarm was created in.")
    ("insufficient_data_health_status" "insufficient_data_health_status - (Optional) The status of the health check when CloudWatch has insufficient data about the state of associated alarm. Valid values are Healthy , Unhealthy and LastKnownStatus.")
    ("regions" "regions - (Optional) A list of AWS regions that you want Amazon Route 53 health checkers to check the specified endpoint from.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the health check.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route53_query_log" '(
    ("cloudwatch_log_group_arn" "cloudwatch_log_group_arn - (Required) CloudWatch log group ARN to send query logs.")
    ("zone_id" "zone_id - (Required) Route53 hosted zone ID to enable query logs.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route53_record" '(
    ("zone_id" "zone_id - (Required) The ID of the hosted zone to contain this record.")
    ("name" "name - (Required) The name of the record.")
    ("type" "type - (Required) The record type. Valid values are A, AAAA, CAA, CNAME, MX, NAPTR, NS, PTR, SOA, SPF, SRV and TXT.")
    ("ttl" "ttl - (Required for non-alias records) The TTL of the record.")
    ("records" "records - (Required for non-alias records) A string list of records. To specify a single record value longer than 255 characters such as a TXT record for DKIM, add \\\"\\\" inside the Terraform configuration string (e.g. \"first255characters\\\"\\\"morecharacters\").")
    ("set_identifier" "set_identifier - (Optional) Unique identifier to differentiate records with routing policies from one another. Required if using failover, geolocation, latency, or weighted routing policies documented below.")
    ("health_check_id" "health_check_id - (Optional) The health check the record should be associated with.")
    ("alias" "alias - (Optional) An alias block. Conflicts with ttl & records. Alias record documented below.")
    ("failover_routing_policy" "failover_routing_policy - (Optional) A block indicating the routing behavior when associated health check fails. Conflicts with any other routing policy. Documented below.")
    ("geolocation_routing_policy" "geolocation_routing_policy - (Optional) A block indicating a routing policy based on the geolocation of the requestor. Conflicts with any other routing policy. Documented below.")
    ("latency_routing_policy" "latency_routing_policy - (Optional) A block indicating a routing policy based on the latency between the requestor and an AWS region. Conflicts with any other routing policy. Documented below.")
    ("weighted_routing_policy" "weighted_routing_policy - (Optional) A block indicating a weighted routing policy. Conflicts with any other routing policy. Documented below.")
    ("multivalue_answer_routing_policy" "multivalue_answer_routing_policy - (Optional) Set to true to indicate a multivalue answer routing policy. Conflicts with any other routing policy.")
    ("allow_overwrite" "allow_overwrite - (Optional) Allow creation of this record in Terraform to overwrite an existing record, if any. This does not prevent other resources within Terraform or manual Route53 changes from overwriting this record. true by default.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route53_zone" '(
    ("name" "name - (Required) This is the name of the hosted zone.")
    ("comment" "comment - (Optional) A comment for the hosted zone. Defaults to 'Managed by Terraform'.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the zone.")
    ("vpc_id" "vpc_id - (Optional) The VPC to associate with a private hosted zone. Specifying vpc_id will create a private hosted zone. Conflicts w/ delegation_set_id as delegation sets can only be used for public zones.")
    ("vpc_region" "vpc_region - (Optional) The VPC's region. Defaults to the region of the AWS provider.")
    ("delegation_set_id" "delegation_set_id - (Optional) The ID of the reusable delegation set whose NS records you want to assign to the hosted zone. Conflicts w/ vpc_id as delegation sets can only be used for public zones.")
    ("force_destroy" "force_destroy - (Optional) Whether to destroy all records (possibly managed outside of Terraform) in the zone when destroying the zone.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route53_zone_association" '(
    ("zone_id" "zone_id - (Required) The private hosted zone to associate.")
    ("vpc_id" "vpc_id - (Required) The VPC to associate with the private hosted zone.")
    ("vpc_region" "vpc_region - (Optional) The VPC's region. Defaults to the region of the AWS provider.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_s3_bucket" '(
    ("bucket" "bucket - (Optional, Forces new resource) The name of the bucket. If omitted, Terraform will assign a random, unique name.")
    ("bucket_prefix" "bucket_prefix - (Optional, Forces new resource) Creates a unique bucket name beginning with the specified prefix. Conflicts with bucket.")
    ("acl" "acl - (Optional) The canned ACL to apply. Defaults to \"private\".")
    ("policy" "policy - (Optional) A valid bucket policy JSON document. Note that if the policy document is not specific enough (but still valid), Terraform may view the policy as constantly changing in a terraform plan. In this case, please make sure you use the verbose/specific version of the policy.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the bucket.")
    ("force_destroy" "force_destroy - (Optional, Default:false ) A boolean that indicates all objects should be deleted from the bucket so that the bucket can be destroyed without error. These objects are not recoverable.")
    ("website" "website - (Optional) A website object (documented below).")
    ("cors_rule" "cors_rule - (Optional) A rule of Cross-Origin Resource Sharing (documented below).")
    ("versioning" "versioning - (Optional) A state of versioning (documented below)")
    ("logging" "logging - (Optional) A settings of bucket logging (documented below).")
    ("lifecycle_rule" "lifecycle_rule - (Optional) A configuration of object lifecycle management (documented below).")
    ("acceleration_status" "acceleration_status - (Optional) Sets the accelerate configuration of an existing bucket. Can be Enabled or Suspended.")
    ("region" "region - (Optional) If specified, the AWS region this bucket should reside in. Otherwise, the region used by the callee.")
    ("request_payer" "request_payer - (Optional) Specifies who should bear the cost of Amazon S3 data transfer. Can be either BucketOwner or Requester. By default, the owner of the S3 bucket would incur the costs of any data transfer. See Requester Pays Buckets developer guide for more information.")
    ("replication_configuration" "replication_configuration - (Optional) A configuration of replication configuration (documented below).")
    ("server_side_encryption_configuration" "server_side_encryption_configuration - (Optional) A configuration of server-side encryption configuration (documented below)")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_s3_bucket_metric" '(
    ("bucket" "bucket - (Required) The name of the bucket to put metric configuration.")
    ("name" "name - (Required) Unique identifier of the metrics configuration for the bucket.")
    ("filter" "filter - (Optional) Object filtering that accepts a prefix, tags, or a logical AND of prefix and tags (documented below).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_s3_bucket_notification" '(
    ("bucket" "bucket - (Required) The name of the bucket to put notification configuration.")
    ("topic" "topic - (Optional) The notification configuration to SNS Topic (documented below).")
    ("queue" "queue - (Optional) The notification configuration to SQS Queue (documented below).")
    ("lambda_function" "lambda_function - (Optional, Multiple) Used to configure notifications to a Lambda Function (documented below).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_s3_bucket_object" '(
    ("bucket" "bucket - (Required) The name of the bucket to put the file in.")
    ("key" "key - (Required) The name of the object once it is in the bucket.")
    ("source" "source - (Required unless content or content_base64 is set) The path to a file that will be read and uploaded as raw bytes for the object content.")
    ("content" "content - (Required unless source or content_base64 is set) Literal string value to use as the object content, which will be uploaded as UTF-8-encoded text.")
    ("content_base64" "content_base64 - (Required unless source or content is set) Base64-encoded data that will be decoded and uploaded as raw bytes for the object content. This allows safely uploading non-UTF8 binary data, but is recommended only for small content such as the result of the gzipbase64 function with small text strings. For larger objects, use source to stream the content from a disk file.")
    ("acl" "acl - (Optional) The canned ACL to apply. Defaults to \"private\".")
    ("cache_control" "cache_control - (Optional) Specifies caching behavior along the request/reply chain Read w3c cache_control for further details.")
    ("content_disposition" "content_disposition - (Optional) Specifies presentational information for the object. Read w3c content_disposition for further information.")
    ("content_encoding" "content_encoding - (Optional) Specifies what content encodings have been applied to the object and thus what decoding mechanisms must be applied to obtain the media-type referenced by the Content-Type header field. Read w3c content encoding for further information.")
    ("content_language" "content_language - (Optional) The language the content is in e.g. en-US or en-GB.")
    ("content_type" "content_type - (Optional) A standard MIME type describing the format of the object data, e.g. application/octet-stream. All Valid MIME Types are valid for this input.")
    ("website_redirect" "website_redirect - (Optional) Specifies a target URL for website redirect.")
    ("storage_class" "storage_class - (Optional) Specifies the desired Storage Class for the object. Can be either \"STANDARD\", \"REDUCED_REDUNDANCY\", \"ONEZONE_IA\", or \"STANDARD_IA\". Defaults to \"STANDARD\".")
    ("etag" "etag - (Optional) Used to trigger updates. The only meaningful value is ${md5(file(\"path/to/file\"))}. This attribute is not compatible with kms_key_id.")
    ("server_side_encryption" "server_side_encryption - (Optional) Specifies server-side encryption of the object in S3. Valid values are \"AES256\" and \"aws:kms\".")
    ("kms_key_id" "kms_key_id - (Optional) Specifies the AWS KMS Key ARN to use for object encryption. This value is a fully qualified ARN of the KMS Key. If using aws_kms_key, use the exported arn attribute:   kms_key_id = \"${aws_kms_key.foo.arn}\"")
    ("tags" "tags - (Optional) A mapping of tags to assign to the object.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_s3_bucket_policy" '(
    ("bucket" "bucket - (Required) The name of the bucket to which to apply the policy.")
    ("policy" "policy - (Required) The text of the policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_secretsmanager_secret" '(
    ("name" "name - (Required) Specifies the friendly name of the new secret. The secret name can consist of uppercase letters, lowercase letters, digits, and any of the following characters: /_+=.@- Spaces are not permitted.")
    ("description" "description - (Optional) A description of the secret.")
    ("kms_key_id" "kms_key_id - (Optional) Specifies the ARN or alias of the AWS KMS customer master key (CMK) to be used to encrypt the secret values in the versions stored in this secret. If you don't specify this value, then Secrets Manager defaults to using the AWS account's default CMK (the one named aws/secretsmanager). If the default KMS CMK with that name doesn't yet exist, then AWS Secrets Manager creates it for you automatically the first time.")
    ("recovery_window_in_days" "recovery_window_in_days - (Optional) Specifies the number of days that AWS Secrets Manager waits before it can delete the secret. This value can range from 7 to 30 days. The default value is 30.")
    ("rotation_lambda_arn" "rotation_lambda_arn - (Optional) Specifies the ARN of the Lambda function that can rotate the secret.")
    ("rotation_rules" "rotation_rules - (Optional) A structure that defines the rotation configuration for this secret. Defined below.")
    ("tags" "tags - (Optional) Specifies a key-value map of user-defined tags that are attached to the secret.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_secretsmanager_secret_version" '(
    ("secret_id" "secret_id - (Required) Specifies the secret to which you want to add a new version. You can specify either the Amazon Resource Name (ARN) or the friendly name of the secret. The secret must already exist.")
    ("secret_string" "secret_string - (Required) Specifies text data that you want to encrypt and store in this version of the secret.")
    ("version_stages" "version_stages - (Optional) Specifies a list of staging labels that are attached to this version of the secret. A staging label must be unique to a single version of the secret. If you specify a staging label that's already associated with a different version of the same secret then that staging label is automatically removed from the other version and attached to this version. If you do not specify a value, then AWS Secrets Manager automatically moves the staging label AWSCURRENT to this new version on creation.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_active_receipt_rule_set" '(
    ("rule_set_name" "rule_set_name - (Required) The name of the rule set")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_domain_identity" '(
    ("domain" "domain - (Required) The domain name to assign to SES")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_domain_identity_verification" '(
    ("domain" "domain - (Required) The domain name of the SES domain identity to verify.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_domain_dkim" '(
    ("domain" "domain - (Required) Verified domain name to generate DKIM tokens for.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_domain_mail_from" '(
    ("domain" "domain - (Required) Verified domain name to generate DKIM tokens for.")
    ("mail_from_domain" "mail_from_domain - (Required) Subdomain (of above domain) which is to be used as MAIL FROM address (Required for DMARC validation)")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_receipt_filter" '(
    ("name" "name - (Required) The name of the filter")
    ("cidr" "cidr - (Required) The IP address or address range to filter, in CIDR notation")
    ("policy" "policy - (Required) Block or Allow")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_receipt_rule" '(
    ("name" "name - (Required) The name of the rule")
    ("rule_set_name" "rule_set_name - (Required) The name of the rule set")
    ("after" "after - (Optional) The name of the rule to place this rule after")
    ("enabled" "enabled - (Optional) If true, the rule will be enabled")
    ("recipients" "recipients - (Optional) A list of email addresses")
    ("scan_enabled" "scan_enabled - (Optional) If true, incoming emails will be scanned for spam and viruses")
    ("tls_policy" "tls_policy - (Optional) Require or Optional")
    ("add_header_action" "add_header_action - (Optional) A list of Add Header Action blocks. Documented below.")
    ("bounce_action" "bounce_action - (Optional) A list of Bounce Action blocks. Documented below.")
    ("lambda_action" "lambda_action - (Optional) A list of Lambda Action blocks. Documented below.")
    ("s3_action" "s3_action - (Optional) A list of S3 Action blocks. Documented below.")
    ("sns_action" "sns_action - (Optional) A list of SNS Action blocks. Documented below.")
    ("stop_action" "stop_action - (Optional) A list of Stop Action blocks. Documented below.")
    ("workmail_action" "workmail_action - (Optional) A list of WorkMail Action blocks. Documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_receipt_rule_set" '(
    ("rule_set_name" "rule_set_name - (Required) The name of the rule set")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_configuration_set" '(
    ("name" "name - (Required) The name of the configuration set")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_event_destination" '(
    ("name" "name - (Required) The name of the event destination")
    ("configuration_set_name" "configuration_set_name - (Required) The name of the configuration set")
    ("enabled" "enabled - (Optional) If true, the event destination will be enabled")
    ("matching_types" "matching_types - (Required) A list of matching types. May be any of \"send\", \"reject\", \"bounce\", \"complaint\", \"delivery\", \"open\", or \"click\".")
    ("cloudwatch_destination" "cloudwatch_destination - (Optional) CloudWatch destination for the events")
    ("kinesis_destination" "kinesis_destination - (Optional) Send the events to a kinesis firehose destination")
    ("sns_destination" "sns_destination - (Optional) Send the events to an SNS Topic destination")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_identity_notification_topic" '(
    ("topic_arn" "topic_arn - (Optional) The Amazon Resource Name (ARN) of the Amazon SNS topic. Can be set to \"\" (an empty string) to disable publishing.")
    ("notification_type" "notification_type - (Required) The type of notifications that will be published to the specified Amazon SNS topic. Valid Values: Bounce, Complaint or Delivery.")
    ("identity" "identity - (Required) The identity for which the Amazon SNS topic will be set. You can specify an identity by using its name or by using its Amazon Resource Name (ARN).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ses_template" '(
    ("name" "name - (Required) The name of the template. Cannot exceed 64 characters. You will refer to this name when you send email.")
    ("html" "html - (Optional) The HTML body of the email. Must be less than 500KB in size, including both the text and HTML parts.")
    ("subject" "subject - (Optional) The subject line of the email.")
    ("text" "text - (Optional) The email body that will be visible to recipients whose email clients do not display HTML. Must be less than 500KB in size, including both the text and HTML parts.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_servicecatalog_portfolio" '(
    ("name" "name - (Required) The name of the portfolio.")
    ("description" "description - (Required) Description of the portfolio")
    ("provider_name" "provider_name - (Required) Name of the person or organization who owns the portfolio.")
    ("tags" "tags - (Optional) Tags to apply to the connection.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_service_discovery_private_dns_namespace" '(
    ("name" "name - (Required) The name of the namespace.")
    ("vpc" "vpc - (Required) The ID of VPC that you want to associate the namespace with.")
    ("description" "description - (Optional) The description that you specify for the namespace when you create it.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_service_discovery_public_dns_namespace" '(
    ("name" "name - (Required) The name of the namespace.")
    ("description" "description - (Optional) The description that you specify for the namespace when you create it.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_service_discovery_service" '(
    ("name" "name - (Required, ForceNew) The name of the service.")
    ("description" "description - (Optional) The description of the service.")
    ("dns_config" "dns_config - (Required) A complex type that contains information about the resource record sets that you want Amazon Route 53 to create when you register an instance.")
    ("health_check_config" "health_check_config - (Optional) A complex type that contains settings for an optional health check. Only for Public DNS namespaces.")
    ("health_check_custom_config" "health_check_custom_config - (Optional, ForceNew) A complex type that contains settings for ECS managed health checks.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sfn_activity" '(
    ("name" "name - (Required) The name of the activity to create.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sfn_state_machine" '(
    ("name" "name - (Required) The name of the state machine.")
    ("definition" "definition - (Required) The Amazon States Language definition of the state machine.")
    ("role_arn" "role_arn - (Required) The Amazon Resource Name (ARN) of the IAM role to use for this state machine.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_simpledb_domain" '(
    ("name" "name - (Required) The name of the SimpleDB domain")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sns_platform_application" '(
    ("name" "name - (Required) The friendly name for the SNS platform application")
    ("platform" "platform - (Required) The platform that the app is registered with. See Platform for supported platforms.")
    ("platform_credential" "platform_credential - (Required) Application Platform credential. See Credential for type of credential required for platform. The value of this attribute when stored into the Terraform state is only a hash of the real value, so therefore it is not practical to use this as an attribute for other resources.")
    ("event_delivery_failure_topic_arn" "event_delivery_failure_topic_arn - (Optional) SNS Topic triggered when a delivery to any of the platform endpoints associated with your platform application encounters a permanent failure.")
    ("event_endpoint_created_topic_arn" "event_endpoint_created_topic_arn - (Optional) SNS Topic triggered when a new platform endpoint is added to your platform application.")
    ("event_endpoint_deleted_topic_arn" "event_endpoint_deleted_topic_arn - (Optional) SNS Topic triggered when an existing platform endpoint is deleted from your platform application.")
    ("event_endpoint_updated_topic_arn" "event_endpoint_updated_topic_arn - (Optional) SNS Topic triggered when an existing platform endpoint is changed from your platform application.")
    ("failure_feedback_role_arn" "failure_feedback_role_arn - (Optional) The IAM role permitted to receive failure feedback for this application.")
    ("platform_principal" "platform_principal - (Optional) Application Platform principal. See Principal for type of principal required for platform. The value of this attribute when stored into the Terraform state is only a hash of the real value, so therefore it is not practical to use this as an attribute for other resources.")
    ("success_feedback_role_arn" "success_feedback_role_arn - (Optional) The IAM role permitted to receive success feedback for this application.")
    ("success_feedback_sample_rate" "success_feedback_sample_rate - (Optional) The percentage of success to sample (0-100)")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sns_topic" '(
    ("name" "name - (Optional) The friendly name for the SNS topic. By default generated by Terraform.")
    ("name_prefix" "name_prefix - (Optional) The friendly name for the SNS topic. Conflicts with name.")
    ("display_name" "display_name - (Optional) The display name for the SNS topic")
    ("policy" "policy - (Optional) The fully-formed AWS policy as JSON")
    ("delivery_policy" "delivery_policy - (Optional) The SNS delivery policy")
    ("application_success_feedback_role_arn" "application_success_feedback_role_arn - (Optional) The IAM role permitted to receive success feedback for this topic")
    ("application_success_feedback_sample_rate" "application_success_feedback_sample_rate - (Optional) Percentage of success to sample")
    ("application_failure_feedback_role_arn" "application_failure_feedback_role_arn - (Optional) IAM role for failure feedback")
    ("http_success_feedback_role_arn" "http_success_feedback_role_arn - (Optional) The IAM role permitted to receive success feedback for this topic")
    ("http_success_feedback_sample_rate" "http_success_feedback_sample_rate - (Optional) Percentage of success to sample")
    ("http_failure_feedback_role_arn" "http_failure_feedback_role_arn - (Optional) IAM role for failure feedback")
    ("lambda_success_feedback_role_arn" "lambda_success_feedback_role_arn - (Optional) The IAM role permitted to receive success feedback for this topic")
    ("lambda_success_feedback_sample_rate" "lambda_success_feedback_sample_rate - (Optional) Percentage of success to sample")
    ("lambda_failure_feedback_role_arn" "lambda_failure_feedback_role_arn - (Optional) IAM role for failure feedback")
    ("sqs_success_feedback_role_arn" "sqs_success_feedback_role_arn - (Optional) The IAM role permitted to receive success feedback for this topic")
    ("sqs_success_feedback_sample_rate" "sqs_success_feedback_sample_rate - (Optional) Percentage of success to sample")
    ("sqs_failure_feedback_role_arn" "sqs_failure_feedback_role_arn - (Optional) IAM role for failure feedback")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sns_topic_policy" '(
    ("arn" "arn - (Required) The ARN of the SNS topic")
    ("policy" "policy - (Required) The fully-formed AWS policy as JSON")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sns_topic_subscription" '(
    ("topic_arn" "topic_arn - (Required) The ARN of the SNS topic to subscribe to")
    ("protocol" "protocol - (Required) The protocol to use. The possible values for this are: sqs, sms, lambda, application. (http or https are partially supported, see below) (email is option but unsupported, see below).")
    ("endpoint" "endpoint - (Required) The endpoint to send data to, the contents will vary with the protocol. (see below for more information)")
    ("endpoint_auto_confirms" "endpoint_auto_confirms - (Optional) Boolean indicating whether the end point is capable of auto confirming subscription e.g., PagerDuty (default is false)")
    ("confirmation_timeout_in_minutes" "confirmation_timeout_in_minutes - (Optional) Integer indicating number of minutes to wait in retying mode for fetching subscription arn before marking it as failure. Only applicable for http and https protocols (default is 1 minute).")
    ("raw_message_delivery" "raw_message_delivery - (Optional) Boolean indicating whether or not to enable raw message delivery (the original message is directly passed, not wrapped in JSON with the original message in the message property) (default is false).")
    ("filter_policy" "filter_policy - (Optional) The text of a filter policy to the topic subscription.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_activation" '(
    ("name" "name - (Optional) The default name of the registerd managed instance.")
    ("description" "description - (Optional) The description of the resource that you want to register.")
    ("expiration_date" "expiration_date - (Optional) A timestamp in RFC3339 format by which this activation request should expire. The default value is 24 hours from resource creation time.")
    ("iam_role" "iam_role - (Required) The IAM Role to attach to the managed instance.")
    ("registration_limit" "registration_limit - (Optional) The maximum number of managed instances you want to register. The default value is 1 instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_association" '(
    ("name" "name - (Required) The name of the SSM document to apply.")
    ("association_name" "association_name - (Optional) The descriptive name for the association.")
    ("document_version" "document_version - (Optional) The document version you want to associate with the target(s). Can be a specific version or the default version.")
    ("instance_id" "instance_id - (Optional) The instance ID to apply an SSM document to. Use targets with key InstanceIds for document schema versions 2.0 and above.")
    ("output_location" "output_location - (Optional) An output location block. Output Location is documented below.")
    ("parameters" "parameters - (Optional) A block of arbitrary string parameters to pass to the SSM document.")
    ("schedule_expression" "schedule_expression - (Optional) A cron expression when the association will be applied to the target(s).")
    ("targets" "targets - (Optional) A block containing the targets of the SSM association. Targets are documented below. AWS currently supports a maximum of 5 targets.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_document" '(
    ("name" "name - (Required) The name of the document.")
    ("content" "content - (Required) The JSON or YAML content of the document.")
    ("document_format" "document_format - (Optional, defaults to JSON) The format of the document. Valid document types include: JSON and YAML")
    ("document_type" "document_type - (Required) The type of the document. Valid document types include: Command, Policy and Automation")
    ("permissions" "permissions - (Optional) Additional Permissions to attach to the document. See Permissions below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_maintenance_window" '(
    ("name" "name - (Required) The name of the maintenance window.")
    ("schedule" "schedule - (Required) The schedule of the Maintenance Window in the form of a cron or rate expression.")
    ("cutoff" "cutoff - (Required) The number of hours before the end of the Maintenance Window that Systems Manager stops scheduling new tasks for execution.")
    ("duration" "duration - (Required) The duration of the Maintenance Window in hours.")
    ("allow_unassociated_targets" "allow_unassociated_targets - (Optional) Whether targets must be registered with the Maintenance Window before tasks can be defined for those targets.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_maintenance_window_target" '(
    ("window_id" "window_id - (Required) The Id of the maintenance window to register the target with.")
    ("resource_type" "resource_type - (Required) The type of target being registered with the Maintenance Window. Possible values INSTANCE.")
    ("targets" "targets - (Required) The targets (either instances or tags). Instances are specified using Key=instanceids,Values=instanceid1,instanceid2. Tags are specified using Key=tag name,Values=tag value.")
    ("owner_information" "owner_information - (Optional) User-provided value that will be included in any CloudWatch events raised while running tasks for these targets in this Maintenance Window.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_maintenance_window_task" '(
    ("window_id" "window_id - (Required) The Id of the maintenance window to register the task with.")
    ("max_concurrency" "max_concurrency - (Required) The maximum number of targets this task can be run for in parallel.")
    ("max_errors" "max_errors - (Required) The maximum number of errors allowed before this task stops being scheduled.")
    ("task_type" "task_type - (Required) The type of task being registered. The only allowed value is RUN_COMMAND.")
    ("task_arn" "task_arn - (Required) The ARN of the task to execute.")
    ("service_role_arn" "service_role_arn - (Required) The role that should be assumed when executing the task.")
    ("targets" "targets - (Required) The targets (either instances or window target ids). Instances are specified using Key=InstanceIds,Values=instanceid1,instanceid2. Window target ids are specified using Key=WindowTargetIds,Values=window target id1, window target id2.")
    ("priority" "priority - (Optional) The priority of the task in the Maintenance Window, the lower the number the higher the priority. Tasks in a Maintenance Window are scheduled in priority order with tasks that have the same priority scheduled in parallel.")
    ("logging_info" "logging_info - (Optional) A structure containing information about an Amazon S3 bucket to write instance-level logs to. Documented below.")
    ("task_parameters" "task_parameters - (Optional) A structure containing information about parameters required by the particular task_arn. Documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_patch_baseline" '(
    ("name" "name - (Required) The name of the patch baseline.")
    ("description" "description - (Optional) The description of the patch baseline.")
    ("operating_system" "operating_system - (Optional) Defines the operating system the patch baseline applies to. Supported operating systems include WINDOWS, AMAZON_LINUX, UBUNTU, CENTOS, and REDHAT_ENTERPRISE_LINUX. The Default value is WINDOWS.")
    ("approved_patches_compliance_level" "approved_patches_compliance_level - (Optional) Defines the compliance level for approved patches. This means that if an approved patch is reported as missing, this is the severity of the compliance violation. Valid compliance levels include the following: CRITICAL, HIGH, MEDIUM, LOW, INFORMATIONAL, UNSPECIFIED. The default value is UNSPECIFIED.")
    ("approved_patches" "approved_patches - (Optional) A list of explicitly approved patches for the baseline.")
    ("rejected_patches" "rejected_patches - (Optional) A list of rejected patches.")
    ("global_filter" "global_filter - (Optional) A set of global filters used to exclude patches from the baseline. Up to 4 global filters can be specified using Key/Value pairs. Valid Keys are PRODUCT | CLASSIFICATION | MSRC_SEVERITY | PATCH_ID.")
    ("approval_rule" "approval_rule - (Optional) A set of rules used to include patches in the baseline. up to 10 approval rules can be specified. Each approval_rule block requires the fields documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_patch_group" '(
    ("baseline_id" "baseline_id - (Required) The ID of the patch baseline to register the patch group with.")
    ("patch_group" "patch_group - (Required) The name of the patch group that should be registered with the patch baseline.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_parameter" '(
    ("name" "name - (Required) The name of the parameter.")
    ("type" "type - (Required) The type of the parameter. Valid types are String, StringList and SecureString.")
    ("value" "value - (Required) The value of the parameter.")
    ("description" "description - (Optional) The description of the parameter.")
    ("key_id" "key_id - (Optional) The KMS key id or arn for encrypting a SecureString.")
    ("overwrite" "overwrite - (Optional) Overwrite an existing parameter. If not specified, will default to false if the resource has not been created by terraform to avoid overwrite of existing resource and will default to true otherwise (terraform lifecycle rules should then be used to manage the update behavior).")
    ("allowed_pattern" "allowed_pattern - (Optional) A regular expression used to validate the parameter value.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the object.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_ssm_resource_data_sync" '(
    ("name" "name - (Required) Name for the configuration.")
    ("s3_destination" "s3_destination - (Required) Amazon S3 configuration details for the sync.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sqs_queue" '(
    ("name" "name - (Optional) This is the human-readable name of the queue. If omitted, Terraform will assign a random name.")
    ("name_prefix" "name_prefix - (Optional) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("visibility_timeout_seconds" "visibility_timeout_seconds - (Optional) The visibility timeout for the queue. An integer from 0 to 43200 (12 hours). The default for this attribute is 30. For more information about visibility timeout, see AWS docs.")
    ("message_retention_seconds" "message_retention_seconds - (Optional) The number of seconds Amazon SQS retains a message. Integer representing seconds, from 60 (1 minute) to 1209600 (14 days). The default for this attribute is 345600 (4 days).")
    ("max_message_size" "max_message_size - (Optional) The limit of how many bytes a message can contain before Amazon SQS rejects it. An integer from 1024 bytes (1 KiB) up to 262144 bytes (256 KiB). The default for this attribute is 262144 (256 KiB).")
    ("delay_seconds" "delay_seconds - (Optional) The time in seconds that the delivery of all messages in the queue will be delayed. An integer from 0 to 900 (15 minutes). The default for this attribute is 0 seconds.")
    ("receive_wait_time_seconds" "receive_wait_time_seconds - (Optional) The time for which a ReceiveMessage call will wait for a message to arrive (long polling) before returning. An integer from 0 to 20 (seconds). The default for this attribute is 0, meaning that the call will return immediately.")
    ("policy" "policy - (Optional) The JSON policy for the SQS queue")
    ("redrive_policy" "redrive_policy - (Optional) The JSON policy to set up the Dead Letter Queue, see AWS docs. Note: when specifying maxReceiveCount, you must specify it as an integer (5), and not a string (\"5\").")
    ("fifo_queue" "fifo_queue - (Optional) Boolean designating a FIFO queue. If not set, it defaults to false making it standard.")
    ("content_based_deduplication" "content_based_deduplication - (Optional) Enables content-based deduplication for FIFO queues. For more information, see the related documentation")
    ("kms_master_key_id" "kms_master_key_id - (Optional) The ID of an AWS-managed customer master key (CMK) for Amazon SQS or a custom CMK. For more information, see Key Terms.")
    ("kms_data_key_reuse_period_seconds" "kms_data_key_reuse_period_seconds - (Optional) The length of time, in seconds, for which Amazon SQS can reuse a data key to encrypt or decrypt messages before calling AWS KMS again. An integer representing seconds, between 60 seconds (1 minute) and 86,400 seconds (24 hours). The default is 300 (5 minutes).")
    ("tags" "tags - (Optional) A mapping of tags to assign to the queue.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_sqs_queue_policy" '(
    ("queue_url" "queue_url - (Required) The URL of the SQS Queue to which to attach the policy")
    ("policy" "policy - (Required) The JSON policy for the SQS queue")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_customer_gateway" '(
    ("bgp_asn" "bgp_asn - (Required) The gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).")
    ("ip_address" "ip_address - (Required) The IP address of the gateway's Internet-routable external interface.")
    ("type" "type - (Required) The type of customer gateway. The only type AWS supports at this time is \"ipsec.1\".")
    ("tags" "tags - (Optional) Tags to apply to the gateway.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_default_network_acl" '(
    ("default_network_acl_id" "default_network_acl_id - (Required) The Network ACL ID to manage. This attribute is exported from aws_vpc, or manually found via the AWS Console.")
    ("subnet_ids" "subnet_ids - (Optional) A list of Subnet IDs to apply the ACL to. See the notes below on managing Subnets in the Default Network ACL")
    ("ingress" "ingress - (Optional) Specifies an ingress rule. Parameters defined below.")
    ("egress" "egress - (Optional) Specifies an egress rule. Parameters defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_default_route_table" '(
    ("default_route_table_id" "default_route_table_id - (Required) The ID of the Default Routing Table.")
    ("route" "route - (Optional) A list of route objects. Their keys are documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("propagating_vgws" "propagating_vgws - (Optional) A list of virtual gateways for propagation.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_default_security_group" '(
    ("ingress" "ingress - (Optional) Can be specified multiple times for each ingress rule. Each ingress block supports fields documented below.")
    ("egress" "egress - (Optional, VPC only) Can be specified multiple times for each   egress rule. Each egress block supports fields documented below.")
    ("vpc_id" "vpc_id - (Optional, Forces new resource) The VPC ID. Note that changing the vpc_id will not restore any default security group rules that were modified, added, or removed. It will be left in its current state")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_default_subnet" '(
    ("map_public_ip_on_launch" "map_public_ip_on_launch -  (Optional) Specify true to indicate that instances launched into the subnet should be assigned a public IP address.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_default_vpc" '(
    ("enable_dns_support" "enable_dns_support - (Optional) A boolean flag to enable/disable DNS support in the VPC. Defaults true.")
    ("enable_dns_hostnames" "enable_dns_hostnames - (Optional) A boolean flag to enable/disable DNS hostnames in the VPC. Defaults false.")
    ("enable_classiclink" "enable_classiclink - (Optional) A boolean flag to enable/disable ClassicLink  for the VPC. Only valid in regions and accounts that support EC2 Classic. See the ClassicLink documentation for more information. Defaults false.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_default_vpc_dhcp_options" '(
    ("netbios_name_servers" "netbios_name_servers - (Optional) List of NETBIOS name servers.")
    ("netbios_node_type" "netbios_node_type - (Optional) The NetBIOS node type (1, 2, 4, or 8). AWS recommends to specify 2 since broadcast and multicast are not supported in their network. For more information about these node types, see RFC 2132.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_egress_only_internet_gateway" '(
    ("vpc_id" "vpc_id - (Required) The VPC ID to create in.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_flow_log" '(
    ("log_group_name" "log_group_name - (Required) The name of the CloudWatch log group")
    ("iam_role_arn" "iam_role_arn - (Required) The ARN for the IAM role that's used to post flow logs to a CloudWatch Logs log group")
    ("vpc_id" "vpc_id - (Optional) VPC ID to attach to")
    ("subnet_id" "subnet_id - (Optional) Subnet ID to attach to")
    ("eni_id" "eni_id - (Optional) Elastic Network Interface ID to attach to")
    ("traffic_type" "traffic_type - (Required) The type of traffic to capture. Valid values: ACCEPT,REJECT, ALL")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_internet_gateway" '(
    ("vpc_id" "vpc_id - (Required) The VPC ID to create in.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_main_route_table_association" '(
    ("vpc_id" "vpc_id - (Required) The ID of the VPC whose main route table should be set")
    ("route_table_id" "route_table_id - (Required) The ID of the Route Table to set as the new main route table for the target VPC")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_nat_gateway" '(
    ("allocation_id" "allocation_id - (Required) The Allocation ID of the Elastic IP address for the gateway.")
    ("subnet_id" "subnet_id - (Required) The Subnet ID of the subnet in which to place the gateway.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_network_acl" '(
    ("vpc_id" "vpc_id - (Required) The ID of the associated VPC.")
    ("subnet_ids" "subnet_ids - (Optional) A list of Subnet IDs to apply the ACL to")
    ("subnet_id" "subnet_id - (Optional, Deprecated) The ID of the associated Subnet. This attribute is deprecated, please use the subnet_ids attribute instead")
    ("ingress" "ingress - (Optional) Specifies an ingress rule. Parameters defined below.")
    ("egress" "egress - (Optional) Specifies an egress rule. Parameters defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_network_acl_rule" '(
    ("network_acl_id" "network_acl_id - (Required) The ID of the network ACL.")
    ("rule_number" "rule_number - (Required) The rule number for the entry (for example, 100). ACL entries are processed in ascending order by rule number.")
    ("egress" "egress - (Optional, bool) Indicates whether this is an egress rule (rule is applied to traffic leaving the subnet). Default false.")
    ("protocol" "protocol - (Required) The protocol. A value of -1 means all protocols.")
    ("rule_action" "rule_action - (Required) Indicates whether to allow or deny the traffic that matches the rule. Accepted values: allow | deny")
    ("cidr_block" "cidr_block - (Optional) The network range to allow or deny, in CIDR notation (for example 172.16.0.0/24 ).")
    ("ipv6_cidr_block" "ipv6_cidr_block - (Optional) The IPv6 CIDR block to allow or deny.")
    ("from_port" "from_port - (Optional) The from port to match.")
    ("to_port" "to_port - (Optional) The to port to match.")
    ("icmp_type" "icmp_type - (Optional) ICMP protocol: The ICMP type. Required if specifying ICMP for the protocol. e.g. -1")
    ("icmp_code" "icmp_code - (Optional) ICMP protocol: The ICMP code. Required if specifying ICMP for the protocol. e.g. -1")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_network_interface" '(
    ("subnet_id" "subnet_id - (Required) Subnet ID to create the ENI in.")
    ("description" "description - (Optional) A description for the network interface.")
    ("private_ips" "private_ips - (Optional) List of private IPs to assign to the ENI.")
    ("private_ips_count" "private_ips_count - (Optional) Number of private IPs to assign to the ENI.")
    ("security_groups" "security_groups - (Optional) List of security group IDs to assign to the ENI.")
    ("attachment" "attachment - (Optional) Block to define the attachment of the ENI. Documented below.")
    ("source_dest_check" "source_dest_check - (Optional) Whether to enable source destination checking for the ENI. Default true.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_network_interface_attachment" '(
    ("instance_id" "instance_id - (Required) Instance ID to attach.")
    ("network_interface_id" "network_interface_id - (Required) ENI ID to attach.")
    ("device_index" "device_index - (Required) Network interface index (int).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route" '(
    ("route_table_id" "route_table_id - (Required) The ID of the routing table.")
    ("destination_cidr_block" "destination_cidr_block - (Optional) The destination CIDR block.")
    ("destination_ipv6_cidr_block" "destination_ipv6_cidr_block - (Optional) The destination IPv6 CIDR block.")
    ("vpc_peering_connection_id" "vpc_peering_connection_id - (Optional) An ID of a VPC peering connection.")
    ("egress_only_gateway_id" "egress_only_gateway_id - (Optional) An ID of a VPC Egress Only Internet Gateway.")
    ("gateway_id" "gateway_id - (Optional) An ID of a VPC internet gateway or a virtual private gateway.")
    ("nat_gateway_id" "nat_gateway_id - (Optional) An ID of a VPC NAT gateway.")
    ("instance_id" "instance_id - (Optional) An ID of an EC2 instance.")
    ("network_interface_id" "network_interface_id - (Optional) An ID of a network interface.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route_table" '(
    ("vpc_id" "vpc_id - (Required) The VPC ID.")
    ("route" "route - (Optional) A list of route objects. Their keys are documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("propagating_vgws" "propagating_vgws - (Optional) A list of virtual gateways for propagation.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_route_table_association" '(
    ("subnet_id" "subnet_id - (Required) The subnet ID to create an association.")
    ("route_table_id" "route_table_id - (Required) The ID of the routing table to associate with.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_security_group" '(
    ("name" "name - (Optional, Forces new resource) The name of the security group. If omitted, Terraform will assign a random, unique name")
    ("name_prefix" "name_prefix - (Optional, Forces new resource) Creates a unique name beginning with the specified prefix. Conflicts with name.")
    ("description" "description - (Optional, Forces new resource) The security group description. Defaults to \"Managed by Terraform\". Cannot be \"\". NOTE: This field maps to the AWS GroupDescription attribute, for which there is no Update API. If you'd like to classify your security groups in a way that can be updated, use tags.")
    ("ingress" "ingress - (Optional) Can be specified multiple times for each ingress rule. Each ingress block supports fields documented below.")
    ("egress" "egress - (Optional, VPC only) Can be specified multiple times for each   egress rule. Each egress block supports fields documented below.")
    ("revoke_rules_on_delete" "revoke_rules_on_delete - (Optional) Instruct Terraform to revoke all of the Security Groups attached ingress and egress rules before deleting the rule itself. This is normally not needed, however certain AWS services such as Elastic Map Reduce may automatically add required rules to security groups used with the service, and those rules may contain a cyclic dependency that prevent the security groups from being destroyed without removing the dependency first. Default false")
    ("vpc_id" "vpc_id - (Optional, Forces new resource) The VPC ID.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_network_interface_sg_attachment" '(
    ("security_group_id" "security_group_id - (Required) The ID of the security group.")
    ("network_interface_id" "network_interface_id - (Required) The ID of the network interface to attach to.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_security_group_rule" '(
    ("type" "type - (Required) The type of rule being created. Valid options are ingress (inbound) or egress (outbound).")
    ("cidr_blocks" "cidr_blocks - (Optional) List of CIDR blocks. Cannot be specified with source_security_group_id.")
    ("ipv6_cidr_blocks" "ipv6_cidr_blocks - (Optional) List of IPv6 CIDR blocks.")
    ("prefix_list_ids" "prefix_list_ids - (Optional) List of prefix list IDs (for allowing access to VPC endpoints). Only valid with egress.")
    ("from_port" "from_port - (Required) The start port (or ICMP type number if protocol is \"icmp\").")
    ("protocol" "protocol - (Required) The protocol. If not icmp, tcp, udp, or all use the protocol number")
    ("security_group_id" "security_group_id - (Required) The security group to apply this rule to.")
    ("source_security_group_id" "source_security_group_id - (Optional) The security group id to allow access to/from,  depending on the type. Cannot be specified with cidr_blocks.")
    ("self" "self - (Optional) If true, the security group itself will be added as  a source to this ingress rule.")
    ("to_port" "to_port - (Required) The end port (or ICMP code if protocol is \"icmp\").")
    ("description" "description - (Optional) Description of the rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_subnet" '(
    ("availability_zone" "availability_zone- (Optional) The AZ for the subnet.")
    ("cidr_block" "cidr_block - (Required) The CIDR block for the subnet.")
    ("ipv6_cidr_block" "ipv6_cidr_block - (Optional) The IPv6 network range for the subnet, in CIDR notation. The subnet size must use a /64 prefix length.")
    ("map_public_ip_on_launch" "map_public_ip_on_launch -  (Optional) Specify true to indicate that instances launched into the subnet should be assigned a public IP address. Default is false.")
    ("assign_ipv6_address_on_creation" "assign_ipv6_address_on_creation - (Optional) Specify true to indicate that network interfaces created in the specified subnet should be assigned an IPv6 address. Default is false")
    ("vpc_id" "vpc_id - (Required) The VPC ID.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc" '(
    ("cidr_block" "cidr_block - (Required) The CIDR block for the VPC.")
    ("instance_tenancy" "instance_tenancy - (Optional) A tenancy option for instances launched into the VPC")
    ("enable_dns_support" "enable_dns_support - (Optional) A boolean flag to enable/disable DNS support in the VPC. Defaults true.")
    ("enable_dns_hostnames" "enable_dns_hostnames - (Optional) A boolean flag to enable/disable DNS hostnames in the VPC. Defaults false.")
    ("enable_classiclink" "enable_classiclink - (Optional) A boolean flag to enable/disable ClassicLink for the VPC. Only valid in regions and accounts that support EC2 Classic. See the ClassicLink documentation for more information. Defaults false.")
    ("enable_classiclink_dns_support" "enable_classiclink_dns_support - (Optional) A boolean flag to enable/disable ClassicLink DNS Support for the VPC. Only valid in regions and accounts that support EC2 Classic.")
    ("assign_generated_ipv6_cidr_block" "assign_generated_ipv6_cidr_block - (Optional) Requests an Amazon-provided IPv6 CIDR  block with a /56 prefix length for the VPC. You cannot specify the range of IP addresses, or  the size of the CIDR block. Default is false.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_dhcp_options" '(
    ("domain_name" "domain_name - (Optional) the suffix domain name to use by default when resolving non Fully Qualified Domain Names. In other words, this is what ends up being the search value in the /etc/resolv.conf file.")
    ("domain_name_servers" "domain_name_servers - (Optional) List of name servers to configure in /etc/resolv.conf. If you want to use the default AWS nameservers you should set this to AmazonProvidedDNS.")
    ("ntp_servers" "ntp_servers - (Optional) List of NTP servers to configure.")
    ("netbios_name_servers" "netbios_name_servers - (Optional) List of NETBIOS name servers.")
    ("netbios_node_type" "netbios_node_type - (Optional) The NetBIOS node type (1, 2, 4, or 8). AWS recommends to specify 2 since broadcast and multicast are not supported in their network. For more information about these node types, see RFC 2132.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_dhcp_options_association" '(
    ("vpc_id" "vpc_id - (Required) The ID of the VPC to which we would like to associate a DHCP Options Set.")
    ("dhcp_options_id" "dhcp_options_id - (Required) The ID of the DHCP Options Set to associate to the VPC.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_endpoint" '(
    ("vpc_id" "vpc_id - (Required) The ID of the VPC in which the endpoint will be used.")
    ("vpc_endpoint_type" "vpc_endpoint_type - (Optional) The VPC endpoint type, Gateway or Interface. Defaults to Gateway.")
    ("service_name" "service_name - (Required) The service name, in the form com.amazonaws.region.service for AWS services.")
    ("auto_accept" "auto_accept - (Optional) Accept the VPC endpoint (the VPC endpoint and service need to be in the same AWS account).")
    ("policy" "policy - (Optional) A policy to attach to the endpoint that controls access to the service. Applicable for endpoints of type Gateway. Defaults to full access.")
    ("route_table_ids" "route_table_ids - (Optional) One or more route table IDs. Applicable for endpoints of type Gateway.")
    ("subnet_ids" "subnet_ids - (Optional) The ID of one or more subnets in which to create a network interface for the endpoint. Applicable for endpoints of type Interface.")
    ("security_group_ids" "security_group_ids - (Optional) The ID of one or more security groups to associate with the network interface. Required for endpoints of type Interface.")
    ("private_dns_enabled" "private_dns_enabled - (Optional) Whether or not to associate a private hosted zone with the specified VPC. Applicable for endpoints of type Interface. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_endpoint_connection_notification" '(
    ("vpc_endpoint_service_id" "vpc_endpoint_service_id - (Optional) The ID of the VPC Endpoint Service to receive notifications for.")
    ("vpc_endpoint_id" "vpc_endpoint_id - (Optional) The ID of the VPC Endpoint to receive notifications for.")
    ("connection_notification_arn" "connection_notification_arn - (Required) The ARN of the SNS topic for the notifications.")
    ("connection_events" "connection_events - (Required) One or more endpoint events for which to receive notifications.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_endpoint_route_table_association" '(
    ("vpc_endpoint_id" "vpc_endpoint_id - (Required) The ID of the VPC endpoint with which the routing table will be associated.")
    ("route_table_id" "route_table_id - (Required) The ID of the routing table to be associated with the VPC endpoint.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_endpoint_service" '(
    ("acceptance_required" "acceptance_required - (Required) Whether or not VPC endpoint connection requests to the service must be accepted by the service owner - true or false.")
    ("network_load_balancer_arns" "network_load_balancer_arns - (Required) The ARNs of one or more Network Load Balancers for the endpoint service.")
    ("allowed_principals" "allowed_principals - (Optional) The ARNs of one or more principals allowed to discover the endpoint service.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_endpoint_service_allowed_principal" '(
    ("vpc_endpoint_service_id" "vpc_endpoint_service_id - (Required) The ID of the VPC endpoint service to allow permission.")
    ("principal_arn" "principal_arn - (Required) The ARN of the principal to allow permissions.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_endpoint_subnet_association" '(
    ("vpc_endpoint_id" "vpc_endpoint_id - (Required) The ID of the VPC endpoint with which the subnet will be associated.")
    ("subnet_id" "subnet_id - (Required) The ID of the subnet to be associated with the VPC endpoint.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_peering_connection" '(
    ("peer_owner_id" "peer_owner_id - (Optional) The AWS account ID of the owner of the peer VPC. Defaults to the account ID the AWS provider is currently connected to.")
    ("peer_vpc_id" "peer_vpc_id - (Required) The ID of the VPC with which you are creating the VPC Peering Connection.")
    ("vpc_id" "vpc_id - (Required) The ID of the requester VPC.")
    ("auto_accept" "auto_accept - (Optional) Accept the peering (both VPCs need to be in the same AWS account).")
    ("peer_region" "peer_region - (Optional) The region of the accepter VPC of the [VPC Peering Connection]. auto_accept must be false, and use the aws_vpc_peering_connection_accepter to manage the accepter side.")
    ("accepter" "accepter (Optional) - An optional configuration block that allows for VPC Peering Connection options to be set for the VPC that accepts the peering connection (a maximum of one).")
    ("requester" "requester (Optional) - A optional configuration block that allows for VPC Peering Connection options to be set for the VPC that requests the peering connection (a maximum of one).")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_peering_connection_accepter" '(
    ("vpc_peering_connection_id" "vpc_peering_connection_id - (Required) The VPC Peering Connection ID to manage.")
    ("auto_accept" "auto_accept - (Optional) Whether or not to accept the peering request. Defaults to false.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpc_peering_connection_options" '(
    ("vpc_peering_connection_id" "vpc_peering_connection_id - (Required) The ID of the requester VPC.")
    ("accepter" "accepter (Optional) - An optional configuration block that allows for VPC Peering Connection options to be set for the VPC that accepts the peering connection (a maximum of one).")
    ("requester" "requester (Optional) - A optional configuration block that allows for VPC Peering Connection options to be set for the VPC that requests the peering connection (a maximum of one).")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpn_connection" '(
    ("customer_gateway_id" "customer_gateway_id - (Required) The ID of the customer gateway.")
    ("static_routes_only" "static_routes_only - (Optional, Default false) Whether the VPN connection uses static routes exclusively. Static routes must be used for devices that don't support BGP.")
    ("tags" "tags - (Optional) Tags to apply to the connection.")
    ("type" "type - (Required) The type of VPN connection. The only type AWS supports at this time is \"ipsec.1\".")
    ("vpn_gateway_id" "vpn_gateway_id - (Required) The ID of the virtual private gateway.")
    ("tunnel1_inside_cidr" "tunnel1_inside_cidr - (Optional) The CIDR block of the inside IP addresses for the first VPN tunnel.")
    ("tunnel2_inside_cidr" "tunnel2_inside_cidr - (Optional) The CIDR block of the second IP addresses for the first VPN tunnel.")
    ("tunnel1_preshared_key" "tunnel1_preshared_key - (Optional) The preshared key of the first VPN tunnel.")
    ("tunnel2_preshared_key" "tunnel2_preshared_key - (Optional) The preshared key of the second VPN tunnel.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpn_connection_route" '(
    ("destination_cidr_block" "destination_cidr_block - (Required) The CIDR block associated with the local subnet of the customer network.")
    ("vpn_connection_id" "vpn_connection_id - (Required) The ID of the VPN connection.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpn_gateway" '(
    ("vpc_id" "vpc_id - (Optional) The VPC ID to create in.")
    ("availability_zone" "availability_zone - (Optional) The Availability Zone for the virtual private gateway.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("amazon_side_asn" "amazon_side_asn - (Optional) The Autonomous System Number (ASN) for the Amazon side of the gateway. If you don't specify an ASN, the virtual private gateway is created with the default ASN.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpn_gateway_attachment" '(
    ("vpc_id" "vpc_id - (Required) The ID of the VPC.")
    ("vpn_gateway_id" "vpn_gateway_id - (Required) The ID of the Virtual Private Gateway.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_vpn_gateway_route_propagation" '(
    ("vpn_gateway_id" "vpn_gateway_id - The id of the aws_vpn_gateway to propagate routes from.")
    ("route_table_id" "route_table_id - The id of the aws_route_table to propagate routes into.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_resource_group" '(
    ("name" "name - (Required) The name of the resource group. Must be unique on your Azure subscription.")
    ("location" "location - (Required) The location where the resource group should be created. For a list of all Azure locations, please consult this link or run az account list-locations --output table.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_app_service" '(
    ("name" "name - (Required) Specifies the name of the App Service. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the App Service.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("app_service_plan_id" "app_service_plan_id - (Required) The ID of the App Service Plan within which to create this App Service. Changing this forces a new resource to be created.")
    ("app_settings" "app_settings - (Optional) A key-value pair of App Settings.")
    ("connection_string" "connection_string - (Optional) An connection_string block as defined below.")
    ("client_affinity_enabled" "client_affinity_enabled - (Optional) Should the App Service send session affinity cookies, which route client requests in the same session to the same instance?")
    ("enabled" "enabled - (Optional) Is the App Service Enabled? Changing this forces a new resource to be created.")
    ("https_only" "https_only - (Optional) Can the App Service only be accessed via HTTPS? Defaults to false.")
    ("site_config" "site_config - (Optional) A site_config object as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("identity" "identity - (Optional) A Managed Service Identity block as defined below.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_app_service_plan" '(
    ("name" "name - (Required) Specifies the name of the App Service Plan component. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the App Service Plan component.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("kind" "kind - (Optional) The kind of the App Service Plan to create. Possible values are Windows (also available as App), Linux and FunctionApp (for a Consumption Plan). Defaults to Windows. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_app_service_active_slot" '(
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the App Service exists. Changing this forces a new resource to be created.")
    ("app_service_name" "app_service_name - (Required) The name of the App Service within which the Slot exists.  Changing this forces a new resource to be created.")
    ("app_service_slot_name" "app_service_slot_name - (Required) The name of the App Service Slot which should be promoted to the Production Slot within the App Service.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_app_service_custom_hostname_binding" '(
    ("hostname" "hostname - (Required) Specifies the Custom Hostname to use for the App Service, example www.example.com. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_app_service_slot" '(
    ("name" "name - (Required) Specifies the name of the App Service Slot component. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the App Service Slot component.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("app_service_plan_id" "app_service_plan_id - (Required) The ID of the App Service Plan within which to create this App Service Slot. Changing this forces a new resource to be created.")
    ("app_service_name" "app_service_name - (Required) The name of the App Service within which to create the App Service Slot.  Changing this forces a new resource to be created.")
    ("app_settings" "app_settings - (Optional) A key-value pair of App Settings.")
    ("connection_string" "connection_string - (Optional) An connection_string block as defined below.")
    ("client_affinity_enabled" "client_affinity_enabled - (Optional) Should the App Service Slot send session affinity cookies, which route client requests in the same session to the same instance? Changing this forces a new resource to be created.")
    ("enabled" "enabled - (Optional) Is the App Service Slot Enabled? Changing this forces a new resource to be created.")
    ("https_only" "https_only - (Optional) Can the App Service Slot only be accessed via HTTPS? Defaults to false. Changing this forces a new resource to be created.")
    ("site_config" "site_config - (Optional) A site_config object as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_function_app" '(
    ("name" "name - (Required) Specifies the name of the Function App. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Function App.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("app_service_plan_id" "app_service_plan_id - (Required) The ID of the App Service Plan within which to create this Function App. Changing this forces a new resource to be created.")
    ("storage_connection_string" "storage_connection_string - (Required) The connection string of the backend storage account which will be used by this Function App (such as the dashboard, logs).")
    ("app_settings" "app_settings - (Optional) A key-value pair of App Settings.")
    ("connection_string" "connection_string - (Optional) An connection_string block as defined below.")
    ("client_affinity_enabled" "client_affinity_enabled - (Optional) Should the Function App send session affinity cookies, which route client requests in the same session to the same instance?")
    ("enabled" "enabled - (Optional) Is the Function App enabled?")
    ("https_only" "https_only - (Optional) Can the Function App only be accessed via HTTPS? Defaults to false.")
    ("version" "version - (Optional) The runtime version associated with the Function App. Possible values are ~1 and beta. Defaults to ~1.")
    ("site_config" "site_config - (Optional) A site_config object as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_role_assignment" '(
    ("name" "name - (Optional) A unique UUID/GUID for this Role Assignment - one will be generated if not specified. Changing this forces a new resource to be created.")
    ("scope" "scope - (Required) The scope at which the Role Assignment applies too, such as /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333, /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup, or /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup/providers/Microsoft.Compute/virtualMachines/myVM. Changing this forces a new resource to be created.")
    ("role_definition_id" "role_definition_id - (Optional) The Scoped-ID of the Role Definition. Changing this forces a new resource to be created. Conflicts with role_definition_name.")
    ("role_definition_name" "role_definition_name - (Optional) The name of a built-in Role. Changing this forces a new resource to be created. Conflicts with role_definition_id.")
    ("principal_id" "principal_id - (Required) The ID of the Principal (User or Application) to assign the Role Definition to. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_role_definition" '(
    ("role_definition_id" "role_definition_id - (Required) A unique UUID/GUID which identifies this role. Changing this forces a new resource to be created.")
    ("name" "name - (Required) The name of the Role Definition. Changing this forces a new resource to be created.")
    ("scope" "scope - (Required) The scope at which the Role Definition applies too, such as /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333, /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup, or /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup/providers/Microsoft.Compute/virtualMachines/myVM. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) A description of the Role Definition.")
    ("permissions" "permissions - (Required) A permissions block as defined below.")
    ("assignable_scopes" "assignable_scopes - (Required) One or more assignable scopes for this Role Definition, such as /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333, /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup, or /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup/providers/Microsoft.Compute/virtualMachines/myVM.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_automation_account" '(
    ("name" "name - (Required) Specifies the name of the Automation Account. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Automation Account is created. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) A sku block as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_automation_credential" '(
    ("name" "name - (Required) Specifies the name of the Credential. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Credential is created. Changing this forces a new resource to be created.")
    ("account_name" "account_name - (Required) The name of the automation account in which the Credential is created. Changing this forces a new resource to be created.")
    ("username" "username - (Required) The username associated with this Automation Credential.")
    ("password" "password - (Required) The password associated with this Automation Credential.")
    ("description" "description -  (Optional) The description associated with this Automation Credential.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_automation_runbook" '(
    ("name" "name - (Required) Specifies the name of the Runbook. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Runbook is created. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("account_name" "account_name - (Required) The name of the automation account in which the Runbook is created. Changing this forces a new resource to be created.")
    ("runbook_type" "runbook_type - (Required) The type of the runbook - can be either Graph, GraphPowerShell, GraphPowerShellWorkflow, PowerShellWorkflow, PowerShell or Script.")
    ("log_progress" "log_progress - (Required) Progress log option.")
    ("log_verbose" "log_verbose -  (Required) Verbose log option.")
    ("publish_content_link" "publish_content_link - (Required) The published runbook content link.")
    ("description" "description -  (Optional) A description for this credential.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_automation_schedule" '(
    ("name" "name - (Required) Specifies the name of the Schedule. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Schedule is created. Changing this forces a new resource to be created.")
    ("account_name" "account_name - (Required) The name of the automation account in which the Schedule is created. Changing this forces a new resource to be created.")
    ("description" "description -  (Optional) A description for this Schedule.")
    ("start_time" "start_time -  (Required) Start time of the schedule. Must be at least five minutes in the future.")
    ("expiry_time" "expiry_time -  (Optional) The end time of the schedule.")
    ("frequency" "frequency - (Required) The frequency of the schedule. - can be either OneTime, Day, Hour, Week, or Month.")
    ("timezone" "timezone - (Optional) The timezone of the start time. For possible values see: https://msdn.microsoft.com/en-us/library/ms912391(v=winembedded.11).aspx")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_application_insights" '(
    ("name" "name - (Required) Specifies the name of the Application Insights component. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Application Insights component.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("application_type" "application_type - (Required) Specifies the type of Application Insights to create. Valid values are Web and Other.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_cdn_profile" '(
    ("name" "name - (Required) Specifies the name of the CDN Profile. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the CDN Profile.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) The pricing related information of current CDN profile. Accepted values are Standard_Verizon, Standard_Akamai or Premium_Verizon.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_cdn_endpoint" '(
    ("name" "name - (Required) Specifies the name of the CDN Endpoint. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the CDN Endpoint.")
    ("profile_name" "profile_name - (Required) The CDN Profile to which to attach the CDN Endpoint.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("is_http_allowed" "is_http_allowed - (Optional) Defaults to true.")
    ("is_https_allowed" "is_https_allowed - (Optional) Defaults to true.")
    ("content_types_to_compress" "content_types_to_compress - (Optional) An array of strings that indicates a content types on which compression will be applied. The value for the elements should be MIME types.")
    ("geo_filter" "geo_filter - (Optional) A set of Geo Filters for this CDN Endpoint. Each geo_filter block supports fields documented below.")
    ("is_compression_enabled" "is_compression_enabled - (Optional) Indicates whether compression is to be enabled. Defaults to false.")
    ("querystring_caching_behaviour" "querystring_caching_behaviour - (Optional) Sets query string caching behavior. Allowed values are IgnoreQueryString, BypassCaching and UseQueryString. Defaults to IgnoreQueryString.")
    ("optimization_type" "optimization_type - (Optional) What types of optimization should this CDN Endpoint optimize for? Possible values include DynamicSiteAcceleration, GeneralMediaStreaming, GeneralWebDelivery, LargeFileDownload and VideoOnDemandMediaStreaming.")
    ("origin" "origin - (Optional) The set of origins of the CDN endpoint. When multiple origins exist, the first origin will be used as primary and rest will be used as failover options. Each origin block supports fields documented below.")
    ("origin_host_header" "origin_host_header - (Optional) The host header CDN provider will send along with content requests to origins. Defaults to the host name of the origin.")
    ("origin_path" "origin_path - (Optional) The path used at for origin requests.")
    ("probe_path" "probe_path - (Optional) the path to a file hosted on the origin which helps accelerate delivery of the dynamic content and calculate the most optimal routes for the CDN. This is relative to the origin_path.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_availability_set" '(
    ("name" "name - (Required) Specifies the name of the availability set. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the availability set. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("platform_update_domain_count" "platform_update_domain_count - (Optional) Specifies the number of update domains that are used. Defaults to 5.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_managed_disk" '(
    ("name" "name - (Required) Specifies the name of the managed disk. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the managed disk.")
    ("location" "location - (Required) Specified the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("storage_account_type" "storage_account_type - (Required) The type of storage to use for the managed disk. Allowable values are Standard_LRS or Premium_LRS.")
    ("create_option" "create_option - (Required) The method to use when creating the managed disk. Possible values include:  Import - Import a VHD file in to the managed disk (VHD specified with source_uri).  Empty - Create an empty managed disk.  Copy - Copy an existing managed disk or snapshot (specified with source_resource_id).  FromImage - Copy a Platform Image (specified with image_reference_id)")
    ("source_uri" "source_uri - (Optional) URI to a valid VHD file to be used when create_option is Import.")
    ("source_resource_id" "source_resource_id - (Optional) ID of an existing managed disk to copy when create_option is Copy.")
    ("image_reference_id" "image_reference_id - (Optional) ID of an existing platform/marketplace disk image to copy when create_option is FromImage.")
    ("os_type" "os_type - (Optional) Specify a value when the source of an Import or Copy operation targets a source that contains an operating system. Valid values are Linux or Windows")
    ("disk_size_gb" "disk_size_gb - (Optional, Required for a new managed disk) Specifies the size of the managed disk to create in gigabytes. If create_option is Copy or FromImage, then the value must be equal to or greater than the source's size.")
    ("encryption_settings" "encryption_settings - (Optional) an encryption_settings block as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("zones" "zones - (Optional) A collection containing the availability zone to allocate the Managed Disk in.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_snapshot" '(
    ("name" "name - (Required) Specifies the name of the Snapshot resource. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Snapshot. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("create_option" "create_option - (Required) Indicates how the snapshot is to be created. Possible values are Copy or Import. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_image" '(
    ("name" "name - (Required) Specifies the name of the image. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the image. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specified the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("source_virtual_machine_id" "source_virtual_machine_id - (Optional) The Virtual Machine ID from which to create the image.")
    ("os_disk" "os_disk - (Optional) One or more os_disk elements as defined below.")
    ("data_disk" "data_disk - (Optional) One or more data_disk elements as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_machine" '(
    ("name" "name - (Required) Specifies the name of the virtual machine resource. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the virtual machine.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("plan" "plan - (Optional) A plan block as documented below.")
    ("availability_set_id" "availability_set_id - (Optional) The Id of the Availability Set in which to create the virtual machine")
    ("boot_diagnostics" "boot_diagnostics - (Optional) A boot diagnostics profile block as referenced below.")
    ("vm_size" "vm_size - (Required) Specifies the size of the virtual machine.")
    ("storage_image_reference" "storage_image_reference - (Optional) A Storage Image Reference block as documented below.")
    ("storage_os_disk" "storage_os_disk - (Required) A Storage OS Disk block as referenced below.")
    ("delete_os_disk_on_termination" "delete_os_disk_on_termination - (Optional) Flag to enable deletion of the OS disk VHD blob or managed disk when the VM is deleted, defaults to false")
    ("storage_data_disk" "storage_data_disk - (Optional) A list of Storage Data disk blocks as referenced below.")
    ("delete_data_disks_on_termination" "delete_data_disks_on_termination - (Optional) Flag to enable deletion of storage data disk VHD blobs or managed disks when the VM is deleted, defaults to false")
    ("os_profile" "os_profile - (Optional) An OS Profile block as documented below. Required when create_option in the storage_os_disk block is set to FromImage.")
    ("identity" "identity - (Optional) An identity block as documented below.")
    ("license_type" "license_type - (Optional, when a Windows machine) Specifies the Windows OS license type. If supplied, the only allowed values are Windows_Client and Windows_Server.")
    ("os_profile_windows_config" "os_profile_windows_config - (Required, when a Windows machine) A Windows config block as documented below.")
    ("os_profile_linux_config" "os_profile_linux_config - (Required, when a Linux machine) A Linux config block as documented below.")
    ("os_profile_secrets" "os_profile_secrets - (Optional) A collection of Secret blocks as documented below.")
    ("network_interface_ids" "network_interface_ids - (Required) Specifies the list of resource IDs for the network interfaces associated with the virtual machine.")
    ("primary_network_interface_id" "primary_network_interface_id - (Optional) Specifies the resource ID for the primary network interface associated with the virtual machine.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("zones" "zones - (Optional) A collection containing the availability zone to allocate the Virtual Machine in.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_machine_extension" '(
    ("name" "name - (Required) The name of the virtual machine extension peering. Changing this forces a new resource to be created.")
    ("location" "location - (Required) The location where the extension is created. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the virtual network. Changing this forces a new resource to be created.")
    ("virtual_machine_name" "virtual_machine_name - (Required) The name of the virtual machine. Changing this forces a new resource to be created.")
    ("publisher" "publisher - (Required) The publisher of the extension, available publishers can be found by using the Azure CLI.")
    ("type" "type - (Required) The type of extension, available types for a publisher can be found using the Azure CLI.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_machine_scale_set" '(
    ("name" "name - (Required) Specifies the name of the virtual machine scale set resource. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the virtual machine scale set. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) A sku block as documented below.")
    ("upgrade_policy_mode" "upgrade_policy_mode - (Required) Specifies the mode of an upgrade to virtual machines in the scale set. Possible values, Manual or Automatic.")
    ("overprovision" "overprovision - (Optional) Specifies whether the virtual machine scale set should be overprovisioned.")
    ("single_placement_group" "single_placement_group - (Optional) Specifies whether the scale set is limited to a single placement group with a maximum size of 100 virtual machines. If set to false, managed disks must be used. Default is true. Changing this forces a new resource to be created. See documentation for more information.")
    ("os_profile" "os_profile - (Required) A Virtual Machine OS Profile block as documented below.")
    ("os_profile_secrets" "os_profile_secrets - (Optional) A collection of Secret blocks as documented below.")
    ("os_profile_windows_config" "os_profile_windows_config - (Required, when a windows machine) A Windows config block as documented below.")
    ("os_profile_linux_config" "os_profile_linux_config - (Required, when a linux machine) A Linux config block as documented below.")
    ("network_profile" "network_profile - (Required) A collection of network profile block as documented below.")
    ("storage_profile_os_disk" "storage_profile_os_disk - (Required) A storage profile os disk block as documented below")
    ("storage_profile_data_disk" "storage_profile_data_disk - (Optional) A storage profile data disk block as documented below")
    ("storage_profile_image_reference" "storage_profile_image_reference - (Optional) A storage profile image reference block as documented below.")
    ("extension" "extension - (Optional) Can be specified multiple times to add extension profiles to the scale set. Each extension block supports the fields documented below.")
    ("boot_diagnostics" "boot_diagnostics - (Optional) A boot diagnostics profile block as referenced below.")
    ("plan" "plan - (Optional) A plan block as documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("zones" "zones - (Optional) A collection of availability zones to spread the Virtual Machines over.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_container_group" '(
    ("name" "name - (Required) Specifies the name of the Container Group. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Container Group. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("ip_address_type" "ip_address_type - (Optional) Specifies the ip address type of the container. Public is the only acceptable value at this time. Changing this forces a new resource to be created.")
    ("dns_name_label" "dns_name_label - (Optional) The DNS label/name for the container groups IP.")
    ("os_type" "os_type - (Required) The OS for the container group. Allowed values are Linux and Windows. Changing this forces a new resource to be created.")
    ("restart_policy" "restart_policy - (Optional) Restart policy for the container group. Allowed values are Always, Never, OnFailure. Defaults to Always.")
    ("container" "container - (Required) The definition of a container that is part of the group as documented in the container block below. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_container_registry" '(
    ("name" "name - (Required) Specifies the name of the Container Registry. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Container Registry.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("admin_enabled" "admin_enabled - (Optional) Specifies whether the admin user is enabled. Defaults to false.")
    ("storage_account_id" "storage_account_id - (Required for Classic Sku - Optional otherwise) The ID of a Storage Account which must be located in the same Azure Region as the Container Registry.")
    ("sku" "sku - (Optional) The SKU name of the the container registry. Possible values are Classic (which was previously Basic), Basic, Standard and Premium.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_container_service" '(
    ("name" "name - (Required) The name of the Container Service instance to create. Changing this forces a new resource to be created.")
    ("location" "location - (Required) The location where the Container Service instance should be created. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("orchestration_platform" "orchestration_platform - (Required) Specifies the Container Orchestration Platform to use. Currently can be either DCOS, Kubernetes or Swarm. Changing this forces a new resource to be created.")
    ("master_profile" "master_profile - (Required) A Master Profile block as documented below.")
    ("linux_profile" "linux_profile - (Required) A Linux Profile block as documented below.")
    ("agent_pool_profile" "agent_pool_profile - (Required) One or more Agent Pool Profile's block as documented below.")
    ("service_principal" "service_principal - (only Required when you're using Kubernetes as an Orchestration Platform) A Service Principal block as documented below.")
    ("diagnostics_profile" "diagnostics_profile - (Required) A VM Diagnostics Profile block as documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_kubernetes_cluster" '(
    ("name" "name - (Required) The name of the AKS Managed Cluster instance to create. Changing this forces a new resource to be created.")
    ("location" "location - (Required) The location where the AKS Managed Cluster instance should be created. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("dns_prefix" "dns_prefix - (Optional) DNS prefix specified when creating the managed cluster.")
    ("kubernetes_version" "kubernetes_version - (Optional) Version of Kubernetes specified when creating the AKS managed cluster. If not specified, the latest recommended version will be used at provisioning time (but won't auto-upgrade).")
    ("linux_profile" "linux_profile - (Required) A Linux Profile block as documented below.")
    ("agent_pool_profile" "agent_pool_profile - (Required) One or more Agent Pool Profile's block as documented below.")
    ("service_principal" "service_principal - (Required) A Service Principal block as documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_cosmosdb_account" '(
    ("name" "name - (Required) Specifies the name of the CosmosDB Account. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the CosmosDB Account is created. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("offer_type" "offer_type - (Required) Specifies the Offer Type to use for this CosmosDB Account - currently this can only be set to Standard.")
    ("kind" "kind - (Optional) Specifies the Kind of CosmosDB to create - possible values are GlobalDocumentDB and MongoDB. Defaults to GlobalDocumentDB. Changing this forces a new resource to be created.")
    ("consistency_policy" "consistency_policy - (Required) Specifies a consistency_policy resource, used to define the consistency policy for this CosmosDB account.")
    ("geo_location" "geo_location - (Required) Specifies a geo_location resource, used to define where data should be replicated with the failover_priority 0 specifying the primary location.")
    ("ip_range_filter" "ip_range_filter - (Optional) CosmosDB Firewall Support: This value specifies the set of IP addresses or IP address ranges in CIDR form to be included as the allowed list of client IP's for a given database account. IP addresses/ranges must be comma separated and must not contain any spaces.")
    ("enable_automatic_failover" "enable_automatic_failover - (Optional) Enable automatic fail over for this Cosmos DB account.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_mysql_configuration" '(
    ("name" "name - (Required) Specifies the name of the MySQL Configuration, which needs to be a valid MySQL configuration name. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) Specifies the name of the MySQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the MySQL Server exists. Changing this forces a new resource to be created.")
    ("value" "value - (Required) Specifies the value of the MySQL Configuration. See the MySQL documentation for valid values.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_mysql_database" '(
    ("name" "name - (Required) Specifies the name of the MySQL Database, which needs to be a valid MySQL identifier. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) Specifies the name of the MySQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the MySQL Server exists. Changing this forces a new resource to be created.")
    ("charset" "charset - (Required) Specifies the Charset for the MySQL Database, which needs to be a valid MySQL Charset. Changing this forces a new resource to be created.")
    ("collation" "collation - (Required) Specifies the Collation for the MySQL Database, which needs to be a valid MySQL Collation. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_mysql_firewall_rule" '(
    ("name" "name - (Required) Specifies the name of the MySQL Firewall Rule. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) Specifies the name of the MySQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the MySQL Server exists. Changing this forces a new resource to be created.")
    ("start_ip_address" "start_ip_address - (Required) Specifies the Start IP Address associated with this Firewall Rule. Changing this forces a new resource to be created.")
    ("end_ip_address" "end_ip_address - (Required) Specifies the End IP Address associated with this Firewall Rule. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_mysql_server" '(
    ("name" "name - (Required) Specifies the name of the MySQL Server. Changing this forces a new resource to be created. This needs to be globally unique within Azure.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the MySQL Server.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) A sku block as defined below.")
    ("administrator_login" "administrator_login - (Required) The Administrator Login for the MySQL Server. Changing this forces a new resource to be created.")
    ("administrator_login_password" "administrator_login_password - (Required) The Password associated with the administrator_login for the MySQL Server.")
    ("version" "version - (Required) Specifies the version of MySQL to use. Valid values are 5.6 and 5.7. Changing this forces a new resource to be created.")
    ("storage_mb" "storage_mb - (Required) Specifies the amount of storage for the MySQL Server in Megabytes. Possible values are shown below. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_postgresql_configuration" '(
    ("name" "name - (Required) Specifies the name of the PostgreSQL Configuration, which needs to be a valid PostgreSQL configuration name. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) Specifies the name of the PostgreSQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the PostgreSQL Server exists. Changing this forces a new resource to be created.")
    ("value" "value - (Required) Specifies the value of the PostgreSQL Configuration. See the PostgreSQL documentation for valid values.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_postgresql_database" '(
    ("name" "name - (Required) Specifies the name of the PostgreSQL Database, which needs to be a valid PostgreSQL identifier. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) Specifies the name of the PostgreSQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the PostgreSQL Server exists. Changing this forces a new resource to be created.")
    ("charset" "charset - (Required) Specifies the Charset for the PostgreSQL Database, which needs to be a valid PostgreSQL Charset. Changing this forces a new resource to be created.")
    ("collation" "collation - (Required) Specifies the Collation for the PostgreSQL Database, which needs to be a valid PostgreSQL Collation. Note that Microsoft uses different notation - en-US instead of en_US. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_postgresql_firewall_rule" '(
    ("name" "name - (Required) Specifies the name of the PostgreSQL Firewall Rule. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) Specifies the name of the PostgreSQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the PostgreSQL Server exists. Changing this forces a new resource to be created.")
    ("start_ip_address" "start_ip_address - (Required) Specifies the Charset for the PostgreSQL Database. Changing this forces a new resource to be created.")
    ("end_ip_address" "end_ip_address - (Required) Specifies the End IP Address associated with this Firewall Rule. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_postgresql_server" '(
    ("name" "name - (Required) Specifies the name of the PostgreSQL Server. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the PostgreSQL Server.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) A sku block as defined below.")
    ("administrator_login" "administrator_login - (Required) The Administrator Login for the PostgreSQL Server. Changing this forces a new resource to be created.")
    ("administrator_login_password" "administrator_login_password - (Required) The Password associated with the administrator_login for the PostgreSQL Server.")
    ("version" "version - (Required) Specifies the version of PostgreSQL to use. Valid values are 9.5 and 9.6. Changing this forces a new resource to be created.")
    ("storage_mb" "storage_mb - (Required) Specifies the amount of storage for the PostgreSQL Server in Megabytes. Possible values are shown below. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_sql_database" '(
    ("name" "name - (Required) The name of the database.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the database.  This must be the same as Database Server resource group currently.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) The name of the SQL Server on which to create the database.")
    ("create_mode" "create_mode - (Optional) Specifies the type of database to create. Defaults to Default. See below for the accepted values/")
    ("source_database_id" "source_database_id - (Optional) The URI of the source database if create_mode value is not Default.")
    ("restore_point_in_time" "restore_point_in_time - (Optional) The point in time for the restore. Only applies if create_mode is PointInTimeRestore e.g. 2013-11-08T22:00:40Z")
    ("edition" "edition - (Optional) The edition of the database to be created. Applies only if create_mode is Default. Valid values are: Basic, Standard, Premium, or DataWarehouse. Please see Azure SQL Database Service Tiers.")
    ("collation" "collation - (Optional) The name of the collation. Applies only if create_mode is Default.  Azure default is SQL_LATIN1_GENERAL_CP1_CI_AS. Changing this forces a new resource to be created.")
    ("max_size_bytes" "max_size_bytes - (Optional) The maximum size that the database can grow to. Applies only if create_mode is Default.  Please see Azure SQL Database Service Tiers.")
    ("requested_service_objective_id" "requested_service_objective_id - (Optional) Use requested_service_objective_id or requested_service_objective_name to set the performance level for the database. Valid values are: S0, S1, S2, S3, P1, P2, P4, P6, P11 and ElasticPool.  Please see Azure SQL Database Service Tiers.")
    ("requested_service_objective_name" "requested_service_objective_name - (Optional) Use requested_service_objective_name or requested_service_objective_id to set the performance level for the database.  Please see Azure SQL Database Service Tiers.")
    ("source_database_deletion_date" "source_database_deletion_date - (Optional) The deletion date time of the source database. Only applies to deleted databases where create_mode is PointInTimeRestore.")
    ("elastic_pool_name" "elastic_pool_name - (Optional) The name of the elastic database pool.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_sql_active_directory_administrator" '(
    ("server_name" "server_name - (Required) The name of the SQL Server on which to set the administrator. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group for the SQL server. Changing this forces a new resource to be created.")
    ("login" "login - (Required) The login name of the principal to set as the server administrator")
    ("object_id" "object_id - (Required) The ID of the principal to set as the server administrator")
    ("tenant_id" "tenant_id - (Required) The Azure Tenant ID")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_sql_elasticpool" '(
    ("name" "name - (Required) The name of the elastic pool. This needs to be globally unique. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the elastic pool. This must be the same as the resource group of the underlying SQL server.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("server_name" "server_name - (Required) The name of the SQL Server on which to create the elastic pool. Changing this forces a new resource to be created.")
    ("edition" "edition - (Required) The edition of the elastic pool to be created. Valid values are Basic, Standard, and Premium. Refer to Azure SQL Database Service Tiers for details. Changing this forces a new resource to be created.")
    ("dtu" "dtu - (Required) The total shared DTU for the elastic pool. Valid values depend on the edition which has been defined. Refer to Azure SQL Database Service Tiers for valid combinations.")
    ("db_dtu_min" "db_dtu_min - (Optional) The minimum DTU which will be guaranteed to all databases in the elastic pool to be created.")
    ("db_dtu_max" "db_dtu_max - (Optional) The maximum DTU which will be guaranteed to all databases in the elastic pool to be created.")
    ("pool_size" "pool_size - (Optional) The maximum size in MB that all databases in the elastic pool can grow to. The maximum size must be consistent with combination of edition and dtu and the limits documented in Azure SQL Database Service Tiers. If not defined when creating an elastic pool, the value is set to the size implied by edition and dtu.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_sql_firewall_rule" '(
    ("name" "name - (Required) The name of the SQL Server.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the sql server.")
    ("server_name" "server_name - (Required) The name of the SQL Server on which to create the Firewall Rule.")
    ("start_ip_address" "start_ip_address - (Required) The starting IP address to allow through the firewall for this rule.")
    ("end_ip_address" "end_ip_address - (Required) The ending IP address to allow through the firewall for this rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_sql_server" '(
    ("name" "name - (Required) The name of the SQL Server. This needs to be globally unique within Azure.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the SQL Server.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("version" "version - (Required) The version for the new server. Valid values are: 2.0 (for v11 server) and 12.0 (for v12 server).")
    ("administrator_login" "administrator_login - (Required) The administrator login name for the new server. Changing this forces a new resource to be created.")
    ("administrator_login_password" "administrator_login_password - (Required) The password associated with the administrator_login user. Needs to comply with Azure's Password Policy")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_sql_virtual_network_rule" '(
    ("name" "name - (Required) The name of the SQL virtual network rule. Changing this forces a new resource to be created. Cannot be empty and must only contain alphanumeric characters and hyphens. Cannot start with a number, and cannot start or end with a hyphen.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_a_record" '(
    ("name" "name - (Required) The name of the DNS A Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("TTL" "TTL - (Required) The Time To Live (TTL) of the DNS record.")
    ("records" "records - (Required) List of IPv4 Addresses.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_aaaa_record" '(
    ("name" "name - (Required) The name of the DNS AAAA Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("TTL" "TTL - (Required) The Time To Live (TTL) of the DNS record.")
    ("records" "records - (Required) List of IPv6 Addresses.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_cname_record" '(
    ("name" "name - (Required) The name of the DNS CNAME Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("TTL" "TTL - (Required) The Time To Live (TTL) of the DNS record.")
    ("record" "record - (Required) The target of the CNAME.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_mx_record" '(
    ("name" "name - (Required) The name of the DNS MX Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("ttl" "ttl - (Required) The Time To Live (TTL) of the DNS record.")
    ("record" "record - (Required) A list of values that make up the SRV record. Each record block supports fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_ns_record" '(
    ("name" "name - (Required) The name of the DNS NS Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("ttl" "ttl - (Required) The Time To Live (TTL) of the DNS record.")
    ("record" "record - (Required) A list of values that make up the NS record. Each record block supports fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_ptr_record" '(
    ("name" "name - (Required) The name of the DNS PTR Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("ttl" "ttl - (Required) The Time To Live (TTL) of the DNS record.")
    ("records" "records - (Required) List of Fully Qualified Domain Names.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_srv_record" '(
    ("name" "name - (Required) The name of the DNS SRV Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("ttl" "ttl - (Required) The Time To Live (TTL) of the DNS record.")
    ("record" "record - (Required) A list of values that make up the SRV record. Each record block supports fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_txt_record" '(
    ("name" "name - (Required) The name of the DNS TXT Record.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("zone_name" "zone_name - (Required) Specifies the DNS Zone where the resource exists. Changing this forces a new resource to be created.")
    ("ttl" "ttl - (Required) The Time To Live (TTL) of the DNS record.")
    ("record" "record - (Required) A list of values that make up the txt record. Each record block supports fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_dns_zone" '(
    ("name" "name - (Required) The name of the DNS Zone. Must be a valid domain name.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the resource group where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_key_vault" '(
    ("name" "name - (Required) Specifies the name of the Key Vault. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Key Vault. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) An SKU block as described below.")
    ("tenant_id" "tenant_id - (Required) The Azure Active Directory tenant ID that should be used for authenticating requests to the key vault.")
    ("access_policy" "access_policy - (Required) An access policy block as described below. At least one policy is required up to a maximum of 16.")
    ("enabled_for_deployment" "enabled_for_deployment - (Optional) Boolean flag to specify whether Azure Virtual Machines are permitted to retrieve certificates stored as secrets from the key vault. Defaults to false.")
    ("enabled_for_disk_encryption" "enabled_for_disk_encryption - (Optional) Boolean flag to specify whether Azure Disk Encryption is permitted to retrieve secrets from the vault and unwrap keys. Defaults to false.")
    ("enabled_for_template_deployment" "enabled_for_template_deployment - (Optional) Boolean flag to specify whether Azure Resource Manager is permitted to retrieve secrets from the key vault. Defaults to false.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_key_vault_certificate" '(
    ("name" "name - (Required) Specifies the name of the Key Vault Certificate. Changing this forces a new resource to be created.")
    ("vault_uri" "vault_uri - (Required) Specifies the URI used to access the Key Vault instance, available on the azurerm_key_vault resource.")
    ("certificate" "certificate - (Optional) A certificate block as defined below, used to Import an existing certificate.")
    ("certificate_policy" "certificate_policy - (Required) A certificate_policy block as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_key_vault_key" '(
    ("name" "name - (Required) Specifies the name of the Key Vault Key. Changing this forces a new resource to be created.")
    ("vault_uri" "vault_uri - (Required) Specifies the URI used to access the Key Vault instance, available on the azurerm_key_vault resource.")
    ("key_type" "key_type - (Required) Specifies the Key Type to use for this Key Vault Key. Possible values are EC (Elliptic Curve), Oct (Octet), RSA and RSA-HSM. Changing this forces a new resource to be created.")
    ("key_size" "key_size - (Required) Specifies the Size of the Key to create in bytes. For example, 1024 or 2048. Changing this forces a new resource to be created.")
    ("key_opts" "key_opts - (Required) A list of JSON web key operations. Possible values include: decrypt, encrypt, sign, unwrapKey, verify and wrapKey. Please note these values are case sensitive.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_key_vault_secret" '(
    ("name" "name - (Required) Specifies the name of the Key Vault Secret. Changing this forces a new resource to be created.")
    ("value" "value - (Required) Specifies the value of the Key Vault Secret.")
    ("vault_uri" "vault_uri - (Required) Specifies the URI used to access the Key Vault instance, available on the azurerm_key_vault resource.")
    ("content_type" "content_type - (Optional) Specifies the content type for the Key Vault Secret.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_lb" '(
    ("name" "name - (Required) Specifies the name of the LoadBalancer.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the LoadBalancer.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists.")
    ("frontend_ip_configuration" "frontend_ip_configuration - (Optional) A frontend ip configuration block as documented below.")
    ("sku" "sku - (Optional) The SKU of the Azure Load Balancer. Accepted values are Basic and Standard. Defaults to Basic.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_lb_backend_address_pool" '(
    ("name" "name - (Required) Specifies the name of the Backend Address Pool.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the resource.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The ID of the LoadBalancer in which to create the Backend Address Pool.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_lb_rule" '(
    ("name" "name - (Required) Specifies the name of the LB Rule.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the resource.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The ID of the LoadBalancer in which to create the Rule.")
    ("frontend_ip_configuration_name" "frontend_ip_configuration_name - (Required) The name of the frontend IP configuration to which the rule is associated.")
    ("protocol" "protocol - (Required) The transport protocol for the external endpoint. Possible values are Udp or Tcp.")
    ("frontend_port" "frontend_port - (Required) The port for the external endpoint. Port numbers for each Rule must be unique within the Load Balancer. Possible values range between 1 and 65534, inclusive.")
    ("backend_port" "backend_port - (Required) The port used for internal connections on the endpoint. Possible values range between 1 and 65535, inclusive.")
    ("backend_address_pool_id" "backend_address_pool_id - (Optional) A reference to a Backend Address Pool over which this Load Balancing Rule operates.")
    ("probe_id" "probe_id - (Optional) A reference to a Probe used by this Load Balancing Rule.")
    ("enable_floating_ip" "enable_floating_ip - (Optional) Floating IP is pertinent to failover scenarios: a \"floating” IP is reassigned to a secondary server in case the primary server fails. Floating IP is required for SQL AlwaysOn.")
    ("idle_timeout_in_minutes" "idle_timeout_in_minutes - (Optional) Specifies the timeout for the Tcp idle connection. The value can be set between 4 and 30 minutes. The default value is 4 minutes. This element is only used when the protocol is set to Tcp.")
    ("load_distribution" "load_distribution - (Optional) Specifies the load balancing distribution type to be used by the Load Balancer. Possible values are: Default – The load balancer is configured to use a 5 tuple hash to map traffic to available servers. SourceIP – The load balancer is configured to use a 2 tuple hash to map traffic to available servers. SourceIPProtocol – The load balancer is configured to use a 3 tuple hash to map traffic to available servers. Also known as Session Persistence, where  the options are called None, Client IP and Client IP and Protocol respectively.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_lb_nat_rule" '(
    ("name" "name - (Required) Specifies the name of the NAT Rule.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the resource.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The ID of the LoadBalancer in which to create the NAT Rule.")
    ("frontend_ip_configuration_name" "frontend_ip_configuration_name - (Required) The name of the frontend IP configuration exposing this rule.")
    ("protocol" "protocol - (Required) The transport protocol for the external endpoint. Possible values are Udp or Tcp.")
    ("frontend_port" "frontend_port - (Required) The port for the external endpoint. Port numbers for each Rule must be unique within the Load Balancer. Possible values range between 1 and 65534, inclusive.")
    ("backend_port" "backend_port - (Required) The port used for internal connections on the endpoint. Possible values range between 1 and 65535, inclusive.")
    ("enable_floating_ip" "enable_floating_ip - (Optional) Enables the Floating IP Capacity, required to configure a SQL AlwaysOn Availability Group.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_lb_nat_pool" '(
    ("name" "name - (Required) Specifies the name of the NAT pool.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the resource.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The ID of the LoadBalancer in which to create the NAT pool.")
    ("frontend_ip_configuration_name" "frontend_ip_configuration_name - (Required) The name of the frontend IP configuration exposing this rule.")
    ("protocol" "protocol - (Required) The transport protocol for the external endpoint. Possible values are Udp or Tcp.")
    ("frontend_port_start" "frontend_port_start - (Required) The first port number in the range of external ports that will be used to provide Inbound Nat to NICs associated with this Load Balancer. Possible values range between 1 and 65534, inclusive.")
    ("frontend_port_end" "frontend_port_end - (Required) The last port number in the range of external ports that will be used to provide Inbound Nat to NICs associated with this Load Balancer. Possible values range between 1 and 65534, inclusive.")
    ("backend_port" "backend_port - (Required) The port used for the internal endpoint. Possible values range between 1 and 65535, inclusive.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_lb_probe" '(
    ("name" "name - (Required) Specifies the name of the Probe.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the resource.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The ID of the LoadBalancer in which to create the NAT Rule.")
    ("protocol" "protocol - (Optional) Specifies the protocol of the end point. Possible values are Http or Tcp. If Tcp is specified, a received ACK is required for the probe to be successful. If Http is specified, a 200 OK response from the specified URI is required for the probe to be successful.")
    ("port" "port - (Required) Port on which the Probe queries the backend endpoint. Possible values range from 1 to 65535, inclusive.")
    ("request_path" "request_path - (Optional) The URI used for requesting health status from the backend endpoint. Required if protocol is set to Http. Otherwise, it is not allowed.")
    ("interval_in_seconds" "interval_in_seconds - (Optional) The interval, in seconds between probes to the backend endpoint for health status. The default value is 15, the minimum value is 5.")
    ("number_of_probes" "number_of_probes - (Optional) The number of failed probe attempts after which the backend endpoint is removed from rotation. The default value is 2. NumberOfProbes multiplied by intervalInSeconds value must be greater or equal to 10.Endpoints are returned to rotation when at least one probe is successful.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_management_lock" '(
    ("name" "name - (Required) Specifies the name of the Management Lock. Changing this forces a new resource to be created.")
    ("scope" "scope - (Required) Specifies the scope at which the Management Lock should be created. Changing this forces a new resource to be created.")
    ("lock_level" "lock_level - (Required) Specifies the Level to be used for this Lock. Possible values are CanNotDelete and ReadOnly. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_eventgrid_topic" '(
    ("name" "name - (Required) Specifies the name of the EventGrid Topic resource. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the EventGrid Topic exists. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_eventhub" '(
    ("name" "name - (Required) Specifies the name of the EventHub Namespace resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) Specifies the name of the EventHub Namespace. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the EventHub's parent Namespace exists. Changing this forces a new resource to be created.")
    ("partition_count" "partition_count - (Required) Specifies the current number of shards on the Event Hub.")
    ("message_retention" "message_retention - (Required) Specifies the number of days to retain the events for this Event Hub. Needs to be between 1 and 7 days; or 1 day when using a Basic SKU for the parent EventHub Namespace.")
    ("capture_description" "capture_description - (Optional) A capture_description block as defined below.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_eventhub_authorization_rule" '(
    ("name" "name - (Required) Specifies the name of the EventHub Authorization Rule resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) Specifies the name of the grandparent EventHub Namespace. Changing this forces a new resource to be created.")
    ("eventhub_name" "eventhub_name - (Required) Specifies the name of the EventHub. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the EventHub Namespace exists. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_eventhub_consumer_group" '(
    ("name" "name - (Required) Specifies the name of the EventHub Consumer Group resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) Specifies the name of the grandparent EventHub Namespace. Changing this forces a new resource to be created.")
    ("eventhub_name" "eventhub_name - (Required) Specifies the name of the EventHub. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the EventHub Consumer Group's grandparent Namespace exists. Changing this forces a new resource to be created.")
    ("user_metadata" "user_metadata - (Optional) Specifies the user metadata.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_eventhub_namespace" '(
    ("name" "name - (Required) Specifies the name of the EventHub Namespace resource. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the namespace. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) Defines which tier to use. Valid options are Basic and Standard.")
    ("capacity" "capacity - (Optional) Specifies the Capacity / Throughput Units for a Standard SKU namespace. Valid values range from 1 - 20.")
    ("auto_inflate_enabled" "auto_inflate_enabled - (Optional) Is Auto Inflate enabled for the EventHub Namespace?")
    ("maximum_throughput_units" "maximum_throughput_units - (Optional) Specifies the maximum number of throughput units when Auto Inflate is Enabled. Valid values range from 1 - 20.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_iothub" '(
    ("name" "name - (Required) Specifies the name of the IotHub resource. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group under which the IotHub resource has to be created. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource has to be createc. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) A sku block as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_servicebus_namespace" '(
    ("name" "name - (Required) Specifies the name of the ServiceBus Namespace resource . Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the namespace.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) Defines which tier to use. Options are basic, standard or premium.")
    ("capacity" "capacity - (Optional) Specifies the capacity of a Premium namespace. Can be 1, 2 or 4.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_servicebus_queue" '(
    ("name" "name - (Required) Specifies the name of the ServiceBus Queue resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) The name of the ServiceBus Namespace to create this queue in. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the namespace. Changing this forces a new resource to be created.")
    ("auto_delete_on_idle" "auto_delete_on_idle - (Optional) The idle interval after which the Queue is automatically deleted, minimum of 5 minutes. Provided in the TimeSpan format.")
    ("default_message_ttl" "default_message_ttl - (Optional) The TTL of messages sent to this queue. This is the default value used when TTL is not set on message itself. Provided in the TimeSpan format.")
    ("duplicate_detection_history_time_window" "duplicate_detection_history_time_window - (Optional) The duration during which duplicates can be detected. Default value is 10 minutes. Provided in the TimeSpan format.")
    ("enable_express" "enable_express - (Optional) Boolean flag which controls whether Express Entities are enabled. An express queue holds a message in memory temporarily before writing it to persistent storage. Defaults to false for Basic and Standard. For Premium, it MUST be set to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_servicebus_subscription" '(
    ("name" "name - (Required) Specifies the name of the ServiceBus Subscription resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) The name of the ServiceBus Namespace to create this Subscription in. Changing this forces a new resource to be created.")
    ("topic_name" "topic_name - (Required) The name of the ServiceBus Topic to create this Subscription in. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the namespace. Changing this forces a new resource to be created.")
    ("max_delivery_count" "max_delivery_count - (Required) The maximum number of deliveries.")
    ("auto_delete_on_idle" "auto_delete_on_idle - (Optional) The idle interval after which the Subscription is automatically deleted, minimum of 5 minutes. Provided in the TimeSpan format.")
    ("default_message_ttl" "default_message_ttl - (Optional) The TTL of messages sent to this Subscription if no TTL value is set on the message itself. Provided in the TimeSpan format.")
    ("lock_duration" "lock_duration - (Optional) The lock duration for the subscription, maximum supported value is 5 minutes. Defaults to 1 minute.")
    ("dead_lettering_on_message_expiration" "dead_lettering_on_message_expiration - (Optional) Boolean flag which controls whether the Subscription has dead letter support when a message expires. Defaults to false.")
    ("enable_batched_operations" "enable_batched_operations - (Optional) Boolean flag which controls whether the Subscription supports batched operations. Defaults to false.")
    ("requires_session" "requires_session - (Optional) Boolean flag which controls whether this Subscription supports the concept of a session. Defaults to false. Changing this forces a new resource to be created.")
    ("forward_to" "forward_to - (Optional) The name of a Queue or Topic to automatically forward  messages to.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_servicebus_subscription_rule" '(
    ("name" "name - (Required) Specifies the name of the ServiceBus Subscription Rule. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) The name of the ServiceBus Namespace in which the ServiceBus Topic exists. Changing this forces a new resource to be created.")
    ("topic_name" "topic_name - (Required) The name of the ServiceBus Topic in which the ServiceBus Subscription exists. Changing this forces a new resource to be created.")
    ("subscription_name" "subscription_name - (Required) The name of the ServiceBus Subscription in which this Rule should be created. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in the ServiceBus Namespace exists. Changing this forces a new resource to be created.")
    ("filter_type" "filter_type - (Required) Type of filter to be applied to a BrokeredMessage. Possible values are SqlFilter and CorrelationFilter.")
    ("sql_filter" "sql_filter - (Optional) Represents a filter written in SQL language-based syntax that to be evaluated against a BrokeredMessage. Required when filter_type is set to SqlFilter.")
    ("correlation_filter" "correlation_filter - (Optional) A correlation_filter block as documented below to be evaluated against a BrokeredMessage. Required when filter_type is set to CorrelationFilter.")
    ("action" "action - (Optional) Represents set of actions written in SQL language-based syntax that is performed against a BrokeredMessage.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_servicebus_topic" '(
    ("name" "name - (Required) Specifies the name of the ServiceBus Topic resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) The name of the ServiceBus Namespace to create this topic in. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the namespace. Changing this forces a new resource to be created.")
    ("status" "status - (Optional) The Status of the Service Bus Topic. Acceptable values are Active or Disabled. Defaults to Active.")
    ("auto_delete_on_idle" "auto_delete_on_idle - (Optional) The idle interval after which the Topic is automatically deleted, minimum of 5 minutes. Provided in the TimeSpan format.")
    ("default_message_ttl" "default_message_ttl - (Optional) The TTL of messages sent to this topic if no TTL value is set on the message itself. Provided in the TimeSpan format.")
    ("duplicate_detection_history_time_window" "duplicate_detection_history_time_window - (Optional) The duration during which duplicates can be detected. Provided in the TimeSpan format. Defaults to 10 minutes (00:10:00)")
    ("enable_batched_operations" "enable_batched_operations - (Optional) Boolean flag which controls if server-side batched operations are enabled. Defaults to false.")
    ("enable_express" "enable_express - (Optional) Boolean flag which controls whether Express Entities are enabled. An express topic holds a message in memory temporarily before writing it to persistent storage. Defaults to false.")
    ("enable_partitioning" "enable_partitioning - (Optional) Boolean flag which controls whether to enable the topic to be partitioned across multiple message brokers. Defaults to false. Changing this forces a new resource to be created.")
    ("max_size_in_megabytes" "max_size_in_megabytes - (Optional) Integer value which controls the size of memory allocated for the topic. For supported values see the \"Queue/topic size\" section of this document.")
    ("requires_duplicate_detection" "requires_duplicate_detection - (Optional) Boolean flag which controls whether the Topic requires duplicate detection. Defaults to false. Changing this forces a new resource to be created.")
    ("support_ordering" "support_ordering - (Optional) Boolean flag which controls whether the Topic supports ordering. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_servicebus_topic_authorization_rule" '(
    ("name" "name - (Required) Specifies the name of the erviceBus Topic Authorization Rule resource. Changing this forces a new resource to be created.")
    ("namespace_name" "namespace_name - (Required) Specifies the name of the ServiceBus Namespace. Changing this forces a new resource to be created.")
    ("topic_name" "topic_name - (Required) Specifies the name of the ServiceBus Topic. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the ServiceBus Namespace exists. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_metric_alertrule" '(
    ("name" "name - (Required) Specifies the name of the alert rule. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the alert rule. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) A verbose description of the alert rule that will be included in the alert email.")
    ("enabled" "enabled - (Optional) If true, the alert rule is enabled. Defaults to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_application_gateway" '(
    ("name" "name - (Required) The name of the application gateway. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the application gateway.")
    ("location" "location - (Required) The location/region where the application gateway is created. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) Specifies size, tier and capacity of the application gateway. Must be specified once. The sku block fields documented below.")
    ("gateway_ip_configuration" "gateway_ip_configuration - (Required) List of subnets that the application gateway is deployed into. The application gateway must be deployed into an existing virtual network/subnet. No other resource can be deployed in a subnet where application gateway is deployed. The gateway_ip_configuration block supports fields documented below.")
    ("frontend_port" "frontend_port - (Required) Front-end port for the application gateway. The frontend_port block supports fields documented below.")
    ("frontend_ip_configuration" "frontend_ip_configuration - (Required) Specifies lists of frontend IP configurations. Currently only one Public and/or one Private IP address can be specified. Also one frontendIpConfiguration element can specify either Public or Private IP address, not both. The frontend_ip_configuration block supports fields documented below.")
    ("backend_address_pool" "backend_address_pool - (Required) Backend pools can be composed of NICs, virtual machine scale sets, public IPs, internal IPs, fully qualified domain names (FQDN), and multi-tenant back-ends like Azure Web Apps. Application Gateway backend pool members are not tied to an availability set. Members of backend pools can be across clusters, data centers, or outside of Azure as long as they have IP connectivity. The backend_address_pool block supports fields documented below.")
    ("backend_http_settings" "backend_http_settings - (Required) Related group of backend http and/or https features to be applied when routing to backend address pools. The backend_http_settings block supports fields documented below.")
    ("http_listener" "http_listener - (Required) 1 or more listeners specifying port, http or https and SSL certificate (if configuring SSL offload) Each http_listener is attached to a frontend_ip_configuration. The http_listener block supports fields documented below.")
    ("probe" "probe - (Optional) Specifies list of URL probes. The probe block supports fields documented below.")
    ("request_routing_rule" "request_routing_rule - (Required) Request routing rules can be either Basic or Path Based. Request routing rules are order sensitive. The request_routing_rule block supports fields documented below.")
    ("url_path_map" "url_path_map - (Optional) UrlPathMaps give url Path to backend mapping information for PathBasedRouting specified in request_routing_rule. The url_path_map block supports fields documented below.")
    ("authentication_certificate" "authentication_certificate - (Optional) List of authentication certificates. The authentication_certificate block supports fields documented below.")
    ("ssl_certificate" "ssl_certificate - (Optional) List of ssl certificates. The ssl_certificate block supports fields documented below.")
    ("waf_configuration" "waf_configuration - (Optional) Web Application Firewall configuration settings. The waf_configuration block supports fields documented below.")
    ("disabled_ssl_protocols" "disabled_ssl_protocols - TODO - based on \"sslPolicy\": {\"disabledSslProtocols\": []}")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_application_security_group" '(
    ("name" "name - (Required) Specifies the name of the Application Security Group. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Application Security Group.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_express_route_circuit" '(
    ("name" "name - (Required) The name of the ExpressRoute circuit. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the ExpressRoute circuit. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("service_provider_name" "service_provider_name - (Required) The name of the ExpressRoute Service Provider.")
    ("peering_location" "peering_location - (Required) The name of the peering location and not the Azure resource location.")
    ("bandwidth_in_mbps" "bandwidth_in_mbps - (Required) The bandwidth in Mbps of the circuit being created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_express_route_circuit_authorization" '(
    ("name" "name - (Required) The name of the ExpressRoute circuit. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the ExpressRoute circuit. Changing this forces a new resource to be created.")
    ("express_route_circuit_name" "express_route_circuit_name - (Required) The name of the Express Route Circuit in which to create the Authorization.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_express_route_circuit_peering" '(
    ("peering_type" "peering_type - (Required) The type of the ExpressRoute Circuit Peering. Acceptable values include AzurePrivatePeering, AzurePublicPeering and MicrosoftPeering. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_local_network_gateway" '(
    ("name" "name - (Required) The name of the local network gateway. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the local network gateway.")
    ("location" "location - (Required) The location/region where the local network gatway is created. Changing this forces a new resource to be created.")
    ("gateway_address" "gateway_address - (Required) The IP address of the gateway to which to connect.")
    ("address_space" "address_space - (Required) The list of string CIDRs representing the address spaces the gateway exposes.")
    ("bgp_settings" "bgp_settings - (Optional) A bgp_settings block as defined below containing the Local Network Gateway's BGP speaker settings.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_network_interface" '(
    ("name" "name - (Required) The name of the network interface. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the network interface. Changing this forces a new resource to be created.")
    ("location" "location - (Required) The location/region where the network interface is created. Changing this forces a new resource to be created.")
    ("network_security_group_id" "network_security_group_id - (Optional) The ID of the Network Security Group to associate with the network interface.")
    ("internal_dns_name_label" "internal_dns_name_label - (Optional) Relative DNS name for this NIC used for internal communications between VMs in the same VNet")
    ("enable_ip_forwarding" "enable_ip_forwarding - (Optional) Enables IP Forwarding on the NIC. Defaults to false.")
    ("enable_accelerated_networking" "enable_accelerated_networking - (Optional) Enables Azure Accelerated Networking using SR-IOV. Only certain VM instance sizes are supported. Refer to Create a Virtual Machine with Accelerated Networking. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_network_security_group" '(
    ("name" "name - (Required) Specifies the name of the network security group. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the network security group. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("security_rule" "security_rule - (Optional) One or more security_rule blocks as defined below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_network_security_rule" '(
    ("name" "name - (Required) The name of the security rule. This needs to be unique across all Rules in the Network Security Group. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Network Security Rule. Changing this forces a new resource to be created.")
    ("network_security_group_name" "network_security_group_name - (Required) The name of the Network Security Group that we want to attach the rule to. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) A description for this rule. Restricted to 140 characters.")
    ("protocol" "protocol - (Required) Network protocol this rule applies to. Possible values include Tcp, Udp or * (which matches both).")
    ("source_port_range" "source_port_range - (Optional) Source Port or Range. Integer or range between 0 and 65535 or * to match any. This is required if source_port_ranges is not specified.")
    ("source_port_ranges" "source_port_ranges - (Optional) List of source ports or port ranges. This is required if source_port_range is not specified.")
    ("destination_port_range" "destination_port_range - (Optional) Destination Port or Range. Integer or range between 0 and 65535 or * to match any. This is required if destination_port_ranges is not specified.")
    ("destination_port_ranges" "destination_port_ranges - (Optional) List of destination ports or port ranges. This is required if destination_port_range is not specified.")
    ("source_address_prefix" "source_address_prefix - (Optional) CIDR or source IP range or * to match any IP. Tags such as ‘VirtualNetwork’, ‘AzureLoadBalancer’ and ‘Internet’ can also be used. This is required if source_address_prefixes is not specified.")
    ("source_address_prefixes" "source_address_prefixes - (Optional) List of source address prefixes. Tags may not be used. This is required if source_address_prefix is not specified.")
    ("source_application_security_group_ids" "source_application_security_group_ids - (Optional) A List of source Application Security Group ID's")
    ("destination_address_prefix" "destination_address_prefix - (Optional) CIDR or destination IP range or * to match any IP. Tags such as ‘VirtualNetwork’, ‘AzureLoadBalancer’ and ‘Internet’ can also be used. This is required if destination_address_prefixes is not specified.")
    ("destination_address_prefixes" "destination_address_prefixes - (Optional) List of destination address prefixes. Tags may not be used. This is required if destination_address_prefix is not specified.")
    ("destination_application_security_group_ids" "destination_application_security_group_ids - (Optional) A List of destination Application Security Group ID's")
    ("access" "access - (Required) Specifies whether network traffic is allowed or denied. Possible values are Allow and Deny.")
    ("priority" "priority - (Required) Specifies the priority of the rule. The value can be between 100 and 4096. The priority number must be unique for each rule in the collection. The lower the priority number, the higher the priority of the rule.")
    ("direction" "direction - (Required) The direction specifies if rule will be evaluated on incoming or outgoing traffic. Possible values are Inbound and Outbound.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_network_watcher" '(
    ("name" "name - (Required) The name of the Network Watcher. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Network Watcher. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_packet_capture" '(
    ("name" "name - (Required) The name to use for this Packet Capture. Changing this forces a new resource to be created.")
    ("network_watcher_name" "network_watcher_name - (Required) The name of the Network Watcher. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Network Watcher exists. Changing this forces a new resource to be created.")
    ("target_resource_id" "target_resource_id - (Required) The ID of the Resource to capture packets from. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_public_ip" '(
    ("name" "name - (Required) Specifies the name of the Public IP resource . Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the public ip.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Optional) The SKU of the Public IP. Accepted values are Basic and Standard. Defaults to Basic.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_route" '(
    ("name" "name - (Required) The name of the route. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the route. Changing this forces a new resource to be created.")
    ("route_table_name" "route_table_name - (Required) The name of the route table within which create the route. Changing this forces a new resource to be created.")
    ("address_prefix" "address_prefix - (Required) The destination CIDR to which the route applies, such as 10.1.0.0/16")
    ("next_hop_type" "next_hop_type - (Required) The type of Azure hop the packet should be sent to. Possible values are VirtualNetworkGateway, VnetLocal, Internet, VirtualAppliance and None")
    ("next_hop_in_ip_address" "next_hop_in_ip_address - (Optional) Contains the IP address packets should be forwarded to. Next hop values are only allowed in routes where the next hop type is VirtualAppliance.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_route_table" '(
    ("name" "name - (Required) The name of the route table. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the route table. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("route" "route - (Optional) Can be specified multiple times to define multiple routes. Each route block supports fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_subnet" '(
    ("name" "name - (Required) The name of the subnet. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the subnet. Changing this forces a new resource to be created.")
    ("virtual_network_name" "virtual_network_name - (Required) The name of the virtual network to which to attach the subnet. Changing this forces a new resource to be created.")
    ("address_prefix" "address_prefix - (Required) The address prefix to use for the subnet.")
    ("network_security_group_id" "network_security_group_id - (Optional) The ID of the Network Security Group to associate with the subnet.")
    ("route_table_id" "route_table_id - (Optional) The ID of the Route Table to associate with the subnet.")
    ("service_endpoints" "service_endpoints - (Optional) The list of Service endpoints to associate with the subnet. Possible values include: Microsoft.Storage, Microsoft.Sql.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_traffic_manager_endpoint" '(
    ("name" "name - (Required) The name of the Traffic Manager endpoint. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Traffic Manager endpoint.")
    ("profile_name" "profile_name - (Required) The name of the Traffic Manager Profile to attach create the Traffic Manager endpoint.")
    ("endpoint_status" "endpoint_status - (Optional) The status of the Endpoint, can be set to either Enabled or Disabled. Defaults to Enabled.")
    ("type" "type - (Required) The Endpoint type, must be one of:  azureEndpoints  externalEndpoints  nestedEndpoints")
    ("target" "target - (Optional) The FQDN DNS name of the target. This argument must be provided for an endpoint of type externalEndpoints, for other types it will be computed.")
    ("target_resource_id" "target_resource_id - (Optional) The resource id of an Azure resource to target. This argument must be provided for an endpoint of type azureEndpoints or nestedEndpoints.")
    ("weight" "weight - (Optional) Specifies how much traffic should be distributed to this endpoint, this must be specified for Profiles using the  Weighted traffic routing method. Supports values between 1 and 1000.")
    ("priority" "priority - (Optional) Specifies the priority of this Endpoint, this must be specified for Profiles using the Priority traffic routing method. Supports values between 1 and 1000, with no Endpoints sharing the same value. If omitted the value will be computed in order of creation.")
    ("endpoint_location" "endpoint_location - (Optional) Specifies the Azure location of the Endpoint, this must be specified for Profiles using the Performance routing method if the Endpoint is of either type nestedEndpoints or externalEndpoints. For Endpoints of type azureEndpoints the value will be taken from the location of the Azure target resource.")
    ("min_child_endpoints" "min_child_endpoints - (Optional) This argument specifies the minimum number of endpoints that must be ‘online’ in the child profile in order for the parent profile to direct traffic to any of the endpoints in that child profile. This argument only applies to Endpoints of type nestedEndpoints and defaults to 1.")
    ("geo_mappings" "geo_mappings - (Optional) A list of Geographic Regions used to distribute traffic, such as WORLD, UK or DE. The same location can't be specified in two endpoints. See the Geographic Hierarchies documentation for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_traffic_manager_profile" '(
    ("name" "name - (Required) The name of the virtual network. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the virtual network.")
    ("profile_status" "profile_status - (Optional) The status of the profile, can be set to either Enabled or Disabled. Defaults to Enabled.")
    ("traffic_routing_method" "traffic_routing_method - (Required) Specifies the algorithm used to route traffic, possible values are:  Geographic - Traffic is routed based on Geographic regions specified in the Endpoint.  Performance - Traffic is routed via the User's closest Endpoint  Weighted - Traffic is spread across Endpoints proportional to their weight value.  Priority - Traffic is routed to the Endpoint with the lowest priority value.")
    ("dns_config" "dns_config - (Required) This block specifies the DNS configuration of the Profile, it supports the fields documented below.")
    ("monitor_config" "monitor_config - (Required) This block specifies the Endpoint monitoring configuration for the Profile, it supports the fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_network" '(
    ("name" "name - (Required) The name of the virtual network. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the virtual network.")
    ("address_space" "address_space - (Required) The address space that is used the virtual network. You can supply more than one address space. Changing this forces a new resource to be created.")
    ("location" "location - (Required) The location/region where the virtual network is created. Changing this forces a new resource to be created.")
    ("dns_servers" "dns_servers - (Optional) List of IP addresses of DNS servers")
    ("subnet" "subnet - (Optional) Can be specified multiple times to define multiple subnets. Each subnet block supports fields documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_network_gateway" '(
    ("name" "name - (Required) The name of the Virtual Network Gateway. Changing the name forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Virtual Network Gateway. Changing the resource group name forces a new resource to be created.")
    ("location" "location - (Required) The location/region where the Virtual Network Gateway is located. Changing the location/region forces a new resource to be created.")
    ("type" "type - (Required) The type of the Virtual Network Gateway. Valid options are Vpn or ExpressRoute. Changing the type forces a new resource to be created.")
    ("vpn_type" "vpn_type - (Optional) The routing type of the Virtual Network Gateway. Valid options are RouteBased or PolicyBased. Defaults to RouteBased.")
    ("enable_bgp" "enable_bgp - (Optional) If true, BGP (Border Gateway Protocol) will be enabled for this Virtual Network Gateway. Defaults to false.")
    ("active_active" "active_active - (Optional) If true, an active-active Virtual Network Gateway will be created. An active-active gateway requires a HighPerformance or an UltraPerformance sku. If false, an active-standby gateway will be created. Defaults to false.")
    ("default_local_network_gateway_id" "default_local_network_gateway_id -  (Optional) The ID of the local network gateway through which outbound Internet traffic from the virtual network in which the gateway is created will be routed (forced tunneling). Refer to the Azure documentation on forced tunneling. If not specified, forced tunneling is disabled.")
    ("sku" "sku - (Required) Configuration of the size and capacity of the virtual network gateway. Valid options are Basic, Standard, HighPerformance, UltraPerformance, VpnGw1, VpnGw2 and VpnGw3 and depend on the type and vpn_type arguments. A PolicyBased gateway only supports the Basic sku. Further, the UltraPerformance sku is only supported by an ExpressRoute gateway.")
    ("ip_configuration" "ip_configuration (Required) One or two ip_configuration blocks documented below. An active-standby gateway requires exactly one ip_configuration block whereas an active-active gateway requires exactly two ip_configuration blocks.")
    ("vpn_client_configuration" "vpn_client_configuration (Optional) A vpn_client_configuration block which is documented below. In this block the Virtual Network Gateway can be configured to accept IPSec point-to-site connections.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_network_gateway_connection" '(
    ("name" "name - (Required) The name of the connection. Changing the name forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the connection Changing the name forces a new resource to be created.")
    ("location" "location - (Required) The location/region where the connection is located. Changing this forces a new resource to be created.")
    ("type" "type - (Required) The type of connection. Valid options are IPsec (Site-to-Site), ExpressRoute (ExpressRoute), and Vnet2Vnet (VNet-to-VNet). Each connection type requires different mandatory arguments (refer to the examples above). Changing the connection type will force a new connection to be created.")
    ("virtual_network_gateway_id" "virtual_network_gateway_id - (Required) The ID of the Virtual Network Gateway in which the connection will be created. Changing the gateway forces a new resource to be created.")
    ("authorization_key" "authorization_key - (Optional) The authorization key associated with the Express Route Circuit. This field is required only if the type is an ExpressRoute connection.")
    ("express_route_circuit_id" "express_route_circuit_id - (Optional) The ID of the Express Route Circuit when creating an ExpressRoute connection (i.e. when type is ExpressRoute). The Express Route Circuit can be in the same or in a different subscription.")
    ("peer_virtual_network_gateway_id" "peer_virtual_network_gateway_id - (Optional) The ID of the peer virtual network gateway when creating a VNet-to-VNet connection (i.e. when type is Vnet2Vnet). The peer Virtual Network Gateway can be in the same or in a different subscription.")
    ("local_network_gateway_id" "local_network_gateway_id - (Optional) The ID of the local network gateway when creating Site-to-Site connection (i.e. when type is IPsec).")
    ("routing_weight" "routing_weight - (Optional) The routing weight. Defaults to 10.")
    ("shared_key" "shared_key - (Optional) The shared IPSec key. A key must be provided if a Site-to-Site or VNet-to-VNet connection is created whereas ExpressRoute connections do not need a shared key.")
    ("enable_bgp" "enable_bgp - (Optional) If true, BGP (Border Gateway Protocol) is enabled for this connection. Defaults to false.")
    ("use_policy_based_traffic_selectors" "use_policy_based_traffic_selectors - (Optional) If true, policy-based traffic selectors are enabled for this connection. Enabling policy-based traffic selectors requires an ipsec_policy block. Defaults to false.")
    ("ipsec_policy" "ipsec_policy (Optional) A ipsec_policy block which is documented below. Only a single policy can be defined for a connection. For details on custom policies refer to the relevant section in the Azure documentation.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_virtual_network_peering" '(
    ("name" "name - (Required) The name of the virtual network peering. Changing this forces a new resource to be created.")
    ("virtual_network_name" "virtual_network_name - (Required) The name of the virtual network. Changing this forces a new resource to be created.")
    ("remote_virtual_network_id" "remote_virtual_network_id - (Required) The full Azure resource ID of the remote virtual network.  Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the virtual network. Changing this forces a new resource to be created.")
    ("allow_virtual_network_access" "allow_virtual_network_access - (Optional) Controls if the VMs in the remote virtual network can access VMs in the local virtual network. Defaults to false.")
    ("allow_forwarded_traffic" "allow_forwarded_traffic - (Optional) Controls if forwarded traffic from  VMs in the remote virtual network is allowed. Defaults to false.")
    ("allow_gateway_transit" "allow_gateway_transit - (Optional) Controls gatewayLinks can be used in the remote virtual network’s link to the local virtual network.")
    ("use_remote_gateways" "use_remote_gateways - (Optional) Controls if remote gateways can be used on the local virtual network. If the flag is set to true, and allowGatewayTransit on the remote peering is also true, virtual network will use gateways of remote virtual network for transit. Only one peering can have this flag set to true. This flag cannot be set if virtual network already has a gateway. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_policy_assignment" '(
    ("name" "name - (Required) The name of the Policy Assignment. Changing this forces a new resource to be created.")
    ("scope" "scope- (Required) The Scope at which the Policy Assignment should be applied. This can either be the Subscription (e.g. /subscriptions/00000000-0000-0000-000000000000) or a Resource Group (e.g./subscriptions/00000000-0000-0000-000000000000/resourceGroups/myResourceGroup). Changing this forces a new resource to be created.")
    ("policy_definition_id" "policy_definition_id - (Required) The ID of the Policy Definition to be applied at the specified Scope.")
    ("description" "description - (Optional) A description to use for this Policy Assignment. Changing this forces a new resource to be created.")
    ("display_name" "display_name - (Optional) A friendly display name to use for this Policy Assignment. Changing this forces a new resource to be created.")
    ("parameters" "parameters - (Optional) Parameters for the policy definition. This field is a JSON object that maps to the Parameters field from the Policy Definition. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_policy_definition" '(
    ("name" "name - (Required) The name of the policy definition. Changing this forces a new resource to be created.")
    ("policy_type" "policy_type - (Required) The policy type.  The value can be \"BuiltIn\", \"Custom\" or \"NotSpecified\". Changing this forces a new resource to be created.")
    ("mode" "mode - (Required) The policy mode that allows you to specify which resource types will be evaluated.  The value can be \"All\", \"Indexed\" or \"NotSpecified\". Changing this resource forces a new resource to be created.")
    ("display_name" "display_name - (Required) The display name of the policy definition.")
    ("description" "description - (Optional) The description of the policy definition.")
    ("policy_rule" "policy_rule - (Optional) The policy rule for the policy definition. This is a json object representing the rule that contains an if and a then block.")
    ("metadata" "metadata - (Optional) The metadata for the policy definition. This is a json object representing the rule that contains an if and a then block.")
    ("parameters" "parameters - (Optional) Parameters for the policy definition. This field is a json object that allows you to parameterize your policy definition.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_log_analytics_solution" '(
    ("solution_name" "solution_name - (Required) Specifies the name of the solution to be deployed. See here for options.Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Log Analytics solution is created. Changing this forces a new resource to be created. Note: The solution and it's related workspace can only exist in the same resource group.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("workspace_resource_id" "workspace_resource_id - (Required) The full resource ID of the Log Analytics workspace with which the solution will be linked. Changing this forces a new resource to be created.")
    ("workspace_resource_name" "workspace_resource_name - (Required) The full name of the Log Analytics workspace with which the solution will be linked. Changing this forces a new resource to be created.")
    ("plan" "plan - A plan block as documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_log_analytics_workspace" '(
    ("name" "name - (Required) Specifies the name of the Log Analytics Workspace. Workspace name should include 4-63 letters, digits or '-'. The '-' shouldn't be the first or the last symbol. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Log Analytics workspace is created. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) Specifies the Sku of the Log Analytics Workspace. Possible values are Free, PerNode, Premium, Standard, Standalone and Unlimited.")
    ("retention_in_days" "retention_in_days - (Optional) The workspace data retention in days. Possible values range between 30 and 730.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_recovery_services_vault" '(
    ("name" "name - (Required) Specifies the name of the Recovery Services Vault. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Recovery Services Vault. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("sku" "sku - (Required) Sets the vault's SKU. Possible values include: Standard, RS0.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_redis_cache" '(
    ("name" "name - (Required) The name of the Redis instance. Changing this forces a new resource to be created.")
    ("location" "location - (Required) The location of the resource group.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Redis instance.")
    ("capacity" "capacity - (Required) The size of the Redis cache to deploy. Valid values for a SKU family of C (Basic/Standard) are 0, 1, 2, 3, 4, 5, 6, and for P (Premium) family are 1, 2, 3, 4.")
    ("family" "family - (Required) The SKU family to use. Valid values are C and P, where C = Basic/Standard, P = Premium.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_redis_firewall_rule" '(
    ("name" "name - (Required) The name of the Firewall Rule. Changing this forces a new resource to be created.")
    ("redis_cache_name" "redis_cache_name - (Required) The name of the Redis Cache. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which this Redis Cache exists.")
    ("start_ip" "start_ip - (Required) The lowest IP address included in the range")
    ("end_ip" "end_ip - (Required) The highest IP address included in the range.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_search_service" '(
    ("name" "name - (Required) The name of the Search Service. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Search Service. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("sku" "sku - (Required) Valid values are free and standard. standard2 and standard3 are also valid, but can only be used when it's enabled on the backend by Microsoft support. free provisions the service in shared clusters. standard provisions the service in dedicated clusters.  Changing this forces a new resource to be created.")
    ("replica_count" "replica_count - (Optional) Default is 1. Valid values include 1 through 12. Valid only when sku is standard. Changing this forces a new resource to be created.")
    ("partition_count" "partition_count - (Optional) Default is 1. Valid values include 1, 2, 3, 4, 6, or 12. Valid only when sku is standard. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_scheduler_job_collection" '(
    ("name" "name - (Required) Specifies the name of the Scheduler Job Collection. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the Scheduler Job Collection. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("sku" "sku - (Required) Sets the Job Collection's pricing level's SKU. Possible values include: Standard, Free, P10Premium, P20Premium.")
    ("state" "state - (Optional) Sets Job Collection's state. Possible values include: Enabled, Disabled, Suspended.")
    ("quota" "quota - (Optional) Configures the Job collection quotas as documented in the quota block below.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_storage_account" '(
    ("name" "name - (Required) Specifies the name of the storage account. Changing this forces a new resource to be created. This must be unique across the entire Azure service, not just within the resource group.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the storage account. Changing this forces a new resource to be created.")
    ("location" "location - (Required) Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.")
    ("account_kind" "account_kind - (Optional) Defines the Kind of account. Valid options are Storage,  StorageV2 and BlobStorage. Changing this forces a new resource to be created.  Defaults to Storage.")
    ("account_tier" "account_tier - (Required) Defines the Tier to use for this storage account. Valid options are Standard and Premium. Changing this forces a new resource to be created")
    ("account_replication_type" "account_replication_type - (Required) Defines the type of replication to use for this storage account. Valid options are LRS, GRS, RAGRS and ZRS.")
    ("access_tier" "access_tier - (Optional) Defines the access tier for BlobStorage and StorageV2 accounts. Valid options are Hot and Cold, defaults to Hot.")
    ("enable_blob_encryption" "enable_blob_encryption - (Optional) Boolean flag which controls if Encryption Services are enabled for Blob storage, see here for more information.")
    ("enable_file_encryption" "enable_file_encryption - (Optional) Boolean flag which controls if Encryption Services are enabled for File storage, see here for more information.")
    ("enable_https_traffic_only" "enable_https_traffic_only - (Optional) Boolean flag which forces HTTPS if enabled, see here for more information.")
    ("account_encryption_source" "account_encryption_source - (Optional) The Encryption Source for this Storage Account. Possible values are Microsoft.Keyvault and Microsoft.Storage. Defaults to Microsoft.Storage.")
    ("custom_domain" "custom_domain - (Optional) A custom_domain block as documented below.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_storage_container" '(
    ("name" "name - (Required) The name of the storage container. Must be unique within the storage service the container is located.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the storage container. Changing this forces a new resource to be created.")
    ("storage_account_name" "storage_account_name - (Required) Specifies the storage account in which to create the storage container. Changing this forces a new resource to be created.")
    ("container_access_type" "container_access_type - (Optional) The 'interface' for access the container provides. Can be either blob, container or private. Defaults to private. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_storage_blob" '(
    ("name" "name - (Required) The name of the storage blob. Must be unique within the storage container the blob is located.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the storage container. Changing this forces a new resource to be created.")
    ("storage_account_name" "storage_account_name - (Required) Specifies the storage account in which to create the storage container. Changing this forces a new resource to be created.")
    ("storage_container_name" "storage_container_name - (Required) The name of the storage container in which this blob should be created.")
    ("type" "type - (Optional) The type of the storage blob to be created. One of either block or page. When not copying from an existing blob, this becomes required.")
    ("size" "size - (Optional) Used only for page blobs to specify the size in bytes of the blob to be created. Must be a multiple of 512. Defaults to 0.")
    ("source" "source - (Optional) An absolute path to a file on the local system. Cannot be defined if source_uri is defined.")
    ("source_uri" "source_uri - (Optional) The URI of an existing blob, or a file in the Azure File service, to use as the source contents for the blob to be created. Changing this forces a new resource to be created. Cannot be defined if source is defined.")
    ("parallelism" "parallelism - (Optional) The number of workers per CPU core to run for concurrent uploads. Defaults to 8.")
    ("attempts" "attempts - (Optional) The number of attempts to make per page or block when uploading. Defaults to 1.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_storage_queue" '(
    ("name" "name - (Required) The name of the storage queue. Must be unique within the storage account the queue is located.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the storage queue. Changing this forces a new resource to be created.")
    ("storage_account_name" "storage_account_name - (Required) Specifies the storage account in which to create the storage queue. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_storage_share" '(
    ("name" "name - (Required) The name of the share. Must be unique within the storage account where the share is located.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the share. Changing this forces a new resource to be created.")
    ("storage_account_name" "storage_account_name - (Required) Specifies the storage account in which to create the share. Changing this forces a new resource to be created.")
    ("quota" "quota - (Optional) The maximum size of the share, in gigabytes. Must be greater than 0, and less than or equal to 5 TB (5120 GB). Default this is set to 0 which results in setting the quota to 5 TB.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_storage_table" '(
    ("name" "name - (Required) The name of the storage table. Must be unique within the storage account the table is located.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the storage table. Changing this forces a new resource to be created.")
    ("storage_account_name" "storage_account_name - (Required) Specifies the storage account in which to create the storage table. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "azurerm_template_deployment" '(
    ("name" "name - (Required) Specifies the name of the template deployment. Changing this forces a new resource to be created.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which to create the template deployment.")
    ("deployment_mode" "deployment_mode - (Required) Specifies the mode that is used to deploy resources. This value could be either Incremental or Complete. Note that you will almost always want this to be set to Incremental otherwise the deployment will destroy all infrastructure not specified within the template, and Terraform will not be aware of this.")
    ("template_body" "template_body - (Optional) Specifies the JSON definition for the template.")

  ) company-terraform-resource-arguments-hash)

(puthash "bitbucket_default_reviewers" '(
    ("owner" "owner - (Required) The owner of this repository. Can be you or any team you have write access to.")
    ("repository" "repository - (Required) The name of the repository.")
    ("reviewers" "reviewers - (Required) A list of reviewers to use.")

  ) company-terraform-resource-arguments-hash)

(puthash "bitbucket_hook" '(
    ("owner" "owner - (Required) The owner of this repository. Can be you or any team you have write access to.")
    ("repository" "repository - (Required) The name of the repository.")
    ("url" "url - (Required) Where to POST to.")
    ("description" "description - (Required) The name / description to show in the UI.")
    ("events" "events - (Required) The event you want to react on.")

  ) company-terraform-resource-arguments-hash)

(puthash "bitbucket_repository" '(
    ("owner" "owner - (Required) The owner of this repository. Can be you or any team you have write access to.")
    ("name" "name - (Required) The name of the repository.")
    ("slug" "slug - (Optional) The slug of the repository.")
    ("scm" "scm - (Optional) What SCM you want to use. Valid options are hg or git. Defaults to git.")
    ("is_private" "is_private - (Optional) If this should be private or not. Defaults to true.")
    ("website" "website - (Optional) URL of website associated with this repository.")
    ("language" "language - (Optional) What the language of this repository should be.")
    ("has_issues" "has_issues - (Optional) If this should have issues turned on or not.")
    ("has_wiki" "has_wiki - (Optional) If this should have wiki turned on or not.")
    ("project_key" "project_key - (Optional) If you want to have this repo associated with a project.")
    ("fork_policy" "fork_policy - (Optional) What the fork policy should be. Defaults to allow_forks.")
    ("description" "description - (Optional) What the description of the repo is.")

  ) company-terraform-resource-arguments-hash)

(puthash "clc_server" '(
    ("name_template" "name_template - (Required, string) The basename of the server. A unique name will be generated by the platform.")
    ("source_server_id" "source_server_id - (Required, string) The name or ID of the base OS image. Examples: \"ubuntu-14-64-template\", \"rhel-7-64-template\", \"win2012r2dtc-64\"")
    ("group_id" "group_id - (Required, string) The name or ID of the server group to spawn server into.")
    ("cpu" "cpu - (Required, int) The number of virtual cores")
    ("memory_mb" "memory_mb - (Required, int) Provisioned RAM")
    ("type" "type - (Required, string) The virtualization type One of \"standard\", \"hyperscale\", \"bareMetal\"")
    ("password" "password - (Optional, string) The root/administrator password. Will be generated by platform if not provided.")
    ("description" "description - (Optional, string) Description for server (visible in control portal only)")
    ("power_state" "power_state - (Optional, string) See PowerStates below for details. If absent, defaults to started.")
    ("private_ip_address" "private_ip_address - (Optional, string) Set internal IP address. If absent, allocated and assigned from pool.")
    ("network_id" "network_id - (Optional, string) GUID of network to use. (Must be set up in advance from control portal.) When absent, the default network will be used.")
    ("storage_type" "storage_type - (Optional, string) Backup and replication strategy for disks. One of \"standard\", \"premium\"")
    ("aa_policy_id" "aa_policy_id - (Optional, string | hyperscale) Anti-Affinity policy ID")
    ("configuration_id" "configuration_id - (Optional, string | bareMetal) Hardware configuration ID")
    ("os_type" "os_type - (Optional, string | bareMetal) Operating system to install.")
    ("additional_disks" "additional_disks - (Optional) See Disks below for details.")
    ("custom_fields" "custom_fields - (Optional) See CustomFields below for details.")
    ("metadata" "metadata - (Optional) Misc state storage for non-CLC metadata.")

  ) company-terraform-resource-arguments-hash)

(puthash "clc_group" '(
    ("name" "name - (Required, string) The name (or GUID) of this server group. Will resolve to existing if present.")
    ("parent" "parent - (Required, string) The name or ID of the parent group. Will error if absent or unable to resolve.")
    ("location_id" "location_id - (Required, string) The datacenter location of both parent group and this group. Examples: \"WA1\", \"VA1\"")
    ("description" "description - (Optional, string) Description for server group (visible in control portal only)")
    ("custom_fields" "custom_fields - (Optional) See CustomFields below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "clc_public_ip" '(
    ("server_id" "server_id - (Required, string) The name or ID of the server to bind IP to.")
    ("internal_ip_address" "internal_ip_address - (Required, string) The internal IP of the NIC to attach to. If not provided, a new internal NIC will be provisioned and used.")
    ("ports" "ports - (Optional) See Ports below for details.")
    ("source_restrictions" "source_restrictions - (Optional) See SourceRestrictions below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "clc_load_balancer" '(
    ("name" "name - (Required, string) The name of the load balancer.")
    ("data_center" "data_center - (Required, string) The datacenter location of both parent group and this group.")
    ("status" "status - (Required, string) Either \"enabled\" or \"disabled\"")
    ("description" "description - (Optional, string) Description for server group (visible in control portal only)")

  ) company-terraform-resource-arguments-hash)

(puthash "clc_load_balancer_pool" '(
    ("load_balancer" "load_balancer - (Required, string) The id of the load balancer.")
    ("data_center" "data_center - (Required, string) The datacenter location for this pool.")
    ("port" "port - (Required, int) Either 80 or 443")
    ("method" "method - (Optional, string) The configured balancing method. Either \"roundRobin\" (default) or \"leastConnection\".")
    ("persistence" "persistence - (Optional, string) The configured persistence method. Either \"standard\" (default) or \"sticky\".")
    ("nodes" "nodes - (Optional) See Nodes below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "chef_data_bag" '(
    ("name" "name - (Required) The unique name to assign to the data bag. This is the name that other server clients will use to find and retrieve data from the data bag.")

  ) company-terraform-resource-arguments-hash)

(puthash "chef_data_bag_item" '(
    ("data_bag_name" "data_bag_name - (Required) The name of the data bag into which this item will be placed.")
    ("content_json" "content_json - (Required) A string containing a JSON object that will be the content of the item. Must at minimum contain a property called \"id\" that is unique within the data bag, which will become the identifier of the created item.")

  ) company-terraform-resource-arguments-hash)

(puthash "chef_environment" '(
    ("name" "name - (Required) The unique name to assign to the environment. This name will be used when nodes are created within the environment.")
    ("description" "description - (Optional) A human-friendly description of the environment. If not set, a placeholder of \"Managed by Terraform\" will be set.")
    ("default_attributes_json" "default_attributes_json - (Optional) String containing a JSON-serialized object containing the default attributes for the environment.")
    ("override_attributes_json" "override_attributes_json - (Optional) String containing a JSON-serialized object containing the override attributes for the environment.")
    ("cookbook_constraints" "cookbook_constraints - (Optional) Mapping of cookbook names to cookbook version constraints that should apply for this environment.")

  ) company-terraform-resource-arguments-hash)

(puthash "chef_node" '(
    ("name" "name - (Required) The unique name to assign to the node.")
    ("automatic_attributes_json" "automatic_attributes_json - (Optional) String containing a JSON-serialized object containing the automatic attributes for the node.")
    ("normal_attributes_json" "normal_attributes_json - (Optional) String containing a JSON-serialized object containing the normal attributes for the node.")
    ("default_attributes_json" "default_attributes_json - (Optional) String containing a JSON-serialized object containing the default attributes for the node.")
    ("override_attributes_json" "override_attributes_json - (Optional) String containing a JSON-serialized object containing the override attributes for the node.")
    ("run_list" "run_list - (Optional) List of strings to set as the run list for the node.")

  ) company-terraform-resource-arguments-hash)

(puthash "chef_role" '(
    ("name" "name - (Required) The unique name to assign to the role.")
    ("description" "description - (Optional) A human-friendly description of the role. If not set, a placeholder of \"Managed by Terraform\" will be set.")
    ("default_attributes_json" "default_attributes_json - (Optional) String containing a JSON-serialized object containing the default attributes for the role.")
    ("override_attributes_json" "override_attributes_json - (Optional) String containing a JSON-serialized object containing the override attributes for the role.")
    ("run_list" "run_list - (Optional) List of strings to set as the run list for any nodes that belong to this role.")

  ) company-terraform-resource-arguments-hash)

(puthash "circonus_check" '(
    ("active" "active - (Optional) Whether or not the check is enabled or not (default true).")
    ("caql" "caql - (Optional) A Circonus Analytics Query Language (CAQL) check.  See below for details on how to configure a caql check.")
    ("cloudwatch" "cloudwatch - (Optional) A CloudWatch check check. See below for details on how to configure a cloudwatch check.")
    ("collector" "collector - (Required) A collector ID.  The collector(s) that are responsible for running a circonus_check. The id can be the Circonus ID for a Circonus collector (a.k.a. \"broker\") running in the cloud or an enterprise collector running in your datacenter.  One collection of metrics will be automatically created for each collector specified.")
    ("consul" "consul - (Optional) A native Consul check.  See below for details on how to configure a consul check.")
    ("http" "http - (Optional) A poll-based HTTP check.  See below for details on how to configure the http check.")
    ("httptrap" "httptrap - (Optional) An push-based HTTP check.  This check method expects clients to send a specially crafted HTTP JSON payload.  See below for details on how to configure the httptrap check.")
    ("icmp_ping" "icmp_ping - (Optional) An ICMP ping check.  See below for details on how to configure the icmp_ping check.")
    ("json" "json - (Optional) A JSON check.  See below for details on how to configure the json check.")
    ("metric" "metric - (Required) A list of one or more metric configurations.  All metrics obtained from this check instance will be available as individual metric streams.  See below for a list of supported metric attrbutes.")
    ("metric_limit" "metric_limit - (Optional) Setting a metric limit will tell the Circonus backend to periodically look at the check to see if there are additional metrics the collector has seen that we should collect. It will not reactivate metrics previously collected and then marked as inactive. Values are 0 to disable, -1 to enable all metrics or N+ to collect up to the value N (both -1 and N+ can not exceed other account restrictions).")
    ("mysql" "mysql - (Optional) A MySQL check.  See below for details on how to configure the mysql check.")
    ("name" "name - (Optional) The name of the check that will be displayed in the web interface.")
    ("notes" "notes - (Optional) Notes about this check.")
    ("period" "period - (Optional) The period between each time the check is made in seconds.")
    ("postgresql" "postgresql - (Optional) A PostgreSQL check.  See below for details on how to configure the postgresql check.")
    ("statsd" "statsd - (Optional) A statsd check.  See below for details on how to configure the statsd check.")
    ("tags" "tags - (Optional) A list of tags assigned to this check.")
    ("target" "target - (Required) A string containing the location of the thing being checked.  This value changes based on the check type.  For example, for an http check type this would be the URL you're checking. For a DNS check it would be the hostname you wanted to look up.")
    ("tcp" "tcp - (Optional) A TCP check.  See below for details on how to configure the tcp check (includes TLS support).")
    ("timeout" "timeout - (Optional) A floating point number representing the maximum number of seconds this check should wait for a result.  Defaults to 10.0.")

  ) company-terraform-resource-arguments-hash)

(puthash "circonus_contact_group" '(
    ("aggregation_window" "aggregation_window - (Optional) The aggregation window for batching up alert notifications.")
    ("alert_option" "alert_option - (Optional) There is one alert_option per severity, where severity can be any number between 1 (high) and 5 (low).  If configured, the alerting system will remind or escalate alerts to further contact groups if an alert sent to this contact group is not acknowledged or resolved.  See below for details.")
    ("email" "email - (Optional) Zero or more email attributes may be present to dispatch email to Circonus users by referencing their user ID, or by specifying an email address.  See below for details on supported attributes.")
    ("http" "http - (Optional) Zero or more http attributes may be present to dispatch Webhook/HTTP requests by Circonus.  See below for details on supported attributes.")
    ("irc" "irc - (Optional) Zero or more irc attributes may be present to dispatch IRC notifications to users.  See below for details on supported attributes.")
    ("long_message" "long_message - (Optional) The bulk of the message used in long form alert messages.")
    ("long_subject" "long_subject - (Optional) The subject used in long form alert messages.")
    ("long_summary" "long_summary - (Optional) The brief summary used in long form alert messages.")
    ("name" "name - (Required) The name of the contact group.")
    ("pager_duty" "pager_duty - (Optional) Zero or more pager_duty attributes may be present to dispatch to Pager Duty teams. See below for details on supported attributes.")
    ("short_message" "short_message - (Optional) The subject used in short form alert messages.")
    ("short_summary" "short_summary - (Optional) The brief summary used in short form alert messages.")
    ("slack" "slack - (Optional) Zero or more slack attributes may be present to dispatch to Slack teams.  See below for details on supported attributes.")
    ("sms" "sms - (Optional) Zero or more sms attributes may be present to dispatch SMS messages to Circonus users by referencing their user ID, or by specifying an SMS Phone Number.  See below for details on supported attributes.")
    ("tags" "tags - (Optional) A list of tags attached to the Contact Group.")
    ("victorops" "victorops - (Optional) Zero or more victorops attributes may be present to dispatch to VictorOps teams. See below for details on supported attributes.")

  ) company-terraform-resource-arguments-hash)

(puthash "circonus_graph" '(
    ("description" "description - (Optional) Description of what the graph is for.")
    ("graph_style" "graph_style - (Optional) How the graph should be rendered.  Valid options are area or line (default).")
    ("left" "left - (Optional) A map of graph left axis options.  Valid values in left include: logarithmic can be set to 0 (default) or 1; min is the min Y axis value on the left; and max is the Y axis max value on the left.")
    ("line_style" "line_style - (Optional) How the line should change between points.  Can be either stepped (default) or interpolated.")
    ("name" "name - (Required) The title of the graph.")
    ("notes" "notes - (Optional) A place for storing notes about this graph.")
    ("right" "right - (Optional) A map of graph right axis options.  Valid values in right include: logarithmic can be set to 0 (default) or 1; min is the min Y axis value on the right; and max is the Y axis max value on the right.")
    ("metric" "metric - (Optional) A list of metric streams to graph.  See below for options.")
    ("metric_cluster" "metric_cluster - (Optional) A metric cluster to graph.  See below for options.")
    ("tags" "tags - (Optional) A list of tags assigned to this graph.")

  ) company-terraform-resource-arguments-hash)

(puthash "circonus_metric" '(
    ("active" "active - (Optional) A boolean indicating if the metric is being filtered out at the circonus_check's collector(s) or not.")
    ("name" "name - (Required) The name of the metric.  A name must be unique within a circonus_check and its meaning is circonus_check.type specific.")
    ("tags" "tags - (Optional) A list of tags assigned to the metric.")
    ("type" "type - (Required) The type of metric.  This value must be present and can be one of the following values: numeric, text, histogram, composite, or caql.")
    ("unit" "unit - (Optional) The unit of measurement for this circonus_metric.")

  ) company-terraform-resource-arguments-hash)

(puthash "circonus_metric_cluster" '(
    ("description" "description - (Optional) A long-form description of the metric cluster.")
    ("name" "name - (Required) The name of the metric cluster.  This name must be unique across all metric clusters in a given Circonus Account.")
    ("query" "query - (Required) One or more query attributes must be present.  Each query must contain both a definition and a type.  See below for details on supported attributes.")
    ("tags" "tags - (Optional) A list of tags attached to the metric cluster.")

  ) company-terraform-resource-arguments-hash)

(puthash "circonus_rule_set" '(
    ("check" "check - (Required) The Circonus ID that this Rule Set will use to search for a metric stream to alert on.")
    ("if" "if - (Required) One or more ordered predicate clauses that describe when Circonus should generate a notification.  See below for details on the structure of an if configuration clause.")
    ("link" "link - (Optional) A link to external documentation (or anything else you feel is important) when a notification is sent.  This value will show up in email alerts and the Circonus UI.")
    ("metric_type" "metric_type - (Optional) The type of metric this rule set will operate on. Valid values are numeric (the default) and text.")
    ("notes" "notes - (Optional) Notes about this rule set.")
    ("parent" "parent - (Optional) A Circonus Metric ID that, if specified and active with a severity 1 alert, will silence this rule set until all of the severity 1 alerts on the parent clear.  This value must match the format ${check_id}_${metric_name}.")
    ("metric_name" "metric_name - (Required) The name of the metric stream within a given check that this rule set is active on.")
    ("tags" "tags - (Optional) A list of tags assigned to this rule set.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_load_balancer" '(
    ("zone" "zone - (Required) The zone to add the load balancer to.")
    ("name" "name - (Required) The DNS name to associate with the load balancer.")
    ("fallback_pool_id" "fallback_pool_id - (Required) The pool ID to use when all other pools are detected as unhealthy.")
    ("default_pool_ids" "default_pool_ids - (Required) A list of pool IDs ordered by their failover priority. Used whenever region/pop pools are not defined.")
    ("description" "description - (Optional) Free text description.")
    ("ttl" "ttl - (Optional) Time to live (TTL) of this load balancer's DNS name. Conflicts with proxied - this cannot be set for proxied load balancers. Default is 30.")
    ("proxied" "proxied - (Optional) Whether the hostname gets Cloudflare's origin protection. Defaults to false.")
    ("region_pools" "region_pools - (Optional) A set containing mappings of region/country codes to a list of pool IDs (ordered by their failover priority) for the given region. Fields documented below.")
    ("pop_pools" "pop_pools - (Optional) A set containing mappings of Cloudflare Point-of-Presence (PoP) identifiers to a list of pool IDs (ordered by their failover priority) for the PoP (datacenter). This feature is only available to enterprise customers. Fields documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_load_balancer_pool" '(
    ("name" "name - (Required) A short name (tag) for the pool. Only alphanumeric characters, hyphens and underscores are allowed.")
    ("origins" "origins - (Required) The list of origins within this pool. Traffic directed at this pool is balanced across all currently healthy origins, provided the pool itself is healthy. Fields documented below")
    ("check_regions" "check_regions - (Optional) A list of regions from which to run health checks. Empty means every Cloudflare datacenter (the default).")
    ("description" "description - (Optional) Free text description.")
    ("enabled" "enabled - (Optional) Whether to enable (the default) this pool. Disabled pools will not receive traffic and are excluded from health checks. Disabling a pool will cause any load balancers using it to failover to the next pool (if any).")
    ("minimum_origins" "minimum_origins - (Optional) The minimum number of origins that must be healthy for this pool to serve traffic. If the number of healthy origins falls below this number, the pool will be marked unhealthy and we wil failover to the next available pool. Default: 1.")
    ("monitor" "monitor - (Optional) The ID of the Monitor to use for health checking origins within this pool.")
    ("notification_email" "notification_email - (Optional) The email address to send health status notifications to. This can be an individual mailbox or a mailing list.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_page_rule" '(
    ("zone" "zone - (Required) The zone to which the page rule should be added.")
    ("target" "target - (Required) The URL pattern to target with the page rule.")
    ("actions" "actions - (Required) The actions taken by the page rule, options given below.")
    ("priority" "priority - (Optional) The priority of the page rule among others for this target.")
    ("status" "status - (Optional) Whether the page rule is active or paused.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_rate_limit" '(
    ("zone" "zone - (Required) The DNS zone to apply rate limiting to.")
    ("threshold" "threshold - (Required) The threshold that triggers the rate limit mitigations, combine with period. i.e. threshold per period (min: 2, max: 1,000,000).")
    ("period" "period - (Required) The time in seconds to count matching traffic. If the count exceeds threshold within this period the action will be performed (min: 1, max: 86,400).")
    ("action" "action - (Required) The action to be performed when the threshold of matched traffic within the period defined is exceeded.")
    ("match" "match - (Optional) Determines which traffic the rate limit counts towards the threshold. By default matches all traffic in the zone. See definition below.")
    ("disabled" "disabled - (Optional) Whether this ratelimit is currently disabled. Default: false.")
    ("description" "description - (Optional) A note that you can use to describe the reason for a rate limit. This value is sanitized and all tags are removed.")
    ("bypass_url_patterns" "bypass_url_patterns - (Optional) URLs matching the patterns specified here will be excluded from rate limiting.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_record" '(
    ("domain" "domain - (Required) The domain to add the record to")
    ("name" "name - (Required) The name of the record")
    ("type" "type - (Required) The type of the record")
    ("value" "value - (Optional) The (string) value of the record. Either this or data must be specified")
    ("data" "data - (Optional) Map of attributes that constitute the record value. Primarily used for LOC and SRV record types. Either this or value must be specified")
    ("ttl" "ttl - (Optional) The TTL of the record (automatic: '1')")
    ("priority" "priority - (Optional) The priority of the record")
    ("proxied" "proxied - (Optional) Whether the record gets Cloudflare's origin protection; defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_load_balancer_monitor" '(
    ("expected_body" "expected_body - (Required) A case-insensitive sub-string to look for in the response body. If this string is not found, the origin will be marked as unhealthy.")
    ("expected_codes" "expected_codes - (Required) The expected HTTP response code or code range of the health check. Eg 2xx")
    ("method" "method - (Optional) The HTTP method to use for the health check. Default: \"GET\".")
    ("timeout" "timeout - (Optional) The timeout (in seconds) before marking the health check as failed. Default: 5.")
    ("path" "path - (Optional) The endpoint path to health check against. Default: \"/\".")
    ("interval" "interval - (Optional) The interval between each health check. Shorter intervals may improve failover time, but will increase load on the origins as we check from multiple locations. Default: 60.")
    ("retries" "retries - (Optional) The number of retries to attempt in case of a timeout before marking the origin as unhealthy. Retries are attempted immediately. Default: 2.")
    ("header" "header - (Optional) The HTTP request headers to send in the health check. It is recommended you set a Host header by default. The User-Agent header cannot be overridden. Fields documented below.")
    ("type" "type - (Optional) The protocol to use for the healthcheck. Currently supported protocols are 'HTTP' and 'HTTPS'. Default: \"http\".")
    ("description" "description - (Optional) Free text description.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudflare_zone_settings_override" '(
    ("name" "name - (Required) The name of the DNS zone to apply rate limiting to.")
    ("settings" "settings - (Optional) Settings overrides that will be applied to the zone. If a setting is not specified the existing setting will be used. For a full list of available settings see below.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudscale_server" '(
    ("name" "name - (Required) Name of the new server. The name has to be a valid host name or a fully qualified domain name (FQDN).")
    ("flavor_slug" "flavor_slug - (Required) The slug (name) of the flavor to use for the new server. Possible values can be found in our API documentation.")
    ("image_slug" "image_slug - (Required) The slug (name) of the image to use for the new server. Possible values can be found in our API documentation.")
    ("ssh_keys" "ssh_keys - (Required) A list of SSH public keys. Use the full content of your *.pub file here.")
    ("volume_size_gb" "volume_size_gb - (Optional) The size in GB of the SSD root volume of the new server. If this parameter is not specified, the value will be set to 10. Valid values are either 10 or multiples of 50.")
    ("bulk_volume_size_gb" "bulk_volume_size_gb - (Optional) The size in GB of the bulk storage volume of the new server. If this parameter is not specified, no bulk storage volume will be attached to the server. Valid values are multiples of 100.")
    ("use_public_network" "use_public_network - (Optional) Attach/detach the public network interface to/from the new server. Can be true (default) or false.")
    ("use_private_network" "use_private_network - (Optional) Attach/detach the private network interface to/from the new server. Can be true or false (default).")
    ("use_ipv6" "use_ipv6 - (Optional) Enable/disable IPv6 on the public network interface of the new server. Can be true (default) or false.")
    ("anti_affinity_uuid" "anti_affinity_uuid - (Optional) Pass the UUID of another server to either create a new anti-affinity group with that server or add the new server to the same (existing) group as the other server.")
    ("user_data" "user_data - (Optional) User data (custom cloud-config settings) to use for the new server. Needs to be valid YAML. A default configuration will be used if this parameter is not specified or set to null. Use only if you are an advanced user with knowledge of cloud-config and cloud-init.")
    ("status" "status - (Optional) The desired state of a server. Can be running (default) or stopped.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudscale_floating_ip" '(
    ("server" "server - (Required) Assign the Floating IP to this server (UUID).")
    ("ip_version" "ip_version - (Required) 4 or 6, for an IPv4 or IPv6 address or network respectively.")
    ("prefix_length" "prefix_length - (Optional) If you want to assign an entire network instead of a single IP address to your server, you must specify the prefix length. Currently, there is only support for ip_version=6 and prefix_length=56.")
    ("reverse_ptr" "reverse_ptr - (Optional) You can specify the PTR record (reverse DNS pointer) in case of a single Floating IP address.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_affinity_group" '(
    ("name" "name - (Required) The name of the affinity group. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) The description of the affinity group.")
    ("type" "type - (Required) The affinity group type. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to register this affinity group to. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_disk" '(
    ("name" "name - (Required) The name of the disk volume. Changing this forces a new resource to be created.")
    ("attach" "attach - (Optional) Determines whether or not to attach the disk volume to a virtual machine (defaults false).")
    ("device_id" "device_id - (Optional) The device ID to map the disk volume to within the guest OS.")
    ("disk_offering" "disk_offering - (Required) The name or ID of the disk offering to use for this disk volume.")
    ("size" "size - (Optional) The size of the disk volume in gigabytes.")
    ("shrink_ok" "shrink_ok - (Optional) Verifies if the disk volume is allowed to shrink when resizing (defaults false).")
    ("virtual_machine_id" "virtual_machine_id - (Optional) The ID of the virtual machine to which you want to attach the disk volume.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The name or ID of the zone where this disk volume will be available. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_egress_firewall" '(
    ("network_id" "network_id - (Required) The network ID for which to create the egress firewall rules. Changing this forces a new resource to be created.")
    ("managed" "managed - (Optional) USE WITH CAUTION! If enabled all the egress firewall rules for this network will be managed by this resource. This means it will delete all firewall rules that are not in your config! (defaults false)")
    ("rule" "rule - (Optional) Can be specified multiple times. Each rule block supports fields documented below. If managed = false at least one rule is required!")
    ("parallelism" "parallelism (Optional) Specifies how much rules will be created or deleted concurrently. (defaults 2)")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_firewall" '(
    ("ip_address_id" "ip_address_id - (Required) The IP address ID for which to create the firewall rules. Changing this forces a new resource to be created.")
    ("managed" "managed - (Optional) USE WITH CAUTION! If enabled all the firewall rules for this IP address will be managed by this resource. This means it will delete all firewall rules that are not in your config! (defaults false)")
    ("rule" "rule - (Optional) Can be specified multiple times. Each rule block supports fields documented below. If managed = false at least one rule is required!")
    ("parallelism" "parallelism (Optional) Specifies how much rules will be created or deleted concurrently. (defaults 2)")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_instance" '(
    ("name" "name - (Required) The name of the instance.")
    ("display_name" "display_name - (Optional) The display name of the instance.")
    ("service_offering" "service_offering - (Required) The name or ID of the service offering used for this instance.")
    ("network_id" "network_id - (Optional) The ID of the network to connect this instance to. Changing this forces a new resource to be created.")
    ("ip_address" "ip_address - (Optional) The IP address to assign to this instance. Changing this forces a new resource to be created.")
    ("template" "template - (Required) The name or ID of the template used for this instance. Changing this forces a new resource to be created.")
    ("root_disk_size" "root_disk_size - (Optional) The size of the root disk in gigabytes. The root disk is resized on deploy. Only applies to template-based deployments. Changing this forces a new resource to be created.")
    ("group" "group - (Optional) The group name of the instance.")
    ("affinity_group_ids" "affinity_group_ids - (Optional) List of affinity group IDs to apply to this instance.")
    ("affinity_group_names" "affinity_group_names - (Optional) List of affinity group names to apply to this instance.")
    ("security_group_ids" "security_group_ids - (Optional) List of security group IDs to apply to this instance. Changing this forces a new resource to be created.")
    ("security_group_names" "security_group_names - (Optional) List of security group names to apply to this instance. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The name or ID of the zone where this instance will be created. Changing this forces a new resource to be created.")
    ("user_data" "user_data - (Optional) The user data to provide when launching the instance.")
    ("keypair" "keypair - (Optional) The name of the SSH key pair that will be used to access this instance.")
    ("expunge" "expunge - (Optional) This determines if the instance is expunged when it is destroyed (defaults false)")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_ipaddress" '(
    ("is_portable" "is_portable - (Optional) This determines if the IP address should be transferable across zones (defaults false)")
    ("network_id" "network_id - (Optional) The ID of the network for which an IP address should be acquired and associated. Changing this forces a new resource to be created.")
    ("vpc_id" "vpc_id - (Optional) The ID of the VPC for which an IP address should be acquired and associated. Changing this forces a new resource to be created.")
    ("zone" "zone - (Optional) The name or ID of the zone for which an IP address should be acquired and associated. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_loadbalancer_rule" '(
    ("name" "name - (Required) Name of the loadbalancer rule. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) The description of the load balancer rule.")
    ("ip_address_id" "ip_address_id - (Required) Public IP address ID from where the network traffic will be load balanced from. Changing this forces a new resource to be created.")
    ("network_id" "network_id - (Optional) The network ID this rule will be created for. Required when public IP address is not associated with any network yet (VPC case).")
    ("algorithm" "algorithm - (Required) Load balancer rule algorithm (source, roundrobin, leastconn). Changing this forces a new resource to be created.")
    ("private_port" "private_port - (Required) The private port of the private IP address (virtual machine) where the network traffic will be load balanced to. Changing this forces a new resource to be created.")
    ("public_port" "public_port - (Required) The public port from where the network traffic will be load balanced from. Changing this forces a new resource to be created.")
    ("protocol" "protocol - (Optional) Load balancer protocol (tcp, udp, tcp-proxy). Changing this forces a new resource to be created.")
    ("member_ids" "member_ids - (Required) List of instance IDs to assign to the load balancer rule. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_network" '(
    ("name" "name - (Required) The name of the network.")
    ("display_text" "display_text - (Optional) The display text of the network.")
    ("cidr" "cidr - (Required) The CIDR block for the network. Changing this forces a new resource to be created.")
    ("gateway" "gateway - (Optional) Gateway that will be provided to the instances in this network. Defaults to the first usable IP in the range.")
    ("startip" "startip - (Optional) Start of the IP block that will be available on the network. Defaults to the second available IP in the range.")
    ("endip" "endip - (Optional) End of the IP block that will be available on the network. Defaults to the last available IP in the range.")
    ("network_domain" "network_domain - (Optional) DNS domain for the network.")
    ("network_offering" "network_offering - (Required) The name or ID of the network offering to use for this network.")
    ("vlan" "vlan - (Optional) The VLAN number (1-4095) the network will use. This might be required by the Network Offering if specifyVlan=true is set. Only the ROOT admin can set this value.")
    ("vpc_id" "vpc_id - (Optional) The VPC ID in which to create this network. Changing this forces a new resource to be created.")
    ("acl_id" "acl_id - (Optional) The ACL ID that should be attached to the network or none if you do not want to attach an ACL. You can dynamically attach and swap ACL's, but if you want to detach an attached ACL and revert to using none, this will force a new resource to be created. (defaults none)")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The name or ID of the zone where this network will be available. Changing this forces a new resource to be created.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_network_acl" '(
    ("name" "name - (Required) The name of the ACL. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) The description of the ACL. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")
    ("vpc_id" "vpc_id - (Required) The ID of the VPC to create this ACL for. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_network_acl_rule" '(
    ("acl_id" "acl_id - (Required) The network ACL ID for which to create the rules. Changing this forces a new resource to be created.")
    ("managed" "managed - (Optional) USE WITH CAUTION! If enabled all the firewall rules for this network ACL will be managed by this resource. This means it will delete all firewall rules that are not in your config! (defaults false)")
    ("rule" "rule - (Optional) Can be specified multiple times. Each rule block supports fields documented below. If managed = false at least one rule is required!")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")
    ("parallelism" "parallelism (Optional) Specifies how much rules will be created or deleted concurrently. (defaults 2)")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_nic" '(
    ("network_id" "network_id - (Required) The ID of the network to plug the NIC into. Changing this forces a new resource to be created.")
    ("ip_address" "ip_address - (Optional) The IP address to assign to the NIC. Changing this forces a new resource to be created.")
    ("virtual_machine_id" "virtual_machine_id - (Required) The ID of the virtual machine to which to attach the NIC. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_port_forward" '(
    ("ip_address_id" "ip_address_id - (Required) The IP address ID for which to create the port forwards. Changing this forces a new resource to be created.")
    ("managed" "managed - (Optional) USE WITH CAUTION! If enabled all the port forwards for this IP address will be managed by this resource. This means it will delete all port forwards that are not in your config! (defaults false)")
    ("project" "project - (Optional) The name or ID of the project to create this port forward in. Changing this forces a new resource to be created.")
    ("forward" "forward - (Required) Can be specified multiple times. Each forward block supports fields documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_private_gateway" '(
    ("gateway" "gateway - (Required) the gateway of the Private gateway. Changing this forces a new resource to be created.")
    ("ip_address" "ip_address - (Required) the IP address of the Private gateway. Changing this forces a new resource to be created.")
    ("netmask" "netmask - (Required) The netmask of the Private gateway. Changing this forces a new resource to be created.")
    ("vlan" "vlan - (Required) The VLAN number (1-4095) the network will use.")
    ("physical_network_id" "physical_network_id - (Optional) The ID of the physical network this private gateway belongs to.")
    ("network_offering" "network_offering - (Optional) The name or ID of the network offering to use for the private gateways network connection.")
    ("acl_id" "acl_id - (Required) The ACL ID that should be attached to the network.")
    ("vpc_id" "vpc_id - (Required) The VPC ID in which to create this Private gateway. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_secondary_ipaddress" '(
    ("ip_address" "ip_address - (Optional) The IP address to bind the to NIC. If not supplied an IP address will be selected randomly. Changing this forces a new resource to be   created.")
    ("nic_id" "nic_id - (Optional) The NIC ID to which you want to attach the secondary IP address. Changing this forces a new resource to be created (defaults to the ID of the primary NIC)")
    ("virtual_machine_id" "virtual_machine_id - (Required) The ID of the virtual machine to which you want to attach the secondary IP address. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_security_group" '(
    ("name" "name - (Required) The name of the security group. Changing this forces a new resource to be created.")
    ("description" "description - (Optional) The description of the security group. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to create this security group in. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_security_group_rule" '(
    ("security_group_id" "security_group_id - (Required) The security group ID for which to create the rules. Changing this forces a new resource to be created.")
    ("rule" "rule - (Required) Can be specified multiple times. Each rule block supports fields documented below.")
    ("project" "project - (Optional) The name or ID of the project in which the security group is created. Changing this forces a new resource to be created.")
    ("parallelism" "parallelism (Optional) Specifies how much rules will be created or deleted concurrently. (defaults 2)")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_ssh_keypair" '(
    ("name" "name - (Required) The name of the SSH key pair. This is a unique value within a CloudStack account. Changing this forces a new resource to be created.")
    ("public_key" "public_key - (Optional) The public key to register with CloudStack. If this is omitted, CloudStack will generate a new key pair. The key can be loaded from a file on disk using the file() interpolation function. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to register this key to. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_static_nat" '(
    ("ip_address_id" "ip_address_id - (Required) The public IP address ID for which static NAT will be enabled. Changing this forces a new resource to be created.")
    ("virtual_machine_id" "virtual_machine_id - (Required) The virtual machine ID to enable the static NAT feature for. Changing this forces a new resource to be created.")
    ("vm_guest_ip" "vm_guest_ip - (Optional) The virtual machine IP address to forward the static NAT traffic to (useful when the virtual machine has secondary NICs or IP addresses). Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_static_route" '(
    ("cidr" "cidr - (Required) The CIDR for the static route. Changing this forces a new resource to be created.")
    ("gateway_id" "gateway_id - (Required) The ID of the Private gateway. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_template" '(
    ("name" "name - (Required) The name of the template.")
    ("display_text" "display_text - (Optional) The display name of the template.")
    ("format" "format - (Required) The format of the template. Valid values are QCOW2, RAW, and VHD.")
    ("hypervisor" "hypervisor - (Required) The target hypervisor for the template. Changing this forces a new resource to be created.")
    ("os_type" "os_type - (Required) The OS Type that best represents the OS of this template.")
    ("url" "url - (Required) The URL of where the template is hosted. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to create this template for. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The name or ID of the zone where this template will be created. Changing this forces a new resource to be created.")
    ("is_dynamically_scalable" "is_dynamically_scalable - (Optional) Set to indicate if the template contains tools to support dynamic scaling of VM cpu/memory (defaults false)")
    ("is_extractable" "is_extractable - (Optional) Set to indicate if the template is extractable (defaults false)")
    ("is_featured" "is_featured - (Optional) Set to indicate if the template is featured (defaults false)")
    ("is_public" "is_public - (Optional) Set to indicate if the template is available for all accounts (defaults true)")
    ("password_enabled" "password_enabled - (Optional) Set to indicate if the template should be password enabled (defaults false)")
    ("is_ready_timeout" "is_ready_timeout - (Optional) The maximum time in seconds to wait until the template is ready for use (defaults 300 seconds)")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_vpc" '(
    ("name" "name - (Required) The name of the VPC.")
    ("display_text" "display_text - (Optional) The display text of the VPC.")
    ("cidr" "cidr - (Required) The CIDR block for the VPC. Changing this forces a new resource to be created.")
    ("vpc_offering" "vpc_offering - (Required) The name or ID of the VPC offering to use for this VPC. Changing this forces a new resource to be created.")
    ("network_domain" "network_domain - (Optional) The default DNS domain for networks created in this VPC. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The name or ID of the project to deploy this instance to. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The name or ID of the zone where this disk volume will be available. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_vpn_gateway" '(
    ("vpc_id" "vpc_id - (Required) The ID of the VPC for which to create the VPN Gateway. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_vpn_customer_gateway" '(
    ("name" "name - (Required) The name of the VPN Customer Gateway.")
    ("cidr" "cidr - (Required) The CIDR block that needs to be routed through this gateway.")
    ("esp_policy" "esp_policy - (Required) The ESP policy to use for this VPN Customer Gateway.")
    ("gateway" "gateway - (Required) The public IP address of the related VPN Gateway.")
    ("ike_policy" "ike_policy - (Required) The IKE policy to use for this VPN Customer Gateway.")
    ("ipsec_psk" "ipsec_psk - (Required) The IPSEC pre-shared key used for this gateway.")
    ("dpd" "dpd - (Optional) If DPD is enabled for the related VPN connection (defaults false)")
    ("esp_lifetime" "esp_lifetime - (Optional) The ESP lifetime of phase 2 VPN connection to this VPN Customer Gateway in seconds (defaults 86400)")
    ("ike_lifetime" "ike_lifetime - (Optional) The IKE lifetime of phase 2 VPN connection to this VPN Customer Gateway in seconds (defaults 86400)")
    ("project" "project - (Optional) The name or ID of the project to create this VPN Customer Gateway in. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cloudstack_vpn_connection" '(
    ("customer_gateway_id" "customer_gateway_id - (Required) The Customer Gateway ID to connect. Changing this forces a new resource to be created.")
    ("vpn_gateway_id" "vpn_gateway_id - (Required) The VPN Gateway ID to connect. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "cobbler_distro" '(
    ("arch" "arch - (Required) The architecture of the distro. Valid options are: i386, x86_64, ia64, ppc, ppc64, s390, arm.")
    ("breed" "breed - (Required) The \"breed\" of distribution. Valid options are: redhat, fedora, centos, scientific linux, suse, debian, and ubuntu. These choices may vary depending on the version of Cobbler in use.")
    ("boot_files" "boot_files - (Optional) Files copied into tftpboot beyond the kernel/initrd.")
    ("comment" "comment - (Optional) Free form text description.")
    ("fetchable_files" "fetchable_files - (Optional) Templates for tftp or wget.")
    ("kernel" "kernel - (Required) Absolute path to kernel on filesystem. This must already exist prior to creating the distro.")
    ("kernel_options" "kernel_options - (Optional) Kernel options to use with the kernel.")
    ("kernel_options_post" "kernel_options_post - (Optional) Post install Kernel options to use with the kernel after installation.")
    ("initrd" "initrd - (Required) Absolute path to initrd on filesystem. This must already exist prior to creating the distro.")
    ("mgmt_classes" "mgmt_classes - (Optional) Management classes for external config management.")
    ("name" "name - (Required) A name for the distro.")
    ("os_version" "os_version - (Required) The version of the distro you are creating. This varies with the version of Cobbler you are using. An updated signature list may need to be obtained in order to support a newer version. Example: trusty.")
    ("owners" "owners - (Optional) Owners list for authz_ownership.")
    ("redhat_management_key" "redhat_management_key - (Optional) Red Hat Management key.")
    ("redhat_management_server" "redhat_management_server - (Optional) Red Hat Management server.")
    ("template_files" "template_files - (Optional) File mappings for built-in config management.")

  ) company-terraform-resource-arguments-hash)

(puthash "cobbler_kickstart_file" '(
    ("body" "body - (Required) The body of the kickstart file.")
    ("name" "name - (Required) The name of the kickstart file. This must be the full path, including /var/lib/cobbler/kickstarts.")

  ) company-terraform-resource-arguments-hash)

(puthash "cobbler_repo" '(
    ("apt_components" "apt_components - (Optional) List of Apt components such as main, restricted, universe. Applicable to apt breeds only.")
    ("apt_dists" "apt_dists - (Optional) List of Apt distribution names such as trusty, trusty-updates. Applicable to apt breeds only.")
    ("arch" "arch - (Optional) The architecture of the repo. Valid options are: i386, x86_64, ia64, ppc, ppc64, s390, arm.")
    ("breed" "breed - (Required) The \"breed\" of distribution. Valid options are: rsync, rhn, yum, apt, and wget. These choices may vary depending on the version of Cobbler in use.")
    ("comment" "comment - (Optional) Free form text description.")
    ("createrepo_flags" "createrepo_flags - (Optional) Flags to use with createrepo.")
    ("environment" "environment - (Optional) Environment variables to use during repo command execution.")
    ("keep_updated" "keep_updated - (Optional) Update the repo upon Cobbler sync. Valid values are true or false.")
    ("mirror" "mirror - (Required) Address of the repo to mirror.")
    ("mirror_locally" "mirror_locally - (Required) Whether to copy the files locally or just references to the external files. Valid values are true or false.")
    ("name" "name - (Required) A name for the repo.")
    ("owners" "owners - (Optional) List of Owners for authz_ownership.")
    ("proxy" "proxy - (Optional) Proxy to use for downloading the repo. This argument does not work on older versions of Cobbler.")
    ("rpm_list" "rpm_list - (Optional) List of specific RPMs to mirror.")

  ) company-terraform-resource-arguments-hash)

(puthash "cobbler_profile" '(
    ("boot_files" "boot_files - (Optional) Files copied into tftpboot beyond the kernel/initrd.")
    ("comment" "comment - (Optional) Free form text description.")
    ("parent" "parent - (Optional) The parent this profile inherits settings from.")
    ("server" "server - (Optional) The server-override for the profile.")
    ("distro" "distro - (Optional) Parent distribution.")
    ("enable_gpxe" "enable_gpxe - (Optional) Use gPXE instead of PXELINUX for advanced booting options.")
    ("enable_menu" "enable_menu - (Optional) Enable a boot menu.")
    ("fetchable_files" "fetchable_files - (Optional) Templates for tftp or wget.")
    ("kernel_options" "kernel_options - (Optional) Kernel options for the profile.")
    ("kernel_options_post" "kernel_options_post - (Optional) Post install kernel options.")
    ("kickstart" "kickstart - (Optional) The kickstart file to use.")
    ("ks_meta" "ks_meta - (Optional) Kickstart metadata.")
    ("mgmt_classes" "mgmt_classes - (Optional) For external configuration management.")
    ("mgmt_parameters" "mgmt_parameters - (Optional) Parameters which will be handed to your management application (Must be a valid YAML dictionary).")
    ("name_servers_search" "name_servers_search - (Optional) Name server search settings.")
    ("name_servers" "name_servers - (Optional) Name servers.")
    ("name" "name - (Required) The name of the profile.")
    ("owners" "owners - (Optional) Owners list for authz_ownership.")
    ("proxy" "proxy - (Optional) Proxy URL.")
    ("redhat_management_key" "redhat_management_key - (Optional) Red Hat Management Key.")
    ("redhat_management_server" "redhat_management_server - (Optional) RedHat Management Server.")
    ("repos" "repos - (Optional) Repos to auto-assign to this profile.")
    ("template_files" "template_files - (Optional) File mappings for built-in config management.")
    ("template_remote_kickstarts" "template_remote_kickstarts - (Optional) remote kickstart templates.")
    ("virt_auto_boot" "virt_auto_boot - (Optional) Auto boot virtual machines.")
    ("virt_bridge" "virt_bridge - (Optional) The bridge for virtual machines.")
    ("virt_cpus" "virt_cpus - (Optional) The number of virtual CPUs.")
    ("virt_file_size" "virt_file_size - (Optional) The virtual machine file size.")
    ("virt_path" "virt_path - (Optional) The virtual machine path.")
    ("virt_ram" "virt_ram - (Optional) The amount of RAM for the virtual machine.")
    ("virt_type" "virt_type - (Optional) The type of virtual machine. Valid options are: xenpv, xenfv, qemu, kvm, vmware, openvz.")
    ("virt_disk_driver" "virt_disk_driver - (Optional) The virtual machine disk driver.")

  ) company-terraform-resource-arguments-hash)

(puthash "cobbler_snippet" '(
    ("body" "body - (Required) The body of the snippet.")
    ("name" "name - (Required) The name of the snippet. This must be the full path, including /var/lib/cobbler/snippets.")

  ) company-terraform-resource-arguments-hash)

(puthash "cobbler_system" '(
    ("boot_files" "boot_files - (Optional) TFTP boot files copied into tftpboot.")
    ("comment" "comment - (Optional) Free form text description")
    ("enable_gpxe" "enable_gpxe - (Optional) Use gPXE instead of PXELINUX.")
    ("fetchable_files" "fetchable_files - (Optional) Templates for tftp or wget.")
    ("gateway" "gateway - (Optional) Network gateway.")
    ("hostname" "hostname - (Optional) Hostname of the system.")
    ("image" "image - (Optional) Parent image (if no profile is used).")
    ("interface" "interface - (Optional)")
    ("ipv6_default_device" "ipv6_default_device - (Optional) IPv6 default device.")
    ("kernel_options" "kernel_options - (Optional) Kernel options. ex: selinux=permissive.")
    ("kernel_options_post" "kernel_options_post - (Optional) Kernel options (post install).")
    ("kickstart" "kickstart - (Optional) Path to kickstart template.")
    ("ks_meta" "ks_meta - (Optional) Kickstart metadata.")
    ("ldap_enabled" "ldap_enabled - (Optional) Configure LDAP at next config update.")
    ("ldap_type" "ldap_type - (Optional) LDAP management type.")
    ("mgmt_classes" "mgmt_classes - (Optional) Management classes for external config management.")
    ("mgmt_parameters" "mgmt_parameters - (Optional) Parameters which will be handed to your management application. Must be a valid YAML dictionary.")
    ("monit_enabled" "monit_enabled - (Optional) Configure monit on this machine at next config update.")
    ("name_servers_search" "name_servers_search - (Optional) Name servers search path.")
    ("name_servers" "name_servers - (Optional) Name servers.")
    ("name" "name - (Required) The name of the system.")
    ("netboot_enabled" "netboot_enabled - (Optional) (re)Install this machine at next boot.")
    ("owners" "owners - (Optional) Owners list for authz_ownership.")
    ("power_address" "power_address - (Optional) Power management address.")
    ("power_id" "power_id - (Optional) Usually a plug number or blade name if power type requires it.")
    ("power_pass" "power_pass - (Optional) Power management password.")
    ("power_type" "power_type - (Optional) Power management type.")
    ("power_user" "power_user - (Optional) Power management user.")
    ("profile" "profile - (Required) Parent profile.")
    ("proxy" "proxy - (Optional) Proxy URL.")
    ("redhat_management_key" "redhat_management_key - (Optional) Red Hat management key.")
    ("redhat_management_server" "redhat_management_server - (Optional) Red Hat management server.")
    ("status" "status - (Optional) System status (development, testing, acceptance, production).")
    ("template_files" "template_files - (Optional) File mappings for built-in configuration management.")
    ("template_remote_kickstarts" "template_remote_kickstarts - (Optional) template remote kickstarts.")
    ("virt_auto_boot" "virt_auto_boot - (Optional) Auto boot the VM.")
    ("virt_cpus" "virt_cpus - (Optional) Number of virtual CPUs in the VM.")
    ("virt_disk_driver" "virt_disk_driver - (Optional) The on-disk format for the virtualization disk.")
    ("virt_file_size" "virt_file_size - (Optional) Virt file size.")
    ("virt_path" "virt_path - (Optional) Path to the VM.")
    ("virt_pxe_boot" "virt_pxe_boot - (Optional) Use PXE to build this VM?")
    ("virt_ram" "virt_ram - (Optional) The amount of RAM for the VM.")
    ("virt_type" "virt_type - (Optional) Virtualization technology to use: xenpv, xenfv, qemu, kvm, vmware, openvz.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_agent_service" '(
    ("address" "address - (Optional) The address of the service. Defaults to the address of the agent.")
    ("name" "name - (Required) The name of the service.")
    ("port" "port - (Optional) The port of the service.")
    ("tags" "tags - (Optional) A list of values that are opaque to Consul, but can be used to distinguish between services or nodes.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_catalog_entry" '(
    ("address" "address - (Required) The address of the node being added to, or referenced in the catalog.")
    ("node" "node - (Required) The name of the node being added to, or referenced in the catalog.")
    ("service" "service - (Optional) A service to optionally associated with the node. Supported values are documented below.")
    ("datacenter" "datacenter - (Optional) The datacenter to use. This overrides the datacenter in the provider setup and the agent's default datacenter.")
    ("token" "token - (Optional) ACL token.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_keys" '(
    ("datacenter" "datacenter - (Optional) The datacenter to use. This overrides the datacenter in the provider setup and the agent's default datacenter.")
    ("token" "token - (Optional) The ACL token to use. This overrides the token that the agent provides by default.")
    ("key" "key - (Required) Specifies a key in Consul to be written. Supported values documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_key_prefix" '(
    ("datacenter" "datacenter - (Optional) The datacenter to use. This overrides the datacenter in the provider setup and the agent's default datacenter.")
    ("token" "token - (Optional) The ACL token to use. This overrides the token that the agent provides by default.")
    ("path_prefix" "path_prefix - (Required) Specifies the common prefix shared by all keys that will be managed by this resource instance. In most cases this will end with a slash, to manage a \"folder\" of keys.")
    ("subkeys" "subkeys - (Required) A mapping from subkey name (which will be appended to the given path_prefix) to the value that should be stored at that key. Use slashes, as shown in the above example, to create \"sub-folders\" under the given path prefix.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_node" '(
    ("address" "address - (Required) The address of the node being added to, or referenced in the catalog.")
    ("name" "name - (Required) The name of the node being added to, or referenced in the catalog.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_prepared_query" '(
    ("datacenter" "datacenter - (Optional) The datacenter to use. This overrides the datacenter in the provider setup and the agent's default datacenter.")
    ("token" "token - (Optional) The ACL token to use when saving the prepared query. This overrides the token that the agent provides by default.")
    ("stored_token" "stored_token - (Optional) The ACL token to store with the prepared query. This token will be used by default whenever the query is executed.")
    ("name" "name - (Required) The name of the prepared query. Used to identify the prepared query during requests. Can be specified as an empty string to configure the query as a catch-all.")
    ("service" "service - (Required) The name of the service to query.")
    ("session" "session - (Optional) The name of the Consul session to tie this query's lifetime to.  This is an advanced parameter that should not be used without a complete understanding of Consul sessions and the implications of their use (it is recommended to leave this blank in nearly all cases).  If this parameter is omitted the query will not expire.")
    ("tags" "tags - (Optional) The list of required and/or disallowed tags.  If a tag is in this list it must be present.  If the tag is preceded with a \"!\" then it is disallowed.")
    ("only_passing" "only_passing - (Optional) When true, the prepared query will only return nodes with passing health checks in the result.")
    ("near" "near - (Optional) Allows specifying the name of a node to sort results near using Consul's distance sorting and network coordinates. The magic _agent value can be used to always sort nearest the node servicing the request.")
    ("failover" "failover - (Optional) Options for controlling behavior when no healthy nodes are available in the local DC.  nearest_n - (Optional) Return results from this many datacenters, sorted in ascending order of estimated RTT.  datacenters - (Optional) Remote datacenters to return results from.")
    ("dns" "dns - (Optional) Settings for controlling the DNS response details.  ttl - (Optional) The TTL to send when returning DNS results.")
    ("template" "template - (Optional) Query templating options. This is used to make a single prepared query respond to many different requests.  type - (Required) The type of template matching to perform. Currently only name_prefix_match is supported.  regexp - (Required) The regular expression to match with. When using name_prefix_match, this regex is applied against the query name.")

  ) company-terraform-resource-arguments-hash)

(puthash "consul_service" '(
    ("service_id" "service_id - (Optional, string) The ID of the service, defaults to the value of name if not supplied.")
    ("address" "address - (Optional, string) The address of the service. Defaults to the address of the agent.")
    ("name" "name - (Required, string) The name of the service.")
    ("port" "port - (Optional, int) The port of the service.")
    ("tags" "tags - (Optional, set of strings) A list of values that are opaque to Consul, but can be used to distinguish between services or nodes.")

  ) company-terraform-resource-arguments-hash)

(puthash "datadog_downtime" '(
    ("scope" "scope - (Required) A list of items to apply the downtime to, e.g. host:X")
    ("active" "active - (Optional) A flag indicating if the downtime is active now.")
    ("disabled" "disabled - (Optional) A flag indicating if the downtime was disabled.")
    ("start" "start - (Optional) POSIX timestamp to start the downtime.")
    ("end" "end - (Optional) POSIX timestamp to end the downtime.")
    ("recurrence" "recurrence - (Optional) A dictionary to configure the downtime to be recurring.   type - days, weeks, months, or years  period - How often to repeat as an integer. For example to repeat every 3 days, select a type of days and a period of 3.  week_days - (Optional) A list of week days to repeat on. Choose from: Mon, Tue, Wed, Thu, Fri, Sat or Sun. Only applicable when type is weeks. First letter must be capitalized.  until_occurrences - (Optional) How many times the downtime will be rescheduled. until_occurrences and until_date are mutually exclusive.  until_date - (Optional) The date at which the recurrence should end as a POSIX timestamp. until_occurrences and until_date are mutually exclusive.")
    ("message" "message - (Optional) A message to include with notifications for this downtime.")
    ("monitor_id" "monitor_id - (Optional) Reference to which monitor this downtime is applied. When scheduling downtime for a given monitor, datadog changes silenced property of the monitor  to match the end POSIX timestamp.")

  ) company-terraform-resource-arguments-hash)

(puthash "datadog_monitor" '(
    ("type" "type - (Required) The type of the monitor, chosen from:   metric alert  service check  event alert  query alert  composite")
    ("name" "name - (Required) Name of Datadog monitor")
    ("query" "query - (Required) The monitor query to notify on with syntax varying depending on what type of monitor you are creating. See API Reference for options.")
    ("message" "message - (Required) A message to include with notifications for this monitor. Email notifications can be sent to specific users by using the same '@username' notation as events.")
    ("escalation_message" "escalation_message - (Optional) A message to include with a re-notification. Supports the '@username' notification allowed elsewhere.")
    ("thresholds" "thresholds - (Optional)  Metric alerts: A dictionary of thresholds by threshold type. Currently we have four threshold types for metric alerts: critical, critical recovery, warning, and warning recovery. Critical is defined in the query, but can also be specified in this option. Warning and recovery thresholds can only be specified using the thresholds option. Example usage:  thresholds {     critical          = 90     critical_recovery = 85     warning           = 80     warning_recovery  = 75 }   Service checks: A dictionary of thresholds by status. Because service checks can have multiple thresholds, we don't define them directly in the query. Default values:  thresholds {     ok       = 1     critical = 1     warning  = 1 }")
    ("notify_no_data" "notify_no_data (Optional) A boolean indicating whether this monitor will notify when data stops reporting. Defaults to true.")
    ("new_host_delay" "new_host_delay (Optional) Time (in seconds) to allow a host to boot and applications to fully start before starting the evaluation of monitor results. Should be a non negative integer. Defaults to 300.")
    ("evaluation_delay" "evaluation_delay (Optional) Time (in seconds) to delay evaluation, as a non-negative integer. For example, if the value is set to 300 (5min), the timeframe is set to last_5m and the time is 7:00, the monitor will evaluate data from 6:50 to 6:55. This is useful for AWS CloudWatch and other backfilled metrics to ensure the monitor will always have data during evaluation.")
    ("no_data_timeframe" "no_data_timeframe (Optional) The number of minutes before a monitor will notify when data stops reporting. Must be at least 2x the monitor timeframe for metric alerts or 2 minutes for service checks. Default: 2x timeframe for metric alerts, 2 minutes for service checks.")
    ("renotify_interval" "renotify_interval (Optional) The number of minutes after the last notification before a monitor will re-notify on the current status. It will only re-notify if it's not resolved.")
    ("notify_audit" "notify_audit (Optional) A boolean indicating whether tagged users will be notified on changes to this monitor. Defaults to false.")
    ("timeout_h" "timeout_h (Optional) The number of hours of the monitor not reporting data before it will automatically resolve from a triggered state. Defaults to false.")
    ("include_tags" "include_tags (Optional) A boolean indicating whether notifications from this monitor will automatically insert its triggering tags into the title. Defaults to true.")
    ("require_full_window" "require_full_window (Optional) A boolean indicating whether this monitor needs a full window of data before it's evaluated. We highly recommend you set this to False for sparse metrics, otherwise some evaluations will be skipped. Default: True for \"on average\", \"at all times\" and \"in total\" aggregation. False otherwise.")
    ("locked" "locked (Optional) A boolean indicating whether changes to to this monitor should be restricted to the creator or admins. Defaults to False.")
    ("tags" "tags (Optional) A list of tags to associate with your monitor. This can help you categorize and filter monitors in the manage monitors page of the UI. Note: it's not currently possible to filter by these tags when querying via the API")
    ("silenced" "silenced (Optional) Each scope will be muted until the given POSIX timestamp or forever if the value is 0. To mute the alert completely: silenced {   \"*\" =  0 } To mute role:db for a short time: silenced {   \"role:db\" = 1412798116 }")

  ) company-terraform-resource-arguments-hash)

(puthash "datadog_timeboard" '(
    ("title" "title - (Required) The name of the dashboard.")
    ("description" "description - (Required) A description of the dashboard's content.")
    ("read_only" "read_only - (Optional) The read-only status of the timeboard. Default is false.")
    ("graph" "graph - (Required) Nested block describing a graph definition. The structure of this block is described below. Multiple graph blocks are allowed within a datadog_timeboard resource.")
    ("template_variable" "template_variable - (Optional) Nested block describing a template variable. The structure of this block is described below. Multiple template_variable blocks are allowed within a datadog_timeboard resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "datadog_user" '(
    ("disabled" "disabled - (Optional) Whether the user is disabled")
    ("email" "email - (Required) Email address for user")
    ("handle" "handle - (Required) The user handle, must be a valid email.")
    ("is_admin" "is_admin - (Optional) Whether the user is an administrator")
    ("name" "name - (Required) Name for user")
    ("role" "role - (Optional) Role description for user (NOTE: can only be applied on user creation)")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_certificate" '(
    ("name" "name - (Required) The name of the certificate for identification.")
    ("private_key" "private_key - (Required) The contents of a PEM-formatted private-key corresponding to the SSL certificate.")
    ("leaf_certificate" "leaf_certificate - (Required) The contents of a PEM-formatted public TLS certificate.")
    ("certificate_chain" "certificate_chain - (Optional) The full PEM-formatted trust chain between the certificate authority's certificate and your domain's TLS certificate.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_domain" '(
    ("name" "name - (Required) The name of the domain")
    ("ip_address" "ip_address - (Required) The IP address of the domain. This IP is used to created an initial A record for the domain. It is required upstream by the DigitalOcean API.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_droplet" '(
    ("image" "image - (Required) The Droplet image ID or slug.")
    ("name" "name - (Required) The Droplet name")
    ("region" "region - (Required) The region to start in")
    ("size" "size - (Required) The instance size to start")
    ("backups" "backups - (Optional) Boolean controlling if backups are made. Defaults to false.")
    ("monitoring" "monitoring - (Optional) Boolean controlling whether monitoring agent is installed. Defaults to false.")
    ("ipv6" "ipv6 - (Optional) Boolean controlling if IPv6 is enabled. Defaults to false.")
    ("private_networking" "private_networking - (Optional) Boolean controlling if private networks are enabled. Defaults to false.")
    ("ssh_keys" "ssh_keys - (Optional) A list of SSH IDs or fingerprints to enable in the format [12345, 123456]. To retrieve this info, use a tool such as curl with the DigitalOcean API, to retrieve them.")
    ("resize_disk" "resize_disk - (Optional) Boolean controlling whether to increase the disk size when resizing a Droplet. It defaults to true. When set to false, only the Droplet's RAM and CPU will be resized. Increasing a Droplet's disk size is a permanent change. Increasing only RAM and CPU is reversible.")
    ("tags" "tags - (Optional) A list of the tags to label this droplet. A tag resource must exist before it can be associated with a droplet.")
    ("user_data" "user_data (Optional) - A string of the desired User Data for the Droplet.")
    ("volume_ids" "volume_ids (Optional) - A list of the IDs of each block storage volume to be attached to the Droplet.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_firewall" '(
    ("name" "name - (Required) The Firewall name")
    ("droplet_ids" "droplet_ids (Optional) - The list of the IDs of the Droplets assigned to the Firewall.")
    ("tags" "tags (Optional) - The names of the Tags assigned to the Firewall.")
    ("inbound_rule" "inbound_rule - (Optional) The inbound access rule block for the Firewall. The inbound_rule block is documented below.")
    ("outbound_rule" "outbound_rule - (Optional) The outbound access rule block for the Firewall. The outbound_rule block is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_floating_ip" '(
    ("region" "region - (Required) The region that the Floating IP is reserved to.")
    ("droplet_id" "droplet_id - (Optional) The ID of Droplet that the Floating IP will be assigned to.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_loadbalancer" '(
    ("name" "name - (Required) The Load Balancer name")
    ("region" "region - (Required) The region to start in")
    ("algorithm" "algorithm - (Optional) The load balancing algorithm used to determine which backend Droplet will be selected by a client. It must be either round_robin or least_connections. The default value is round_robin.")
    ("forwarding_rule" "forwarding_rule - (Required) A list of forwarding_rule to be assigned to the Load Balancer. The forwarding_rule block is documented below.")
    ("healthcheck" "healthcheck - (Optional) A healthcheck block to be assigned to the Load Balancer. The healthcheck block is documented below. Only 1 healthcheck is allowed.")
    ("sticky_sessions" "sticky_sessions - (Optional) A sticky_sessions block to be assigned to the Load Balancer. The sticky_sessions block is documented below. Only 1 sticky_sessions block is allowed.")
    ("redirect_http_to_https" "redirect_http_to_https - (Optional) A boolean value indicating whether HTTP requests to the Load Balancer on port 80 will be redirected to HTTPS on port 443. Default value is false.")
    ("droplet_ids" "droplet_ids (Optional) - A list of the IDs of each droplet to be attached to the Load Balancer.")
    ("droplet_tag" "droplet_tag (Optional) - The name of a Droplet tag corresponding to Droplets to be assigned to the Load Balancer.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_record" '(
    ("type" "type - (Required) The type of record")
    ("domain" "domain - (Required) The domain to add the record to")
    ("value" "value - (Optional) The value of the record")
    ("name" "name - (Optional) The name of the record")
    ("weight" "weight - (Optional) The weight of the record, for SRV records.")
    ("port" "port - (Optional) The port of the record, for SRV records.")
    ("priority" "priority - (Optional) The priority of the record, for MX and SRV records.")
    ("ttl" "ttl - (Optional) The time to live for the record, in seconds.")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_ssh_key" '(
    ("name" "name - (Required) The name of the SSH key for identification")
    ("public_key" "public_key - (Required) The public key. If this is a file, it can be read using the file interpolation function")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_tag" '(
    ("name" "name - (Required) The name of the tag")

  ) company-terraform-resource-arguments-hash)

(puthash "digitalocean_volume" '(
    ("region" "region - (Required) The region that the block storage volume will be created in.")
    ("name" "name - (Required) A name for the block storage volume. Must be lowercase and be composed only of numbers, letters and \"-\", up to a limit of 64 characters.")
    ("size" "size - (Required) The size of the block storage volume in GiB.")
    ("description" "description - (Optional) A free-form text field up to a limit of 1024 bytes to describe a block storage volume.")
    ("droplet_ids" "droplet_ids - (Computed) A list of associated droplet ids")

  ) company-terraform-resource-arguments-hash)

(puthash "dns_a_record_set" '(
    ("zone" "zone - (Required) DNS zone the record set belongs to. It must be an FQDN, that is, include the trailing dot.")
    ("name" "name - (Required) The name of the record set. The zone argument will be appended to this value to create the full record path.")
    ("addresses" "addresses - (Required) The IPv4 addresses this record set will point to.")
    ("ttl" "ttl - (Optional) The TTL of the record set. Defaults to 3600.")

  ) company-terraform-resource-arguments-hash)

(puthash "dns_aaaa_record_set" '(
    ("zone" "zone - (Required) DNS zone the record set belongs to. It must be an FQDN, that is, include the trailing dot.")
    ("name" "name - (Required) The name of the record set. The zone argument will be appended to this value to create the full record path.")
    ("addresses" "addresses - (Required) The IPv6 addresses this record set will point to.")
    ("ttl" "ttl - (Optional) The TTL of the record set. Defaults to 3600.")

  ) company-terraform-resource-arguments-hash)

(puthash "dns_cname_record" '(
    ("zone" "zone - (Required) DNS zone the record belongs to. It must be an FQDN, that is, include the trailing dot.")
    ("name" "name - (Required) The name of the record. The zone argument will be appended to this value to create the full record path.")
    ("cname" "cname - (Required) The canonical name this record will point to.")
    ("ttl" "ttl - (Optional) The TTL of the record set. Defaults to 3600.")

  ) company-terraform-resource-arguments-hash)

(puthash "dns_ptr_record" '(
    ("zone" "zone - (Required) DNS zone the record belongs to. It must be an FQDN, that is, include the trailing dot.")
    ("name" "name - (Required) The name of the record. The zone argument will be appended to this value to create the full record path.")
    ("ptr" "ptr - (Required) The canonical name this record will point to.")
    ("ttl" "ttl - (Optional) The TTL of the record set. Defaults to 3600.")

  ) company-terraform-resource-arguments-hash)

(puthash "dme_record" '(
    ("domainid" "domainid - (String, Required) The domain id to add the record to")
    ("name" "name - (Required) The name of the record type - (Required) The type of")
    ("value" "the record value - (Required) The value of the record; its usage will depend on the type (see below)")
    ("ttl" "ttl - (Integer, Optional) The TTL of the record gtdLocation - (String, Optional) The GTD Location of the record on Global Traffic Director enabled domains; Unless GTD is enabled this should either be omitted or set to \"DEFAULT\"")

  ) company-terraform-resource-arguments-hash)

(puthash "dnsimple_record" '(
    ("domain" "domain - (Required) The domain to add the record to")
    ("name" "name - (Required) The name of the record")
    ("value" "value - (Required) The value of the record")
    ("type" "type - (Required) The type of the record")
    ("ttl" "ttl - (Optional) The TTL of the record")
    ("priority" "priority - (Optional) The priority of the record - only useful for some record types")

  ) company-terraform-resource-arguments-hash)

(puthash "docker_container" '(
    ("name" "name - (Required, string) The name of the Docker container.")
    ("image" "image - (Required, string) The ID of the image to back this container. The easiest way to get this value is to use the docker_image resource as is shown in the example above.")
    ("command" "command - (Optional, list of strings) The command to use to start the container. For example, to run /usr/bin/myprogram -f baz.conf set the command to be [\"/usr/bin/myprogram\", \"-f\", \"baz.conf\"].")
    ("entrypoint" "entrypoint - (Optional, list of strings) The command to use as the Entrypoint for the container. The Entrypoint allows you to configure a container to run as an executable. For example, to run /usr/bin/myprogram when starting a container, set the entrypoint to be [\"/usr/bin/myprogram\"].")
    ("user" "user - (Optional, string) User used for run the first process. Format is user or user:group which user and group can be passed literraly or by name.")
    ("dns" "dns - (Optional, set of strings) Set of DNS servers.")
    ("dns_opts" "dns_opts - (Optional, set of strings) Set of DNS options used by the DNS provider(s), see resolv.conf documentation for valid list of options.")
    ("dns_search" "dns_search - (Optional, set of strings) Set of DNS search domains that are used when bare unqualified hostnames are used inside of the container.")
    ("env" "env - (Optional, set of strings) Environment variables to set.")
    ("labels" "labels - (Optional, map of strings) Key/value pairs to set as labels on the container.")
    ("links" "links - (Optional, set of strings) Set of links for link based connectivity between containers that are running on the same host.")
    ("hostname" "hostname - (Optional, string) Hostname of the container.")
    ("domainname" "domainname - (Optional, string) Domain name of the container.")
    ("restart" "restart - (Optional, string) The restart policy for the container. Must be one of \"no\", \"on-failure\", \"always\", \"unless-stopped\".")
    ("max_retry_count" "max_retry_count - (Optional, int) The maximum amount of times to an attempt a restart when restart is set to \"on-failure\"")
    ("must_run" "must_run - (Optional, bool) If true, then the Docker container will be kept running. If false, then as long as the container exists, Terraform assumes it is successful.")
    ("capabilities" "capabilities - (Optional, block) See Capabilities below for details.")
    ("ports" "ports - (Optional, block) See Ports below for details.")
    ("host" "host - (Optional, block) See Extra Hosts below for details.")
    ("privileged" "privileged - (Optional, bool) Run container in privileged mode.")
    ("publish_all_ports" "publish_all_ports - (Optional, bool) Publish all ports of the container.")
    ("volumes" "volumes - (Optional, block) See Volumes below for details.")
    ("memory" "memory - (Optional, int) The memory limit for the container in MBs.")
    ("memory_swap" "memory_swap - (Optional, int) The total memory limit (memory + swap) for the container in MBs. This setting may compute to -1 after terraform apply if the target host doesn't support memory swap, when that is the case docker will use a soft limitation.")
    ("cpu_shares" "cpu_shares - (Optional, int) CPU shares (relative weight) for the container.")
    ("log_driver" "log_driver - (Optional, string) The logging driver to use for the container. Defaults to \"json-file\".")
    ("log_opts" "log_opts - (Optional, map of strings) Key/value pairs to use as options for the logging driver.")
    ("network_alias" "network_alias - (Optional, set of strings) Network aliases of the container for user-defined networks only.")
    ("network_mode" "network_mode - (Optional, string) Network mode of the container.")
    ("networks" "networks - (Optional, set of strings) Id of the networks in which the container is.")
    ("destroy_grace_seconds" "destroy_grace_seconds - (Optional, int) If defined will attempt to stop the container before destroying. Container will be destroyed after n seconds or on successful stop.")
    ("upload" "upload - (Optional, block) See File Upload below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "docker_image" '(
    ("name" "name - (Required, string) The name of the Docker image, including any tags.")
    ("keep_locally" "keep_locally - (Optional, boolean) If true, then the Docker image won't be deleted on destroy operation. If this is false, it will delete the image from the docker local storage on destroy operation.")
    ("pull_triggers" "pull_triggers - (Optional, list of strings) List of values which cause an image pull when changed. This is used to store the image digest from the registry when using the docker_registry_image data source to trigger an image update.")
    ("pull_trigger" "pull_trigger - Deprecated, use pull_triggers instead.")

  ) company-terraform-resource-arguments-hash)

(puthash "docker_network" '(
    ("name" "name - (Required, string) The name of the Docker network.")
    ("check_duplicate" "check_duplicate - (Optional, boolean) Requests daemon to check for networks with same name.")
    ("driver" "driver - (Optional, string) Name of the network driver to use. Defaults to bridge driver.")
    ("options" "options - (Optional, map of strings) Network specific options to be used by the drivers.")
    ("internal" "internal - (Optional, boolean) Restrict external access to the network. Defaults to false.")
    ("ipam_driver" "ipam_driver - (Optional, string) Driver used by the custom IP scheme of the network.")
    ("ipam_config" "ipam_config - (Optional, block) See IPAM config below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "docker_volume" '(
    ("name" "name - (Optional, string) The name of the Docker volume (generated if not provided).")
    ("driver" "driver - (Optional, string) Driver type for the volume (defaults to local).")
    ("driver_opts" "driver_opts - (Optional, map of strings) Options specific to the driver.")

  ) company-terraform-resource-arguments-hash)

(puthash "dyn_record" '(
    ("name" "name - (Required) The name of the record.")
    ("type" "type - (Required) The type of the record.")
    ("value" "value - (Required) The value of the record.")
    ("zone" "zone - (Required) The DNS zone to add the record to.")
    ("ttl" "ttl - (Optional) The TTL of the record. Default uses the zone default.")

  ) company-terraform-resource-arguments-hash)

(puthash "fastly_service_v1" '(
    ("name" "name - (Required) The unique name for the Service to create.")
    ("domain" "domain - (Required) A set of Domain names to serve as entry points for your Service. Defined below.")
    ("backend" "backend - (Optional) A set of Backends to service requests from your Domains. Defined below. Backends must be defined in this argument, or defined in the vcl argument below")
    ("condition" "condition - (Optional) A set of conditions to add logic to any basic configuration object in this service. Defined below.")
    ("cache_setting" "cache_setting - (Optional) A set of Cache Settings, allowing you to override when an item is not to be cached based on an above condition. Defined below")
    ("gzip" "gzip - (Required) A set of gzip rules to control automatic gzipping of content. Defined below.")
    ("header" "header - (Optional) A set of Headers to manipulate for each request. Defined below.")
    ("healthcheck" "healthcheck - (Optional) Automated healthchecks on the cache that can change how fastly interacts with the cache based on its health.")
    ("default_host" "default_host - (Optional) The default hostname.")
    ("default_ttl" "default_ttl - (Optional) The default Time-to-live (TTL) for requests.")
    ("force_destroy" "force_destroy - (Optional) Services that are active cannot be destroyed. In order to destroy the Service, set force_destroy to true. Default false.")
    ("request_setting" "request_setting - (Optional) A set of Request modifiers. Defined below")
    ("s3logging" "s3logging - (Optional) A set of S3 Buckets to send streaming logs too. Defined below.")
    ("papertrail" "papertrail - (Optional) A Papertrail endpoint to send streaming logs too. Defined below.")
    ("sumologic" "sumologic - (Optional) A Sumologic endpoint to send streaming logs too. Defined below.")
    ("gcslogging" "gcslogging - (Optional) A gcs endpoint to send streaming logs too. Defined below.")
    ("syslog" "syslog - (Optional) A syslog endpoint to send streaming logs too. Defined below.")
    ("logentries" "logentries - (Optional) A logentries endpoint to send streaming logs too. Defined below.")
    ("response_object" "response_object - (Optional) Allows you to create synthetic responses that exist entirely on the varnish machine. Useful for creating error or maintenance pages that exists outside the scope of your datacenter. Best when used with Condition objects.")
    ("vcl" "vcl - (Optional) A set of custom VCL configuration blocks. The ability to upload custom VCL code is not enabled by default for new Fastly accounts (see the Fastly documentation for details).")

  ) company-terraform-resource-arguments-hash)

(puthash "github_branch_protection" '(
    ("repository" "repository - (Required) The GitHub repository name.")
    ("branch" "branch - (Required) The Git branch to protect.")
    ("enforce_admins" "enforce_admins - (Optional) Boolean, setting this to true enforces status checks for repository administrators.")
    ("required_status_checks" "required_status_checks - (Optional) Enforce restrictions for required status checks. See Required Status Checks below for details.")
    ("required_pull_request_reviews" "required_pull_request_reviews - (Optional) Enforce restrictions for pull request reviews. See Required Pull Request Reviews below for details.")
    ("restrictions" "restrictions - (Optional) Enforce restrictions for the users and teams that may push to the branch. See Restrictions below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_membership" '(
    ("username" "username - (Required) The user to add to the organization.")
    ("role" "role - (Optional) The role of the user within the organization.         Must be one of member or admin. Defaults to member.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_organization_webhook" '(
    ("name" "name - (Required) The type of the webhook. See a list of available hooks.")
    ("events" "events - (Required) A list of events which should trigger the webhook. See a list of available events")
    ("configuration" "configuration - (Required) key/value pair of configuration for this webhook. Available keys are url, content_type, secret and insecure_ssl.")
    ("active" "active - (Optional) Indicate of the webhook should receive events. Defaults to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_repository" '(
    ("name" "name - (Required) The name of the repository.")
    ("description" "description - (Optional) A description of the repository.")
    ("homepage_url" "homepage_url - (Optional) URL of a page describing the project.")
    ("private" "private - (Optional) Set to true to create a private repository. Repositories are created as public (e.g. open source) by default.")
    ("has_issues" "has_issues - (Optional) Set to true to enable the Github Issues features on the repository.")
    ("has_wiki" "has_wiki - (Optional) Set to true to enable the Github Wiki features on the repository.")
    ("allow_merge_commit" "allow_merge_commit - (Optional) Set to false to disable merge commits on the repository.")
    ("allow_squash_merge" "allow_squash_merge - (Optional) Set to false to disable squash merges on the repository.")
    ("allow_rebase_merge" "allow_rebase_merge - (Optional) Set to false to disable rebase merges on the repository.")
    ("has_downloads" "has_downloads - (Optional) Set to true to enable the (deprecated) downloads features on the repository.")
    ("auto_init" "auto_init - (Optional) Meaningful only during create; set to true to produce an initial commit in the repository.")
    ("gitignore_template" "gitignore_template - (Optional) Meaningful only during create, will be ignored after repository creation. Use the name of the template without the extension. For example, \"Haskell\".")
    ("license_template" "license_template - (Optional) Meaningful only during create, will be ignored after repository creation. Use the name of the template without the extension. For example, \"mit\" or \"mozilla\".")
    ("default_branch" "default_branch - (Optional) The name of the default branch of the repository. NOTE: This can only be set after a repository has already been created, and after a correct reference has been created for the target branch inside the repository. This means a user will have to omit this parameter from the initial repository creation and create the target branch inside of the repository prior to setting this attribute.")
    ("archived" "archived - (Optional) Specifies if the repository should be archived. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_repository_collaborator" '(
    ("repository" "repository - (Required) The GitHub repository")
    ("username" "username - (Required) The user to add to the repository as a collaborator.")
    ("permission" "permission - (Optional) The permission of the outside collaborator for the repository.         Must be one of pull, push, or admin. Defaults to push.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_repository_deploy_key" '(
    ("key" "key - (Required) A ssh key.")
    ("read_only" "read_only - (Required) A boolean qualifying the key to be either read only or read/write.")
    ("repository" "repository - (Required) Name of the Github repository.")
    ("title" "title - (Required) A title.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_repository_webhook" '(
    ("name" "name - (Required) The type of the webhook. See a list of available hooks.")
    ("repository" "repository - (Required) The repository of the webhook.")
    ("events" "events - (Required) A list of events which should trigger the webhook. See a list of available events")
    ("configuration" "configuration - (Required) key/value pair of configuration for this webhook. Available keys are url, content_type, secret and insecure_ssl.")
    ("active" "active - (Optional) Indicate of the webhook should receive events. Defaults to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_team" '(
    ("name" "name - (Required) The name of the team.")
    ("description" "description - (Optional) A description of the team.")
    ("privacy" "privacy - (Optional) The level of privacy for the team. Must be one of secret or closed.            Defaults to secret.")
    ("parent_team_id" "parent_team_id - (Optional) The ID of the parent team, if this is a nested team.")
    ("ldap_dn" "ldap_dn - (Optional) The LDAP Distinguished Name of the group where membership will be synchronized. Only available in GitHub Enterprise.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_team_membership" '(
    ("team_id" "team_id - (Required) The GitHub team id")
    ("username" "username - (Required) The user to add to the team.")
    ("role" "role - (Optional) The role of the user within the team.         Must be one of member or maintainer. Defaults to member.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_team_repository" '(
    ("team_id" "team_id - (Required) The GitHub team id")
    ("repository" "repository - (Required) The repository to add to the team.")
    ("permission" "permission - (Optional) The permissions of team members regarding the repository. Must be one of pull, push, or admin. Defaults to pull.")

  ) company-terraform-resource-arguments-hash)

(puthash "github_issue_label" '(
    ("repository" "repository - (Required) The GitHub repository")
    ("name" "name - (Required) The name of the label.")
    ("color" "color - (Required) A 6 character hex code, without the leading #, identifying the color of the label.")
    ("url" "url - (Computed) The URL to the issue label")

  ) company-terraform-resource-arguments-hash)

(puthash "gitlab_deploy_key" '(
    ("project" "project - (Required, string) The name or id of the project to add the deploy key to.")
    ("title" "title - (Required, string) A title to describe the deploy key with.")
    ("key" "key - (Required, string) The public ssh key body.")
    ("can_push" "can_push - (Optional, boolean) Allow this deploy key to be used to push changes to the project.  Defaults to false. NOTE:: this cannot currently be managed.")

  ) company-terraform-resource-arguments-hash)

(puthash "gitlab_group" '(
    ("name" "name - (Required) The name of this group.")
    ("path" "path - (Required) The url of the hook to invoke.")
    ("description" "description - (Optional) The description of the group.")
    ("lfs_enabled" "lfs_enabled - (Optional) Boolean, defaults to true.  Whether to enable LFS support for projects in this group.")
    ("request_access_enabled" "request_access_enabled - (Optional) Boolean, defaults to false.  Whether to enable users to request access to the group.")
    ("visibility_level" "visibility_level - (Optional) Set to public to create a public group. Valid values are private, internal, public. Groups are created as private by default.")
    ("parent_id" "parent_id - (Optional) Integer, id of the parent group (creates a nested group).")

  ) company-terraform-resource-arguments-hash)

(puthash "gitlab_label" '(
    ("project" "project - (Required) The name or id of the project to add the label to.")
    ("name" "name - (Required) The name of the label.")
    ("color" "color - (Required) The color of the label given in 6-digit hex notation with leading '#' sign (e.g. #FFAABB) or one of the CSS color names.")
    ("description" "description - (Optional) The description of the label.")

  ) company-terraform-resource-arguments-hash)

(puthash "gitlab_project_hook" '(
    ("project" "project - (Required) The name or id of the project to add the hook to.")
    ("url" "url - (Required) The url of the hook to invoke.")
    ("token" "token - (Optional) A token to present when invoking the hook.")
    ("enable_ssl_verification" "enable_ssl_verification - (Optional) Enable ssl verification when invoking the hook.")
    ("push_events" "push_events - (Optional) Invoke the hook for push events.")
    ("issues_events" "issues_events - (Optional) Invoke the hook for issues events.")
    ("merge_requests_events" "merge_requests_events - (Optional) Invoke the hook for merge requests.")
    ("tag_push_events" "tag_push_events - (Optional) Invoke the hook for tag push events.")
    ("note_events" "note_events - (Optional) Invoke the hook for notes events.")
    ("job_events" "job_events - (Optional) Invoke the hook for job events.")
    ("pipeline_events" "pipeline_events - (Optional) Invoke the hook for pipeline events.")
    ("wiki_page_events" "wiki_page_events - (Optional) Invoke the hook for wiki page events.")

  ) company-terraform-resource-arguments-hash)

(puthash "gitlab_project" '(
    ("name" "name - (Required) The name of the project.")
    ("path" "path - (Optional) The path of the repository.")
    ("namespace_id" "namespace_id - (Optional) The namespace (group or user) of the project. Defaults to your user. See gitlab_group for an example.")
    ("description" "description - (Optional) A description of the project.")
    ("default_branch" "default_branch - (Optional) The default branch for the project.")
    ("issues_enabled" "issues_enabled - (Optional) Enable issue tracking for the project.")
    ("merge_requests_enabled" "merge_requests_enabled - (Optional) Enable merge requests for the project.")
    ("wiki_enabled" "wiki_enabled - (Optional) Enable wiki for the project.")
    ("snippets_enabled" "snippets_enabled - (Optional) Enable snippets for the project.")
    ("visibility_level" "visibility_level - (Optional) Set to public to create a public project. Valid values are private, internal, public. Repositories are created as private by default.")

  ) company-terraform-resource-arguments-hash)

(puthash "gitlab_user" '(
    ("name" "name - (Required) The name of the user.")
    ("username" "username - (Required) The username of the user.")
    ("password" "password - (Required) The password of the user.")
    ("email" "email - (Required) The e-mail address of the user.")
    ("is_admin" "is_admin - (Optional) Boolean, defaults to false.  Whether to enable administrative priviledges for the user.")
    ("projects_limit" "projects_limit - (Optional) Integer, defaults to 0.  Number of projects user can create.")
    ("can_create_group" "can_create_group - (Optional) Boolean, defaults to false. Whether to allow the user to create groups.")
    ("skip_confirmation" "skip_confirmation - (Optional) Boolean, defaults to true. Whether to skip confirmation.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_bigquery_dataset" '(
    ("dataset_id" "dataset_id - (Required) A unique ID for the resource. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")
    ("friendly_name" "friendly_name - (Optional) A descriptive name for the dataset.")
    ("description" "description - (Optional) A user-friendly description of the dataset.")
    ("location" "location - (Optional) The geographic location where the dataset should reside. Possible values include EU and US. The default value is US. Changing this forces a new resource to be created.")
    ("default_table_expiration_ms" "default_table_expiration_ms - (Optional) The default lifetime of all tables in the dataset, in milliseconds. The minimum value is 3600000 milliseconds (one hour). Once this property is set, all newly-created tables in the dataset will have an expirationTime property set to the creation time plus the value in this property, and changing the value will only affect new tables, not existing ones. When the expirationTime for a given table is reached, that table will be deleted automatically. If a table's expirationTime is modified or removed before the table expires, or if you provide an explicit expirationTime when creating a table, that value takes precedence over the default expiration time indicated by this property.")
    ("labels" "labels - (Optional) A mapping of labels to assign to the resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_bigquery_table" '(
    ("dataset_id" "dataset_id - (Required) The dataset ID to create the table in. Changing this forces a new resource to be created.")
    ("table_id" "table_id - (Required) A unique ID for the resource. Changing this forces a new resource to be created.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")
    ("description" "description - (Optional) The field description.")
    ("expiration_time" "expiration_time - (Optional) The time when this table expires, in milliseconds since the epoch. If not present, the table will persist indefinitely. Expired tables will be deleted and their storage reclaimed.")
    ("friendly_name" "friendly_name - (Optional) A descriptive name for the table.")
    ("labels" "labels - (Optional) A mapping of labels to assign to the resource.")
    ("schema" "schema - (Optional) A JSON schema for the table.")
    ("time_partitioning" "time_partitioning - (Optional) If specified, configures time-based partitioning for this table. Structure is documented below.")
    ("view" "view - (Optional) If specified, configures this table as a view. Structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_bigtable_instance" '(
    ("name" "name - (Required) The name of the Bigtable instance.")
    ("cluster_id" "cluster_id - (Required) The name of the Bigtable instance's cluster.")
    ("zone" "zone - (Required) The zone to create the Bigtable instance in. Zones that support Bigtable instances are noted on the Cloud Locations page.")
    ("num_nodes" "num_nodes - (Optional) The number of nodes in your Bigtable instance. Minimum of 3 for a PRODUCTION instance. Cannot be set for a DEVELOPMENT instance.")
    ("instance_type" "instance_type - (Optional) The instance type to create. One of \"DEVELOPMENT\" or \"PRODUCTION\". Defaults to PRODUCTION.")
    ("storage_type" "storage_type - (Optional) The storage type to use. One of \"SSD\" or \"HDD\". Defaults to SSD.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")
    ("display_name" "display_name - (Optional) The human-readable display name of the Bigtable instance. Defaults to the instance name.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_bigtable_table" '(
    ("name" "name - (Required) The name of the table.")
    ("instance_name" "instance_name - (Required) The name of the Bigtable instance.")
    ("split_keys" "split_keys - (Optional) A list of predefined keys to split the table on.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_cloudfunctions_function" '(
    ("name" "name - (Required) A user-defined name of the function. Function names must be unique globally.")
    ("source_archive_bucket" "source_archive_bucket - (Required) The GCS bucket containing the zip archive which contains the function.")
    ("source_archive_object" "source_archive_object - (Required) The source archive object (file) in archive bucket.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_folder" '(
    ("display_name" "display_name - (Required) The folder’s display name. A folder’s display name must be unique amongst its siblings, e.g. no two folders with the same parent can share the same display name. The display name must start and end with a letter or digit, may contain letters, digits, spaces, hyphens and underscores and can be no longer than 30 characters.")
    ("parent" "parent - (Required) The resource name of the parent Folder or Organization. Must be of the form folders/{folder_id} or organizations/{org_id}.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_folder_iam_binding" '(
    ("folder" "folder - (Required) The resource name of the folder the policy is attached to. Its format is folders/{folder_id}.")
    ("members" "members (Required) - An array of identites that will be granted the privilege in the role. Each entry can have one of the following values:  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_folder_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_folder_iam_member" '(
    ("folder" "folder - (Required) The resource name of the folder the policy is attached to. Its format is folders/{folder_id}.")
    ("member" "member - (Required) The identity that will be granted the privilege in the role. This field can have one of the following values:  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_folder_iam_policy" '(
    ("folder" "folder - (Required) The resource name of the folder the policy is attached to. Its format is folders/{folder_id}.")
    ("policy_data" "policy_data - (Required) The google_iam_policy data source that represents the IAM policy that will be applied to the folder. This policy overrides any existing policy applied to the folder.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_folder_organization_policy" '(
    ("folder" "folder - (Required) The resource name of the folder to set the policy for. Its format is folders/{folder_id}.")
    ("constraint" "constraint - (Required) The name of the Constraint the Policy is configuring, for example, serviceuser.services. Check out the complete list of available constraints.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_organization_policy" '(
    ("org_id" "org_id - (Required) The numeric ID of the organization to set the policy for.")
    ("constraint" "constraint - (Required) The name of the Constraint the Policy is configuring, for example, serviceuser.services. Check out the complete list of available constraints.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_organization_iam_binding" '(
    ("org_id" "org_id - (Required) The numeric ID of the organization in which you want to create a custom role.")
    ("role" "role - (Required) The role that should be applied. Only one google_organization_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("members" "members - (Required) A list of users that the role should apply to.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_organization_iam_custom_role" '(
    ("role_id" "role_id - (Required) The role id to use for this role.")
    ("org_id" "org_id - (Required) The numeric ID of the organization in which you want to create a custom role.")
    ("title" "title - (Required) A human-readable title for the role.")
    ("permissions" "permissions (Required) The names of the permissions this role grants when bound in an IAM policy. At least one permission must be specified.")
    ("stage" "stage - (Optional) The current launch stage of the role. Defaults to GA. List of possible stages is here.")
    ("description" "description - (Optional) A human-readable description for the role.")
    ("deleted" "deleted - (Optional) The current deleted state of the role. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_organization_iam_member" '(
    ("org_id" "org_id - (Required) The numeric ID of the organization in which you want to create a custom role.")
    ("role" "role - (Required) The role that should be applied. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("member" "member - (Required) The user that the role should apply to.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_organization_iam_policy" '(
    ("org_id" "org_id - (Required) The numeric ID of the organization in which you want to create a custom role.")
    ("policy_data" "policy_data - (Required) The google_iam_policy data source that represents the IAM policy that will be applied to the organization. This policy overrides any existing policy applied to the organization.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project" '(
    ("name" "name - (Required) The display name of the project.")
    ("project_id" "project_id - (Required) The project ID. Changing this forces a new project to be created.")
    ("org_id" "org_id - (Optional) The numeric ID of the organization this project belongs to. Changing this forces a new project to be created.  Only one of org_id or folder_id may be specified. If the org_id is specified then the project is created at the top level. Changing this forces the project to be migrated to the newly specified organization.")
    ("folder_id" "folder_id - (Optional) The numeric ID of the folder this project should be created under. Only one of org_id or folder_id may be specified. If the folder_id is specified, then the project is created under the specified folder. Changing this forces the project to be migrated to the newly specified folder.")
    ("billing_account" "billing_account - (Optional) The alphanumeric ID of the billing account this project belongs to. The user or service account performing this operation with Terraform must have Billing Account Administrator privileges (roles/billing.admin) in the organization. See Google Cloud Billing API Access Control for more details.")
    ("skip_delete" "skip_delete - (Optional) If true, the Terraform resource can be deleted without deleting the Project via the Google API.")
    ("policy_data" "policy_data - (Deprecated) The IAM policy associated with the project. This argument is no longer supported, and will be removed in a future version of Terraform. It should be replaced with a google_project_iam_policy resource.")
    ("labels" "labels - (Optional) A set of key/value label pairs to assign to the project.")
    ("auto_create_network" "auto_create_network - (Optional) Create the 'default' network automatically.  Default true. Note: this might be more accurately described as \"Delete Default Network\", since the network is created automatically then deleted before project creation returns, but we choose this name to match the GCP Console UI. Setting this field to false will enable the Compute Engine API which is required to delete the network.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_iam_binding" '(
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_project_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_project_iam_policy) The google_iam_policy data source that represents the IAM policy that will be applied to the project. The policy will be merged with any existing policy applied to the project. Changing this updates the policy. Deleting this removes the policy, but leaves the original project policy intact. If there are overlapping binding entries between the original project policy and the data source policy, they will be removed.")
    ("project" "project - (Optional) The project ID. If not specified, uses the ID of the project configured with the provider.")
    ("authoritative" "authoritative - (DEPRECATED) (Optional, only for google_project_iam_policy) A boolean value indicating if this policy should overwrite any existing IAM policy on the project. When set to true, any policies not in your config file will be removed. This can lock you out of your project until an Organization Administrator grants you access again, so please exercise caution. If this argument is true and you want to delete the resource, you must set the disable_project argument to true, acknowledging that the project will be inaccessible to anyone but the Organization Admins, as it will no longer have an IAM policy. Rather than using this, you should use google_project_iam_binding and google_project_iam_member.")
    ("disable_project" "disable_project - (DEPRECATED) (Optional, only for google_project_iam_policy) A boolean value that must be set to true if you want to delete a google_project_iam_policy that is authoritative.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_iam_member" '(
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_project_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_project_iam_policy) The google_iam_policy data source that represents the IAM policy that will be applied to the project. The policy will be merged with any existing policy applied to the project. Changing this updates the policy. Deleting this removes the policy, but leaves the original project policy intact. If there are overlapping binding entries between the original project policy and the data source policy, they will be removed.")
    ("project" "project - (Optional) The project ID. If not specified, uses the ID of the project configured with the provider.")
    ("authoritative" "authoritative - (DEPRECATED) (Optional, only for google_project_iam_policy) A boolean value indicating if this policy should overwrite any existing IAM policy on the project. When set to true, any policies not in your config file will be removed. This can lock you out of your project until an Organization Administrator grants you access again, so please exercise caution. If this argument is true and you want to delete the resource, you must set the disable_project argument to true, acknowledging that the project will be inaccessible to anyone but the Organization Admins, as it will no longer have an IAM policy. Rather than using this, you should use google_project_iam_binding and google_project_iam_member.")
    ("disable_project" "disable_project - (DEPRECATED) (Optional, only for google_project_iam_policy) A boolean value that must be set to true if you want to delete a google_project_iam_policy that is authoritative.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_iam_policy" '(
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_project_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_project_iam_policy) The google_iam_policy data source that represents the IAM policy that will be applied to the project. The policy will be merged with any existing policy applied to the project. Changing this updates the policy. Deleting this removes the policy, but leaves the original project policy intact. If there are overlapping binding entries between the original project policy and the data source policy, they will be removed.")
    ("project" "project - (Optional) The project ID. If not specified, uses the ID of the project configured with the provider.")
    ("authoritative" "authoritative - (DEPRECATED) (Optional, only for google_project_iam_policy) A boolean value indicating if this policy should overwrite any existing IAM policy on the project. When set to true, any policies not in your config file will be removed. This can lock you out of your project until an Organization Administrator grants you access again, so please exercise caution. If this argument is true and you want to delete the resource, you must set the disable_project argument to true, acknowledging that the project will be inaccessible to anyone but the Organization Admins, as it will no longer have an IAM policy. Rather than using this, you should use google_project_iam_binding and google_project_iam_member.")
    ("disable_project" "disable_project - (DEPRECATED) (Optional, only for google_project_iam_policy) A boolean value that must be set to true if you want to delete a google_project_iam_policy that is authoritative.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_iam_custom_role" '(
    ("role_id" "role_id - (Required) The role id to use for this role.")
    ("title" "title - (Required) A human-readable title for the role.")
    ("permissions" "permissions (Required) The names of the permissions this role grants when bound in an IAM policy. At least one permission must be specified.")
    ("project" "project - (Optional) The project that the service account will be created in. Defaults to the provider project configuration.")
    ("stage" "stage - (Optional) The current launch stage of the role. Defaults to GA. List of possible stages is here.")
    ("description" "description - (Optional) A human-readable description for the role.")
    ("deleted" "deleted - (Optional) The current deleted state of the role. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_organization_policy" '(
    ("project" "project - (Required) The project id of the project to set the policy for.")
    ("constraint" "constraint - (Required) The name of the Constraint the Policy is configuring, for example, serviceuser.services. Check out the complete list of available constraints.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_service" '(
    ("service" "service - (Required) The service to enable.")
    ("project" "project - (Optional) The project ID. If not provided, the provider project is used.")
    ("disable_on_destroy" "disable_on_destroy - (Optional) If true, disable the service when the terraform resource is destroyed.  Defaults to true.  May be useful in the event that a project is long-lived but the infrastructure running in that project changes frequently.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_services" '(
    ("project" "project - (Required) The project ID. Changing this forces Terraform to attempt to disable all previously managed API services in the previous project.")
    ("services" "services - (Required) The list of services that are enabled. Supports update.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_project_usage_export_bucket" '(
    ("project" "project: (Required) The project to set the export bucket on.")
    ("bucket_name" "bucket_name: (Required) The bucket to store reports in.")
    ("prefix" "prefix: (Optional) A prefix for the reports, for instance, the project name.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_service_account" '(
    ("account_id" "account_id - (Required) The service account ID. Changing this forces a new service account to be created.")
    ("display_name" "display_name - (Optional) The display name for the service account. Can be updated without creating a new resource.")
    ("project" "project - (Optional) The ID of the project that the service account will be created in. Defaults to the provider project configuration.")
    ("policy_data" "policy_data - (DEPRECATED, Optional) The google_iam_policy data source that represents the IAM policy that will be applied to the service account. The policy will be merged with any existing policy. This attribute has been deprecated. Use the google_service_account_iam_* resources instead. Deleting this removes the policy declared in Terraform. Any policy bindings associated with the project before Terraform was used are not deleted.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_service_account_iam_binding" '(
    ("service_account_id" "service_account_id - (Required) The service account id to apply policy to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_service_account_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_service_account_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_service_account_iam_member" '(
    ("service_account_id" "service_account_id - (Required) The service account id to apply policy to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_service_account_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_service_account_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_service_account_iam_policy" '(
    ("service_account_id" "service_account_id - (Required) The service account id to apply policy to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_service_account_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_service_account_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_service_account_key" '(
    ("service_account_id" "service_account_id - (Required) The Service account id of the Key Pair. This can be a string in the format {ACCOUNT} or projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}, where {ACCOUNT} is the email address or unique id of the service account. If the {ACCOUNT} syntax is used, the project will be inferred from the account.")
    ("key_algorithm" "key_algorithm - (Optional) The algorithm used to generate the key. KEY_ALG_RSA_2048 is the default algorithm. Valid values are listed at ServiceAccountPrivateKeyType (only used on create)")
    ("public_key_type" "public_key_type (Optional) The output format of the public key requested. X509_PEM is the default output format.")
    ("private_key_type" "private_key_type (Optional) The output format of the private key. TYPE_GOOGLE_CREDENTIALS_FILE is the default output format.")
    ("pgp_key" "pgp_key – (Optional) An optional PGP key to encrypt the resulting private key material. Only used when creating or importing a new key pair. May either be a base64-encoded public key or a keybase:keybaseusername string for looking up in Vault.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_address" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_autoscaler" '(
    ("name" "name - (Required) The name of the autoscaler.")
    ("target" "target - (Required) The full URL to the instance group manager whose size we control.")
    ("zone" "zone - (Required) The zone of the target.")
    ("autoscaling_policy" "autoscaling_policy - (Required) The parameters of the autoscaling algorithm. Structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_backend_bucket" '(
    ("bucket_name" "bucket_name - (Required) Cloud Storage bucket name.")
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035.  Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_backend_service" '(
    ("name" "name - (Required) The name of the backend service.")
    ("health_checks" "health_checks - (Required) Specifies a list of HTTP/HTTPS health checks for checking the health of the backend service. Currently at most one health check can be specified, and a health check is required.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_disk" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The zone where this disk will be available.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_firewall" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("network" "network - (Required) The name or self_link of the network to attach this firewall to.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_forwarding_rule" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_global_address" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035.  Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_global_forwarding_rule" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("target" "target - (Required) URL of target HTTP or HTTPS proxy.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_health_check" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_http_health_check" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035.  Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_https_health_check" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035.  Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_image" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_instance" '(
    ("boot_disk" "boot_disk - (Required) The boot disk for the instance. Structure is documented below.")
    ("machine_type" "machine_type - (Required) The machine type to create. To create a custom machine type, value should be set as specified here. Note: allow_stopping_for_update must be set to true in order to update this field.")
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The zone that the machine should be created in.")
    ("network_interface" "network_interface - (Required) Networks to attach to the instance. This can be specified multiple times. Structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_instance_group" '(
    ("name" "name - (Required) The name of the instance group. Must be 1-63 characters long and comply with RFC1035. Supported characters include lowercase letters, numbers, and hyphens.")
    ("zone" "zone - (Required) The zone that this instance group should be created in.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_instance_group_manager" '(
    ("base_instance_name" "base_instance_name - (Required) The base instance name to use for instances in this group. The value must be a valid RFC1035 name. Supported characters are lowercase letters, numbers, and hyphens (-). Instances are named by appending a hyphen and a random four-character string to the base instance name.")
    ("instance_template" "instance_template - (Required) The full URL to an instance template from which all new instances will be created.")
    ("name" "name - (Required) The name of the instance group manager. Must be 1-63 characters long and comply with RFC1035. Supported characters include lowercase letters, numbers, and hyphens.")
    ("zone" "zone - (Required) The zone that instances in this group should be created in.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_instance_template" '(
    ("disk" "disk - (Required) Disks to attach to instances created from this template. This can be specified multiple times for multiple disks. Structure is documented below.")
    ("machine_type" "machine_type - (Required) The machine type to create.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_network_peering" '(
    ("name" "name - (Required) Name of the peering.")
    ("network" "network - (Required) Resource link of the network to add a peering to.")
    ("peer_network" "peer_network - (Required) Resource link of the peer network.")
    ("auto_create_routes" "auto_create_routes - (Optional) If set to true, the routes between the two networks will be created and managed automatically. Defaults to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_network" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_project_metadata" '(
    ("metadata" "metadata - (Required) A series of key value pairs. Changing this resource updates the GCE state.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_project_metadata_item" '(
    ("key" "key - (Required) The metadata key to set.")
    ("value" "value - (Required) The value to set for the given metadata key.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_region_autoscaler" '(
    ("name" "name - (Required) The name of the autoscaler.")
    ("target" "target - (Required) The full URL to the instance group manager whose size we control.")
    ("region" "region - (Required) The region of the target.")
    ("autoscaling_policy" "autoscaling_policy - (Required) The parameters of the autoscaling algorithm. Structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_region_backend_service" '(
    ("name" "name - (Required) The name of the backend service.")
    ("health_checks" "health_checks - (Required) Specifies a list of health checks for checking the health of the backend service. Currently at most one health check can be specified, and a health check is required.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_region_instance_group_manager" '(
    ("base_instance_name" "base_instance_name - (Required) The base instance name to use for instances in this group. The value must be a valid RFC1035 name. Supported characters are lowercase letters, numbers, and hyphens (-). Instances are named by appending a hyphen and a random four-character string to the base instance name.")
    ("instance_template" "instance_template - (Required) The full URL to an instance template from which all new instances will be created.")
    ("name" "name - (Required) The name of the instance group manager. Must be 1-63 characters long and comply with RFC1035. Supported characters include lowercase letters, numbers, and hyphens.")
    ("region" "region - (Required) The region where the managed instance group resides.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_route" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("dest_range" "dest_range - (Required) The destination IPv4 address range that this route applies to.")
    ("network" "network - (Required) The name or self_link of the network to attach this route to.")
    ("priority" "priority - (Optional) The priority of this route, used to break ties. Defaults to 1000.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_router" '(
    ("name" "name - (Required) A unique name for the router, required by GCE. Changing this forces a new router to be created.")
    ("network" "network - (Required) The name or resource link to the network this Cloud Router will use to learn and announce routes. Changing this forces a new router to be created.")
    ("bgp" "bgp - (Required) BGP information specific to this router. Changing this forces a new router to be created. Structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_router_interface" '(
    ("name" "name - (Required) A unique name for the interface, required by GCE. Changing this forces a new interface to be created.")
    ("router" "router - (Required) The name of the router this interface will be attached to. Changing this forces a new interface to be created.")
    ("vpn_tunnel" "vpn_tunnel - (Required) The name or resource link to the VPN tunnel this interface will be linked to. Changing this forces a new interface to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_router_peer" '(
    ("name" "name - (Required) A unique name for BGP peer, required by GCE. Changing this forces a new peer to be created.")
    ("router" "router - (Required) The name of the router in which this BGP peer will be configured. Changing this forces a new peer to be created.")
    ("interface" "interface - (Required) The name of the interface the BGP peer is associated with. Changing this forces a new peer to be created.")
    ("peer_ip_address" "peer_ip_address - (Required) IP address of the BGP interface outside Google Cloud. Changing this forces a new peer to be created.")
    ("peer_asn" "peer_asn - (Required) Peer BGP Autonomous System Number (ASN). Changing this forces a new peer to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_security_policy" '(
    ("name" "name - (Required) The name of the security policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_shared_vpc_host_project" '(
    ("project" "project - (Required) The ID of the project that will serve as a Shared VPC host project")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_shared_vpc_service_project" '(
    ("host_project" "host_project - (Required) The ID of a host project to associate.")
    ("service_project" "service_project - (Required) The ID of the project that will serve as a Shared VPC service project.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_snapshot" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("zone" "zone - (Required) The zone where the source disk is located.")
    ("source_disk" "source_disk - (Required) The disk which will be used as the source of the snapshot.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_ssl_certificate" '(
    ("certificate" "certificate - (Required) A local certificate file in PEM format. The chain may be at most 5 certs long, and must include at least one intermediate cert. Changing this forces a new resource to be created.")
    ("private_key" "private_key - (Required) Write only private key in PEM format. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_ssl_policy" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_subnetwork" '(
    ("ip_cidr_range" "ip_cidr_range - (Required) The IP address range that machines in this network are assigned to, represented as a CIDR block.")
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("network" "network - (Required) The network name or resource link to the parent network of this subnetwork. The parent network must have been created in custom subnet mode.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_subnetwork_iam_binding" '(
    ("subnetwork" "subnetwork - (Required) The name of the subnetwork.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_compute_subnetwork_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_compute_subnetwork_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")
    ("region" "region - (Optional) The region of the subnetwork. If unspecified, this defaults to the region configured in the provider.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_subnetwork_iam_member" '(
    ("subnetwork" "subnetwork - (Required) The name of the subnetwork.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_compute_subnetwork_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_compute_subnetwork_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")
    ("region" "region - (Optional) The region of the subnetwork. If unspecified, this defaults to the region configured in the provider.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_subnetwork_iam_policy" '(
    ("subnetwork" "subnetwork - (Required) The name of the subnetwork.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_compute_subnetwork_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_compute_subnetwork_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")
    ("region" "region - (Optional) The region of the subnetwork. If unspecified, this defaults to the region configured in the provider.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_target_http_proxy" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")
    ("url_map" "url_map - (Required) A reference to UrlMap resource")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_target_https_proxy" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")
    ("ssl_certificates" "ssl_certificates - (Required) A list of SslCertificate resources that are used to authenticate connections between users and the load balancer. Currently, exactly one SSL certificate must be specified.")
    ("url_map" "url_map - (Required) A reference to UrlMap resource")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_target_ssl_proxy" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")
    ("backend_service" "backend_service - (Required) A reference to BackendService resource")
    ("ssl_certificates" "ssl_certificates - (Required) A list of SslCertificate resources that are used to authenticate connections between users and the load balancer. Currently, exactly one SSL certificate must be specified.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_target_tcp_proxy" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")
    ("backend_service" "backend_service - (Required) A reference to BackendService resource")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_target_pool" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_url_map" '(
    ("default_service" "default_service - (Required) The backend service or backend bucket to use when none of the given rules match.")
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_vpn_gateway" '(
    ("name" "name - (Required) Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035.  Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.")
    ("network" "network - (Required) A reference to Network resource")

  ) company-terraform-resource-arguments-hash)

(puthash "google_compute_vpn_tunnel" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")
    ("peer_ip" "peer_ip - (Required) The VPN gateway sitting outside of GCE. Changing this forces a new resource to be created.")
    ("shared_secret" "shared_secret - (Required) A passphrase shared between the two VPN gateways. Changing this forces a new resource to be created.")
    ("target_vpn_gateway" "target_vpn_gateway - (Required) A link to the VPN gateway sitting inside GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_container_cluster" '(
    ("name" "name - (Required) The name of the cluster, unique within the project and zone.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_container_node_pool" '(
    ("zone" "zone - (Optional) The zone in which the cluster resides.")
    ("region" "region - (Optional) The region in which the cluster resides (for regional clusters).")
    ("cluster" "cluster - (Required) The cluster to create the node pool for.  Cluster must be present in zone provided for zonal clusters.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_dataflow_job" '(
    ("name" "name - (Required) A unique name for the resource, required by Dataflow.")
    ("template_gcs_path" "template_gcs_path - (Required) The GCS path to the Dataflow job template.")
    ("temp_gcs_location" "temp_gcs_location - (Required) A writeable location on GCS for the Dataflow job to dump its temporary data.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_dataproc_cluster" '(
    ("name" "name - (Required) The name of the cluster, unique within the project and zone.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_dataproc_job" '(
    ("placement.cluster_name" "placement.cluster_name - (Required) The name of the cluster where the job  will be submitted.")
    ("xxx_config" "xxx_config - (Required) Exactly one of the specific job types to run on the cluster should be specified. If you want to submit multiple jobs, this will currently require the definition of multiple google_dataproc_job resources as shown in the example above, or by setting the count attribute. The following job configs are supported:  pyspark_config  - Submits a PySpark job to the cluster  spark_config    - Submits a Spark job to the cluster  hadoop_config   - Submits a Hadoop job to the cluster  hive_config     - Submits a Hive job to the cluster  hpig_config     - Submits a Pig job to the cluster  sparksql_config - Submits a Spark SQL job to the cluster")

  ) company-terraform-resource-arguments-hash)

(puthash "google_dns_managed_zone" '(
    ("dns_name" "dns_name - (Required) The fully qualified DNS name of this zone, e.g. terraform.io..")
    ("name" "name - (Required) A unique name for the resource, required by GCE. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_dns_record_set" '(
    ("managed_zone" "managed_zone - (Required) The name of the zone in which this record set will reside.")
    ("name" "name - (Required) The DNS name this record set will apply to.")
    ("rrdatas" "rrdatas - (Required) The string data for the records in this record set whose meaning depends on the DNS type. For TXT record, if the string data contains spaces, add surrounding \\\" if you don't want your string to get split on spaces.")
    ("ttl" "ttl - (Required) The time-to-live of this record set (seconds).")
    ("type" "type - (Required) The DNS record set type.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_endpoints_service" '(

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_topic" '(
    ("name" "name - (Required) A unique name for the pubsub topic. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_topic_iam_binding" '(
    ("topic" "topic - (Required) The topic name or id to bind to attach IAM policy to.")
    ("project" "project - (Optional) The project in which the resource belongs. If it is not provided, the provider project is used.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_pubsub_topic_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_pubsub_topic_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_topic_iam_member" '(
    ("topic" "topic - (Required) The topic name or id to bind to attach IAM policy to.")
    ("project" "project - (Optional) The project in which the resource belongs. If it is not provided, the provider project is used.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_pubsub_topic_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_pubsub_topic_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_topic_iam_policy" '(
    ("topic" "topic - (Required) The topic name or id to bind to attach IAM policy to.")
    ("project" "project - (Optional) The project in which the resource belongs. If it is not provided, the provider project is used.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_pubsub_topic_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_pubsub_topic_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_subscription" '(
    ("name" "name - (Required) A unique name for the resource, required by pubsub. Changing this forces a new resource to be created.")
    ("topic" "topic - (Required) The topic name or id to bind this subscription to, required by pubsub. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_subscription_iam_binding" '(
    ("subscription" "subscription - (Required) The subscription name or id to bind to attach IAM policy to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_pubsub_subscription_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_pubsub_subscription_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_subscription_iam_member" '(
    ("subscription" "subscription - (Required) The subscription name or id to bind to attach IAM policy to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_pubsub_subscription_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_pubsub_subscription_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_pubsub_subscription_iam_policy" '(
    ("subscription" "subscription - (Required) The subscription name or id to bind to attach IAM policy to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_pubsub_subscription_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_pubsub_subscription_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_runtimeconfig_config" '(
    ("name" "name - (Required) The name of the runtime config.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_runtimeconfig_variable" '(
    ("name" "name - (Required) The name of the variable to manage. Note that variable names can be hierarchical using slashes (e.g. \"prod-variables/hostname\").")
    ("parent" "parent - (Required) The name of the RuntimeConfig resource containing this variable.")
    ("text" "text or value - (Required) The content to associate with the variable. Exactly one of text or variable must be specified. If text is specified, it must be a valid UTF-8 string and less than 4096 bytes in length. If value is specified, it must be base64 encoded and less than 4096 bytes in length.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_sourcerepo_repository" '(
    ("name" "name - (Required) The name of the repository that will be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_database" '(
    ("instance" "instance - (Required) The name of the instance that will serve the new database.")
    ("name" "name - (Required) The name of the database.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_database_iam_binding" '(
    ("database" "database - (Required) The name of the Spanner database.")
    ("instance" "instance - (Required) The name of the Spanner instance the database belongs to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_spanner_database_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_spanner_database_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_database_iam_member" '(
    ("database" "database - (Required) The name of the Spanner database.")
    ("instance" "instance - (Required) The name of the Spanner instance the database belongs to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_spanner_database_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_spanner_database_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_database_iam_policy" '(
    ("database" "database - (Required) The name of the Spanner database.")
    ("instance" "instance - (Required) The name of the Spanner instance the database belongs to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_spanner_database_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_spanner_database_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_instance" '(
    ("config" "config - (Required) The name of the instance's configuration (similar but not quite the same as a region) which defines defines the geographic placement and replication of your databases in this instance. It determines where your data is stored. Values are typically of the form regional-europe-west1 , us-central etc. In order to obtain a valid list please consult the Configuration section of the docs.")
    ("display_name" "display_name - (Required) The descriptive name for this instance as it appears in UIs. Can be updated, however should be kept globally unique to avoid confusion.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_instance_iam_binding" '(
    ("instance" "instance - (Required) The name of the instance.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_spanner_instance_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_spanner_instance_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_instance_iam_member" '(
    ("instance" "instance - (Required) The name of the instance.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_spanner_instance_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_spanner_instance_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_spanner_instance_iam_policy" '(
    ("instance" "instance - (Required) The name of the instance.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_spanner_instance_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_spanner_instance_iam_policy) The policy data generated by a google_iam_policy data source.")
    ("project" "project - (Optional) The ID of the project in which the resource belongs. If it is not provided, the provider project is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_sql_database" '(
    ("name" "name - (Required) The name of the database.")
    ("instance" "instance - (Required) The name of containing instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_sql_database_instance" '(
    ("region" "region - (Required) The region the instance will sit in. Note, first-generation Cloud SQL instance regions do not line up with the Google Compute Engine (GCE) regions, and Cloud SQL is not available in all regions - choose from one of the options listed here.")
    ("settings" "settings - (Required) The settings to use for the database. The configuration is detailed below.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_sql_user" '(
    ("instance" "instance - (Required) The name of the Cloud SQL instance. Changing this forces a new resource to be created.")
    ("name" "name - (Required) The name of the user. Changing this forces a new resource to be created.")
    ("password" "password - (Optional) The password for the user. Can be updated.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_logging_billing_account_sink" '(
    ("name" "name - (Required) The name of the logging sink.")
    ("billing_account" "billing_account - (Required) The billing account exported to the sink.")
    ("destination" "destination - (Required) The destination of the sink (or, in other words, where logs are written to). Can be a Cloud Storage bucket, a PubSub topic, or a BigQuery dataset. Examples:  \"storage.googleapis.com/[GCS_BUCKET]\" \"bigquery.googleapis.com/projects/[PROJECT_ID]/datasets/[DATASET]\" \"pubsub.googleapis.com/projects/[PROJECT_ID]/topics/[TOPIC_ID]\"  The writer associated with the sink must have access to write to the above resource.")
    ("filter" "filter - (Optional) The filter to apply when exporting logs. Only log entries that match the filter are exported. See Advanced Log Filters for information on how to write a filter.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_logging_organization_sink" '(
    ("name" "name - (Required) The name of the logging sink.")
    ("org_id" "org_id - (Required) The numeric ID of the organization to be exported to the sink.")
    ("destination" "destination - (Required) The destination of the sink (or, in other words, where logs are written to). Can be a Cloud Storage bucket, a PubSub topic, or a BigQuery dataset. Examples:  \"storage.googleapis.com/[GCS_BUCKET]\" \"bigquery.googleapis.com/projects/[PROJECT_ID]/datasets/[DATASET]\" \"pubsub.googleapis.com/projects/[PROJECT_ID]/topics/[TOPIC_ID]\"  The writer associated with the sink must have access to write to the above resource.")
    ("filter" "filter - (Optional) The filter to apply when exporting logs. Only log entries that match the filter are exported. See Advanced Log Filters for information on how to write a filter.")
    ("include_children" "include_children - (Optional) Whether or not to include children organizations in the sink export. If true, logs associated with child projects are also exported; otherwise only logs relating to the provided organization are included.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_logging_folder_sink" '(
    ("name" "name - (Required) The name of the logging sink.")
    ("folder" "folder - (Required) The folder to be exported to the sink. Note that either [FOLDER_ID] or \"folders/[FOLDER_ID]\" is accepted.")
    ("destination" "destination - (Required) The destination of the sink (or, in other words, where logs are written to). Can be a Cloud Storage bucket, a PubSub topic, or a BigQuery dataset. Examples:  \"storage.googleapis.com/[GCS_BUCKET]\" \"bigquery.googleapis.com/projects/[PROJECT_ID]/datasets/[DATASET]\" \"pubsub.googleapis.com/projects/[PROJECT_ID]/topics/[TOPIC_ID]\"  The writer associated with the sink must have access to write to the above resource.")
    ("filter" "filter - (Optional) The filter to apply when exporting logs. Only log entries that match the filter are exported. See Advanced Log Filters for information on how to write a filter.")
    ("include_children" "include_children - (Optional) Whether or not to include children folders in the sink export. If true, logs associated with child projects are also exported; otherwise only logs relating to the provided folder are included.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_logging_project_sink" '(
    ("name" "name - (Required) The name of the logging sink.")
    ("destination" "destination - (Required) The destination of the sink (or, in other words, where logs are written to). Can be a Cloud Storage bucket, a PubSub topic, or a BigQuery dataset. Examples:  \"storage.googleapis.com/[GCS_BUCKET]\" \"bigquery.googleapis.com/projects/[PROJECT_ID]/datasets/[DATASET]\" \"pubsub.googleapis.com/projects/[PROJECT_ID]/topics/[TOPIC_ID]\"  The writer associated with the sink must have access to write to the above resource.")
    ("filter" "filter - (Optional) The filter to apply when exporting logs. Only log entries that match the filter are exported. See Advanced Log Filters for information on how to write a filter.")
    ("project" "project - (Optional) The ID of the project to create the sink in. If omitted, the project associated with the provider is used.")
    ("unique_writer_identity" "unique_writer_identity - (Optional) Whether or not to create a unique identity associated with this sink. If false (the default), then the writer_identity used is serviceAccount:cloud-logs@system.gserviceaccount.com. If true, then a unique service account is created and used for this sink. If you wish to publish logs across projects, you must set unique_writer_identity to true.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_bucket" '(
    ("name" "name - (Required) The name of the bucket.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_bucket_acl" '(
    ("bucket" "bucket - (Required) The name of the bucket it applies to.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_bucket_iam_binding" '(
    ("bucket" "bucket - (Required) The name of the bucket it applies to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_bucket_iam_member" '(
    ("bucket" "bucket - (Required) The name of the bucket it applies to.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_bucket_object" '(
    ("bucket" "bucket - (Required) The name of the containing bucket.")
    ("name" "name - (Required) The name of the object.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_default_object_acl" '(
    ("bucket" "bucket - (Required) The name of the bucket it applies to.")
    ("role_entity" "role_entity - (Required) List of role/entity pairs in the form ROLE:entity. See GCS Object ACL documentation for more details.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_notification" '(
    ("bucket" "bucket - (Required) The name of the bucket.")
    ("payload_format" "payload_format - (Required) The desired content of the Payload. One of \"JSON_API_V1\" or \"NONE\".")
    ("topic" "topic - (Required) The Cloud PubSub topic to which this subscription publishes.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_storage_object_acl" '(
    ("bucket" "bucket - (Required) The name of the bucket it applies to.")
    ("object" "object - (Required) The name of the object it applies to.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_key_ring" '(
    ("name" "name - (Required) The KeyRing's name. A KeyRing’s name must be unique within a location and match the regular expression [a-zA-Z0-9_-]{1,63}")
    ("location" "location - (Required) The Google Cloud Platform location for the KeyRing. A full list of valid locations can be found by running gcloud kms locations list.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_key_ring_iam_binding" '(
    ("key_ring_id" "key_ring_id - (Required) The key ring ID, in the form {project_id}/{location_name}/{key_ring_name} or {location_name}/{key_ring_name}. In the second form, the provider's project setting will be used as a fallback.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_kms_key_ring_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_kms_key_ring_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_key_ring_iam_member" '(
    ("key_ring_id" "key_ring_id - (Required) The key ring ID, in the form {project_id}/{location_name}/{key_ring_name} or {location_name}/{key_ring_name}. In the second form, the provider's project setting will be used as a fallback.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_kms_key_ring_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_kms_key_ring_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_key_ring_iam_policy" '(
    ("key_ring_id" "key_ring_id - (Required) The key ring ID, in the form {project_id}/{location_name}/{key_ring_name} or {location_name}/{key_ring_name}. In the second form, the provider's project setting will be used as a fallback.")
    ("member/members" "member/members - (Required) Identities that will be granted the privilege in role. Each entry can have one of the following values:  allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account.  allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account.  user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com or joe@example.com.  serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com.  group:{emailid}: An email address that represents a Google group. For example, admins@example.com.  domain:{domain}: A Google Apps domain name that represents all the users of that domain. For example, google.com or example.com.")
    ("role" "role - (Required) The role that should be applied. Only one google_kms_key_ring_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("policy_data" "policy_data - (Required only by google_kms_key_ring_iam_policy) The policy data generated by a google_iam_policy data source.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_crypto_key" '(
    ("name" "name - (Required) The CryptoKey's name. A CryptoKey’s name must be unique within a location and match the regular expression [a-zA-Z0-9_-]{1,63}")
    ("key_ring" "key_ring - (Required) The id of the Google Cloud Platform KeyRing to which the key shall belong.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_crypto_key_iam_binding" '(
    ("members" "members - (Required) A list of users that the role should apply to.")
    ("role" "role - (Required) The role that should be applied. Only one google_kms_crypto_key_iam_binding can be used per role. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("crypto_key_id" "crypto_key_id - (Required) The crypto key ID, in the form {project_id}/{location_name}/{key_ring_name}/{crypto_key_name} or {location_name}/{key_ring_name}/{crypto_key_name}. In the second form, the provider's project setting will be used as a fallback.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_kms_crypto_key_iam_member" '(
    ("member" "member - (Required) The user that the role should apply to.")
    ("role" "role - (Required) The role that should be applied. Note that custom roles must be of the format [projects|organizations]/{parent-name}/roles/{role-name}.")
    ("crypto_key_id" "crypto_key_id - (Required) The key ring ID, in the form {project_id}/{location_name}/{key_ring_name}/{crypto_key_name} or {location_name}/{key_ring_name}/{crypto_key_name}. In the second form, the provider's project setting will be used as a fallback.")

  ) company-terraform-resource-arguments-hash)

(puthash "google_cloudiot_registry" '(
    ("name" "name - (Required) A unique name for the resource, required by device registry. Changing this forces a new resource to be created.")

  ) company-terraform-resource-arguments-hash)

(puthash "grafana_alert_notification" '(
    ("name" "name - (Required) The name of the alert notification channel.")
    ("type" "type - (Required) The type of the alert notification channel.")
    ("is_default" "is_default - (Optional) Is this the default channel for all your alerts.")
    ("settings" "settings - (Optional) Additional settings, for full reference lookup Grafana HTTP API documentation.")

  ) company-terraform-resource-arguments-hash)

(puthash "grafana_dashboard" '(
    ("config_json" "config_json - (Required) The JSON configuration for the dashboard.")

  ) company-terraform-resource-arguments-hash)

(puthash "grafana_data_source" '(
    ("type" "type - (Required) The data source type. Must be one of the data source keywords supported by the Grafana server.")
    ("name" "name - (Required) A unique name for the data source within the Grafana server.")
    ("url" "url - (Optional) The URL for the data source. The type of URL required varies depending on the chosen data source type.")
    ("is_default" "is_default - (Optional) If true, the data source will be the default source used by the Grafana server. Only one data source on a server can be the default.")
    ("basic_auth_enabled" "basic_auth_enabled - (Optional) - If true, HTTP basic authentication will be used to make requests.")
    ("basic_auth_username" "basic_auth_username - (Required if basic_auth_enabled is true) The username to use for basic auth.")
    ("basic_auth_password" "basic_auth_password - (Required if basic_auth_enabled is true) The password to use for basic auth.")
    ("username" "username - (Required by some data source types) The username to use to authenticate to the data source.")
    ("password" "password - (Required by some data source types) The password to use to authenticate to the data source.")
    ("json_data" "json_data - (Required by some data source types) The default region and authentication type to access the data source. json_data is documented in more detail below.")
    ("secure_json_data" "secure_json_data - (Required by some data source types) The access and secret keys required to access the data source. secure_json_data is documented in more detail below.")
    ("database_name" "database_name - (Required by some data source types) The name of the database to use on the selected data source server.")
    ("access_mode" "access_mode - (Optional) The method by which the browser-based Grafana application will access the data source. The default is \"proxy\", which means that the application will make requests via a proxy endpoint on the Grafana server.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_addon" '(
    ("app" "app - (Required) The Heroku app to add to.")
    ("plan" "plan - (Required) The addon to add.")
    ("config" "config - (Optional) Optional plan configuration.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_addon_attachment" '(
    ("app_id" "app_id - (Required) The ID of the Heroku App to attach to.")
    ("addon_id" "addon_id - (Required) The ID of the existing Heroku Addon to attach.")
    ("name" "name - (Optional) A friendly name for the Heroku Addon Attachment.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_app" '(
    ("name" "name - (Required) The name of the application. In Heroku, this is also the unique ID, so it must be unique and have a minimum of 3 characters.")
    ("region" "region - (Required) The region that the app should be deployed in.")
    ("stack" "stack - (Optional) The application stack is what platform to run the application in.")
    ("buildpacks" "buildpacks - (Optional) Buildpack names or URLs for the application.  Buildpacks configured externally won't be altered if this is not present.")
    ("config_vars" "config_vars - (Optional) Configuration variables for the application.  The config variables in this map are not the final set of configuration  variables, but rather variables you want present. That is, other  configuration variables set externally won't be removed by Terraform  if they aren't present in this list.")
    ("space" "space - (Optional) The name of a private space to create the app in.")
    ("organization" "organization - (Optional) A block that can be specified once to define  organization settings for this app. The fields for this block are  documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_app_feature" '(
    ("app" "app - (Required) The Heroku app to link to.")
    ("name" "name - (Required) The name of the App Feature to manage.")
    ("enabled" "enabled - (Optional) Whether to enable or disable the App Feature. The default value is true.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_cert" '(
    ("app" "app - (Required) The Heroku app to add to.")
    ("certificate_chain" "certificate_chain - (Required) The certificate chain to add")
    ("private_key" "private_key - (Required) The private key for a given certificate chain")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_domain" '(
    ("hostname" "hostname - (Required) The hostname to serve requests from.")
    ("app" "app - (Required) The Heroku app to link to.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_drain" '(
    ("url" "url - (Required) The URL for Heroku to drain your logs to.")
    ("app" "app - (Required) The Heroku app to link to.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_pipeline" '(
    ("name" "name - (Required) The name of the pipeline.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_pipeline_coupling" '(
    ("app" "app - (Required) The name of the app for this coupling.")
    ("pipeline" "pipeline - (Required) The ID of the pipeline to add this app to.")
    ("stage" "stage - (Required) The stage to couple this app to. Must be one of review, development, staging, or production.")

  ) company-terraform-resource-arguments-hash)

(puthash "heroku_space" '(
    ("name" "name - (Required) The name of the space.")
    ("organization" "organization - (Required) The name of the organization which will own the space.")
    ("region" "region - (Optional) The region that the space should be created in.")

  ) company-terraform-resource-arguments-hash)

(puthash "icinga2_checkcommand" '(
    ("arguments" "arguments - (Optional) A mapping of arguments to include with the command.")
    ("command" "command - (Required) Path to the command te be executed.")
    ("name" "name - (Required) Name by which to reference the checkcommand")
    ("templates" "templates - (Optional) A list of Icinga2 templates to assign to the host.")

  ) company-terraform-resource-arguments-hash)

(puthash "icinga2_host" '(
    ("address" "address  - (Required) The address of the host.")
    ("check_command" "check_command - (Required) The name of an existing Icinga2 CheckCommand object that is used to determine if the host is available or not.")
    ("hostname" "hostname - (Required) The hostname of the host.")
    ("templates" "templates - (Optional) A list of Icinga2 templates to assign to the host.")
    ("vars" "vars - (Optional) A mapping of variables to assign to the host.")

  ) company-terraform-resource-arguments-hash)

(puthash "icinga2_hostgroup" '(
    ("name" "name - (Required) The name of the hostgroup.")
    ("display_name" "display_name - (Required) The name of the hostgroup to display in the Icinga2 interface.")

  ) company-terraform-resource-arguments-hash)

(puthash "icinga2_service" '(
    ("name" "name - (Required) The name of the Service object.")
    ("check_command" "check_command - (Required) The name of an existing Icinga2 CheckCommand object that is used to determine if the service is available on the host.")
    ("hostname" "hostname - (Required) The host to check the service's status on")

  ) company-terraform-resource-arguments-hash)

(puthash "influxdb_database" '(
    ("name" "name - (Required) The name for the database. This must be unique on the InfluxDB server.")
    ("retention_policies" "retention_policies - (Optional) A list of retention policies for specified database")

  ) company-terraform-resource-arguments-hash)

(puthash "influxdb_user" '(
    ("name" "name - (Required) The name for the user.")
    ("password" "password - (Required) The password for the user.")
    ("admin" "admin - (Optional) Mark the user as admin.")
    ("grant" "grant - (Optional) A list of grants for non-admin users")

  ) company-terraform-resource-arguments-hash)

(puthash "influxdb_continuous_query" '(
    ("name" "name - (Required) The name for the continuous_query. This must be unique on the InfluxDB server.")
    ("database" "database - (Required) The database for the continuous_query. This must be an existing influxdb database.")
    ("query" "query - (Required) The query for the continuous_query.")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_config_map" '(
    ("data" "data - (Optional) A map of the configuration data.")
    ("metadata" "metadata - (Required) Standard config map's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_horizontal_pod_autoscaler" '(
    ("metadata" "metadata - (Required) Standard horizontal pod autoscaler's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Required) Behaviour of the autoscaler. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#spec-and-status")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_limit_range" '(
    ("metadata" "metadata - (Required) Standard limit range's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Optional) Spec defines the limits enforced. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#spec-and-status")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_namespace" '(
    ("metadata" "metadata - (Required) Standard namespace's metadata.")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_persistent_volume" '(
    ("metadata" "metadata - (Required) Standard persistent volume's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Required) Spec of the persistent volume owned by the cluster. See below.")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_persistent_volume_claim" '(
    ("metadata" "metadata - (Required) Standard persistent volume claim's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Required) Spec defines the desired characteristics of a volume requested by a pod author. More info: http://kubernetes.io/docs/user-guide/persistent-volumes#persistentvolumeclaims")
    ("wait_until_bound" "wait_until_bound - (Optional) Whether to wait for the claim to reach Bound state (to find volume in which to claim the space)")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_pod" '(
    ("metadata" "metadata - (Required) Standard pod's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Required) Spec of the pod owned by the cluster")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_replication_controller" '(
    ("metadata" "metadata - (Required) Standard replication controller's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Required) Spec defines the specification of the desired behavior of the replication controller. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#spec-and-status")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_resource_quota" '(
    ("metadata" "metadata - (Required) Standard resource quota's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Optional) Spec defines the desired quota. https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#spec-and-status")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_secret" '(
    ("data" "data - (Optional) A map of the secret data.")
    ("metadata" "metadata - (Required) Standard secret's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("type" "type - (Optional) The secret type. Defaults to Opaque. More info: https://github.com/kubernetes/community/blob/master/contributors/design-proposals/auth/secrets.md#proposed-design")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_service" '(
    ("metadata" "metadata - (Required) Standard service's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("spec" "spec - (Required) Spec defines the behavior of a service. https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#spec-and-status")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_service_account" '(
    ("metadata" "metadata - (Required) Standard service account's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("image_pull_secret" "image_pull_secret - (Optional) A list of references to secrets in the same namespace to use for pulling any images in pods that reference this Service Account. More info: http://kubernetes.io/docs/user-guide/secrets#manually-specifying-an-imagepullsecret")
    ("secret" "secret - (Optional) A list of secrets allowed to be used by pods running using this Service Account. More info: http://kubernetes.io/docs/user-guide/secrets")

  ) company-terraform-resource-arguments-hash)

(puthash "kubernetes_storage_class" '(
    ("metadata" "metadata - (Required) Standard storage class's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")
    ("parameters" "parameters - (Optional) The parameters for the provisioner that should create volumes of this storage class. Read more about available parameters.")
    ("storage_provisioner" "storage_provisioner - (Required) Indicates the type of the provisioner")

  ) company-terraform-resource-arguments-hash)

(puthash "librato_alert" '(
    ("name" "name - (Required) The name of the alert.")
    ("description" "description - (Required) Description of the alert.")
    ("active" "active - whether the alert is active (can be triggered). Defaults to true.")
    ("rearm_seconds" "rearm_seconds - minimum amount of time between sending alert notifications, in seconds.")
    ("services" "services - list of notification service IDs.")
    ("condition" "condition - A trigger condition for the alert. Conditions documented below.")
    ("attributes" "attributes - A hash of additional attribtues for the alert. Attributes documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "librato_metric" '(
    ("type" "type - (Required) The type of metric to create (gauge, counter, or composite).")
    ("name" "name - (Required) The unique identifier of the metric.")
    ("display_name" "display_name - The name which will be used for the metric when viewing the Metrics website.")
    ("description" "description - Text that can be used to explain precisely what the metric is measuring.")
    ("period" "period - Number of seconds that is the standard reporting period of the metric.")
    ("attributes" "attributes - The attributes hash configures specific components of a metric’s visualization.")
    ("composite" "composite - The definition of the composite metric.")

  ) company-terraform-resource-arguments-hash)

(puthash "librato_service" '(
    ("type" "type - (Required) The type of notificaion.")
    ("title" "title - (Required) The alert title.")
    ("settings" "settings - (Required) a JSON hash of settings specific to the alert type.")

  ) company-terraform-resource-arguments-hash)

(puthash "librato_space" '(
    ("name" "name - (Required) The name of the space.")

  ) company-terraform-resource-arguments-hash)

(puthash "librato_space_chart" '(
    ("space_id" "space_id - (Required) The ID of the space this chart should be in.")
    ("name" "name - (Required) The title of the chart when it is displayed.")
    ("type" "type - (Optional) Indicates the type of chart. Must be one of line or stacked (default to line).")
    ("min" "min - (Optional) The minimum display value of the chart's Y-axis.")
    ("max" "max - (Optional) The maximum display value of the chart's Y-axis.")
    ("label" "label - (Optional) The Y-axis label.")
    ("related_space" "related_space - (Optional) The ID of another space to which this chart is related.")
    ("stream" "stream - (Optional) Nested block describing a metric to use for data in the chart. The structure of this block is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "file" '(
    ("content" "content - (Required) The content of file to create.")
    ("filename" "filename - (Required) The path of the file to create.")

  ) company-terraform-resource-arguments-hash)

(puthash "logentries_log" '(
    ("logset_id" "logset_id - (Required) The id of the logentries_logset resource.")
    ("name" "name - (Required) The name of the log. The name should be short and descriptive. For example, Apache Access, Hadoop Namenode.")
    ("filename" "filename - (Optional) the filename of the log.")
    ("retention_period" "retention_period - (Optional, default ACCOUNT_DEFAULT) The retention period (1W, 2W, 1M, 2M, 6M, 1Y, 2Y, UNLIMITED, ACCOUNT_DEFAULT)")
    ("source" "source - (Optional, default token) The log source (token, syslog, agent, api). Review the Logentries log inputs documentation for more information.")
    ("type" "type - (Optional) The log type. See the Logentries log type documentation for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "logentries_logset" '(
    ("name" "name - (Required) The log set name, which should be short and descriptive. For example, www, db1.")
    ("location" "location - (Optional, default \"nonlocation\") A location is for your convenience only. You can specify a DNS entry such as web.example.com, IP address or arbitrary comment.")

  ) company-terraform-resource-arguments-hash)

(puthash "logicmonitor_collector" '(
    ("backup_collector_id" "backup_collector_id - (Optional) The Id of the failover Collector configured for this Collector")
    ("collector_group_id" "collector_group_id - (Optional) The Id of the group the Collector is in")
    ("description" "description - (Optional) The Collector's description")
    ("enable_failback" "enable_failback - (Optional) Whether or not automatic failback is enabled for the Collector")
    ("enable_collector_device_failover" "enable_collector_device_failover - (Optional) Whether or not the device the Collector is installed on is enabled for fail over")
    ("escalation_chain_id" "escalation_chain_id - (Optional) The Id of the escalation chain associated with this Collector")
    ("resend_interval" "resend_interval - (Optional) The interval, in minutes, after which alert notifications for the Collector will be resent")
    ("suppress_alert_clear" "suppress_alert_clear - (Optional) Whether alert clear notifications are suppressed for the Collector")

  ) company-terraform-resource-arguments-hash)

(puthash "logicmonitor_collectorgroup" '(
    ("name" "name - (Required) Name of collector group")
    ("description" "description - (Optional) Set description of collector group")

  ) company-terraform-resource-arguments-hash)

(puthash "logicmonitor_device" '(
    ("ip_addr" "ip_addr - (Required) Ip Address/Hostname of device")
    ("collector" "collector - (required) The id of the collector that will monitoring the device")
    ("display_name" "display_name - (Optional) Display name of device, (default is ip_addr)")
    ("disable_alerting" "disable_alerting - (Optional) The host is created with alerting disabled (default is true)")
    ("hostgroup_id" "hostgroup_id - (Optional) The host group id that specifies which group the device belongs to (multiple host group ids can be added, represented by a comma separated string)")
    ("properties" "properties - (Optional) The properties associated with this device group. Any string value pair will work (see example).")

  ) company-terraform-resource-arguments-hash)

(puthash "logicmonitor_devicegroup" '(
    ("name" "name - (Required) Name of device group")
    ("description" "description - (Optional) Description of device group")
    ("parent_id" "parent_id - (Optional) The id of the parent group for this device group (the root device group has an Id of 1)")
    ("applies_to" "applies_to - (Optional) The Applies to custom query for this group. Setting this field will make this a dynamic group.")
    ("disable_alerting" "disable_alerting - (Optional) Indicates whether alerting is disabled (true) or enabled (false) for this device group")
    ("properties" "properties - (Optional) The properties associated with this device group. Any string value pair will work (see example).")

  ) company-terraform-resource-arguments-hash)

(puthash "mailgun_domain" '(
    ("name" "name - (Required) The domain to add to Mailgun")
    ("smtp_password" "smtp_password - (Required) Password for SMTP authentication")
    ("spam_action" "spam_action - (Optional) disabled or tag Disable, no spam filtering will occur for inbound messages. Tag, messages will be tagged with a spam header.")
    ("wildcard" "wildcard - (Optional) Boolean that determines whether the domain will accept email for sub-domains.")

  ) company-terraform-resource-arguments-hash)

(puthash "mysql_database" '(
    ("name" "name - (Required) The name of the database. This must be unique within a given MySQL server and may or may not be case-sensitive depending on the operating system on which the MySQL server is running.")
    ("default_character_set" "default_character_set - (Optional) The default character set to use when a table is created without specifying an explicit character set. Defaults to \"utf8\".")
    ("default_collation" "default_collation - (Optional) The default collation to use when a table is created without specifying an explicit collation. Defaults to utf8_general_ci. Each character set has its own set of collations, so changing the character set requires also changing the collation.")

  ) company-terraform-resource-arguments-hash)

(puthash "mysql_grant" '(
    ("user" "user - (Required) The name of the user.")
    ("host" "host - (Optional) The source host of the user. Defaults to \"localhost\".")
    ("database" "database - (Required) The database to grant privileges on. At this time, privileges are given to all tables on the database (mydb.*).")
    ("privileges" "privileges - (Required) A list of privileges to grant to the user. Refer to a list of privileges (such as here) for applicable privileges.")
    ("grant" "grant - (Optional) Whether to also give the user privileges to grant the same privileges to other users.")

  ) company-terraform-resource-arguments-hash)

(puthash "mysql_user" '(
    ("user" "user - (Required) The name of the user.")
    ("host" "host - (Optional) The source host of the user. Defaults to \"localhost\".")
    ("plaintext_password" "plaintext_password - (Optional) The password for the user. This must be provided in plain text, so the data source for it must be secured. An unsalted hash of the provided password is stored in state. Conflicts with auth_plugin.")
    ("password" "password - (Optional) Deprecated alias of plaintext_password, whose value is stored as plaintext in state. Prefer to use plaintext_password instead, which stores the password as an unsalted hash. Conflicts with auth_plugin.")
    ("auth_plugin" "auth_plugin - (Optional) Use an authentication plugin to authenticate the user instead of using password authentication. Description of the fields allowed in the block below. Conflicts with password and plaintext_password.")

  ) company-terraform-resource-arguments-hash)

(puthash "newrelic_alert_channel" '(
    ("name" "name - (Required) The name of the channel.")
    ("type" "type - (Required) The type of channel.  One of: campfire, email, hipchat, opsgenie, pagerduty, slack, victorops, or webhook.")
    ("configuration" "configuration - (Required) A map of key / value pairs with channel type specific values.")

  ) company-terraform-resource-arguments-hash)

(puthash "newrelic_alert_condition" '(
    ("policy_id" "policy_id - (Required) The ID of the policy where this condition should be used.")
    ("name" "name - (Required) The title of the condition")
    ("type" "type - (Required) The type of condition. One of: apm_app_metric, apm_jvm_metric, apm_kt_metric, servers_metric, browser_metric, mobile_metric")
    ("entities" "entities - (Required) The instance IDS associated with this condition.")
    ("metric" "metric - (Required) The metric field accepts parameters based on the type set.")
    ("gc_metric" "gc_metric - (Optional) A valid Garbage Collection metric e.g. GC/G1 Young Generation. This is required if you are using apm_jvm_metric with gc_cpu_time condition type.")
    ("violation_close_timer" "violation_close_timer - (Optional) Automatically close instance-based violations, including JVM health metric violations, after the number of hours specified. Must be: 1, 2, 4, 8, 12 or 24.")
    ("runbook_url" "runbook_url - (Optional) Runbook URL to display in notifications.")
    ("condition_scope" "condition_scope - (Optional) instance or application.  This is required if you are using the JVM plugin in New Relic.")
    ("term" "term - (Required) A list of terms for this condition. See Terms below for details.")
    ("user_defined_metric" "user_defined_metric - (Optional) A custom metric to be evaluated.")
    ("user_defined_value_function" "user_defined_value_function - (Optional) One of: average, min, max, total, or sample_size.")

  ) company-terraform-resource-arguments-hash)

(puthash "newrelic_alert_policy" '(
    ("name" "name - (Required) The name of the policy.")
    ("incident_preference" "incident_preference - (Optional) The rollup strategy for the policy.  Options include: PER_POLICY, PER_CONDITION, or PER_CONDITION_AND_TARGET.  The default is PER_POLICY.")

  ) company-terraform-resource-arguments-hash)

(puthash "newrelic_alert_policy_channel" '(
    ("policy_id" "policy_id - (Required) The ID of the policy.")
    ("channel_id" "channel_id - (Required) The ID of the channel.")

  ) company-terraform-resource-arguments-hash)

(puthash "newrelic_nrql_alert_condition" '(
    ("policy_id" "policy_id - (Required) The ID of the policy where this condition should be used.")
    ("name" "name - (Required) The title of the condition")
    ("runbook_url" "runbook_url - (Optional) Runbook URL to display in notifications.")
    ("enabled" "enabled - (Optional) Set whether to enable the alert condition. Defaults to true.")
    ("term" "term - (Required) A list of terms for this condition. See Terms below for details.")
    ("nrql" "nrql - (Required) A NRQL query. See NRQL below for details.")
    ("value_function" "value_function - (Optional) Possible values are single_value, sum.")

  ) company-terraform-resource-arguments-hash)

(puthash "newrelic_dashboard" '(
    ("title" "title - (Required) The title of the dashboard.")
    ("icon" "icon - (Optional) The icon for the dashboard.  Defaults to bar-chart.")
    ("visibility" "visibility - (Optional) Who can see the dashboard in an account. Must be owner or all. Defaults to all.")
    ("widget" "widget - (Optional) A widget that describes a visualization. See Widgets below for details.")
    ("editable" "editable - (Optional) Who can edit the dashboard in an account. Must be read_only, editable_by_owner, editable_by_all, or all. Defaults to editable_by_all.")

  ) company-terraform-resource-arguments-hash)

(puthash "nomad_acl_policy" '(
    ("name" "name (string: <required>) - A unique name for the policy.")
    ("rules_hcl" "rules_hcl (string: <required>) - The contents of the policy to register, as HCL or JSON.")
    ("description" "description (string: \"\") - A description of the policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "nomad_acl_token" '(
    ("type" "type (string: <required>) - The type of token this is. Use client for tokens that will have policies associated with them. Use management for tokens that can perform any action.")
    ("name" "name (string: \"\") - A human-friendly name for this token.")
    ("policies" "policies (set: []) - A set of policy names to associate with this token. Must be set on client-type tokens, must not be set on management-type tokens. Policies do not need to exist before being used here.")
    ("global" "global (bool: false) - Whether the token should be replicated to all regions, or if it will only be used in the region it was created in.")

  ) company-terraform-resource-arguments-hash)

(puthash "nomad_job" '(
    ("jobspec" "jobspec (string: <required>) - The contents of the jobspec to register.")
    ("deregister_on_destroy" "deregister_on_destroy (bool: true) - Determines if the job will be deregistered when this resource is destroyed in Terraform.")
    ("deregister_on_id_change" "deregister_on_id_change (bool: true) - Determines if the job will be deregistered if the ID of the job in the jobspec changes.")
    ("policy_override" "policy_override (bool: false) - Determins if the job will override any soft-mandatory Sentinel policies and register even if they fail.")

  ) company-terraform-resource-arguments-hash)

(puthash "nomad_namespace" '(
    ("name" "name (string: <required>) - A unique name for the namespace.")
    ("description" "description (string: \"\") - A description of the namespace.")

  ) company-terraform-resource-arguments-hash)

(puthash "nomad_quota_specification" '(
    ("name" "name (string: <required>) - A unique name for the quota specification.")
    ("description" "description (string: \"\") - A description of the quota specification.")
    ("limits" "limits (block: <required>) - A block of quota limits to enforce. Can be repeated. See below for the structure of this block.")

  ) company-terraform-resource-arguments-hash)

(puthash "nomad_sentinel_policy" '(
    ("name" "name (string: <required>) - A unique name for the policy.")
    ("policy" "policy (string: <required>) - The contents of the policy to register.")
    ("enforcement_level" "enforcement_level (strings: <required>) - The enforcement level for this policy.")
    ("scope" "scope (strings: <required>) - The scope for this policy.")
    ("description" "description (string: \"\") - A description of the policy.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_zone" '(
    ("zone" "zone - (Required) The domain name of the zone.")
    ("link" "link - (Optional) The target zone(domain name) to link to.")
    ("ttl" "ttl - (Optional) The SOA TTL.")
    ("refresh" "refresh - (Optional) The SOA Refresh.")
    ("retry" "retry - (Optional) The SOA Retry.")
    ("expiry" "expiry - (Optional) The SOA Expiry.")
    ("nx_ttl" "nx_ttl - (Optional) The SOA NX TTL.")
    ("primary" "primary - (Optional) The primary zones' ip. This makes the zone a secondary.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_record" '(
    ("zone" "zone - (Required) The zone the record belongs to.")
    ("domain" "domain - (Required) The records' domain.")
    ("type" "type - (Required) The records' RR type.")
    ("ttl" "ttl - (Optional) The records' time to live.")
    ("link" "link - (Optional) The target record to link to. This means this record is a 'linked' record, and it inherits all properties from its target.")
    ("use_client_subnet" "use_client_subnet - (Optional) Whether to use EDNS client subnet data when available(in filter chain).")
    ("answers" "answers - (Optional) One or more NS1 answers for the records' specified type. Answers are documented below.")
    ("filters" "filters - (Optional) One or more NS1 filters for the record(order matters). Filters are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_monitoringjob" '(
    ("name" "name - (Required) The free-form display name for the monitoring job.")
    ("job_type" "job_type - (Required) The type of monitoring job to be run.")
    ("active" "active - (Required) Indicates if the job is active or temporaril.y disabled.")
    ("regions" "regions - (Required) The list of region codes in which to run the monitoring job.")
    ("frequency" "frequency - (Required) The frequency, in seconds, at which to run the monitoring job in each region.")
    ("rapid_recheck" "rapid_recheck - (Required) If true, on any apparent state change, the job is quickly re-run after one second to confirm the state change before notification.")
    ("policy" "policy - (Required) The policy for determining the monitor's global status based on the status of the job in all regions.")
    ("config" "config - (Required) A configuration dictionary with keys and values depending on the jobs' type.")
    ("notify_delay" "notify_delay - (Optional) The time in seconds after a failure to wait before sending a notification.")
    ("notify_repeat" "notify_repeat - (Optional) The time in seconds between repeat notifications of a failed job.")
    ("notify_failback" "notify_failback - (Optional) If true, a notification is sent when a job returns to an \"up\" state.")
    ("notify_regional" "notify_regional - (Optional) If true, notifications are sent for any regional failure (and failback if desired), in addition to global state notifications.")
    ("notify_list" "notify_list - (Optional) The id of the notification list to send notifications to.")
    ("notes" "notes - (Optional) Freeform notes to be included in any notifications about this job.")
    ("rules" "rules - (Optional) A list of rules for determining failure conditions. Job Rules are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_notifylist" '(
    ("name" "name - (Required) The free-form display name for the notify list.")
    ("notifications" "notifications - (Optional) A list of notifiers. All notifiers in a notification list will receive notifications whenever an event is send to the list (e.g., when a monitoring job fails). Notifiers are documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_datasource" '(
    ("name" "name - (Required) The free form name of the data source.")
    ("sourcetype" "sourcetype - (Required) The data sources type, listed in API endpoint https://api.nsone.net/v1/data/sourcetypes.")
    ("config" "config - (Optional) The data source configuration, determined by its type.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_datafeed" '(
    ("source_id" "source_id - (Required) The data source id that this feed is connected to.")
    ("name" "name - (Required) The free form name of the data feed.")
    ("config" "config - (Optional) The feeds configuration matching the specification in 'feed_config' from /data/sourcetypes.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_apikey" '(
    ("name" "name - (Required) The free form name of the apikey.")
    ("key" "key - (Required) The apikeys authentication token.")
    ("teams" "teams - (Required) The teams that the apikey belongs to.")
    ("permissions" "permissions - (Optional) The allowed permissions of the apikey. Permissions documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_team" '(
    ("name" "name - (Required) The free form name of the team.")
    ("permissions" "permissions - (Optional) The allowed permissions of the team. Permissions documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "ns1_user" '(
    ("name" "name - (Required) The free form name of the user.")
    ("username" "username - (Required) The users login name.")
    ("email" "email - (Required) The email address of the user.")
    ("notify" "notify - (Required) The Whether or not to notify the user of specified events. Only billing is available currently.")
    ("teams" "teams - (Required) The teams that the user belongs to.")
    ("permissions" "permissions - (Optional) The allowed permissions of the user. Permissions documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "docs-oneandone-datasource-instance-size" '(
    ("name" "name -(Optional) Number of cores per processor")
    ("ram" "ram - (Optional) Size of ram in GB")
    ("vcores" "vcores - (Optional)  Number of vcores")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_block_storage" '(
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter, where the block storage will be created. Can be DE, GB, US or ES")
    ("description" "description - (Optional) Description for the block storage")
    ("name" "name - (Required) The name of the storage")
    ("server_id" "server_id - (Optional) ID of the server that the block storage will be attached to")
    ("size" "size - (Required) Size of the block storage (min: 20, max: 500, multipleOf: 10)")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_firewall_policy" '(
    ("description" "description - (Optional) Description for the VPN")
    ("name" "name - (Required) The name of the VPN.")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_loadbalancer" '(
    ("name" "name - (Required) The name of the load balancer.")
    ("description" "description - (Optional) Description for the load balancer")
    ("method" "method - (Required)  Balancing procedure Can be ROUND_ROBIN or LEAST_CONNECTIONS")
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter. Can be DE, GB, US or ES")
    ("persistence" "persistence - (Optional) True/false defines whether persistence should be turned on/off")
    ("persistence_time" "persistence_time - (Optional) Persistence duration in seconds")
    ("health_check_test" "health_check_test - (Optional) Can be TCP orICMP.")
    ("health_check_interval" "health_check_interval - (Optional)")
    ("health_check_path" "health_check_path - (Optional)")
    ("health_check_path_parser" "health_check_path_parser - (Optional)")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_monitoring_policy" '(
    ("name" "name - (Required) The name of the VPN.")
    ("description" "description - (Optional) Description for the VPN")
    ("email" "email - (Optional)  Email address to which notifications monitoring system will send")
    ("agent" "agent (Required) Indicates which monitoring type will be used. True: To use this monitoring type, you must install an agent on the server.  False: Monitor a server without installing an agent. Note: If you do not install an agent, you cannot retrieve information such as free hard disk space or ongoing processes.")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_private_network" '(
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter. Can be DE, GB, US or ES.")
    ("description" "description - (Optional) Description for the shared storage")
    ("name" "name - (Required) The name of the private network")
    ("network_address" "network_address - (Optional) Network address for the private network")
    ("subnet_mask" "subnet_mask - (Optional) Subnet mask for the private network")
    ("server_ids" "server_ids  (Optional) List of servers that are to be associated with the private network")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_public_ip" '(
    ("ip_type" "ip_type - (Required) IP type. Can be IPV4 or IPV6")
    ("reverse_dns" "reverse_dns - (Optional)")
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter. Can be DE, GB, US or ES.")
    ("ip_address" "ip_address - (Computed) The IP address.")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_server" '(
    ("cores_per_processor" "cores_per_processor -(Optional) Number of cores per processor")
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter. Can be DE, GB, US or ES")
    ("description" "description - (Optional) Description of the server")
    ("firewall_policy_id" "firewall_policy_id - (Optional) ID of firewall policy")
    ("fixed_instance_size" "fixed_instance_size - (Optional) ID of a fixed instance size")
    ("hdds" "hdds - (Optional) List of HDDs. One HDD must be main.")
    ("*disk_size" "*disk_size -(Required) The size of HDD")
    ("*is_main" "*is_main - (Optional) Indicates if HDD is to be used as main hard disk of the server")
    ("image" "image -(Required) The name of a desired image to be provisioned with the server")
    ("ip" "ip - (Optional) IP address for the server")
    ("loadbalancer_id" "loadbalancer_id - (Optional) ID of the load balancer")
    ("monitoring_policy_id" "monitoring_policy_id - (Optional) ID of monitoring policy")
    ("name" "name -(Required) The name of the server.")
    ("password" "password - (Optional) Desired password.")
    ("ram" "ram -(Optional) Size of ram.")
    ("ssh_key_path" "ssh_key_path - (Optional) Path to private ssh key")
    ("ssh_key_public" "ssh_key_public - (Optional) The public key data in OpenSSH authorized_keys format.")
    ("vcores" "vcores -(Optional) Number of virtual cores.")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_shared_storage" '(
    ("name" "name - (Required) The name of the storage")
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter. Can be DE, GB, US or ES")
    ("description" "description - (Optional) Description for the shared storage")
    ("size" "size - (Required) Size of the shared storage")
    ("storage_servers" "storage_servers  (Optional) List of servers that will have access to the stored storage   id - (Required) ID of the server  rights - (Required) Access rights to be assigned to the server. Can be RW or R")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_ssh_key" '(
    ("description" "description - (Optional) Description for the ssh key")
    ("name" "name - (Required) The name of the storage")
    ("public_key" "public_key - (Optional) Public key to import. If not given, new SSH key pair will be created and the private key is returned in the response")

  ) company-terraform-resource-arguments-hash)

(puthash "oneandone_vpn" '(
    ("datacenter" "datacenter - (Optional) Location of desired 1and1 datacenter. Can be DE, GB, US or ES.")
    ("name" "name - (Required) The name of the VPN")
    ("description" "description - (Optional)")
    ("download_path" "download_path - (Optional)")
    ("file_name" "file_name - (Optional)")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_blockstorage_volume_v1" '(
    ("region" "region - (Optional) The region in which to create the volume. If omitted, the region argument of the provider is used. Changing this creates a new volume.")
    ("size" "size - (Required) The size of the volume to create (in gigabytes). Changing this creates a new volume.")
    ("name" "name - (Optional) A unique name for the volume. Changing this updates the volume's name.")
    ("description" "description - (Optional) A description of the volume. Changing this updates the volume's description.")
    ("availability_zone" "availability_zone - (Optional) The availability zone for the volume. Changing this creates a new volume.")
    ("image_id" "image_id - (Optional) The image ID from which to create the volume. Changing this creates a new volume.")
    ("snapshot_id" "snapshot_id - (Optional) The snapshot ID from which to create the volume. Changing this creates a new volume.")
    ("source_vol_id" "source_vol_id - (Optional) The volume ID from which to create the volume. Changing this creates a new volume.")
    ("metadata" "metadata - (Optional) Metadata key/value pairs to associate with the volume. Changing this updates the existing volume metadata.")
    ("volume_type" "volume_type - (Optional) The type of volume to create. Changing this creates a new volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_blockstorage_volume_v2" '(
    ("region" "region - (Optional) The region in which to create the volume. If omitted, the region argument of the provider is used. Changing this creates a new volume.")
    ("size" "size - (Required) The size of the volume to create (in gigabytes). Changing this creates a new volume.")
    ("availability_zone" "availability_zone - (Optional) The availability zone for the volume. Changing this creates a new volume.")
    ("consistency_group_id" "consistency_group_id - (Optional) The consistency group to place the volume in.")
    ("description" "description - (Optional) A description of the volume. Changing this updates the volume's description.")
    ("image_id" "image_id - (Optional) The image ID from which to create the volume. Changing this creates a new volume.")
    ("metadata" "metadata - (Optional) Metadata key/value pairs to associate with the volume. Changing this updates the existing volume metadata.")
    ("name" "name - (Optional) A unique name for the volume. Changing this updates the volume's name.")
    ("snapshot_id" "snapshot_id - (Optional) The snapshot ID from which to create the volume. Changing this creates a new volume.")
    ("source_replica" "source_replica - (Optional) The volume ID to replicate with.")
    ("source_vol_id" "source_vol_id - (Optional) The volume ID from which to create the volume. Changing this creates a new volume.")
    ("volume_type" "volume_type - (Optional) The type of volume to create. Changing this creates a new volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_blockstorage_volume_attach_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Block Storage client. A Block Storage client is needed to create a volume attachment. If omitted, the region argument of the provider is used. Changing this creates a new volume attachment.")
    ("attach_mode" "attach_mode - (Optional) Specify whether to attach the volume as Read-Only (ro) or Read-Write (rw). Only values of ro and rw are accepted. If left unspecified, the Block Storage API will apply a default of rw.")
    ("device" "device - (Optional) The device to tell the Block Storage service this volume will be attached as. This is purely for informational purposes. You can specify auto or a device such as /dev/vdc.")
    ("host_name" "host_name - (Required) The host to attach the volume to.")
    ("initiator" "initiator - (Optional) The iSCSI initiator string to make the connection.")
    ("ip_address" "ip_address - (Optional) The IP address of the host_name above.")
    ("multipath" "multipath - (Optional) Whether to connect to this volume via multipath.")
    ("os_type" "os_type - (Optional) The iSCSI initiator OS type.")
    ("platform" "platform - (Optional) The iSCSI initiator platform.")
    ("volume_id" "volume_id - (Required) The ID of the Volume to attach to an Instance.")
    ("wwpn" "wwpn - (Optional) An array of wwpn strings. Used for Fibre Channel connections.")
    ("wwnn" "wwnn - (Optional) A wwnn name. Used for Fibre Channel connections.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_blockstorage_volume_v3" '(
    ("region" "region - (Optional) The region in which to create the volume. If omitted, the region argument of the provider is used. Changing this creates a new volume.")
    ("size" "size - (Required) The size of the volume to create (in gigabytes).")
    ("enable_online_resize" "enable_online_resize - (Optional) When this option is set it allows extending attached volumes. Note: updating size of an attached volume requires Cinder support for version 3.42 and a compatible storage driver.")
    ("availability_zone" "availability_zone - (Optional) The availability zone for the volume. Changing this creates a new volume.")
    ("consistency_group_id" "consistency_group_id - (Optional) The consistency group to place the volume in.")
    ("description" "description - (Optional) A description of the volume. Changing this updates the volume's description.")
    ("image_id" "image_id - (Optional) The image ID from which to create the volume. Changing this creates a new volume.")
    ("metadata" "metadata - (Optional) Metadata key/value pairs to associate with the volume. Changing this updates the existing volume metadata.")
    ("name" "name - (Optional) A unique name for the volume. Changing this updates the volume's name.")
    ("snapshot_id" "snapshot_id - (Optional) The snapshot ID from which to create the volume. Changing this creates a new volume.")
    ("source_replica" "source_replica - (Optional) The volume ID to replicate with.")
    ("source_vol_id" "source_vol_id - (Optional) The volume ID from which to create the volume. Changing this creates a new volume.")
    ("volume_type" "volume_type - (Optional) The type of volume to create. Changing this creates a new volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_blockstorage_volume_attach_v3" '(
    ("region" "region - (Optional) The region in which to obtain the V3 Block Storage client. A Block Storage client is needed to create a volume attachment. If omitted, the region argument of the provider is used. Changing this creates a new volume attachment.")
    ("attach_mode" "attach_mode - (Optional) Specify whether to attach the volume as Read-Only (ro) or Read-Write (rw). Only values of ro and rw are accepted. If left unspecified, the Block Storage API will apply a default of rw.")
    ("device" "device - (Optional) The device to tell the Block Storage service this volume will be attached as. This is purely for informational purposes. You can specify auto or a device such as /dev/vdc.")
    ("host_name" "host_name - (Required) The host to attach the volume to.")
    ("initiator" "initiator - (Optional) The iSCSI initiator string to make the connection.")
    ("ip_address" "ip_address - (Optional) The IP address of the host_name above.")
    ("multipath" "multipath - (Optional) Whether to connect to this volume via multipath.")
    ("os_type" "os_type - (Optional) The iSCSI initiator OS type.")
    ("platform" "platform - (Optional) The iSCSI initiator platform.")
    ("volume_id" "volume_id - (Required) The ID of the Volume to attach to an Instance.")
    ("wwpn" "wwpn - (Optional) An array of wwpn strings. Used for Fibre Channel connections.")
    ("wwnn" "wwnn - (Optional) A wwnn name. Used for Fibre Channel connections.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_flavor_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Flavors are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new flavor.")
    ("name" "name - (Required) A unique name for the flavor. Changing this creates a new flavor.")
    ("ram" "ram - (Required) The amount of RAM to use, in megabytes. Changing this creates a new flavor.")
    ("vcpus" "vcpus - (Required) The number of virtual CPUs to use. Changing this creates a new flavor.")
    ("disk" "disk - (Required) The amount of disk space in gigabytes to use for the root (/) partition. Changing this creates a new flavor.")
    ("swap" "swap - (Optional) The amount of disk space in megabytes to use. If unspecified, the default is 0. Changing this creates a new flavor.")
    ("rx_tx_factor" "rx_tx_factor - (Optional) RX/TX bandwith factor. The default is 1. Changing this creates a new flavor.")
    ("is_public" "is_public - (Optional) Whether the flavor is public. Changing this creates a new flavor.")
    ("extra_specs" "extra_specs - (Optional) Key/Value pairs of metadata for the flavor.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_floatingip_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. A Compute client is needed to create a floating IP that can be used with a compute instance. If omitted, the region argument of the provider is used. Changing this creates a new floating IP (which may or may not have a different address).")
    ("pool" "pool - (Required) The name of the pool from which to obtain the floating IP. Changing this creates a new floating IP.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_floatingip_associate_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Keypairs are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new floatingip_associate.")
    ("floating_ip" "floating_ip - (Required) The floating IP to associate.")
    ("instance_id" "instance_id - (Required) The instance to associte the floating IP with.")
    ("fixed_ip" "fixed_ip - (Optional) The specific IP address to direct traffic to.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_instance_v2" '(
    ("region" "region - (Optional) The region in which to create the server instance. If omitted, the region argument of the provider is used. Changing this creates a new server.")
    ("name" "name - (Required) A unique name for the resource.")
    ("image_id" "image_id - (Optional; Required if image_name is empty and not booting from a volume. Do not specify if booting from a volume.) The image ID of the desired image for the server. Changing this creates a new server.")
    ("image_name" "image_name - (Optional; Required if image_id is empty and not booting from a volume. Do not specify if booting from a volume.) The name of the desired image for the server. Changing this creates a new server.")
    ("flavor_id" "flavor_id - (Optional; Required if flavor_name is empty) The flavor ID of the desired flavor for the server. Changing this resizes the existing server.")
    ("flavor_name" "flavor_name - (Optional; Required if flavor_id is empty) The name of the desired flavor for the server. Changing this resizes the existing server.")
    ("user_data" "user_data - (Optional) The user data to provide when launching the instance. Changing this creates a new server.")
    ("security_groups" "security_groups - (Optional) An array of one or more security group names to associate with the server. Changing this results in adding/removing security groups from the existing server. Note: When attaching the instance to networks using Ports, place the security groups on the Port and not the instance.")
    ("availability_zone" "availability_zone - (Optional) The availability zone in which to create the server. Changing this creates a new server.")
    ("network" "network - (Optional) An array of one or more networks to attach to the instance. The network object structure is documented below. Changing this creates a new server.")
    ("metadata" "metadata - (Optional) Metadata key/value pairs to make available from within the instance. Changing this updates the existing server metadata.")
    ("config_drive" "config_drive - (Optional) Whether to use the config_drive feature to configure the instance. Changing this creates a new server.")
    ("admin_pass" "admin_pass - (Optional) The administrative password to assign to the server. Changing this changes the root password on the existing server.")
    ("key_pair" "key_pair - (Optional) The name of a key pair to put on the server. The key pair must already be created and associated with the tenant's account. Changing this creates a new server.")
    ("block_device" "block_device - (Optional) Configuration of block devices. The block_device structure is documented below. Changing this creates a new server. You can specify multiple block devices which will create an instance with multiple disks. This configuration is very flexible, so please see the following reference for more information.")
    ("scheduler_hints" "scheduler_hints - (Optional) Provide the Nova scheduler with hints on how the instance should be launched. The available hints are described below.")
    ("personality" "personality - (Optional) Customize the personality of an instance by defining one or more files and their contents. The personality structure is described below.")
    ("stop_before_destroy" "stop_before_destroy - (Optional) Whether to try stop instance gracefully before destroying it, thus giving chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.")
    ("force_delete" "force_delete - (Optional) Whether to force the OpenStack instance to be forcefully deleted. This is useful for environments that have reclaim / soft deletion enabled.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_keypair_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Keypairs are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new keypair.")
    ("name" "name - (Required) A unique name for the keypair. Changing this creates a new keypair.")
    ("public_key" "public_key - (Optional) A pregenerated OpenSSH-formatted public key. Changing this creates a new keypair. If a public key is not specified, then a public/private key pair will be automatically generated. If a pair is created, then destroying this resource means you will lose access to that keypair forever.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_secgroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. A Compute client is needed to create a security group. If omitted, the region argument of the provider is used. Changing this creates a new security group.")
    ("name" "name - (Required) A unique name for the security group. Changing this updates the name of an existing security group.")
    ("description" "description - (Required) A description for the security group. Changing this updates the description of an existing security group.")
    ("rule" "rule - (Optional) A rule describing how the security group operates. The rule object structure is documented below. Changing this updates the security group rules. As shown in the example above, multiple rule blocks may be used.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_servergroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. If omitted, the region argument of the provider is used. Changing this creates a new server group.")
    ("name" "name - (Required) A unique name for the server group. Changing this creates a new server group.")
    ("policies" "policies - (Required) The set of policies for the server group. Only two two policies are available right now, and both are mutually exclusive. See the Policies section for more information. Changing this creates a new server group.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_compute_volume_attach_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. A Compute client is needed to create a volume attachment. If omitted, the region argument of the provider is used. Changing this creates a new volume attachment.")
    ("instance_id" "instance_id - (Required) The ID of the Instance to attach the Volume to.")
    ("volume_id" "volume_id - (Required) The ID of the Volume to attach to an Instance.")
    ("device" "device - (Optional) The device of the volume attachment (ex: /dev/vdc). NOTE: Being able to specify a device is dependent upon the hypervisor in use. There is a chance that the device specified in Terraform will not be the same device the hypervisor chose. If this happens, Terraform will wish to update the device upon subsequent applying which will cause the volume to be detached and reattached indefinitely. Please use with caution.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_db_instance_v1" '(
    ("region" "region - (Required) The region in which to create the db instance. Changing this creates a new instance.")
    ("name" "name - (Required) A unique name for the resource.")
    ("flavor_id" "flavor_id - (Required) The flavor ID of the desired flavor for the instance. Changing this creates new instance.")
    ("configuration_id" "configuration_id - (Optional) Configuration ID to be attached to the instance. Database instance will be rebooted when configuration is detached.")
    ("size" "size - (Required) Specifies the volume size in GB. Changing this creates new instance.")
    ("datastore" "datastore - (Required) An array of database engine type and version. The datastore object structure is documented below. Changing this creates a new instance.")
    ("network" "network - (Optional) An array of one or more networks to attach to the instance. The network object structure is documented below. Changing this creates a new instance.")
    ("user" "user - (Optional) An array of username, password, host and databases. The user object structure is documented below.")
    ("database" "database - (Optional) An array of database name, charset and collate. The database object structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_db_database_v1" '(
    ("name" "name - (Required) A unique name for the resource.")
    ("instance_id" "instance_id - (Required) The ID for the database instance.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_db_user_v1" '(
    ("name" "name - (Required) A unique name for the resource.")
    ("instance" "instance - (Required) The ID for the database instance.")
    ("password" "password - (Required) User's password.")
    ("databases" "databases - (Optional) A list of database user should have access to.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_db_configuration_v1" '(
    ("region" "region - (Required) The region in which to create the db instance. Changing this creates a new instance.")
    ("name" "name - (Required) A unique name for the resource.")
    ("description" "description - (Optional) Description of the resource.")
    ("datastore" "datastore - (Required) An array of database engine type and version. The datastore object structure is documented below. Changing this creates resource.")
    ("configuration" "configuration - (Optional) An array of configuration parameter name and value. Can be specified multiple times. The configuration object structure is documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_dns_recordset_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 DNS client. If omitted, the region argument of the provider is used. Changing this creates a new DNS  record set.")
    ("zone_id" "zone_id - (Required) The ID of the zone in which to create the record set. Changing this creates a new DNS  record set.")
    ("name" "name - (Required) The name of the record set. Note the . at the end of the name. Changing this creates a new DNS  record set.")
    ("type" "type - (Optional) The type of record set. Examples: \"A\", \"MX\". Changing this creates a new DNS  record set.")
    ("ttl" "ttl - (Optional) The time to live (TTL) of the record set.")
    ("description" "description - (Optional) A description of the  record set.")
    ("records" "records - (Optional) An array of DNS records.")
    ("value_specs" "value_specs - (Optional) Map of additional options. Changing this creates a new record set.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_dns_zone_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Keypairs are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new DNS zone.")
    ("name" "name - (Required) The name of the zone. Note the . at the end of the name. Changing this creates a new DNS zone.")
    ("email" "email - (Optional) The email contact for the zone record.")
    ("type" "type - (Optional) The type of zone. Can either be PRIMARY or SECONDARY. Changing this creates a new zone.")
    ("attributes" "attributes - (Optional) Attributes for the DNS Service scheduler. Changing this creates a new zone.")
    ("ttl" "ttl - (Optional) The time to live (TTL) of the zone.")
    ("description" "description - (Optional) A description of the zone.")
    ("masters" "masters - (Optional) An array of master DNS servers. For when type is SECONDARY.")
    ("value_specs" "value_specs - (Optional) Map of additional options. Changing this creates a new zone.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_identity_project_v3" '(
    ("description" "description - (Optional) A description of the project.")
    ("domain_id" "domain_id - (Optional) The domain this project belongs to.")
    ("enabled" "enabled - (Optional) Whether the project is enabled or disabled. Valid values are true and false.")
    ("is_domain" "is_domain - (Optional) Whether this project is a domain. Valid values are true and false.")
    ("name" "name - (Optional) The name of the project.")
    ("parent_id" "parent_id - (Optional) The parent of this project.")
    ("region" "region - (Optional) The region in which to obtain the V3 Keystone client. If omitted, the region argument of the provider is used. Changing this creates a new User.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_identity_role_v3" '(
    ("name" "name - The name of the role.")
    ("domain_id" "domain_id - (Optional) The domain the role belongs to.")
    ("region" "region - (Optional) The region in which to obtain the V3 Keystone client. If omitted, the region argument of the provider is used. Changing this creates a new Role.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_identity_role_assignment_v3" '(
    ("domain_id" "domain_id - (Optional; Required if project_id is empty) The domain to assign the role in.")
    ("group_id" "group_id - (Optional; Required if user_id is empty) The group to assign the role to.")
    ("project_id" "project_id - (Optional; Required if domain_id is empty) The project to assign the role in.")
    ("user_id" "user_id - (Optional; Required if group_id is empty) The user to assign the role to.")
    ("role_id" "role_id - (Required) The role to assign.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_identity_user_v3" '(
    ("description" "description - (Optional) A description of the user.")
    ("default_project_id" "default_project_id - (Optional) The default project this user belongs to.")
    ("domain_id" "domain_id - (Optional) The domain this user belongs to.")
    ("enabled" "enabled - (Optional) Whether the user is enabled or disabled. Valid values are true and false.")
    ("extra" "extra - (Optional) Free-form key/value pairs of extra information.")
    ("ignore_change_password_upon_first_use" "ignore_change_password_upon_first_use - (Optional) User will not have to change their password upon first use. Valid values are true and false.")
    ("ignore_password_expiry" "ignore_password_expiry - (Optional) User's password will not expire. Valid values are true and false.")
    ("ignore_lockout_failure_attempts" "ignore_lockout_failure_attempts - (Optional) User will not have a failure lockout placed on their account. Valid values are true and false.")
    ("multi_factor_auth_enabled" "multi_factor_auth_enabled - (Optional) Whether to enable multi-factor authentication. Valid values are true and false.")
    ("multi_factor_auth_rule" "multi_factor_auth_rule - (Optional) A multi-factor authentication rule. The structure is documented below. Please see the Ocata release notes for more information on how to use mulit-factor rules.")
    ("name" "name - (Optional) The name of the user.")
    ("password" "password - (Optional) The password for the user.")
    ("region" "region - (Optional) The region in which to obtain the V3 Keystone client. If omitted, the region argument of the provider is used. Changing this creates a new User.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_images_image_v2" '(
    ("container_format" "container_format - (Required) The container format. Must be one of \"ami\", \"ari\", \"aki\", \"bare\", \"ovf\".")
    ("disk_format" "disk_format - (Required) The disk format. Must be one of \"ami\", \"ari\", \"aki\", \"vhd\", \"vmdk\", \"raw\", \"qcow2\", \"vdi\", \"iso\".")
    ("local_file_path" "local_file_path - (Optional) This is the filepath of the raw image file that will be uploaded to Glance. Conflicts with image_source_url.")
    ("image_cache_path" "image_cache_path - (Optional) This is the directory where the images will be downloaded. Images will be stored with a filename corresponding to the url's md5 hash. Defaults to \"$HOME/.terraform/image_cache\"")
    ("image_source_url" "image_source_url - (Optional) This is the url of the raw image that will be downloaded in the image_cache_path before being uploaded to Glance. Glance is able to download image from internet but the gophercloud library does not yet provide a way to do so. Conflicts with local_file_path.")
    ("min_disk_gb" "min_disk_gb - (Optional) Amount of disk space (in GB) required to boot image. Defaults to 0.")
    ("min_ram_mb" "min_ram_mb - (Optional) Amount of ram (in MB) required to boot image. Defauts to 0.")
    ("name" "name - (Required) The name of the image.")
    ("properties" "properties - (Optional) A map of key/value pairs to set freeform information about an image.")
    ("protected" "protected - (Optional) If true, image will not be deletable. Defaults to false.")
    ("region" "region - (Optional) The region in which to obtain the V2 Glance client. A Glance client is needed to create an Image that can be used with a compute instance. If omitted, the region argument of the provider is used. Changing this creates a new Image.")
    ("tags" "tags - (Optional) The tags of the image. It must be a list of strings. At this time, it is not possible to delete all tags of an image.")
    ("verify_checksum" "verify_checksum - (Optional) If false, the checksum will not be verified once the image is finished uploading. Defaults to true.")
    ("visibility" "visibility - (Optional) The visibility of the image. Must be one of \"public\", \"private\", \"community\", or \"shared\". The ability to set the visibility depends upon the configuration of the OpenStack cloud.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_floatingip_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a floating IP that can be used with another networking resource, such as a load balancer. If omitted, the region argument of the provider is used. Changing this creates a new floating IP (which may or may not have a different address).")
    ("pool" "pool - (Required) The name of the pool from which to obtain the floating IP. Changing this creates a new floating IP.")
    ("port_id" "port_id - (Optional) ID of an existing port with at least one IP address to associate with this floating IP.")
    ("tenant_id" "tenant_id - (Optional) The target tenant ID in which to allocate the floating IP, if you specify this together with a port_id, make sure the target port belongs to the same tenant. Changing this creates a new floating IP (which may or may not have a different address)")
    ("fixed_ip" "fixed_ip - Fixed IP of the port to associate with this floating IP. Required if the port has multiple fixed IPs.")
    ("subnet_id" "subnet_id - (Optional) The subnet ID of the floating IP pool. Specify this if the floating IP network has multiple subnets.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_floatingip_associate_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a floating IP that can be used with another networking resource, such as a load balancer. If omitted, the region argument of the provider is used. Changing this creates a new floating IP (which may or may not have a different address).")
    ("floating_ip" "floating_ip - (Required) IP Address of an existing floating IP.")
    ("port_id" "port_id - (Required) ID of an existing port with at least one IP address to associate with this floating IP.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_network_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a Neutron network. If omitted, the region argument of the provider is used. Changing this creates a new network.")
    ("name" "name - (Optional) The name of the network. Changing this updates the name of the existing network.")
    ("shared" "shared - (Optional)  Specifies whether the network resource can be accessed by any tenant or not. Changing this updates the sharing capabalities of the existing network.")
    ("tenant_id" "tenant_id - (Optional) The owner of the network. Required if admin wants to create a network for another tenant. Changing this creates a new network.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the network. Acceptable values are \"true\" and \"false\". Changing this value updates the state of the existing network.")
    ("segments" "segments - (Optional) An array of one or more provider segment objects.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")
    ("availability_zone_hints" "availability_zone_hints -  (Optional) An availability zone is used to make network resources highly available. Used for resources with high availability so that they are scheduled on different availability zones. Changing this  creates a new network.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_port_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a port. If omitted, the region argument of the provider is used. Changing this creates a new port.")
    ("name" "name - (Optional) A unique name for the port. Changing this updates the name of an existing port.")
    ("network_id" "network_id - (Required) The ID of the network to attach the port to. Changing this creates a new port.")
    ("admin_state_up" "admin_state_up - (Optional) Administrative up/down status for the port (must be \"true\" or \"false\" if provided). Changing this updates the admin_state_up of an existing port.")
    ("mac_address" "mac_address - (Optional) Specify a specific MAC address for the port. Changing this creates a new port.")
    ("tenant_id" "tenant_id - (Optional) The owner of the Port. Required if admin wants to create a port for another tenant. Changing this creates a new port.")
    ("device_owner" "device_owner - (Optional) The device owner of the Port. Changing this creates a new port.")
    ("security_group_ids" "security_group_ids - (Optional - Conflicts with no_security_groups) A list of security group IDs to apply to the port. The security groups must be specified by ID and not name (as opposed to how they are configured with the Compute Instance).")
    ("no_security_groups" "no_security_groups - (Optional - Conflicts with security_group_ids) If set to true, then no security groups are applied to the port. If set to false and no security_group_ids are specified, then the Port will yield to the default behavior of the Networking service, which is to usually apply the \"default\" security group.")
    ("device_id" "device_id - (Optional) The ID of the device attached to the port. Changing this creates a new port.")
    ("fixed_ip" "fixed_ip - (Optional) An array of desired IPs for this port. The structure is described below.")
    ("allowed_address_pairs" "allowed_address_pairs - (Optional) An IP/MAC Address pair of additional IP addresses that can be active on this port. The structure is described below.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_router_interface_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a router. If omitted, the region argument of the provider is used. Changing this creates a new router interface.")
    ("router_id" "router_id - (Required) ID of the router this interface belongs to. Changing this creates a new router interface.")
    ("subnet_id" "subnet_id - ID of the subnet this interface connects to. Changing this creates a new router interface.")
    ("port_id" "port_id - ID of the port this interface connects to. Changing this creates a new router interface.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_router_route_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to configure a routing entry on a router. If omitted, the region argument of the provider is used. Changing this creates a new routing entry.")
    ("router_id" "router_id - (Required) ID of the router this routing entry belongs to. Changing this creates a new routing entry.")
    ("destination_cidr" "destination_cidr - (Required) CIDR block to match on the packet’s destination IP. Changing this creates a new routing entry.")
    ("next_hop" "next_hop - (Required) IP address of the next hop gateway.  Changing this creates a new routing entry.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_router_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a router. If omitted, the region argument of the provider is used. Changing this creates a new router.")
    ("name" "name - (Optional) A unique name for the router. Changing this updates the name of an existing router.")
    ("admin_state_up" "admin_state_up - (Optional) Administrative up/down status for the router (must be \"true\" or \"false\" if provided). Changing this updates the admin_state_up of an existing router.")
    ("distributed" "distributed - (Optional) Indicates whether or not to create a distributed router. The default policy setting in Neutron restricts usage of this property to administrative users only.")
    ("external_gateway" "external_gateway - (Deprecated - use external_network_id instead) The network UUID of an external gateway for the router. A router with an external gateway is required if any compute instances or load balancers will be using floating IPs. Changing this updates the external gateway of an existing router.")
    ("external_network_id" "external_network_id - (Optional) The network UUID of an external gateway for the router. A router with an external gateway is required if any compute instances or load balancers will be using floating IPs. Changing this updates the external gateway of the router.")
    ("enable_snat" "enable_snat - (Optional) Enable Source NAT for the router. Valid values are \"true\" or \"false\". An external_network_id has to be set in order to set this property. Changing this updates the enable_snat of the router.")
    ("external_fixed_ip" "external_fixed_ip - (Optional) An external fixed IP for the router. This can be repeated. The structure is described below. An external_network_id has to be set in order to set this property. Changing this updates the external fixed IPs of the router.")
    ("tenant_id" "tenant_id - (Optional) The owner of the floating IP. Required if admin wants to create a router for another tenant. Changing this creates a new router.")
    ("value_specs" "value_specs - (Optional) Map of additional driver-specific options.")
    ("vendor_options" "vendor_options - (Optional) Map of additional vendor-specific options. Supported options are described below.")
    ("availability_zone_hints" "availability_zone_hints -  (Optional) An availability zone is used to make  network resources highly available. Used for resources with high availability so that they are scheduled on different availability zones. Changing this creates a new router.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_subnet_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a Neutron subnet. If omitted, the region argument of the provider is used. Changing this creates a new subnet.")
    ("network_id" "network_id - (Required) The UUID of the parent network. Changing this creates a new subnet.")
    ("cidr" "cidr - (Required) CIDR representing IP range for this subnet, based on IP version. Changing this creates a new subnet.")
    ("ip_version" "ip_version - (Optional) IP version, either 4 (default) or 6. Changing this creates a new subnet.")
    ("ipv6_address_mode" "ipv6_address_mode - (Optional) The IPv6 address mode. Valid values are dhcpv6-stateful, dhcpv6-stateless, or slaac.")
    ("ipv6_ra_mode" "ipv6_ra_mode - (Optional) The IPv6 Router Advertisement mode. Valid values are dhcpv6-stateful, dhcpv6-stateless, or slaac.")
    ("name" "name - (Optional) The name of the subnet. Changing this updates the name of the existing subnet.")
    ("tenant_id" "tenant_id - (Optional) The owner of the subnet. Required if admin wants to create a subnet for another tenant. Changing this creates a new subnet.")
    ("allocation_pools" "allocation_pools - (Optional) An array of sub-ranges of CIDR available for dynamic allocation to ports. The allocation_pool object structure is documented below. Changing this creates a new subnet.")
    ("gateway_ip" "gateway_ip - (Optional)  Default gateway used by devices in this subnet. Leaving this blank and not setting no_gateway will cause a default gateway of .1 to be used. Changing this updates the gateway IP of the existing subnet.")
    ("no_gateway" "no_gateway - (Optional) Do not set a gateway IP on this subnet. Changing this removes or adds a default gateway IP of the existing subnet.")
    ("enable_dhcp" "enable_dhcp - (Optional) The administrative state of the network. Acceptable values are \"true\" and \"false\". Changing this value enables or disables the DHCP capabilities of the existing subnet. Defaults to true.")
    ("dns_nameservers" "dns_nameservers - (Optional) An array of DNS name server names used by hosts in this subnet. Changing this updates the DNS name servers for the existing subnet.")
    ("host_routes" "host_routes - (Optional) An array of routes that should be used by devices with IPs from this subnet (not including local subnet route). The host_route object structure is documented below. Changing this updates the host routes for the existing subnet.")
    ("subnetpool_id" "subnetpool_id - (Optional) The ID of the subnetpool associated with the subnet.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_subnet_route_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to configure a routing entry on a subnet. If omitted, the region argument of the provider is used. Changing this creates a new routing entry.")
    ("subnet_id" "subnet_id - (Required) ID of the subnet this routing entry belongs to. Changing this creates a new routing entry.")
    ("destination_cidr" "destination_cidr - (Required) CIDR block to match on the packet’s destination IP. Changing this creates a new routing entry.")
    ("next_hop" "next_hop - (Required) IP address of the next hop gateway.  Changing this creates a new routing entry.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_subnetpool_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a Neutron subnetpool. If omitted, the region argument of the provider is used. Changing this creates a new subnetpool.")
    ("name" "name - (Required) The name of the subnetpool. Changing this updates the name of the existing subnetpool.")
    ("default_quota" "default_quota - (Optional) The per-project quota on the prefix space that can be allocated from the subnetpool for project subnets. Changing this updates the default quota of the existing subnetpool.")
    ("project_id" "project_id - (Optional) The owner of the subnetpool. Required if admin wants to create a subnetpool for another project. Changing this creates a new subnetpool.")
    ("prefixes" "prefixes - (Required) A list of subnet prefixes to assign to the subnetpool. Neutron API merges adjacent prefixes and treats them as a single prefix. Each subnet prefix must be unique among all subnet prefixes in all subnetpools that are associated with the address scope. Changing this updates the prefixes list of the existing subnetpool.")
    ("default_prefixlen" "default_prefixlen - (Optional) The size of the prefix to allocate when the cidr or prefixlen attributes are omitted when you create the subnet. Defaults to the MinPrefixLen. Changing this updates the default prefixlen of the existing subnetpool.")
    ("min_prefixlen" "min_prefixlen - (Optional) The smallest prefix that can be allocated from a subnetpool. For IPv4 subnetpools, default is 8. For IPv6 subnetpools, default is 64. Changing this updates the min prefixlen of the existing subnetpool.")
    ("max_prefixlen" "max_prefixlen - (Optional) The maximum prefix size that can be allocated from the subnetpool. For IPv4 subnetpools, default is 32. For IPv6 subnetpools, default is 128. Changing this updates the max prefixlen of the existing subnetpool.")
    ("address_scope_id" "address_scope_id - (Optional) The Neutron address scope to assign to the subnetpool. Changing this updates the address scope id of the existing subnetpool.")
    ("shared" "shared - (Optional) Indicates whether this subnetpool is shared across all projects. Changing this updates the shared status of the existing subnetpool.")
    ("description" "description - (Optional) The human-readable description for the subnetpool. Changing this updates the description of the existing subnetpool.")
    ("is_default" "is_default - (Optional) Indicates whether the subnetpool is default subnetpool or not. Changing this updates the default status of the existing subnetpool.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_secgroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a port. If omitted, the region argument of the provider is used. Changing this creates a new security group.")
    ("name" "name - (Required) A unique name for the security group.")
    ("description" "description - (Optional) A unique name for the security group.")
    ("tenant_id" "tenant_id - (Optional) The owner of the security group. Required if admin wants to create a port for another tenant. Changing this creates a new security group.")
    ("delete_default_rules" "delete_default_rules - (Optional) Whether or not to delete the default egress security rules. This is false by default. See the below note for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_networking_secgroup_rule_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a port. If omitted, the region argument of the provider is used. Changing this creates a new security group rule.")
    ("direction" "direction - (Required) The direction of the rule, valid values are ingress or egress. Changing this creates a new security group rule.")
    ("ethertype" "ethertype - (Required) The layer 3 protocol type, valid values are IPv4 or IPv6. Changing this creates a new security group rule.")
    ("protocol" "protocol - (Optional) The layer 4 protocol type, valid values are following. Changing this creates a new security group rule. This is required if you want to specify a port range.  tcp  udp  icmp  ah  dccp  egp  esp  gre  igmp  ipv6-encap  ipv6-frag  ipv6-icmp  ipv6-nonxt  ipv6-opts  ipv6-route  ospf  pgm  rsvp  sctp  udplite  vrrp")
    ("port_range_min" "port_range_min - (Optional) The lower part of the allowed port range, valid integer value needs to be between 1 and 65535. Changing this creates a new security group rule.")
    ("port_range_max" "port_range_max - (Optional) The higher part of the allowed port range, valid integer value needs to be between 1 and 65535. Changing this creates a new security group rule.")
    ("remote_ip_prefix" "remote_ip_prefix - (Optional) The remote CIDR, the value needs to be a valid CIDR (i.e. 192.168.0.0/16). Changing this creates a new security group rule.")
    ("remote_group_id" "remote_group_id - (Optional) The remote group id, the value needs to be an Openstack ID of a security group in the same tenant. Changing this creates a new security group rule.")
    ("security_group_id" "security_group_id - (Required) The security group id the rule should belong to, the value needs to be an Openstack ID of a security group in the same tenant. Changing this creates a new security group rule.")
    ("tenant_id" "tenant_id - (Optional) The owner of the security group. Required if admin wants to create a port for another tenant. Changing this creates a new security group rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_member_v1" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an LB member. If omitted, the region argument of the provider is used. Changing this creates a new LB member.")
    ("pool_id" "pool_id - (Required)  The ID of the LB pool. Changing this creates a new member.")
    ("address" "address - (Required) The IP address of the member. Changing this creates a new member.")
    ("port" "port - (Required) An integer representing the port on which the member is hosted. Changing this creates a new member.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the member. Acceptable values are 'true' and 'false'. Changing this value updates the state of the existing member.")
    ("tenant_id" "tenant_id - (Optional) The owner of the member. Required if admin wants to create a member for another tenant. Changing this creates a new member.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_monitor_v1" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an LB monitor. If omitted, the region argument of the provider is used. Changing this creates a new LB monitor.")
    ("type" "type - (Required) The type of probe, which is PING, TCP, HTTP, or HTTPS, that is sent by the monitor to verify the member state. Changing this creates a new monitor.")
    ("delay" "delay - (Required) The time, in seconds, between sending probes to members. Changing this creates a new monitor.")
    ("timeout" "timeout - (Required) Maximum number of seconds for a monitor to wait for a ping reply before it times out. The value must be less than the delay value. Changing this updates the timeout of the existing monitor.")
    ("max_retries" "max_retries - (Required) Number of permissible ping failures before changing the member's status to INACTIVE. Must be a number between 1 and 10. Changing this updates the max_retries of the existing monitor.")
    ("url_path" "url_path - (Optional) Required for HTTP(S) types. URI path that will be accessed if monitor type is HTTP or HTTPS. Changing this updates the url_path of the existing monitor.")
    ("http_method" "http_method - (Optional) Required for HTTP(S) types. The HTTP method used for requests by the monitor. If this attribute is not specified, it defaults to \"GET\". Changing this updates the http_method of the existing monitor.")
    ("expected_codes" "expected_codes - (Optional) equired for HTTP(S) types. Expected HTTP codes for a passing HTTP(S) monitor. You can either specify a single status like \"200\", or a range like \"200-202\". Changing this updates the expected_codes of the existing monitor.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the monitor. Acceptable values are \"true\" and \"false\". Changing this value updates the state of the existing monitor.")
    ("tenant_id" "tenant_id - (Optional) The owner of the monitor. Required if admin wants to create a monitor for another tenant. Changing this creates a new monitor.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_pool_v1" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an LB pool. If omitted, the region argument of the provider is used. Changing this creates a new LB pool.")
    ("name" "name - (Required) The name of the pool. Changing this updates the name of the existing pool.")
    ("protocol" "protocol - (Required)  The protocol used by the pool members, you can use either 'TCP, 'HTTP', or 'HTTPS'. Changing this creates a new pool.")
    ("subnet_id" "subnet_id - (Required) The network on which the members of the pool will be located. Only members that are on this network can be added to the pool. Changing this creates a new pool.")
    ("lb_method" "lb_method - (Required) The algorithm used to distribute load between the members of the pool. The current specification supports 'ROUND_ROBIN' and 'LEAST_CONNECTIONS' as valid values for this attribute.")
    ("lb_provider" "lb_provider - (Optional) The backend load balancing provider. For example: haproxy, F5, etc.")
    ("tenant_id" "tenant_id - (Optional) The owner of the pool. Required if admin wants to create a pool member for another tenant. Changing this creates a new pool.")
    ("monitor_ids" "monitor_ids - (Optional) A list of IDs of monitors to associate with the pool.")
    ("member" "member - (Optional) An existing node to add to the pool. Changing this updates the members of the pool. The member object structure is documented below. Please note that the member block is deprecated in favor of the openstack_lb_member_v1 resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_vip_v1" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a VIP. If omitted, the region argument of the provider is used. Changing this creates a new VIP.")
    ("name" "name - (Required) The name of the vip. Changing this updates the name of the existing vip.")
    ("subnet_id" "subnet_id - (Required) The network on which to allocate the vip's address. A tenant can only create vips on networks authorized by policy (e.g. networks that belong to them or networks that are shared). Changing this creates a new vip.")
    ("protocol" "protocol - (Required)  The protocol - can be either 'TCP, 'HTTP', or HTTPS'. Changing this creates a new vip.")
    ("port" "port - (Required) The port on which to listen for client traffic. Changing this creates a new vip.")
    ("pool_id" "pool_id - (Required) The ID of the pool with which the vip is associated. Changing this updates the pool_id of the existing vip.")
    ("tenant_id" "tenant_id - (Optional) The owner of the vip. Required if admin wants to create a vip member for another tenant. Changing this creates a new vip.")
    ("address" "address - (Optional)  The IP address of the vip. Changing this creates a new vip.")
    ("description" "description - (Optional) Human-readable description for the vip. Changing this updates the description of the existing vip.")
    ("persistence" "persistence - (Optional) Omit this field to prevent session persistence. The persistence object structure is documented below. Changing this updates the persistence of the existing vip.")
    ("conn_limit" "conn_limit - (Optional) The maximum number of connections allowed for the vip. Default is -1, meaning no limit. Changing this updates the conn_limit of the existing vip.")
    ("floating_ip" "floating_ip - (Optional) A Networking Floating IP that will be associated with the vip. The Floating IP must be provisioned already.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the vip. Acceptable values are \"true\" and \"false\". Changing this value updates the state of the existing vip.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_loadbalancer_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an LB member. If omitted, the region argument of the provider is used. Changing this creates a new LB member.")
    ("vip_subnet_id" "vip_subnet_id - (Required) The network on which to allocate the Loadbalancer's address. A tenant can only create Loadbalancers on networks authorized by policy (e.g. networks that belong to them or networks that are shared).  Changing this creates a new loadbalancer.")
    ("name" "name - (Optional) Human-readable name for the Loadbalancer. Does not have to be unique.")
    ("description" "description - (Optional) Human-readable description for the Loadbalancer.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the Loadbalancer.  Only administrative users can specify a tenant UUID other than their own.  Changing this creates a new loadbalancer.")
    ("vip_address" "vip_address - (Optional) The ip address of the load balancer. Changing this creates a new loadbalancer.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the Loadbalancer. A valid value is true (UP) or false (DOWN).")
    ("flavor" "flavor - (Optional) The UUID of a flavor. Changing this creates a new loadbalancer.")
    ("loadbalancer_provider" "loadbalancer_provider - (Optional) The name of the provider. Changing this creates a new loadbalancer.")
    ("security_group_ids" "security_group_ids - (Optional) A list of security group IDs to apply to the loadbalancer. The security groups must be specified by ID and not name (as opposed to how they are configured with the Compute Instance).")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_listener_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new Listener.")
    ("protocol" "protocol - (Required) The protocol - can either be TCP, HTTP, HTTPS or TERMINATED_HTTPS. Changing this creates a new Listener.")
    ("protocol_port" "protocol_port - (Required) The port on which to listen for client traffic. Changing this creates a new Listener.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the Listener.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new Listener.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The load balancer on which to provision this Listener. Changing this creates a new Listener.")
    ("name" "name - (Optional) Human-readable name for the Listener. Does not have to be unique.")
    ("default_pool_id" "default_pool_id - (Optional) The ID of the default pool with which the Listener is associated. Changing this creates a new Listener.")
    ("description" "description - (Optional) Human-readable description for the Listener.")
    ("connection_limit" "connection_limit - (Optional) The maximum number of connections allowed for the Listener.")
    ("default_tls_container_ref" "default_tls_container_ref - (Optional) A reference to a Barbican Secrets container which stores TLS information. This is required if the protocol is TERMINATED_HTTPS. See here for more information.")
    ("sni_container_refs" "sni_container_refs - (Optional) A list of references to Barbican Secrets containers which store SNI information. See here for more information.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the Listener. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_pool_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new pool.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the pool.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new pool.")
    ("name" "name - (Optional) Human-readable name for the pool.")
    ("description" "description - (Optional) Human-readable description for the pool.")
    ("protocol" "protocol = (Required) The protocol - can either be TCP, HTTP or HTTPS. Changing this creates a new pool.")
    ("loadbalancer_id" "loadbalancer_id - (Optional) The load balancer on which to provision this pool. Changing this creates a new pool. Note:  One of LoadbalancerID or ListenerID must be provided.")
    ("listener_id" "listener_id - (Optional) The Listener on which the members of the pool will be associated with. Changing this creates a new pool. Note:  One of LoadbalancerID or ListenerID must be provided.")
    ("lb_method" "lb_method - (Required) The load balancing algorithm to distribute traffic to the pool's members. Must be one of ROUND_ROBIN, LEAST_CONNECTIONS, or SOURCE_IP.")
    ("persistence" "persistence - Omit this field to prevent session persistence.  Indicates whether connections in the same session will be processed by the same Pool member or not. Changing this creates a new pool.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the pool. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_member_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new member.")
    ("pool_id" "pool_id - (Required) The id of the pool that this member will be assigned to.")
    ("subnet_id" "subnet_id - (Optional) The subnet in which to access the member")
    ("name" "name - (Optional) Human-readable name for the member.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the member.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new member.")
    ("address" "address - (Required) The IP address of the member to receive traffic from the load balancer. Changing this creates a new member.")
    ("protocol_port" "protocol_port - (Required) The port on which to listen for client traffic. Changing this creates a new member.")
    ("weight" "weight - (Optional)  A positive integer value that indicates the relative portion of traffic that this member should receive from the pool. For example, a member with a weight of 10 receives five times as much traffic as a member with a weight of 2.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the member. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_lb_monitor_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new monitor.")
    ("pool_id" "pool_id - (Required) The id of the pool that this monitor will be assigned to.")
    ("name" "name - (Optional) The Name of the Monitor.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the monitor.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new monitor.")
    ("type" "type - (Required) The type of probe, which is PING, TCP, HTTP, or HTTPS, that is sent by the load balancer to verify the member state. Changing this creates a new monitor.")
    ("delay" "delay - (Required) The time, in seconds, between sending probes to members.")
    ("timeout" "timeout - (Required) Maximum number of seconds for a monitor to wait for a ping reply before it times out. The value must be less than the delay value.")
    ("max_retries" "max_retries - (Required) Number of permissible ping failures before changing the member's status to INACTIVE. Must be a number between 1 and 10..")
    ("url_path" "url_path - (Optional) Required for HTTP(S) types. URI path that will be accessed if monitor type is HTTP or HTTPS.")
    ("http_method" "http_method - (Optional) Required for HTTP(S) types. The HTTP method used for requests by the monitor. If this attribute is not specified, it defaults to \"GET\".")
    ("expected_codes" "expected_codes - (Optional) Required for HTTP(S) types. Expected HTTP codes for a passing HTTP(S) monitor. You can either specify a single status like \"200\", or a range like \"200-202\".")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the monitor. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_fw_firewall_v1" '(
    ("region" "region - (Optional) The region in which to obtain the v1 networking client. A networking client is needed to create a firewall. If omitted, the region argument of the provider is used. Changing this creates a new firewall.")
    ("policy_id" "policy_id - (Required) The policy resource id for the firewall. Changing this updates the policy_id of an existing firewall.")
    ("name" "name - (Optional) A name for the firewall. Changing this updates the name of an existing firewall.")
    ("description" "description - (Required) A description for the firewall. Changing this updates the description of an existing firewall.")
    ("admin_state_up" "admin_state_up - (Optional) Administrative up/down status for the firewall (must be \"true\" or \"false\" if provided - defaults to \"true\"). Changing this updates the admin_state_up of an existing firewall.")
    ("tenant_id" "tenant_id - (Optional) The owner of the floating IP. Required if admin wants to create a firewall for another tenant. Changing this creates a new firewall.")
    ("associated_routers" "associated_routers - (Optional) Router(s) to associate this firewall instance with. Must be a list of strings. Changing this updates the associated routers of an existing firewall. Conflicts with no_routers.")
    ("no_routers" "no_routers - (Optional) Should this firewall not be associated with any routers (must be \"true\" or \"false\" if provide - defaults to \"false\"). Conflicts with associated_routers.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_fw_policy_v1" '(
    ("region" "region - (Optional) The region in which to obtain the v1 networking client. A networking client is needed to create a firewall policy. If omitted, the region argument of the provider is used. Changing this creates a new firewall policy.")
    ("name" "name - (Optional) A name for the firewall policy. Changing this updates the name of an existing firewall policy.")
    ("description" "description - (Optional) A description for the firewall policy. Changing this updates the description of an existing firewall policy.")
    ("rules" "rules - (Optional) An array of one or more firewall rules that comprise the policy. Changing this results in adding/removing rules from the existing firewall policy.")
    ("audited" "audited - (Optional) Audit status of the firewall policy (must be \"true\" or \"false\" if provided - defaults to \"false\"). This status is set to \"false\" whenever the firewall policy or any of its rules are changed. Changing this updates the audited status of an existing firewall policy.")
    ("shared" "shared - (Optional) Sharing status of the firewall policy (must be \"true\" or \"false\" if provided). If this is \"true\" the policy is visible to, and can be used in, firewalls in other tenants. Changing this updates the shared status of an existing firewall policy. Only administrative users can specify if the policy should be shared.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_fw_rule_v1" '(
    ("region" "region - (Optional) The region in which to obtain the v1 Compute client. A Compute client is needed to create a firewall rule. If omitted, the region argument of the provider is used. Changing this creates a new firewall rule.")
    ("name" "name - (Optional) A unique name for the firewall rule. Changing this updates the name of an existing firewall rule.")
    ("description" "description - (Optional) A description for the firewall rule. Changing this updates the description of an existing firewall rule.")
    ("protocol" "protocol - (Required) The protocol type on which the firewall rule operates. Valid values are: tcp, udp, icmp, and any. Changing this updates the protocol of an existing firewall rule.")
    ("action" "action - (Required) Action to be taken ( must be \"allow\" or \"deny\") when the firewall rule matches. Changing this updates the action of an existing firewall rule.")
    ("ip_version" "ip_version - (Optional) IP version, either 4 (default) or 6. Changing this updates the ip_version of an existing firewall rule.")
    ("source_ip_address" "source_ip_address - (Optional) The source IP address on which the firewall rule operates. Changing this updates the source_ip_address of an existing firewall rule.")
    ("destination_ip_address" "destination_ip_address - (Optional) The destination IP address on which the firewall rule operates. Changing this updates the destination_ip_address of an existing firewall rule.")
    ("source_port" "source_port - (Optional) The source port on which the firewall rule operates. Changing this updates the source_port of an existing firewall rule.")
    ("destination_port" "destination_port - (Optional) The destination port on which the firewall rule operates. Changing this updates the destination_port of an existing firewall rule.")
    ("enabled" "enabled - (Optional) Enabled status for the firewall rule (must be \"true\" or \"false\" if provided - defaults to \"true\"). Changing this updates the enabled status of an existing firewall rule.")
    ("tenant_id" "tenant_id - (Optional) The owner of the firewall rule. Required if admin wants to create a firewall rule for another tenant. Changing this creates a new firewall rule.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_objectstorage_container_v1" '(
    ("region" "region - (Optional) The region in which to create the container. If omitted, the region argument of the provider is used. Changing this creates a new container.")
    ("name" "name - (Required) A unique name for the container. Changing this creates a new container.")
    ("container_read" "container_read - (Optional) Sets an access control list (ACL) that grants read access. This header can contain a comma-delimited list of users that can read the container (allows the GET method for all objects in the container). Changing this updates the access control list read access.")
    ("container_sync_to" "container_sync_to - (Optional) The destination for container synchronization. Changing this updates container synchronization.")
    ("container_sync_key" "container_sync_key - (Optional) The secret key for container synchronization. Changing this updates container synchronization.")
    ("container_write" "container_write - (Optional) Sets an ACL that grants write access. Changing this updates the access control list write access.")
    ("metadata" "metadata - (Optional) Custom key/value pairs to associate with the container. Changing this updates the existing container metadata.")
    ("content_type" "content_type - (Optional) The MIME type for the container. Changing this updates the MIME type.")
    ("force_destroy" "force_destroy -  (Optional, Default:false ) A boolean that indicates all objects should be deleted from the container so that the container can be destroyed without error. These objects are not recoverable.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_objectstorage_object_v1" '(
    ("container_name" "container_name - (Required) A unique (within an account) name for the container.  The container name must be from 1 to 256 characters long and can start  with any character and contain any pattern. Character set must be UTF-8.  The container name cannot contain a slash (/) character because this  character delimits the container and object name. For example, the path  /v1/account/www/pages specifies the www container, not the www/pages container.")
    ("content" "content - (Optional) A string representing the content of the object. Conflicts with source and copy_from.")
    ("content_disposition" "content_disposition - (Optional) A string which specifies the override behavior for   the browser. For example, this header might specify that the browser use a download  program to save this file rather than show the file, which is the default.")
    ("content_encoding" "content_encoding - (Optional) A string representing the value of the Content-Encoding  metadata.")
    ("content_type" "content_type - (Optional) A string which sets the MIME type for the object.")
    ("copy_from" "copy_from - (Optional) A string representing the name of an object  used to create the new object by copying the copy_from object. The value is in form  {container}/{object}. You must UTF-8-encode and then URL-encode the names of the  container and object before you include them in the header. Conflicts with source and  content.")
    ("delete_after" "delete_after - (Optional) An integer representing the number of seconds after which the system removes the object. Internally, the Object Storage system stores this value in  the X-Delete-At metadata item.")
    ("delete_at" "delete_at - (Optional) An string representing the date when the system removes the object.  For example, \"2015-08-26\" is equivalent to Mon, Wed, 26 Aug 2015 00:00:00 GMT.")
    ("detect_content_type" "detect_content_type - (Optional) If set to true, Object Storage guesses the content  type based on the file extension and ignores the value sent in the Content-Type  header, if present.")
    ("etag" "etag - (Optional) Used to trigger updates. The only meaningful value is ${md5(file(\"path/to/file\"))}.")
    ("name" "name - (Required) A unique name for the object.")
    ("object_manifest" "object_manifest - (Optional) A string set to specify that this is a dynamic large  object manifest object. The value is the container and object name prefix of the segment objects in the form container/prefix. You must UTF-8-encode and then  URL-encode the names of the container and prefix before you include them in this  header.")
    ("region" "region - (Optional) The region in which to create the container. If omitted, the region argument of the provider is used. Changing this creates a new container.")
    ("source" "source - (Optional) A string representing the local path of a file which will be used as the object's content. Conflicts with source and copy_from.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_vpnaas_ipsec_policy_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an IPSec policy. If omitted, the region argument of the provider is used. Changing this creates a new policy.")
    ("name" "name - (Optional) The name of the policy. Changing this updates the name of the existing policy.")
    ("tenant_id" "tenant_id - (Optional) The owner of the policy. Required if admin wants to create a policy for another project. Changing this creates a new policy.")
    ("description" "description - (Optional) The human-readable description for the policy. Changing this updates the description of the existing policy.")
    ("auth_algorithm" "auth_algorithm - (Optional) The authentication hash algorithm. Valid values are sha1, sha256, sha384, sha512. Default is sha1. Changing this updates the algorithm of the existing policy.")
    ("encapsulation_mode" "encapsulation_mode - (Optional) The encapsulation mode. Valid values are tunnel and transport. Default is tunnel. Changing this updates the existing policy.")
    ("encryption_algorithm" "encryption_algorithm - (Optional) The encryption algorithm. Valid values are 3des, aes-128, aes-192 and so on. The default value is aes-128. Changing this updates the existing policy.")
    ("pfs" "pfs - (Optional) The perfect forward secrecy mode. Valid values are Group2, Group5 and Group14. Default is Group5. Changing this updates the existing policy.")
    ("transform_protocol" "transform_protocol - (Optional) The transform protocol. Valid values are ESP, AH and AH-ESP. Changing this updates the existing policy. Default is ESP.")
    ("lifetime" "lifetime - (Optional) The lifetime of the security association. Consists of Unit and Value.  unit - (Optional) The units for the lifetime of the security association. Can be either seconds or kilobytes. Default is seconds.  value - (Optional) The value for the lifetime of the security association. Must be a positive integer. Default is 3600.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_vpnaas_ike_policy_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a VPN service. If omitted, the region argument of the provider is used. Changing this creates a new service.")
    ("name" "name - (Optional) The name of the policy. Changing this updates the name of the existing policy.")
    ("tenant_id" "tenant_id - (Optional) The owner of the policy. Required if admin wants to create a service for another policy. Changing this creates a new policy.")
    ("description" "description - (Optional) The human-readable description for the policy. Changing this updates the description of the existing policy.")
    ("auth_algorithm" "auth_algorithm - (Optional) The authentication hash algorithm. Valid values are sha1, sha256, sha384, sha512. Default is sha1. Changing this updates the algorithm of the existing policy.")
    ("encryption_algorithm" "encryption_algorithm - (Optional) The encryption algorithm. Valid values are 3des, aes-128, aes-192 and so on. The default value is aes-128. Changing this updates the existing policy.")
    ("pfs" "pfs - (Optional) The perfect forward secrecy mode. Valid values are Group2, Group5 and Group14. Default is Group5. Changing this updates the existing policy.")
    ("phase1_negotiation_mode" "phase1_negotiation_mode - (Optional) The IKE mode. A valid value is main, which is the default. Changing this updates the existing policy.")
    ("ike_version" "ike_version - (Optional) The IKE mode. A valid value is v1 or v2. Default is v1. Changing this updates the existing policy.")
    ("lifetime" "lifetime - (Optional) The lifetime of the security association. Consists of Unit and Value.  unit - (Optional) The units for the lifetime of the security association. Can be either seconds or kilobytes. Default is seconds.  value - (Optional) The value for the lifetime of the security association. Must be a positive integer. Default is 3600.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_vpnaas_service_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a VPN service. If omitted, the region argument of the provider is used. Changing this creates a new service.")
    ("name" "name - (Optional) The name of the service. Changing this updates the name of the existing service.")
    ("tenant_id" "tenant_id - (Optional) The owner of the service. Required if admin wants to create a service for another project. Changing this creates a new service.")
    ("description" "description - (Optional) The human-readable description for the service. Changing this updates the description of the existing service.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the resource. Can either be up(true) or down(false). Changing this updates the administrative state of the existing service.")
    ("subnet_id" "subnet_id - (Optional) SubnetID is the ID of the subnet. Default is null.")
    ("router_id" "router_id - (Required) The ID of the router. Changing this creates a new service.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "openstack_vpnaas_endpoint_group_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an endpoint group. If omitted, the region argument of the provider is used. Changing this creates a new group.")
    ("name" "name - (Optional) The name of the group. Changing this updates the name of the existing group.")
    ("tenant_id" "tenant_id - (Optional) The owner of the group. Required if admin wants to create an endpoint group for another project. Changing this creates a new group.")
    ("description" "description - (Optional) The human-readable description for the group. Changing this updates the description of the existing group.")
    ("type" "type -  The type of the endpoints in the group. A valid value is subnet, cidr, network, router, or vlan. Changing this creates a new group.")
    ("endpoints" "endpoints - List of endpoints of the same type, for the endpoint group. The values will depend on the type. Changing this creates a new group.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_blockstorage_volume_v2" '(
    ("region" "region - (Optional) The region in which to create the volume. If omitted, the region argument of the provider is used. Changing this creates a new volume.")
    ("size" "size - (Required) The size of the volume to create (in gigabytes). Changing this creates a new volume.")
    ("availability_zone" "availability_zone - (Optional) The availability zone for the volume. Changing this creates a new volume.")
    ("consistency_group_id" "consistency_group_id - (Optional) The consistency group to place the volume in.")
    ("description" "description - (Optional) A description of the volume. Changing this updates the volume's description.")
    ("image_id" "image_id - (Optional) The image ID from which to create the volume. Changing this creates a new volume.")
    ("metadata" "metadata - (Optional) Metadata key/value pairs to associate with the volume. Changing this updates the existing volume metadata.")
    ("name" "name - (Optional) A unique name for the volume. Changing this updates the volume's name.")
    ("snapshot_id" "snapshot_id - (Optional) The snapshot ID from which to create the volume. Changing this creates a new volume.")
    ("source_replica" "source_replica - (Optional) The volume ID to replicate with.")
    ("source_vol_id" "source_vol_id - (Optional) The volume ID from which to create the volume. Changing this creates a new volume.")
    ("volume_type" "volume_type - (Optional) The type of volume to create. Changing this creates a new volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_floatingip_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. A Compute client is needed to create a floating IP that can be used with a compute instance. If omitted, the region argument of the provider is used. Changing this creates a new floating IP (which may or may not have a different address).")
    ("pool" "pool - (Required) The name of the pool from which to obtain the floating IP. Changing this creates a new floating IP.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_floatingip_associate_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Keypairs are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new floatingip_associate.")
    ("floating_ip" "floating_ip - (Required) The floating IP to associate.")
    ("instance_id" "instance_id - (Required) The instance to associte the floating IP with.")
    ("fixed_ip" "fixed_ip - (Optional) The specific IP address to direct traffic to.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_instance_v2" '(
    ("region" "region - (Optional) The region in which to create the server instance. If omitted, the region argument of the provider is used. Changing this creates a new server.")
    ("name" "name - (Required) A unique name for the resource.")
    ("image_id" "image_id - (Optional; Required if image_name is empty and not booting from a volume. Do not specify if booting from a volume.) The image ID of the desired image for the server. Changing this creates a new server.")
    ("image_name" "image_name - (Optional; Required if image_id is empty and not booting from a volume. Do not specify if booting from a volume.) The name of the desired image for the server. Changing this creates a new server.")
    ("flavor_id" "flavor_id - (Optional; Required if flavor_name is empty) The flavor ID of the desired flavor for the server. Changing this resizes the existing server.")
    ("flavor_name" "flavor_name - (Optional; Required if flavor_id is empty) The name of the desired flavor for the server. Changing this resizes the existing server.")
    ("user_data" "user_data - (Optional) The user data to provide when launching the instance. Changing this creates a new server.")
    ("security_groups" "security_groups - (Optional) An array of one or more security group names to associate with the server. Changing this results in adding/removing security groups from the existing server. Note: When attaching the instance to networks using Ports, place the security groups on the Port and not the instance.")
    ("availability_zone" "availability_zone - (Optional) The availability zone in which to create the server. Changing this creates a new server.")
    ("network" "network - (Optional) An array of one or more networks to attach to the instance. The network object structure is documented below. Changing this creates a new server.")
    ("metadata" "metadata - (Optional) Metadata key/value pairs to make available from within the instance. Changing this updates the existing server metadata.")
    ("config_drive" "config_drive - (Optional) Whether to use the config_drive feature to configure the instance. Changing this creates a new server.")
    ("admin_pass" "admin_pass - (Optional) The administrative password to assign to the server. Changing this changes the root password on the existing server.")
    ("key_pair" "key_pair - (Optional) The name of a key pair to put on the server. The key pair must already be created and associated with the tenant's account. Changing this creates a new server.")
    ("block_device" "block_device - (Optional) Configuration of block devices. The block_device structure is documented below. Changing this creates a new server. You can specify multiple block devices which will create an instance with multiple disks. This configuration is very flexible, so please see the following reference for more information.")
    ("scheduler_hints" "scheduler_hints - (Optional) Provide the Nova scheduler with hints on how the instance should be launched. The available hints are described below.")
    ("personality" "personality - (Optional) Customize the personality of an instance by defining one or more files and their contents. The personality structure is described below.")
    ("stop_before_destroy" "stop_before_destroy - (Optional) Whether to try stop instance gracefully before destroying it, thus giving chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.")
    ("force_delete" "force_delete - (Optional) Whether to force the OpenTelekomCloud instance to be forcefully deleted. This is useful for environments that have reclaim / soft deletion enabled.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_keypair_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Keypairs are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new keypair.")
    ("name" "name - (Required) A unique name for the keypair. Changing this creates a new keypair.")
    ("public_key" "public_key - (Required) A pregenerated OpenSSH-formatted public key. Changing this creates a new keypair.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_secgroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. A Compute client is needed to create a security group. If omitted, the region argument of the provider is used. Changing this creates a new security group.")
    ("name" "name - (Required) A unique name for the security group. Changing this updates the name of an existing security group.")
    ("description" "description - (Required) A description for the security group. Changing this updates the description of an existing security group.")
    ("rule" "rule - (Optional) A rule describing how the security group operates. The rule object structure is documented below. Changing this updates the security group rules. As shown in the example above, multiple rule blocks may be used.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_servergroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. If omitted, the region argument of the provider is used. Changing this creates a new server group.")
    ("name" "name - (Required) A unique name for the server group. Changing this creates a new server group.")
    ("policies" "policies - (Required) The set of policies for the server group. Only two two policies are available right now, and both are mutually exclusive. See the Policies section for more information. Changing this creates a new server group.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_compute_volume_attach_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. A Compute client is needed to create a volume attachment. If omitted, the region argument of the provider is used. Changing this creates a new volume attachment.")
    ("instance_id" "instance_id - (Required) The ID of the Instance to attach the Volume to.")
    ("volume_id" "volume_id - (Required) The ID of the Volume to attach to an Instance.")
    ("device" "device - (Optional) The device of the volume attachment (ex: /dev/vdc). NOTE: Being able to specify a device is dependent upon the hypervisor in use. There is a chance that the device specified in Terraform will not be the same device the hypervisor chose. If this happens, Terraform will wish to update the device upon subsequent applying which will cause the volume to be detached and reattached indefinitely. Please use with caution.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_dns_recordset_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 DNS client. If omitted, the region argument of the provider is used. Changing this creates a new DNS  record set.")
    ("zone_id" "zone_id - (Required) The ID of the zone in which to create the record set. Changing this creates a new DNS  record set.")
    ("name" "name - (Required) The name of the record set. Note the . at the end of the name. Changing this creates a new DNS  record set.")
    ("type" "type - (Optional) The type of record set. Examples: \"A\", \"MX\". Changing this creates a new DNS  record set.")
    ("ttl" "ttl - (Optional) The time to live (TTL) of the record set.")
    ("description" "description - (Optional) A description of the  record set.")
    ("records" "records - (Optional) An array of DNS records.")
    ("value_specs" "value_specs - (Optional) Map of additional options. Changing this creates a new record set.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_dns_zone_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. Keypairs are associated with accounts, but a Compute client is needed to create one. If omitted, the region argument of the provider is used. Changing this creates a new DNS zone.")
    ("name" "name - (Required) The name of the zone. Note the . at the end of the name. Changing this creates a new DNS zone.")
    ("email" "email - (Optional) The email contact for the zone record.")
    ("type" "type - (Optional) The type of zone. Can either be PRIMARY or SECONDARY. Changing this creates a new zone.")
    ("attributes" "attributes - (Optional) Attributes for the DNS Service scheduler. Changing this creates a new zone.")
    ("ttl" "ttl - (Optional) The time to live (TTL) of the zone.")
    ("description" "description - (Optional) A description of the zone.")
    ("masters" "masters - (Optional) An array of master DNS servers. For when type is SECONDARY.")
    ("value_specs" "value_specs - (Optional) Map of additional options. Changing this creates a new zone.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_images_image_v2" '(
    ("container_format" "container_format - (Required) The container format. Must be one of \"ami\", \"ari\", \"aki\", \"bare\", \"ovf\".")
    ("disk_format" "disk_format - (Required) The disk format. Must be one of \"ami\", \"ari\", \"aki\", \"vhd\", \"vmdk\", \"raw\", \"qcow2\", \"vdi\", \"iso\".")
    ("local_file_path" "local_file_path - (Optional) This is the filepath of the raw image file that will be uploaded to Glance. Conflicts with image_source_url.")
    ("image_cache_path" "image_cache_path - (Optional) This is the directory where the images will be downloaded. Images will be stored with a filename corresponding to the url's md5 hash. Defaults to \"$HOME/.terraform/image_cache\"")
    ("image_source_url" "image_source_url - (Optional) This is the url of the raw image that will be downloaded in the image_cache_path before being uploaded to Glance. Glance is able to download image from internet but the gophercloud library does not yet provide a way to do so. Conflicts with local_file_path.")
    ("min_disk_gb" "min_disk_gb - (Optional) Amount of disk space (in GB) required to boot image. Defaults to 0.")
    ("min_ram_mb" "min_ram_mb - (Optional) Amount of ram (in MB) required to boot image. Defauts to 0.")
    ("name" "name - (Required) The name of the image.")
    ("protected" "protected - (Optional) If true, image will not be deletable. Defaults to false.")
    ("region" "region - (Optional) The region in which to obtain the V2 Glance client. A Glance client is needed to create an Image that can be used with a compute instance. If omitted, the region argument of the provider is used. Changing this creates a new Image.")
    ("tags" "tags - (Optional) The tags of the image. It must be a list of strings. At this time, it is not possible to delete all tags of an image.")
    ("visibility" "visibility - (Optional) The visibility of the image. Must be one of \"public\", \"private\", \"community\", or \"shared\". The ability to set the visibility depends upon the configuration of the OpenTelekomCloud cloud.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_floatingip_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a floating IP that can be used with another networking resource, such as a load balancer. If omitted, the region argument of the provider is used. Changing this creates a new floating IP (which may or may not have a different address).")
    ("pool" "pool - (Required) The name of the pool from which to obtain the floating IP. Changing this creates a new floating IP.")
    ("port_id" "port_id - (Optional) ID of an existing port with at least one IP address to associate with this floating IP.")
    ("tenant_id" "tenant_id - (Optional) The target tenant ID in which to allocate the floating IP, if you specify this together with a port_id, make sure the target port belongs to the same tenant. Changing this creates a new floating IP (which may or may not have a different address)")
    ("fixed_ip" "fixed_ip - Fixed IP of the port to associate with this floating IP. Required if the port has multiple fixed IPs.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_network_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a Neutron network. If omitted, the region argument of the provider is used. Changing this creates a new network.")
    ("name" "name - (Optional) The name of the network. Changing this updates the name of the existing network.")
    ("shared" "shared - (Optional)  Specifies whether the network resource can be accessed by any tenant or not. Changing this updates the sharing capabalities of the existing network.")
    ("tenant_id" "tenant_id - (Optional) The owner of the network. Required if admin wants to create a network for another tenant. Changing this creates a new network.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the network. Acceptable values are \"true\" and \"false\". Changing this value updates the state of the existing network.")
    ("segments" "segments - (Optional) An array of one or more provider segment objects.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_port_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a port. If omitted, the region argument of the provider is used. Changing this creates a new port.")
    ("name" "name - (Optional) A unique name for the port. Changing this updates the name of an existing port.")
    ("network_id" "network_id - (Required) The ID of the network to attach the port to. Changing this creates a new port.")
    ("admin_state_up" "admin_state_up - (Optional) Administrative up/down status for the port (must be \"true\" or \"false\" if provided). Changing this updates the admin_state_up of an existing port.")
    ("mac_address" "mac_address - (Optional) Specify a specific MAC address for the port. Changing this creates a new port.")
    ("tenant_id" "tenant_id - (Optional) The owner of the Port. Required if admin wants to create a port for another tenant. Changing this creates a new port.")
    ("device_owner" "device_owner - (Optional) The device owner of the Port. Changing this creates a new port.")
    ("security_group_ids" "security_group_ids - (Optional) A list of security group IDs to apply to the port. The security groups must be specified by ID and not name (as opposed to how they are configured with the Compute Instance).")
    ("device_id" "device_id - (Optional) The ID of the device attached to the port. Changing this creates a new port.")
    ("fixed_ip" "fixed_ip - (Optional) An array of desired IPs for this port. The structure is described below.")
    ("allowed_address_pairs" "allowed_address_pairs - (Optional) An IP/MAC Address pair of additional IP addresses that can be active on this port. The structure is described below.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_router_interface_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a router. If omitted, the region argument of the provider is used. Changing this creates a new router interface.")
    ("router_id" "router_id - (Required) ID of the router this interface belongs to. Changing this creates a new router interface.")
    ("subnet_id" "subnet_id - ID of the subnet this interface connects to. Changing this creates a new router interface.")
    ("port_id" "port_id - ID of the port this interface connects to. Changing this creates a new router interface.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_router_route_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to configure a routing entry on a router. If omitted, the region argument of the provider is used. Changing this creates a new routing entry.")
    ("router_id" "router_id - (Required) ID of the router this routing entry belongs to. Changing this creates a new routing entry.")
    ("destination_cidr" "destination_cidr - (Required) CIDR block to match on the packet’s destination IP. Changing this creates a new routing entry.")
    ("next_hop" "next_hop - (Required) IP address of the next hop gateway.  Changing this creates a new routing entry.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_router_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a router. If omitted, the region argument of the provider is used. Changing this creates a new router.")
    ("name" "name - (Optional) A unique name for the router. Changing this updates the name of an existing router.")
    ("admin_state_up" "admin_state_up - (Optional) Administrative up/down status for the router (must be \"true\" or \"false\" if provided). Changing this updates the admin_state_up of an existing router.")
    ("distributed" "distributed - (Optional) Indicates whether or not to create a distributed router. The default policy setting in Neutron restricts usage of this property to administrative users only.")
    ("external_gateway" "external_gateway - (Optional) The network UUID of an external gateway for the router. A router with an external gateway is required if any compute instances or load balancers will be using floating IPs. Changing this updates the external_gateway of an existing router.")
    ("tenant_id" "tenant_id - (Optional) The owner of the floating IP. Required if admin wants to create a router for another tenant. Changing this creates a new router.")
    ("value_specs" "value_specs - (Optional) Map of additional driver-specific options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_subnet_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create a Neutron subnet. If omitted, the region argument of the provider is used. Changing this creates a new subnet.")
    ("network_id" "network_id - (Required) The UUID of the parent network. Changing this creates a new subnet.")
    ("cidr" "cidr - (Required) CIDR representing IP range for this subnet, based on IP version. Changing this creates a new subnet.")
    ("ip_version" "ip_version - (Optional) IP version, either 4 (default) or 6. Changing this creates a new subnet.")
    ("name" "name - (Optional) The name of the subnet. Changing this updates the name of the existing subnet.")
    ("tenant_id" "tenant_id - (Optional) The owner of the subnet. Required if admin wants to create a subnet for another tenant. Changing this creates a new subnet.")
    ("allocation_pools" "allocation_pools - (Optional) An array of sub-ranges of CIDR available for dynamic allocation to ports. The allocation_pool object structure is documented below. Changing this creates a new subnet.")
    ("gateway_ip" "gateway_ip - (Optional)  Default gateway used by devices in this subnet. Leaving this blank and not setting no_gateway will cause a default gateway of .1 to be used. Changing this updates the gateway IP of the existing subnet.")
    ("no_gateway" "no_gateway - (Optional) Do not set a gateway IP on this subnet. Changing this removes or adds a default gateway IP of the existing subnet.")
    ("enable_dhcp" "enable_dhcp - (Optional) The administrative state of the network. Acceptable values are \"true\" and \"false\". Changing this value enables or disables the DHCP capabilities of the existing subnet. Defaults to true.")
    ("dns_nameservers" "dns_nameservers - (Optional) An array of DNS name server names used by hosts in this subnet. Changing this updates the DNS name servers for the existing subnet.")
    ("host_routes" "host_routes - (Optional) An array of routes that should be used by devices with IPs from this subnet (not including local subnet route). The host_route object structure is documented below. Changing this updates the host routes for the existing subnet.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_secgroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a port. If omitted, the region argument of the provider is used. Changing this creates a new security group.")
    ("name" "name - (Required) A unique name for the security group.")
    ("description" "description - (Optional) A unique name for the security group.")
    ("tenant_id" "tenant_id - (Optional) The owner of the security group. Required if admin wants to create a port for another tenant. Changing this creates a new security group.")
    ("delete_default_rules" "delete_default_rules - (Optional) Whether or not to delete the default egress security rules. This is false by default. See the below note for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_networking_secgroup_rule_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 networking client. A networking client is needed to create a port. If omitted, the region argument of the provider is used. Changing this creates a new security group rule.")
    ("direction" "direction - (Required) The direction of the rule, valid values are ingress or egress. Changing this creates a new security group rule.")
    ("ethertype" "ethertype - (Required) The layer 3 protocol type, valid values are IPv4 or IPv6. Changing this creates a new security group rule.")
    ("protocol" "protocol - (Optional) The layer 4 protocol type, valid values are following. Changing this creates a new security group rule. This is required if you want to specify a port range.  tcp  udp  icmp  ah  dccp  egp  esp  gre  igmp  ipv6-encap  ipv6-frag  ipv6-icmp  ipv6-nonxt  ipv6-opts  ipv6-route  ospf  pgm  rsvp  sctp  udplite  vrrp")
    ("port_range_min" "port_range_min - (Optional) The lower part of the allowed port range, valid integer value needs to be between 1 and 65535. Changing this creates a new security group rule.")
    ("port_range_max" "port_range_max - (Optional) The higher part of the allowed port range, valid integer value needs to be between 1 and 65535. Changing this creates a new security group rule.")
    ("remote_ip_prefix" "remote_ip_prefix - (Optional) The remote CIDR, the value needs to be a valid CIDR (i.e. 192.168.0.0/16). Changing this creates a new security group rule.")
    ("remote_group_id" "remote_group_id - (Optional) The remote group id, the value needs to be an OpenTelekomCloud ID of a security group in the same tenant. Changing this creates a new security group rule.")
    ("security_group_id" "security_group_id - (Required) The security group id the rule should belong to, the value needs to be an OpenTelekomCloud ID of a security group in the same tenant. Changing this creates a new security group rule.")
    ("tenant_id" "tenant_id - (Optional) The owner of the security group. Required if admin wants to create a port for another tenant. Changing this creates a new security group rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_lb_loadbalancer_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an LB member. If omitted, the region argument of the provider is used. Changing this creates a new LB member.")
    ("vip_subnet_id" "vip_subnet_id - (Required) The network on which to allocate the Loadbalancer's address. A tenant can only create Loadbalancers on networks authorized by policy (e.g. networks that belong to them or networks that are shared).  Changing this creates a new loadbalancer.")
    ("name" "name - (Optional) Human-readable name for the Loadbalancer. Does not have to be unique.")
    ("description" "description - (Optional) Human-readable description for the Loadbalancer.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the Loadbalancer.  Only administrative users can specify a tenant UUID other than their own.  Changing this creates a new loadbalancer.")
    ("vip_address" "vip_address - (Optional) The ip address of the load balancer. Changing this creates a new loadbalancer.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the Loadbalancer. A valid value is true (UP) or false (DOWN).")
    ("flavor" "flavor - (Optional) The UUID of a flavor. Changing this creates a new loadbalancer.")
    ("loadbalancer_provider" "loadbalancer_provider - (Optional) The name of the provider. Changing this creates a new loadbalancer.")
    ("security_group_ids" "security_group_ids - (Optional) A list of security group IDs to apply to the loadbalancer. The security groups must be specified by ID and not name (as opposed to how they are configured with the Compute Instance).")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_lb_listener_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new Listener.")
    ("protocol" "protocol - (Required) The protocol - can either be TCP, HTTP, HTTPS or TERMINATED_HTTPS. Changing this creates a new Listener.")
    ("protocol_port" "protocol_port - (Required) The port on which to listen for client traffic. Changing this creates a new Listener.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the Listener.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new Listener.")
    ("loadbalancer_id" "loadbalancer_id - (Required) The load balancer on which to provision this Listener. Changing this creates a new Listener.")
    ("name" "name - (Optional) Human-readable name for the Listener. Does not have to be unique.")
    ("default_pool_id" "default_pool_id - (Optional) The ID of the default pool with which the Listener is associated. Changing this creates a new Listener.")
    ("description" "description - (Optional) Human-readable description for the Listener.")
    ("connection_limit" "connection_limit - (Optional) The maximum number of connections allowed for the Listener.")
    ("default_tls_container_ref" "default_tls_container_ref - (Optional) A reference to a Barbican Secrets container which stores TLS information. This is required if the protocol is TERMINATED_HTTPS. See here for more information.")
    ("sni_container_refs" "sni_container_refs - (Optional) A list of references to Barbican Secrets containers which store SNI information. See here for more information.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the Listener. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_lb_pool_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new pool.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the pool.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new pool.")
    ("name" "name - (Optional) Human-readable name for the pool.")
    ("description" "description - (Optional) Human-readable description for the pool.")
    ("protocol" "protocol = (Required) The protocol - can either be TCP, HTTP or HTTPS. Changing this creates a new pool.")
    ("loadbalancer_id" "loadbalancer_id - (Optional) The load balancer on which to provision this pool. Changing this creates a new pool. Note:  One of LoadbalancerID or ListenerID must be provided.")
    ("listener_id" "listener_id - (Optional) The Listener on which the members of the pool will be associated with. Changing this creates a new pool. Note:  One of LoadbalancerID or ListenerID must be provided.")
    ("lb_method" "lb_method - (Required) The load balancing algorithm to distribute traffic to the pool's members. Must be one of ROUND_ROBIN, LEAST_CONNECTIONS, or SOURCE_IP.")
    ("persistence" "persistence - Omit this field to prevent session persistence.  Indicates whether connections in the same session will be processed by the same Pool member or not. Changing this creates a new pool.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the pool. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_lb_member_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new member.")
    ("pool_id" "pool_id - (Required) The id of the pool that this member will be assigned to.")
    ("subnet_id" "subnet_id - (Required) The subnet in which to access the member")
    ("name" "name - (Optional) Human-readable name for the member.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the member.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new member.")
    ("address" "address - (Required) The IP address of the member to receive traffic from the load balancer. Changing this creates a new member.")
    ("protocol_port" "protocol_port - (Required) The port on which to listen for client traffic. Changing this creates a new member.")
    ("weight" "weight - (Optional)  A positive integer value that indicates the relative portion of traffic that this member should receive from the pool. For example, a member with a weight of 10 receives five times as much traffic as a member with a weight of 2.")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the member. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_lb_monitor_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to create an . If omitted, the region argument of the provider is used. Changing this creates a new monitor.")
    ("pool_id" "pool_id - (Required) The id of the pool that this monitor will be assigned to.")
    ("name" "name - (Optional) The Name of the Monitor.")
    ("tenant_id" "tenant_id - (Optional) Required for admins. The UUID of the tenant who owns the monitor.  Only administrative users can specify a tenant UUID other than their own. Changing this creates a new monitor.")
    ("type" "type - (Required) The type of probe, which is PING, TCP, HTTP, or HTTPS, that is sent by the load balancer to verify the member state. Changing this creates a new monitor.")
    ("delay" "delay - (Required) The time, in seconds, between sending probes to members.")
    ("timeout" "timeout - (Required) Maximum number of seconds for a monitor to wait for a ping reply before it times out. The value must be less than the delay value.")
    ("max_retries" "max_retries - (Required) Number of permissible ping failures before changing the member's status to INACTIVE. Must be a number between 1 and 10..")
    ("url_path" "url_path - (Optional) Required for HTTP(S) types. URI path that will be accessed if monitor type is HTTP or HTTPS.")
    ("http_method" "http_method - (Optional) Required for HTTP(S) types. The HTTP method used for requests by the monitor. If this attribute is not specified, it defaults to \"GET\".")
    ("expected_codes" "expected_codes - (Optional) Required for HTTP(S) types. Expected HTTP codes for a passing HTTP(S) monitor. You can either specify a single status like \"200\", or a range like \"200-202\".")
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the monitor. A valid value is true (UP) or false (DOWN).")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_fw_firewall_group_v2" '(
    ("region" "region - (Optional) The region in which to obtain the v1 networking client. A networking client is needed to create a firewall group. If omitted, the region argument of the provider is used. Changing this creates a new firewall group.")
    ("ingress_policy_id" "ingress_policy_id - The ingress policy resource id for the firewall group. Changing this updates the ingress_policy_id of an existing firewall group.")
    ("egress_policy_id" "egress_policy_id - The egress policy resource id for the firewall group. Changing this updates the egress_policy_id of an existing firewall group.")
    ("name" "name - (Optional) A name for the firewall group. Changing this updates the name of an existing firewall group.")
    ("description" "description - (Required) A description for the firewall group. Changing this updates the description of an existing firewall group.")
    ("admin_state_up" "admin_state_up - (Optional) Administrative up/down status for the firewall group (must be \"true\" or \"false\" if provided - defaults to \"true\"). Changing this updates the admin_state_up of an existing firewall group.")
    ("tenant_id" "tenant_id - (Optional) The owner of the floating IP. Required if admin wants to create a firewall group for another tenant. Changing this creates a new firewall group.")
    ("ports" "ports - (Optional) Port(s) to associate this firewall group instance with. Must be a list of strings. Changing this updates the associated routers of an existing firewall group.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_fw_policy_v2" '(
    ("region" "region - (Optional) The region in which to obtain the v1 networking client. A networking client is needed to create a firewall policy. If omitted, the region argument of the provider is used. Changing this creates a new firewall policy.")
    ("name" "name - (Optional) A name for the firewall policy. Changing this updates the name of an existing firewall policy.")
    ("description" "description - (Optional) A description for the firewall policy. Changing this updates the description of an existing firewall policy.")
    ("rules" "rules - (Optional) An array of one or more firewall rules that comprise the policy. Changing this results in adding/removing rules from the existing firewall policy.")
    ("audited" "audited - (Optional) Audit status of the firewall policy (must be \"true\" or \"false\" if provided - defaults to \"false\"). This status is set to \"false\" whenever the firewall policy or any of its rules are changed. Changing this updates the audited status of an existing firewall policy.")
    ("shared" "shared - (Optional) Sharing status of the firewall policy (must be \"true\" or \"false\" if provided). If this is \"true\" the policy is visible to, and can be used in, firewalls in other tenants. Changing this updates the shared status of an existing firewall policy. Only administrative users can specify if the policy should be shared.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opentelekomcloud_fw_rule_v2" '(
    ("region" "region - (Optional) The region in which to obtain the v1 Compute client. A Compute client is needed to create a firewall rule. If omitted, the region argument of the provider is used. Changing this creates a new firewall rule.")
    ("name" "name - (Optional) A unique name for the firewall rule. Changing this updates the name of an existing firewall rule.")
    ("description" "description - (Optional) A description for the firewall rule. Changing this updates the description of an existing firewall rule.")
    ("protocol" "protocol - (Required) The protocol type on which the firewall rule operates. Valid values are: tcp, udp, icmp, and any. Changing this updates the protocol of an existing firewall rule.")
    ("action" "action - (Required) Action to be taken ( must be \"allow\" or \"deny\") when the firewall rule matches. Changing this updates the action of an existing firewall rule.")
    ("ip_version" "ip_version - (Optional) IP version, either 4 (default) or 6. Changing this updates the ip_version of an existing firewall rule.")
    ("source_ip_address" "source_ip_address - (Optional) The source IP address on which the firewall rule operates. Changing this updates the source_ip_address of an existing firewall rule.")
    ("destination_ip_address" "destination_ip_address - (Optional) The destination IP address on which the firewall rule operates. Changing this updates the destination_ip_address of an existing firewall rule.")
    ("source_port" "source_port - (Optional) The source port on which the firewall rule operates. Changing this updates the source_port of an existing firewall rule.")
    ("destination_port" "destination_port - (Optional) The destination port on which the firewall rule operates. Changing this updates the destination_port of an existing firewall rule.")
    ("enabled" "enabled - (Optional) Enabled status for the firewall rule (must be \"true\" or \"false\" if provided - defaults to \"true\"). Changing this updates the enabled status of an existing firewall rule.")
    ("tenant_id" "tenant_id - (Optional) The owner of the firewall rule. Required if admin wants to create a firewall rule for another tenant. Changing this creates a new firewall rule.")
    ("value_specs" "value_specs - (Optional) Map of additional options.")

  ) company-terraform-resource-arguments-hash)

(puthash "opsgenie_team" '(
    ("name" "name - (Required) The name associated with this team. OpsGenie defines that this must not be longer than 100 characters.")
    ("description" "description - (Optional) A description for this team.")
    ("member" "member - (Optional) A Member block as documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "opsgenie_user" '(
    ("username" "username - (Required) The email address associated with this user. OpsGenie defines that this must not be longer than 100 characters.")
    ("full_name" "full_name - (Required) The Full Name of the User.")
    ("role" "role - (Required) The Role assigned to the User. Either a built-in such as 'Owner', 'Admin' or 'User' - or the name of a custom role.")
    ("locale" "locale - (Optional) Location information for the user. Please look at Supported Locale Ids for available locales - Defaults to \"en_US\".")
    ("timezone" "timezone - (Optional) Timezone information of the user. Please look at Supported Timezone Ids for available timezones - Defaults to \"America/New_York\".")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_acl" '(
    ("name" "name - (Required) The name of the ACL.")
    ("enabled" "enabled - (Optional) Enables or disables the ACL. Set to true by default.")
    ("description" "description - (Optional) A description of the ACL.")
    ("tags" "tags - (Optional) List of tags that may be applied to the ACL.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_image_list" '(
    ("name" "name - (Required) The name of the Image List.")
    ("description" "description - (Required) A description of the Image List.")
    ("default" "default - (Required) The image list entry to be used, by default, when launching instances using this image list. Defaults to 1.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_image_list_entry" '(
    ("name" "name - (Required) The name of the Image List.")
    ("machine_images" "machine_images - (Required) An array of machine images.")
    ("version" "version - (Required) The unique version of the image list entry, as an integer.")
    ("attributes" "attributes - (Optional) JSON String of optional data that will be passed to an instance of this machine image when it is launched.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_instance" '(
    ("name" "name - (Required) The name of the instance.")
    ("shape" "shape - (Required) The shape of the instance, e.g. oc4.")
    ("instance_attributes" "instance_attributes - (Optional) A JSON string of custom attributes. See Attributes below for more information.")
    ("boot_order" "boot_order - (Optional) The index number of the bootable storage volume, presented as a list, that should be used to boot the instance. The only valid value is [1]. If you set this attribute, you must also specify a bootable storage volume with index number 1 in the volume sub-parameter of storage_attachments. When you specify boot_order, you don't need to specify the imagelist attribute, because the instance is booted using the image on the specified bootable storage volume. If you specify both boot_order and imagelist, the imagelist attribute is ignored.")
    ("hostname" "hostname - (Optional) The host name assigned to the instance. On an Oracle Linux instance, this host name is displayed in response to the hostname command. Only relative DNS is supported. The domain name is suffixed to the host name that you specify. The host name must not end with a period. If you don't specify a host name, then a name is generated automatically.")
    ("image_list" "image_list - (Optional) The imageList of the instance, e.g. /oracle/public/oel_6.4_2GB_v1.")
    ("label" "label - (Optional) The label to apply to the instance.")
    ("desired_state" "desired_state - (Optional) Set the desire state of the instance to running (default) or shutdown. You can use this request to shut down and restart individual instances which use a persistent bootable storage volume.")
    ("networking_info" "networking_info - (Optional) Information pertaining to an individual network interface to be created and attached to the instance. If left unspecified, the instance will be created within the shared_network. See Networking Info below for more information.")
    ("storage" "storage - (Optional) Information pertaining to an individual storage attachment to be created during instance creation. Please see Storage Attachments below for more information.")
    ("reverse_dns" "reverse_dns - (Optional) If set to true (default), then reverse DNS records are created. If set to false, no reverse DNS records are created.")
    ("ssh_keys" "ssh_keys - (Optional) A list of the names of the SSH Keys that can be used to log into the instance.")
    ("tags" "tags - (Optional) A list of strings that should be supplied to the instance as tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_address_association" '(
    ("name" "name - (Required) The name of the ip address association.")
    ("ip_address_reservation" "ip_address_reservation - (Optional) The name of the NAT IP address reservation.")
    ("vnic" "vnic - (Optional) The name of the virtual NIC associated with this NAT IP reservation.")
    ("description" "description - (Optional) A description of the ip address association.")
    ("tags" "tags - (Optional) List of tags that may be applied to the ip address association.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_address_prefix_set" '(
    ("name" "name - (Required) The name of the ip address prefix set.")
    ("prefixes" "prefixes - (Optional) List of CIDR IPv4 prefixes assigned in the virtual network.")
    ("description" "description - (Optional) A description of the ip address prefix set.")
    ("tags" "tags - (Optional) List of tags that may be applied to the ip address prefix set.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_address_reservation" '(
    ("name" "name - (Required) The name of the ip address reservation.")
    ("ip_address_pool" "ip_address_pool - (Required) The IP address pool from which you want to reserve an IP address. Must be either public-ippool or cloud-ippool.")
    ("description" "description - (Optional) A description of the ip address reservation.")
    ("tags" "tags - (Optional) List of tags that may be applied to the IP address reservation.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_association" '(
    ("vcable" "vcable - (Required) The vcable of the instance to associate the IP address with.")
    ("parent_pool" "parent_pool - (Required) The pool from which to take an IP address. To associate a specific reserved IP address, use the prefix ipreservation: followed by the name of the IP reservation. To allocate an IP address from a pool, use the prefix ippool:, e.g. ippool:/oracle/public/ippool.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_network" '(
    ("name" "name - (Required) The name of the IP Network. Changing this name forces a new resource to be created.")
    ("ip_address_prefix" "ip_address_prefix - (Required) The IPv4 address prefix, in CIDR format.")
    ("description" "description - (Optional) The description of the IP Network.")
    ("ip_network_exchange" "ip_network_exchange - (Optional) Specify the IP Network exchange to which the IP Network belongs to.")
    ("public_napt_enabled" "public_napt_enabled - (Optional) If true, enable public internet access using NAPT for VNICs without any public IP Reservation. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_network_exchange" '(
    ("name" "name - (Required) The name of the ip network exchange.")
    ("description" "description - (Optional) A description of the ip network exchange.")
    ("tags" "tags - (Optional) List of tags that may be applied to the IP network exchange.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ip_reservation" '(
    ("permanent" "permanent - (Required) Whether the IP address remains reserved even when it is no longer associated with an instance (if true), or may be returned to the pool and replaced with a different IP address when an instance is restarted, or deleted and recreated (if false).")
    ("parent_pool" "parent_pool - (Optional) The pool from which to allocate the IP address. Defaults to /oracle/public/ippool, and is currently the only acceptable input.")
    ("name" "name - (Optional) Name of the IP Reservation. Will be generated if unspecified.")
    ("tags" "tags - (Optional) List of tags that may be applied to the IP reservation.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_machine_image" '(
    ("account" "account - (Required) The two part name of the compute object storage account in the format /Compute-{identity_domain}/cloud_storage")
    ("name" "name - (Required) The name of the Machine Image.")
    ("file" "file - (Required) The name of the Machine Image .tar.gz file in the compute_images storage container.")
    ("description" "description - (Optional) A description of the Machine Image.")
    ("attributes" "attributes - (Optional) An optional JSON object of arbitrary attributes to be made available to the instance. These are user-defined tags. After defining attributes, you can view them from within an instance at http://192.0.0.192/")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_orchestrated_instance" '(
    ("name" "name - (Required) The name of the orchestration.")
    ("desired_state" "desired_state - (Required) The desired state of the orchestration. Permitted values are:  active: all resource (instances) declared in the orchestration are created  suspend: all resources (instances) declared in the orchestration are removed unless the instances has persistent = true  inactive:  all resources (instances) declared in the orchestration are removed including the instances that have persistent = true")
    ("instance" "instance - (Required) The information pertaining to creating an instance through the orchestration API.")
    ("description" "description - (Optional) The description of the orchestration.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_route" '(
    ("name" "name - (Required) The name of the route.")
    ("description" "description - (Optional) The description of the route.")
    ("admin_distance" "admin_distance - (Optional) The route's administrative distance. Defaults to 0.")
    ("ip_address_prefix" "ip_address_prefix - (Required) The IPv4 address prefix, in CIDR format, of the external network from which to route traffic.")
    ("next_hop_vnic_set" "next_hop_vnic_set - (Required) Name of the virtual NIC set to route matching packets to. Routed flows are load-balanced among all the virtual NICs in the virtual NIC set.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_sec_rule" '(
    ("name" "name - (Required) The unique (within the identity domain) name of the security rule.")
    ("description" "description - (Optional) A description for this security rule.")
    ("source_list" "source_list - (Required) The source security list (prefixed with seclist:), or security IP list (prefixed with seciplist:).  destination_list - (Required) The destination security list (prefixed with seclist:), or security IP list (prefixed with seciplist:).")
    ("application" "application - (Required) The name of the application to which the rule applies.")
    ("action" "action - (Required) Whether to permit, refuse or deny packets to which this rule applies. This will ordinarily be permit.")
    ("disabled" "disabled - (Optional) Whether to disable this security rule. This is useful if you want to temporarily disable a rule without removing it outright from your Terraform resource definition. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_security_application" '(
    ("name" "name - (Required) The unique (within the identity domain) name of the application")
    ("protocol" "protocol - (Required) The protocol to enable for this application. Must be one of tcp, udp, ah, esp, icmp, icmpv6, igmp, ipip, gre, mplsip, ospf, pim, rdp, sctp or all.")
    ("dport" "dport - (Required) The port, or range of ports, to enable for this application, e.g 8080, 6000-7000. This must be set if the protocol is set to tcp or udp.")
    ("icmptype" "icmptype - (Optional) The ICMP type to enable for this application, if the protocol is icmp. Must be one of echo, reply, ttl, traceroute, unreachable.")
    ("icmpcode" "icmpcode - (Optional) The ICMP code to enable for this application, if the protocol is icmp. Must be one of admin, df, host, network, port or protocol.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_security_association" '(
    ("name" "name - (Optional) The Name for the Security Association. If not specified, one is created automatically. Changing this forces a new resource to be created.")
    ("vcable" "vcable - (Required) The vcable of the instance to associate to the security list.")
    ("seclist" "seclist - (Required) The name of the security list to associate the instance to.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_security_ip_list" '(
    ("name" "name - (Required) The unique (within the identity domain) name of the security IP list.")
    ("ip_entries" "ip_entries - (Required) The IP addresses to include in the list.")
    ("description" "description - (Optional) The description of the security ip list.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_security_list" '(
    ("name" "name - (Required) The unique (within the identity domain) name of the security list.")
    ("policy" "policy - (Required) The policy to apply to instances associated with this list. Must be one of permit, reject (packets are dropped but a reply is sent) and deny (packets are dropped and no reply is sent).")
    ("output_cidr_policy" "output_cidr_policy - (Required) The policy for outbound traffic from the security list. Must be one of permit, reject (packets are dropped but a reply is sent) and deny (packets are dropped and no reply is sent).")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_security_protocol" '(
    ("name" "name - (Required) The name of the security protocol.")
    ("dst_ports" "dst_ports (Optional) Enter a list of port numbers or port range strings. Traffic is enabled by a security rule when a packet's destination port matches the ports specified here. For TCP, SCTP, and UDP, each port is a destination transport port, between 0 and 65535, inclusive. For ICMP, each port is an ICMP type, between 0 and 255, inclusive. If no destination ports are specified, all destination ports or ICMP types are allowed.")
    ("src_ports" "src_ports (Optional) Enter a list of port numbers or port range strings. Traffic is enabled by a security rule when a packet's source port matches the ports specified here. For TCP, SCTP, and UDP, each port is a source transport port, between 0 and 65535, inclusive. For ICMP, each port is an ICMP type, between 0 and 255, inclusive. If no source ports are specified, all source ports or ICMP types are allowed.")
    ("ip_protocol" "ip_protocol (Optional) The protocol used in the data portion of the IP datagram.  Permitted values are: tcp, udp, icmp, igmp, ipip, rdp, esp, ah, gre, icmpv6, ospf, pim, sctp,  mplsip, all.  Traffic is enabled by a security rule when the protocol in the packet matches the  protocol specified here. If no protocol is specified, all protocols are allowed.")
    ("description" "description - (Optional) A description of the security protocol.")
    ("tags" "tags - (Optional) List of tags that may be applied to the security protocol.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_security_rule" '(
    ("name" "name - (Required) The name of the security rule.")
    ("flow_direction" "flow_direction - (Required) Specify the direction of flow of traffic, which is relative to the instances, for this security rule. Allowed values are ingress or egress.")
    ("disabled" "disabled - (Optional) Whether to disable this security rule. This is useful if you want to temporarily disable a rule without removing it outright from your Terraform resource definition. Defaults to false.")
    ("acl" "acl - (Optional) Name of the ACL that contains this security rule.")
    ("dst_ip_address_prefixes" "dst_ip_address_prefixes - (Optional) List of IP address prefix set names to match the packet's destination IP address.")
    ("src_ip_address_prefixes" "src_ip_address_prefixes - (Optional) List of names of IP address prefix set to match the packet's source IP address.")
    ("dst_vnic_set" "dst_vnic_set - (Optional) Name of virtual NIC set containing the packet's destination virtual NIC.")
    ("src_vnic_set" "src_vnic_set - (Optional) Name of virtual NIC set containing the packet's source virtual NIC.")
    ("security_protocols" "security_protocols - (Optional) List of security protocol object names to match the packet's protocol and port.")
    ("description" "description - (Optional) A description of the security rule.")
    ("tags" "tags - (Optional) List of tags that may be applied to the security rule.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_ssh_key" '(
    ("name" "name - (Required) The unique (within this identity domain) name of the SSH key.")
    ("key" "key - (Required) The SSH key itself")
    ("enabled" "enabled - (Optional) Whether or not the key is enabled. This is useful if you want to temporarily disable an SSH key, without removing it entirely from your Terraform resource definition. Defaults to true")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_storage_volume_attachment" '(
    ("instance" "instance - (Required) The name of the instance the volume will be attached to.")
    ("storage_volume" "storage_volume - (Required) The name of the storage volume that will be attached to the instance")
    ("index" "index - (Required) The index on the instance that the storage volume will be attached to.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_storage_volume" '(
    ("name" "name (Required) The name for the Storage Account.")
    ("description" "description (Optional) The description of the storage volume.")
    ("size" "size (Required) The size of this storage volume in GB. The allowed range is from 1 GB to 2 TB (2048 GB).")
    ("storage_type" "storage_type - (Optional) - The Type of Storage to provision. Defaults to /oracle/public/storage/default.")
    ("bootable" "bootable - (Optional) Is the Volume Bootable? Defaults to false.")
    ("image_list" "image_list - (Optional) Defines an image list.")
    ("image_list_entry" "image_list_entry - (Optional) Defines an image list entry.")
    ("snapshot" "snapshot - (Optional) The name of the parent snapshot from which the storage volume is restored or cloned. See Snapshots, below for more information.")
    ("snapshot_id" "snapshot_id - (Optional) The Id of the parent snapshot from which the storage volume is restored or cloned. See Snapshots, below for more information.")
    ("snapshot_account" "snapshot_account - (Optional) The Account of the parent snapshot from which the storage volume is restored. See Snapshots, below for more information.")
    ("tags" "tags - (Optional) Comma-separated strings that tag the storage volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_storage_volume_snapshot" '(
    ("volume_name" "volume_name (Required) The name of the storage volume to create the snapshot from.")
    ("description" "description (Optional) The description of the storage volume snapshot.")
    ("name" "name (Optional) The name of the storage volume snapshot. Will be generated if unspecified.")
    ("parent_volume_bootable" "parent_volume_bootable (Optional) A string value of whether or not the parent volume is 'bootable' or not. Defaults to \"false\".")
    ("collocated" "collocated (Optional) Boolean specifying whether the snapshot is collocated or remote. Defaults to false.")
    ("tags" "tags - (Optional) Comma-separated strings that tag the storage volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_compute_vnic_set" '(
    ("name" "name - (Required) The unique (within this identity domain) name of the virtual nic set.")
    ("description" "description - (Optional) A description of the virtual nic set.")
    ("applied_acls" "applied_acls - (Optional) A list of the ACLs to apply to the virtual nics in the set.")
    ("virtual_nics" "virtual_nics - (Optional) List of virtual NICs associated with this virtual NIC set.")
    ("tags" "tags - (Optional) A list of tags to apply to the storage volume.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_storage_container" '(
    ("name" "name - (Required) The name of the Storage Container.")
    ("read_acls" "read_acls - (Optional) The list of ACLs that grant read access. See Setting Container ACLs.")
    ("write_acls" "write_acls - (Optional) The list of ACLs that grant write access. See Setting Container ACLs.")
    ("primary_key" "primary_key - (Optional) The primary secret key value for temporary URLs.")
    ("secondary_key" "secondary_key - (Optional) The secondary secret key value for temporary URLs.")
    ("allowed_origins" "allowed_origins - (Optional) List of origins that are allowed to make cross-origin requests.")
    ("exposed_headers" "exposed_headers - (Optional) List of headers exposed to the user agent (e.g. browser) in the actual request response")
    ("max_age" "max_age - (Optional) Maximum age in seconds for the origin to hold the preflight results.")
    ("quota_bytes" "quota_bytes - (Optional) Maximum size of the container, in bytes")
    ("quota_count" "quota_count - (Optional) Maximum object count of the container")
    ("metadata" "metadata - (Optional) Additional object metadata headers. See Container Metadata  below for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "opc_storage_object" '(
    ("name" "name - (Required) The name of the Storage Object.")
    ("container" "container - (Required) The name of Storage Container the store the object in.")

  ) company-terraform-resource-arguments-hash)

(puthash "oraclepaas_database_service_instance" '(
    ("name" "name - (Required) The name of the Service Instance.")
    ("edition" "edition - (Required) Database edition for the service instance. Possible values are SE, EE, EE_HP, or EE_EP.")
    ("level" "level - (Required) Service level for the service instance. Possible values are BASIC or PAAS.")
    ("shape" "shape - (Required) Desired compute shape. Possible values are oc3, oc4, oc5, oc6, oc1m, oc2m, oc3m, or oc4m.")
    ("subscription_type" "subscription_type - (Required) Billing unit. Possible values are HOURLY or MONTHLY.")
    ("version" "version - (Required) Oracle Database software version; one of: 12.2.0.1, 12.1.0.2, or 11.2.0.4.")
    ("vm_public_key" "vm_public_key - (Required) Public key for the secure shell (SSH). This key will be used for authentication when connecting to the Database Cloud Service instance using an SSH client.")
    ("database_configuration" "database_configuration - (Required) Specifies the details on how to configure the database. Database configuration is documented below.")
    ("default_access_rules" "default_access_rules - (Optional) Specifies the details on which default access rules are enable or disabled. Default Access Rules are configured below.")
    ("instantiate_from_backup" "instantiate_from_backup - (Optional) Specify if the service instance's database should, after the instance is created, be replaced by a database stored in an existing cloud backup that was created using Oracle Database Backup Cloud Service. Instantiate from Backup is documented below.")
    ("ip_network" "ip_network - (Optional) This attribute is only applicable to accounts where regions are supported. The three-part name of an IP network to which the service instance is added. For example: /Compute-identity_domain/user/object")
    ("ip_reservations" "ip_reservations - (Optional) Groups one or more IP reservations in use on this service instance. This attribute is only applicable to accounts where regions are supported.")
    ("backups" "backups - (Optional) Provides Cloud Storage information for how to implement service instance backups. Backups is documented below")
    ("bring_you_own_license" "bring_you_own_license - (Optional) Specify if you want to use an existing perpetual license to Oracle Database to establish the right to use Oracle Database on the new instance. Default value is false.")
    ("description" "description - (Optional) A description of the Service Instance.")
    ("high_performance_storage" "high_performance_storage - (Optional) Specifies whether the service instance will be provisioned with high performance storage. Default value is false.")
    ("hybrid_disastery_recovery" "hybrid_disastery_recovery - (Optional) Provides information about an Oracle Hybrid Disaster Recovery configuration. Hybrid Disaster Recovery is documented below.")
    ("notification_email" "notification_email - (Optional)  The email address to send notifications around successful or unsuccessful completions of the instance-creation operation.")
    ("region" "region - (Optional) Specifies the location where the service instance is provisioned (only for accounts where regions are supported).")
    ("standby" "standby - (Optional) Specifies the configuration details of the standby database. This is only applicable in Oracle Cloud Infrastructure Regions. failover_database and disaster_recovery inside the database_configuration block must be set to true. Standby is documented below.")
    ("subnet" "subnet - (Optional) Name of the subnet within the region where the Oracle Database Cloud Service instance is to be provisioned.")

  ) company-terraform-resource-arguments-hash)

(puthash "oraclepaas_java_service_instance" '(
    ("name" "name - (Required) The name of the Service Instance.")
    ("ssh_public_key" "ssh_public_key - (Required) The ssh key to connect to the java service instance.")
    ("edition" "edition - (Required) The edition for the service instance. Possible values are SE, EE, or SUITE.")
    ("backups" "backups - (Required) Provides Cloud Storage information for service instance backups. Backups is documented below")
    ("metering_frequency" "metering_frequency - (Optional) Billing unit. Possible values are HOURLY or MONTHLY. Default value is HOURLY.")
    ("availability_domain" "availability_domain - (Optional) Name of a data center location in the Oracle Cloud Infrastructure region that is specified in region. This is only available for OCI.")
    ("snapshot_name" "snapshot_name - (Optional) Name of the snapshot to clone from.")
    ("source_service_name" "source_service_name - (Optional) Name of the existing Oracle Java Cloud Service instance that has the snapshot from which you are creating a clone.")
    ("subnet" "subnet - (Optional) A subdivision of a cloud network that is set up in the data center as specified in availabilityDomain. This is only available for OCI.")
    ("use_identity_service" "use_identity_service - (Optional) Flag that specifies whether to use Oracle Identity Cloud Service (true) or the local WebLogic identity store (false) for user authentication and to maintain administrators, application users, groups and roles. The default value is false.")
    ("weblogic_server" "weblogic_server - (Required) The attributes required to create a WebLogic server alongside the java service instance. WebLogic Server is documented below.")
    ("otd" "otd - (Optional) The attributes required to create an Oracle Traffic Director (Load balancer). OTD is documented below.")
    ("level" "level - (Optional) Service level for the service instance. Possible values are BASIC or PAAS. Default value is PAAS.")
    ("backup_destination" "backup_destination - (Optional) Specifies whether to enable backups for this Oracle Java Cloud Service instance. Valid values are BOTH or NONE. Defaults to BOTH.")
    ("description" "description - (Optional) Provides additional on the java service instance.")
    ("enable_admin_console" "enable_admin_console - (Optional) Flag that specifies whether to enable (true) or disable (false) the access rules that control external communication to the WebLogic Server Administration Console, Fusion Middleware Control, and Load Balancer Console.")
    ("ip_network" "ip_network - (Optional) The three-part name of a custom IP network to attach this service instance to. For example: /Compute-identity_domain/user/object.")
    ("region" "region - (Optional) Name of the region where the Oracle Java Cloud Service instance is to be provisioned. This attribute is only applicable to accounts where regions are supported. A region name must be specified if you want to use ipReservations or ipNetwork.")
    ("bring_your_own_license" "bring_your_own_license - (Optional) Flag that specifies whether to apply an existing on-premises license for Oracle WebLogic Server (true) to the new Oracle Java Cloud Service instance you are provisioning. The default value is false.")
    ("force_delete" "force_delete - (Optional) Flag that specifies whether you want to force the removal of the service instance even if the database instance cannot be reached to delete the database schemas. Default value is true")

  ) company-terraform-resource-arguments-hash)

(puthash "oraclepaas_database_access_rule" '(
    ("name" "name - (Required) The name of the Access Rule")
    ("service_instance_id" "service_instance_id - (Required) The name of the database service instance to attach the access rule to")
    ("description" "description - (Required) The description of the Access Rule")
    ("ports" "ports - (Required) The port or range of ports to allow traffic on")
    ("source" "source - (Required) The IP addresses and subnets from which traffic is allowed. Valid values are DB, PUBLIC-INTERNET, or a single IP address or comma-separated list of subnets (in CIDR format) or IPv4 addresses.")
    ("enabled" "enabled - (Optional)  Determines whether the access rule is enabled. Default is true.")

  ) company-terraform-resource-arguments-hash)

(puthash "oraclepaas_java_access_rule" '(
    ("name" "name - (Required) The name of the Access Rule")
    ("service_instance_id" "service_instance_id - (Required) The name of the java service instance to attach the access rule to")
    ("description" "description - (Required) The description of the Access Rule")
    ("ports" "ports - (Required) The port or range of ports to allow traffic on")
    ("destination" "destination - (Required) Destination to which traffic is allowed. Valid values include WLS_ADMIN, WLS_ADMIN_SERVER, OTD_ADMIN_HOST, OTD")
    ("source" "source - (Required) The IP addresses and subnets from which traffic is allowed. Valid values include WLS_ADMIN, WLS_ADMIN_SERVER, WLS_MANAGED_SERVER, OTD_ADMIN_HOST, OTD, or a single IP address or comma-separated list of subnets (in CIDR format) or IPv4 addresses.")
    ("enabled" "enabled - (Optional) Determines whether the access rule is enabled. Default is true.")
    ("protocol" "protocol - (Optional) Specifies the communication protocol. Valid values are tcp or udp. Default is tcp.")

  ) company-terraform-resource-arguments-hash)

(puthash "ovh_vrack_publiccloud_attachment" '(
    ("vrack_id" "vrack_id - (Required) The id of the vrack. If omitted, the OVH_VRACK_ID environment variable is used.")
    ("project_id" "project_id - (Required) The id of the public cloud project. If omitted, the OVH_PROJECT_ID environment variable is used.")

  ) company-terraform-resource-arguments-hash)

(puthash "ovh_publiccloud_private_network" '(
    ("project_id" "project_id - (Required) The id of the public cloud project. If omitted, the OVH_PROJECT_ID environment variable is used.")
    ("name" "name - (Required) The name of the network.")
    ("vlan_id" "vlan_id - a vlan id to associate with the network. Changing this value recreates the resource. Defaults to 0.")
    ("regions" "regions - an array of valid OVH public cloud region ID in which the network will be available. Ex.: \"GRA1\". Defaults to all public cloud regions.")

  ) company-terraform-resource-arguments-hash)

(puthash "ovh_publiccloud_private_network_subnet" '(
    ("project_id" "project_id - (Required) The id of the public cloud project. If omitted, the OVH_PROJECT_ID environment variable is used. Changing this forces a new resource to be created.")
    ("network_id" "network_id - (Required) The id of the network. Changing this forces a new resource to be created.")
    ("dhcp" "dhcp - (Optional) Enable DHCP. Changing this forces a new resource to be created. Defaults to false. _")
    ("start" "start - (Required) First ip for this region. Changing this value recreates the subnet.")
    ("end" "end - (Required) Last ip for this region. Changing this value recreates the subnet.")
    ("network" "network - (Required) Global network in CIDR format. Changing this value recreates the subnet")
    ("region" "region - The region in which the network subnet will be created. Ex.: \"GRA1\". Changing this value recreates the resource.")
    ("no_gateway" "no_gateway - Set to true if you don't want to set a default gateway IP. Changing this value recreates the resource. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "ovh_publiccloud_user" '(
    ("project_id" "project_id - (Required) The id of the public cloud project. If omitted, the OVH_PROJECT_ID environment variable is used.")
    ("description" "description - A description associated with the user.")

  ) company-terraform-resource-arguments-hash)

(puthash "packet_device" '(
    ("hostname" "hostname - (Required) The device name")
    ("project_id" "project_id - (Required) The id of the project in which to create the device")
    ("operating_system" "operating_system - (Required) The operating system slug")
    ("facility" "facility - (Required) The facility in which to create the device")
    ("plan" "plan - (Required) The hardware config slug")
    ("billing_cycle" "billing_cycle - (Required) monthly or hourly")
    ("user_data" "user_data (Optional) - A string of the desired User Data for the device.")
    ("public_ipv4_subnet_size" "public_ipv4_subnet_size (Optional) - Size of allocated subnet, more information is in the Custom Subnet Size doc.")
    ("ipxe_script_url" "ipxe_script_url (Optional) - URL pointing to a hosted iPXE script. More information is in the Custom iPXE doc.")
    ("always_pxe" "always_pxe (Optional) - If true, a device with OS custom_ipxe will continue to boot via iPXE on reboots.")
    ("hardware_reservation_id" "hardware_reservation_id (Optional) - The id of hardware reservation where you want this device deployed, or next-available if you want to pick your next available reservation automatically.")
    ("storage" "storage (Optional) - JSON for custom partitioning. Only usable on reserved hardware. More information in in the Custom Partitioning and RAID doc.")
    ("tags" "tags - Tags attached to the device")
    ("description" "description - Description string for the device")

  ) company-terraform-resource-arguments-hash)

(puthash "packet_project" '(
    ("name" "name - (Required) The name of the Project on Packet.net")
    ("payment_method_id" "payment_method_id - The UUID of payment method for this project. If you keep it empty, Packet API will pick your default Payment Method.")
    ("organization_id" "organization_id - The UUID of Organization under which you want to create the project. If you leave it out, the project will be create under your the default Organization of your account.")

  ) company-terraform-resource-arguments-hash)

(puthash "packet_organization" '(
    ("name" "name - (Required) The name of the Organization.")
    ("description" "description - Description string.")
    ("website" "website - Website link.")
    ("twitter" "twitter - Twitter handle.")
    ("logo" "logo - Logo URL.")

  ) company-terraform-resource-arguments-hash)

(puthash "packet_ssh_key" '(
    ("name" "name - (Required) The name of the SSH key for identification")
    ("public_key" "public_key - (Required) The public key. If this is a file, it can be read using the file interpolation function")

  ) company-terraform-resource-arguments-hash)

(puthash "packet_volume" '(
    ("plan" "plan - (Required) The service plan slug of the volume")
    ("facility" "facility - (Required) The facility to create the volume in")
    ("project_id" "project_id - (Required) The packet project ID to deploy the volume in")
    ("size" "size - (Required) The size in GB to make the volume")
    ("billing_cycle" "billing_cycle - The billing cycle, defaults to \"hourly\"")
    ("description" "description - Optional description for the volume")
    ("snapshot_policies" "snapshot_policies - Optional list of snapshot policies")
    ("locked" "locked - Lock or unlock the volume")

  ) company-terraform-resource-arguments-hash)

(puthash "packet_volume_attachment" '(
    ("volume_id" "volume_id - (Required) The ID of the volume to attach")
    ("device_id" "device_id - (Required) The ID of the device to which the volume should be attached")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_addon" '(
    ("name" "name - (Required) The name of the add-on.")
    ("src" "src - (Required) The source URL to display in a frame in the PagerDuty UI. HTTPS is required.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_escalation_policy" '(
    ("name" "name - (Required) The name of the escalation policy.")
    ("teams" "teams - (Optional) Teams associated with the policy. Account must have the teams ability to use this parameter.")
    ("description" "description - (Optional) A human-friendly description of the escalation policy. If not set, a placeholder of \"Managed by Terraform\" will be set.")
    ("num_loops" "num_loops - (Optional) The number of times the escalation policy will repeat after reaching the end of its escalation.")
    ("rule" "rule - (Required) An Escalation rule block. Escalation rules documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_extension" '(
    ("name" "name - (Optional) The name of the service extension.")
    ("endpoint_url" "endpoint_url - (Required) The url of the extension.")
    ("extension_schema" "extension_schema - (Required) This is the schema for this extension.")
    ("extension_objects" "extension_objects - (Required) This is the objects for which the extension applies (An array of service ids). Note: You can use the pagerduty_extension_schema data source to locate the appropriate extension vendor ID.  »   Attributes Reference")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_maintenance_window" '(
    ("start_time" "start_time  - (Required) The maintenance window's start time. This is when the services will stop creating incidents. If this date is in the past, it will be updated to be the current time.")
    ("end_time" "end_time    - (Required) The maintenance window's end time. This is when the services will start creating incidents again. This date must be in the future and after the start_time.")
    ("services" "services    - (Required) A list of service IDs to include in the maintenance window.")
    ("description" "description - (Optional) A description for the maintenance window.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_schedule" '(
    ("name" "name - (Optional) The name of the escalation policy.")
    ("time_zone" "time_zone - (Required) The time zone of the schedule (e.g Europe/Berlin).")
    ("description" "description - (Optional) The description of the schedule")
    ("layer" "layer - (Required) A schedule layer block. Schedule layers documented below.")
    ("overflow" "overflow - (Optional) Any on-call schedule entries that pass the date range bounds will be truncated at the bounds, unless the parameter overflow is passed. For instance, if your schedule is a rotation that changes daily at midnight UTC, and your date range is from 2011-06-01T10:00:00Z to 2011-06-01T14:00:00Z: If you don't pass the overflow=true parameter, you will get one schedule entry returned with a start of 2011-06-01T10:00:00Z and end of 2011-06-01T14:00:00Z. If you do pass the overflow parameter, you will get one schedule entry returned with a start of 2011-06-01T00:00:00Z and end of 2011-06-02T00:00:00Z.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_service" '(
    ("name" "name - (Required) The name of the service.")
    ("description" "description - (Optional) A human-friendly description of the escalation policy. If not set, a placeholder of \"Managed by Terraform\" will be set.")
    ("auto_resolve_timeout" "auto_resolve_timeout - (Optional) Time in seconds that an incident is automatically resolved if left open for that long. Disabled if set to the \"null\" string.")
    ("acknowledgement_timeout" "acknowledgement_timeout - (Optional) Time in seconds that an incident changes to the Triggered State after being Acknowledged. Disabled if set to the \"null\" string.")
    ("escalation_policy" "escalation_policy - (Required) The escalation policy used by this service.")
    ("alert_creation" "alert_creation - (Optional) Must be one of two values. PagerDuty receives events from your monitoring systems and can then create incidents in different ways. Value \"create_incidents\" is default: events will create an incident that cannot be merged. Value \"create_alerts_and_incidents\" is the alternative: events will create an alert and then add it to a new incident, these incidents can be merged.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_service_integration" '(
    ("service" "service - (Required) The ID of the service the integration should belong to.")
    ("name" "name - (Optional) The name of the service integration.")
    ("type" "type - (Optional) The service type. Can be: aws_cloudwatch_inbound_integration, cloudkick_inbound_integration, event_transformer_api_inbound_integration, events_api_v2_inbound_integration (requires service alert_creation to be create_alerts_and_incidents), generic_email_inbound_integration, generic_events_api_inbound_integration, keynote_inbound_integration, nagios_inbound_integration, pingdom_inbound_integrationor sql_monitor_inbound_integration. Note: This is meant for generic service integrations. To integrate with a vendor (e.g Datadog or Amazon Cloudwatch) use the vendor field instead.")
    ("vendor" "vendor - (Optional) The ID of the vendor the integration should integrate with (e.g Datadog or Amazon Cloudwatch).")
    ("integration_key" "integration_key - (Optional) This is the unique key used to route events to this integration when received via the PagerDuty Events API.")
    ("integration_email" "integration_email - (Optional) This is the unique fully-qualified email address used for routing emails to this integration for processing. Note: You can use the pagerduty_vendor data source to locate the appropriate vendor ID.  »   Attributes Reference")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_team" '(
    ("name" "name - (Required) The name of the group.")
    ("description" "description - (Optional) A human-friendly description of the team. If not set, a placeholder of \"Managed by Terraform\" will be set.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_team_membership" '(
    ("user_id" "user_id - (Required) The ID of the user to add to the team.")
    ("team_id" "team_id - (Required) The ID of the team in which the user will belong.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_user" '(
    ("name" "name - (Required) The name of the user.")
    ("email" "email - (Required) The user's email address.")
    ("color" "color - (Optional) The schedule color for the user.")
    ("role" "role - (Optional) The user role. Account must have the read_only_users ability to set a user as a read_only_user. Can be admin, limited_user, owner, read_only_user, team_responder or user")
    ("job_title" "job_title - (Optional) The user's title.")
    ("teams" "teams - (Optional) A list of teams the user should belong to.")
    ("description" "description - (Optional) A human-friendly description of the user. If not set, a placeholder of \"Managed by Terraform\" will be set.")

  ) company-terraform-resource-arguments-hash)

(puthash "pagerduty_user_contact_method" '(
    ("user_id" "user_id - (Required) The ID of the user.")
    ("type" "type - (Required) The contact method type. May be (email_contact_method, phone_contact_method, sms_contact_method).")
    ("send_short_email" "send_short_email - (Optional) Send an abbreviated email message instead of the standard email output.")
    ("country_code" "country_code - (Optional) The 1-to-3 digit country calling code. Required when using phone_contact_method or sms_contact_method.")
    ("label" "label - (Required) The label (e.g., \"Work\", \"Mobile\", etc.).")
    ("address" "address - (Required) The \"address\" to deliver to: email, phone number, etc., depending on the type.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_address_group" '(
    ("name" "name - (Required) The address group's name.")
    ("device_group" "device_group - (Optional) The device group to put the address group into (default: shared).")
    ("static_addresses" "static_addresses - (Optional) The address objects to include in this statically defined address group.")
    ("dynamic_match" "dynamic_match - (Optional) The IP tags to include in this DAG.")
    ("description" "description - (Optional) The address group's description.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_address_object" '(
    ("name" "name - (Required) The address object's name.")
    ("device_group" "device_group - (Optional) The device group to put the address object into (default: shared).")
    ("type" "type - (Optional) The type of address object.  This can be ip-netmask (default), ip-range, or fqdn.")
    ("value" "value - (Required) The address object's value.  This can take various forms depending on what type of address object this is, but can be something like 192.168.80.150 or 192.168.80.0/24.")
    ("description" "description - (Optional) The address object's description.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_administrative_tag" '(
    ("name" "name - (Required) The administrative tag's name.")
    ("device_group" "device_group - (Optional) The device group to put the administrative tag into (default: shared).")
    ("color" "color - (Optional) The tag's color.  This should be either an empty string (no color) or a string such as color1 or color15.  Note that for maximum portability, you should limit color usage to color16, which was available in PAN-OS 6.1.  PAN-OS 8.1's colors go up to color42.  The value color18 is reserved internally by PAN-OS and thus not available for use.")
    ("comment" "comment - (Optional) The administrative tag's description.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_device_group" '(
    ("name" "name - (Required) The device group's name.")
    ("description" "description - (Optional) The device group's description.")
    ("device" "device - The device definition (see below).")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_device_group_entry" '(
    ("device_group" "device_group - (Required) The device group's name.")
    ("serial" "serial - (Required) The serial number of the firewall.")
    ("vsys_list" "vsys_list - (Optional) A subset of all available vsys on the firewall that should be in this device group.  If the firewall is a virtual firewall, then this parameter should just be omitted.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_nat_policy" '(
    ("name" "name - (Required) The NAT policy's name.")
    ("device_group" "device_group - (Optional) The device group to put the NAT policy into (default: shared).")
    ("rulebase" "rulebase - (Optional) The rulebase.  This can be pre-rulebase (default), post-rulebase, or rulebase.")
    ("description" "description - (Optional) The description.")
    ("type" "type - (Optional). NAT type.  This can be ipv4 (default), nat64, or nptv6.")
    ("source_zones" "source_zones - (Required) The list of source zone(s).")
    ("destination_zone" "destination_zone - (Required) The destination zone.")
    ("to_interface" "to_interface - (Optional) Egress interface from route lookup (default: any).")
    ("service" "service - (Optional) Service (default: any).")
    ("source_addresses" "source_addresses - (Required) List of source address(es).")
    ("destination_addresses" "destination_addresses - (Required) List of destination address(es).")
    ("sat_type" "sat_type - (Optional) Type of source address translation.  This can be none (default), dynamic-ip-and-port, dynamic-ip, or static-ip.")
    ("sat_address_type" "sat_address_type - (Optional) Source address translation address type.")
    ("sat_translated_addresses" "sat_translated_addresses - (Optional) Source address translation list of translated addresses.")
    ("sat_interface" "sat_interface - (Optional) Source address translation interface.")
    ("sat_ip_address" "sat_ip_address - (Optional) Source address translation IP address.")
    ("sat_fallback_type" "sat_fallback_type - (Optional) Source address translation fallback type. This can be none, interface-address, or translated-address.")
    ("sat_fallback_translated_addresses" "sat_fallback_translated_addresses - (Optional) Source address translation list of fallback translated addresses.")
    ("sat_fallback_interface" "sat_fallback_interface - (Optional) Source address translation fallback interface.")
    ("sat_fallback_ip_type" "sat_fallback_ip_type - (Optional) Source address translation fallback IP type.  This can be ip or floating.")
    ("sat_fallback_ip_address" "sat_fallback_ip_address - (Optional) The source address translation fallback IP address.")
    ("sat_static_translated_address" "sat_static_translated_address - (Optional) The statically translated source address.")
    ("sat_static_bi_directional" "sat_static_bi_directional - (Optional) Set to true to enable bi-directional source address translation.")
    ("dat_address" "dat_address - (Optional) Destination address translation's address.")
    ("dat_port" "dat_port - (Optional) Destination address translation's port number.")
    ("disabled" "disabled - (Optional) Set to true to disable this rule.")
    ("tags" "tags - (Optional) List of administrative tags.")
    ("target" "target - (Optional) A target definition (see below).  If there are no target sections, then the policy will apply to every vsys of every device in the device group.")
    ("negate_target" "negate_target - (Optional, bool) Instead of applying the policy for the given serial numbers, apply it to everything except them.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_security_policies" '(
    ("device_group" "device_group - (Optional) The device group to put the security policy into (default: shared).")
    ("rulebase" "rulebase - (Optional) The rulebase.  This can be pre-rulebase (default), post-rulebase, or rulebase.")
    ("rule" "rule - The security policy definition (see below).  The security policy ordering will match how they appear in the terraform plan file.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_service_group" '(
    ("name" "name - (Required) The service group's name.")
    ("device_group" "device_group - (Optional) The device group to put the service group into (default: shared).")
    ("services" "services - (Required) List of services to put in this service group.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_panorama_service_object" '(
    ("name" "name - (Required) The service object's name.")
    ("device_group" "device_group - (Optional) The device group to put the service object into (default: shared).")
    ("description" "description - (Optional) The service object's description.")
    ("protocol" "protocol - (Required) The service's protocol.  This should be tcp or udp.")
    ("source_port" "source_port - (Optional) The source port.  This can be a single port number, range (1-65535), or comma separated (80,8080,443).")
    ("destination_port" "destination_port - (Required) The destination port.  This can be a single port number, range (1-65535), or comma separated (80,8080,443).")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_address_group" '(
    ("name" "name - (Required) The address group's name.")
    ("vsys" "vsys - (Optional) The vsys to put the address group into (default: vsys1).")
    ("static_addresses" "static_addresses - (Optional) The address objects to include in this statically defined address group.")
    ("dynamic_match" "dynamic_match - (Optional) The IP tags to include in this DAG.")
    ("description" "description - (Optional) The address group's description.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_address_object" '(
    ("name" "name - (Required) The address object's name.")
    ("vsys" "vsys - (Optional) The vsys to put the address object into (default: vsys1).")
    ("type" "type - (Optional) The type of address object.  This can be ip-netmask (default), ip-range, or fqdn.")
    ("value" "value - (Required) The address object's value.  This can take various forms depending on what type of address object this is, but can be something like 192.168.80.150 or 192.168.80.0/24.")
    ("description" "description - (Optional) The address object's description.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_administrative_tag" '(
    ("name" "name - (Required) The administrative tag's name.")
    ("vsys" "vsys - (Optional) The vsys to put the administrative tag into (default: vsys1).")
    ("color" "color - (Optional) The tag's color.  This should be either an empty string (no color) or a string such as color1 or color15.  Note that for maximum portability, you should limit color usage to color16, which was available in PAN-OS 6.1.  PAN-OS 8.1's colors go up to color42.  The value color18 is reserved internally by PAN-OS and thus not available for use.")
    ("comment" "comment - (Optional) The administrative tag's description.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_dag_tags" '(
    ("vsys" "vsys - (Optional) The vsys to put the DAG tags in (default: vsys1).")
    ("register" "register - (Required) A set that includes ip, the IP address to be tagged and tags, a list of tags to associate with the given IP.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_ethernet_interface" '(
    ("name" "name - (Required) The ethernet interface's name.  This should be something like ethernet1/X.")
    ("vsys" "vsys - (Required) The vsys that will use this interface.  This should be something like vsys1 or vsys3.")
    ("mode" "mode - (Required) The interface mode.  This can be any of the following values: layer3, layer2, virtual-wire, tap, ha, decrypt-mirror, or aggregate-group.")
    ("static_ips" "static_ips - (Optional) List of static IPv4 addresses to set for this data interface.")
    ("enable_dhcp" "enable_dhcp - (Optional) Set to true to enable DHCP on this interface.")
    ("create_dhcp_default_route" "create_dhcp_default_route - (Optional) Set to true to create a DHCP default route.")
    ("dhcp_default_route_metric" "dhcp_default_route_metric - (Optional) The metric for the DHCP default route.")
    ("ipv6_enabled" "ipv6_enabled - (Optional) Set to true to enable IPv6.")
    ("management_profile" "management_profile - (Optional) The management profile.")
    ("mtu" "mtu - (Optional) The MTU.")
    ("adjust_tcp_mss" "adjust_tcp_mss - (Optional) Adjust TCP MSS (default: false).")
    ("netflow_profile" "netflow_profile - (Optional) The netflow profile.")
    ("lldp_enabled" "lldp_enabled - (Optional) Enable LLDP (default: false).")
    ("lldp_profile" "lldp_profile - (Optional) LLDP profile.")
    ("link_speed" "link_speed - (Optional) Link speed.  This can be any of the following: 10, 100, 1000, or auto.")
    ("link_duplex" "link_duplex - (Optional) Link duplex setting.  This can be full, half, or auto.")
    ("link_state" "link_state - (Optional) The link state.  This can be up, down, or auto.")
    ("aggregate_group" "aggregate_group - (Optional) The aggregate group (applicable for physical firewalls only).")
    ("comment" "comment - (Optional) The interface comment.")
    ("ipv4_mss_adjust" "ipv4_mss_adjust - (Optional, PAN-OS 8.0+) The IPv4 MSS adjust value.")
    ("ipv6_mss_adjust" "ipv6_mss_adjust - (Optional, PAN-OS 8.0+) The IPv6 MSS adjust value.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_general_settings" '(
    ("hostname" "hostname - Firewall hostname.")
    ("timezone" "timezone - The timezone (e.g. - US/Pacific).")
    ("domain" "domain - The domain.")
    ("update_server" "update_server - The update server (Default: updates.paloaltonetworks.com).")
    ("verify_update_server" "verify_update_server - Verify update server identity (Default: true).")
    ("dns_primary" "dns_primary - Primary DNS server.")
    ("dns_secondary" "dns_secondary - Secondary DNS server.")
    ("ntp_primary_address" "ntp_primary_address - Primary NTP server.")
    ("ntp_primary_auth_type" "ntp_primary_auth_type - Primary NTP auth type.  This can be none, autokey, or symmetric-key.")
    ("ntp_primary_key_id" "ntp_primary_key_id - Primary NTP symmetric-key key ID.")
    ("ntp_primary_algorithm" "ntp_primary_algorithm - Primary NTP symmetric-key algorithm.  This can be sha1 or md5.")
    ("ntp_primary_auth_key" "ntp_primary_auth_key - Primary NTP symmetric-key auth key.  This is the SHA1 hash if the algorithm is sha1, or the md5sum if the algorithm is md5.")
    ("ntp_secondary_address" "ntp_secondary_address - Secondary NTP server.")
    ("ntp_secondary_auth_type" "ntp_secondary_auth_type - Secondary NTP auth type.  This can be none, autokey, or symmetric-key.")
    ("ntp_secondary_key_id" "ntp_secondary_key_id - Secondary NTP symmetric-key key ID.")
    ("ntp_secondary_algorithm" "ntp_secondary_algorithm - Secondary NTP symmetric-key algorithm.  This can be sha1 or md5.")
    ("ntp_secondary_auth_key" "ntp_secondary_auth_key - Secondary NTP symmetric-key auth key.  This is the SHA1 hash if the algorithm is sha1, or the md5sum if the algorithm is md5.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_management_profile" '(
    ("name" "name - (Required) The management profile's name.")
    ("ping" "ping - (Optional) Allow ping.")
    ("telnet" "telnet - (Optional) Allow telnet.")
    ("ssh" "ssh - (Optional) Allow SSH.")
    ("http" "http - (Optional) Allow HTTP.")
    ("http_ocsp" "http_ocsp - (Optional) Allow HTTP OCSP.")
    ("https" "https - (Optional) Allow HTTPS.")
    ("snmp" "snmp - (Optional) Allow SNMP.")
    ("response_pages" "response_pages - (Optional) Allow response pages.")
    ("userid_service" "userid_service - (Optional) Allow User ID service.")
    ("userid_syslog_listener_ssl" "userid_syslog_listener_ssl - (Optional) Allow User ID syslog listener for SSL.")
    ("userid_syslog_listener_udp" "userid_syslog_listener_udp - (Optional) Allow User ID syslog listener for UDP.")
    ("permitted_ips" "permitted_ips - (Optional) The list of permitted IP addresses or address ranges for this management profile.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_nat_policy" '(
    ("name" "name - (Required) The NAT policy's name.")
    ("vsys" "vsys - (Optional) The vsys to put the NAT policy into (default: vsys1).")
    ("rulebase" "rulebase - (Optional, Deprecated) The rulebase.  For firewalls, there is only the rulebase value (default), but on Panorama, there is also pre-rulebase and post-rulebase.")
    ("description" "description - (Optional) The description.")
    ("type" "type - (Optional). NAT type.  This can be ipv4 (default), nat64, or nptv6.")
    ("source_zones" "source_zones - (Required) The list of source zone(s).")
    ("destination_zone" "destination_zone - (Required) The destination zone.")
    ("to_interface" "to_interface - (Optional) Egress interface from route lookup (default: any).")
    ("service" "service - (Optional) Service (default: any).")
    ("source_addresses" "source_addresses - (Required) List of source address(es).")
    ("destination_addresses" "destination_addresses - (Required) List of destination address(es).")
    ("sat_type" "sat_type - (Optional) Type of source address translation.  This can be none (default), dynamic-ip-and-port, dynamic-ip, or static-ip.")
    ("sat_address_type" "sat_address_type - (Optional) Source address translation address type.")
    ("sat_translated_addresses" "sat_translated_addresses - (Optional) Source address translation list of translated addresses.")
    ("sat_interface" "sat_interface - (Optional) Source address translation interface.")
    ("sat_ip_address" "sat_ip_address - (Optional) Source address translation IP address.")
    ("sat_fallback_type" "sat_fallback_type - (Optional) Source address translation fallback type. This can be none, interface-address, or translated-address.")
    ("sat_fallback_translated_addresses" "sat_fallback_translated_addresses - (Optional) Source address translation list of fallback translated addresses.")
    ("sat_fallback_interface" "sat_fallback_interface - (Optional) Source address translation fallback interface.")
    ("sat_fallback_ip_type" "sat_fallback_ip_type - (Optional) Source address translation fallback IP type.  This can be ip or floating.")
    ("sat_fallback_ip_address" "sat_fallback_ip_address - (Optional) The source address translation fallback IP address.")
    ("sat_static_translated_address" "sat_static_translated_address - (Optional) The statically translated source address.")
    ("sat_static_bi_directional" "sat_static_bi_directional - (Optional) Set to true to enable bi-directional source address translation.")
    ("dat_address" "dat_address - (Optional) Destination address translation's address.")
    ("dat_port" "dat_port - (Optional) Destination address translation's port number.")
    ("disabled" "disabled - (Optional) Set to true to disable this rule.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_security_policies" '(
    ("vsys" "vsys - (Optional) The vsys to put the security policy into (default: vsys1).")
    ("rulebase" "rulebase - (Optional, Deprecated) The rulebase.  For firewalls, there is only the rulebase value (default), but on Panorama, there is also pre-rulebase and post-rulebase.")
    ("rule" "rule - The security policy definition (see below).  The security policy ordering will match how they appear in the terraform plan file.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_service_group" '(
    ("name" "name - (Required) The service group's name.")
    ("vsys" "vsys - (Optional) The vsys to put the service group into (default: vsys1).")
    ("services" "services - (Required) List of services to put in this service group.")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_service_object" '(
    ("name" "name - (Required) The service object's name.")
    ("vsys" "vsys - (Optional) The vsys to put the service object into (default: vsys1).")
    ("description" "description - (Optional) The service object's description.")
    ("protocol" "protocol - (Required) The service's protocol.  This should be tcp or udp.")
    ("source_port" "source_port - (Optional) The source port.  This can be a single port number, range (1-65535), or comma separated (80,8080,443).")
    ("destination_port" "destination_port - (Required) The destination port.  This can be a single port number, range (1-65535), or comma separated (80,8080,443).")
    ("tags" "tags - (Optional) List of administrative tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_virtual_router" '(
    ("name" "name - (Required) The virtual router's name.")
    ("vsys" "vsys - (Required) The vsys that will use this virtual router.  This should be something like vsys1 or vsys3.")
    ("interfaces" "interfaces - (Optional) List of interfaces that should use this virtual router.")
    ("static_dist" "static_dist - (Optional) Admin distance - Static (default: 10).")
    ("static_ipv6_dist" "static_ipv6_dist - (Optional) Admin distance - Static IPv6 (default: 10).")
    ("ospf_int_dist" "ospf_int_dist - (Optional) Admin distance - OSPF Int (default: 30).")
    ("ospf_ext_dist" "ospf_ext_dist - (Optional) Admin distance - OSPF Ext (default: 110).")
    ("ospfv3_int_dist" "ospfv3_int_dist - (Optional) Admin distance - OSPFv3 Int (default: 30).")
    ("ospfv3_ext_dist" "ospfv3_ext_dist - (Optional) Admin distance - OSPFv3 Ext (default: 110).")
    ("ibgp_dist" "ibgp_dist - (Optional) Admin distance - IBGP (default: 200).")
    ("ebgp_dist" "ebgp_dist - (Optional) Admin distance - EBGP (default: 20).")
    ("rip_dist" "rip_dist - (Optional) Admin distance - RIP (default: 120).")

  ) company-terraform-resource-arguments-hash)

(puthash "panos_zone" '(
    ("name" "name - (Required) The zone's name.")
    ("vsys" "vsys - (Optional) The vsys to put the zone into (default: vsys1).")
    ("mode" "mode - (Required) The zone's mode.  This can be layer3, layer2, virtual-wire, tap, or tunnel.")
    ("zone_profile" "zone_profile - (Optional) The zone protection profile.")
    ("log_setting" "log_setting - (Optional) Log setting.")
    ("enable_user_id" "enable_user_id - (Optional) Boolean to enable user identification.")
    ("interfaces" "interfaces - (Optional) List of interfaces to associated with this zone.")
    ("include_acls" "include_acls - (Optional) Users from these addresses/subnets will be identified.  This can be an address object, an address group, a single IP address, or an IP address subnet.")
    ("exclude_acls" "exclude_acls - (Optional) Users from these addresses/subnets will not be identified.  This can be an address object, an address group, a single IP address, or an IP address subnet.")

  ) company-terraform-resource-arguments-hash)

(puthash "postgresql_database" '(
    ("name" "name - (Required) The name of the database. Must be unique on the PostgreSQL server instance where it is configured.")
    ("owner" "owner - (Optional) The role name of the user who will own the database, or DEFAULT to use the default (namely, the user executing the command). To create a database owned by another role or to change the owner of an existing database, you must be a direct or indirect member of the specified role, or the username in the provider is a superuser.")
    ("tablespace_name" "tablespace_name - (Optional) The name of the tablespace that will be associated with the database, or DEFAULT to use the template database's tablespace.  This tablespace will be the default tablespace used for objects created in this database.")
    ("connection_limit" "connection_limit - (Optional) How many concurrent connections can be established to this database. -1 (the default) means no limit.")
    ("allow_connections" "allow_connections - (Optional) If false then no one can connect to this database. The default is true, allowing connections (except as restricted by other mechanisms, such as GRANT or REVOKE CONNECT).")
    ("is_template" "is_template - (Optional) If true, then this database can be cloned by any user with CREATEDB privileges; if false (the default), then only superusers or the owner of the database can clone it.")
    ("template" "template - (Optional) The name of the template database from which to create the database, or DEFAULT to use the default template (template0).  NOTE: the default in Terraform is template0, not template1.  Changing this value will force the creation of a new resource as this value can only be changed when a database is created.")
    ("encoding" "encoding - (Optional) Character set encoding to use in the database. Specify a string constant (e.g. UTF8 or SQL_ASCII), or an integer encoding number.  If unset or set to an empty string the default encoding is set to UTF8.  If set to DEFAULT Terraform will use the same encoding as the template database.  Changing this value will force the creation of a new resource as this value can only be changed when a database is created.")
    ("lc_collate" "lc_collate - (Optional) Collation order (LC_COLLATE) to use in the database.  This affects the sort order applied to strings, e.g. in queries with ORDER BY, as well as the order used in indexes on text columns. If unset or set to an empty string the default collation is set to C.  If set to DEFAULT Terraform will use the same collation order as the specified template database.  Changing this value will force the creation of a new resource as this value can only be changed when a database is created.")
    ("lc_ctype" "lc_ctype - (Optional) Character classification (LC_CTYPE) to use in the database. This affects the categorization of characters, e.g. lower, upper and digit. If unset or set to an empty string the default character classification is set to C.  If set to DEFAULT Terraform will use the character classification of the specified template database.  Changing this value will force the creation of a new resource as this value can only be changed when a database is created.")

  ) company-terraform-resource-arguments-hash)

(puthash "postgresql_extension" '(
    ("name" "name - (Required) The name of the extension.")
    ("schema" "schema - (Optional) Sets the schema of an extension.")
    ("version" "version - (Optional) Sets the version number of the extension.")

  ) company-terraform-resource-arguments-hash)

(puthash "postgresql_role" '(
    ("name" "name - (Required) The name of the role. Must be unique on the PostgreSQL server instance where it is configured.")
    ("superuser" "superuser - (Optional) Defines whether the role is a \"superuser\", and therefore can override all access restrictions within the database.  Default value is false.")
    ("create_database" "create_database - (Optional) Defines a role's ability to execute CREATE DATABASE.  Default value is false.")
    ("create_role" "create_role - (Optional) Defines a role's ability to execute CREATE ROLE. A role with this privilege can also alter and drop other roles.  Default value is false.")
    ("inherit" "inherit - (Optional) Defines whether a role \"inherits\" the privileges of roles it is a member of.  Default value is true.")
    ("login" "login - (Optional) Defines whether role is allowed to log in.  Roles without this attribute are useful for managing database privileges, but are not users in the usual sense of the word.  Default value is false.")
    ("replication" "replication - (Optional) Defines whether a role is allowed to initiate streaming replication or put the system in and out of backup mode.  Default value is false")
    ("bypass_row_level_security" "bypass_row_level_security - (Optional) Defines whether a role bypasses every row-level security (RLS) policy.  Default value is false.")
    ("connection_limit" "connection_limit - (Optional) If this role can log in, this specifies how many concurrent connections the role can establish. -1 (the default) means no limit.")
    ("encrypted_password" "encrypted_password - (Optional) Defines whether the password is stored encrypted in the system catalogs.  Default value is true.  NOTE: this value is always set (to the conservative and safe value), but may interfere with the behavior of PostgreSQL's password_encryption setting.")
    ("password" "password - (Optional) Sets the role's password. (A password is only of use for roles having the login attribute set to true, but you can nonetheless define one for roles without it.) Roles without a password explicitly set are left alone.  If the password is set to the magic value NULL, the password will be always be cleared.")
    ("valid_until" "valid_until - (Optional) Defines the date and time after which the role's password is no longer valid.  Established connections past this valid_time will have to be manually terminated.  This value corresponds to a PostgreSQL datetime. If omitted or the magic value NULL is used, valid_until will be set to infinity.  Default is NULL, therefore infinity.")
    ("skip_drop_role" "skip_drop_role - (Optional) When a PostgreSQL ROLE exists in multiple databases and the ROLE is dropped, the cleanup of ownership of objects in each of the respective databases must occur before the ROLE can be dropped from the catalog.  Set this option to true when there are multiple databases in a PostgreSQL cluster using the same PostgreSQL ROLE for object ownership. This is the third and final step taken when removing a ROLE from a database.")
    ("skip_reassign_owned" "skip_reassign_owned - (Optional) When a PostgreSQL ROLE exists in multiple databases and the ROLE is dropped, a REASSIGN OWNED in must be executed on each of the respective databases before the DROP ROLE can be executed to dropped the ROLE from the catalog.  This is the first and second steps taken when removing a ROLE from a database (the second step being an implicit DROP OWNED).")

  ) company-terraform-resource-arguments-hash)

(puthash "postgresql_schema" '(
    ("name" "name - (Required) The name of the schema. Must be unique in the PostgreSQL database instance where it is configured.")
    ("owner" "owner - (Optional) The ROLE who owns the schema.")
    ("if_not_exists" "if_not_exists - (Optional) When true, use the existing schema if it exists. (Default: true)")
    ("policy" "policy - (Optional) Can be specified multiple times for each policy.  Each policy block supports fields documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "powerdns_record" '(
    ("zone" "zone - (Required) The name of zone to contain this record.")
    ("name" "name - (Required) The name of the record.")
    ("type" "type - (Required) The record type.")
    ("ttl" "ttl - (Required) The TTL of the record.")
    ("records" "records - (Required) A string list of records.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_datacenter" '(
    ("name" "name - (Required)[string] The name of the Virtual Data Center.")
    ("location" "location - (Required)[string] The physical location where the data center will be created.")
    ("description" "description - (Optional)[string] Description for the data center.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_firewall" '(

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_group" '(
    ("access_activity_log" "access_activity_log - (Required) [Boolean] The group will be allowed to access the activity log.")
    ("create_datacenter" "create_datacenter - (Optional) [Boolean] The group will be allowed to create virtual data centers.")
    ("create_snapshot" "create_snapshot - (Optional) [Boolean] The group will be allowed to create snapshots.")
    ("name" "name - (Optional) [string] A name for the group.")
    ("reserve_ip" "reserve_ip - (Optional) [Boolean] The group will be allowed to reserve IP addresses.")
    ("user_id" "user_id - (Optional) [string] The ID of the specific user to add to the group.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_ipblock" '(
    ("location" "location - (Required)")
    ("size" "size - (Required)")
    ("ips" "ips - (Computed) IPs associated with this block")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_ipfailover" '(
    ("datacenter_id" "datacenter_id - (Required) [string] The ID of a virtual data center.")
    ("ip" "ip - (Required) [string] The Reserved IP address to be used in the failover group.")
    ("lan_id" "lan_id - (Required) [string] The ID of a LAN.")
    ("nicuuid" "nicuuid - (Required) [string] The ID of a NIC.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_lan" '(
    ("datacenter_id" "datacenter_id - (Required) [string]")
    ("name" "name - (Optional) [string] The name of the LAN")
    ("public" "public - (Optional) [Boolean] indicating if the LAN faces the public Internet or not.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_loadbalancer" '(
    ("name" "name - (Required) the name of the loadbalancer")
    ("datacenter_id" "datacenter_id - (Required)[string]")
    ("nic_ids" "nic_ids - (Required)[list]")
    ("dhcp" "dhcp - (Optional) [boolean] Indicates if the load balancer will reserve an IP using DHCP.")
    ("ip" "ip - (Optional) [string] IPv4 address of the load balancer.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_nic" '(
    ("datacenter_id" "datacenter_id - (Required)[string]1")
    ("server_id" "server_id - (Required)[string]1")
    ("lan" "lan - (Required) [integer] The LAN ID the NIC will sit on.")
    ("name" "name - (Optional) [string] The name of the LAN.")
    ("dhcp" "dhcp - (Optional) [boolean]")
    ("ip" "ip - (Optional) [string] IP assigned to the NIC.")
    ("firewall_active" "firewall_active - (Optional) [boolean] If this resource is set to true and is nested under a server resource firewall, with open SSH port, resource must be nested under the nic.")
    ("nat" "nat - (Optional) [boolean] Boolean value indicating if the private IP address has outbound access to the public internet.")
    ("ips" "ips - (Computed) the IPs assigned to the NIC")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_server" '(
    ("name" "name - (Required) [string] The name of the server.")
    ("datacenter_id" "datacenter_id - (Required)[string]")
    ("cores" "cores - (Required)[integer] Number of server cores.")
    ("ram" "ram - (Required)[integer] The amount of memory for the server in MB.")
    ("availability_zone" "availability_zone - (Optional)[string] The availability zone in which the server should exist.")
    ("licence_type" "licence_type - (Optional)[string] Sets the OS type of the server.")
    ("cpu_family" "cpu_family - (Optional)[string] Sets the CPU type. \"AMD_OPTERON\" or \"INTEL_XEON\". Defaults to \"AMD_OPTERON\".")
    ("volume" "volume -  (Required) See Volume section.")
    ("nic" "nic - (Required) See NIC section.")
    ("firewall" "firewall - (Optional) See Firewall Rule section.")
    ("boot_volume" "boot_volume - (Computed) The associated boot volume.")
    ("boot_cdrom" "boot_cdrom - (Computed) The associated boot drive, if any.")
    ("boot_image" "boot_image - (Computed) The associated boot image.")
    ("primary_nic" "primary_nic - (Computed) The associated nic.")
    ("primary_ip" "primary_ip - (Computed) The associated ip.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_share" '(
    ("edit_privilege" "edit_privilege - (Required) [Boolean] The group has permission to edit privileges on this resource.")
    ("group_id" "group_id - (Required) [string] The ID of the specific group containing the resource to update.")
    ("resource_id" "resource_id - (Required) [string] The ID of the specific resource to update.")
    ("share_privilege" "share_privilege - (Required) [Boolean] The group has permission to share this resource.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_snapshot" '(
    ("datacenter_id" "datacenter_id - (Required) [Boolean] The ID of the Virtual Data Center.")
    ("name" "name - (Required) [Boolean] The name of the snapshot.")
    ("volume_id" "volume_id - (Required) [Boolean] The ID of the specific volume to take snapshot from.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_user" '(
    ("administrator" "administrator - (Required) [Boolean] The group has permission to edit privileges on this resource.")
    ("email" "email - (Required) [string] An e-mail address for the user.")
    ("first_name" "first_name - (Required) [string] A name for the user.")
    ("force_sec_auth" "force_sec_auth - (Required) [Boolean] The group has permission to user this resource.")
    ("last_name" "last_name - (Required) [string] A name for the user.")
    ("password" "password - (Required) [string] A password for the user.")

  ) company-terraform-resource-arguments-hash)

(puthash "profitbricks_volume" '(
    ("datacenter_id" "datacenter_id - (Required) [string] 1")
    ("server_id" "server_id - (Required)[string] 1")
    ("disk_type" "disk_type - (Required) [string] The volume type, HDD or SSD.")
    ("bus" "bus - (Required) [boolean] The bus type of the volume.")
    ("size" "size -  (Required)[integer] The size of the volume in GB.")
    ("ssh_key_path" "ssh_key_path -  (Required)[list] List of paths to files containing a public SSH key that will be injected into ProfitBricks provided Linux images. Required if image_password is not provided.")
    ("sshkey" "sshkey - (Computed) the associated public ssh key.")
    ("image_password" "image_password - [string] Required if sshkey_path is not provided.")
    ("image_name" "image_name - [string] The image or snapshot ID. It is required if licence_type is not provided.")
    ("licence_type" "licence_type - [string] Required if image_name is not provided.")
    ("name" "name - (Optional) [string] The name of the volume.")
    ("availability_zone" "availability_zone - (Optional) [string] The storage availability zone assigned to the volume. AUTO, ZONE_1, ZONE_2, or ZONE_3")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_binding" '(
    ("source" "source - (Required) The source exchange.")
    ("vhost" "vhost - (Required) The vhost to create the resource in.")
    ("destination" "destination - (Required) The destination queue or exchange.")
    ("destination_type" "destination_type - (Required) The type of destination (queue or exchange).")
    ("routing_key" "routing_key - (Optional) A routing key for the binding.")
    ("arguments" "arguments - (Optional) Additional key/value arguments for the binding.")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_exchange" '(
    ("name" "name - (Required) The name of the exchange.")
    ("vhost" "vhost - (Required) The vhost to create the resource in.")
    ("settings" "settings - (Required) The settings of the exchange. The structure is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_permissions" '(
    ("user" "user - (Required) The user to apply the permissions to.")
    ("vhost" "vhost - (Required) The vhost to create the resource in.")
    ("permissions" "permissions - (Required) The settings of the permissions. The structure is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_policy" '(
    ("name" "name - (Required) The name of the policy.")
    ("vhost" "vhost - (Required) The vhost to create the resource in.")
    ("policy" "policy - (Required) The settings of the policy. The structure is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_queue" '(
    ("name" "name - (Required) The name of the queue.")
    ("vhost" "vhost - (Required) The vhost to create the resource in.")
    ("settings" "settings - (Required) The settings of the queue. The structure is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_user" '(
    ("name" "name - (Required) The name of the user.")
    ("password" "password - (Required) The password of the user. The value of this argument is plain-text so make sure to secure where this is defined.")
    ("tags" "tags - (Optional) Which permission model to apply to the user. Valid options are: management, policymaker, monitoring, and administrator.")

  ) company-terraform-resource-arguments-hash)

(puthash "rabbitmq_vhost" '(
    ("name" "name - (Required) The name of the vhost.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_certificate" '(
    ("name" "name - (Required) The name of the certificate.")
    ("description" "description - (Optional) A certificate description.")
    ("environment_id" "environment_id - (Required) The ID of the environment to create the certificate for.")
    ("cert" "cert - (Required) The certificate content.")
    ("cert_chain" "cert_chain - (Optional) The certificate chain.")
    ("key" "key - (Required) The certificate key.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_environment" '(
    ("name" "name - (Required) The name of the environment.")
    ("description" "description - (Optional) An environment description.")
    ("orchestration" "orchestration - (Optional) Must be one of cattle, swarm, mesos, windows or kubernetes. This is a helper for setting the project_template_ids for the included Rancher templates. This will conflict with project_template_id setting. Changing this forces a new resource to be created.")
    ("project_template_id" "project_template_id - (Optional) This can be any valid project template ID. If this is set, then orchestration can not be. Changing this forces a new resource to be created.")
    ("member" "member - (Optional) Members to add to the environment.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_host" '(
    ("id" "id - (Computed) The ID of the resource.")
    ("name" "name - (Required) The name of the host.")
    ("description" "description - (Optional) A host description.")
    ("environment_id" "environment_id - (Required) The ID of the environment the host is associated to.")
    ("hostname" "hostname - (Required) The host name. Used as the primary key to detect the host ID.")
    ("labels" "labels - (Optional) A dictionary of labels to apply to the host. Computed internal labels are excluded from that list.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_registration_token" '(
    ("name" "name - (Required) The name of the registration token.")
    ("description" "description - (Optional) A registration token description.")
    ("environment_id" "environment_id - (Required) The ID of the environment to create the token for.")
    ("host_labels" "host_labels - (Optional) A map of host labels to add to the registration command.")
    ("agent_ip" "agent_ip - (Optional) A string containing the CATTLE_AGENT_IP to add to the registration command.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_registry_credential" '(
    ("name" "name - (Required) The name of the registry credential.")
    ("description" "description - (Optional) A registry credential description.")
    ("registry_id" "registry_id - (Required) The ID of the registry to create the credential for.")
    ("public_value" "public_value - (Required) The public value (user name) of the account.")
    ("secret_value" "secret_value - (Required) The secret value (password) of the account.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_registry" '(
    ("name" "name - (Required) The name of the registry.")
    ("description" "description - (Optional) A registry description.")
    ("environment_id" "environment_id - (Required) The ID of the environment to create the registry for.")
    ("server_address" "server_address - (Required) The server address for the registry.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_secret" '(
    ("name" "name - (Required) The name of the secret.")
    ("description" "description - (Optional) A description of the secret.")
    ("environment_id" "environment_id - (Required) The ID of the environment to create the secret for.")
    ("value" "value - (Required) The secret value.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_stack" '(
    ("name" "name - (Required) The name of the stack.")
    ("description" "description - (Optional) A stack description.")
    ("environment_id" "environment_id - (Required) The ID of the environment to create the stack for.")
    ("docker_compose" "docker_compose - (Optional) The docker-compose.yml content to apply for the stack.")
    ("rancher_compose" "rancher_compose - (Optional) The rancher-compose.yml content to apply for the stack.")
    ("environment" "environment - (Optional) The environment to apply to interpret the docker-compose and rancher-compose files.")
    ("catalog_id" "catalog_id - (Optional) The catalog ID to link this stack to. When provided, docker_compose and rancher_compose will be retrieved from the catalog unless they are overridden.")
    ("scope" "scope - (Optional) The scope to attach the stack to. Must be one of user or system. Defaults to user.")
    ("start_on_create" "start_on_create - (Optional) Whether to start the stack automatically.")
    ("finish_upgrade" "finish_upgrade - (Optional) Whether to automatically finish upgrades to this stack.")

  ) company-terraform-resource-arguments-hash)

(puthash "rancher_volume" '(
    ("name" "name - (Required) The name of the volume.")
    ("description" "description - (Optional) A description of the volume.")
    ("environment_id" "environment_id - (Required) The ID of the environment to create the volume for.")
    ("driver" "driver - (Required) The volume driver.")

  ) company-terraform-resource-arguments-hash)

(puthash "random_id" '(
    ("byte_length" "byte_length - (Required) The number of random bytes to produce. The minimum value is 1, which produces eight bits of randomness.")
    ("keepers" "keepers - (Optional) Arbitrary map of values that, when changed, will trigger a new id to be generated. See the main provider documentation for more information.")
    ("prefix" "prefix - (Optional) Arbitrary string to prefix the output value with. This string is supplied as-is, meaning it is not guaranteed to be URL-safe or base64 encoded.")

  ) company-terraform-resource-arguments-hash)

(puthash "random_pet" '(
    ("keepers" "keepers - (Optional) Arbitrary map of values that, when changed, will trigger a new id to be generated. See the main provider documentation for more information.")
    ("length" "length - (Optional) The length (in words) of the pet name.")
    ("prefix" "prefix - (Optional) A string to prefix the name with.")
    ("separator" "separator - (Optional) The character to separate words in the pet name.")

  ) company-terraform-resource-arguments-hash)

(puthash "random_shuffle" '(
    ("input" "input - (Required) The list of strings to shuffle.")
    ("result_count" "result_count - (Optional) The number of results to return. Defaults to the number of items in the input list. If fewer items are requested, some elements will be excluded from the result. If more items are requested, items will be repeated in the result but not more frequently than the number of items in the input list.")
    ("keepers" "keepers - (Optional) Arbitrary map of values that, when changed, will trigger a new id to be generated. See the main provider documentation for more information.")
    ("seed" "seed - (Optional) Arbitrary string with which to seed the random number generator, in order to produce less-volatile permutations of the list. Important: Even with an identical seed, it is not guaranteed that the same permutation will be produced across different versions of Terraform. This argument causes the result to be less volatile, but not fixed for all time.")

  ) company-terraform-resource-arguments-hash)

(puthash "random_string" '(
    ("length" "length - (Required) The length of the string desired")
    ("upper" "upper - (Optional) (default true) Include uppercase alphabet characters in random string.")
    ("lower" "lower - (Optional) (default true) Include lowercase alphabet characters in random string.")
    ("number" "number - (Optional) (default true) Include numeric characters in random string.")
    ("special" "special - (Optional) (default true) Include special characters in random string. These are '!@#$%&*()-_=+[]{}<>:?'")
    ("override_special" "override_special - (Optional) Supply your own list of special characters to use for string generation.  This overrides characters list in the special argument.  The special argument must still be set to true for any overwritten characters to be used in generation.")
    ("keepers" "keepers - (Optional) Arbitrary map of values that, when changed, will trigger a new id to be generated. See the main provider documentation for more information.")

  ) company-terraform-resource-arguments-hash)

(puthash "random_integer" '(
    ("min" "min - (int) The minimum inclusive value of the range.")
    ("max" "max - (int) The maximum inclusive value of the range.")
    ("keepers" "keepers - (Optional) Arbitrary map of values that, when changed, will trigger a new id to be generated. See the main provider documentation for more information.")
    ("seed" "seed - (Optional) A custom seed to always produce the same value.")

  ) company-terraform-resource-arguments-hash)

(puthash "rundeck_project" '(
    ("name" "name - (Required) The name of the project, used both in the UI and to uniquely identify the project. Must therefore be unique across a single Rundeck installation.")
    ("resource_model_source" "resource_model_source - (Required) Nested block instructing Rundeck on how to determine the set of resources (nodes) for this project. The nested block structure is described below.")
    ("description" "description - (Optional) A description of the project, to be displayed in the Rundeck UI. Defaults to \"Managed by Terraform\".")
    ("default_node_file_copier_plugin" "default_node_file_copier_plugin - (Optional) The name of a plugin to use to copy files onto nodes within this project. Defaults to jsch-scp, which uses the \"Secure Copy\" protocol to send files over SSH.")
    ("default_node_executor_plugin" "default_node_executor_plugin - (Optional) The name of a plugin to use to run commands on nodes within this project. Defaults to jsch-ssh, which uses the SSH protocol to access the nodes.")
    ("ssh_authentication_type" "ssh_authentication_type - (Optional) When the SSH-based file copier and executor plugins are used, the type of SSH authentication to use. Defaults to privateKey.")
    ("ssh_key_storage_path" "ssh_key_storage_path - (Optional) When the SSH-based file copier and executor plugins are used, the location within Rundeck's key store where the SSH private key can be found. Private keys can be uploaded to rundeck using the rundeck_private_key resource.")
    ("ssh_key_file_path" "ssh_key_file_path - (Optional) Like ssh_key_storage_path except that the key is read from the Rundeck server's local filesystem, rather than from the key store.")
    ("extra_config" "extra_config - (Optional) Behind the scenes a Rundeck project is really an arbitrary set of key/value pairs. This map argument allows setting any configuration properties that aren't explicitly supported by the other arguments described above, but due to limitations of Terraform the key names must be written with slashes in place of dots. Do not use this argument to set properties that the above arguments set, or undefined behavior will result.")

  ) company-terraform-resource-arguments-hash)

(puthash "rundeck_private_key" '(
    ("path" "path - (Required) The path within the key store where the key will be stored.")
    ("key_material" "key_material - (Required) The private key material to store, serialized in any way that is accepted by OpenSSH.")

  ) company-terraform-resource-arguments-hash)

(puthash "rundeck_public_key" '(
    ("path" "path - (Required) The path within the key store where the key will be stored. By convention this path name normally ends with \".pub\" and otherwise has the same name as the associated private key.")
    ("key_material" "key_material - (Optional) The public key string to store, serialized in any way that is accepted by OpenSSH. If this is not included, key_material becomes an attribute that can be used to read the already-existing key material in the Rundeck store.")

  ) company-terraform-resource-arguments-hash)

(puthash "rundeck_job" '(
    ("name" "name - (Required) The name of the job, used to describe the job in the Rundeck UI.")
    ("description" "description - (Required) A longer description of the job, describing the job in the Rundeck UI.")
    ("project_name" "project_name - (Required) The name of the project that this job should belong to.")
    ("group_name" "group_name - (Optional) The name of a group within the project in which to place the job. Setting this creates collapsable subcategories within the Rundeck UI's project job index.")
    ("log_level" "log_level - (Optional) The log level that Rundeck should use for this job. Defaults to \"INFO\".")
    ("allow_concurrent_executions" "allow_concurrent_executions - (Optional) Boolean defining whether two or more executions of this job can run concurrently. The default is false, meaning that jobs will only run sequentially.")
    ("max_thread_count" "max_thread_count - (Optional) The maximum number of threads to use to execute this job, which controls on how many nodes the commands can be run simulateneously. Defaults to 1, meaning that the nodes will be visited sequentially.")
    ("continue_on_error" "continue_on_error - (Optional) Boolean defining whether Rundeck will continue to run subsequent steps if any intermediate step fails. Defaults to false, meaning that execution will stop and the execution will be considered to have failed.")
    ("rank_attribute" "rank_attribute - (Optional) The name of the attribute that will be used to decide in which order the nodes will be visited while executing the job across multiple nodes.")
    ("rank_order" "rank_order - (Optional) Keyword deciding which direction the nodes are sorted in terms of the chosen rank_attribute. May be either \"ascending\" (the default) or \"descending\".")
    ("preserve_options_order" "preserve_options_order: (Optional) Boolean controlling whether the configured options will be presented in their configuration order when shown in the Rundeck UI. The default is false, which means that the options will be displayed in alphabetical order by name.")
    ("command_ordering_strategy" "command_ordering_strategy: (Optional) The name of the strategy used to describe how to traverse the matrix of nodes and commands. The default is \"node-first\", meaning that all commands will be executed on a single node before moving on to the next. May also be set to \"step-first\", meaning that a single step will be executed across all nodes before moving on to the next step.")
    ("node_filter_query" "node_filter_query - (Optional) A query string using Rundeck's node filter language that defines which subset of the project's nodes will be used to execute this job.")
    ("node_filter_exclude_precedence" "node_filter_exclude_precedence: (Optional) Boolean controlling a deprecated Rundeck feature that controls whether node exclusions take priority over inclusions.")
    ("option" "option: (Optional) Nested block defining an option a user may set when executing this job. A job may have any number of options. The structure of this nested block is described below.")
    ("command" "command: (Required) Nested block defining one step in the job workflow. A job must have one or more commands. The structure of this nested block is described below.")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_ip" '(
    ("server" "server - (Optional) ID of server to associate IP with")
    ("reverse" "reverse - (Optional) Reverse DNS of the IP")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_server" '(
    ("name" "name - (Required) name of server")
    ("image" "image - (Required) base image of server")
    ("type" "type - (Required) type of server")
    ("bootscript" "bootscript - (Optional) server bootscript")
    ("boot_type" "boot_type - (Optional) the boot mechanism for this server. Possible values include local and bootscript")
    ("tags" "tags - (Optional) list of tags for server")
    ("enable_ipv6" "enable_ipv6 - (Optional) enable ipv6")
    ("dynamic_ip_required" "dynamic_ip_required - (Optional) make server publicly available")
    ("public_ip" "public_ip - (Optional) set a public ip previously created (a real ip is expected here, not its resource id)")
    ("security_group" "security_group - (Optional) assign security group to server")
    ("volume" "volume - (Optional) attach additional volumes to your instance (see below)")
    ("public_ipv6" "public_ipv6 - (Read Only) if enable_ipv6 is set this contains the ipv6 address of your instance")
    ("state" "state - (Optional) allows you to define the desired state of your server. Valid values include (stopped, running)")
    ("state_detail" "state_detail - (Read Only) contains details from the scaleway API the state of your instance")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_security_group" '(
    ("name" "name - (Required) name of security group")
    ("description" "description - (Required) description of security group")
    ("enable_default_security" "enable_default_security - (Optional) default: true. Add default security group rules")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_security_group_rule" '(
    ("security_group" "security_group - (Required) the security group which should be associated with this rule")
    ("action" "action - (Required) action of rule (accept, drop)")
    ("direction" "direction - (Required) direction of rule (inbound, outbound)")
    ("ip_range" "ip_range - (Required) ip_range of rule")
    ("protocol" "protocol - (Required) protocol of rule (ICMP, TCP, UDP)")
    ("port" "port - (Optional) port of the rule")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_volume" '(
    ("name" "name - (Required) name of volume")
    ("size_in_gb" "size_in_gb - (Required) size of the volume in GB")
    ("type" "type - (Required) type of volume")
    ("server" "server - (Read Only) the scaleway_server instance which has this volume mounted right now")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_token" '(
    ("expires" "expires - (Optional) Define if the token should automatically expire or not")
    ("email" "email - (Optional) Scaleway account email. Defaults to registered account")
    ("password" "password - (Optional) Scaleway account password. Required for cross-account token management")
    ("description" "description - (Optional) Token description")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_user_data" '(
    ("server" "server - (Required) ID of server to associate the user data with")
    ("key" "key - (Required) The key of the user data object")
    ("value" "value - (Required) The value of the user data object")

  ) company-terraform-resource-arguments-hash)

(puthash "scaleway_volume_attachment" '(
    ("server" "server - (Required) id of the server")
    ("volume" "volume - (Required) id of the volume to be attached")

  ) company-terraform-resource-arguments-hash)

(puthash "virtual_guest" '(
    ("name" "name | string  Hostname for the computing instance.  Required")
    ("domain" "domain | string  Domain for the computing instance.  Required")
    ("cpu" "cpu | int  The number of CPU cores to allocate.  Required")
    ("ram" "ram | int  The amount of memory to allocate in megabytes.  Required")
    ("region" "region | string  Specifies which datacenter the instance is to be provisioned in.  Required")
    ("hourly_billing" "hourly_billing | boolean  Specifies the billing type for the instance. When true, the computing instance will be billed on hourly usage, otherwise it will be billed on a monthly basis.  Required")
    ("local_disk" "local_disk | boolean  Specifies the disk type for the instance. When true, the disks for the computing instance will be provisioned on the host which it runs, otherwise SAN disks will be provisioned.  Required")
    ("dedicated_acct_host_only" "dedicated_acct_host_only | boolean  Specifies whether or not the instance must only run on hosts with instances from the same account  Default: nil  Optional")
    ("image" "image | string  An identifier for the operating system to provision the computing instance with.  Conditionally required    - Disallowed when blockDeviceTemplateGroup.globalIdentifier is provided, as the template will specify the operating system.")
    ("block_device_template_group_gid" "block_device_template_group_gid | string  A global identifier for the template to be used to provision the computing instance.  Conditionally required    - Disallowed when operatingSystemReferenceCode is provided, as the template will specify the operating system.")
    ("public_network_speed" "public_network_speed | int  Specifies the connection speed for the instance's network components.  Default: 10  Optional")
    ("private_network_only" "private_network_only | boolean  Specifies whether or not the instance only has access to the private network. When true this flag specifies that a compute instance is to only have access to the private network.  Default: False  Optional")
    ("frontend_vlan_id" "frontend_vlan_id | int  Specifies the network VLAN which is to be used for the front end interface of the computing instance.  Default: nil  Optional")
    ("backend_vlan_id" "backend_vlan_id | int  Specifies the network VLAN which is to be used for the back end interface of the computing instance.  Default: nil  Optional")
    ("disks" "disks | array  Block device and disk image settings for the computing instance  Optional  Default: The smallest available capacity for the primary disk will be used. If an image template is specified the disk capacity will be be provided by the template.")
    ("user_data" "user_data | string  Arbitrary data to be made available to the computing instance.  Default: nil  Optional")
    ("ssh_keys" "ssh_keys | array  SSH keys to install on the computing instance upon provisioning.  Default: nil  Optional")
    ("ipv4_address" "ipv4_address | string  Uses editObject call, template data defined here.  Default: nil  Optional")
    ("ipv4_address_private" "ipv4_address_private | string  Uses editObject call, template data defined here.  Default: nil  Optional")
    ("post_install_script_uri" "post_install_script_uri | string  As defined in the SoftLayer_Virtual_Guest_SupplementalCreateObjectOptions.  Default: nil  Optional")

  ) company-terraform-resource-arguments-hash)

(puthash "ssh_key" '(
    ("name" "name - (Required) A descriptive name used to identify an SSH key.")
    ("public_key" "public_key - (Required) The public SSH key.")
    ("notes" "notes - (Optional) A small note about an SSH key to use at your discretion.")

  ) company-terraform-resource-arguments-hash)

(puthash "statuscake_test" '(
    ("website_name" "website_name - (Required) This is the name of the test and the website to be monitored.")
    ("website_url" "website_url - (Required) The URL of the website to be monitored")
    ("check_rate" "check_rate - (Optional) Test check rate in seconds. Defaults to 300")
    ("contact_id" "contact_id - (Optional) The id of the contact group to be add to the test.  Each test can have only one.")
    ("test_type" "test_type - (Required) The type of Test. Either HTTP or TCP")
    ("paused" "paused - (Optional) Whether or not the test is paused. Defaults to false.")
    ("timeout" "timeout - (Optional) The timeout of the test in seconds.")
    ("confirmations" "confirmations - (Optional) The number of confirmation servers to use in order to detect downtime. Defaults to 0.")
    ("port" "port - (Optional) The port to use when specifying a TCP test.")
    ("trigger_rate" "trigger_rate - (Optional) The number of minutes to wait before sending an alert. Default is 5.")

  ) company-terraform-resource-arguments-hash)

(puthash "aws_group" '(
    ("name" "name - (Optional) The group description.")
    ("description" "description - (Optional) The group description.")
    ("product" "product - (Required) Operation system type.")
    ("capacity" "capacity - (Required) The group capacity. Only a single block is allowed.  target - (Required) The desired number of instances the group should have at any time.  minimum - (Optional; Required if using scaling policies) The minimum number of instances the group should have at any time.  maximum - (Optional; Required if using scaling policies) The maximum number of instances the group should have at any time.")
    ("strategy" "strategy - (Required) This determines how your group request is fulfilled from the possible On-Demand and Spot pools selected for launch. Only a single block is allowed.  risk - (Optional; Required if not using ondemand_count) The percentage of Spot instances that would spin up from the capcity.target number.  ondemand_count - (Optional; Required if not using risk) Number of on demand instances to launch in the group. All other instances will be spot instances. When this parameter is set the \"risk\" parameter is being ignored.  availability_vs_cost - (Optional) The percentage of Spot instances that would spin up from the capcity.target number.  draining_timeout - (Optional) The time in seconds, the instance is allowed to run while detached from the ELB. This is to allow the instance time to be drained from incoming TCP connections before terminating it, during a scale down operation.")
    ("instance_types" "instance_types - The type of instance determines your instance's CPU capacity, memory and storage (e.g., m1.small, c1.xlarge).  ondemand - (Required) The base instance type.  spot - (Required) One or more instance types.")
    ("launch_specification" "launch_specification - (Required) Describes the launch specification for an instance.  image_id - (Required) The ID of the AMI used to launch the instance.  key_pair - (Optional) The key name that should be used for the instance.  security_group_ids - (Optional) A list of associated security group IDS.  monitoring - (Optional) Indicates whether monitoring is enabled for the instance.  user_data - (Optional) The user data to provide when launching the instance.  iam_instance_profile - (Optional) The ARN of an IAM instance profile to associate with launched instances.  load_balancer_names - (Optional) Registers each instance with the specified Elastic Load Balancers.")
    ("tags" "tags - (Optional) A mapping of tags to assign to the resource.")
    ("elastic_ips" "elastic_ips - (Optional) A list of AWS Elastic IP allocation IDs to associate to the group instances.")

  ) company-terraform-resource-arguments-hash)

(puthash "template_dir" '(
    ("source_dir" "source_dir - (Required) Path to the directory where the files to template reside.")
    ("destination_dir" "destination_dir - (Required) Path to the directory where the templated files will be written.")
    ("vars" "vars - (Optional) Variables for interpolation within the template. Note that variables must all be primitives. Direct references to lists or maps will cause a validation error.")

  ) company-terraform-resource-arguments-hash)

(puthash "tls_private_key" '(
    ("algorithm" "algorithm - (Required) The name of the algorithm to use for the key. Currently-supported values are \"RSA\" and \"ECDSA\".")
    ("rsa_bits" "rsa_bits - (Optional) When algorithm is \"RSA\", the size of the generated RSA key in bits. Defaults to 2048.")
    ("ecdsa_curve" "ecdsa_curve - (Optional) When algorithm is \"ECDSA\", the name of the elliptic curve to use. May be any one of \"P224\", \"P256\", \"P384\" or \"P521\", with \"P224\" as the default.")

  ) company-terraform-resource-arguments-hash)

(puthash "tls_self_signed_cert" '(
    ("key_algorithm" "key_algorithm - (Required) The name of the algorithm for the key provided in private_key_pem.")
    ("private_key_pem" "private_key_pem - (Required) PEM-encoded private key data. This can be read from a separate file using the file interpolation function. If the certificate is being generated to be used for a throwaway development environment or other non-critical application, the tls_private_key resource can be used to generate a TLS private key from within Terraform. Only an irreversable secure hash of the private key will be stored in the Terraform state.")
    ("subject" "subject - (Required) The subject for which a certificate is being requested. This is a nested configuration block whose structure matches the corresponding block for tls_cert_request.")
    ("validity_period_hours" "validity_period_hours - (Required) The number of hours after initial issuing that the certificate will become invalid.")
    ("allowed_uses" "allowed_uses - (Required) List of keywords each describing a use that is permitted for the issued certificate. The valid keywords are listed below.")
    ("dns_names" "dns_names - (Optional) List of DNS names for which a certificate is being requested.")
    ("ip_addresses" "ip_addresses - (Optional) List of IP addresses for which a certificate is being requested.")
    ("early_renewal_hours" "early_renewal_hours - (Optional) If set, the resource will consider the certificate to have expired the given number of hours before its actual expiry time. This can be useful to deploy an updated certificate in advance of the expiration of the current certificate. Note however that the old certificate remains valid until its true expiration time, since this resource does not (and cannot) support certificate revocation. Note also that this advance update can only be performed should the Terraform configuration be applied during the early renewal period.")
    ("is_ca_certificate" "is_ca_certificate - (Optional) Boolean controlling whether the CA flag will be set in the generated certificate. Defaults to false, meaning that the certificate does not represent a certificate authority.")

  ) company-terraform-resource-arguments-hash)

(puthash "tls_locally_signed_cert" '(
    ("cert_request_pem" "cert_request_pem - (Required) PEM-encoded request certificate data.")
    ("ca_key_algorithm" "ca_key_algorithm - (Required) The name of the algorithm for the key provided in ca_private_key_pem.")
    ("ca_private_key_pem" "ca_private_key_pem - (Required) PEM-encoded private key data for the CA. This can be read from a separate file using the file interpolation function.")
    ("ca_cert_pem" "ca_cert_pem - (Required) PEM-encoded certificate data for the CA.")
    ("validity_period_hours" "validity_period_hours - (Required) The number of hours after initial issuing that the certificate will become invalid.")
    ("allowed_uses" "allowed_uses - (Required) List of keywords each describing a use that is permitted for the issued certificate. The valid keywords are listed below.")
    ("early_renewal_hours" "early_renewal_hours - (Optional) If set, the resource will consider the certificate to have expired the given number of hours before its actual expiry time. This can be useful to deploy an updated certificate in advance of the expiration of the current certificate. Note however that the old certificate remains valid until its true expiration time, since this resource does not (and cannot) support certificate revocation. Note also that this advance update can only be performed should the Terraform configuration be applied during the early renewal period.")
    ("is_ca_certificate" "is_ca_certificate - (Optional) Boolean controlling whether the CA flag will be set in the generated certificate. Defaults to false, meaning that the certificate does not represent a certificate authority.")

  ) company-terraform-resource-arguments-hash)

(puthash "tls_cert_request" '(
    ("key_algorithm" "key_algorithm - (Required) The name of the algorithm for the key provided in private_key_pem.")
    ("private_key_pem" "private_key_pem - (Required) PEM-encoded private key data. This can be read from a separate file using the file interpolation function. Only an irreversable secure hash of the private key will be stored in the Terraform state.")
    ("subject" "subject - (Required) The subject for which a certificate is being requested. This is a nested configuration block whose structure is described below.")
    ("dns_names" "dns_names - (Optional) List of DNS names for which a certificate is being requested.")
    ("ip_addresses" "ip_addresses - (Optional) List of IP addresses for which a certificate is being requested.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_fabric" '(
    ("name" "name - (String, Required, Change forces new resource) Network name.")
    ("description" "description - (String, Optional, Change forces new resource) Optional description of network.")
    ("subnet" "subnet - (String, Required, Change forces new resource) CIDR formatted string describing network.")
    ("provision_start_ip" "provision_start_ip - (String, Required, Change forces new resource) First IP on the network that can be assigned.")
    ("provision_end_ip" "provision_end_ip - (String, Required, Change forces new resource) Last assignable IP on the network.")
    ("gateway" "gateway - (String, Optional, Change forces new resource) Optional gateway IP.")
    ("resolvers" "resolvers - (List, Optional) Array of IP addresses for resolvers.")
    ("routes" "routes - (Map, Optional, Change forces new resource) Map of CIDR block to Gateway IP address.")
    ("internet_nat" "internet_nat - (Bool, Optional, Change forces new resource) If a NAT zone is provisioned at Gateway IP address. Default is true.")
    ("vlan_id" "vlan_id - (Int, Required, Change forces new resource) VLAN id the network is on. Number between 0-4095 indicating VLAN ID.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_firewall_rule" '(
    ("rule" "rule - (string, Required) The firewall rule described using the Cloud API rule syntax defined at https://docs.joyent.com/public-cloud/network/firewall/cloud-firewall-rules-reference. Note: Cloud API will normalize rules based on case-sensitivity, parentheses, ordering of IP addresses, etc. This can result in Terraform updating rules repeatedly if the rule definition differs from the normalized value.")
    ("enabled" "enabled - (boolean, Optional)  Default: false Whether the rule should be effective.")
    ("description" "description - (string, Optional) Description of the firewall rule")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_instance_template" '(
    ("template_name" "template_name - (string, Required) Friendly name for the instance template.")
    ("image" "image - (string, Required)  UUID of the image.")
    ("package" "package - (string, Required) Package name used for provisioning.")
    ("firewall_enabled" "firewall_enabled - (boolean, Optional) Whether to enable the firewall for group instances. Default is false.")
    ("tags" "tags - (map, Optional) Tags for group instances.")
    ("networks" "networks - (list, Optional) Network IDs for group instances.")
    ("metadata" "metadata - (map, Optional) Metadata for group instances.")
    ("userdata" "userdata - (string, Optional) Data copied to instance on boot.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_key" '(
    ("name" "name - (string, Change forces new resource) The name of the key. If this is left empty, the name is inferred from the comment in the SSH key material.")
    ("key" "key - (string, Required, Change forces new resource) The SSH key material. In order to read this from a file, use the file interpolation.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_machine" '(
    ("name" "name - (string) The friendly name for the machine. Triton will generate a name if one is not specified.")
    ("tags" "tags - (map) A mapping of tags to apply to the machine.")
    ("cns" "cns - (map of CNS attributes, Optional) A mapping of CNS attributes to apply to the machine.")
    ("metadata" "metadata - (map, optional) A mapping of metadata to apply to the machine.")
    ("package" "package - (string, Required) The name of the package to use for provisioning.")
    ("image" "image - (string, Required) The UUID of the image to provision.")
    ("networks" "networks - (list, optional) The list of networks to associate with the machine. The network ID will be in hex form, e.g xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx.")
    ("affinity" "affinity - (list of Affinity rules, Optional) A list of valid Affinity Rules to apply to the machine which assist in data center placement. Using this attribute will force resource creation to be serial. NOTE: Affinity rules are best guess and assist in placing instances across a data center. They're used at creation and not referenced after.")
    ("(Deprecated) locality" "(Deprecated) locality - (map of Locality hints, Optional) A mapping of Locality attributes to apply to the machine that assist in data center placement. NOTE: Locality hints are only used at the time of machine creation and not referenced after. Locality is deprecated as of CloudAPI v8.3.0.")
    ("firewall_enabled" "firewall_enabled - (boolean)  Default: false Whether the cloud firewall should be enabled for this machine.")
    ("root_authorized_keys" "root_authorized_keys - (string) The public keys authorized for root access via SSH to the machine.")
    ("user_data" "user_data - (string) Data to be copied to the machine on boot. NOTE: The content of user_data will not be executed on boot. The data will only be written to the file on each boot before the content of the script from user_script is to be run.")
    ("user_script" "user_script - (string) The user script to run on boot (every boot on SmartMachines). To learn more about both the user script and user data see the metadata API documentation and the Joyent Metadata Data Dictionary specification.")
    ("administrator_pw" "administrator_pw - (string) The initial password for the Administrator user. Only used for Windows virtual machines.")
    ("cloud_config" "cloud_config - (string) Cloud-init configuration for Linux brand machines, used instead of user_data.")
    ("deletion_protection_enabled" "deletion_protection_enabled - (bool) Whether an instance is destroyable. Default is false.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_service_group" '(
    ("group_name" "group_name - (string, Required) Friendly name for the service group.")
    ("template" "template - (string, Required)  Identifier of an instance template.")
    ("capacity" "capacity - (int, Optional) Number of instances to launch and monitor.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_snapshot" '(
    ("name" "name - (string, Required) The name for the snapshot.")
    ("machine_id" "machine_id - (string, Required) The ID of the machine of which to take a snapshot.")

  ) company-terraform-resource-arguments-hash)

(puthash "triton_vlan" '(
    ("vlan_id" "vlan_id - (int, Required, Change forces new resource) Number between 0-4095 indicating VLAN ID")
    ("name" "name - (string, Required) Unique name to identify VLAN")
    ("description" "description - (string, Optional) Description of the VLAN")

  ) company-terraform-resource-arguments-hash)

(puthash "ultradns_dirpool" '(
    ("zone" "zone - (Required) The domain to add the record to")
    ("name" "name - (Required) The name of the record")
    ("type" "type - (Required) The Record Type of the record")
    ("description" "description - (Required) Description of the Traffic Controller pool. Valid values are strings less than 256 characters.")
    ("rdata" "rdata - (Required) a list of Record Data blocks, one for each member in the pool. Record Data documented below.")
    ("ttl" "ttl - (Optional) The TTL of the record. Default: 3600.")
    ("conflict_resolve" "conflict_resolve - (Optional) String. Valid: \"GEO\" or \"IP\". Default: \"GEO\".")
    ("no_response" "no_response - (Optional) a single Record Data block, without any host attribute. Record Data documented below.")

  ) company-terraform-resource-arguments-hash)

(puthash "ultradns_probe_http" '(
    ("zone" "zone - (Required) The domain of the pool to probe.")
    ("name" "name - (Required) The name of the pool to probe.")
    ("pool_record" "pool_record - (optional) IP address or domain. If provided, a record-level probe is created, otherwise a pool-level probe is created.")
    ("agents" "agents - (Required) List of locations that will be used for probing. One or more values must be specified. Valid values are \"NEW_YORK\", \"PALO_ALTO\", \"DALLAS\" & \"AMSTERDAM\".")
    ("threshold" "threshold - (Required) Number of agents that must agree for a probe state to be changed.")
    ("http_probe" "http_probe - (Required) an HTTP Probe block.")
    ("interval" "interval - (Optional) Length of time between probes in minutes. Valid values are \"HALF_MINUTE\", \"ONE_MINUTE\", \"TWO_MINUTES\", \"FIVE_MINUTES\", \"TEN_MINUTES\" & \"FIFTEEN_MINUTE\". Default: \"FIVE_MINUTES\".")

  ) company-terraform-resource-arguments-hash)

(puthash "ultradns_probe_ping" '(
    ("zone" "zone - (Required) The domain of the pool to probe.")
    ("name" "name - (Required) The name of the pool to probe.")
    ("pool_record" "pool_record - (optional) IP address or domain. If provided, a record-level probe is created, otherwise a pool-level probe is created.")
    ("agents" "agents - (Required) List of locations that will be used for probing. One or more values must be specified. Valid values are \"NEW_YORK\", \"PALO_ALTO\", \"DALLAS\" & \"AMSTERDAM\".")
    ("threshold" "threshold - (Required) Number of agents that must agree for a probe state to be changed.")
    ("ping_probe" "ping_probe - (Required) a Ping Probe block.")
    ("interval" "interval - (Optional) Length of time between probes in minutes. Valid values are \"HALF_MINUTE\", \"ONE_MINUTE\", \"TWO_MINUTES\", \"FIVE_MINUTES\", \"TEN_MINUTES\" & \"FIFTEEN_MINUTE\". Default: \"FIVE_MINUTES\".")

  ) company-terraform-resource-arguments-hash)

(puthash "ultradns_record" '(
    ("zone" "zone - (Required) The domain to add the record to")
    ("name" "name - (Required) The name of the record")
    ("rdata" "rdata - (Required) An array containing the values of the record")
    ("type" "type - (Required) The type of the record")
    ("ttl" "ttl - (Optional) The TTL of the record")

  ) company-terraform-resource-arguments-hash)

(puthash "ultradns_tcpool" '(
    ("zone" "zone - (Required) The domain to add the record to")
    ("name" "name - (Required) The name of the record")
    ("rdata" "rdata - (Required) a list of rdata blocks, one for each member in the pool. Record Data documented below.")
    ("description" "description - (Required) Description of the Traffic Controller pool. Valid values are strings less than 256 characters.")
    ("ttl" "ttl - (Optional) The TTL of the record. Default: 3600.")
    ("run_probes" "run_probes - (Optional) Boolean to run probes for this pool. Default: true.")
    ("act_on_probes" "act_on_probes - (Optional) Boolean to enable and disable pool records when probes are run. Default: true.")
    ("max_to_lb" "max_to_lb - (Optional) Determines the number of records to balance between. Valid values are integers  0 - len(rdata). Default: 0.")
    ("backup_record_rdata" "backup_record_rdata - (Optional) IPv4 address or CNAME for the backup record. Default: nil.")
    ("backup_record_failover_delay" "backup_record_failover_delay - (Optional) Time in minutes that Traffic Controller waits after detecting that the pool record has failed before activating primary records. Valid values are integers 0 - 30. Default: 0.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_approle_auth_backend_role" '(
    ("role_name" "role_name - (Required) The name of the role.")
    ("role_id" "role_id - (Optional) The RoleID of this role. If not specified, one will be auto-generated.")
    ("bind_secret_id" "bind_secret_id - (Optional) Whether or not to require secret_id to be presented when logging in using this AppRole. Defaults to true.")
    ("bound_cidr_list" "bound_cidr_list - (Optional) If set, specifies blocks of IP addresses which can perform the login operation.")
    ("policies" "policies - (Optional) An array of strings specifying the policies to be set on tokens issued using this role.")
    ("secret_id_num_uses" "secret_id_num_uses - (Optional) The number of times any particular SecretID can be used to fetch a token from this AppRole, after which the SecretID will expire. A value of zero will allow unlimited uses.")
    ("secret_id_ttl" "secret_id_ttl - (Optional) The number of seconds after which any SecretID expires.")
    ("token_num_uses" "token_num_uses - (Optional) The number of times issued tokens can be used. A value of 0 means unlimited uses.")
    ("token_ttl" "token_ttl - (Optional) The TTL period of tokens issued using this role, provided as a number of seconds.")
    ("token_max_ttl" "token_max_ttl - (Optional) The maximum allowed lifetime of tokens issued using this role, provided as a number of seconds.")
    ("period" "period - (Optional) If set, indicates that the token generated using this role should never expire. The token should be renewed within the duration specified by this value. At each renewal, the token's TTL will be set to the value of this field. The maximum allowed lifetime of token issued using this role. Specified as a number of seconds.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_approle_auth_backend_login" '(
    ("role_id" "role_id - (Required) The ID of the role to log in with.")
    ("secret_id" "secret_id - (Optional) The secret ID of the role to log in with. Required unless bind_secret_id is set to false on the role.")
    ("backend" "backend - The unique path of the Vault backend to log in with.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_approle_auth_backend_role_secret_id" '(
    ("role_name" "role_name - (Required) The name of the role to create the SecretID for.")
    ("metadata" "metadata - (Optional) A JSON-encoded string containing metadata in key-value pairs to be set on tokens issued with this SecretID.")
    ("cidr_list" "cidr_list - (Optional) If set, specifies blocks of IP addresses which can perform the login operation using this SecretID.")
    ("secret_id" "secret_id - (Optional) The SecretID to be created. If set, uses \"Push\" mode.  Defaults to Vault auto-generating SecretIDs.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_auth_backend" '(
    ("type" "type - (Required) The name of the policy")
    ("path" "path - (Optional) The path to mount the auth backend. This defaults to the name.")
    ("description" "description - (Optional) A description of the auth backend")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_auth_backend_cert" '(
    ("cert_name" "cert_name - (Required) The name of the certificate.")
    ("aws_public_cert" "aws_public_cert - (Required) The  Base64 encoded AWS Public key required to verify PKCS7 signature of the EC2 instance metadata. You can find this key in the AWS documentation.")
    ("type" "type - (Optional) Either \"pkcs7\" or \"identity\", indicating the type of document which can be verified using the given certificate. Defaults to \"pkcs7\".")
    ("backend" "backend - (Optional) The path the AWS auth backend being configured was mounted at.  Defaults to aws.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_auth_backend_client" '(
    ("backend" "backend - (Optional) The path the AWS auth backend being configured was mounted at.  Defaults to aws.")
    ("access_key" "access_key - (Optional) The AWS access key that Vault should use for the auth backend.")
    ("secret_key" "secret_key - (Optional) The AWS secret key that Vault should use for the auth backend.")
    ("ec2_endpoint" "ec2_endpoint - (Optional) Override the URL Vault uses when making EC2 API calls.")
    ("iam_endpoint" "iam_endpoint - (Optional) Override the URL Vault uses when making IAM API calls.")
    ("sts_endpoint" "sts_endpoint - (Optional) Override the URL Vault uses when making STS API calls.")
    ("iam_server_id_header_value" "iam_server_id_header_value - (Optional) The value to require in the X-Vault-AWS-IAM-Server-ID header as part of GetCallerIdentity requests that are used in the IAM auth method.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_auth_backend_identity_whitelist" '(
    ("backend" "backend - (Optional) The path of the AWS backend being configured.")
    ("safety_buffer" "safety_buffer - (Optional) The amount of extra time, in minutes, that must have passed beyond the roletag expiration, before it is removed from the backend storage.")
    ("disable_periodic_tidy" "disable_periodic_tidy - (Optional) If set to true, disables the periodic tidying of the identity-whitelist entries.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_auth_backend_login" '(
    ("backend" "backend - (Optional) The unique name of the AWS auth backend. Defaults to 'aws'.")
    ("role" "role - (Optional) The name of the AWS auth backend role to create tokens against.")
    ("identity" "identity - (Optional) The base64-encoded EC2 instance identity document to authenticate with. Can be retrieved from the EC2 metadata server.")
    ("signature" "signature - (Optional) The base64-encoded SHA256 RSA signature of the instance identity document to authenticate with, with all newline characters removed. Can be retrieved from the EC2 metadata server.")
    ("pkcs7" "pkcs7 - (Optional) The PKCS#7 signature of the identity document to authenticate with, with all newline characters removed. Can be retrieved from the EC2 metadata server.")
    ("nonce" "nonce - (Optional) The unique nonce to be used for login requests. Can be set to a user-specified value, or will contain the server-generated value once a token is issued. EC2 instances can only acquire a single token until the whitelist is tidied again unless they keep track of this nonce.")
    ("iam_http_request_method" "iam_http_request_method - (Optional) The HTTP method used in the signed IAM request.")
    ("iam_request_url" "iam_request_url - (Optional) The base64-encoded HTTP URL used in the signed request.")
    ("iam_request_body" "iam_request_body - (Optional) The base64-encoded body of the signed request.")
    ("iam_request_headers" "iam_request_headers - (Optional) The base64-encoded, JSON serialized representation of the GetCallerIdentity HTTP request headers.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_auth_backend_role" '(
    ("role" "role - (Required) The name of the role.")
    ("auth_type" "auth_type - (Optional) The auth type permitted for this role. Valid choices are ec2 and iam. Defaults to iam.")
    ("bound_ami_id" "bound_ami_id - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that they should be using the AMI ID specified by this field. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_account_id" "bound_account_id - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that they should be using the account ID specified by this field. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_region" "bound_region - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that the region in their identity document must match the one specified by this field. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_vpc_id" "bound_vpc_id - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that they be associated with the VPC ID that matches the value specified by this field. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_subnet_id" "bound_subnet_id - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that they be associated with the subnet ID that matches the value specified by this field. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_iam_role_arn" "bound_iam_role_arn - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that they must match the IAM role ARN specified by this field. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_iam_instance_profile_arn" "bound_iam_instance_profile_arn - (Optional) If set, defines a constraint on the EC2 instances that can perform the login operation that they must be associated with an IAM instance profile ARN which has a prefix that matches the value specified by this field. The value is prefix-matched as though it were a glob ending in *. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("role_tag" "role_tag - (Optional) If set, enable role tags for this role. The value set for this field should be the key of the tag on the EC2 instance. auth_type must be set to ec2 or inferred_entity_type must be set to ec2_instance to use this constraint.")
    ("bound_iam_principal_arn" "bound_iam_principal_arn - (Optional) If set, defines the IAM principal that must be authenticated when auth_type is set to iam. Wildcards are supported at the end of the ARN.")
    ("inferred_entity_type" "inferred_entity_type - (Optional) If set, instructs Vault to turn on inferencing. The only valid value is ec2_instance, which instructs Vault to infer that the role comes from an EC2 instance in an IAM instance profile. This only applies when auth_type is set to iam.")
    ("inferred_aws_region" "inferred_aws_region - (Optional) When inferred_entity_type is set, this is the region to search for the inferred entities. Required if inferred_entity_type is set. This only applies when auth_type is set to iam.")
    ("resolve_aws_unique_ids" "resolve_aws_unique_ids - (Optional) If set to true, the bound_iam_principal_arn is resolved to an AWS Unique ID for the bound principal ARN. This field is ignored when bound_iam_principal_arn ends in a wildcard. Resolving to unique IDs more closely mimics the behavior of AWS services in that if an IAM user or role is deleted and a new one is recreated with the same name, those new users or roles won't get access to roles in Vault that were permissioned to the prioer principals of the same name. Defaults to true. Once set to true, this cannot be changed to false--the role must be deleted and recreated, with the value set to true.")
    ("ttl" "ttl - (Optional) The TTL period of tokens issued using this role, provided as a number of minutes.")
    ("max_ttl" "max_ttl - (Optional) The maximum allowed lifetime of tokens issued using this role, provided as a number of minutes.")
    ("period" "period - (Optional) If set, indicates that the token generated using this role should never expire. The token should be renewed within the duration specified by this value. At each renewal, the token's TTL will be set to the value of this field. The maximum allowed lifetime of token issued using this role. Specified as a number of minutes.")
    ("policies" "policies - (Optional) An array of strings specifying the policies to be set on tokens issued using this role.")
    ("allow_instance_migration" "allow_instance_migration - (Optional) If set to true, allows migration of the underlying instance where the client resides.")
    ("disallow_reauthentication" "disallow_reauthentication - (Optional) IF set to true, only allows a single token to be granted per instance ID. This can only be set when auth_type is set to ec2.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_auth_backend_sts_role" '(
    ("account_id" "account_id - (Optional) The AWS account ID to configure the STS role for.")
    ("sts_role" "sts_role - (Optional) The STS role to assume when verifying requests made by EC2 instances in the account specified by account_id.")
    ("backend" "backend - (Optional) The path the AWS auth backend being configured was mounted at.  Defaults to aws.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_secret_backend" '(
    ("access_key" "access_key - (Required) The AWS Access Key ID this backend should use to issue new credentials.")
    ("secret_key" "secret_key - (Required) The AWS Secret Key this backend should use to issue new credentials.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_aws_secret_backend_role" '(
    ("backend" "backend - (Required) The path the AWS secret backend is mounted at, with no leading or trailing /s.")
    ("name" "name - (Required) The name to identify this role within the backend. Must be unique within the backend.")
    ("policy" "policy - (Optional) The JSON-formatted policy to associate with this role. Either policy or policy_arn must be specified.")
    ("policy_arn" "policy_arn - (Optional) The ARN for a pre-existing policy to associate with this role. Either policy or policy_arn must be specified.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_database_secret_backend_connection" '(
    ("name" "name - (Required) A unique name to give the database connection.")
    ("backend" "backend - (Required) The unique name of the Vault mount to configure.")
    ("verify_connection" "verify_connection - (Optional) Whether the connection should be verified on initial configuration or not.")
    ("allowed_roles" "allowed_roles - (Optional) A list of roles that are allowed to use this connection.")
    ("cassandra" "cassandra - (Optional) A nested block containing configuration options for Cassandra connections.")
    ("mongodb" "mongodb - (Optional) A nested block containing configuration options for MongoDB connections.")
    ("hana" "hana - (Optional) A nested block containing configuration options for SAP HanaDB connections.")
    ("mssql" "mssql - (Optional) A nested block containing configuration options for MSSQL connections.")
    ("mysql" "mysql - (Optional) A nested block containing configuration options for MySQL connections.")
    ("postgresql" "postgresql - (Optional) A nested block containing configuration options for PostgreSQL connections.")
    ("oracle" "oracle - (Optional) A nested block containing configuration options for Oracle connections.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_database_secret_backend_role" '(
    ("name" "name - (Required) A unique name to give the role.")
    ("backend" "backend - (Required) The unique name of the Vault mount to configure.")
    ("db_name" "db_name - (Required) The unique name of the database connection to use for the role.")
    ("creation_statements" "creation_statements - (Required) The database statements to execute when creating a user.")
    ("revocation_statements" "revocation_statements - (Optional) The database statements to execute when revoking a user.")
    ("rollback_statements" "rollback_statements - (Optional) The database statements to execute when rolling back creation due to an error.")
    ("renew_statements" "renew_statements - (Optional) The database statements to execute when renewing a user.")
    ("default_ttl" "default_ttl - (Optional) The default number of seconds for leases for this role.")
    ("max_ttl" "max_ttl - (Optional) The maximum number of seconds for leases for this role.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_generic_secret" '(
    ("path" "path - (Required) The full logical path at which to write the given data. To write data into the \"generic\" secret backend mounted in Vault by default, this should be prefixed with secret/. Writing to other backends with this resource is possible; consult each backend's documentation to see which endpoints support the PUT and DELETE methods.")
    ("data_json" "data_json - (Required) String containing a JSON-encoded object that will be written as the secret data at the given path.")
    ("allow_read" "allow_read - (Optional, Deprecated) True/false. Set this to true if your vault authentication is able to read the data, this allows the resource to be compared and updated. Defaults to false.")
    ("disable_read" "disable_read - (Optional) True/false. Set this to true if your vault authentication is not able to read the data. Setting this to true will break drift detection. Defaults to false.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_okta_auth_backend" '(
    ("path" "path - (Required) Path to mount the Okta auth backend")
    ("description" "description - (Optional) The description of the auth backend")
    ("organization" "organization - (Required) The Okta organization. This will be the first part of the url https://XXX.okta.com")
    ("token" "token - (Optional) The Okta API token. This is required to query Okta for user group membership. If this is not supplied only locally configured groups will be enabled.")
    ("base_url" "base_url - (Optional) The Okta url. Examples: oktapreview.com, okta.com")
    ("ttl" "ttl - (Optional) Duration after which authentication will be expired. See the documentation for info on valid duration formats.")
    ("max_ttl" "max_ttl - (Optional) Maximum duration after which authentication will be expired See the documentation for info on valid duration formats.")
    ("group" "group - (Optional) Associate Okta groups with policies within Vault. See below for more details.")
    ("user" "user - (Optional) Associate Okta users with groups or policies within Vault. See below for more details.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_okta_auth_backend_user" '(
    ("path" "path - (Required) The path where the Okta auth backend is mounted")
    ("username" "username - (Required Optional) Name of the user within Okta")
    ("groups" "groups - (Optional) List of Okta groups to associate with this user")
    ("policies" "policies - (Optional) List of Vault policies to associate with this user")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_okta_auth_backend_group" '(
    ("path" "path - (Required) The path where the Okta auth backend is mounted")
    ("group_name" "group_name - (Required) Name of the group within the Okta")
    ("policies" "policies - (Optional) Vault policies to associate with this group")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_mount" '(
    ("path" "path - (Required) Where the secret backend will be mounted")
    ("type" "type - (Required) Type of the backend, such as \"aws\"")
    ("description" "description - (Optional) Human-friendly description of the mount")
    ("default_lease_ttl_seconds" "default_lease_ttl_seconds - (Optional) Default lease duration for tokens and secrets in seconds")
    ("max_lease_ttl_seconds" "max_lease_ttl_seconds - (Optional) Maximum possible lease duration for tokens and secrets in seconds")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_okta_auth_backend" '(
    ("path" "path - (Required) Path to mount the Okta auth backend")
    ("description" "description - (Optional) The description of the auth backend")
    ("organization" "organization - (Required) The Okta organization. This will be the first part of the url https://XXX.okta.com")
    ("token" "token - (Optional) The Okta API token. This is required to query Okta for user group membership. If this is not supplied only locally configured groups will be enabled.")
    ("base_url" "base_url - (Optional) The Okta url. Examples: oktapreview.com, okta.com")
    ("ttl" "ttl - (Optional) Duration after which authentication will be expired. See the documentation for info on valid duration formats.")
    ("max_ttl" "max_ttl - (Optional) Maximum duration after which authentication will be expired See the documentation for info on valid duration formats.")
    ("group" "group - (Optional) Associate Okta groups with policies within Vault. See below for more details.")
    ("user" "user - (Optional) Associate Okta users with groups or policies within Vault. See below for more details.")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_okta_auth_backend_group" '(
    ("path" "path - (Required) The path where the Okta auth backend is mounted")
    ("group_name" "group_name - (Required) Name of the group within the Okta")
    ("policies" "policies - (Optional) Vault policies to associate with this group")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_okta_auth_backend_user" '(
    ("path" "path - (Required) The path where the Okta auth backend is mounted")
    ("username" "username - (Required Optional) Name of the user within Okta")
    ("groups" "groups - (Optional) List of Okta groups to associate with this user")
    ("policies" "policies - (Optional) List of Vault policies to associate with this user")

  ) company-terraform-resource-arguments-hash)

(puthash "vault_policy" '(
    ("name" "name - (Required) The name of the policy")
    ("policy" "policy - (Required) String containing a Vault policy")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_dnat" '(
    ("edge_gateway" "edge_gateway - (Required) The name of the edge gateway on which to apply the DNAT")
    ("external_ip" "external_ip - (Required) One of the external IPs available on your Edge Gateway")
    ("port" "port - (Required) The port number to map")
    ("internal_ip" "internal_ip - (Required) The IP of the VM to map to")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_firewall_rules" '(
    ("edge_gateway" "edge_gateway - (Required) The name of the edge gateway on which to apply the Firewall Rules")
    ("default_action" "default_action - (Required) Either \"allow\" or \"deny\". Specifies what to do should none of the rules match")
    ("rule" "rule - (Optional) Configures a firewall rule; see Rules below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_network" '(
    ("name" "name - (Required) A unique name for the network")
    ("edge_gateway" "edge_gateway - (Required) The name of the edge gateway")
    ("netmask" "netmask - (Optional) The netmask for the new network. Defaults to 255.255.255.0")
    ("gateway" "gateway (Required) The gateway for this network")
    ("dns1" "dns1 - (Optional) First DNS server to use. Defaults to 8.8.8.8")
    ("dns2" "dns2 - (Optional) Second DNS server to use. Defaults to 8.8.4.4")
    ("dns_suffix" "dns_suffix - (Optional) A FQDN for the virtual machines on this network")
    ("dhcp_pool" "dhcp_pool - (Optional) A range of IPs to issue to virtual machines that don't have a static IP; see IP Pools below for details.")
    ("static_ip_pool" "static_ip_pool - (Optional) A range of IPs permitted to be used as static IPs for virtual machines; see IP Pools below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_snat" '(
    ("edge_gateway" "edge_gateway - (Required) The name of the edge gateway on which to apply the SNAT")
    ("external_ip" "external_ip - (Required) One of the external IPs available on your Edge Gateway")
    ("internal_ip" "internal_ip - (Required) The IP or IP Range of the VM(s) to map from")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_edgegateway_vpn" '(
    ("edge_gateway" "edge_gateway - (Required) The name of the edge gateway on which to apply the Firewall Rules")
    ("name" "name - (Required) The name of the VPN")
    ("description" "description - (Required) A description for the VPN")
    ("encryption_protocol" "encryption_protocol - (Required) - E.g. AES256")
    ("local_ip_address" "local_ip_address - (Required) - Local IP Address")
    ("local_id" "local_id - (Required) - Local ID")
    ("mtu" "mtu - (Required) - The MTU setting")
    ("peer_ip_address" "peer_ip_address - (Required) - Peer IP Address")
    ("peer_id" "peer_id - (Required) - Peer ID")
    ("shared_secret" "shared_secret - (Required) - Shared Secret")
    ("local_subnets" "local_subnets - (Required) - List of Local Subnets see Local Subnets below for details.")
    ("peer_subnets" "peer_subnets - (Required) - List of Peer Subnets see Peer Subnets below for details.")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_vapp" '(
    ("name" "name - (Required) A unique name for the vApp")
    ("catalog_name" "catalog_name - (Optional) The catalog name in which to find the given vApp Template")
    ("template_name" "template_name - (Optional) The name of the vApp Template to use")
    ("memory" "memory - (Optional) The amount of RAM (in MB) to allocate to the vApp")
    ("cpus" "cpus - (Optional) The number of virtual CPUs to allocate to the vApp")
    ("initscript" "initscript (Optional) A script to be run only on initial boot")
    ("network_name" "network_name - (Optional) Name of the network this vApp should join")
    ("network_href" "network_href - (Deprecated) The vCloud Director generated href of the network this vApp should join. If empty it will use the network name and query vCloud Director to discover this")
    ("ip" "ip - (Optional) The IP to assign to this vApp. Must be an IP address or one of dhcp, allocated or none. If given the address must be within the static_ip_pool set for the network. If left blank, and the network has dhcp_pool set with at least one available IP then this will be set with DHCP.")
    ("metadata" "metadata - (Optional) Key value map of metadata to assign to this vApp")
    ("ovf" "ovf - (Optional) Key value map of ovf parameters to assign to VM product section")
    ("power_on" "power_on - (Optional) A boolean value stating if this vApp should be powered on. Default to true")

  ) company-terraform-resource-arguments-hash)

(puthash "vcd_vapp_vm" '(
    ("vapp_name" "vapp_name - (Required) The vApp this VM should belong to.")
    ("name" "name - (Required) A unique name for the vApp")
    ("catalog_name" "catalog_name - (Required) The catalog name in which to find the given vApp Template")
    ("template_name" "template_name - (Required) The name of the vApp Template to use")
    ("memory" "memory - (Optional) The amount of RAM (in MB) to allocate to the vApp")
    ("cpus" "cpus - (Optional) The number of virtual CPUs to allocate to the vApp")
    ("initscript" "initscript (Optional) A script to be run only on initial boot")
    ("ip" "ip - (Optional) The IP to assign to this vApp. Must be an IP address or one of dhcp, allocated or none. If given the address must be within the static_ip_pool set for the network. If left blank, and the network has dhcp_pool set with at least one available IP then this will be set with DHCP.")
    ("power_on" "power_on - (Optional) A boolean value stating if this vApp should be powered on. Default to true")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_dhcp_relay_profile" '(
    ("description" "description - (Optional) Description of this resource.")
    ("display_name" "display_name - (Optional) The display name of this resource. Defaults to ID if not set.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this dhcp relay profile.")
    ("server_addresses" "server_addresses - (Required) IP addresses of the DHCP relay servers.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_dhcp_relay_service" '(
    ("description" "description - (Optional) Description of this resource.")
    ("display_name" "display_name - (Optional) The display name of this resource. Defaults to ID if not set.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this dhcp_relay_service.")
    ("dhcp_relay_profile_id" "dhcp_relay_profile_id - (Required) dhcp relay profile referenced by the dhcp relay service.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_firewall_section" '(
    ("display_name" "display_name - (Optional) The display name of this firewall section. Defaults to ID if not set.")
    ("description" "description - (Optional) Description of this firewall section.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this firewall section.")
    ("applied_to" "applied_to - (Optional) List of objects where the rules in this section will be enforced. This will take precedence over rule level applied_to. [Supported target types: \"LogicalPort\", \"LogicalSwitch\", \"NSGroup\"]")
    ("section_type" "section_type - (Required) Type of the rules which a section can contain. Either LAYER2 or LAYER3. Only homogeneous sections are supported.")
    ("stateful" "stateful - (Required) Stateful or Stateless nature of firewall section is enforced on all rules inside the section. Layer3 sections can be stateful or stateless. Layer2 sections can only be stateless.")
    ("rule" "rule - (Optional) A list of rules to be applied in this section. each rule has the following arguments:   display_name - (Optional) The display name of this rule. Defaults to ID if not set.  description - (Optional) Description of this rule.  action - (Required) Action enforced on the packets which matches the firewall rule. [Allowed values: \"ALLOW\", \"DROP\", \"REJECT\"]  applied_to - (Optional) List of object where rule will be enforced. The section level field overrides this one. Null will be treated as any. [Supported target types: \"LogicalPort\", \"LogicalSwitch\", \"NSGroup\"]  destination - (Optional) List of the destinations. Null will be treated as any. [Allowed target types: \"IPSet\", \"LogicalPort\", \"LogicalSwitch\", \"NSGroup\", \"MACSet\" (depending on the section type)]  destinations_excluded - (Optional) Negation of the destination.  direction - (Optional) Rule direction in case of stateless firewall rules. This will only considered if section level parameter is set to stateless. Default to IN_OUT if not specified. [Allowed values: \"IN\", \"OUT\", \"IN_OUT\"]  disabled - (Optional) Flag to disable rule. Disabled will only be persisted but never provisioned/realized.  ip_protocol - (Optional) Type of IP packet that should be matched while enforcing the rule. [allowed values: \"IPV4\", \"IPV6\", \"IPV4_IPV6\"]  logged - (Optional) Flag to enable packet logging. Default is disabled.  notes - (Optional) User notes specific to the rule.  rule_tag - (Optional) User level field which will be printed in CLI and packet logs.  service - (Optional) List of the services. Null will be treated as any. [Allowed target types: \"NSService\", \"NSServiceGroup\"]  source - (Optional) List of sources. Null will be treated as any. [Allowed target types: \"IPSet\", \"LogicalPort\", \"LogicalSwitch\", \"NSGroup\", \"MACSet\" (depending on the section type)]  sources_excluded - (Optional) Negation of the source.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_ip_set" '(
    ("description" "description - (Optional) Description of this resource.")
    ("display_name" "display_name - (Optional) The display name of this resource. Defaults to ID if not set.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this ip_set.")
    ("ip_addresses" "ip_addresses - (Optional) IP addresses.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_logical_port" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of this resource.")
    ("logical_switch_id" "logical_switch_id - (Required) Logical switch ID for the logical port.")
    ("admin_state" "admin_state - (Optional) Admin state for the logical port. Accepted values - 'UP' or 'DOWN'. The default value is 'UP'.")
    ("switching_profile_id" "switching_profile_id - (Optional) List of IDs of switching profiles (of various types) to be associated with this switch. Default switching profiles will be used if not specified.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this logical port.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_logical_router_downlink_port" '(
    ("logical_router_id" "logical_router_id - (Required) Identifier for logical Tier-1 router on which this port is created")
    ("linked_logical_switch_port_id" "linked_logical_switch_port_id - (Required) Identifier for port on logical switch to connect to")
    ("ip_address" "ip_address - (Required) Logical router port subnet (ip_address / prefix length)")
    ("mac_address" "mac_address - (Optional) Mac Address")
    ("urpf_mode" "urpf_mode - (Optional) Unicast Reverse Path Forwarding mode")
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of the resource.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this port.")
    ("service_binding" "service_binding - (Optional) A list of services for this port")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_logical_router_link_port_on_tier0" '(
    ("logical_router_id" "logical_router_id - (Required) Identifier for logical Tier0 router on which this port is created.")
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of the resource.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this port.")
    ("service_binding" "service_binding - (Optional) A list of services for this port")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_logical_router_link_port_on_tier1" '(
    ("logical_router_id" "logical_router_id - (Required) Identifier for logical tier-1 router on which this port is created.")
    ("linked_logical_switch_port_id" "linked_logical_switch_port_id - (Required) Identifier for port on logical Tier-0 router to connect to.")
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of the resource.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this port.")
    ("service_binding" "service_binding - (Optional) A list of services for this port")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_logical_switch" '(
    ("transport_zone_id" "transport_zone_id - (Required) Transport Zone ID for the logical switch.")
    ("admin_state" "admin_state - (Optional) Admin state for the logical switch. Accepted values - 'UP' or 'DOWN'. The default value is 'UP'.")
    ("replication_mode" "replication_mode - (Optional) Replication mode of the Logical Switch. Accepted values - 'MTEP' (Hierarchical Two-Tier replication) and 'SOURCE' (Head Replication), with 'MTEP' being the default value. Applies to overlay logical switches.")
    ("switching_profile_id" "switching_profile_id - (Optional) List of IDs of switching profiles (of various types) to be associated with this switch. Default switching profiles will be used if not specified.")
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of the resource.")
    ("ip_pool_id" "ip_pool_id - (Optional) Ip Pool ID to be associated with the logical switch.")
    ("mac_pool_id" "mac_pool_id - (Optional) Mac Pool ID to be associated with the logical switch.")
    ("vlan" "vlan - (Optional) Vlan for vlan logical switch. If not specified, this switch is overlay logical switch.")
    ("vni" "vni - (Optional) Vni for the logical switch.")
    ("address_binding" "address_binding - (Optional) List of Address Bindings for the logical switch. This setting allows to provide bindings between IP address, mac Address and vlan.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this logical switch.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_logical_tier1_router" '(
    ("edge_cluster_id" "edge_cluster_id - (Optional) Edge Cluster ID for the logical Tier1 router.")
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of the resource.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this logical Tier1 router.")
    ("failover_mode" "failover_mode - (Optional) This failover mode determines, whether the preferred service router instance for given logical router will preempt the peer. Note - It can be specified if and only if logical router is ACTIVE_STANDBY and NON_PREEMPTIVE mode is supported only for a Tier1 logical router. For ACTIVE_ACTIVE logical routers, this field must not be populated")
    ("enable_router_advertisement" "enable_router_advertisement - (Optional) Enable the router advertisement")
    ("advertise_connected_routes" "advertise_connected_routes - (Optional) Enable the router advertisement for all NSX connected routes")
    ("advertise_static_routes" "advertise_static_routes - (Optional) Enable the router advertisement for static routes")
    ("advertise_nat_routes" "advertise_nat_routes - (Optional) Enable the router advertisement for NAT routes")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_nat_rule" '(
    ("logical_router_id" "logical_router_id - (Required) ID of the logical router.")
    ("description" "description - (Optional) Description of this resource.")
    ("display_name" "display_name - (Optional) The display name of this resource. Defaults to ID if not set.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this NAT rule.")
    ("action" "action - (Required) NAT rule action type. Valid actions are: SNAT, DNAT, NO_NAT and REFLEXIVE. All rules in a logical router are either stateless or stateful. Mix is not supported. SNAT and DNAT are stateful, and can NOT be supported when the logical router is running at active-active HA mode. The REFLEXIVE action is stateless. The NO_NAT action has no translated_fields, only match fields.")
    ("enabled" "enabled - (Optional) enable/disable the rule.")
    ("logging" "logging - (Optional) enable/disable the logging of rule.")
    ("match_destination_network" "match_destination_network - (Optional) IP Address | CIDR | (null implies Any).")
    ("match_source_network" "match_source_network - (Optional) IP Address | CIDR | (null implies Any).")
    ("nat_pass" "nat_pass - (Optional) Enable/disable to bypass following firewall stage. The default is true, meaning that the following firewall stage will be skipped. Please note, if action is NO_NAT, then nat_pass must be set to true or omitted.")
    ("translated_network" "translated_network - (Optional) IP Address | IP Range | CIDR. For DNAT rules only a single ip is supported.")
    ("translated_ports" "translated_ports - (Optional) port number or port range. DNAT only.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_ns_group" '(
    ("description" "description - (Optional) Description of this resource.")
    ("display_name" "display_name - (Optional) The display name of this resource. Defaults to ID if not set.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this NS group.")
    ("member" "member - (Optional) Reference to the direct/static members of the NSGroup. Can be ID based expressions only. VirtualMachine cannot be added as a static member. target_type can be: NSGroup, IPSet, LogicalPort, LogicalSwitch, MACSet")
    ("membership_criteria" "membership_criteria - (Optional) List of tag or ID expressions which define the membership criteria for this NSGroup. An object must satisfy at least one of these expressions to qualify as a member of this group.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_static_route" '(
    ("description" "description - (Optional) Description of this resource.")
    ("display_name" "display_name - (Optional) The display name of this resource. Defaults to ID if not set.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this static route.")
    ("logical_router_id" "logical_router_id - (Optional) Logical router id.")
    ("network" "network - (Required) CIDR.")
    ("next_hop" "next_hop - (Required) List of Next Hops, each with those arguments:   administrative_distance - (Optional) Administrative Distance for the next hop IP.  ip_address - (Optional) Next Hop IP.  logical_router_port_id - (Optional) Reference of logical router port to be used for next hop.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_vm_tags" '(
    ("instance_id" "instance_id - (Required) BIOS Id of the Virtual Machine.")
    ("tag" "tag - (Required) A list of scope + tag pairs to associate with this VM.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_algorithm_type_ns_service" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description.")
    ("destination_port" "destination_port - (Required) a single destination port.")
    ("source_ports" "source_ports - (Optional) Set of source ports/ranges.")
    ("algorithm" "algorithm - (Required) Algorithm one of \"ORACLE_TNS\", \"FTP\", \"SUN_RPC_TCP\", \"SUN_RPC_UDP\", \"MS_RPC_TCP\", \"MS_RPC_UDP\", \"NBNS_BROADCAST\", \"NBDG_BROADCAST\", \"TFTP\"")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this service.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_ether_type_ns_service" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description.")
    ("ether_type" "ether_type - (Required) Type of the encapsulated protocol.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this service.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_icmp_type_ns_service" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description.")
    ("protocol" "protocol - (Required) Version of ICMP protocol ICMPv4 or ICMPv6.")
    ("icmp_type" "icmp_type - (Optional) ICMP message type.")
    ("icmp_code" "icmp_code - (Optional) ICMP message code")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this service.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_igmp_type_ns_service" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description.")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this service.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_ip_protocol_ns_service" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description.")
    ("protocol" "protocol - (Required) IP protocol number (0-255)")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this service.")

  ) company-terraform-resource-arguments-hash)

(puthash "nsxt_l4_port_set_ns_service" '(
    ("display_name" "display_name - (Optional) Display name, defaults to ID if not set.")
    ("description" "description - (Optional) Description of this resource.")
    ("destination_ports" "destination_ports - (Optional) Set of destination ports.")
    ("source_ports" "source_ports - (Optional) Set of source ports.")
    ("protocol" "protocol - (Optional) VL4 protocol")
    ("tag" "tag - (Optional) A list of scope + tag pairs to associate with this service.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_license" '(
    ("license_key" "license_key - (Required) The license key to add.")
    ("labels" "labels - (Optional) A map of key/value pairs to be attached as labels (tags) to the license key.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster" '(
    ("name" "name - (Required) The name of the cluster.")
    ("datacenter_id" "datacenter_id - (Required) The managed object ID of the datacenter to create the cluster in. Forces a new resource if changed.")
    ("folder" "folder - (Optional) The relative path to a folder to put this cluster in. This is a path relative to the datacenter you are deploying the cluster to. Example: for the dc1 datacenter, and a provided folder of foo/bar, Terraform will place a cluster named terraform-compute-cluster-test in a host folder located at /dc1/host/foo/bar, with the final inventory path being /dc1/host/foo/bar/terraform-datastore-cluster-test.")
    ("tags" "tags - (Optional) The IDs of any tags to attach to this resource. See here for a reference on how to apply tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster_host_group" '(
    ("name" "name - (Required) The name of the host group. This must be unique in the cluster. Forces a new resource if changed.")
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the group in.  Forces a new resource if changed.")
    ("host_system_ids" "host_system_ids - (Optional) The managed object IDs of the hosts to put in the cluster.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster_vm_affinity_rule" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the group in.  Forces a new resource if changed.")
    ("name" "name - (Required) The name of the rule. This must be unique in the cluster.")
    ("virtual_machine_ids" "virtual_machine_ids - (Required) The UUIDs of the virtual machines to run on the same host together.")
    ("enabled" "enabled - (Optional) Enable this rule in the cluster. Default: true.")
    ("mandatory" "mandatory - (Optional) When this value is true, prevents any virtual machine operations that may violate this rule. Default: false.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster_vm_anti_affinity_rule" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the group in.  Forces a new resource if changed.")
    ("name" "name - (Required) The name of the rule. This must be unique in the cluster.")
    ("virtual_machine_ids" "virtual_machine_ids - (Required) The UUIDs of the virtual machines to run on hosts different from each other.")
    ("enabled" "enabled - (Optional) Enable this rule in the cluster. Default: true.")
    ("mandatory" "mandatory - (Optional) When this value is true, prevents any virtual machine operations that may violate this rule. Default: false.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster_vm_dependency_rule" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the group in.  Forces a new resource if changed.")
    ("name" "name - (Required) The name of the rule. This must be unique in the cluster.")
    ("dependency_vm_group_name" "dependency_vm_group_name - (Required) The name of the VM group that this rule depends on. The VMs defined in the group specified by vm_group_name will not be started until the VMs in this group are started.")
    ("vm_group_name" "vm_group_name - (Required) The name of the VM group that is the subject of this rule. The VMs defined in this group will not be started until the VMs in the group specified by dependency_vm_group_name are started.")
    ("enabled" "enabled - (Optional) Enable this rule in the cluster. Default: true.")
    ("mandatory" "mandatory - (Optional) When this value is true, prevents any virtual machine operations that may violate this rule. Default: false.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster_vm_group" '(
    ("name" "name - (Required) The name of the VM group. This must be unique in the cluster. Forces a new resource if changed.")
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the group in.  Forces a new resource if changed.")
    ("virtual_machine_ids" "virtual_machine_ids - (Required) The UUIDs of the virtual machines in this group.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_compute_cluster_vm_host_rule" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the group in.  Forces a new resource if changed.")
    ("name" "name - (Required) The name of the rule. This must be unique in the cluster.")
    ("vm_group_name" "vm_group_name - (Required) The name of the virtual machine group to use with this rule.")
    ("affinity_host_group_name" "affinity_host_group_name - (Optional) When this field is used, the virtual machines defined in vm_group_name will be run on the hosts defined in this host group.")
    ("anti_affinity_host_group_name" "anti_affinity_host_group_name - (Optional) When this field is used, the virtual machines defined in vm_group_name will not be run on the hosts defined in this host group.")
    ("enabled" "enabled - (Optional) Enable this rule in the cluster. Default: true.")
    ("mandatory" "mandatory - (Optional) When this value is true, prevents any virtual machine operations that may violate this rule. Default: false.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_drs_vm_override" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the override in.  Forces a new resource if changed.")
    ("virtual_machine_id" "virtual_machine_id - (Required) The UUID of the virtual machine to create the override for.  Forces a new resource if changed.")
    ("drs_enabled" "drs_enabled - (Optional) Overrides the default DRS setting for this virtual machine. Can be either true or false. Default: false.")
    ("drs_automation_level" "drs_automation_level - (Optional) Overrides the automation level for this virtual machine in the cluster. Can be one of manual, partiallyAutomated, or fullyAutomated. Default: manual.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_dpm_host_override" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the override in.  Forces a new resource if changed.")
    ("host_system_ids" "host_system_ids - (Optional) The managed object ID of the host to create the override for.")
    ("dpm_enabled" "dpm_enabled - (Optional) Enable DPM support for this host. Default: false.")
    ("dpm_automation_level" "dpm_automation_level - (Optional) The automation level for host power operations on this host. Can be one of manual or automated. Default: manual.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_ha_vm_override" '(
    ("compute_cluster_id" "compute_cluster_id - (Required) The managed object reference ID of the cluster to put the override in.  Forces a new resource if changed.")
    ("virtual_machine_id" "virtual_machine_id - (Required) The UUID of the virtual machine to create the override for.  Forces a new resource if changed.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_custom_attribute" '(
    ("name" "name - (Required) The name of the custom attribute.")
    ("managed_object_type" "managed_object_type - (Optional) The object type that this attribute may be applied to. If not set, the custom attribute may be applied to any object type. For a full list, click here. Forces a new resource if changed.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_datacenter" '(
    ("name" "name - (Required) The name of the datacenter. This name needs to be unique within the folder. Forces a new resource if changed.")
    ("folder" "folder - (Optional) The folder where the datacenter should be created. Forces a new resource if changed.")
    ("tags" "tags - (Optional) The IDs of any tags to attach to this resource. See here for a reference on how to apply tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_folder" '(
    ("path" "path - (Required) The path of the folder to be created. This is relative to the root of the type of folder you are creating, and the supplied datacenter. For example, given a default datacenter of default-dc, a folder of type vm (denoting a virtual machine folder), and a supplied folder of terraform-test-folder, the resulting path would be /default-dc/vm/terraform-test-folder.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_tag" '(
    ("name" "name - (Required) The display name of the tag. The name must be unique within its category.")
    ("category_id" "category_id - (Required) The unique identifier of the parent category in which this tag will be created. Forces a new resource if changed.")
    ("description" "description - (Optional) A description for the tag.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_tag_category" '(
    ("name" "name - (Required) The name of the category.")
    ("cardinality" "cardinality - (Required) The number of tags that can be assigned from this category to a single object at once. Can be one of SINGLE (object can only be assigned one tag in this category), to MULTIPLE (object can be assigned multiple tags in this category). Forces a new resource if changed.")
    ("associable_types" "associable_types - (Required) A list object types that this category is valid to be assigned to. For a full list, click here.")
    ("description" "description - (Optional) A description for the category.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_distributed_port_group" '(
    ("name" "name - (Required) The name of the port group.")
    ("distributed_virtual_switch_uuid" "distributed_virtual_switch_uuid - (Required) The ID of the DVS to add the port group to. Forces a new resource if changed.")
    ("type" "type - (Optional) The port group type. Can be one of earlyBinding (static binding) or ephemeral. Default: earlyBinding.")
    ("description" "description - (Optional) An optional description for the port group.")
    ("number_of_ports" "number_of_ports - (Optional) The number of ports available on this port group. Cannot be decreased below the amount of used ports on the port group.")
    ("auto_expand" "auto_expand - (Optional) Allows the port group to create additional ports past the limit specified in number_of_ports if necessary. Default: true.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_distributed_virtual_switch" '(
    ("name" "name - (Required) The name of the distributed virtual switch.")
    ("datacenter_id" "datacenter_id - (Required) The ID of the datacenter where the distributed virtual switch will be created. Forces a new resource if changed.")
    ("folder" "folder - (Optional) The folder to create the DVS in. Forces a new resource if changed.")
    ("description" "description - (Optional) A detailed description for the DVS.")
    ("contact_name" "contact_name - (Optional) The name of the person who is responsible for the DVS.")
    ("contact_detail" "contact_detail - (Optional) The detailed contact information for the person who is responsible for the DVS.")
    ("ipv4_address" "ipv4_address - (Optional) An IPv4 address to identify the switch. This is mostly useful when used with the Netflow arguments found below.")
    ("lacp_api_version" "lacp_api_version - (Optional) The Link Aggregation Control Protocol group version to use with the switch. Possible values are singleLag and multipleLag.")
    ("link_discovery_operation" "link_discovery_operation - (Optional) Whether to advertise or listen for link discovery traffic.")
    ("link_discovery_protocol" "link_discovery_protocol - (Optional) The discovery protocol type. Valid types are cdp and lldp.")
    ("max_mtu" "max_mtu - (Optional) The maximum transmission unit (MTU) for the virtual switch.")
    ("multicast_filtering_mode" "multicast_filtering_mode - (Optional) The multicast filtering mode to use with the switch. Can be one of legacyFiltering or snooping.")
    ("version" "version - (Optional) - The version of the DVS to create. The default is to create the DVS at the latest version supported by the version of vSphere being used. A DVS can be upgraded to another version, but cannot be downgraded.")
    ("tags" "tags - (Optional) The IDs of any tags to attach to this resource. See here for a reference on how to apply tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_host_port_group" '(
    ("name" "name - (Required) The name of the port group.  Forces a new resource if changed.")
    ("host_system_id" "host_system_id - (Required) The managed object ID of the host to set the port group up on. Forces a new resource if changed.")
    ("virtual_switch_name" "virtual_switch_name - (Required) The name of the virtual switch to bind this port group to. Forces a new resource if changed.")
    ("vlan_id" "vlan_id - (Optional) The VLAN ID/trunk mode for this port group.  An ID of 0 denotes no tagging, an ID of 1-4094 tags with the specific ID, and an ID of 4095 enables trunk mode, allowing the guest to manage its own tagging. Default: 0.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_host_virtual_switch" '(
    ("name" "name - (Required) The name of the virtual switch. Forces a new resource if changed.")
    ("host_system_id" "host_system_id - (Required) The managed object ID of the host to set the virtual switch up on. Forces a new resource if changed.")
    ("mtu" "mtu - (Optional) The maximum transmission unit (MTU) for the virtual switch. Default: 1500.")
    ("number_of_ports" "number_of_ports - (Optional) The number of ports to create with this virtual switch. Default: 128.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_datastore_cluster" '(
    ("name" "name - (Required) The name of the datastore cluster.")
    ("datacenter_id" "datacenter_id - (Required) The managed object ID of the datacenter to create the datastore cluster in. Forces a new resource if changed.")
    ("folder" "folder - (Optional) The relative path to a folder to put this datastore cluster in.  This is a path relative to the datacenter you are deploying the datastore to.  Example: for the dc1 datacenter, and a provided folder of foo/bar, Terraform will place a datastore cluster named terraform-datastore-cluster-test in a datastore folder located at /dc1/datastore/foo/bar, with the final inventory path being /dc1/datastore/foo/bar/terraform-datastore-cluster-test.")
    ("sdrs_enabled" "sdrs_enabled - (Optional) Enable Storage DRS for this datastore cluster. Default: false.")
    ("tags" "tags - (Optional) The IDs of any tags to attach to this resource. See here for a reference on how to apply tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_datastore_cluster_vm_anti_affinity_rule" '(
    ("datastore_cluster_id" "datastore_cluster_id - (Required) The managed object reference ID of the datastore cluster to put the group in.  Forces a new resource if changed.")
    ("name" "name - (Required) The name of the rule. This must be unique in the cluster.")
    ("virtual_machine_ids" "virtual_machine_ids - (Required) The UUIDs of the virtual machines to run on different datastores from each other.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_file" '(
    ("source_file" "source_file - (Required) The path to the file being uploaded from the Terraform host to vSphere or copied within vSphere. Forces a new resource if changed.")
    ("destination_file" "destination_file - (Required) The path to where the file should be uploaded or copied to on vSphere.")
    ("source_datacenter" "source_datacenter - (Optional) The name of a datacenter in which the file will be copied from. Forces a new resource if changed.")
    ("datacenter" "datacenter - (Optional) The name of a datacenter in which the file will be uploaded to.")
    ("source_datastore" "source_datastore - (Optional) The name of the datastore in which file will be copied from. Forces a new resource if changed.")
    ("datastore" "datastore - (Required) The name of the datastore in which to upload the file to.")
    ("create_directories" "create_directories - (Optional) Create directories in destination_file path parameter if any missing for copy operation.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_nas_datastore" '(
    ("name" "name - (Required) The name of the datastore. Forces a new resource if changed.")
    ("host_system_ids" "host_system_ids - (Required) The managed object IDs of the hosts to mount the datastore on.")
    ("type" "type - (Optional) The type of NAS volume. Can be one of NFS (to denote v3) or NFS41 (to denote NFS v4.1). Default: NFS. Forces a new resource if changed.")
    ("remote_hosts" "remote_hosts - (Required) The hostnames or IP addresses of the remote server or servers. Only one element should be present for NFS v3 but multiple can be present for NFS v4.1. Forces a new resource if changed.")
    ("remote_path" "remote_path - (Required) The remote path of the mount point. Forces a new resource if changed.")
    ("access_mode" "access_mode - (Optional) Access mode for the mount point. Can be one of readOnly or readWrite. Note that readWrite does not necessarily mean that the datastore will be read-write depending on the permissions of the actual share. Default: readWrite. Forces a new resource if changed.")
    ("security_type" "security_type - (Optional) The security type to use when using NFS v4.1. Can be one of AUTH_SYS, SEC_KRB5, or SEC_KRB5I. Forces a new resource if changed.")
    ("folder" "folder - (Optional) The relative path to a folder to put this datastore in. This is a path relative to the datacenter you are deploying the datastore to. Example: for the dc1 datacenter, and a provided folder of foo/bar, Terraform will place a datastore named terraform-test in a datastore folder located at /dc1/datastore/foo/bar, with the final inventory path being /dc1/datastore/foo/bar/terraform-test. Conflicts with datastore_cluster_id.")
    ("datastore_cluster_id" "datastore_cluster_id - (Optional) The managed object ID of a datastore cluster to put this datastore in. Conflicts with folder.")
    ("tags" "tags - (Optional) The IDs of any tags to attach to this resource. See here for a reference on how to apply tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_storage_drs_vm_override" '(
    ("datastore_cluster_id" "datastore_cluster_id - (Required) The managed object reference ID of the datastore cluster to put the override in. Forces a new resource if changed.")
    ("virtual_machine_id" "virtual_machine_id - (Required) The UUID of the virtual machine to create the override for.  Forces a new resource if changed.")
    ("sdrs_enabled" "sdrs_enabled - (Optional) Overrides the default Storage DRS setting for this virtual machine. When not specified, the datastore cluster setting is used.")
    ("sdrs_automation_level" "sdrs_automation_level - (Optional) Overrides any Storage DRS automation levels for this virtual machine. Can be one of automated or manual. When not specified, the datastore cluster's settings are used according to the specific SDRS subsystem.")
    ("sdrs_intra_vm_affinity" "sdrs_intra_vm_affinity - (Optional) Overrides the intra-VM affinity setting for this virtual machine. When true, all disks for this virtual machine will be kept on the same datastore. When false, Storage DRS may locate individual disks on different datastores if it helps satisfy cluster requirements. When not specified, the datastore cluster's settings are used.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_vmfs_datastore" '(
    ("name" "name - (Required) The name of the datastore. Forces a new resource if changed.")
    ("host_system_id" "host_system_id - (Required) The managed object ID of the host to set the datastore up on. Note that this is not necessarily the only host that the datastore will be set up on - see here for more info. Forces a new resource if changed.")
    ("disks" "disks - (Required) The disks to use with the datastore.")
    ("folder" "folder - (Optional) The relative path to a folder to put this datastore in. This is a path relative to the datacenter you are deploying the datastore to. Example: for the dc1 datacenter, and a provided folder of foo/bar, Terraform will place a datastore named terraform-test in a datastore folder located at /dc1/datastore/foo/bar, with the final inventory path being /dc1/datastore/foo/bar/terraform-test. Conflicts with datastore_cluster_id.")
    ("datastore_cluster_id" "datastore_cluster_id - (Optional) The managed object ID of a datastore cluster to put this datastore in. Conflicts with folder.")
    ("tags" "tags - (Optional) The IDs of any tags to attach to this resource. See here for a reference on how to apply tags.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_virtual_disk" '(
    ("vmdk_path" "vmdk_path - (Required) The path, including filename, of the virtual disk to be created.  This needs to end in .vmdk.")
    ("datastore" "datastore - (Required) The name of the datastore in which to create the disk.")
    ("size" "size - (Required) Size of the disk (in GB).")
    ("datacenter" "datacenter - (Optional) The name of the datacenter in which to create the disk. Can be omitted when when ESXi or if there is only one datacenter in your infrastructure.")
    ("type" "type - (Optional) The type of disk to create. Can be one of eagerZeroedThick, lazy, or thin. Default: eagerZeroedThick. For information on what each kind of disk provisioning policy means, click here.")
    ("adapter_type" "adapter_type - (Optional) The adapter type for this virtual disk. Can be one of ide, lsiLogic, or busLogic.  Default: lsiLogic.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_virtual_machine" '(
    ("name" "name - (Required) The name of the virtual machine.")
    ("resource_pool_id" "resource_pool_id - (Required) The managed object reference ID of the resource pool to put this virtual machine in. See the section on virtual machine migration for details on changing this value.")

  ) company-terraform-resource-arguments-hash)

(puthash "vsphere_virtual_machine_snapshot" '(
    ("virtual_machine_uuid" "virtual_machine_uuid - (Required) The virtual machine UUID.")
    ("snapshot_name" "snapshot_name - (Required) The name of the snapshot.")
    ("description" "description - (Required) A description for the snapshot.")
    ("memory" "memory - (Required) If set to true, a dump of the internal state of the virtual machine is included in the snapshot.")
    ("quiesce" "quiesce - (Required) If set to true, and the virtual machine is powered on when the snapshot is taken, VMware Tools is used to quiesce the file system in the virtual machine.")
    ("remove_children" "remove_children - (Optional) If set to true, the entire snapshot subtree is removed when this resource is destroyed.")
    ("consolidate" "consolidate - (Optional) If set to true, the delta disks involved in this snapshot will be consolidated into the parent when this resource is destroyed.")

  ) company-terraform-resource-arguments-hash)

(puthash "alicloud_disk" '(
    ("id" "id - The disk ID.")
    ("availability_zone" "availability_zone - The Zone to create the disk in.")
    ("name" "name - The disk name.")
    ("description" "description - The disk description.")
    ("status" "status - The disk status.")
    ("category" "category - The disk category.")
    ("size" "size - The disk size.")
    ("snapshot_id" "snapshot_id - The disk snapshot ID.")
    ("tags" "tags - The disk tags.")
    ("encrypted" "encrypted - Whether the disk is encrypted.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_disk_attachment" '(
    ("instance_id" "instance_id - ID of the Instance.")
    ("disk_id" "disk_id - ID of the Disk.")
    ("device_name" "device_name - The device name exposed to the instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_instance" '(
    ("id" "id - The instance ID.")
    ("availability_zone" "availability_zone - The Zone to start the instance in.")
    ("instance_name" "instance_name - The instance name.")
    ("host_name" "host_name - The instance host name.")
    ("description" "description - The instance description.")
    ("status" "status - The instance status.")
    ("image_id" "image_id - The instance Image Id.")
    ("instance_type" "instance_type - The instance type.")
    ("private_ip" "private_ip - The instance private ip.")
    ("public_ip" "public_ip - The instance public ip.")
    ("vswitch_id" "vswitch_id - If the instance created in VPC, then this value is  virtual switch ID.")
    ("tags" "tags - The instance tags, use jsonencode(item) to display the value.")
    ("key_name" "key_name - The name of key pair that has been bound in ECS instance.")
    ("role_name" "role_name - The name of RAM role that has been bound in ECS instance.")
    ("user_data" "user_data - The hash value of the user data.")
    ("period" "period - The ECS instance using duration.")
    ("period_unit" "period_unit - The ECS instance using duration unit.")
    ("dry_run" "dry_run - Whether to pre-detection.")
    ("spot_strategy" "spot_strategy - The spot strategy of a Pay-As-You-Go instance")
    ("spot_price_limit" "spot_price_limit - The hourly price threshold of a instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_security_group" '(
    ("id" "id - The ID of the security group")
    ("vpc_id" "vpc_id - The VPC ID.")
    ("name" "name - The name of the security group")
    ("description" "description - The description of the security group")
    ("inner_access" "inner_access - Whether to allow inner network access.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_security_group_rule" '(
    ("id" "id - The ID of the security group rule")
    ("type" "type - The type of rule, ingress or egress")
    ("name" "name - The name of the security group")
    ("port_range" "port_range - The range of port numbers")
    ("ip_protocol" "ip_protocol - The protocol of the security group rule")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_eip" '(
    ("id" "id - The EIP ID.")
    ("bandwidth" "bandwidth - The elastic public network bandwidth.")
    ("internet_charge_type" "internet_charge_type - The EIP internet charge type.")
    ("status" "status - The EIP current status.")
    ("ip_address" "ip_address - The elastic ip address")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_eip_association" '(
    ("allocation_id" "allocation_id - As above.")
    ("instance_id" "instance_id - As above.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_key_pair" '(
    ("key_name" "key_name - The name of the key pair.")
    ("fingerprint" "fingerprint The finger print of the key pair.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_key_pair_attachment" '(
    ("key_name" "key_name - The name of the key pair.")
    ("instance_ids" "instance_ids The list of ECS instance's IDs.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_slb" '(
    ("id" "id - The ID of the load balancer.")
    ("name" "name - The name of the load balancer.")
    ("internet" "internet - The internet of the load balancer.")
    ("internet_charge_type" "internet_charge_type - The internet_charge_type of the load balancer.")
    ("bandwidth" "bandwidth - The bandwidth of the load balancer.")
    ("vswitch_id" "vswitch_id - The VSwitch ID of the load balancer. Only available on SLB launched in a VPC.")
    ("address" "address - The IP address of the load balancer.")
    ("specification" "specification - The specification of the Server Load Balancer instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_slb_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_slb_listener" '(
    ("id" "id - The ID of the load balancer listener. It is consist of load_balancer_id and frontend_port: :.")
    ("load_balancer_id" "load_balancer_id - The Load Balancer ID which is used to launch a new listener.")
    ("frontend_port" "frontend_port - Port used by the Server Load Balancer instance frontend.")
    ("backend_port" "backend_port - Port used by the Server Load Balancer instance backend.")
    ("protocol" "protocol - The protocol to listen on.")
    ("bandwidth" "bandwidth - Bandwidth peak of Listener.")
    ("scheduler" "scheduler - Scheduling algorithm.")
    ("sticky_session" "sticky_session - Whether to enable session persistence.")
    ("sticky_session_type" "sticky_session_type - Mode for handling the cookie.")
    ("cookie_timeout" "cookie_timeout - Cookie timeout.")
    ("cookie" "cookie - The cookie configured on the server.")
    ("persistence_timeout" "persistence_timeout - Timeout of connection persistence.")
    ("health_check" "health_check - Whether to enable health check.")
    ("health_check_type" "health_check_type - Type of health check.")
    ("health_check_domain" "health_check_domain - Domain name used for health check.")
    ("health_check_uri" "health_check_uri - URI used for health check.")
    ("health_check_connect_port" "health_check_connect_port - Port used for health check.")
    ("healthy_threshold" "healthy_threshold - Threshold determining the result of the health check is success.")
    ("unhealthy_threshold" "unhealthy_threshold - Threshold determining the result of the health check is fail.")
    ("health_check_timeout" "health_check_timeout - Maximum timeout of each health check response.")
    ("health_check_interval" "health_check_interval - Time interval of health checks.")
    ("health_check_http_code" "health_check_http_code - Regular health check HTTP status code.")
    ("ssl_certificate_id" "ssl_certificate_id - (Optinal) Security certificate ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_slb_rule" '(
    ("id" "id - The ID of the forwarding rule.")
    ("load_balancer_id" "load_balancer_id - The Load Balancer ID in which forwarding rule belongs.")
    ("name" "name - The name of the forwarding rule.")
    ("forntend_port" "forntend_port - The listener port in which forwarding rule belongs.")
    ("domain" "domain - The domain name of the forwarding rule.")
    ("url" "url - The url of the forwarding rule.")
    ("server_group_id" "server_group_id - The Id of the virtual server group.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_slb_server_group" '(
    ("id" "id - The ID of the virtual server group.")
    ("load_balancer_id" "load_balancer_id - The Load Balancer ID which is used to launch a new virtual server group.")
    ("name" "name - The name of the virtual server group.")
    ("servers" "servers - A list of ECS instances that have be added.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_vpc" '(
    ("id" "id - The ID of the VPC.")
    ("cidr_block" "cidr_block - The CIDR block for the VPC.")
    ("name" "name - The name of the VPC.")
    ("description" "description - The description of the VPC.")
    ("router_id" "router_id - The ID of the router created by default on VPC creation.")
    ("route_table_id" "route_table_id - The route table ID of the router created by default on VPC creation.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_vswitch" '(
    ("id" "id - The ID of the switch.")
    ("availability_zone" "availability_zone The AZ for the switch.")
    ("cidr_block" "cidr_block - The CIDR block for the switch.")
    ("vpc_id" "vpc_id - The VPC ID.")
    ("name" "name - The name of the switch.")
    ("description" "description - The description of the switch.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_route_entry" '(
    ("router_id" "router_id - The ID of the virtual router attached to Vpc.")
    ("route_table_id" "route_table_id - The ID of the route table.")
    ("destination_cidrblock" "destination_cidrblock - The RouteEntry's target network segment.")
    ("nexthop_type" "nexthop_type - The next hop type.")
    ("nexthop_id" "nexthop_id - The route entry's next hop.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_nat_gateway" '(
    ("id" "id - The ID of the nat gateway.")
    ("name" "name - The name of the nat gateway.")
    ("description" "description - The description of the nat gateway.")
    ("spec" "spec - It has been deprecated from provider version 1.7.1.")
    ("specification" "specification - The specification of the nat gateway.")
    ("vpc_id" "vpc_id - The VPC ID for the nat gateway.")
    ("bandwidth_package_ids" "bandwidth_package_ids - A list ID of the bandwidth packages, and split them with commas")
    ("snat_table_ids" "snat_table_ids - The nat gateway will auto create a snap and forward item, the snat_table_ids is the created one.")
    ("forward_table_ids" "forward_table_ids - The nat gateway will auto create a snap and forward item, the forward_table_ids is the created one.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_router_interface" '(
    ("id" "id - Router interface ID.")
    ("router_id" "router_id - Router ID.")
    ("router_type" "router_type - Router type.")
    ("role" "role - Router interface role.")
    ("name" "name - Router interface name.")
    ("description" "description - Router interface description.")
    ("specification" "specification - Router nterface specification.")
    ("access_point_id" "access_point_id - Access point of the router interface.")
    ("opposite_access_point_id" "opposite_access_point_id - Access point of the opposite router interface.")
    ("opposite_router_type" "opposite_router_type - Peer router type.")
    ("opposite_router_id" "opposite_router_id - Peer router ID.")
    ("opposite_interface_id" "opposite_interface_id - Peer router interface ID.")
    ("opposite_interface_owner_id" "opposite_interface_owner_id - Peer account ID.")
    ("health_check_source_ip" "health_check_source_ip - Source IP of Packet of Line HealthCheck.")
    ("health_check_target_ip" "health_check_target_ip - Target IP of Packet of Line HealthCheck.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_forward_entry" '(

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_snat_entry" '(

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_db_account" '(
    ("id" "id - The current account resource ID. Composed of instance ID and account name with format \":\".")
    ("instance_id" "instance_id - The Id of DB instance.")
    ("name" "name - The name of DB account.")
    ("description" "description - The account description.")
    ("type" "type - Privilege type of account.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_db_account_privilege" '(
    ("id" "id - The current account resource ID. Composed of instance ID, account name and privilege with format \"::\".")
    ("instance_id" "instance_id - The Id of DB instance.")
    ("account_name" "account_name - The name of DB account.")
    ("privilege" "privilege - The specified account privilege.")
    ("db_names" "db_names - List of granted privilege database names.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_db_backup_policy" '(
    ("id" "id - The current backup policy resource ID. It is same as 'instance_id'.")
    ("instance_id" "instance_id - The Id of DB instance.")
    ("backup_period" "backup_period - DB Instance backup period.")
    ("backup_time" "backup_time - DB instance backup time.")
    ("retention_period" "retention_period - Instance backup retention days.")
    ("log_backup" "log_backup - Whether to backup instance log.")
    ("log_retention_period" "log_retention_period - Instance log backup retention days.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_db_connection" '(
    ("id" "id - The current instance connection resource ID. Composed of instance ID and connection string with format \":\".")
    ("connection_prefix" "connection_prefix - Prefix of a connection string.")
    ("port" "port - Connection instance port.")
    ("connection_string" "connection_string - Connection instance string.")
    ("ip_address" "ip_address - The ip address of connection string.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_db_database" '(
    ("id" "id - The current database resource ID. Composed of instance ID and database name with format \":\".")
    ("instance_id" "instance_id - The Id of DB instance.")
    ("name" "name - The name of DB database.")
    ("character_set" "character_set - Character set that database used.")
    ("description" "description - The database description.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_db_instance" '(
    ("id" "id - The RDS instance ID.")
    ("instance_charge_type" "instance_charge_type - The instance charge type.")
    ("period" "period - The DB instance using duration.")
    ("engine" "engine - Database type.")
    ("engine_version" "engine_version - The database engine version.")
    ("db_instance_class" "db_instance_class - (Deprecated from version 1.5.0)")
    ("instance_type" "instance_type - The RDS instance type.")
    ("db_instance_storage" "db_instance_storage - (Deprecated from version 1.5.0)")
    ("instance_storage" "instance_storage - The RDS instance storage space.")
    ("instance_name" "instance_name - The name of DB instance.")
    ("port" "port - RDS database connection port.")
    ("connection_string" "connection_string - RDS database connection string.")
    ("zone_id" "zone_id - The zone ID of the RDS instance.")
    ("db_instance_net_type" "db_instance_net_type - (Deprecated from version 1.5.0).")
    ("instance_network_type" "instance_network_type - (Deprecated from version 1.5.0).")
    ("db_mappings" "db_mappings - - (Deprecated from version 1.5.0).")
    ("preferred_backup_period" "preferred_backup_period - (Deprecated from version 1.5.0).")
    ("preferred_backup_time" "preferred_backup_time - (Deprecated from version 1.5.0).")
    ("backup_retention_period" "backup_retention_period - (Deprecated from version 1.5.0).")
    ("security_ips" "security_ips - Security ips of instance whitelist.")
    ("connections" "connections - (Deprecated from version 1.5.0).")
    ("vswitch_id" "vswitch_id - If the rds instance created in VPC, then this value is virtual switch ID.")
    ("master_user_name" "master_user_name - (Deprecated from version 1.5.0).")
    ("preferred_backup_period" "preferred_backup_period - (Deprecated from version 1.5.0).")
    ("preferred_backup_time" "preferred_backup_time - (Deprecated from version 1.5.0).")
    ("backup_retention_period" "backup_retention_period - (Deprecated from version 1.5.0).")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ess_attachment" '(
    ("id" "id - The ESS attachment resource ID.")
    ("instance_ids" "instance_ids - ID of list \"Attached\" ECS instance.")
    ("force" "force - Whether to delete \"AutoCreated\" ECS instances.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ess_scaling_group" '(
    ("id" "id - The scaling group ID.")
    ("min_size" "min_size - The minimum number of ECS instances.")
    ("max_size" "max_size - The maximum number of ECS instances.")
    ("scaling_group_name" "scaling_group_name - The name of the scaling group.")
    ("default_cooldown" "default_cooldown - The default cool-down of the scaling group.")
    ("removal_policies" "removal_policies - The removal policy used to select the ECS instance to remove from the scaling group.")
    ("db_instance_ids" "db_instance_ids - The db instances id which the ECS instance attached to.")
    ("loadbalancer_ids" "loadbalancer_ids - The slb instances id which the ECS instance attached to.")
    ("vswitch_ids" "vswitch_ids - The vswitches id in which the ECS instance launched.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ess_scaling_configuration" '(
    ("id" "id - The scaling configuration ID.")
    ("active" "active - Wether the current scaling configuration is actived.")
    ("image_id" "image_id - The ecs instance Image id.")
    ("instance_type" "instance_type - The ecs instance type.")
    ("security_group_id" "security_group_id - ID of the security group to which a newly created instance belongs.")
    ("scaling_configuration_name" "scaling_configuration_name - Name of scaling configuration.")
    ("internet_charge_type" "internet_charge_type - Internet charge type of ecs instance.")
    ("key_name" "key_name - The name of key pair that has been bound in ECS instance.")
    ("role_name" "role_name - The name of RAM role that has been bound in ECS instance.")
    ("user_data" "user_data - The hash value of the user data.")
    ("force_delete" "force_delete - Whether delete the last scaling configuration forcibly with deleting its scaling group.")
    ("tags" "tags - The scaling instance tags, use jsonencode(item) to display the value.")
    ("instance_name" "instance_name - The ecs instance name.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ess_scaling_rule" '(
    ("id" "id - The scaling rule ID.")
    ("scaling_group_id" "scaling_group_id - The id of scaling group.")
    ("ari" "ari - Unique identifier of a scaling rule.")
    ("adjustment_type" "adjustment_type - Adjustment mode of a scaling rule.")
    ("adjustment_value" "adjustment_value - Adjustment value of a scaling rule.")
    ("scaling_rule_name" "scaling_rule_name - Name of a scaling rule.")
    ("cooldown" "cooldown - Cool-down time of a scaling rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ess_schedule" '(
    ("id" "id - The schedule task ID.")
    ("scheduled_action" "scheduled_action - The action of schedule task.")
    ("launch_time" "launch_time - The time of schedule task be triggered.")
    ("scheduled_task_name" "scheduled_task_name - The name of schedule task.")
    ("description" "description - The description of schedule task.")
    ("task_enabled" "task_enabled - Wether the task is enabled.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_oss_bucket" '(
    ("id" "id - The name of the bucket.")
    ("acl" "acl - The acl of the bucket.")
    ("creation_date" "creation_date - The creation date of the bucket.")
    ("extranet_endpoint" "extranet_endpoint - The extranet access endpoint of the bucket.")
    ("intranet_endpoint" "intranet_endpoint - The intranet access endpoint of the bucket.")
    ("location" "location - The location of the bucket.")
    ("owner" "owner - The bucket owner.")
    ("storage_class" "storage_class - The bucket storage type.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_oss_bucket_object" '(
    ("id" "id - the key of the resource supplied above")
    ("content_length" "content_length - the content length of request.")
    ("etag" "etag - the ETag generated for the object (an MD5 sum of the object content).")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_container_cluster" '(

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_cs_application" '(
    ("id" "id - The ID of the container application. It's formate is :")
    ("cluster_name" "cluster_name - The name of the container cluster.")
    ("name" "name - The application name.")
    ("description" "description - The application description.")
    ("template" "template - The application deploying template.")
    ("environment" "environment - The application environment variables.")
    ("services" "services - List of services in the application. It contains several attributes to Block Nodes.")
    ("default_domain" "default_domain - The application default domain and it can be used to configure routing service.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_cs_swarm" '(
    ("id" "id - The ID of the container cluster.")
    ("name" "name - The name of the container cluster.")
    ("size" "size - It has been deprecated from provider version 1.9.1. New field 'node_number' replaces it.")
    ("node_number" "node_number - The node number.")
    ("vpc_id" "vpc_id - The ID of VPC where the current cluster is located.")
    ("vswitch_id" "vswitch_id - The ID of VSwitch where the current cluster is located.")
    ("slb_id" "slb_id - The ID of load balancer where the current cluster worker node is located.")
    ("security_group_id" "security_group_id - The ID of security group where the current cluster worker node is located.")
    ("agent_version" "agent_version - The nodes agent version.")
    ("instance_type" "instance_type - The instance type of nodes.")
    ("disk_category" "disk_category - The data disk category of nodes.")
    ("disk_size" "disk_size - The data disk size of nodes.")
    ("nodes" "nodes - List of cluster nodes. It contains several attributes to Block Nodes.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_cs_kubernetes" '(
    ("id" "id - The ID of the container cluster.")
    ("name" "name - The name of the container cluster.")
    ("availability_zone" "availability_zone - The ID of availability zone.")
    ("worker_number" "worker_number The ECS instance node number in the current container cluster.")
    ("vswitch_id" "vswitch_id - The ID of VSwitch where the current cluster is located.")
    ("vpc_id" "vpc_id - The ID of VPC where the current cluster is located.")
    ("slb_id" "slb_id - (Deprecated from version 1.9.2).")
    ("slb_internet" "slb_internet - The ID of public load balancer where the current cluster master node is located.")
    ("slb_intranet" "slb_intranet - The ID of private load balancer where the current cluster master node is located.")
    ("security_group_id" "security_group_id - The ID of security group where the current cluster worker node is located.")
    ("image_id" "image_id - The ID of node image.")
    ("nat_gateway_id" "nat_gateway_id - The ID of nat gateway used to launch kubernetes cluster.")
    ("master_instance_type" "master_instance_type - The instance type of master node.")
    ("worker_instance_type" "worker_instance_type - The instance type of worker node.")
    ("master_disk_category" "master_disk_category - The system disk category of master node.")
    ("master_disk_size" "master_disk_size - The system disk size of master node.")
    ("worker_disk_category" "worker_disk_category - The system disk category of worker node.")
    ("worker_disk_size" "worker_disk_size - The system disk size of worker node.")
    ("nodes" "nodes - List of cluster nodes. It contains several attributes to Block Nodes.")
    ("connections" "connections - Map of kubernetes cluster connection information. It contains several attributes to Block Connections.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_cms_alarm" '(
    ("id" "id - The ID of the alarm rule.")
    ("name" "name - The alarm name.")
    ("project" "project - Monitor project name.")
    ("metric" "metric - Name of the monitoring metrics.")
    ("dimensions" "dimensions - Map of the resources associated with the alarm rule.")
    ("period" "period - Index query cycle.")
    ("statistics" "statistics - Statistical method.")
    ("operator" "operator - Alarm comparison operator.")
    ("threshold" "threshold - Alarm threshold value.")
    ("triggered_count" "triggered_count - Number of trigger alarm.")
    ("contact_groups" "contact_groups - List contact groups of the alarm rule.")
    ("start_time" "start_time - Start time of the alarm effective period.")
    ("end_time" "end_time - End time of the alarm effective period.")
    ("silence_time" "silence_time - Notification silence period in the alarm state.")
    ("notify_type" "notify_type - Notification type.")
    ("enabled" "enabled - Whether to enable alarm rule.")
    ("status" "status - The current alarm rule status.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_dns" '(
    ("id" "id - The domain id.")
    ("name" "name - The domain name.")
    ("group_id" "group_id - The group id of domain.")
    ("dns_server" "dns_server - A list of the dns server name.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_dns_group" '(
    ("id" "id - The group id.")
    ("name" "name - The group name.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_dns_record" '(
    ("id" "id - The record id.")
    ("name" "name - (Required) The record domain name.")
    ("type" "type - (Required) The record type.")
    ("host_record" "host_record - The host record of record.")
    ("value" "value - The record value.")
    ("ttl" "ttl - The record effective time.")
    ("priority" "priority - The record priority.")
    ("routing" "routing - The record parsing line.")
    ("status" "status - The record status. Enable or Disable.")
    ("Locked" "Locked - The record locked state. true or false.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_access_key" '(
    ("id" "id - The access key ID.")
    ("status" "status - The access key status.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_account_alias" '(
    ("account_alias" "account_alias - The account alias.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_alias" '(

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_group" '(
    ("id" "id - The group ID.")
    ("name" "name - The group name.")
    ("comments" "comments - The group comments.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_group_membership" '(
    ("id" "id - The membership ID.")
    ("group_name" "group_name - The group name.")
    ("user_names" "user_names - The list of names of users which in the group.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_group_policy_attachment" '(
    ("id" "id - The attachment ID.")
    ("group_name" "group_name - The group name.")
    ("policy_name" "policy_name - The policy name.")
    ("policy_type" "policy_type - The policy type.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_login_profile" '(
    ("id" "id - The login profile ID.")
    ("user_name" "user_name - The user name.")
    ("mfa_bind_required" "mfa_bind_required - The parameter which indicates whether the MFA needs to be bind when the user first logs in.")
    ("password_reset_required" "password_reset_required - The parameter which indicates whether the password needs to be reset when the user first logs in.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_policy" '(
    ("id" "id - The policy ID.")
    ("name" "name - The policy name.")
    ("type" "type - The policy type.")
    ("description" "description - The policy description.")
    ("statement" "statement - List of statement of the policy document.")
    ("document" "document - The policy document.")
    ("version" "version - The policy document version.")
    ("attachment_count" "attachment_count - The policy attachment count.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_role" '(
    ("id" "id - The role ID.")
    ("name" "name - The role name.")
    ("arn" "arn - The role arn.")
    ("description" "description - The role description.")
    ("version" "version - The role policy document version.")
    ("document" "document - Authorization strategy of the role.")
    ("ram_users" "ram_users - List of services which can assume the RAM role.")
    ("services" "services - List of services which can assume the RAM role.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_role_policy_attachment" '(
    ("id" "id - The attachment ID.")
    ("role_name" "role_name - The role name.")
    ("policy_name" "policy_name - The policy name.")
    ("policy_type" "policy_type - The policy type.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_user" '(
    ("id" "id - The user ID.")
    ("name" "name - The user name.")
    ("display_name" "display_name - The user display name.")
    ("mobile" "mobile - The user phone number.")
    ("email" "email - The user email.")
    ("comments" "comments - The user comments.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_user_policy_attachment" '(
    ("id" "id - The attachment ID.")
    ("user_name" "user_name - The user name.")
    ("policy_name" "policy_name - The policy name.")
    ("policy_type" "policy_type - The policy type.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ram_role_attachment" '(
    ("role_name" "role_name - The name of the role.")
    ("instance_ids" "instance_ids The list of ECS instance's IDs.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_cdn_domain" '(
    ("domain_name" "domain_name - The accelerated domain name.")
    ("sources" "sources - The accelerated domain sources.")
    ("cdn_type" "cdn_type - The cdn type of the accelerated domain.")
    ("source_type" "source_type - The source type ot the accelerated domain.")
    ("scope" "scope - The accelerated domain scope.")
    ("optimize_enable" "optimize_enable - The page optimize config of the accelerated domain.")
    ("page_compress_enable" "page_compress_enable - The page compress config of the accelerated domain.")
    ("range_enable" "range_enable - The range source config of the accelerated domain.")
    ("video_seek_enable" "video_seek_enable - The video seek config of the accelerated domain.")
    ("parameter_filter_config" "parameter_filter_config - The parameter filter config of the accelerated domain.")
    ("page_404_config" "page_404_config - The error page config of the accelerated domain.")
    ("refer_config" "refer_config - The refer config of the accelerated domain.")
    ("auth_config" "auth_config - The auth config of the accelerated domain.")
    ("http_header_config" "http_header_config - The http header configs of the accelerated domain.")
    ("cache_config" "cache_config - The cache configs of the accelerated domain.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_kms_key" '(
    ("id" "id - The ID of the key.")
    ("arn" "arn - The Alicloud Resource Name (ARN) of the key.")
    ("description" "description - The description of the key.")
    ("key_usage" "key_usage - Specifies the usage of CMK.")
    ("deletion_window_in_days" "deletion_window_in_days - During pre-deletion days.")
    ("is_enabled" "is_enabled - Whether the key is enabled.")

  ) company-terraform-resource-attributes-hash)

(puthash "alicloud_ots_table" '(
    ("table_name" "table_name - The table name of the OTS which could not be changed.")
    ("primary_key" "primary_key - The property of TableMeta which indicates the structure information of a table.")
    ("time_to_live" "time_to_live - The retention time of data stored in this table.")
    ("max_version" "max_version - The maximum number of versions stored in this table.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_acm_certificate" '(
    ("id" "id - The ARN of the certificate")
    ("arn" "arn - The ARN of the certificate")
    ("domain_validation_options" "domain_validation_options - A list of attributes to feed into other resources to complete certificate validation. Can have more than one element, e.g. if SANs are defined. Only set if DNS-validation was used.")
    ("validation_emails" "validation_emails - A list of addresses that received a validation E-Mail. Only set if EMAIL-validation was used.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_acm_certificate_validation" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_acmpca_certificate_authority" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_account" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_api_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_authorizer" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_base_path_mapping" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_client_certificate" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_deployment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_documentation_part" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_documentation_version" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_domain_name" '(
    ("id" "id - The internal id assigned to this domain name by API Gateway.")
    ("certificate_upload_date" "certificate_upload_date - The upload date associated with the domain certificate.")
    ("cloudfront_domain_name" "cloudfront_domain_name - The hostname created by Cloudfront to represent the distribution that implements this domain name mapping.")
    ("cloudfront_zone_id" "cloudfront_zone_id - For convenience, the hosted zone id (Z2FDTNDATAQYW2) that can be used to create a Route53 alias record for the distribution.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_gateway_response" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_integration" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_integration_response" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_method" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_method_response" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_method_settings" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_model" '(
    ("id" "id - The ID of the model")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_resource" '(
    ("id" "id - The resource's identifier.")
    ("path" "path - The complete path for this API resource, including all parent paths.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_rest_api" '(
    ("id" "id - The ID of the REST API")
    ("root_resource_id" "root_resource_id - The resource ID of the REST API's root")
    ("created_date" "created_date - The creation date of the REST API")
    ("execution_arn" "execution_arn - The execution ARN part to be used in lambda_permission's source_arn when allowing API Gateway to invoke a Lambda function, e.g. arn:aws:execute-api:eu-west-2:123456789012:z4675bid1j, which can be concatenated with allowed stage, method and resource path.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_stage" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_usage_plan" '(
    ("id" "id - The ID of the API resource")
    ("name" "name - The name of the usage plan.")
    ("description" "description - The description of a usage plan.")
    ("api_stages" "api_stages - The associated API stages of the usage plan.")
    ("quota_settings" "quota_settings - The quota of the usage plan.")
    ("throttle_settings" "throttle_settings - The throttling limits of the usage plan.")
    ("product_code" "product_code - The AWS Markeplace product identifier to associate with the usage plan as a SaaS product on AWS Marketplace.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_usage_plan_key" '(
    ("id" "id - The Id of a usage plan key.")
    ("key_id" "key_id - The identifier of the API gateway key resource.")
    ("key_type" "key_type - The type of a usage plan key. Currently, the valid key type is API_KEY.")
    ("usage_plan_id" "usage_plan_id - The ID of the API resource")
    ("name" "name - The name of a usage plan key.")
    ("value" "value - The value of a usage plan key.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_api_gateway_vpc_link" '(
    ("id" "id - The identifier of the VpcLink.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_appautoscaling_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_appautoscaling_scheduled_action" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the scheduled action.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_appautoscaling_target" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_appsync_datasource" '(
    ("arn" "arn - The ARN")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_appsync_graphql_api" '(
    ("id" "id - API ID")
    ("arn" "arn - The ARN")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_athena_database" '(
    ("id" "id - The database name")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_athena_named_query" '(
    ("id" "id - The unique ID of the query.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_batch_compute_environment" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the compute environment.")
    ("ecs_cluster_arn" "ecs_cluster_arn - The Amazon Resource Name (ARN) of the underlying Amazon ECS cluster used by the compute environment.")
    ("status" "status - The current status of the compute environment (for example, CREATING or VALID).")
    ("status_reason" "status_reason - A short, human-readable string to provide additional details about the current status of the compute environment.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_batch_job_definition" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_batch_job_queue" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloud9_environment_ec2" '(
    ("id" "id - The ID of the environment.")
    ("arn" "arn - The ARN of the environment.")
    ("type" "type - The type of the environment (e.g. ssh or ec2)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_budgets_budget" '(
    ("id" "id - id of resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudformation_stack" '(
    ("id" "id - A unique identifier of the stack.")
    ("outputs" "outputs - A map of outputs from the stack.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudfront_distribution" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudfront_origin_access_identity" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudtrail" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_dashboard" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_event_permission" '(
    ("id" "id - The statement ID of the CloudWatch Events permission.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_event_rule" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_event_target" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_destination" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the log destination.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_destination_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_group" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the log group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_metric_filter" '(
    ("id" "id - The name of the metric filter.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_resource_policy" '(
    ("id" "id - The name of the CloudWatch log resource policy")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_stream" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the log stream.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_log_subscription_filter" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cloudwatch_metric_alarm" '(
    ("id" "id - The ID of the health check")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codebuild_project" '(
    ("id" "id - The ARN of the CodeBuild project.")
    ("description" "description - A short description of the project.")
    ("encryption_key" "encryption_key - The AWS Key Management Service (AWS KMS) customer master key (CMK) that was used for encrypting the build project's build output artifacts.")
    ("name" "name - The projects name.")
    ("service_role" "service_role - The ARN of the IAM service role.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codecommit_repository" '(
    ("repository_id" "repository_id - The ID of the repository")
    ("arn" "arn - The ARN of the repository")
    ("clone_url_http" "clone_url_http - The URL to use for cloning the repository over HTTPS.")
    ("clone_url_ssh" "clone_url_ssh - The URL to use for cloning the repository over SSH.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codecommit_trigger" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codedeploy_app" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codedeploy_deployment_config" '(
    ("id" "id - The deployment group's config name.")
    ("deployment_config_id" "deployment_config_id - The AWS Assigned deployment config id")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codedeploy_deployment_group" '(
    ("id" "id - The deployment group's ID.")
    ("app_name" "app_name - The group's assigned application.")
    ("deployment_group_name" "deployment_group_name - The group's name.")
    ("service_role_arn" "service_role_arn - The group's service role ARN.")
    ("autoscaling_groups" "autoscaling_groups - The autoscaling groups associated with the deployment group.")
    ("deployment_config_name" "deployment_config_name - The name of the group's deployment config.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_codepipeline" '(
    ("id" "id - The codepipeline ID.")
    ("arn" "arn - The codepipeline ARN.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cognito_identity_pool" '(
    ("id" "id - An identity pool ID in the format REGION:GUID.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cognito_identity_pool_roles_attachment" '(
    ("id" "id - The identity pool ID.")
    ("identity_pool_id" "identity_pool_id (Required) - An identity pool ID in the format REGION:GUID.")
    ("role_mapping" "role_mapping (Optional) - The List of Role Mapping.")
    ("roles" "roles (Required) - The map of roles associated with this pool. For a given role, the key will be either \"authenticated\" or \"unauthenticated\" and the value will be the Role ARN.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cognito_user_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cognito_user_pool" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cognito_user_pool_client" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_cognito_user_pool_domain" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_config_config_rule" '(
    ("arn" "arn - The ARN of the config rule")
    ("rule_id" "rule_id - The ID of the config rule")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_config_configuration_recorder" '(
    ("id" "id - Name of the recorder")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_config_configuration_recorder_status" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_config_delivery_channel" '(
    ("id" "id - The name of the delivery channel.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dms_certificate" '(
    ("certificate_arn" "certificate_arn - The Amazon Resource Name (ARN) for the certificate.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dms_endpoint" '(
    ("endpoint_arn" "endpoint_arn - The Amazon Resource Name (ARN) for the endpoint.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dms_replication_instance" '(
    ("replication_instance_arn" "replication_instance_arn - The Amazon Resource Name (ARN) of the replication instance.")
    ("replication_instance_private_ips" "replication_instance_private_ips -  A list of the private IP addresses of the replication instance.")
    ("replication_instance_public_ips" "replication_instance_public_ips - A list of the public IP addresses of the replication instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dms_replication_subnet_group" '(
    ("vpc_id" "vpc_id - The ID of the VPC the subnet group is in.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dms_replication_task" '(
    ("replication_task_arn" "replication_task_arn - The Amazon Resource Name (ARN) for the replication task.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_devicefarm_project" '(
    ("arn" "arn - The Amazon Resource Name of this project")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_directory_service_directory" '(
    ("id" "id - The directory identifier.")
    ("access_url" "access_url - The access URL for the directory, such as http://alias.awsapps.com.")
    ("dns_ip_addresses" "dns_ip_addresses - A list of IP addresses of the DNS servers for the directory or connector.")
    ("security_group_id" "security_group_id - The ID of the security group created by the directory (SimpleAD or MicrosoftAD only).")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_directory_service_conditional_forwarder" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dx_connection" '(
    ("id" "id - The ID of the connection.")
    ("arn" "arn - The ARN of the connection.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dx_connection_association" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dx_lag" '(
    ("id" "id - The ID of the LAG.")
    ("arn" "arn - The ARN of the LAG.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dynamodb_global_table" '(
    ("id" "id - The name of the DynamoDB Global Table")
    ("arn" "arn - The ARN of the DynamoDB Global Table")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dynamodb_table" '(
    ("arn" "arn - The arn of the table")
    ("id" "id - The name of the table")
    ("stream_arn" "stream_arn - The ARN of the Table Stream. Only available when stream_enabled = true")
    ("stream_label" "stream_label - A timestamp, in ISO 8601 format, for this stream. Note that this timestamp is not a unique identifier for the stream on its own. However, the combination of AWS customer ID, table name and this field is guaranteed to be unique. It can be used for creating CloudWatch Alarms. Only available when stream_enabled = true")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dynamodb_table_item" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dax_cluster" '(
    ("arn" "arn - The ARN of the DAX cluster")
    ("nodes" "nodes - List of node objects including id, address, port and availability_zone. Referenceable e.g. as ${aws_dax_cluster.test.nodes.0.address}")
    ("configuration_endpoint" "configuration_endpoint - The configuration endpoint for this DAX cluster, consisting of a DNS name and a port number")
    ("cluster_address" "cluster_address - The DNS name of the DAX cluster without the port appended")
    ("port" "port - The port used by the configuration endpoint")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dax_parameter_group" '(
    ("id" "id - The name of the parameter group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_dax_subnet_group" '(
    ("id" "id - The name of the subnet group.")
    ("vpc_id" "vpc_id – VPC ID of the subnet group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_alb" '(
    ("id" "id - The ARN of the load balancer (matches arn).")
    ("arn" "arn - The ARN of the load balancer (matches id).")
    ("arn_suffix" "arn_suffix - The ARN suffix for use with CloudWatch Metrics.")
    ("dns_name" "dns_name - The DNS name of the load balancer.")
    ("canonical_hosted_zone_id" "canonical_hosted_zone_id - The canonical hosted zone ID of the load balancer.")
    ("zone_id" "zone_id - The canonical hosted zone ID of the load balancer (to be used in a Route 53 Alias record).")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_alb_listener" '(
    ("id" "id - The ARN of the listener (matches arn)")
    ("arn" "arn - The ARN of the listener (matches id)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_alb_listener_certificate" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_alb_listener_rule" '(
    ("id" "id - The ARN of the rule (matches arn)")
    ("arn" "arn - The ARN of the rule (matches id)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_alb_target_group" '(
    ("id" "id - The ARN of the Target Group (matches arn)")
    ("arn" "arn - The ARN of the Target Group (matches id)")
    ("arn_suffix" "arn_suffix - The ARN suffix for use with CloudWatch Metrics.")
    ("name" "name - The name of the Target Group")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_alb_target_group_attachment" '(
    ("id" "id - A unique identifier for the attachment")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ami" '(
    ("id" "id - The ID of the created AMI.")
    ("root_snapshot_id" "root_snapshot_id - The Snapshot ID for the root volume (for EBS-backed AMIs)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ami_copy" '(
    ("id" "id - The ID of the created AMI.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ami_from_instance" '(
    ("id" "id - The ID of the created AMI.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ami_launch_permission" '(
    ("id" "id - A combination of \"image_id-account_id\".")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_app_cookie_stickiness_policy" '(
    ("id" "id - The ID of the policy.")
    ("name" "name - The name of the stickiness policy.")
    ("load_balancer" "load_balancer - The name of load balancer to which the policy is attached.")
    ("lb_port" "lb_port - The load balancer port to which the policy is applied.")
    ("cookie_name" "cookie_name - The application cookie whose lifetime the ELB's cookie should follow.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_autoscaling_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_autoscaling_group" '(
    ("id" "id - The autoscaling group id.")
    ("arn" "arn - The ARN for this AutoScaling Group")
    ("availability_zones" "availability_zones - The availability zones of the autoscale group.")
    ("min_size" "min_size - The minimum size of the autoscale group")
    ("max_size" "max_size - The maximum size of the autoscale group")
    ("default_cooldown" "default_cooldown - Time between a scaling activity and the succeeding scaling activity.")
    ("name" "name - The name of the autoscale group")
    ("health_check_grace_period" "health_check_grace_period - Time after instance comes into service before checking health.")
    ("health_check_type" "health_check_type - \"EC2\" or \"ELB\". Controls how health checking is done.")
    ("desired_capacity" "desired_capacity -The number of Amazon EC2 instances that should be running in the group.")
    ("launch_configuration" "launch_configuration - The launch configuration of the autoscale group")
    ("vpc_zone_identifier" "vpc_zone_identifier (Optional) - The VPC zone identifier")
    ("load_balancers" "load_balancers (Optional) The load balancer names associated with the autoscaling group.")
    ("target_group_arns" "target_group_arns (Optional) list of Target Group ARNs that apply to this AutoScaling Group")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_autoscaling_lifecycle_hook" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_autoscaling_notification" '(
    ("group_names" "group_names")
    ("notifications" "notifications")
    ("topic_arn" "topic_arn")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_autoscaling_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_autoscaling_schedule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_snapshot_create_volume_permission" '(
    ("id" "id - A combination of \"snapshot_id-account_id\".")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ebs_snapshot" '(
    ("id" "id - The snapshot ID (e.g. snap-59fcb34e).")
    ("owner_id" "owner_id - The AWS account ID of the EBS snapshot owner.")
    ("owner_alias" "owner_alias - Value from an Amazon-maintained list (amazon, aws-marketplace, microsoft) of snapshot owners.")
    ("encrypted" "encrypted - Whether the snapshot is encrypted.")
    ("volume_size" "volume_size - The size of the drive in GiBs.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("data_encryption_key_id" "data_encryption_key_id - The data encryption key identifier for the snapshot.")
    ("tags" "tags - A mapping of tags for the snapshot.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ebs_volume" '(
    ("id" "id - The volume ID (e.g. vol-59fcb34e).")
    ("arn" "arn - The volume ARN (e.g. arn:aws:ec2:us-east-1:0123456789012:volume/vol-59fcb34e).")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_eip" '(
    ("id" "id - Contains the EIP allocation ID.")
    ("private_ip" "private_ip - Contains the private IP address (if in VPC).")
    ("associate_with_private_ip" "associate_with_private_ip - Contains the user specified private IP address (if in VPC).")
    ("public_ip" "public_ip - Contains the public IP address.")
    ("instance" "instance - Contains the ID of the attached instance.")
    ("network_interface" "network_interface - Contains the ID of the attached network interface.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_eip_association" '(
    ("association_id" "association_id - The ID that represents the association of the Elastic IP address with an instance.")
    ("allocation_id" "allocation_id - As above")
    ("instance_id" "instance_id - As above")
    ("network_interface_id" "network_interface_id - As above")
    ("private_ip_address" "private_ip_address - As above")
    ("public_ip" "public_ip - As above")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elb" '(
    ("id" "id - The name of the ELB")
    ("arn" "arn - The ARN of the ELB")
    ("name" "name - The name of the ELB")
    ("dns_name" "dns_name - The DNS name of the ELB")
    ("instances" "instances - The list of instances in the ELB")
    ("source_security_group" "source_security_group - The name of the security group that you can use as part of your inbound rules for your load balancer's back-end application instances. Use this for Classic or Default VPC only.")
    ("source_security_group_id" "source_security_group_id - The ID of the security group that you can use as part of your inbound rules for your load balancer's back-end application instances. Only available on ELBs launched in a VPC.")
    ("zone_id" "zone_id - The canonical hosted zone ID of the ELB (to be used in a Route 53 Alias record)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elb_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_instance" '(
    ("id" "id - The instance ID.")
    ("availability_zone" "availability_zone - The availability zone of the instance.")
    ("placement_group" "placement_group - The placement group of the instance.")
    ("key_name" "key_name - The key name of the instance")
    ("password_data" "password_data - Base-64 encoded encrypted password data for the instance. Useful for getting the administrator password for instances running Microsoft Windows. This attribute is only exported if get_password_data is true. Note that this encrypted value will be stored in the state file, as with all exported attributes. See GetPasswordData for more information.")
    ("public_dns" "public_dns - The public DNS name assigned to the instance. For EC2-VPC, this is only available if you've enabled DNS hostnames for your VPC")
    ("public_ip" "public_ip - The public IP address assigned to the instance, if applicable. NOTE: If you are using an aws_eip with your instance, you should refer to the EIP's address directly and not use public_ip, as this field will change after the EIP is attached.")
    ("ipv6_addresses" "ipv6_addresses - A list of assigned IPv6 addresses, if any")
    ("network_interface_id" "network_interface_id - The ID of the network interface that was created with the instance.")
    ("primary_network_interface_id" "primary_network_interface_id - The ID of the instance's primary network interface.")
    ("private_dns" "private_dns - The private DNS name assigned to the instance. Can only be used inside the Amazon EC2, and only available if you've enabled DNS hostnames for your VPC")
    ("private_ip" "private_ip - The private IP address assigned to the instance")
    ("security_groups" "security_groups - The associated security groups.")
    ("vpc_security_group_ids" "vpc_security_group_ids - The associated security groups in non-default VPC")
    ("subnet_id" "subnet_id - The VPC subnet ID.")
    ("credit_specification" "credit_specification - Credit specification of instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_key_pair" '(
    ("key_name" "key_name - The key pair name.")
    ("fingerprint" "fingerprint - The MD5 public key fingerprint as specified in section 4 of RFC 4716.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_launch_configuration" '(
    ("id" "id - The ID of the launch configuration.")
    ("name" "name - The name of the launch configuration.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_launch_template" '(
    ("id" "id - The ID of the launch template.")
    ("default_version" "default_version - The default version of the launch template.")
    ("latest_version" "latest_version - The latest version of the launch template.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_cookie_stickiness_policy" '(
    ("id" "id - The ID of the policy.")
    ("name" "name - The name of the stickiness policy.")
    ("load_balancer" "load_balancer - The load balancer to which the policy is attached.")
    ("lb_port" "lb_port - The load balancer port to which the policy is applied.")
    ("cookie_expiration_period" "cookie_expiration_period - The time period after which the session cookie is considered stale, expressed in seconds.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_ssl_negotiation_policy" '(
    ("id" "id - The ID of the policy.")
    ("name" "name - The name of the stickiness policy.")
    ("load_balancer" "load_balancer - The load balancer to which the policy is attached.")
    ("lb_port" "lb_port - The load balancer port to which the policy is applied.")
    ("attribute" "attribute - The SSL Negotiation policy attributes.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_load_balancer_backend_server_policy" '(
    ("id" "id - The ID of the policy.")
    ("load_balancer_name" "load_balancer_name - The load balancer on which the policy is defined.")
    ("instance_port" "instance_port - The backend port the policies are applied to")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_load_balancer_listener_policy" '(
    ("id" "id - The ID of the policy.")
    ("load_balancer_name" "load_balancer_name - The load balancer on which the policy is defined.")
    ("load_balancer_port" "load_balancer_port - The load balancer listener port the policies are applied to")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_load_balancer_policy" '(
    ("id" "id - The ID of the policy.")
    ("policy_name" "policy_name - The name of the stickiness policy.")
    ("policy_type_name" "policy_type_name - The policy type of the policy.")
    ("load_balancer_name" "load_balancer_name - The load balancer on which the policy is defined.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_placement_group" '(
    ("id" "id - The name of the placement group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_proxy_protocol_policy" '(
    ("id" "id - The ID of the policy.")
    ("load_balancer" "load_balancer - The load balancer to which the policy is attached.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_spot_datafeed_subscription" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_spot_fleet_request" '(
    ("id" "id - The Spot fleet request ID")
    ("spot_request_state" "spot_request_state - The state of the Spot fleet request.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_spot_instance_request" '(
    ("id" "id - The Spot Instance Request ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_volume_attachment" '(
    ("device_name" "device_name - The device name exposed to the instance")
    ("instance_id" "instance_id - ID of the Instance")
    ("volume_id" "volume_id - ID of the Volume")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb" '(
    ("id" "id - The ARN of the load balancer (matches arn).")
    ("arn" "arn - The ARN of the load balancer (matches id).")
    ("arn_suffix" "arn_suffix - The ARN suffix for use with CloudWatch Metrics.")
    ("dns_name" "dns_name - The DNS name of the load balancer.")
    ("canonical_hosted_zone_id" "canonical_hosted_zone_id - The canonical hosted zone ID of the load balancer.")
    ("zone_id" "zone_id - The canonical hosted zone ID of the load balancer (to be used in a Route 53 Alias record).")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_listener" '(
    ("id" "id - The ARN of the listener (matches arn)")
    ("arn" "arn - The ARN of the listener (matches id)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_listener_certificate" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_listener_rule" '(
    ("id" "id - The ARN of the rule (matches arn)")
    ("arn" "arn - The ARN of the rule (matches id)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_target_group" '(
    ("id" "id - The ARN of the Target Group (matches arn)")
    ("arn" "arn - The ARN of the Target Group (matches id)")
    ("arn_suffix" "arn_suffix - The ARN suffix for use with CloudWatch Metrics.")
    ("name" "name - The name of the Target Group")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lb_target_group_attachment" '(
    ("id" "id - A unique identifier for the attachment")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ecr_lifecycle_policy" '(
    ("repository" "repository - The name of the repository.")
    ("registry_id" "registry_id - The registry ID where the repository was created.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ecr_repository" '(
    ("arn" "arn - Full ARN of the repository.")
    ("name" "name - The name of the repository.")
    ("registry_id" "registry_id - The registry ID where the repository was created.")
    ("repository_url" "repository_url - The URL of the repository (in the form aws_account_id.dkr.ecr.region.amazonaws.com/repositoryName")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ecr_repository_policy" '(
    ("repository" "repository - The name of the repository.")
    ("registry_id" "registry_id - The registry ID where the repository was created.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ecs_cluster" '(
    ("id" "id - The Amazon Resource Name (ARN) that identifies the cluster")
    ("arn" "arn - The Amazon Resource Name (ARN) that identifies the cluster")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ecs_service" '(
    ("id" "id - The Amazon Resource Name (ARN) that identifies the service")
    ("name" "name - The name of the service")
    ("cluster" "cluster - The Amazon Resource Name (ARN) of cluster which the service runs on")
    ("iam_role" "iam_role - The ARN of IAM role used for ELB")
    ("desired_count" "desired_count - The number of instances of the task definition")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ecs_task_definition" '(
    ("arn" "arn - Full ARN of the Task Definition (including both family and revision).")
    ("family" "family - The family of the Task Definition.")
    ("revision" "revision - The revision of the task in a particular family.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_efs_file_system" '(
    ("id" "id - The ID that identifies the file system (e.g. fs-ccfc0d65).")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("dns_name" "dns_name - The DNS name for the filesystem per documented convention.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_efs_mount_target" '(
    ("id" "id - The ID of the mount target.")
    ("dns_name" "dns_name - The DNS name for the given subnet/AZ per documented convention.")
    ("network_interface_id" "network_interface_id - The ID of the network interface that Amazon EFS created when it created the mount target.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticache_cluster" '(
    ("cache_nodes" "cache_nodes - List of node objects including id, address, port and availability_zone. Referenceable e.g. as ${aws_elasticache_cluster.bar.cache_nodes.0.address}")
    ("configuration_endpoint" "configuration_endpoint - (Memcached only) The configuration endpoint to allow host discovery.")
    ("cluster_address" "cluster_address - (Memcached only) The DNS name of the cache cluster without the port appended.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticache_parameter_group" '(
    ("id" "id - The ElastiCache parameter group name.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticache_replication_group" '(
    ("id" "id - The ID of the ElastiCache Replication Group.")
    ("configuration_endpoint_address" "configuration_endpoint_address - The address of the replication group configuration endpoint when cluster mode is enabled.")
    ("primary_endpoint_address" "primary_endpoint_address - (Redis only) The address of the endpoint for the primary node in the replication group, if the cluster mode is disabled.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticache_security_group" '(
    ("description" "description")
    ("name" "name")
    ("security_group_names" "security_group_names")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticache_subnet_group" '(
    ("description" "description")
    ("name" "name")
    ("subnet_ids" "subnet_ids")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elastic_beanstalk_application" '(
    ("name" "name")
    ("description" "description")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elastic_beanstalk_application_version" '(
    ("name" "name - The Application Version name.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elastic_beanstalk_configuration_template" '(
    ("name" "name")
    ("application" "application")
    ("description" "description")
    ("environment_id" "environment_id")
    ("option_settings" "option_settings")
    ("solution_stack_name" "solution_stack_name")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elastic_beanstalk_environment" '(
    ("id" "id - ID of the Elastic Beanstalk Environment.")
    ("name" "name - Name of the Elastic Beanstalk Environment.")
    ("description" "description - Description of the Elastic Beanstalk Environment.")
    ("tier" "tier - The environment tier specified.")
    ("application" "application – The Elastic Beanstalk Application specified for this environment.")
    ("setting" "setting – Settings specifically set for this Environment.")
    ("all_settings" "all_settings – List of all option settings configured in the Environment. These are a combination of default settings and their overrides from setting in the configuration.")
    ("cname" "cname - Fully qualified DNS name for the Environment.")
    ("autoscaling_groups" "autoscaling_groups - The autoscaling groups used by this environment.")
    ("instances" "instances - Instances used by this environment.")
    ("launch_configurations" "launch_configurations - Launch configurations in use by this environment.")
    ("load_balancers" "load_balancers - Elastic load balancers in use by this environment.")
    ("queues" "queues - SQS queues in use by this environment.")
    ("triggers" "triggers - Autoscaling triggers in use by this environment.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_emr_cluster" '(
    ("id" "id - The ID of the EMR Cluster")
    ("name" "name - The name of the cluster.")
    ("release_label" "release_label - The release label for the Amazon EMR release.")
    ("master_instance_type" "master_instance_type - The EC2 instance type of the master node.")
    ("master_public_dns" "master_public_dns - The public DNS name of the master EC2 instance.")
    ("core_instance_type" "core_instance_type - The EC2 instance type of the slave nodes.")
    ("core_instance_count" "core_instance_count The number of slave nodes, i.e. EC2 instance nodes.")
    ("log_uri" "log_uri - The path to the Amazon S3 location where logs for this cluster are stored.")
    ("applications" "applications - The applications installed on this cluster.")
    ("ec2_attributes" "ec2_attributes - Provides information about the EC2 instances in a cluster grouped by category: key name, subnet ID, IAM instance profile, and so on.")
    ("bootstrap_action" "bootstrap_action - A list of bootstrap actions that will be run before Hadoop is started on the cluster nodes.")
    ("configurations" "configurations - The list of Configurations supplied to the EMR cluster.")
    ("service_role" "service_role - The IAM role that will be assumed by the Amazon EMR service to access AWS resources on your behalf.")
    ("visible_to_all_users" "visible_to_all_users - Indicates whether the job flow is visible to all IAM users of the AWS account associated with the job flow.")
    ("tags" "tags - The list of tags associated with a cluster.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_emr_instance_group" '(
    ("id" "id - The EMR Instance ID")
    ("running_instance_count" "running_instance_count The number of instances currently running in this instance group.")
    ("status" "status The current status of the instance group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_emr_security_configuration" '(
    ("id" "id - The ID of the EMR Security Configuration (Same as the name)")
    ("name" "name - The Name of the EMR Security Configuration")
    ("configuration" "configuration - The JSON formatted Security Configuration")
    ("creation_date" "creation_date - Date the Security Configuration was created")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticsearch_domain" '(
    ("arn" "arn - Amazon Resource Name (ARN) of the domain.")
    ("domain_id" "domain_id - Unique identifier for the domain.")
    ("endpoint" "endpoint - Domain-specific endpoint used to submit index, search, and data upload requests.")
    ("kibana_endpoint" "kibana_endpoint - Domain-specific endpoint for kibana without https scheme.")
    ("vpc_options.0.availability_zones" "vpc_options.0.availability_zones - If the domain was created inside a VPC, the names of the availability zones the configured subnet_ids were created inside.")
    ("vpc_options.0.vpc_id" "vpc_options.0.vpc_id - If the domain was created inside a VPC, the ID of the VPC.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elasticsearch_domain_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elastictranscoder_pipeline" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_elastictranscoder_preset" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_gamelift_alias" '(
    ("id" "id - Alias ID.")
    ("arn" "arn - Alias ARN.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_gamelift_build" '(
    ("id" "id - Build ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_gamelift_fleet" '(
    ("id" "id - Fleet ID.")
    ("arn" "arn - Fleet ARN.")
    ("operating_system" "operating_system - Operating system of the fleet's computing resources.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_glacier_vault" '(
    ("location" "location - The URI of the vault that was created.")
    ("arn" "arn - The ARN of the vault.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_glue_catalog_database" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_glue_catalog_table" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_glue_connection" '(
    ("id" "id - Catalog ID and name of the connection")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_glue_job" '(
    ("id" "id - Job name")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_guardduty_detector" '(
    ("id" "id - The ID of the GuardDuty detector")
    ("account_id" "account_id - The AWS account ID of the GuardDuty detector")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_guardduty_ipset" '(
    ("id" "id - The ID of the GuardDuty IPSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_guardduty_member" '(
    ("id" "id - The ID of the GuardDuty member")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_guardduty_threatintelset" '(
    ("id" "id - The ID of the GuardDuty ThreatIntelSet and the detector ID. Format: <DetectorID>:<ThreatIntelSetID>")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_access_key" '(
    ("id" "id - The access key ID.")
    ("user" "user - The IAM user associated with this access key.")
    ("key_fingerprint" "key_fingerprint - The fingerprint of the PGP key used to encrypt the secret")
    ("secret" "secret - The secret access key. Note that this will be written to the state file. Please supply a pgp_key instead, which will prevent the secret from being stored in plain text")
    ("encrypted_secret" "encrypted_secret - The encrypted secret, base64 encoded. ~> NOTE: The encrypted secret may be decrypted using the command line, for example: terraform output secret | base64 --decode | keybase pgp decrypt.")
    ("ses_smtp_password" "ses_smtp_password - The secret access key converted into an SES SMTP password by applying AWS's documented conversion algorithm.")
    ("status" "status - \"Active\" or \"Inactive\". Keys are initially active, but can be made inactive by other means.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_account_alias" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_account_password_policy" '(
    ("expire_passwords" "expire_passwords - Indicates whether passwords in the account expire. Returns true if max_password_age contains a value greater than 0. Returns false if it is 0 or not present.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_group" '(
    ("id" "id - The group's ID.")
    ("arn" "arn - The ARN assigned by AWS for this group.")
    ("name" "name - The group's name.")
    ("path" "path - The path of the group in IAM.")
    ("unique_id" "unique_id - The unique ID assigned by AWS.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_group_membership" '(
    ("name" "name - The name to identify the Group Membership")
    ("users" "users - list of IAM User names")
    ("group" "group – IAM Group name")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_group_policy" '(
    ("id" "id - The group policy ID.")
    ("group" "group - The group to which this policy applies.")
    ("name" "name - The name of the policy.")
    ("policy" "policy - The policy document attached to the group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_group_policy_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_instance_profile" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_openid_connect_provider" '(
    ("arn" "arn - The ARN assigned by AWS for this provider.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_policy" '(
    ("id" "id - The policy's ID.")
    ("arn" "arn - The ARN assigned by AWS to this policy.")
    ("description" "description - The description of the policy.")
    ("name" "name - The name of the policy.")
    ("path" "path - The path of the policy in IAM.")
    ("policy" "policy - The policy document.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_policy_attachment" '(
    ("id" "id - The policy's ID.")
    ("name" "name - The name of the attachment.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_role" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the role.")
    ("create_date" "create_date - The creation date of the IAM role.")
    ("unique_id" "unique_id - The stable and unique string identifying the role.")
    ("name" "name - The name of the role.")
    ("description" "description - The description of the role.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_role_policy" '(
    ("id" "id - The role policy ID, in the form of role_name:role_policy_name.")
    ("name" "name - The name of the policy.")
    ("policy" "policy - The policy document attached to the role.")
    ("role" "role - The name of the role associated with the policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_role_policy_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_saml_provider" '(
    ("arn" "arn - The ARN assigned by AWS for this provider.")
    ("valid_until" "valid_until - The expiration date and time for the SAML provider in RFC1123 format, e.g. Mon, 02 Jan 2006 15:04:05 MST.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_server_certificate" '(
    ("id" "id - The unique Server Certificate name")
    ("name" "name - The name of the Server Certificate")
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the server certificate.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_service_linked_role" '(
    ("id" "id - The Amazon Resource Name (ARN) of the role.")
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the role.")
    ("create_date" "create_date - The creation date of the IAM role.")
    ("name" "name - The name of the role.")
    ("path" "path - The path of the role.")
    ("unique_id" "unique_id - The stable and unique string identifying the role.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_user" '(
    ("arn" "arn - The ARN assigned by AWS for this user.")
    ("name" "name - The user's name.")
    ("unique_id" "unique_id - The unique ID assigned by AWS.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_user_group_membership" '(
    ("user" "user - The name of the IAM User")
    ("groups" "groups - The list of IAM Groups")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_user_login_profile" '(
    ("key_fingerprint" "key_fingerprint - The fingerprint of the PGP key used to encrypt the password")
    ("encrypted_password" "encrypted_password - The encrypted password, base64 encoded.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_user_policy" '(
    ("id" "id - The user policy ID, in the form of user_name:user_policy_name.")
    ("name" "name - The name of the policy (always set).")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_user_policy_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iam_user_ssh_key" '(
    ("ssh_public_key_id" "ssh_public_key_id - The unique identifier for the SSH public key.")
    ("fingerprint" "fingerprint - The MD5 message digest of the SSH public key.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iot_certificate" '(
    ("arn" "arn - The ARN of the created AWS IoT certificate")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iot_policy" '(
    ("arn" "arn - The ARN assigned by AWS to this policy.")
    ("name" "name - The name of this policy.")
    ("default_version_id" "default_version_id - The default version of this policy.")
    ("policy" "policy - The policy document.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iot_topic_rule" '(
    ("id" "id - The name of the topic rule")
    ("arn" "arn - The ARN of the topic rule")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iot_thing" '(
    ("default_client_id" "default_client_id - The default client ID.")
    ("version" "version - The current version of the thing record in the registry.")
    ("arn" "arn - The ARN of the thing.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_iot_thing_type" '(
    ("arn" "arn - The ARN of the created AWS IoT Thing Type.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_inspector_assessment_target" '(
    ("arn" "arn - The target assessment ARN.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_inspector_assessment_template" '(
    ("arn" "arn - The template assessment ARN.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_inspector_resource_group" '(
    ("arn" "arn - The resource group ARN.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_kinesis_stream" '(
    ("id" "id - The unique Stream id")
    ("name" "name - The unique Stream name")
    ("shard_count" "shard_count - The count of Shards for this Stream")
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the Stream (same as id)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_kinesis_firehose_delivery_stream" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the Stream")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_kms_alias" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the key alias.")
    ("target_key_arn" "target_key_arn - The Amazon Resource Name (ARN) of the target key identifier.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_kms_grant" '(
    ("grant_id" "grant_id - The unique identifier for the grant.")
    ("grant_token" "grant_token - The grant token for the created grant. For more information, see Grant Tokens.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_kms_key" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the key.")
    ("key_id" "key_id - The globally unique identifier for the key.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lambda_alias" '(
    ("arn" "arn - The Amazon Resource Name (ARN) identifying your Lambda function alias.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lambda_event_source_mapping" '(
    ("function_arn" "function_arn - The the ARN of the Lambda function the event source mapping is sending events to. (Note: this is a computed value that differs from function_name above.)")
    ("last_modified" "last_modified - The date this resource was last modified.")
    ("last_processing_result" "last_processing_result - The result of the last AWS Lambda invocation of your Lambda function.")
    ("state" "state - The state of the event source mapping.")
    ("state_transition_reason" "state_transition_reason - The reason the event source mapping is in its current state.")
    ("uuid" "uuid - The UUID of the created event source mapping.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lambda_function" '(
    ("arn" "arn - The Amazon Resource Name (ARN) identifying your Lambda Function.")
    ("qualified_arn" "qualified_arn - The Amazon Resource Name (ARN) identifying your Lambda Function Version (if versioning is enabled via publish = true).")
    ("invoke_arn" "invoke_arn - The ARN to be used for invoking Lambda Function from API Gateway - to be used in aws_api_gateway_integration's uri")
    ("version" "version - Latest published version of your Lambda Function.")
    ("last_modified" "last_modified - The date this resource was last modified.")
    ("kms_key_arn" "kms_key_arn - (Optional) The ARN for the KMS encryption key.")
    ("source_code_hash" "source_code_hash - Base64-encoded representation of raw SHA-256 sum of the zip file, provided either via filename or s3_* parameters.")
    ("source_code_size" "source_code_size - The size in bytes of the function .zip file.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lambda_permission" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lightsail_domain" '(
    ("id" "id - The name used for this domain")
    ("arn" "arn - The ARN of the Lightsail domain")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lightsail_instance" '(
    ("id" "id - The ARN of the Lightsail instance (matches arn).")
    ("arn" "arn - The ARN of the Lightsail instance (matches id).")
    ("availability_zone" "availability_zone")
    ("blueprint_id" "blueprint_id")
    ("bundle_id" "bundle_id")
    ("key_pair_name" "key_pair_name")
    ("user_data" "user_data")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lightsail_key_pair" '(
    ("id" "id - The name used for this key pair")
    ("arn" "arn - The ARN of the Lightsail key pair")
    ("fingerprint" "fingerprint - The MD5 public key fingerprint as specified in section 4 of RFC 4716.")
    ("public_key" "public_key - the public key, base64 encoded")
    ("private_key" "private_key - the private key, base64 encoded. This is only populated when creating a new key, and when no pgp_key is provided")
    ("encrypted_private_key" "encrypted_private_key – the private key material, base 64 encoded and encrypted with the given pgp_key. This is only populated when creating a new key and pgp_key is supplied")
    ("encrypted_fingerprint" "encrypted_fingerprint - The MD5 public key fingerprint for the encrypted private key")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lightsail_static_ip" '(
    ("arn" "arn - The ARN of the Lightsail static IP")
    ("ip_address" "ip_address - The allocated static IP address")
    ("support_code" "support_code - The support code.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_lightsail_static_ip_attachment" '(
    ("arn" "arn - The ARN of the Lightsail static IP")
    ("ip_address" "ip_address - The allocated static IP address")
    ("support_code" "support_code - The support code.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_mq_broker" '(
    ("id" "id - The unique ID that Amazon MQ generates for the broker.")
    ("arn" "arn - The ARN of the broker.")
    ("instances" "instances - A list of information about allocated brokers (both active & standby).   instances.0.console_url - The URL of the broker's ActiveMQ Web Console.  instances.0.endpoints - The broker's wire-level protocol endpoints in the following order & format referenceable e.g. as instances.0.endpoints.0 (SSL):   ssl://broker-id.mq.us-west-2.amazonaws.com:61617  amqp+ssl://broker-id.mq.us-west-2.amazonaws.com:5671  stomp+ssl://broker-id.mq.us-west-2.amazonaws.com:61614  mqtt+ssl://broker-id.mq.us-west-2.amazonaws.com:8883  wss://broker-id.mq.us-west-2.amazonaws.com:61619")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_mq_configuration" '(
    ("id" "id - The unique ID that Amazon MQ generates for the configuration.")
    ("arn" "arn - The ARN of the configuration.")
    ("latest_revision" "latest_revision - The latest revision of the configuration.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_media_store_container" '(
    ("arn" "arn - The ARN of the container.")
    ("endpoint" "endpoint - The DNS endpoint of the container.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_application" '(
    ("id" "id - The id of the application.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_custom_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_ganglia_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_haproxy_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_instance" '(
    ("id" "id - The id of the OpsWorks instance.")
    ("agent_version" "agent_version - The AWS OpsWorks agent version.")
    ("availability_zone" "availability_zone - The availability zone of the instance.")
    ("ec2_instance_id" "ec2_instance_id - EC2 instance ID")
    ("ssh_key_name" "ssh_key_name - The key name of the instance")
    ("public_dns" "public_dns - The public DNS name assigned to the instance. For EC2-VPC, this is only available if you've enabled DNS hostnames for your VPC")
    ("public_ip" "public_ip - The public IP address assigned to the instance, if applicable.")
    ("private_dns" "private_dns - The private DNS name assigned to the instance. Can only be used inside the Amazon EC2, and only available if you've enabled DNS hostnames for your VPC")
    ("private_ip" "private_ip - The private IP address assigned to the instance")
    ("subnet_id" "subnet_id - The VPC subnet ID.")
    ("tenancy" "tenancy - The Instance tenancy")
    ("security_group_ids" "security_group_ids - The associated security groups.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_java_app_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_memcached_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_mysql_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_nodejs_app_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_permission" '(
    ("id" "id - The computed id of the permission. Please note that this is only used internally to identify the permission. This value is not used in aws.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_php_app_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_rails_app_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_rds_db_instance" '(
    ("id" "id - The computed id. Please note that this is only used internally to identify the stack <-> instance relation. This value is not used in aws.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_stack" '(
    ("id" "id - The id of the stack.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_static_web_layer" '(
    ("id" "id - The id of the layer.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_opsworks_user_profile" '(
    ("id" "id - Same value as user_arn")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_organizations_account" '(
    ("arn" "arn - The ARN for this account.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_organizations_organization" '(
    ("arn" "arn - ARN of the organization")
    ("id" "id - Identifier of the organization")
    ("master_account_arn" "master_account_arn - ARN of the master account")
    ("master_account_email" "master_account_email - Email address of the master account")
    ("master_account_id" "master_account_id - Identifier of the master account")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_organizations_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_organizations_policy_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_event_subscription" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_instance" '(
    ("address" "address - The address of the RDS instance.")
    ("arn" "arn - The ARN of the RDS instance.")
    ("allocated_storage" "allocated_storage - The amount of allocated storage.")
    ("availability_zone" "availability_zone - The availability zone of the instance.")
    ("backup_retention_period" "backup_retention_period - The backup retention period.")
    ("backup_window" "backup_window - The backup window.")
    ("ca_cert_identifier" "ca_cert_identifier - Specifies the identifier of the CA certificate for the DB instance.")
    ("endpoint" "endpoint - The connection endpoint.")
    ("engine" "engine - The database engine.")
    ("engine_version" "engine_version - The database engine version.")
    ("hosted_zone_id" "hosted_zone_id - The canonical hosted zone ID of the DB instance (to be used in a Route 53 Alias record).")
    ("id" "id - The RDS instance ID.")
    ("instance_class" "instance_class- The RDS instance class.")
    ("maintenance_window" "maintenance_window - The instance maintenance window.")
    ("multi_az" "multi_az - If the RDS instance is multi AZ enabled.")
    ("name" "name - The database name.")
    ("port" "port - The database port.")
    ("resource_id" "resource_id - The RDS Resource ID of this instance.")
    ("status" "status - The RDS instance status.")
    ("storage_encrypted" "storage_encrypted - Specifies whether the DB instance is encrypted.")
    ("username" "username - The master username for the database.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_option_group" '(
    ("id" "id - The db option group name.")
    ("arn" "arn - The ARN of the db option group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_parameter_group" '(
    ("id" "id - The db parameter group name.")
    ("arn" "arn - The ARN of the db parameter group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_security_group" '(
    ("id" "id - The db security group ID.")
    ("arn" "arn - The arn of the DB security group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_snapshot" '(
    ("allocated_storage" "allocated_storage - Specifies the allocated storage size in gigabytes (GB).")
    ("availability_zone" "availability_zone - Specifies the name of the Availability Zone the DB instance was located in at the time of the DB snapshot.")
    ("db_snapshot_arn" "db_snapshot_arn - The Amazon Resource Name (ARN) for the DB snapshot.")
    ("encrypted" "encrypted - Specifies whether the DB snapshot is encrypted.")
    ("engine" "engine - Specifies the name of the database engine.")
    ("engine_version" "engine_version - Specifies the version of the database engine.")
    ("iops" "iops - Specifies the Provisioned IOPS (I/O operations per second) value of the DB instance at the time of the snapshot.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("license_model" "license_model - License model information for the restored DB instance.")
    ("option_group_name" "option_group_name - Provides the option group name for the DB snapshot.")
    ("source_db_snapshot_identifier" "source_db_snapshot_identifier - The DB snapshot Arn that the DB snapshot was copied from. It only has value in case of cross customer or cross region copy.")
    ("source_region" "source_region - The region that the DB snapshot was created in or copied from.")
    ("status" "status - Specifies the status of this DB snapshot.")
    ("storage_type" "storage_type - Specifies the storage type associated with DB snapshot.")
    ("vpc_id" "vpc_id - Specifies the storage type associated with DB snapshot.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_db_subnet_group" '(
    ("id" "id - The db subnet group name.")
    ("arn" "arn - The ARN of the db subnet group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_rds_cluster" '(
    ("id" "id - The RDS Cluster Identifier")
    ("cluster_identifier" "cluster_identifier - The RDS Cluster Identifier")
    ("cluster_resource_id" "cluster_resource_id - The RDS Cluster Resource ID")
    ("cluster_members" "cluster_members – List of RDS Instances that are a part of this cluster")
    ("allocated_storage" "allocated_storage - The amount of allocated storage")
    ("availability_zones" "availability_zones - The availability zone of the instance")
    ("backup_retention_period" "backup_retention_period - The backup retention period")
    ("preferred_backup_window" "preferred_backup_window - The daily time range during which the backups happen")
    ("preferred_maintenance_window" "preferred_maintenance_window - The maintenance window")
    ("endpoint" "endpoint - The DNS address of the RDS instance")
    ("reader_endpoint" "reader_endpoint - A read-only endpoint for the Aurora cluster, automatically load-balanced across replicas")
    ("engine" "engine - The database engine")
    ("engine_version" "engine_version - The database engine version")
    ("maintenance_window" "maintenance_window - The instance maintenance window")
    ("database_name" "database_name - The database name")
    ("port" "port - The database port")
    ("status" "status - The RDS instance status")
    ("master_username" "master_username - The master username for the database")
    ("storage_encrypted" "storage_encrypted - Specifies whether the DB cluster is encrypted")
    ("replication_source_identifier" "replication_source_identifier - ARN of the source DB cluster or DB instance if this DB cluster is created as a Read Replica.")
    ("hosted_zone_id" "hosted_zone_id - The Route53 Hosted Zone ID of the endpoint")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_rds_cluster_instance" '(
    ("cluster_identifier" "cluster_identifier - The RDS Cluster Identifier")
    ("identifier" "identifier - The Instance identifier")
    ("id" "id - The Instance identifier")
    ("writer" "writer – Boolean indicating if this instance is writable. False indicates this instance is a read replica.")
    ("allocated_storage" "allocated_storage - The amount of allocated storage")
    ("availability_zone" "availability_zone - The availability zone of the instance")
    ("endpoint" "endpoint - The DNS address for this instance. May not be writable")
    ("engine" "engine - The database engine")
    ("engine_version" "engine_version - The database engine version")
    ("database_name" "database_name - The database name")
    ("port" "port - The database port")
    ("status" "status - The RDS instance status")
    ("storage_encrypted" "storage_encrypted - Specifies whether the DB cluster is encrypted.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key if one is set to the cluster.")
    ("dbi_resource_id" "dbi_resource_id - The region-unique, immutable identifier for the DB instance.")
    ("performance_insights_enabled" "performance_insights_enabled - Specifies whether Performance Insights is enabled or not.")
    ("performance_insights_kms_key_id" "performance_insights_kms_key_id - The ARN for the KMS encryption key used by Performance Insights.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_rds_cluster_parameter_group" '(
    ("id" "id - The db cluster parameter group name.")
    ("arn" "arn - The ARN of the db cluster parameter group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_redshift_cluster" '(
    ("id" "id - The Redshift Cluster ID.")
    ("cluster_identifier" "cluster_identifier - The Cluster Identifier")
    ("cluster_type" "cluster_type - The cluster type")
    ("node_type" "node_type - The type of nodes in the cluster")
    ("database_name" "database_name - The name of the default database in the Cluster")
    ("availability_zone" "availability_zone - The availability zone of the Cluster")
    ("automated_snapshot_retention_period" "automated_snapshot_retention_period - The backup retention period")
    ("preferred_maintenance_window" "preferred_maintenance_window - The backup window")
    ("endpoint" "endpoint - The connection endpoint")
    ("encrypted" "encrypted - Whether the data in the cluster is encrypted")
    ("cluster_security_groups" "cluster_security_groups - The security groups associated with the cluster")
    ("vpc_security_group_ids" "vpc_security_group_ids - The VPC security group Ids associated with the cluster")
    ("port" "port - The Port the cluster responds on")
    ("cluster_version" "cluster_version - The version of Redshift engine software")
    ("cluster_parameter_group_name" "cluster_parameter_group_name - The name of the parameter group to be associated with this cluster")
    ("cluster_subnet_group_name" "cluster_subnet_group_name - The name of a cluster subnet group to be associated with this cluster")
    ("cluster_public_key" "cluster_public_key - The public key for the cluster")
    ("cluster_revision_number" "cluster_revision_number - The specific revision number of the database in the cluster")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_redshift_parameter_group" '(
    ("id" "id - The Redshift parameter group name.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_redshift_security_group" '(
    ("id" "id - The Redshift security group ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_redshift_subnet_group" '(
    ("id" "id - The Redshift Subnet group ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_byte_match_set" '(
    ("id" "id - The ID of the WAF Byte Match Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_geo_match_set" '(
    ("id" "id - The ID of the WAF GeoMatchSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_ipset" '(
    ("id" "id - The ID of the WAF IPSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_rate_based_rule" '(
    ("id" "id - The ID of the WAF rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_regex_match_set" '(
    ("id" "id - The ID of the WAF Regex Match Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_regex_pattern_set" '(
    ("id" "id - The ID of the WAF Regex Pattern Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_rule" '(
    ("id" "id - The ID of the WAF rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_rule_group" '(
    ("id" "id - The ID of the WAF rule group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_size_constraint_set" '(
    ("id" "id - The ID of the WAF Size Constraint Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_sql_injection_match_set" '(
    ("id" "id - The ID of the WAF SQL Injection Match Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_web_acl" '(
    ("id" "id - The ID of the WAF WebACL.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_waf_xss_match_set" '(
    ("id" "id - The ID of the WAF XssMatchSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_byte_match_set" '(
    ("id" "id - The ID of the WAF ByteMatchSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_geo_match_set" '(
    ("id" "id - The ID of the WAF Regional Geo Match Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_ipset" '(
    ("id" "id - The ID of the WAF IPSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_rate_based_rule" '(
    ("id" "id - The ID of the WAF Regional rate based rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_regex_match_set" '(
    ("id" "id - The ID of the WAF Regional Regex Match Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_regex_pattern_set" '(
    ("id" "id - The ID of the WAF Regional Regex Pattern Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_rule" '(
    ("id" "id - The ID of the WAF Regional Rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_rule_group" '(
    ("id" "id - The ID of the WAF Regional Rule Group.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_size_constraint_set" '(
    ("id" "id - The ID of the WAF Size Constraint Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_sql_injection_match_set" '(
    ("id" "id - The ID of the WAF SqlInjectionMatchSet.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_web_acl" '(
    ("id" "id - The ID of the WAF Regional WebACL.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_web_acl_association" '(
    ("id" "id - The ID of the association")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_wafregional_xss_match_set" '(
    ("id" "id - The ID of the Regional WAF XSS Match Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route53_delegation_set" '(
    ("id" "id - The delegation set ID")
    ("name_servers" "name_servers - A list of authoritative name servers for the hosted zone (effectively a list of NS records).")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route53_health_check" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route53_query_log" '(
    ("id" "id - The query logging configuration ID")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route53_record" '(
    ("fqdn" "fqdn - FQDN built using the zone domain and name")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route53_zone" '(
    ("zone_id" "zone_id - The Hosted Zone ID. This can be referenced by zone records.")
    ("name_servers" "name_servers - A list of name servers in associated (or default) delegation set. Find more about delegation sets in AWS docs.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route53_zone_association" '(
    ("id" "id - The calculated unique identifier for the association.")
    ("zone_id" "zone_id - The ID of the hosted zone for the association.")
    ("vpc_id" "vpc_id - The ID of the VPC for the association.")
    ("vpc_region" "vpc_region - The region in which the VPC identified by vpc_id was created.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_s3_bucket" '(
    ("id" "id - The name of the bucket.")
    ("arn" "arn - The ARN of the bucket. Will be of format arn:aws:s3:::bucketname.")
    ("bucket_domain_name" "bucket_domain_name - The bucket domain name. Will be of format bucketname.s3.amazonaws.com.")
    ("hosted_zone_id" "hosted_zone_id - The Route 53 Hosted Zone ID for this bucket's region.")
    ("region" "region - The AWS region this bucket resides in.")
    ("website_endpoint" "website_endpoint - The website endpoint, if the bucket is configured with a website. If not, this will be an empty string.")
    ("website_domain" "website_domain - The domain of the website endpoint, if the bucket is configured with a website. If not, this will be an empty string. This is used to create Route 53 alias records.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_s3_bucket_metric" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_s3_bucket_notification" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_s3_bucket_object" '(
    ("id" "id - the key of the resource supplied above")
    ("etag" "etag - the ETag generated for the object (an MD5 sum of the object content).")
    ("version_id" "version_id - A unique version ID value for the object, if bucket versioning is enabled.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_s3_bucket_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_secretsmanager_secret" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_secretsmanager_secret_version" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_active_receipt_rule_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_domain_identity" '(
    ("arn" "arn - The ARN of the domain identity.")
    ("verification_token" "verification_token - A code which when added to the domain as a TXT record will signal to SES that the owner of the domain has authorised SES to act on their behalf. The domain identity will be in state \"verification pending\" until this is done. See below for an example of how this might be achieved when the domain is hosted in Route 53 and managed by Terraform.  Find out more about verifying domains in Amazon SES in the AWS SES docs.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_domain_identity_verification" '(
    ("id" "id - The domain name of the domain identity.")
    ("arn" "arn - The ARN of the domain identity.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_domain_dkim" '(
    ("dkim_tokens" "dkim_tokens - DKIM tokens generated by SES. These tokens should be used to create CNAME records used to verify SES Easy DKIM. See below for an example of how this might be achieved when the domain is hosted in Route 53 and managed by Terraform.  Find out more about verifying domains in Amazon SES  in the AWS SES docs.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_domain_mail_from" '(
    ("id" "id - The domain name.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_receipt_filter" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_receipt_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_receipt_rule_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_configuration_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_event_destination" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_identity_notification_topic" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ses_template" '(
    ("id" "id - The name of the SES template")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_servicecatalog_portfolio" '(
    ("id" "id - The ID of the Service Catalog Portfolio.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_service_discovery_private_dns_namespace" '(
    ("id" "id - The ID of a namespace.")
    ("arn" "arn - The ARN that Amazon Route 53 assigns to the namespace when you create it.")
    ("hosted_zone" "hosted_zone - The ID for the hosted zone that Amazon Route 53 creates when you create a namespace.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_service_discovery_public_dns_namespace" '(
    ("id" "id - The ID of a namespace.")
    ("arn" "arn - The ARN that Amazon Route 53 assigns to the namespace when you create it.")
    ("hosted_zone" "hosted_zone - The ID for the hosted zone that Amazon Route 53 creates when you create a namespace.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_service_discovery_service" '(
    ("id" "id - The ID of the service.")
    ("arn" "arn - The ARN of the service.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sfn_activity" '(
    ("id" "id - The Amazon Resource Name (ARN) that identifies the created activity.")
    ("name" "name - The name of the activity.")
    ("creation_date" "creation_date - The date the activity was created.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sfn_state_machine" '(
    ("id" "id - The ARN of the state machine.")
    ("creation_date" "creation_date - The date the state machine was created.")
    ("status" "status - The current status of the state machine. Either \"ACTIVE\" or \"DELETING\".")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_simpledb_domain" '(
    ("id" "id - The name of the SimpleDB domain")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sns_platform_application" '(
    ("id" "id - The ARN of the SNS platform application")
    ("arn" "arn - The ARN of the SNS platform application")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sns_topic" '(
    ("id" "id - The ARN of the SNS topic")
    ("arn" "arn - The ARN of the SNS topic, as a more obvious property (clone of id)")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sns_topic_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sns_topic_subscription" '(
    ("id" "id - The ARN of the subscription")
    ("topic_arn" "topic_arn - The ARN of the topic the subscription belongs to")
    ("protocol" "protocol - The protocol being used")
    ("endpoint" "endpoint - The full endpoint to send data to (SQS ARN, HTTP(S) URL, Application ARN, SMS number, etc.)")
    ("arn" "arn - The ARN of the subscription stored as a more user-friendly property")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_activation" '(
    ("activation_code" "activation_code - The code the system generates when it processes the activation.")
    ("name" "name - The default name of the registerd managed instance.")
    ("description" "description - The description of the resource that was registered.")
    ("expired" "expired - If the current activation has expired.")
    ("expiration_date" "expiration_date - The date by which this activation request should expire. The default value is 24 hours.")
    ("iam_role" "iam_role - The IAM Role attached to the managed instance.")
    ("registration_limit" "registration_limit - The maximum number of managed instances you want to be registered. The default value is 1 instance.")
    ("registration_count" "registration_count - The number of managed instances that are currently registered using this activation.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_association" '(
    ("name" "name - The name of the SSM document to apply.")
    ("instance_ids" "instance_ids - The instance id that the SSM document was applied to.")
    ("parameters" "parameters - Additional parameters passed to the SSM document.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_document" '(
    ("created_date" "created_date - The date the document was created.")
    ("description" "description - The description of the document.")
    ("schema_version" "schema_version - The schema version of the document.")
    ("default_version" "default_version - The default version of the document.")
    ("hash" "hash - The sha1 or sha256 of the document content")
    ("hash_type" "hash_type - \"Sha1\" \"Sha256\". The hashing algorithm used when hashing the content.")
    ("latest_version" "latest_version - The latest version of the document.")
    ("owner" "owner - The AWS user account of the person who created the document.")
    ("status" "status - \"Creating\", \"Active\" or \"Deleting\". The current status of the document.")
    ("parameter" "parameter - The parameters that are available to this document.")
    ("platform_types" "platform_types - A list of OS platforms compatible with this SSM document, either \"Windows\" or \"Linux\".")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_maintenance_window" '(
    ("id" "id - The ID of the maintenance window.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_maintenance_window_target" '(
    ("id" "id - The ID of the maintenance window target.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_maintenance_window_task" '(
    ("id" "id - The ID of the maintenance window task.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_patch_baseline" '(
    ("id" "id - The ID of the patch baseline.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_patch_group" '(
    ("id" "id - The ID of the patch baseline.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_parameter" '(
    ("arn" "arn - The ARN of the parameter.")
    ("name" "name - (Required) The name of the parameter.")
    ("description" "description - (Required) The description of the parameter.")
    ("type" "type - (Required) The type of the parameter. Valid types are String, StringList and SecureString.")
    ("value" "value - (Required) The value of the parameter.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_ssm_resource_data_sync" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sqs_queue" '(
    ("id" "id - The URL for the created Amazon SQS queue.")
    ("arn" "arn - The ARN of the SQS queue")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_sqs_queue_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_customer_gateway" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_default_network_acl" '(
    ("id" "id - The ID of the Default Network ACL")
    ("vpc_id" "vpc_id -  The ID of the associated VPC")
    ("ingress" "ingress - Set of ingress rules")
    ("egress" "egress - Set of egress rules")
    ("subnet_ids" "subnet_ids – IDs of associated Subnets")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_default_route_table" '(
    ("id" "id - The ID of the routing table")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_default_security_group" '(
    ("id" "id - The ID of the security group")
    ("vpc_id" "vpc_id - The VPC ID.")
    ("owner_id" "owner_id - The owner ID.")
    ("name" "name - The name of the security group")
    ("description" "description - The description of the security group")
    ("ingress" "ingress - The ingress rules. See above for more.")
    ("egress" "egress - The egress rules. See above for more.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_default_subnet" '(
    ("id" "id - The ID of the subnet")
    ("availability_zone" "availability_zone- The AZ for the subnet.")
    ("cidr_block" "cidr_block - The CIDR block for the subnet.")
    ("vpc_id" "vpc_id - The VPC ID.")
    ("ipv6_association_id" "ipv6_association_id - The association ID for the IPv6 CIDR block.")
    ("ipv6_cidr_block" "ipv6_cidr_block - The IPv6 CIDR block.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_default_vpc" '(
    ("id" "id - The ID of the VPC")
    ("cidr_block" "cidr_block - The CIDR block of the VPC")
    ("instance_tenancy" "instance_tenancy - Tenancy of instances spin up within VPC.")
    ("enable_dns_support" "enable_dns_support - Whether or not the VPC has DNS support")
    ("enable_dns_hostnames" "enable_dns_hostnames - Whether or not the VPC has DNS hostname support")
    ("enable_classiclink" "enable_classiclink - Whether or not the VPC has Classiclink enabled")
    ("assign_generated_ipv6_cidr_block" "assign_generated_ipv6_cidr_block - Whether or not an Amazon-provided IPv6 CIDR  block with a /56 prefix length for the VPC was assigned")
    ("main_route_table_id" "main_route_table_id - The ID of the main route table associated with  this VPC. Note that you can change a VPC's main route table by using an  aws_main_route_table_association")
    ("default_network_acl_id" "default_network_acl_id - The ID of the network ACL created by default on VPC creation")
    ("default_security_group_id" "default_security_group_id - The ID of the security group created by default on VPC creation")
    ("default_route_table_id" "default_route_table_id - The ID of the route table created by default on VPC creation")
    ("ipv6_association_id" "ipv6_association_id - The association ID for the IPv6 CIDR block of the VPC")
    ("ipv6_cidr_block" "ipv6_cidr_block - The IPv6 CIDR block of the VPC")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_default_vpc_dhcp_options" '(
    ("id" "id - The ID of the DHCP Options Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_egress_only_internet_gateway" '(
    ("id" "id - The ID of the Egress Only Internet Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_flow_log" '(
    ("id" "id - The Flow Log ID")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_internet_gateway" '(
    ("id" "id - The ID of the Internet Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_main_route_table_association" '(
    ("id" "id - The ID of the Route Table Association")
    ("original_route_table_id" "original_route_table_id - Used internally, see Notes below")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_nat_gateway" '(
    ("id" "id - The ID of the NAT Gateway.")
    ("allocation_id" "allocation_id - The Allocation ID of the Elastic IP address for the gateway.")
    ("subnet_id" "subnet_id - The Subnet ID of the subnet in which the NAT gateway is placed.")
    ("network_interface_id" "network_interface_id - The ENI ID of the network interface created by the NAT gateway.")
    ("private_ip" "private_ip - The private IP address of the NAT Gateway.")
    ("public_ip" "public_ip - The public IP address of the NAT Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_network_acl" '(
    ("id" "id - The ID of the network ACL")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_network_acl_rule" '(
    ("id" "id - The ID of the network ACL Rule")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_network_interface" '(
    ("subnet_id" "subnet_id - Subnet ID the ENI is in.")
    ("description" "description - A description for the network interface.")
    ("private_ips" "private_ips - List of private IPs assigned to the ENI.")
    ("security_groups" "security_groups - List of security groups attached to the ENI.")
    ("attachment" "attachment - Block defining the attachment of the ENI.")
    ("source_dest_check" "source_dest_check - Whether source destination checking is enabled")
    ("tags" "tags - Tags assigned to the ENI.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_network_interface_attachment" '(
    ("instance_id" "instance_id - Instance ID.")
    ("network_interface_id" "network_interface_id - Network interface ID.")
    ("attachment_id" "attachment_id - The ENI Attachment ID.")
    ("status" "status - The status of the Network Interface Attachment.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route" '(
    ("route_table_id" "route_table_id - The ID of the routing table.")
    ("destination_cidr_block" "destination_cidr_block - The destination CIDR block.")
    ("destination_ipv6_cidr_block" "destination_ipv6_cidr_block - The destination IPv6 CIDR block.")
    ("vpc_peering_connection_id" "vpc_peering_connection_id - An ID of a VPC peering connection.")
    ("egress_only_gateway_id" "egress_only_gateway_id - An ID of a VPC Egress Only Internet Gateway.")
    ("gateway_id" "gateway_id - An ID of a VPC internet gateway or a virtual private gateway.")
    ("nat_gateway_id" "nat_gateway_id - An ID of a VPC NAT gateway.")
    ("instance_id" "instance_id - An ID of a NAT instance.")
    ("network_interface_id" "network_interface_id - An ID of a network interface.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route_table" '(
    ("id" "id - The ID of the routing table")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_route_table_association" '(
    ("id" "id - The ID of the association")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_security_group" '(
    ("id" "id - The ID of the security group")
    ("arn" "arn - The ARN of the security group")
    ("vpc_id" "vpc_id - The VPC ID.")
    ("owner_id" "owner_id - The owner ID.")
    ("name" "name - The name of the security group")
    ("description" "description - The description of the security group")
    ("ingress" "ingress - The ingress rules. See above for more.")
    ("egress" "egress - The egress rules. See above for more.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_network_interface_sg_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_security_group_rule" '(
    ("id" "id - The ID of the security group rule")
    ("type" "type - The type of rule, ingress or egress")
    ("from_port" "from_port - The start port (or ICMP type number if protocol is \"icmp\")")
    ("to_port" "to_port - The end port (or ICMP code if protocol is \"icmp\")")
    ("protocol" "protocol – The protocol used")
    ("description" "description – Description of the rule")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_subnet" '(
    ("id" "id - The ID of the subnet")
    ("availability_zone" "availability_zone- The AZ for the subnet.")
    ("cidr_block" "cidr_block - The CIDR block for the subnet.")
    ("vpc_id" "vpc_id - The VPC ID.")
    ("ipv6_association_id" "ipv6_association_id - The association ID for the IPv6 CIDR block.")
    ("ipv6_cidr_block" "ipv6_cidr_block - The IPv6 CIDR block.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc" '(
    ("id" "id - The ID of the VPC")
    ("cidr_block" "cidr_block - The CIDR block of the VPC")
    ("instance_tenancy" "instance_tenancy - Tenancy of instances spin up within VPC.")
    ("enable_dns_support" "enable_dns_support - Whether or not the VPC has DNS support")
    ("enable_dns_hostnames" "enable_dns_hostnames - Whether or not the VPC has DNS hostname support")
    ("enable_classiclink" "enable_classiclink - Whether or not the VPC has Classiclink enabled")
    ("main_route_table_id" "main_route_table_id - The ID of the main route table associated with  this VPC. Note that you can change a VPC's main route table by using an  aws_main_route_table_association.")
    ("default_network_acl_id" "default_network_acl_id - The ID of the network ACL created by default on VPC creation")
    ("default_security_group_id" "default_security_group_id - The ID of the security group created by default on VPC creation")
    ("default_route_table_id" "default_route_table_id - The ID of the route table created by default on VPC creation")
    ("ipv6_association_id" "ipv6_association_id - The association ID for the IPv6 CIDR block.")
    ("ipv6_cidr_block" "ipv6_cidr_block - The IPv6 CIDR block.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_dhcp_options" '(
    ("id" "id - The ID of the DHCP Options Set.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_dhcp_options_association" '(
    ("id" "id - The ID of the DHCP Options Set Association.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_endpoint" '(
    ("id" "id - The ID of the VPC endpoint.")
    ("state" "state - The state of the VPC endpoint.")
    ("prefix_list_id" "prefix_list_id - The prefix list ID of the exposed AWS service. Applicable for endpoints of type Gateway.")
    ("cidr_blocks" "cidr_blocks - The list of CIDR blocks for the exposed AWS service. Applicable for endpoints of type Gateway.")
    ("network_interface_ids" "network_interface_ids - One or more network interfaces for the VPC Endpoint. Applicable for endpoints of type Interface.")
    ("dns_entry" "dns_entry - The DNS entries for the VPC Endpoint. Applicable for endpoints of type Interface. DNS blocks are documented below.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_endpoint_connection_notification" '(
    ("id" "id - The ID of the VPC connection notification.")
    ("state" "state - The state of the notification.")
    ("notification_type" "notification_type - The type of notification.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_endpoint_route_table_association" '(
    ("id" "id - The ID of the association.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_endpoint_service" '(
    ("id" "id - The ID of the VPC endpoint service.")
    ("state" "state - The state of the VPC endpoint service.")
    ("service_name" "service_name - The service name.")
    ("service_type" "service_type - The service type, Gateway or Interface.")
    ("availability_zones" "availability_zones - The Availability Zones in which the service is available.")
    ("private_dns_name" "private_dns_name - The private DNS name for the service.")
    ("base_endpoint_dns_names" "base_endpoint_dns_names - The DNS names for the service.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_endpoint_service_allowed_principal" '(
    ("id" "id - The ID of the association.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_endpoint_subnet_association" '(
    ("id" "id - The ID of the association.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_peering_connection" '(
    ("id" "id - The ID of the VPC Peering Connection.")
    ("accept_status" "accept_status - The status of the VPC Peering Connection request.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_peering_connection_accepter" '(
    ("id" "id - The ID of the VPC Peering Connection.")
    ("accept_status" "accept_status - The status of the VPC Peering Connection request.")
    ("vpc_id" "vpc_id - The ID of the accepter VPC.")
    ("peer_vpc_id" "peer_vpc_id - The ID of the requester VPC.")
    ("peer_owner_id" "peer_owner_id - The AWS account ID of the owner of the requester VPC.")
    ("peer_region" "peer_region - The region of the accepter VPC.")
    ("accepter" "accepter - A configuration block that describes VPC Peering Connection options set for the accepter VPC.")
    ("requester" "requester - A configuration block that describes VPC Peering Connection options set for the requester VPC.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpc_peering_connection_options" '(
    ("id" "id - The ID of the VPC Peering Connection Options.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpn_connection" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpn_connection_route" '(

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpn_gateway" '(
    ("id" "id - The ID of the VPN Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpn_gateway_attachment" '(
    ("vpc_id" "vpc_id - The ID of the VPC that Virtual Private Gateway is attached to.")
    ("vpn_gateway_id" "vpn_gateway_id - The ID of the Virtual Private Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_vpn_gateway_route_propagation" '(

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_resource_group" '(
    ("id" "id - The resource group ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_app_service" '(
    ("id" "id - The ID of the App Service.")
    ("default_site_hostname" "default_site_hostname - The Default Hostname associated with the App Service - such as mysite.azurewebsites.net")
    ("outbound_ip_addresses" "outbound_ip_addresses - A comma separated list of outbound IP addresses - such as 52.23.25.3,52.143.43.12")
    ("source_control" "source_control - A source_control block as defined below, which contains the Source Control information when scm_type is set to LocalGit.")
    ("site_credential" "site_credential - A site_credential block as defined below, which contains the site-level credentials used to publish to this App Service.")
    ("identity" "identity - An identity block as defined below, which contains the Managed Service Identity information for this App Service.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_app_service_plan" '(
    ("id" "id - The ID of the App Service Plan component.")
    ("maximum_number_of_workers" "maximum_number_of_workers - The maximum number of workers supported with the App Service Plan's sku.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_app_service_active_slot" '(

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_app_service_custom_hostname_binding" '(
    ("id" "id - The ID of the App Service Custom Hostname Binding")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_app_service_slot" '(
    ("id" "id - The ID of the App Service Slot.")
    ("default_site_hostname" "default_site_hostname - The Default Hostname associated with the App Service Slot - such as mysite.azurewebsites.net")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_function_app" '(
    ("id" "id - The ID of the Function App")
    ("default_hostname" "default_hostname - The default hostname associated with the Function App - such as mysite.azurewebsites.net")
    ("outbound_ip_addresses" "outbound_ip_addresses - A comma separated list of outbound IP addresses - such as 52.23.25.3,52.143.43.12")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_role_assignment" '(
    ("id" "id - The Role Assignment ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_role_definition" '(
    ("id" "id - The Role Definition ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_automation_account" '(
    ("id" "id - The Automation Account ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_automation_credential" '(
    ("id" "id - The Automation Credential ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_automation_runbook" '(
    ("id" "id - The Automation Runbook ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_automation_schedule" '(
    ("id" "id - The Automation Schedule ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_application_insights" '(
    ("id" "id - The ID of the Application Insights component.")
    ("app_id" "app_id - The App ID associated with this Application Insights component.")
    ("instrumentation_key" "instrumentation_key - The Instrumentation Key for this Application Insights component.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_cdn_profile" '(
    ("id" "id - The CDN Profile ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_cdn_endpoint" '(
    ("id" "id - The CDN Endpoint ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_availability_set" '(
    ("id" "id - The virtual Availability Set ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_managed_disk" '(
    ("id" "id - The managed disk ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_snapshot" '(
    ("id" "id - The Snapshot ID.")
    ("disk_size_gb" "disk_size_gb - The Size of the Snapshotted Disk in GB.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_image" '(
    ("id" "id - The managed image ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_machine" '(
    ("id" "id - The virtual machine ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_machine_extension" '(
    ("id" "id - The Virtual Machine Extension ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_machine_scale_set" '(
    ("id" "id - The virtual machine scale set ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_container_group" '(
    ("id" "id - The container group ID.")
    ("ip_address" "ip_address - The IP address allocated to the container group.")
    ("fqdn" "fqdn - The FQDN of the container group derived from dns_name_label.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_container_registry" '(
    ("id" "id - The Container Registry ID.")
    ("login_server" "login_server - The URL that can be used to log into the container registry.")
    ("admin_username" "admin_username - The Username associated with the Container Registry Admin account - if the admin account is enabled.")
    ("admin_password" "admin_password - The Password associated with the Container Registry Admin account - if the admin account is enabled.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_container_service" '(
    ("id" "id - The Container Service ID.")
    ("master_profile.fqdn" "master_profile.fqdn - FDQN for the master.")
    ("agent_pool_profile.fqdn" "agent_pool_profile.fqdn - FDQN for the agent pool.")
    ("diagnostics_profile.storage_uri" "diagnostics_profile.storage_uri - The URI of the storage account where diagnostics are stored.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_kubernetes_cluster" '(
    ("id" "id - The Kubernetes Managed Cluster ID.")
    ("fqdn" "fqdn - The FQDN of the Azure Kubernetes Managed Cluster.")
    ("kube_config_raw" "kube_config_raw - Base64 encoded Kubernetes configuration")
    ("kube_config" "kube_config - Kubernetes configuration, sub-attributes defined below:  client_key - Base64 encoded private key used by clients to authenticate to the Kubernetes cluster.  client_certificate - Base64 encoded public certificate used by clients to authenticate to the Kubernetes cluster.  cluster_ca_certificate - Base64 encoded public CA certificate used as the root of trust for the Kubernetes cluster.  host - The Kubernetes cluster server host.  username - A username used to authenticate to the Kubernetes cluster.  password - A password or token used to authenticate to the Kubernetes cluster.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_cosmosdb_account" '(
    ("id" "id - The CosmosDB Account ID.")
    ("endpoint" "endpoint - The endpoint used to connect to the CosmosDB account.")
    ("read_endpoints" "read_endpoints - A list of read endpoints available for this CosmosDB account.")
    ("write_endpoints" "write_endpoints - A list of write endpoints available for this CosmosDB account.")
    ("primary_master_key" "primary_master_key - The Primary master key for the CosmosDB Account.")
    ("secondary_master_key" "secondary_master_key - The Secondary master key for the CosmosDB Account.")
    ("primary_readonly_master_key" "primary_readonly_master_key - The Primary read-only master Key for the CosmosDB Account.")
    ("secondary_readonly_master_key" "secondary_readonly_master_key - The Secondary read-only master key for the CosmosDB Account.")
    ("connection_strings" "connection_strings - A list of connection strings available for this CosmosDB account. If the kind is GlobalDocumentDB, this will be empty.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_mysql_configuration" '(
    ("id" "id - The ID of the MySQL Configuration.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_mysql_database" '(
    ("id" "id - The ID of the MySQL Database.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_mysql_firewall_rule" '(
    ("id" "id - The ID of the MySQL Firewall Rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_mysql_server" '(
    ("id" "id - The ID of the MySQL Server.")
    ("fqdn" "fqdn - The FQDN of the MySQL Server.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_postgresql_configuration" '(
    ("id" "id - The ID of the PostgreSQL Configuration.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_postgresql_database" '(
    ("id" "id - The ID of the PostgreSQL Database.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_postgresql_firewall_rule" '(
    ("id" "id - The ID of the PostgreSQL Firewall Rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_postgresql_server" '(
    ("id" "id - The ID of the PostgreSQL Server.")
    ("fqdn" "fqdn - The FQDN of the PostgreSQL Server.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_sql_database" '(
    ("id" "id - The SQL Database ID.")
    ("creation_data" "creation_data - The creation date of the SQL Database.")
    ("default_secondary_location" "default_secondary_location - The default secondary location of the SQL Database.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_sql_active_directory_administrator" '(
    ("id" "id - The SQL Active Directory Administrator ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_sql_elasticpool" '(
    ("id" "id - The SQL Elastic Pool ID.")
    ("creation_date" "creation_date - The creation date of the SQL Elastic Pool.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_sql_firewall_rule" '(
    ("id" "id - The SQL Firewall Rule ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_sql_server" '(
    ("id" "id - The SQL Server ID.")
    ("fully_qualified_domain_name" "fully_qualified_domain_name - The fully qualified domain name of the Azure SQL Server (e.g. myServerName.database.windows.net)")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_sql_virtual_network_rule" '(
    ("id" "id - The ID of the SQL virtual network rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_a_record" '(
    ("id" "id - The DNS A Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_aaaa_record" '(
    ("id" "id - The DNS AAAA Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_cname_record" '(
    ("id" "id - The DNS CName Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_mx_record" '(
    ("id" "id - The DNS MX Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_ns_record" '(
    ("id" "id - The DNS NS Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_ptr_record" '(
    ("id" "id - The DNS PTR Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_srv_record" '(
    ("id" "id - The DNS SRV Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_txt_record" '(
    ("id" "id - The DNS TXT Record ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_dns_zone" '(
    ("id" "id - The DNS Zone ID.")
    ("max_number_of_record_sets" "max_number_of_record_sets - (Optional) Maximum number of Records in the zone. Defaults to 1000.")
    ("number_of_record_sets" "number_of_record_sets - (Optional) The number of records already in the zone.")
    ("name_servers" "name_servers - (Optional) A list of values that make up the NS record for the zone.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_key_vault" '(
    ("id" "id - The Vault ID.")
    ("vault_uri" "vault_uri - The URI of the vault for performing operations on keys and secrets.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_key_vault_certificate" '(
    ("id" "id - The Key Vault Certificate ID.")
    ("secret_id" "secret_id - The ID of the associated Key Vault Secret.")
    ("version" "version - The current version of the Key Vault Certificate.")
    ("certificate_data" "certificate_data - The raw Key Vault Certificate")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_key_vault_key" '(
    ("id" "id - The Key Vault Key ID.")
    ("version" "version - The current version of the Key Vault Key.")
    ("n" "n - The RSA modulus of this Key Vault Key.")
    ("e" "e - The RSA public exponent of this Key Vault Key.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_key_vault_secret" '(
    ("id" "id - The Key Vault Secret ID.")
    ("version" "version - The current version of the Key Vault Secret.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_lb" '(
    ("id" "id - The LoadBalancer ID.")
    ("private_ip_address" "private_ip_address - The first private IP address assigned to the load balancer in frontend_ip_configuration blocks, if any.")
    ("private_ip_addresses" "private_ip_addresses - The list of private IP address assigned to the load balancer in frontend_ip_configuration blocks, if any.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_lb_backend_address_pool" '(
    ("id" "id - The ID of the LoadBalancer to which the resource is attached.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_lb_rule" '(
    ("id" "id - The ID of the LoadBalancer to which the resource is attached.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_lb_nat_rule" '(
    ("id" "id - The ID of the LoadBalancer to which the resource is attached.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_lb_nat_pool" '(
    ("id" "id - The ID of the LoadBalancer to which the resource is attached.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_lb_probe" '(
    ("id" "id - The ID of the LoadBalancer to which the resource is attached.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_management_lock" '(
    ("id" "id - The ID of the Management Lock")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_eventgrid_topic" '(
    ("id" "id - The EventGrid Topic ID.")
    ("endpoint" "endpoint - The Endpoint associated with the EventGrid Topic.")
    ("primary_access_key" "primary_access_key - The Primary Shared Access Key associated with the EventGrid Topic.")
    ("secondary_access_key" "secondary_access_key - The Secondary Shared Access Key associated with the EventGrid Topic.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_eventhub" '(
    ("id" "id - The EventHub ID.")
    ("partition_ids" "partition_ids - The identifiers for partitions created for Event Hubs.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_eventhub_authorization_rule" '(
    ("id" "id - The EventHub ID.")
    ("primary_key" "primary_key - The Primary Key for the Event Hubs authorization Rule.")
    ("primary_connection_string" "primary_connection_string - The Primary Connection String for the Event Hubs authorization Rule.")
    ("secondary_key" "secondary_key - The Secondary Key for the Event Hubs authorization Rule.")
    ("secondary_connection_string" "secondary_connection_string - The Secondary Connection String for the Event Hubs authorization Rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_eventhub_consumer_group" '(
    ("id" "id - The EventHub Consumer Group ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_eventhub_namespace" '(
    ("id" "id - The EventHub Namespace ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_iothub" '(
    ("id" "id - The IotHub ID.")
    ("hostname" "hostname - The hostname of the IotHub Resource.")
    ("shared_access_policy" "shared_access_policy - A list of shared_access_policy blocks as defined below.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_servicebus_namespace" '(
    ("id" "id - The ServiceBus Namespace ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_servicebus_queue" '(
    ("id" "id - The ServiceBus Queue ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_servicebus_subscription" '(
    ("id" "id - The ServiceBus Subscription ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_servicebus_subscription_rule" '(
    ("id" "id - The ServiceBus Subscription Rule ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_servicebus_topic" '(
    ("id" "id - The ServiceBus Topic ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_servicebus_topic_authorization_rule" '(
    ("id" "id - The ServiceBus Topic ID.")
    ("primary_key" "primary_key - The Primary Key for the ServiceBus Topic authorization Rule.")
    ("primary_connection_string" "primary_connection_string - The Primary Connection String for the ServiceBus Topic authorization Rule.")
    ("secondary_key" "secondary_key - The Secondary Key for the ServiceBus Topic authorization Rule.")
    ("secondary_connection_string" "secondary_connection_string - The Secondary Connection String for the ServiceBus Topic authorization Rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_metric_alertrule" '(
    ("id" "id - The ID of the alert rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_application_gateway" '(
    ("id" "id - The application gatewayConfiguration ID.")
    ("name" "name - The name of the application gateway.")
    ("resource_group_name" "resource_group_name - The name of the resource group in which to create the application gateway.")
    ("location" "location - The location/region where the application gateway is created")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_application_security_group" '(
    ("id" "id - The ID of the Application Security Group.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_express_route_circuit" '(
    ("id" "id - The Resource ID of the ExpressRoute circuit.")
    ("service_provider_provisioning_state" "service_provider_provisioning_state - The ExpressRoute circuit provisioning state from your chosen service provider. Possible values are \"NotProvisioned\", \"Provisioning\", \"Provisioned\", and \"Deprovisioning\".")
    ("service_key" "service_key - The string needed by the service provider to provision the ExpressRoute circuit.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_express_route_circuit_authorization" '(
    ("id" "id - The Resource ID of the ExpressRoute Circuit Authorization.")
    ("authorization_key" "authorization_key - The Authorization Key.")
    ("authorization_use_status" "authorization_use_status - The authorization use status.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_express_route_circuit_peering" '(
    ("id" "id - The Resource ID of the ExpressRoute Circuit Peering.")
    ("azure_asn" "azure_asn - The ASN used by Azure.")
    ("primary_azure_port" "primary_azure_port - The Primary Port used by Azure for this Peering.")
    ("secondary_azure_port" "secondary_azure_port - The Secondary Port used by Azure for this Peering.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_local_network_gateway" '(
    ("id" "id - The local network gateway unique ID within Azure.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_network_interface" '(
    ("id" "id - The Virtual Network Interface ID.")
    ("mac_address" "mac_address - The media access control (MAC) address of the network interface.")
    ("private_ip_address" "private_ip_address - The private ip address of the network interface.")
    ("virtual_machine_id" "virtual_machine_id - Reference to a VM with which this NIC has been associated.")
    ("applied_dns_servers" "applied_dns_servers - If the VM that uses this NIC is part of an Availability Set, then this list will have the union of all DNS servers from all NICs that are part of the Availability Set")
    ("internal_fqdn" "internal_fqdn - Fully qualified DNS name supporting internal communications between VMs in the same VNet")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_network_security_group" '(
    ("id" "id - The Network Security Group ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_network_security_rule" '(
    ("id" "id - The Network Security Rule ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_network_watcher" '(
    ("id" "id - The Network Watcher ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_packet_capture" '(
    ("id" "id - The Packet Capture ID.")
    ("storage_location" "storage_location - (Required) A storage_location block as defined below.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_public_ip" '(
    ("id" "id - The Public IP ID.")
    ("ip_address" "ip_address - The IP address value that was allocated.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_route" '(
    ("id" "id - The Route ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_route_table" '(
    ("id" "id - The Route Table ID.")
    ("subnets" "subnets - The collection of Subnets associated with this route table.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_subnet" '(
    ("id" "id - The subnet ID.")
    ("ip_configurations" "ip_configurations - The collection of IP Configurations with IPs within this subnet.")
    ("name" "name - The name of the subnet.")
    ("resource_group_name" "resource_group_name - The name of the resource group in which the subnet is created in.")
    ("virtual_network_name" "virtual_network_name - The name of the virtual network in which the subnet is created in")
    ("address_prefix" "address_prefix - The address prefix for the subnet")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_traffic_manager_endpoint" '(
    ("id" "id - The Traffic Manager Endpoint id.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_traffic_manager_profile" '(
    ("id" "id - The Traffic Manager Profile id.")
    ("fqdn" "fqdn - The FQDN of the created Profile.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_network" '(
    ("id" "id - The virtual NetworkConfiguration ID.")
    ("name" "name - The name of the virtual network.")
    ("resource_group_name" "resource_group_name - The name of the resource group in which to create the virtual network.")
    ("location" "location - The location/region where the virtual network is created")
    ("address_space" "address_space - The address space that is used the virtual network.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_network_gateway" '(
    ("id" "id - The ID of the Virtual Network Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_network_gateway_connection" '(
    ("id" "id - The connection ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_virtual_network_peering" '(
    ("id" "id - The Virtual Network Peering resource ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_policy_assignment" '(
    ("id" "id - The Policy Assignment id.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_policy_definition" '(
    ("id" "id - The policy definition id.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_log_analytics_solution" '(

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_log_analytics_workspace" '(
    ("id" "id - The Log Analytics Workspace ID.")
    ("primary_shared_key" "primary_shared_key - The Primary shared key for the Log Analytics Workspace.")
    ("secondary_shared_key" "secondary_shared_key - The Secondary shared key for the Log Analytics Workspace.")
    ("workspace_id" "workspace_id - The Workspace (or Customer) ID for the Log Analytics Workspace.")
    ("portal_url" "portal_url - The Portal URL for the Log Analytics Workspace.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_recovery_services_vault" '(
    ("id" "id - The ID of the Recovery Services Vault.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_redis_cache" '(
    ("id" "id - The Route ID.")
    ("hostname" "hostname - The Hostname of the Redis Instance")
    ("ssl_port" "ssl_port - The SSL Port of the Redis Instance")
    ("port" "port - The non-SSL Port of the Redis Instance")
    ("primary_access_key" "primary_access_key - The Primary Access Key for the Redis Instance")
    ("secondary_access_key" "secondary_access_key - The Secondary Access Key for the Redis Instance")
    ("redis_configuration" "redis_configuration - A redis_configuration block as defined below:")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_redis_firewall_rule" '(
    ("id" "id - The Redis Firewall Rule ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_search_service" '(
    ("id" "id - The Search Service ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_scheduler_job_collection" '(
    ("id" "id - The ID of the Scheduler Job Collection.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_storage_account" '(
    ("id" "id - The storage account Resource ID.")
    ("primary_location" "primary_location - The primary location of the storage account.")
    ("secondary_location" "secondary_location - The secondary location of the storage account.")
    ("primary_blob_endpoint" "primary_blob_endpoint - The endpoint URL for blob storage in the primary location.")
    ("secondary_blob_endpoint" "secondary_blob_endpoint - The endpoint URL for blob storage in the secondary location.")
    ("primary_queue_endpoint" "primary_queue_endpoint - The endpoint URL for queue storage in the primary location.")
    ("secondary_queue_endpoint" "secondary_queue_endpoint - The endpoint URL for queue storage in the secondary location.")
    ("primary_table_endpoint" "primary_table_endpoint - The endpoint URL for table storage in the primary location.")
    ("secondary_table_endpoint" "secondary_table_endpoint - The endpoint URL for table storage in the secondary location.")
    ("primary_file_endpoint" "primary_file_endpoint - The endpoint URL for file storage in the primary location.")
    ("primary_access_key" "primary_access_key - The primary access key for the storage account")
    ("secondary_access_key" "secondary_access_key - The secondary access key for the storage account")
    ("primary_connection_string" "primary_connection_string - The connection string associated with the primary location")
    ("secondary_connection_string" "secondary_connection_string - The connection string associated with the secondary location")
    ("primary_blob_connection_string" "primary_blob_connection_string - The connection string associated with the primary blob location")
    ("secondary_blob_connection_string" "secondary_blob_connection_string - The connection string associated with the secondary blob location")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_storage_container" '(
    ("id" "id - The storage container Resource ID.")
    ("properties" "properties - Key-value definition of additional properties associated to the storage container")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_storage_blob" '(
    ("id" "id - The storage blob Resource ID.")
    ("url" "url - The URL of the blob")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_storage_queue" '(
    ("id" "id - The storage queue Resource ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_storage_share" '(
    ("id" "id - The storage share Resource ID.")
    ("url" "url - The URL of the share")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_storage_table" '(
    ("id" "id - The storage table Resource ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "azurerm_template_deployment" '(
    ("id" "id - The Template Deployment ID.")
    ("outputs" "outputs - A map of supported scalar output types returned from the deployment (currently, Azure Template Deployment outputs of type String, Int and Bool are supported, and are converted to strings - others will be ignored) and can be accessed using .outputs[\"name\"].")

  ) company-terraform-resource-attributes-hash)

(puthash "bitbucket_default_reviewers" '(

  ) company-terraform-resource-attributes-hash)

(puthash "bitbucket_hook" '(

  ) company-terraform-resource-attributes-hash)

(puthash "bitbucket_repository" '(

  ) company-terraform-resource-attributes-hash)

(puthash "clc_server" '(

  ) company-terraform-resource-attributes-hash)

(puthash "clc_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "clc_public_ip" '(

  ) company-terraform-resource-attributes-hash)

(puthash "clc_load_balancer" '(

  ) company-terraform-resource-attributes-hash)

(puthash "clc_load_balancer_pool" '(

  ) company-terraform-resource-attributes-hash)

(puthash "chef_data_bag" '(
    ("api_url" "api_url - The URL representing this data bag in the Chef server API.")

  ) company-terraform-resource-attributes-hash)

(puthash "chef_data_bag_item" '(
    ("id" "id - The value of the \"id\" property in the content_json JSON object, which can be used by clients to retrieve this item's content.")

  ) company-terraform-resource-attributes-hash)

(puthash "chef_environment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "chef_node" '(

  ) company-terraform-resource-attributes-hash)

(puthash "chef_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "circonus_check" '(

  ) company-terraform-resource-attributes-hash)

(puthash "circonus_contact_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "circonus_graph" '(

  ) company-terraform-resource-attributes-hash)

(puthash "circonus_metric" '(

  ) company-terraform-resource-attributes-hash)

(puthash "circonus_metric_cluster" '(

  ) company-terraform-resource-attributes-hash)

(puthash "circonus_rule_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_load_balancer" '(
    ("id" "id - Unique identifier in the API for the load balancer.")
    ("zone_id" "zone_id - ID associated with the specified zone.")
    ("created_on" "created_on - The RFC3339 timestamp of when the load balancer was created.")
    ("modified_on" "modified_on - The RFC3339 timestamp of when the load balancer was last modified.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_load_balancer_pool" '(
    ("id" "id - ID for this load balancer pool.")
    ("created_on" "created_on - The RFC3339 timestamp of when the load balancer was created.")
    ("modified_on" "modified_on - The RFC3339 timestamp of when the load balancer was last modified.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_page_rule" '(
    ("id" "id - The page rule ID.")
    ("zone_id" "zone_id - The ID of the zone in which the page rule will be applied.")
    ("target" "target - The URL pattern targeted by the page rule.")
    ("actions" "actions - The actions applied by the page rule.")
    ("priority" "priority - The priority of the page rule.")
    ("status" "status - Whether the page rule is active or paused.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_rate_limit" '(
    ("id" "id - The Rate limit ID.")
    ("zone_id" "zone_id - The DNS zone ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_record" '(
    ("id" "id - The record ID")
    ("hostname" "hostname - The FQDN of the record")
    ("proxiable" "proxiable - Shows whether this record can be proxied, must be true if setting proxied=true")
    ("created_on" "created_on - The RFC3339 timestamp of when the record was created")
    ("modified_on" "modified_on - The RFC3339 timestamp of when the record was last modified")
    ("metadata" "metadata - A key-value map of string metadata cloudflare associates with the record")
    ("zone_id" "zone_id - The zone id of the record")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_load_balancer_monitor" '(
    ("id" "id - Load balancer monitor ID.")
    ("created_on" "created_on - The RFC3339 timestamp of when the load balancer monitor was created.")
    ("modified_on" "modified_on - The RFC3339 timestamp of when the load balancer monitor was last modified.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudflare_zone_settings_override" '(
    ("id" "id - The zone ID.")
    ("initial_settings" "initial_settings - Settings present in the zone at the time the resource is created. This will be used to restore the original settings when this resource is destroyed. Shares the same schema as the settings attribute (Above).")
    ("intial_settings_read_at" "intial_settings_read_at - Time when this resource was created and the initial_settings were set.")
    ("readonly_settings" "readonly_settings - Which of the current settings are not able to be set by the user. Which settings these are is determined by plan level and user permissions.")
    ("zone_status" "zone_status. A full zone implies that DNS is hosted with Cloudflare. A partial zone is typically a partner-hosted zone or a CNAME setup.")
    ("zone_type" "zone_type. Status of the zone. Valid values: active, pending, initializing, moved, deleted, deactivated.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudscale_server" '(
    ("id" "id - The UUID of this server.")
    ("href" "href - The cloudscale.ch API URL of the current resource.")
    ("ssh_fingerprints" "ssh_fingerprints - A list of SSH host key fingerprints (strings) of this server.")
    ("ssh_host_keys" "ssh_host_keys - A list of SSH host keys (strings) of this server.")
    ("anti_affinity_with" "anti_affinity_with - A list of server UUIDs that belong to the same anti-affinity group as this server.")
    ("volumes" "volumes - A list of volume objects attached to this server. Each volume object has three attributes:   device_path - The path (string) to the volume on your server (e.g. /dev/vda)  size_gb - The size (int) of the volume in GB. Typically matches volume_size_gb or bulk_volume_size_gb.  type - A string. Either ssd or bulk.")
    ("interfaces" "interfaces - A list of interface objects attached to this server. Each interface object has two attributes:   type - Either public or private. Public interfaces are connected to the Internet, while private interfaces are not.  addresses - A list of address objects:   address - An IPv4 or IPv6 address that has been assigned to this server.  gateway - An IPv4 or IPv6 address that represents the default gateway for this interface.  prefix_length - The prefix length for this IP address, typically 24 for IPv4 and 128 for IPv6.  reverse_ptr - The PTR record (reverse DNS pointer) for this IP address. If you use an FQDN as your server name it will automatically be used here.  version - The IP version, either 4 or 6.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudscale_floating_ip" '(
    ("href" "href - The cloudscale.ch API URL of the current resource.")
    ("network" "network - The CIDR notation of the Floating IP address or network, e.g. 192.0.2.123/32.")
    ("next_hop" "next_hop - The IP address of the server that your Floating IP is currently assigned to.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_affinity_group" '(
    ("id" "id - The id of the affinity group.")
    ("description" "description - The description of the affinity group.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_disk" '(
    ("id" "id - The ID of the disk volume.")
    ("device_id" "device_id - The device ID the disk volume is mapped to within the guest OS.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_egress_firewall" '(
    ("id" "id - The network ID for which the egress firewall rules are created.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_firewall" '(
    ("id" "id - The IP address ID for which the firewall rules are created.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_instance" '(
    ("id" "id - The instance ID.")
    ("display_name" "display_name - The display name of the instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_ipaddress" '(
    ("id" "id - The ID of the acquired and associated IP address.")
    ("ip_address" "ip_address - The IP address that was acquired and associated.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_loadbalancer_rule" '(
    ("id" "id - The load balancer rule ID.")
    ("description" "description - The description of the load balancer rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_network" '(
    ("id" "id - The ID of the network.")
    ("display_text" "display_text - The display text of the network.")
    ("network_domain" "network_domain - DNS domain for the network.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_network_acl" '(
    ("id" "id - The ID of the Network ACL")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_network_acl_rule" '(
    ("id" "id - The ACL ID for which the rules are created.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_nic" '(
    ("id" "id - The ID of the NIC.")
    ("ip_address" "ip_address - The assigned IP address.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_port_forward" '(
    ("id" "id - The ID of the IP address for which the port forwards are created.")
    ("vm_guest_ip" "vm_guest_ip - The IP address of the virtual machine that is used for the port forwarding rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_private_gateway" '(
    ("id" "id - The ID of the private gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_secondary_ipaddress" '(
    ("id" "id - The secondary IP address ID.")
    ("ip_address" "ip_address - The IP address that was acquired and associated.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_security_group" '(
    ("id" "id - The ID of the security group.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_security_group_rule" '(
    ("id" "id - The security group ID for which the rules are created.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_ssh_keypair" '(
    ("id" "id - The key pair ID.")
    ("fingerprint" "fingerprint - The fingerprint of the public key specified or created.")
    ("private_key" "private_key - The private key generated by CloudStack. Only available if CloudStack generated the key pair.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_static_nat" '(
    ("id" "id - The static nat ID.")
    ("vm_guest_ip" "vm_guest_ip - The IP address of the virtual machine that is used to forward the static NAT traffic to.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_static_route" '(
    ("id" "id - The ID of the static route.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_template" '(
    ("id" "id - The template ID.")
    ("display_text" "display_text - The display text of the template.")
    ("is_dynamically_scalable" "is_dynamically_scalable - Set to \"true\" if the template is dynamically scalable.")
    ("is_extractable" "is_extractable - Set to \"true\" if the template is extractable.")
    ("is_featured" "is_featured - Set to \"true\" if the template is featured.")
    ("is_public" "is_public - Set to \"true\" if the template is public.")
    ("password_enabled" "password_enabled - Set to \"true\" if the template is password enabled.")
    ("is_ready" "is_ready - Set to \"true\" once the template is ready for use.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_vpc" '(
    ("id" "id - The ID of the VPC.")
    ("display_text" "display_text - The display text of the VPC.")
    ("source_nat_ip" "source_nat_ip - The source NAT IP assigned to the VPC.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_vpn_gateway" '(
    ("id" "id - The ID of the VPN Gateway.")
    ("public_ip" "public_ip - The public IP address associated with the VPN Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_vpn_customer_gateway" '(
    ("id" "id - The ID of the VPN Customer Gateway.")
    ("dpd" "dpd - Enable or disable DPD is enabled for the related VPN connection.")
    ("esp_lifetime" "esp_lifetime - The ESP lifetime of phase 2 VPN connection to this VPN Customer Gateway.")
    ("ike_lifetime" "ike_lifetime - The IKE lifetime of phase 2 VPN connection to this VPN Customer Gateway.")

  ) company-terraform-resource-attributes-hash)

(puthash "cloudstack_vpn_connection" '(
    ("id" "id - The ID of the VPN Connection.")

  ) company-terraform-resource-attributes-hash)

(puthash "cobbler_distro" '(

  ) company-terraform-resource-attributes-hash)

(puthash "cobbler_kickstart_file" '(

  ) company-terraform-resource-attributes-hash)

(puthash "cobbler_repo" '(

  ) company-terraform-resource-attributes-hash)

(puthash "cobbler_profile" '(

  ) company-terraform-resource-attributes-hash)

(puthash "cobbler_snippet" '(

  ) company-terraform-resource-attributes-hash)

(puthash "cobbler_system" '(

  ) company-terraform-resource-attributes-hash)

(puthash "consul_agent_service" '(
    ("address" "address - The address of the service.")
    ("id" "id - The ID of the service, defaults to the value of name.")
    ("name" "name - The name of the service.")
    ("port" "port - The port of the service.")
    ("tags" "tags - The tags of the service.")

  ) company-terraform-resource-attributes-hash)

(puthash "consul_catalog_entry" '(
    ("address" "address - The address of the service.")
    ("node" "node - The ID of the service, defaults to the value of name.")

  ) company-terraform-resource-attributes-hash)

(puthash "consul_keys" '(
    ("datacenter" "datacenter - The datacenter the keys are being written to.")

  ) company-terraform-resource-attributes-hash)

(puthash "consul_key_prefix" '(
    ("datacenter" "datacenter - The datacenter the keys are being read/written to.")

  ) company-terraform-resource-attributes-hash)

(puthash "consul_node" '(
    ("address" "address - The address of the service.")
    ("name" "name - The name of the service.")

  ) company-terraform-resource-attributes-hash)

(puthash "consul_prepared_query" '(
    ("id" "id - The ID of the prepared query, generated by Consul.")

  ) company-terraform-resource-attributes-hash)

(puthash "consul_service" '(
    ("service_id" "service_id - The id of the service, defaults to the value of name.")
    ("address" "address - The address of the service.")
    ("name" "name - The name of the service.")
    ("port" "port - The port of the service.")
    ("tags" "tags - The tags of the service.")

  ) company-terraform-resource-attributes-hash)

(puthash "datadog_downtime" '(
    ("id" "id - ID of the Datadog downtime")

  ) company-terraform-resource-attributes-hash)

(puthash "datadog_monitor" '(
    ("id" "id - ID of the Datadog monitor")

  ) company-terraform-resource-attributes-hash)

(puthash "datadog_timeboard" '(

  ) company-terraform-resource-attributes-hash)

(puthash "datadog_user" '(
    ("disabled" "disabled - Returns true if Datadog user is disabled (NOTE: Datadog does not actually delete users so this will be true for those as well)")
    ("id" "id - ID of the Datadog user")
    ("verified" "verified - Returns true if Datadog user is verified")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_certificate" '(
    ("id" "id - The unique ID of the certificate")
    ("name" "name - The name of the certificate")
    ("not_after" "not_after - The expiration date of the certificate")
    ("sha1_fingerprint" "sha1_fingerprint - The SHA-1 fingerprint of the certificate")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_domain" '(
    ("id" "id - The name of the domain")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_droplet" '(
    ("id" "id - The ID of the Droplet")
    ("name" "name- The name of the Droplet")
    ("region" "region - The region of the Droplet")
    ("image" "image - The image of the Droplet")
    ("ipv6" "ipv6 - Is IPv6 enabled")
    ("ipv6_address" "ipv6_address - The IPv6 address")
    ("ipv6_address_private" "ipv6_address_private - The private networking IPv6 address")
    ("ipv4_address" "ipv4_address - The IPv4 address")
    ("ipv4_address_private" "ipv4_address_private - The private networking IPv4 address")
    ("locked" "locked - Is the Droplet locked")
    ("private_networking" "private_networking - Is private networking enabled")
    ("price_hourly" "price_hourly - Droplet hourly price")
    ("price_monthly" "price_monthly - Droplet monthly price")
    ("size" "size - The instance size")
    ("disk" "disk - The size of the instance's disk in GB")
    ("vcpus" "vcpus - The number of the instance's virtual CPUs")
    ("status" "status - The status of the droplet")
    ("tags" "tags - The tags associated with the droplet")
    ("volume_ids" "volume_ids - A list of the attached block storage volumes")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_firewall" '(
    ("id" "id - A unique ID that can be used to identify and reference a Firewall.")
    ("status" "status - A status string indicating the current state of the Firewall. This can be \"waiting\", \"succeeded\", or \"failed\".")
    ("created_at" "created_at - A time value given in ISO8601 combined date and time format that represents when the Firewall was created.")
    ("pending_changes" "pending_changes - An list of object containing the fields, \"droplet_id\", \"removing\", and \"status\".  It is provided to detail exactly which Droplets are having their security policies updated.  When empty, all changes have been successfully applied.")
    ("name" "name - The name of the Firewall.")
    ("droplet_ids" "droplet_ids - The list of the IDs of the Droplets assigned to the Firewall.")
    ("tags" "tags - The names of the Tags assigned to the Firewall.")
    ("inbound_rules" "inbound_rules - The inbound access rule block for the Firewall.")
    ("outbound_rules" "outbound_rules - The outbound access rule block for the Firewall.")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_floating_ip" '(
    ("ip_address" "ip_address - The IP Address of the resource")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_loadbalancer" '(
    ("id" "id - The ID of the Load Balancer")
    ("ip" "ip- The ip of the Load Balancer")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_record" '(
    ("id" "id - The record ID")
    ("fqdn" "fqdn - The FQDN of the record")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_ssh_key" '(
    ("id" "id - The unique ID of the key")
    ("name" "name - The name of the SSH key")
    ("public_key" "public_key - The text of the public key")
    ("fingerprint" "fingerprint - The fingerprint of the SSH key")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_tag" '(
    ("id" "id - The id of the tag")
    ("name" "name - The name of the tag")

  ) company-terraform-resource-attributes-hash)

(puthash "digitalocean_volume" '(
    ("id" "id - The unique identifier for the block storage volume.")

  ) company-terraform-resource-attributes-hash)

(puthash "dns_a_record_set" '(
    ("zone" "zone - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("addresses" "addresses - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "dns_aaaa_record_set" '(
    ("zone" "zone - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("addresses" "addresses - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "dns_cname_record" '(
    ("zone" "zone - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("cname" "cname - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "dns_ptr_record" '(
    ("zone" "zone - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("ptr" "ptr - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "dme_record" '(
    ("name" "name - The name of the record")
    ("type" "type - The type of the record")
    ("value" "value - The value of the record type (see below)")
    ("ttl" "ttl - The TTL of the record")
    ("gtdLocation" "gtdLocation - The GTD Location of the record on GTD enabled domains")

  ) company-terraform-resource-attributes-hash)

(puthash "dnsimple_record" '(
    ("id" "id - The record ID")
    ("name" "name - The name of the record")
    ("value" "value - The value of the record")
    ("type" "type - The type of the record")
    ("ttl" "ttl - The TTL of the record")
    ("priority" "priority - The priority of the record")
    ("domain_id" "domain_id - The domain ID of the record")
    ("hostname" "hostname - The FQDN of the record")

  ) company-terraform-resource-attributes-hash)

(puthash "docker_container" '(
    ("ip_address" "ip_address - The IP address of the container as read from its NetworkSettings.")
    ("ip_prefix_length" "ip_prefix_length - The IP prefix length of the container as read from its NetworkSettings.")
    ("gateway" "gateway - The network gateway of the container as read from its NetworkSettings.")
    ("bridge" "bridge - The network bridge of the container as read from its NetworkSettings.")

  ) company-terraform-resource-attributes-hash)

(puthash "docker_image" '(
    ("latest" "latest (string) - The ID of the image.")

  ) company-terraform-resource-attributes-hash)

(puthash "docker_network" '(
    ("id" "id (string)")
    ("scope" "scope (string)")

  ) company-terraform-resource-attributes-hash)

(puthash "docker_volume" '(
    ("mountpoint" "mountpoint (string) - The mountpoint of the volume.")

  ) company-terraform-resource-attributes-hash)

(puthash "dyn_record" '(
    ("id" "id - The record ID.")
    ("fqdn" "fqdn - The FQDN of the record, built from the name and the zone.")

  ) company-terraform-resource-attributes-hash)

(puthash "fastly_service_v1" '(
    ("id" "id - The ID of the Service.")
    ("name" "name – Name of this service.")
    ("active_version" "active_version - The currently active version of your Fastly Service.")
    ("domain" "domain – Set of Domains. See above for details.")
    ("backend" "backend – Set of Backends. See above for details.")
    ("header" "header – Set of Headers. See above for details.")
    ("s3logging" "s3logging – Set of S3 Logging configurations. See above for details.")
    ("papertrail" "papertrail – Set of Papertrail configurations. See above for details.")
    ("response_object" "response_object - Set of Response Object configurations. See above for details.")
    ("vcl" "vcl – Set of custom VCL configurations. See above for details.")
    ("default_host" "default_host – Default host specified.")
    ("default_ttl" "default_ttl - Default TTL.")
    ("force_destroy" "force_destroy - Force the destruction of the Service on delete.")

  ) company-terraform-resource-attributes-hash)

(puthash "github_branch_protection" '(

  ) company-terraform-resource-attributes-hash)

(puthash "github_membership" '(

  ) company-terraform-resource-attributes-hash)

(puthash "github_organization_webhook" '(
    ("url" "url - URL of the webhook")

  ) company-terraform-resource-attributes-hash)

(puthash "github_repository" '(
    ("full_name" "full_name - A string of the form \"orgname/reponame\".")
    ("html_url" "html_url - URL to the repository on the web.")
    ("ssh_clone_url" "ssh_clone_url - URL that can be provided to git clone to clone the repository via SSH.")
    ("http_clone_url" "http_clone_url - URL that can be provided to git clone to clone the repository via HTTPS.")
    ("git_clone_url" "git_clone_url - URL that can be provided to git clone to clone the repository anonymously via the git protocol.")
    ("svn_url" "svn_url - URL that can be provided to svn checkout to check out the repository via Github's Subversion protocol emulation.")

  ) company-terraform-resource-attributes-hash)

(puthash "github_repository_collaborator" '(

  ) company-terraform-resource-attributes-hash)

(puthash "github_repository_deploy_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "github_repository_webhook" '(
    ("url" "url - URL of the webhook")

  ) company-terraform-resource-attributes-hash)

(puthash "github_team" '(
    ("id" "id - The ID of the created team.")

  ) company-terraform-resource-attributes-hash)

(puthash "github_team_membership" '(

  ) company-terraform-resource-attributes-hash)

(puthash "github_team_repository" '(

  ) company-terraform-resource-attributes-hash)

(puthash "github_issue_label" '(

  ) company-terraform-resource-attributes-hash)

(puthash "gitlab_deploy_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "gitlab_group" '(
    ("id" "id - The unique id assigned to the group by the GitLab server.  Serves as a namespace id where one is needed.")

  ) company-terraform-resource-attributes-hash)

(puthash "gitlab_label" '(
    ("id" "id - The unique id assigned to the label by the GitLab server (the name of the label).")

  ) company-terraform-resource-attributes-hash)

(puthash "gitlab_project_hook" '(
    ("id" "id - The unique id assigned to the hook by the GitLab server.")

  ) company-terraform-resource-attributes-hash)

(puthash "gitlab_project" '(
    ("id" "id - Integer that uniquely identifies the project within the gitlab install.")
    ("ssh_url_to_repo" "ssh_url_to_repo - URL that can be provided to git clone to clone the repository via SSH.")
    ("http_url_to_repo" "http_url_to_repo - URL that can be provided to git clone to clone the repository via HTTP.")
    ("web_url" "web_url - URL that can be used to find the project in a browser.")

  ) company-terraform-resource-attributes-hash)

(puthash "gitlab_user" '(
    ("id" "id - The unique id assigned to the user by the GitLab server.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_bigquery_dataset" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("etag" "etag - A hash of the resource.")
    ("creation_time" "creation_time - The time when this dataset was created, in milliseconds since the epoch.")
    ("last_modified_time" "last_modified_time -  The date when this dataset or any of its tables was last modified, in milliseconds since the epoch.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_bigquery_table" '(
    ("creation_time" "creation_time - The time when this table was created, in milliseconds since the epoch.")
    ("etag" "etag - A hash of the resource.")
    ("last_modified_time" "last_modified_time - The time when this table was last modified, in milliseconds since the epoch.")
    ("location" "location - The geographic location where the table resides. This value is inherited from the dataset.")
    ("num_bytes" "num_bytes - The size of this table in bytes, excluding any data in the streaming buffer.")
    ("num_long_term_bytes" "num_long_term_bytes - The number of bytes in the table that are considered \"long-term storage\".")
    ("num_rows" "num_rows - The number of rows of data in this table, excluding any data in the streaming buffer.")
    ("self_link" "self_link - The URI of the created resource.")
    ("type" "type - Describes the table type.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_bigtable_instance" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_bigtable_table" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_cloudfunctions_function" '(
    ("https_trigger_url" "https_trigger_url - URL which triggers function execution. Returned only if trigger_http is used.")
    ("project" "project - Project of the function. If it is not provided, the provider project is used.")
    ("region" "region - Region of function. Currently can be only \"us-central1\". If it is not provided, the provider region is used.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_folder" '(
    ("name" "name - The resource name of the Folder. Its format is folders/{folder_id}.")
    ("lifecycle_state" "lifecycle_state - The lifecycle state of the folder such as ACTIVE or DELETE_REQUESTED.")
    ("create_time" "create_time - Timestamp when the Folder was created. Assigned by the server. A timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds. Example: \"2014-10-02T15:01:23.045123456Z\".")

  ) company-terraform-resource-attributes-hash)

(puthash "google_folder_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the folder's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_folder_iam_member" '(
    ("etag" "etag - (Computed) The etag of the folder's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_folder_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the folder's IAM policy. etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_folder_organization_policy" '(
    ("etag" "etag - (Computed) The etag of the organization policy. etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other.")
    ("update_time" "update_time - (Computed) The timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds, representing when the variable was last updated. Example: \"2016-10-09T12:33:37.578138407Z\".")

  ) company-terraform-resource-attributes-hash)

(puthash "google_organization_policy" '(
    ("etag" "etag - (Computed) The etag of the organization policy. etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other.")
    ("update_time" "update_time - (Computed) The timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds, representing when the variable was last updated. Example: \"2016-10-09T12:33:37.578138407Z\".")

  ) company-terraform-resource-attributes-hash)

(puthash "google_organization_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the organization's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_organization_iam_custom_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_organization_iam_member" '(
    ("etag" "etag - (Computed) The etag of the organization's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_organization_iam_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_project" '(
    ("number" "number - The numeric identifier of the project.")
    ("policy_etag" "policy_etag - (Deprecated) The etag of the project's IAM policy, used to determine if the IAM policy has changed. Please use google_project_iam_policy's etag property instead; future versions of Terraform will remove the policy_etag attribute")

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the project's IAM policy.")
    ("restore_policy" "restore_policy - (DEPRECATED) (Computed, only for google_project_iam_policy) The IAM policy that will be restored when a non-authoritative policy resource is deleted.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_iam_member" '(
    ("etag" "etag - (Computed) The etag of the project's IAM policy.")
    ("restore_policy" "restore_policy - (DEPRECATED) (Computed, only for google_project_iam_policy) The IAM policy that will be restored when a non-authoritative policy resource is deleted.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the project's IAM policy.")
    ("restore_policy" "restore_policy - (DEPRECATED) (Computed, only for google_project_iam_policy) The IAM policy that will be restored when a non-authoritative policy resource is deleted.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_iam_custom_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_organization_policy" '(
    ("etag" "etag - (Computed) The etag of the organization policy. etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other.")
    ("update_time" "update_time - (Computed) The timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds, representing when the variable was last updated. Example: \"2016-10-09T12:33:37.578138407Z\".")

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_service" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_services" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_project_usage_export_bucket" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_service_account" '(
    ("email" "email - The e-mail address of the service account. This value should be referenced from any google_iam_policy data sources that would grant the service account privileges.")
    ("name" "name - The fully-qualified name of the service account.")
    ("unique_id" "unique_id - The unique id of the service account.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_service_account_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the service account IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_service_account_iam_member" '(
    ("etag" "etag - (Computed) The etag of the service account IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_service_account_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the service account IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_service_account_key" '(
    ("name" "name - The name used for this key pair")
    ("public_key" "public_key - The public key, base64 encoded")
    ("private_key" "private_key - The private key in JSON format, base64 encoded. This is what you normally get as a file when creating service account keys through the CLI or web console. This is only populated when creating a new key, and when no  pgp_key is provided.")
    ("private_key_encrypted" "private_key_encrypted – The private key material, base 64 encoded and encrypted with the given pgp_key. This is only populated when creating a new key and pgp_key is supplied")
    ("private_key_fingerprint" "private_key_fingerprint - The MD5 public key fingerprint for the encrypted private key. This is only populated when creating a new key and pgp_key is supplied")
    ("valid_after" "valid_after - The key can be used after this timestamp. A timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds. Example: \"2014-10-02T15:01:23.045123456Z\".")
    ("valid_before" "valid_before - The key can be used before this timestamp. A timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds. Example: \"2014-10-02T15:01:23.045123456Z\".")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_address" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("address" "address - The IP of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_autoscaler" '(
    ("self_link" "self_link - The URL of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_backend_bucket" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_backend_service" '(
    ("fingerprint" "fingerprint - The fingerprint of the backend service.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_disk" '(
    ("disk_encryption_key_sha256" "disk_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.")
    ("self_link" "self_link - The URI of the created resource.")
    ("users" "users - The Users of the created resource.")
    ("label_fingerprint" "label_fingerprint - The fingerprint of the assigned labels.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_firewall" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_forwarding_rule" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_global_address" '(
    ("address" "address - The static external IP address represented by this resource.")
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_global_forwarding_rule" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("label_fingerprint" "label_fingerprint - (Beta) The current label fingerprint.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_health_check" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_http_health_check" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_https_health_check" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_image" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("label_fingerprint" "label_fingerprint - The fingerprint of the assigned labels.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_instance" '(
    ("instance_id" "instance_id - The server-assigned unique identifier of this instance.")
    ("metadata_fingerprint" "metadata_fingerprint - The unique fingerprint of the metadata.")
    ("self_link" "self_link - The URI of the created resource.")
    ("tags_fingerprint" "tags_fingerprint - The unique fingerprint of the tags.")
    ("label_fingerprint" "label_fingerprint - The unique fingerprint of the labels.")
    ("cpu_platform" "cpu_platform - The CPU platform used by this instance.")
    ("network_interface.0.address" "network_interface.0.address - The internal ip address of the instance, either manually or dynamically assigned.")
    ("network_interface.0.access_config.0.assigned_nat_ip" "network_interface.0.access_config.0.assigned_nat_ip - If the instance has an access config, either the given external ip (in the nat_ip field) or the ephemeral (generated) ip (if you didn't provide one).")
    ("attached_disk.0.disk_encryption_key_sha256" "attached_disk.0.disk_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.")
    ("boot_disk.disk_encryption_key_sha256" "boot_disk.disk_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.")
    ("disk.0.disk_encryption_key_sha256" "disk.0.disk_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_instance_group" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("size" "size - The number of instances in the group.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_instance_group_manager" '(
    ("fingerprint" "fingerprint - The fingerprint of the instance group manager.")
    ("instance_group" "instance_group - The full URL of the instance group created by the manager.")
    ("self_link" "self_link - The URL of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_instance_template" '(
    ("metadata_fingerprint" "metadata_fingerprint - The unique fingerprint of the metadata.")
    ("self_link" "self_link - The URI of the created resource.")
    ("tags_fingerprint" "tags_fingerprint - The unique fingerprint of the tags.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_network_peering" '(
    ("state" "state - State for the peering.")
    ("state_details" "state_details - Details about the current state of the peering.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_network" '(
    ("gateway_ipv4" "gateway_ipv4 - The IPv4 address of the gateway.")
    ("name" "name - The unique name of the network.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_project_metadata" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_project_metadata_item" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_region_autoscaler" '(
    ("self_link" "self_link - The URL of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_region_backend_service" '(
    ("fingerprint" "fingerprint - The fingerprint of the backend service.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_region_instance_group_manager" '(
    ("fingerprint" "fingerprint - The fingerprint of the instance group manager.")
    ("instance_group" "instance_group - The full URL of the instance group created by the manager.")
    ("self_link" "self_link - The URL of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_route" '(
    ("next_hop_network" "next_hop_network - The name of the next hop network, if available.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_router" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_router_interface" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_router_peer" '(
    ("ip_address" "ip_address - IP address of the interface inside Google Cloud Platform.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_security_policy" '(
    ("fingerprint" "fingerprint - Fingerprint of this resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_shared_vpc_host_project" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_shared_vpc_service_project" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_snapshot" '(
    ("snapshot_encryption_key_sha256" "snapshot_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.")
    ("source_disk_encryption_key_sha256" "source_disk_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects the source disk.")
    ("source_disk_link" "source_disk_link - The URI of the source disk.")
    ("self_link" "self_link - The URI of the created resource.")
    ("label_fingerprint" "label_fingerprint - The unique fingerprint of the labels.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_ssl_certificate" '(
    ("certificate_id" "certificate_id - A unique ID for the certificate, assigned by GCE.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_ssl_policy" '(
    ("enabled_features" "enabled_features - The set of enabled encryption ciphers as a result of the policy config")
    ("fingerprint" "fingerprint - Fingerprint of this resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_subnetwork" '(
    ("gateway_address" "gateway_address - The IP address of the gateway.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_subnetwork_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the subnetwork's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_subnetwork_iam_member" '(
    ("etag" "etag - (Computed) The etag of the subnetwork's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_subnetwork_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the subnetwork's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_target_http_proxy" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("proxy_id" "proxy_id - The unique identifier for the resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_target_https_proxy" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("proxy_id" "proxy_id - The unique identifier for the resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_target_ssl_proxy" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("proxy_id" "proxy_id - The unique identifier for the resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_target_tcp_proxy" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("proxy_id" "proxy_id - The unique identifier for the resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_target_pool" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_url_map" '(
    ("fingerprint" "fingerprint - The unique fingerprint for this resource.")
    ("map_id" "map_id - The GCE assigned ID of the resource.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_vpn_gateway" '(
    ("creation_timestamp" "creation_timestamp - Creation timestamp in RFC3339 text format.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_compute_vpn_tunnel" '(
    ("detailed_status" "detailed_status - Information about the status of the VPN tunnel.")
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_container_cluster" '(
    ("endpoint" "endpoint - The IP address of this cluster's Kubernetes master.")
    ("instance_group_urls" "instance_group_urls - List of instance group URLs which have been assigned to the cluster.")
    ("maintenance_policy.0.daily_maintenance_window.0.duration" "maintenance_policy.0.daily_maintenance_window.0.duration - Duration of the time window, automatically chosen to be smallest possible in the given scenario. Duration will be in RFC3339 format \"PTnHnMnS\".")
    ("master_auth.0.client_certificate" "master_auth.0.client_certificate - Base64 encoded public certificate used by clients to authenticate to the cluster endpoint.")
    ("master_auth.0.client_key" "master_auth.0.client_key - Base64 encoded private key used by clients to authenticate to the cluster endpoint.")
    ("master_auth.0.cluster_ca_certificate" "master_auth.0.cluster_ca_certificate - Base64 encoded public certificate that is the root of trust for the cluster.")
    ("master_version" "master_version - The current version of the master in the cluster. This may be different than the min_master_version set in the config if the master has been updated by GKE.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_container_node_pool" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_dataflow_job" '(
    ("state" "state - The current state of the resource, selected from the JobState enum")

  ) company-terraform-resource-attributes-hash)

(puthash "google_dataproc_cluster" '(
    ("cluster_config.master_config.instance_names" "cluster_config.master_config.instance_names - List of master instance names which have been assigned to the cluster.")
    ("cluster_config.worker_config.instance_names" "cluster_config.worker_config.instance_names - List of worker instance names which have been assigned to the cluster.")
    ("cluster_config.preemptible_worker_config.instance_names" "cluster_config.preemptible_worker_config.instance_names - List of preemptible instance names which have been assigned to the cluster.")
    ("cluster_config.bucket" "cluster_config.bucket - The name of the cloud storage bucket ultimately used to house the staging data for the cluster. If staging_bucket is specified, it will contain this value, otherwise it will be the auto generated name.")
    ("cluster_config.software_config.properties" "cluster_config.software_config.properties - A list of the properties used to set the daemon config files. This will include any values supplied by the user via cluster_config.software_config.override_properties")

  ) company-terraform-resource-attributes-hash)

(puthash "google_dataproc_job" '(
    ("reference.0.cluster_uuid" "reference.0.cluster_uuid - A cluster UUID generated by the Cloud Dataproc service when the job is submitted.")
    ("status.0.state" "status.0.state - A state message specifying the overall job state.")
    ("status.0.details" "status.0.details - Optional job state details, such as an error description if the state is ERROR.")
    ("status.0.state_start_time" "status.0.state_start_time - The time when this state was entered.")
    ("status.0.substate" "status.0.substate - Additional state information, which includes status reported by the agent.")
    ("driver_output_resource_uri" "driver_output_resource_uri - A URI pointing to the location of the stdout of the job's driver program.")
    ("driver_controls_files_uri" "driver_controls_files_uri - If present, the location of miscellaneous control files which may be used as part of job setup and handling. If not present, control files may be placed in the same location as driver_output_uri.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_dns_managed_zone" '(
    ("name_servers" "name_servers - The list of nameservers that will be authoritative for this domain. Use NS records to redirect from your DNS provider to these names, thus making Google Cloud DNS authoritative for this zone.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_dns_record_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_endpoints_service" '(
    ("name" "name: The FQDN of the API as described in the provided config.")
    ("syntax" "syntax: SYNTAX_PROTO2 or SYNTAX_PROTO3.")
    ("version" "version: A version string for this api. If specified, will have the form major-version.minor-version, e.g. 1.10.")
    ("methods" "methods: A list of Method objects; structure is documented below.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_topic" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_topic_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the topic's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_topic_iam_member" '(
    ("etag" "etag - (Computed) The etag of the topic's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_topic_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the topic's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_subscription" '(
    ("path" "path - Path of the subscription in the format projects/{project}/subscriptions/{sub}")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_subscription_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the subscription's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_subscription_iam_member" '(
    ("etag" "etag - (Computed) The etag of the subscription's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_pubsub_subscription_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the subscription's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_runtimeconfig_config" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_runtimeconfig_variable" '(
    ("update_time" "update_time - (Computed) The timestamp in RFC3339 UTC \"Zulu\" format, accurate to nanoseconds, representing when the variable was last updated. Example: \"2016-10-09T12:33:37.578138407Z\".")

  ) company-terraform-resource-attributes-hash)

(puthash "google_sourcerepo_repository" '(
    ("size" "size - The size of the repository.")
    ("url" "url - The url to clone the repository.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_database" '(
    ("state" "state - The current state of the database.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_database_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the database's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_database_iam_member" '(
    ("etag" "etag - (Computed) The etag of the database's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_database_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the database's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_instance" '(
    ("state" "state - The current state of the instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_instance_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the instance's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_instance_iam_member" '(
    ("etag" "etag - (Computed) The etag of the instance's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_spanner_instance_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the instance's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_sql_database" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_sql_database_instance" '(
    ("first_ip_address" "first_ip_address - The first IPv4 address of the addresses assigned. This is is to support accessing the first address in the list in a terraform output when the resource is configured with a count.")
    ("ip_address.0.ip_address" "ip_address.0.ip_address - The IPv4 address assigned.")
    ("ip_address.0.time_to_retire" "ip_address.0.time_to_retire - The time this IP address will be retired, in RFC 3339 format.")
    ("self_link" "self_link - The URI of the created resource.")
    ("settings.version" "settings.version - Used to make sure changes to the settings block are atomic.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_sql_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_logging_billing_account_sink" '(
    ("writer_identity" "writer_identity - The identity associated with this sink. This identity must be granted write access to the configured destination.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_logging_organization_sink" '(
    ("writer_identity" "writer_identity - The identity associated with this sink. This identity must be granted write access to the configured destination.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_logging_folder_sink" '(
    ("writer_identity" "writer_identity - The identity associated with this sink. This identity must be granted write access to the configured destination.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_logging_project_sink" '(
    ("writer_identity" "writer_identity - The identity associated with this sink. This identity must be granted write access to the configured destination.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_bucket" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("url" "url - The base URL of the bucket, in the format gs://<bucket-name>.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_bucket_acl" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_bucket_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the storage bucket's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_bucket_iam_member" '(
    ("etag" "etag - (Computed) The etag of the storage bucket's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_bucket_object" '(
    ("crc32c" "crc32c - (Computed) Base 64 CRC32 hash of the uploaded data.")
    ("md5hash" "md5hash - (Computed) Base 64 MD5 hash of the uploaded data.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_default_object_acl" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_notification" '(
    ("self_link" "self_link - The URI of the created resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_storage_object_acl" '(

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_key_ring" '(
    ("id" "id - The ID of the created KeyRing. Its format is {projectId}/{location}/{keyRingName}.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_key_ring_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the key ring's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_key_ring_iam_member" '(
    ("etag" "etag - (Computed) The etag of the key ring's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_key_ring_iam_policy" '(
    ("etag" "etag - (Computed) The etag of the key ring's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_crypto_key" '(
    ("id" "id - The ID of the created CryptoKey. Its format is {projectId}/{location}/{keyRingName}/{cryptoKeyName}.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_crypto_key_iam_binding" '(
    ("etag" "etag - (Computed) The etag of the crypto key's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_kms_crypto_key_iam_member" '(
    ("etag" "etag - (Computed) The etag of the project's IAM policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "google_cloudiot_registry" '(

  ) company-terraform-resource-attributes-hash)

(puthash "grafana_alert_notification" '(
    ("id" "id - The ID of the resource")

  ) company-terraform-resource-attributes-hash)

(puthash "grafana_dashboard" '(
    ("slug" "slug - A URL \"slug\" for this dashboard, generated by Grafana by removing certain characters from the dashboard name given as part of the config_json argument. This can be used to generate the URL for a dashboard.")

  ) company-terraform-resource-attributes-hash)

(puthash "grafana_data_source" '(
    ("id" "id - The opaque unique id assigned to the data source by the Grafana server.")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_addon" '(
    ("id" "id - The ID of the add-on")
    ("name" "name - The add-on name")
    ("plan" "plan - The plan name")
    ("provider_id" "provider_id - The ID of the plan provider")
    ("config_vars" "config_vars - The Configuration variables of the add-on")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_addon_attachment" '(
    ("id" "id - The unique ID of the add-on attachment")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_app" '(
    ("id" "id - The ID of the app. This is also the name of the application.")
    ("name" "name - The name of the application. In Heroku, this is also the unique ID.")
    ("stack" "stack - The application stack is what platform to run the application in.")
    ("space" "space - The private space the app should run in.")
    ("region" "region - The region that the app should be deployed in.")
    ("git_url" "git_url - The Git URL for the application. This is used for deploying new versions of the app.")
    ("web_url" "web_url - The web (HTTP) URL that the application can be accessed at by default.")
    ("heroku_hostname" "heroku_hostname - A hostname for the Heroku application, suitable for pointing DNS records.")
    ("all_config_vars" "all_config_vars - A map of all of the configuration variables that exist for the app, containing both those set by Terraform and those set externally.")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_app_feature" '(

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_cert" '(
    ("id" "id - The ID of the add-on")
    ("cname" "cname - The CNAME for the SSL endpoint")
    ("name" "name - The name of the SSL certificate")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_domain" '(
    ("id" "id - The ID of the of the domain record.")
    ("hostname" "hostname - The hostname traffic will be served as.")
    ("cname" "cname - The CNAME traffic should route to.")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_drain" '(
    ("token" "token - The unique token for your created drain.")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_pipeline" '(
    ("id" "id - The UUID of the pipeline.")
    ("name" "name - The name of the pipeline.")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_pipeline_coupling" '(
    ("id" "id - The UUID of this pipeline coupling.")
    ("app" "app - The name of the application.")
    ("app_id" "app_id - The ID of the application.")
    ("pipeline" "pipeline - The UUID of the pipeline.")
    ("stage" "stage - The stage for this coupling.")

  ) company-terraform-resource-attributes-hash)

(puthash "heroku_space" '(
    ("id" "id - The ID of the space.")
    ("name" "name - The space's name.")
    ("organization" "organization - The space's organization.")
    ("region" "region - The space's region.")

  ) company-terraform-resource-attributes-hash)

(puthash "icinga2_checkcommand" '(

  ) company-terraform-resource-attributes-hash)

(puthash "icinga2_host" '(

  ) company-terraform-resource-attributes-hash)

(puthash "icinga2_hostgroup" '(

  ) company-terraform-resource-attributes-hash)

(puthash "icinga2_service" '(

  ) company-terraform-resource-attributes-hash)

(puthash "influxdb_database" '(

  ) company-terraform-resource-attributes-hash)

(puthash "influxdb_user" '(
    ("admin" "admin - (Bool) indication if the user is an admin or not.")

  ) company-terraform-resource-attributes-hash)

(puthash "influxdb_continuous_query" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_config_map" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_horizontal_pod_autoscaler" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_limit_range" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_namespace" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_persistent_volume" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_persistent_volume_claim" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_pod" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_replication_controller" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_resource_quota" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_secret" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_service" '(

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_service_account" '(
    ("default_secret_name" "default_secret_name - Name of the default secret the is created & managed by the service")

  ) company-terraform-resource-attributes-hash)

(puthash "kubernetes_storage_class" '(

  ) company-terraform-resource-attributes-hash)

(puthash "librato_alert" '(
    ("id" "id - The ID of the alert.")
    ("name" "name - The name of the alert.")
    ("description" "description - (Required) Description of the alert.")
    ("active" "active - whether the alert is active (can be triggered). Defaults to true.")
    ("rearm_seconds" "rearm_seconds - minimum amount of time between sending alert notifications, in seconds.")
    ("services" "services - list of notification service IDs.")
    ("condition" "condition - A trigger condition for the alert. Conditions documented below.")

  ) company-terraform-resource-attributes-hash)

(puthash "librato_metric" '(
    ("name" "name - The identifier for the metric.")
    ("display_name" "display_name - The name which will be used for the metric when viewing the Metrics website.")
    ("type" "type - The type of metric to create (gauge, counter, or composite).")
    ("description" "description - Text that describes precisely what the metric is measuring.")
    ("period" "period - Number of seconds that is the standard reporting period of the metric. Setting the period enables Metrics to detect abnormal interruptions in reporting and aids in analytics. For gauge metrics that have service-side aggregation enabled, this option will define the period that aggregation occurs on.")
    ("source_lag" "source_lag -")
    ("composite" "composite - The composite definition. Only used when type is composite.")

  ) company-terraform-resource-attributes-hash)

(puthash "librato_service" '(
    ("id" "id - The ID of the alert.")
    ("type" "type - The type of notificaion.")
    ("title" "title - The alert title.")
    ("settings" "settings - a JSON hash of settings specific to the alert type.")

  ) company-terraform-resource-attributes-hash)

(puthash "librato_space" '(
    ("id" "id - The ID of the space.")
    ("name" "name - The name of the space.")

  ) company-terraform-resource-attributes-hash)

(puthash "librato_space_chart" '(
    ("id" "id - The ID of the chart.")
    ("space_id" "space_id - The ID of the space this chart should be in.")
    ("title" "title - The title of the chart when it is displayed.")

  ) company-terraform-resource-attributes-hash)

(puthash "file" '(

  ) company-terraform-resource-attributes-hash)

(puthash "logentries_log" '(
    ("token" "token - If the log source is token, this value holds the generated log token that is used by logging clients. See the Logentries token-based input documentation for more information.")

  ) company-terraform-resource-attributes-hash)

(puthash "logentries_logset" '(

  ) company-terraform-resource-attributes-hash)

(puthash "logicmonitor_collector" '(

  ) company-terraform-resource-attributes-hash)

(puthash "logicmonitor_collectorgroup" '(

  ) company-terraform-resource-attributes-hash)

(puthash "logicmonitor_device" '(

  ) company-terraform-resource-attributes-hash)

(puthash "logicmonitor_devicegroup" '(

  ) company-terraform-resource-attributes-hash)

(puthash "mailgun_domain" '(
    ("name" "name - The name of the domain.")
    ("smtp_login" "smtp_login - The login email for the SMTP server.")
    ("smtp_password" "smtp_password - The password to the SMTP server.")
    ("wildcard" "wildcard - Whether or not the domain will accept email for sub-domains.")
    ("spam_action" "spam_action - The spam filtering setting.")
    ("receiving_records" "receiving_records - A list of DNS records for receiving validation.   priority - The priority of the record.  record_type - The record type.  valid - \"valid\" if the record is valid.  value - The value of the record.")
    ("sending_records" "sending_records - A list of DNS records for sending validation.   name - The name of the record.  record_type - The record type.  valid - \"valid\" if the record is valid.  value - The value of the record.")

  ) company-terraform-resource-attributes-hash)

(puthash "mysql_database" '(

  ) company-terraform-resource-attributes-hash)

(puthash "mysql_grant" '(

  ) company-terraform-resource-attributes-hash)

(puthash "mysql_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "newrelic_alert_channel" '(
    ("id" "id - The ID of the channel.")

  ) company-terraform-resource-attributes-hash)

(puthash "newrelic_alert_condition" '(
    ("id" "id - The ID of the alert condition.")

  ) company-terraform-resource-attributes-hash)

(puthash "newrelic_alert_policy" '(
    ("id" "id - The ID of the policy.")
    ("created_at" "created_at - The time the policy was created.")
    ("updated_at" "updated_at - The time the policy was last updated.")

  ) company-terraform-resource-attributes-hash)

(puthash "newrelic_alert_policy_channel" '(

  ) company-terraform-resource-attributes-hash)

(puthash "newrelic_nrql_alert_condition" '(
    ("id" "id - The ID of the NRQL alert condition.")

  ) company-terraform-resource-attributes-hash)

(puthash "newrelic_dashboard" '(
    ("id" "id - The ID of the dashboard.")

  ) company-terraform-resource-attributes-hash)

(puthash "nomad_acl_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nomad_acl_token" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nomad_job" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nomad_namespace" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nomad_quota_specification" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nomad_sentinel_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_zone" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_record" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_monitoringjob" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_notifylist" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_datasource" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_datafeed" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_apikey" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_team" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ns1_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "docs-oneandone-datasource-instance-size" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_block_storage" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_firewall_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_loadbalancer" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_monitoring_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_private_network" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_public_ip" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_server" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_shared_storage" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_ssh_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oneandone_vpn" '(

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_blockstorage_volume_v1" '(
    ("region" "region - See Argument Reference above.")
    ("size" "size - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("availability_zone" "availability_zone - See Argument Reference above.")
    ("image_id" "image_id - See Argument Reference above.")
    ("source_vol_id" "source_vol_id - See Argument Reference above.")
    ("snapshot_id" "snapshot_id - See Argument Reference above.")
    ("metadata" "metadata - See Argument Reference above.")
    ("volume_type" "volume_type - See Argument Reference above.")
    ("attachment" "attachment - If a volume is attached to an instance, this attribute will display the Attachment ID, Instance ID, and the Device as the Instance sees it.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_blockstorage_volume_v2" '(
    ("region" "region - See Argument Reference above.")
    ("size" "size - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("availability_zone" "availability_zone - See Argument Reference above.")
    ("image_id" "image_id - See Argument Reference above.")
    ("source_vol_id" "source_vol_id - See Argument Reference above.")
    ("snapshot_id" "snapshot_id - See Argument Reference above.")
    ("metadata" "metadata - See Argument Reference above.")
    ("volume_type" "volume_type - See Argument Reference above.")
    ("attachment" "attachment - If a volume is attached to an instance, this attribute will display the Attachment ID, Instance ID, and the Device as the Instance sees it.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_blockstorage_volume_attach_v2" '(
    ("data" "data - This is a map of key/value pairs that contain the connection information. You will want to pass this information to a provisioner script to finalize the connection. See below for more information.")
    ("driver_volume_type" "driver_volume_type - The storage driver that the volume is based on.")
    ("mount_point_base" "mount_point_base - A mount point base name for shared storage.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_blockstorage_volume_v3" '(
    ("region" "region - See Argument Reference above.")
    ("size" "size - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("availability_zone" "availability_zone - See Argument Reference above.")
    ("image_id" "image_id - See Argument Reference above.")
    ("source_vol_id" "source_vol_id - See Argument Reference above.")
    ("snapshot_id" "snapshot_id - See Argument Reference above.")
    ("metadata" "metadata - See Argument Reference above.")
    ("volume_type" "volume_type - See Argument Reference above.")
    ("attachment" "attachment - If a volume is attached to an instance, this attribute will display the Attachment ID, Instance ID, and the Device as the Instance sees it.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_blockstorage_volume_attach_v3" '(
    ("data" "data - This is a map of key/value pairs that contain the connection information. You will want to pass this information to a provisioner script to finalize the connection. See below for more information.")
    ("driver_volume_type" "driver_volume_type - The storage driver that the volume is based on.")
    ("mount_point_base" "mount_point_base - A mount point base name for shared storage.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_flavor_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("ram" "ram - See Argument Reference above.")
    ("vcpus" "vcpus - See Argument Reference above.")
    ("disk" "disk - See Argument Reference above.")
    ("swap" "swap - See Argument Reference above.")
    ("rx_tx_factor" "rx_tx_factor - See Argument Reference above.")
    ("is_public" "is_public - See Argument Reference above.")
    ("extra_specs" "extra_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_floatingip_v2" '(
    ("region" "region - See Argument Reference above.")
    ("pool" "pool - See Argument Reference above.")
    ("address" "address - The actual floating IP address itself.")
    ("fixed_ip" "fixed_ip - The fixed IP address corresponding to the floating IP.")
    ("instance_id" "instance_id - UUID of the compute instance associated with the floating IP.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_floatingip_associate_v2" '(
    ("region" "region - See Argument Reference above.")
    ("floating_ip" "floating_ip - See Argument Reference above.")
    ("instance_id" "instance_id - See Argument Reference above.")
    ("fixed_ip" "fixed_ip - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_instance_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("access_ip_v4" "access_ip_v4 - The first detected Fixed IPv4 address or the Floating IP.")
    ("access_ip_v6" "access_ip_v6 - The first detected Fixed IPv6 address.")
    ("metadata" "metadata - See Argument Reference above.")
    ("security_groups" "security_groups - See Argument Reference above.")
    ("flavor_id" "flavor_id - See Argument Reference above.")
    ("flavor_name" "flavor_name - See Argument Reference above.")
    ("network/uuid" "network/uuid - See Argument Reference above.")
    ("network/name" "network/name - See Argument Reference above.")
    ("network/port" "network/port - See Argument Reference above.")
    ("network/fixed_ip_v4" "network/fixed_ip_v4 - The Fixed IPv4 address of the Instance on that network.")
    ("network/fixed_ip_v6" "network/fixed_ip_v6 - The Fixed IPv6 address of the Instance on that network.")
    ("network/mac" "network/mac - The MAC address of the NIC on that network.")
    ("all_metadata" "all_metadata - Contains all instance metadata, even metadata not set by Terraform.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_keypair_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("public_key" "public_key - See Argument Reference above.")
    ("fingerprint" "fingerprint - The fingerprint of the public key.")
    ("private_key" "private_key - The generated private key when no public key is specified.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_secgroup_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("rule" "rule - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_servergroup_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("policies" "policies - See Argument Reference above.")
    ("members" "members - The instances that are part of this server group.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_compute_volume_attach_v2" '(
    ("region" "region - See Argument Reference above.")
    ("instance_id" "instance_id - See Argument Reference above.")
    ("volume_id" "volume_id - See Argument Reference above.")
    ("device" "device - See Argument Reference above. NOTE: The correctness of this information is dependent upon the hypervisor in use. In some cases, this should not be used as an authoritative piece of information.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_db_instance_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("size" "size - See Argument Reference above.")
    ("flavor_id" "flavor_id - See Argument Reference above.")
    ("configuration_id" "configuration_id - See Argument Reference above.")
    ("datastore/type" "datastore/type - See Argument Reference above.")
    ("datastore/version" "datastore/version - See Argument Reference above.")
    ("network/uuid" "network/uuid - See Argument Reference above.")
    ("network/port" "network/port - See Argument Reference above.")
    ("network/fixed_ip_v4" "network/fixed_ip_v4 - The Fixed IPv4 address of the Instance on that network.")
    ("network/fixed_ip_v6" "network/fixed_ip_v6 - The Fixed IPv6 address of the Instance on that")
    ("database/name" "database/name - See Argument Reference above.")
    ("database/collate" "database/collate - See Argument Reference above.")
    ("database/charset" "database/charset - See Argument Reference above.")
    ("user/name" "user/name - See Argument Reference above.")
    ("user/password" "user/password - See Argument Reference above.")
    ("user/databases" "user/databases - See Argument Reference above.")
    ("user/host" "user/host - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_db_database_v1" '(
    ("region" "region - Openstack region resource is created in.")
    ("name" "name - See Argument Reference above.")
    ("instance_id" "instance_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_db_user_v1" '(
    ("region" "region - Openstack region resource is created in.")
    ("name" "name - See Argument Reference above.")
    ("instance" "instance - See Argument Reference above.")
    ("password" "password - See Argument Reference above.")
    ("databases" "databases - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_db_configuration_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("datastore/type" "datastore/type - See Argument Reference above.")
    ("datastore/version" "datastore/version - See Argument Reference above.")
    ("configuration/name" "configuration/name - See Argument Reference above.")
    ("configuration/value" "configuration/value - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_dns_recordset_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("records" "records - See Argument Reference above.")
    ("zone_id" "zone_id - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_dns_zone_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("email" "email - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("attributes" "attributes - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("masters" "masters - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_identity_project_v3" '(
    ("domain_id" "domain_id - See Argument Reference above.")
    ("parent_id" "parent_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_identity_role_v3" '(
    ("name" "name - See Argument Reference above.")
    ("domain_id" "domain_id - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_identity_role_assignment_v3" '(
    ("domain_id" "domain_id - See Argument Reference above.")
    ("project_id" "project_id - See Argument Reference above.")
    ("group_id" "group_id - See Argument Reference above.")
    ("user_id" "user_id - See Argument Reference above.")
    ("role_id" "role_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_identity_user_v3" '(
    ("domain_id" "domain_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_images_image_v2" '(
    ("checksum" "checksum - The checksum of the data associated with the image.")
    ("container_format" "container_format - See Argument Reference above.")
    ("created_at" "created_at - The date the image was created.")
    ("disk_format" "disk_format - See Argument Reference above.")
    ("file" "file - the trailing path after the glance endpoint that represent the location of the image or the path to retrieve it.")
    ("id" "id - A unique ID assigned by Glance.")
    ("metadata" "metadata - The metadata associated with the image. Image metadata allow for meaningfully define the image properties and tags. See http://docs.openstack.org/developer/glance/metadefs-concepts.html.")
    ("min_disk_gb" "min_disk_gb - See Argument Reference above.")
    ("min_ram_mb" "min_ram_mb - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("owner" "owner - The id of the openstack user who owns the image.")
    ("properties" "properties - See Argument Reference above.")
    ("protected" "protected - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")
    ("schema" "schema - The path to the JSON-schema that represent the image or image")
    ("size_bytes" "size_bytes - The size in bytes of the data associated with the image.")
    ("status" "status - The status of the image. It can be \"queued\", \"active\" or \"saving\".")
    ("tags" "tags - See Argument Reference above.")
    ("update_at" "update_at - The date the image was last updated.")
    ("visibility" "visibility - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_floatingip_v2" '(
    ("region" "region - See Argument Reference above.")
    ("pool" "pool - See Argument Reference above.")
    ("address" "address - The actual floating IP address itself.")
    ("port_id" "port_id - ID of associated port.")
    ("tenant_id" "tenant_id - the ID of the tenant in which to create the floating IP.")
    ("fixed_ip" "fixed_ip - The fixed IP which the floating IP maps to.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_floatingip_associate_v2" '(
    ("region" "region - See Argument Reference above.")
    ("floating_ip" "floating_ip - See Argument Reference above.")
    ("port_id" "port_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_network_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("shared" "shared - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("availability_zone_hints" "availability_zone_hints - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_port_v2" '(
    ("region" "region - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("mac_address" "mac_address - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("device_owner" "device_owner - See Argument Reference above.")
    ("security_group_ids" "security_group_ids - See Argument Reference above.")
    ("device_id" "device_id - See Argument Reference above.")
    ("fixed_ip" "fixed_ip - See Argument Reference above.")
    ("all_fixed_ips" "all_fixed_ips - The collection of Fixed IP addresses on the port in the order returned by the Network v2 API.")
    ("all_security_group_ids" "all_security_group_ids - The collection of Security Group IDs on the port which have been explicitly and implicitly added.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_router_interface_v2" '(
    ("region" "region - See Argument Reference above.")
    ("router_id" "router_id - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("port_id" "port_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_router_route_v2" '(
    ("region" "region - See Argument Reference above.")
    ("router_id" "router_id - See Argument Reference above.")
    ("destination_cidr" "destination_cidr - See Argument Reference above.")
    ("next_hop" "next_hop - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_router_v2" '(
    ("id" "id - ID of the router.")
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("external_gateway" "external_gateway - See Argument Reference above.")
    ("external_network_id" "external_network_id - See Argument Reference above.")
    ("enable_snat" "enable_snat - See Argument Reference above.")
    ("external_fixed_ip" "external_fixed_ip - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")
    ("availability_zone_hints" "availability_zone_hints - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_subnet_v2" '(
    ("region" "region - See Argument Reference above.")
    ("network_id" "network_id - See Argument Reference above.")
    ("cidr" "cidr - See Argument Reference above.")
    ("ip_version" "ip_version - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("allocation_pools" "allocation_pools - See Argument Reference above.")
    ("gateway_ip" "gateway_ip - See Argument Reference above.")
    ("enable_dhcp" "enable_dhcp - See Argument Reference above.")
    ("dns_nameservers" "dns_nameservers - See Argument Reference above.")
    ("host_routes" "host_routes - See Argument Reference above.")
    ("subnetpool_id" "subnetpool_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_subnet_route_v2" '(
    ("region" "region - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("destination_cidr" "destination_cidr - See Argument Reference above.")
    ("next_hop" "next_hop - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_subnetpool_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("default_quota" "default_quota - See Argument Reference above.")
    ("project_id" "project_id - See Argument Reference above.")
    ("created_at" "created_at - The time at which subnetpool was created.")
    ("updated_at" "updated_at - The time at which subnetpool was created.")
    ("prefixes" "prefixes - See Argument Reference above.")
    ("default_prefixlen" "default_prefixlen - See Argument Reference above.")
    ("min_prefixlen" "min_prefixlen - See Argument Reference above.")
    ("max_prefixlen" "max_prefixlen - See Argument Reference above.")
    ("address_scope_id" "address_scope_id - See Argument Reference above.")
    ("ip_version" "ip_version - The IP protocol version.")
    ("shared" "shared - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("is_default" "is_default - See Argument Reference above.")
    ("revision_number" "revision_number - The revision number of the subnetpool.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_secgroup_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_networking_secgroup_rule_v2" '(
    ("region" "region - See Argument Reference above.")
    ("direction" "direction - See Argument Reference above.")
    ("ethertype" "ethertype - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("port_range_min" "port_range_min - See Argument Reference above.")
    ("port_range_max" "port_range_max - See Argument Reference above.")
    ("remote_ip_prefix" "remote_ip_prefix - See Argument Reference above.")
    ("remote_group_id" "remote_group_id - See Argument Reference above.")
    ("security_group_id" "security_group_id - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_member_v1" '(
    ("region" "region - See Argument Reference above.")
    ("pool_id" "pool_id - See Argument Reference above.")
    ("address" "address - See Argument Reference above.")
    ("port" "port - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("weight" "weight - The load balancing weight of the member. This is currently unable to be set through Terraform.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_monitor_v1" '(
    ("region" "region - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("delay" "delay - See Argument Reference above.")
    ("timeout" "timeout - See Argument Reference above.")
    ("max_retries" "max_retries - See Argument Reference above.")
    ("url_path" "url_path - See Argument Reference above.")
    ("http_method" "http_method - See Argument Reference above.")
    ("expected_codes" "expected_codes - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_pool_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("lb_method" "lb_method - See Argument Reference above.")
    ("lb_provider" "lb_provider - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("monitor_id" "monitor_id - See Argument Reference above.")
    ("member" "member - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_vip_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("port" "port - See Argument Reference above.")
    ("pool_id" "pool_id - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("address" "address - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("persistence" "persistence - See Argument Reference above.")
    ("conn_limit" "conn_limit - See Argument Reference above.")
    ("floating_ip" "floating_ip - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("port_id" "port_id - Port UUID for this VIP at associated floating IP (if any).")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_loadbalancer_v2" '(
    ("region" "region - See Argument Reference above.")
    ("vip_subnet_id" "vip_subnet_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("vip_address" "vip_address - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("flavor" "flavor - See Argument Reference above.")
    ("loadbalancer_provider" "loadbalancer_provider - See Argument Reference above.")
    ("security_group_ids" "security_group_ids - See Argument Reference above.")
    ("vip_port_id" "vip_port_id - The Port ID of the Load Balancer IP.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_listener_v2" '(
    ("id" "id - The unique ID for the Listener.")
    ("protocol" "protocol - See Argument Reference above.")
    ("protocol_port" "protocol_port - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("default_port_id" "default_port_id - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("connection_limit" "connection_limit - See Argument Reference above.")
    ("default_tls_container_ref" "default_tls_container_ref - See Argument Reference above.")
    ("sni_container_refs" "sni_container_refs - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_pool_v2" '(
    ("id" "id - The unique ID for the pool.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("lb_method" "lb_method - See Argument Reference above.")
    ("persistence" "persistence - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_member_v2" '(
    ("id" "id - The unique ID for the member.")
    ("name" "name - See Argument Reference above.")
    ("weight" "weight - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("pool_id" "pool_id - See Argument Reference above.")
    ("address" "address - See Argument Reference above.")
    ("protocol_port" "protocol_port - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_lb_monitor_v2" '(
    ("id" "id - The unique ID for the monitor.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("delay" "delay - See Argument Reference above.")
    ("timeout" "timeout - See Argument Reference above.")
    ("max_retries" "max_retries - See Argument Reference above.")
    ("url_path" "url_path - See Argument Reference above.")
    ("http_method" "http_method - See Argument Reference above.")
    ("expected_codes" "expected_codes - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_fw_firewall_v1" '(
    ("region" "region - See Argument Reference above.")
    ("policy_id" "policy_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("associated_routers" "associated_routers - See Argument Reference above.")
    ("no_routers" "no_routers - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_fw_policy_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("audited" "audited - See Argument Reference above.")
    ("shared" "shared - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_fw_rule_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("action" "action - See Argument Reference above.")
    ("ip_version" "ip_version - See Argument Reference above.")
    ("source_ip_address" "source_ip_address - See Argument Reference above.")
    ("destination_ip_address" "destination_ip_address - See Argument Reference above.")
    ("source_port" "source_port - See Argument Reference above.")
    ("destination_port" "destination_port - See Argument Reference above.")
    ("enabled" "enabled - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_objectstorage_container_v1" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("container_read" "container_read - See Argument Reference above.")
    ("container_sync_to" "container_sync_to - See Argument Reference above.")
    ("container_sync_key" "container_sync_key - See Argument Reference above.")
    ("container_write" "container_write - See Argument Reference above.")
    ("metadata" "metadata - See Argument Reference above.")
    ("content_type" "content_type - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_objectstorage_object_v1" '(
    ("content_length" "content_length - If the operation succeeds, this value is zero (0) or the  length of informational or error text in the response body.")
    ("content_type" "content_type - If the operation succeeds, this value is the MIME type of the object.  If the operation fails, this value is the MIME type of the error text in the response  body.")
    ("date" "date - The date and time the system responded to the request, using the preferred  format of RFC 7231 as shown in this example Thu, 16 Jun 2016 15:10:38 GMT. The  time is always in UTC.")
    ("etag" "etag - Whatever the value given in argument, will be overriden by the MD5 checksum of the uploaded object content. The value is not quoted.  If it is an SLO, it would be MD5 checksum of the segments’ etags.")
    ("last_modified" "last_modified - The date and time when the object was last modified. The date and time  stamp format is ISO 8601:    CCYY-MM-DDThh:mm:ss±hh:mm For example, 2015-08-27T09:49:58-05:00. The ±hh:mm value, if included, is the time zone as an offset from UTC. In the previous  example, the offset value is -05:00.")
    ("static_large_object" "static_large_object - True if object is a multipart_manifest.")
    ("trans_id" "trans_id - A unique transaction ID for this request. Your service provider might  need this value if you report a problem.")
    ("container_name" "container_name - See Argument Reference above.")
    ("content" "content - See Argument Reference above.")
    ("content_disposition" "content_disposition - See Argument Reference above.")
    ("content_encoding" "content_encoding - See Argument Reference above.")
    ("copy_from" "copy_from - See Argument Reference above.")
    ("delete_after" "delete_after - See Argument Reference above.")
    ("delete_at" "delete_at - See Argument Reference above.")
    ("detect_content_type" "detect_content_type - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("object_manifest" "object_manifest - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")
    ("source" "source - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_vpnaas_ipsec_policy_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("auth_algorithm" "auth_algorithm - See Argument Reference above.")
    ("encapsulation_mode" "encapsulation_mode - See Argument Reference above.")
    ("encryption_algorithm" "encryption_algorithm - See Argument Reference above.")
    ("pfs" "pfs - See Argument Reference above.")
    ("transform_protocol" "transform_protocol - See Argument Reference above.")
    ("lifetime" "lifetime - See Argument Reference above.   unit - See Argument Reference above.  value - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_vpnaas_ike_policy_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("auth_algorithm" "auth_algorithm - See Argument Reference above.")
    ("encapsulation_mode" "encapsulation_mode - See Argument Reference above.")
    ("encryption_algorithm" "encryption_algorithm - See Argument Reference above.")
    ("pfs" "pfs - See Argument Reference above.")
    ("transform_protocol" "transform_protocol - See Argument Reference above.")
    ("lifetime" "lifetime - See Argument Reference above.   unit - See Argument Reference above.  value - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_vpnaas_service_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("router_id" "router_id - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("status" "status - Indicates whether IPsec VPN service is currently operational. Values are ACTIVE, DOWN, BUILD, ERROR, PENDING_CREATE, PENDING_UPDATE, or PENDING_DELETE.")
    ("external_v6_ip" "external_v6_ip - The read-only external (public) IPv6 address that is used for the VPN service.")
    ("external_v4_ip" "external_v4_ip - The read-only external (public) IPv4 address that is used for the VPN service.")
    ("description" "description - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "openstack_vpnaas_endpoint_group_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("endpoints" "endpoints - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_blockstorage_volume_v2" '(
    ("region" "region - See Argument Reference above.")
    ("size" "size - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("availability_zone" "availability_zone - See Argument Reference above.")
    ("image_id" "image_id - See Argument Reference above.")
    ("source_vol_id" "source_vol_id - See Argument Reference above.")
    ("snapshot_id" "snapshot_id - See Argument Reference above.")
    ("metadata" "metadata - See Argument Reference above.")
    ("volume_type" "volume_type - See Argument Reference above.")
    ("attachment" "attachment - If a volume is attached to an instance, this attribute will display the Attachment ID, Instance ID, and the Device as the Instance sees it.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_floatingip_v2" '(
    ("region" "region - See Argument Reference above.")
    ("pool" "pool - See Argument Reference above.")
    ("address" "address - The actual floating IP address itself.")
    ("fixed_ip" "fixed_ip - The fixed IP address corresponding to the floating IP.")
    ("instance_id" "instance_id - UUID of the compute instance associated with the floating IP.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_floatingip_associate_v2" '(
    ("region" "region - See Argument Reference above.")
    ("floating_ip" "floating_ip - See Argument Reference above.")
    ("instance_id" "instance_id - See Argument Reference above.")
    ("fixed_ip" "fixed_ip - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_instance_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("access_ip_v4" "access_ip_v4 - The first detected Fixed IPv4 address or the Floating IP.")
    ("access_ip_v6" "access_ip_v6 - The first detected Fixed IPv6 address.")
    ("metadata" "metadata - See Argument Reference above.")
    ("security_groups" "security_groups - See Argument Reference above.")
    ("flavor_id" "flavor_id - See Argument Reference above.")
    ("flavor_name" "flavor_name - See Argument Reference above.")
    ("network/uuid" "network/uuid - See Argument Reference above.")
    ("network/name" "network/name - See Argument Reference above.")
    ("network/port" "network/port - See Argument Reference above.")
    ("network/fixed_ip_v4" "network/fixed_ip_v4 - The Fixed IPv4 address of the Instance on that network.")
    ("network/fixed_ip_v6" "network/fixed_ip_v6 - The Fixed IPv6 address of the Instance on that network.")
    ("network/mac" "network/mac - The MAC address of the NIC on that network.")
    ("all_metadata" "all_metadata - Contains all instance metadata, even metadata not set by Terraform.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_keypair_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("public_key" "public_key - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_secgroup_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("rule" "rule - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_servergroup_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("policies" "policies - See Argument Reference above.")
    ("members" "members - The instances that are part of this server group.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_compute_volume_attach_v2" '(
    ("region" "region - See Argument Reference above.")
    ("instance_id" "instance_id - See Argument Reference above.")
    ("volume_id" "volume_id - See Argument Reference above.")
    ("device" "device - See Argument Reference above. NOTE: The correctness of this information is dependent upon the hypervisor in use. In some cases, this should not be used as an authoritative piece of information.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_dns_recordset_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("records" "records - See Argument Reference above.")
    ("zone_id" "zone_id - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_dns_zone_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("email" "email - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("attributes" "attributes - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("masters" "masters - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_images_image_v2" '(
    ("checksum" "checksum - The checksum of the data associated with the image.")
    ("container_format" "container_format - See Argument Reference above.")
    ("created_at" "created_at - The date the image was created.")
    ("disk_format" "disk_format - See Argument Reference above.")
    ("file" "file - the trailing path after the glance endpoint that represent the location of the image or the path to retrieve it.")
    ("id" "id - A unique ID assigned by Glance.")
    ("metadata" "metadata - The metadata associated with the image. Image metadata allow for meaningfully define the image properties and tags. See http://docs.openstack.org/developer/glance/metadefs-concepts.html.")
    ("min_disk_gb" "min_disk_gb - See Argument Reference above.")
    ("min_ram_mb" "min_ram_mb - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("owner" "owner - The id of the opentelekomcloud user who owns the image.")
    ("protected" "protected - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")
    ("schema" "schema - The path to the JSON-schema that represent the image or image")
    ("size_bytes" "size_bytes - The size in bytes of the data associated with the image.")
    ("status" "status - The status of the image. It can be \"queued\", \"active\" or \"saving\".")
    ("tags" "tags - See Argument Reference above.")
    ("update_at" "update_at - The date the image was last updated.")
    ("visibility" "visibility - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_floatingip_v2" '(
    ("region" "region - See Argument Reference above.")
    ("pool" "pool - See Argument Reference above.")
    ("address" "address - The actual floating IP address itself.")
    ("port_id" "port_id - ID of associated port.")
    ("tenant_id" "tenant_id - the ID of the tenant in which to create the floating IP.")
    ("fixed_ip" "fixed_ip - The fixed IP which the floating IP maps to.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_network_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("shared" "shared - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_port_v2" '(
    ("region" "region - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("mac_address" "mac_address - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("device_owner" "device_owner - See Argument Reference above.")
    ("security_group_ids" "security_group_ids - See Argument Reference above.")
    ("device_id" "device_id - See Argument Reference above.")
    ("fixed_ip" "fixed_ip - See Argument Reference above.")
    ("all fixed_ips" "all fixed_ips - The collection of Fixed IP addresses on the port in the order returned by the Network v2 API.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_router_interface_v2" '(
    ("region" "region - See Argument Reference above.")
    ("router_id" "router_id - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("port_id" "port_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_router_route_v2" '(
    ("region" "region - See Argument Reference above.")
    ("router_id" "router_id - See Argument Reference above.")
    ("destination_cidr" "destination_cidr - See Argument Reference above.")
    ("next_hop" "next_hop - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_router_v2" '(
    ("id" "id - ID of the router.")
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("external_gateway" "external_gateway - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("value_specs" "value_specs - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_subnet_v2" '(
    ("region" "region - See Argument Reference above.")
    ("network_id" "network_id - See Argument Reference above.")
    ("cidr" "cidr - See Argument Reference above.")
    ("ip_version" "ip_version - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("allocation_pools" "allocation_pools - See Argument Reference above.")
    ("gateway_ip" "gateway_ip - See Argument Reference above.")
    ("enable_dhcp" "enable_dhcp - See Argument Reference above.")
    ("dns_nameservers" "dns_nameservers - See Argument Reference above.")
    ("host_routes" "host_routes - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_secgroup_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_networking_secgroup_rule_v2" '(
    ("region" "region - See Argument Reference above.")
    ("direction" "direction - See Argument Reference above.")
    ("ethertype" "ethertype - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("port_range_min" "port_range_min - See Argument Reference above.")
    ("port_range_max" "port_range_max - See Argument Reference above.")
    ("remote_ip_prefix" "remote_ip_prefix - See Argument Reference above.")
    ("remote_group_id" "remote_group_id - See Argument Reference above.")
    ("security_group_id" "security_group_id - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_lb_loadbalancer_v2" '(
    ("region" "region - See Argument Reference above.")
    ("vip_subnet_id" "vip_subnet_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("vip_address" "vip_address - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("flavor" "flavor - See Argument Reference above.")
    ("loadbalancer_provider" "loadbalancer_provider - See Argument Reference above.")
    ("security_group_ids" "security_group_ids - See Argument Reference above.")
    ("vip_port_id" "vip_port_id - The Port ID of the Load Balancer IP.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_lb_listener_v2" '(
    ("id" "id - The unique ID for the Listener.")
    ("protocol" "protocol - See Argument Reference above.")
    ("protocol_port" "protocol_port - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("default_port_id" "default_port_id - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("connection_limit" "connection_limit - See Argument Reference above.")
    ("default_tls_container_ref" "default_tls_container_ref - See Argument Reference above.")
    ("sni_container_refs" "sni_container_refs - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_lb_pool_v2" '(
    ("id" "id - The unique ID for the pool.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("lb_method" "lb_method - See Argument Reference above.")
    ("persistence" "persistence - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_lb_member_v2" '(
    ("id" "id - The unique ID for the member.")
    ("name" "name - See Argument Reference above.")
    ("weight" "weight - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("subnet_id" "subnet_id - See Argument Reference above.")
    ("pool_id" "pool_id - See Argument Reference above.")
    ("address" "address - See Argument Reference above.")
    ("protocol_port" "protocol_port - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_lb_monitor_v2" '(
    ("id" "id - The unique ID for the monitor.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("delay" "delay - See Argument Reference above.")
    ("timeout" "timeout - See Argument Reference above.")
    ("max_retries" "max_retries - See Argument Reference above.")
    ("url_path" "url_path - See Argument Reference above.")
    ("http_method" "http_method - See Argument Reference above.")
    ("expected_codes" "expected_codes - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_fw_firewall_group_v2" '(
    ("region" "region - See Argument Reference above.")
    ("policy_id" "policy_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("admin_state_up" "admin_state_up - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")
    ("ports" "ports - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_fw_policy_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("audited" "audited - See Argument Reference above.")
    ("shared" "shared - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opentelekomcloud_fw_rule_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("protocol" "protocol - See Argument Reference above.")
    ("action" "action - See Argument Reference above.")
    ("ip_version" "ip_version - See Argument Reference above.")
    ("source_ip_address" "source_ip_address - See Argument Reference above.")
    ("destination_ip_address" "destination_ip_address - See Argument Reference above.")
    ("source_port" "source_port - See Argument Reference above.")
    ("destination_port" "destination_port - See Argument Reference above.")
    ("enabled" "enabled - See Argument Reference above.")
    ("tenant_id" "tenant_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "opsgenie_team" '(
    ("id" "id - The ID of the OpsGenie User.")

  ) company-terraform-resource-attributes-hash)

(puthash "opsgenie_user" '(
    ("id" "id - The ID of the OpsGenie User.")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_acl" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_image_list" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_image_list_entry" '(
    ("uri" "uri - The Unique Resource Identifier for the Image List Entry.")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_instance" '(
    ("id" "id - The id of the instance.")
    ("attributes" "attributes - The full attributes of the instance, as a JSON string.")
    ("availability_domain" "availability_domain - The availability domain the instance is in.")
    ("domain" "domain - The default domain to use for the hostname and for DNS lookups.")
    ("entry" "entry - Imagelist entry number.")
    ("fingerprint" "fingerprint - SSH server fingerprint presented by the instance.")
    ("fqdn" "fqdn - The fully qualified domain name of the instance.")
    ("image_format" "image_format - The format of the image.")
    ("ip_address" "ip_address - The IP Address of the instance.")
    ("placement_requirements" "placement_requirements - The array of placement requirements for the instance.")
    ("platform" "platform - The OS Platform of the instance.")
    ("priority" "priority - The priority at which the instance was ran.")
    ("quota_reservation" "quota_reservation - Reference to the QuotaReservation, to be destroyed with the instance.")
    ("relationships" "relationships - The array of relationship specifications to be satisfied on instance placement.")
    ("resolvers" "resolvers - Array of resolvers to be used instead of the default resolvers.")
    ("site" "site - The site the instance is running on.")
    ("start_time" "start_time - The launch time of the instance.")
    ("state" "state - The instance's state.")
    ("vcable_id" "vcable_id - vCable ID for the instance.")
    ("virtio" "virtio - Boolean that determines if the instance is a virtio device.")
    ("vnc_address" "vnc_address - The VNC address and port of the instance.")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_address_association" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_address_prefix_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_address_reservation" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_association" '(
    ("name" "name The name of the IP Association")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_network" '(
    ("name" "name - The name of the IP Network")
    ("ip_address_prefix" "ip_address_prefix - The IPv4 address prefix, in CIDR format.")
    ("description" "description - The description of the IP Network.")
    ("ip_network_exchange" "ip_network_exchange - The IP Network Exchange for the IP Network")
    ("public_napt_enabled" "public_napt_enabled - Whether public internet access using NAPT for VNICs without any public IP Reservation or not.")
    ("uri" "uri - Uniform Resource Identifier for the IP Network")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_network_exchange" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ip_reservation" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_machine_image" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_orchestrated_instance" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_route" '(
    ("name" "name The name of the route")
    ("description" "description - The description of the route.")
    ("admin_distance" "admin_distance - The route's administrative distance. Defaults to 0.")
    ("ip_address_prefix" "ip_address_prefix - The IPv4 address prefix, in CIDR format, of the external network from which to route traffic.")
    ("next_hop_vnic_set" "next_hop_vnic_set - Name of the virtual NIC set to route matching packets to. Routed flows are load-balanced among all the virtual NICs in the virtual NIC set.")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_sec_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_security_application" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_security_association" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_security_ip_list" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_security_list" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_security_protocol" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_security_rule" '(
    ("uri" "uri - The Uniform Resource Identifier of the security rule.")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_ssh_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_storage_volume_attachment" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_storage_volume" '(
    ("hypervisor" "hypervisor - The hypervisor that this volume is compatible with.")
    ("machine_image" "machine_image - Name of the Machine Image - available if the volume is a bootable storage volume.")
    ("managed" "managed - Is this a Managed Volume?")
    ("platform" "platform - The OS platform this volume is compatible with.")
    ("readonly" "readonly - Can this Volume be attached as readonly?")
    ("status" "status - The current state of the storage volume.")
    ("storage_pool" "storage_pool - The storage pool from which this volume is allocated.")
    ("uri" "uri - Unique Resource Identifier of the Storage Volume.")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_storage_volume_snapshot" '(
    ("account" "account - Account to use for snapshots.")
    ("machine_image_name" "machine_image_name - The name of the machine image that's used in the boot volume from which this snapshot is taken.")
    ("size" "size - The size of the snapshot in GB.")
    ("property" "property - Where the snapshot is stored, whether collocated, or in the Oracle Storage Cloud Service instance.")
    ("platform" "platform - The OS platform this snapshot is compatible with")
    ("snapshot_timestamp" "snapshot_timestamp - Timestamp of the storage snapshot, generated by storage server. The snapshot will contain data written to the original volume before this time.")
    ("snapshot_id" "snapshot_id - The Oracle ID of the snapshot.")
    ("start_timestamp" "start_timestamp - Timestamp when the snapshot was started.")
    ("status" "status - Status of the snapshot.")
    ("status_detail" "status_detail - Details about the latest state of the storage volume snapshot.")
    ("status_timestamp" "status_timestamp - Indicates the time that the current view of the storage volume snapshot was generated.")
    ("uri" "uri - Uniform Resource Identifier")

  ) company-terraform-resource-attributes-hash)

(puthash "opc_compute_vnic_set" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_storage_container" '(

  ) company-terraform-resource-attributes-hash)

(puthash "opc_storage_object" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oraclepaas_database_service_instance" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oraclepaas_java_service_instance" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oraclepaas_database_access_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "oraclepaas_java_access_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ovh_vrack_publiccloud_attachment" '(
    ("vrack_id" "vrack_id - See Argument Reference above.")
    ("project_id" "project_id - See Argument Reference above.")

  ) company-terraform-resource-attributes-hash)

(puthash "ovh_publiccloud_private_network" '(
    ("project_id" "project_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("vlan_id" "vlan_id - See Argument Reference above.")
    ("regions" "regions - See Argument Reference above.")
    ("regions_status" "regions_status - A map representing the status of the network per region.")
    ("regions_status/region" "regions_status/region - The id of the region.")
    ("regions_status/status" "regions_status/status - The status of the network in the region.")
    ("status" "status - the status of the network. should be normally set to 'ACTIVE'.")
    ("type" "type - the type of the network. Either 'private' or 'public'.")

  ) company-terraform-resource-attributes-hash)

(puthash "ovh_publiccloud_private_network_subnet" '(
    ("project_id" "project_id - See Argument Reference above.")
    ("network_id" "network_id - See Argument Reference above.")
    ("dhcp_id" "dhcp_id - See Argument Reference above.")
    ("start" "start - See Argument Reference above.")
    ("end" "end - See Argument Reference above.")
    ("network" "network - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")
    ("gateway_ip" "gateway_ip - The IP of the gateway")
    ("no_gateway" "no_gateway - See Argument Reference above.")
    ("cidr" "cidr - Ip Block representing the subnet cidr.")
    ("ip_pools" "ip_pools - List of ip pools allocated in the subnet.")
    ("ip_pools/network" "ip_pools/network - Global network with cidr.")
    ("ip_pools/region" "ip_pools/region - Region where this subnet is created.")
    ("ip_pools/dhcp" "ip_pools/dhcp - DHCP enabled.")
    ("ip_pools/end" "ip_pools/end - Last ip for this region.")
    ("ip_pools/start" "ip_pools/start - First ip for this region.")

  ) company-terraform-resource-attributes-hash)

(puthash "ovh_publiccloud_user" '(
    ("project_id" "project_id - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("username" "username - the username generated for the user. This username can be used with the Openstack API.")
    ("password" "password - (Sensitive) the password generated for the user. The password can be used with the Openstack API. This attribute is sensitive and will only be retrieve once during creation.")
    ("status" "status - the status of the user. should be normally set to 'ok'.")
    ("creation_date" "creation_date - the date the user was created.")
    ("openstack_rc" "openstack_rc - a convenient map representing an openstack_rc file. Note: no password nor sensitive token is set in this map.")

  ) company-terraform-resource-attributes-hash)

(puthash "packet_device" '(
    ("id" "id - The ID of the device")
    ("hostname" "hostname- The hostname of the device")
    ("project_id" "project_id- The ID of the project the device belongs to")
    ("facility" "facility - The facility the device is in")
    ("plan" "plan - The hardware config of the device")
    ("network" "network - The device's private and public IP (v4 and v6) network details")
    ("access_public_ipv6" "access_public_ipv6 - The ipv6 maintenance IP assigned to the device")
    ("access_public_ipv4" "access_public_ipv4 - The ipv4 maintenance IP assigned to the device")
    ("access_private_ipv4" "access_private_ipv4 - The ipv4 private IP assigned to the device")
    ("locked" "locked - Whether the device is locked")
    ("billing_cycle" "billing_cycle - The billing cycle of the device (monthly or hourly)")
    ("operating_system" "operating_system - The operating system running on the device")
    ("state" "state - The status of the device")
    ("created" "created - The timestamp for when the device was created")
    ("updated" "updated - The timestamp for the last time the device was updated")
    ("tags" "tags - Tags attached to the device")
    ("description" "description - Description string for the device")
    ("hardware_reservation_id" "hardware_reservation_id - The id of hardware reservation which this device occupies")
    ("root_password" "root_password - Root password to the server (disabled after 24 hours)")

  ) company-terraform-resource-attributes-hash)

(puthash "packet_project" '(
    ("id" "id - The unique ID of the project")
    ("payment_method_id" "payment_method_id - The UUID of payment method for this project.")
    ("organization_id" "organization_id - The UUID of this project's parent organization.")
    ("created" "created - The timestamp for when the Project was created")
    ("updated" "updated - The timestamp for the last time the Project was updated")

  ) company-terraform-resource-attributes-hash)

(puthash "packet_organization" '(
    ("id" "id - The unique ID of the organization.")
    ("name" "name - The name of the Organization.")
    ("description" "description - Description string.")
    ("website" "website - Website link.")
    ("twitter" "twitter - Twitter handle.")
    ("logo" "logo - Logo URL.")

  ) company-terraform-resource-attributes-hash)

(puthash "packet_ssh_key" '(
    ("id" "id - The unique ID of the key")
    ("name" "name - The name of the SSH key")
    ("public_key" "public_key - The text of the public key")
    ("fingerprint" "fingerprint - The fingerprint of the SSH key")
    ("created" "created - The timestamp for when the SSH key was created")
    ("updated" "updated - The timestamp for the last time the SSH key was updated")

  ) company-terraform-resource-attributes-hash)

(puthash "packet_volume" '(
    ("id" "id - The unique ID of the volume")
    ("name" "name - The name of the volume")
    ("description" "description - The description of the volume")
    ("size" "size - The size in GB of the volume")
    ("plan" "plan - Performance plan the volume is on")
    ("billing_cycle" "billing_cycle - The billing cycle, defaults to hourly")
    ("facility" "facility - The facility slug the volume resides in")
    ("state" "state - The state of the volume")
    ("locked" "locked - Whether the volume is locked or not")
    ("project_id" "project_id - The project id the volume is in")
    ("attachments" "attachments - A list of attachments, each with it's own href attribute")
    ("created" "created - The timestamp for when the volume was created")
    ("updated" "updated - The timestamp for the last time the volume was updated")

  ) company-terraform-resource-attributes-hash)

(puthash "packet_volume_attachment" '(
    ("id" "id - The unique ID of the volume attachment")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_addon" '(
    ("id" "id - The ID of the add-on.")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_escalation_policy" '(
    ("id" "id - The ID of the escalation policy.")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_extension" '(

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_maintenance_window" '(
    ("id" "id - The ID of the maintenance window.")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_schedule" '(
    ("id" "id - The ID of the schedule")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_service" '(
    ("id" "id - The ID of the service.")
    ("last_incident_timestamp" "last_incident_timestamp- Last incident timestamp of the service")
    ("created_at" "created_at- Creation timestamp of the service")
    ("status" "status- The status of the service")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_service_integration" '(

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_team" '(
    ("id" "id - The ID of the team.")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_team_membership" '(
    ("user_id" "user_id - The ID of the user belonging to the team.")
    ("team_id" "team_id - The team ID the user belongs to.")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_user" '(
    ("id" "id - The ID of the user.")
    ("avatar_url" "avatar_url - The URL of the user's avatar.")
    ("time_zone" "time_zone - The timezone of the user")
    ("html_url" "html_url - URL at which the entity is uniquely displayed in the Web app")
    ("invitation_sent" "invitation_sent - If true, the user has an outstanding invitation.")

  ) company-terraform-resource-attributes-hash)

(puthash "pagerduty_user_contact_method" '(
    ("id" "id - The ID of the contact method.")
    ("blacklisted" "blacklisted - If true, this phone has been blacklisted by PagerDuty and no messages will be sent to it.")
    ("enabled" "enabled - If true, this phone is capable of receiving SMS messages.")

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_address_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_address_object" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_administrative_tag" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_device_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_device_group_entry" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_nat_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_security_policies" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_service_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_panorama_service_object" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_address_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_address_object" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_administrative_tag" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_dag_tags" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_ethernet_interface" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_general_settings" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_management_profile" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_nat_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_security_policies" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_service_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_service_object" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_virtual_router" '(

  ) company-terraform-resource-attributes-hash)

(puthash "panos_zone" '(

  ) company-terraform-resource-attributes-hash)

(puthash "postgresql_database" '(

  ) company-terraform-resource-attributes-hash)

(puthash "postgresql_extension" '(

  ) company-terraform-resource-attributes-hash)

(puthash "postgresql_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "postgresql_schema" '(

  ) company-terraform-resource-attributes-hash)

(puthash "powerdns_record" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_datacenter" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_firewall" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_ipblock" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_ipfailover" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_lan" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_loadbalancer" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_nic" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_server" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_share" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_snapshot" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "profitbricks_volume" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_binding" '(
    ("properties_key" "properties_key - A unique key to refer to the binding.")

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_exchange" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_permissions" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_queue" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rabbitmq_vhost" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_certificate" '(
    ("id" "id - (Computed) The ID of the resource.")
    ("cn" "cn - The certificate CN.")
    ("algorithm" "algorithm - The certificate algorithm.")
    ("cert_fingerprint" "cert_fingerprint - The certificate fingerprint.")
    ("expires_at" "expires_at - The certificate expiration date.")
    ("issued_at" "issued_at - The certificate creation date.")
    ("issuer" "issuer - The certificate issuer.")
    ("key_size" "key_size - The certificate key size.")
    ("serial_number" "serial_number - The certificate serial number.")
    ("subject_alternative_names" "subject_alternative_names - The list of certificate Subject Alternative Names.")
    ("version" "version - The certificate version.")

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_environment" '(
    ("id" "id - The ID of the environment (ie 1a11) that can be used in other Terraform resources such as Rancher Stack definitions.")

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_host" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_registration_token" '(
    ("id" "id - (Computed) The ID of the resource.")
    ("image" "image - (Computed)")
    ("command" "command - The command used to start a rancher agent for this environment.")
    ("registration_url" "registration_url - The URL to use to register new nodes to the environment.")
    ("token" "token - The token to use to register new nodes to the environment.")

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_registry_credential" '(
    ("id" "id - (Computed) The ID of the resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_registry" '(
    ("id" "id - (Computed) The ID of the resource.")

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_secret" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_stack" '(
    ("id" "id - (Computed) The ID of the resource.")
    ("rendered_docker_compose" "rendered_docker_compose - The interpolated docker_compose applied to the stack.")
    ("rendered_rancher_compose" "rendered_rancher_compose - The interpolated rancher_compose applied to the stack.")

  ) company-terraform-resource-attributes-hash)

(puthash "rancher_volume" '(

  ) company-terraform-resource-attributes-hash)

(puthash "random_id" '(
    ("b64_url" "b64_url - The generated id presented in base64, using the URL-friendly character set: case-sensitive letters, digits and the characters _ and -.")
    ("b64_std" "b64_std - The generated id presented in base64 without additional transformations.")
    ("hex" "hex - The generated id presented in padded hexadecimal digits. This result will always be twice as long as the requested byte length.")
    ("dec" "dec - The generated id presented in non-padded decimal digits.")

  ) company-terraform-resource-attributes-hash)

(puthash "random_pet" '(

  ) company-terraform-resource-attributes-hash)

(puthash "random_shuffle" '(
    ("result" "result - Random permutation of the list of strings given in input.")

  ) company-terraform-resource-attributes-hash)

(puthash "random_string" '(
    ("result" "result - Random string generated.")

  ) company-terraform-resource-attributes-hash)

(puthash "random_integer" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rundeck_project" '(
    ("name" "name - The unique name that identifies the project, as set in the arguments.")
    ("ui_url" "ui_url - The URL of the index page for this project in the Rundeck UI.")

  ) company-terraform-resource-attributes-hash)

(puthash "rundeck_private_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "rundeck_public_key" '(
    ("url" "url - The URL at which the key material can be retrieved from the key store by other clients.")
    ("key_material" "key_material - If key_material is omitted in the configuration, it becomes an attribute that exposes the key material already stored at the given path.")

  ) company-terraform-resource-attributes-hash)

(puthash "rundeck_job" '(
    ("id" "id - A unique identifier for the job.")

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_ip" '(
    ("id" "id - ID of the new resource")
    ("ip" "ip - IP of the new resource")
    ("server" "server - ID of the associated server resource")
    ("reverse" "reverse - reverse DNS setting of the IP resource")

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_server" '(

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_security_group" '(
    ("id" "id - id of the new resource")

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_security_group_rule" '(
    ("id" "id - id of the new resource")

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_volume" '(
    ("id" "id - id of the new resource")

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_token" '(
    ("id" "id - Token ID - can be used to access scaleway API")
    ("expiration_date" "expiration_date - Expiration date of token, if expiration is requested")

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_user_data" '(

  ) company-terraform-resource-attributes-hash)

(puthash "scaleway_volume_attachment" '(
    ("id" "id - id of the new resource")

  ) company-terraform-resource-attributes-hash)

(puthash "virtual_guest" '(
    ("id" "id - The ID of the virtual guest.")

  ) company-terraform-resource-attributes-hash)

(puthash "ssh_key" '(
    ("id" "id - The ID of the new SSH key")
    ("fingerprint" "fingerprint - sequence of bytes to authenticate or lookup a longer SSH key.")

  ) company-terraform-resource-attributes-hash)

(puthash "statuscake_test" '(
    ("test_id" "test_id - A unique identifier for the test.")

  ) company-terraform-resource-attributes-hash)

(puthash "aws_group" '(
    ("id" "id - The group ID.")

  ) company-terraform-resource-attributes-hash)

(puthash "template_dir" '(

  ) company-terraform-resource-attributes-hash)

(puthash "tls_private_key" '(
    ("algorithm" "algorithm - The algorithm that was selected for the key.")
    ("private_key_pem" "private_key_pem - The private key data in PEM format.")
    ("public_key_pem" "public_key_pem - The public key data in PEM format.")
    ("public_key_openssh" "public_key_openssh - The public key data in OpenSSH authorized_keys format, if the selected private key format is compatible. All RSA keys are supported, and ECDSA keys with curves \"P256\", \"P384\" and \"P251\" are supported. This attribute is empty if an incompatible ECDSA curve is selected.")

  ) company-terraform-resource-attributes-hash)

(puthash "tls_self_signed_cert" '(
    ("cert_pem" "cert_pem - The certificate data in PEM format.")
    ("validity_start_time" "validity_start_time - The time after which the certificate is valid, as an RFC3339 timestamp.")
    ("validity_end_time" "validity_end_time - The time until which the certificate is invalid, as an RFC3339 timestamp.")

  ) company-terraform-resource-attributes-hash)

(puthash "tls_locally_signed_cert" '(
    ("cert_pem" "cert_pem - The certificate data in PEM format.")
    ("validity_start_time" "validity_start_time - The time after which the certificate is valid, as an RFC3339 timestamp.")
    ("validity_end_time" "validity_end_time - The time until which the certificate is invalid, as an RFC3339 timestamp.")

  ) company-terraform-resource-attributes-hash)

(puthash "tls_cert_request" '(
    ("cert_request_pem" "cert_request_pem - The certificate request data in PEM format.")

  ) company-terraform-resource-attributes-hash)

(puthash "triton_fabric" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_firewall_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_instance_template" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_key" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_machine" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_service_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_snapshot" '(

  ) company-terraform-resource-attributes-hash)

(puthash "triton_vlan" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ultradns_dirpool" '(
    ("id" "id - The record ID")
    ("hostname" "hostname - The FQDN of the record")

  ) company-terraform-resource-attributes-hash)

(puthash "ultradns_probe_http" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ultradns_probe_ping" '(

  ) company-terraform-resource-attributes-hash)

(puthash "ultradns_record" '(
    ("id" "id - The record ID")
    ("name" "name - The name of the record")
    ("rdata" "rdata - An array containing the values of the record")
    ("type" "type - The type of the record")
    ("ttl" "ttl - The TTL of the record")
    ("zone" "zone - The domain of the record")
    ("hostname" "hostname - The FQDN of the record")

  ) company-terraform-resource-attributes-hash)

(puthash "ultradns_tcpool" '(
    ("id" "id - The record ID")
    ("hostname" "hostname - The FQDN of the record")

  ) company-terraform-resource-attributes-hash)

(puthash "vault_approle_auth_backend_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_approle_auth_backend_login" '(
    ("policies" "policies - A list of policies applied to the token.")
    ("renewable" "renewable - Whether the token is renewable or not.")
    ("lease_duration" "lease_duration - How long the token is valid for, in seconds.")
    ("lease_started" "lease_started - The date and time the lease started, in RFC 3339 format.")
    ("accessor" "accessor - The accessor for the token.")
    ("client_token" "client_token - The Vault token created.")
    ("metadata" "metadata - The metadata associated with the token.")

  ) company-terraform-resource-attributes-hash)

(puthash "vault_approle_auth_backend_role_secret_id" '(
    ("accessor" "accessor - The unique ID for this SecretID that can be safely logged.")

  ) company-terraform-resource-attributes-hash)

(puthash "vault_auth_backend" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_auth_backend_cert" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_auth_backend_client" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_auth_backend_identity_whitelist" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_auth_backend_login" '(
    ("lease_duration" "lease_duration - The duration in seconds the token will be valid, relative to the time in lease_start_time.")
    ("lease_start_time" "lease_start_time - The approximate time at which the token was created, using the clock of the system where Terraform was running.")
    ("renewable" "renewable - Set to true if the token can be extended through renewal.")
    ("metadata" "metadata - A map of information returned by the Vault server about the authentication used to generate this token.")
    ("auth_type" "auth_type - The authentication type used to generate this token.")
    ("policies" "policies - The Vault policies assigned to this token.")
    ("accessor" "accessor - The token's accessor.")
    ("client_token" "client_token - The token returned by Vault.")

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_auth_backend_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_auth_backend_sts_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_secret_backend" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_aws_secret_backend_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_database_secret_backend_connection" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_database_secret_backend_role" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_generic_secret" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_okta_auth_backend" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_okta_auth_backend_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_okta_auth_backend_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_mount" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_okta_auth_backend" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_okta_auth_backend_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_okta_auth_backend_user" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vault_policy" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_dnat" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_firewall_rules" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_network" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_snat" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_edgegateway_vpn" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_vapp" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vcd_vapp_vm" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_dhcp_relay_profile" '(
    ("id" "id - ID of the dhcp_relay_profile.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_dhcp_relay_service" '(
    ("id" "id - ID of the dhcp_relay_service.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_firewall_section" '(
    ("id" "id - ID of the firewall_section.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")
    ("is_default" "is_default - A boolean flag which reflects whether a firewall section is default section or not. Each Layer 3 and Layer 2 section will have at least and at most one default section.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_ip_set" '(
    ("id" "id - ID of the ip_set.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_logical_port" '(
    ("id" "id - ID of the logical switch.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_logical_router_downlink_port" '(
    ("id" "id - ID of the logical switch.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_logical_router_link_port_on_tier0" '(
    ("id" "id - ID of the logical switch.")
    ("linked_logical_switch_port_id" "linked_logical_switch_port_id - Identifier for port on logical router to connect to.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_logical_router_link_port_on_tier1" '(
    ("id" "id - ID of the logical switch.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_logical_switch" '(
    ("id" "id - ID of the logical switch.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_logical_tier1_router" '(
    ("id" "id - ID of the logical Tier1 router.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")
    ("advertise_config_revision" "advertise_config_revision - Indicates current revision number of the advertisement configuration object as seen by NSX-T API server. This attribute can be useful for debugging.")
    ("firewall_sections" "firewall_sections - (Optional) The list of firewall sections for this router")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_nat_rule" '(
    ("id" "id - ID of the nat_rule.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")
    ("rule_priority" "rule_priority - The priority of the rule which is ascending, valid range [0-2147483647]. If multiple rules have the same priority, evaluation sequence is undefined.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_ns_group" '(
    ("id" "id - ID of the ns_group.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_static_route" '(
    ("id" "id - ID of the static_route.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")
    ("next_hop" "next_hop additional arguments:   bfd_enabled - Status of bfd for this next hop where bfd_enabled = true indicate bfd is enabled for this next hop and bfd_enabled = false indicate bfd peer is disabled or not configured for this next hop.  blackhole_action - Action to be taken on matching packets for NULL routes.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_vm_tags" '(

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_algorithm_type_ns_service" '(
    ("id" "id - ID of the logical switch.")
    ("default_service" "default_service - The default NSServices are created in the system by default. These NSServices can't be modified/deleted.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_ether_type_ns_service" '(
    ("id" "id - ID of the logical switch.")
    ("default_service" "default_service - The default NSServices are created in the system by default. These NSServices can't be modified/deleted.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_icmp_type_ns_service" '(
    ("id" "id - ID of the logical switch.")
    ("default_service" "default_service - The default NSServices are created in the system by default. These NSServices can't be modified/deleted.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_igmp_type_ns_service" '(
    ("id" "id - ID of the logical switch.")
    ("default_service" "default_service - The default NSServices are created in the system by default. These NSServices can't be modified/deleted.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_ip_protocol_ns_service" '(
    ("id" "id - ID of the logical switch.")
    ("default_service" "default_service - The default NSServices are created in the system by default. These NSServices can't be modified/deleted.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "nsxt_l4_port_set_ns_service" '(
    ("id" "id - ID of the logical switch.")
    ("default_service" "default_service - The default NSServices are created in the system by default. These NSServices can't be modified/deleted.")
    ("revision" "revision - Indicates current revision number of the object as seen by NSX-T API server. This attribute can be useful for debugging.")

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_license" '(
    ("edition_key" "edition_key - The product edition of the license key.")
    ("total" "total - Total number of units (example: CPUs) contained in the license.")
    ("used" "used - The number of units (example: CPUs) assigned to this license.")
    ("name" "name - The display name for the license.")

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster_host_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster_vm_affinity_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster_vm_anti_affinity_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster_vm_dependency_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster_vm_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_compute_cluster_vm_host_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_drs_vm_override" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_dpm_host_override" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_ha_vm_override" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_custom_attribute" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_datacenter" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_folder" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_tag" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_tag_category" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_distributed_port_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_distributed_virtual_switch" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_host_port_group" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_host_virtual_switch" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_datastore_cluster" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_datastore_cluster_vm_anti_affinity_rule" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_file" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_nas_datastore" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_storage_drs_vm_override" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_vmfs_datastore" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_virtual_disk" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_virtual_machine" '(

  ) company-terraform-resource-attributes-hash)

(puthash "vsphere_virtual_machine_snapshot" '(

  ) company-terraform-resource-attributes-hash)

(defconst company-terraform-data-list '(
    ("alicloud_regions" "The Regions data source allows access to the list of Alicloud Regions.")
    ("alicloud_instance_types" "The Instance Types data source list the ecs_instance_types of Alicloud.\n\n NOTE: Default to provide upgraded instance types. If you want to get outdated instance types, you should set is_outdated to true.")
    ("alicloud_images" "The Images data source list image resource list contains private images of the user and images of system resources provided by Alicloud, as well as other public images and those available on the image market.")
    ("alicloud_zones" "The Zones data source allows access to the list of Alicloud Zones which can be accessed by an Alicloud account within the region configured in the provider.")
    ("alicloud_key_pairs" "The Key Pairs data source provides a list of Alicloud Key Pairs in an Alicloud account according to the specified filters.")
    ("alicloud_kms_keys" "The KMS keys data source provides a list of Alicloud KMS keys in an Alicloud account according to the specified filters.")
    ("alicloud_instances" "The Instances data source list ECS instance resource accoring to its ID, name regex, image id, status and other fields.")
    ("alicloud_vpcs" "The VPCs data source lists a number of VPCs resource information owned by an Alicloud account.")
    ("alicloud_vswitches" "The Virtual sunbet data source lists a list of vswitches resource information owned by an Alicloud account, and each vswitch including its basic attribution, VPC ID and containing ECS instance IDs.")
    ("alicloud_eips" "The elastic ip address data source lists a list of eips resource information owned by an Alicloud account, and each EIP including its basic attribution and association instance.")
    ("alicloud_security_groups" "The Security Groups data source provides a list of Security Groups in an Alicloud account according to the specified filters.")
    ("alicloud_security_group_rules" "The alicloud_security_group_rules data source provides a collection of security permissions of a specific security group. Each collection item represents a single ingress or egress permission rule. The id of the security group can be provided via variable or filtered by another data source alicloud_security_groups.")
    ("alicloud_dns_domain_groups" "NOTE: This datasource has been deprecated from v1.3.2. New datasource alicloud_dns_groups will replace.")
    ("alicloud_dns_domain_records" "NOTE: This resource has been deprecated from v1.3.2. New datasource alicloud_dns_records will replace.")
    ("alicloud_dns_groups" "The Dns Domain Groups data source provides a list of Alicloud Dns Domain Groups in an Alicloud account according to the specified filters.")
    ("alicloud_dns_records" "The Dns Domain Records data source provides a list of Alicloud Dns Domain Records in an Alicloud account according to the specified filters.")
    ("alicloud_dns_domains" "The Dns Domains data source provides a list of Alicloud Dns Domains in an Alicloud account according to the specified filters.")
    ("alicloud_ram_account_aliases" "The Ram Account Alias data source provides an alias for the Alicloud account.")
    ("alicloud_ram_account_alias" "NOTE: This datasource has been deprecated from v1.3.2. New datasource alicloud_ram_account_aliases will replace.")
    ("alicloud_ram_groups" "The Ram Groups data source provides a list of Alicloud Ram Groups in an Alicloud account according to the specified filters.")
    ("alicloud_ram_policies" "The Ram Policies data source provides a list of Alicloud Ram Policies in an Alicloud account according to the specified filters.")
    ("alicloud_ram_roles" "The Ram Roles data source provides a list of Alicloud Ram Roles in an Alicloud account according to the specified filters.")
    ("alicloud_ram_users" "The Ram Users data source provides a list of Alicloud Ram Users in an Alicloud account according to the specified filters.")
    ("archive_file" "Generates an archive from content, a file, or directory of files.")
    ("aws_acm_certificate" "Use this data source to get the ARN of a certificate in AWS Certificate Manager (ACM). The process of requesting and verifying a certificate in ACM requires some manual steps, which means that Terraform cannot automate the creation of ACM certificates. But using this data source, you can reference them by domain without having to hard code the ARNs as input.")
    ("aws_acmpca_certificate_authority" "Get information on a AWS Certificate Manager Private Certificate Authority (ACM PCA Certificate Authority).")
    ("aws_alb" "Note: aws_alb is known as aws_lb. The functionality is identical. \n\nProvides information about a Load Balancer.\n\nThis data source can prove useful when a module accepts an LB as an input variable and needs to, for example, determine the security groups associated with it, etc.")
    ("aws_alb_listener" "Note: aws_alb_listener is known as aws_lb_listener. The functionality is identical. \n\nProvides information about a Load Balancer Listener.\n\nThis data source can prove useful when a module accepts an LB Listener as an input variable and needs to know the LB it is attached to, or other information specific to the listener in question.")
    ("aws_alb_target_group" "Note: aws_alb_target_group is known as aws_lb_target_group. The functionality is identical. \n\nProvides information about a Load Balancer Target Group.\n\nThis data source can prove useful when a module accepts an LB Target Group as an input variable and needs to know its attributes. It can also be used to get the ARN of an LB Target Group for use in other resources, given LB Target Group name.")
    ("aws_ami" "Use this data source to get the ID of a registered AMI for use in other resources.")
    ("aws_ami_ids" "Use this data source to get a list of AMI IDs matching the specified criteria.")
    ("aws_api_gateway_rest_api" "Use this data source to get the id and root_resource_id of a REST API in API Gateway. To fetch the REST API you must provide a name to match against.  As there is no unique name constraint on REST APIs this data source will  error if there is more than one match.")
    ("aws_arn" "Parses an Amazon Resource Name (ARN) into its constituent parts.")
    ("aws_autoscaling_groups" "The Autoscaling Groups data source allows access to the list of AWS ASGs within a specific region. This will allow you to pass a list of AutoScaling Groups to other resources.")
    ("aws_availability_zone" "aws_availability_zone provides details about a specific availability zone (AZ) in the current region.\n\nThis can be used both to validate an availability zone given in a variable and to split the AZ name into its component parts of an AWS region and an AZ identifier letter. The latter may be useful e.g. for implementing a consistent subnet numbering scheme across several regions by mapping both the region and the subnet letter to network numbers.\n\nThis is different from the aws_availability_zones (plural) data source, which provides a list of the available zones.")
    ("aws_availability_zones" "The Availability Zones data source allows access to the list of AWS Availability Zones which can be accessed by an AWS account within the region configured in the provider.\n\nThis is different from the aws_availability_zone (singular) data source, which provides some details about a specific availability zone.")
    ("aws_batch_compute_environment" "The Batch Compute Environment data source allows access to details of a specific compute environment within AWS Batch.")
    ("aws_batch_job_queue" "The Batch Job Queue data source allows access to details of a specific job queue within AWS Batch.")
    ("aws_billing_service_account" "Use this data source to get the Account ID of the AWS Billing and Cost Management Service Account for the purpose of whitelisting in S3 bucket policy.")
    ("aws_caller_identity" "Use this data source to get the access to the effective Account ID, User ID, and ARN in which Terraform is authorized.")
    ("aws_canonical_user_id" "The Canonical User ID data source allows access to the canonical user ID for the effective account in which Terraform is working.")
    ("aws_cloudformation_stack" "The CloudFormation Stack data source allows access to stack outputs and other useful data including the template body.")
    ("aws_cloudtrail_service_account" "Use this data source to get the Account ID of the AWS CloudTrail Service Account in a given region for the purpose of allowing CloudTrail to store trail data in S3.")
    ("aws_cloudwatch_log_group" "Use this data source to get information about an AWS Cloudwatch Log Group")
    ("aws_cognito_user_pools" "Use this data source to get a list of cognito user pools.")
    ("aws_db_instance" "Use this data source to get information about an RDS instance")
    ("aws_db_snapshot" "Use this data source to get information about a DB Snapshot for use when provisioning DB instances\n\n NOTE: This data source does not apply to snapshots created on Aurora DB clusters.")
    ("aws_dynamodb_table" "Provides information about a DynamoDB table.")
    ("aws_ebs_snapshot" "Use this data source to get information about an EBS Snapshot for use when provisioning EBS Volumes")
    ("aws_ebs_snapshot_ids" "Use this data source to get a list of EBS Snapshot IDs matching the specified criteria.")
    ("aws_ebs_volume" "Use this data source to get information about an EBS volume for use in other resources.")
    ("aws_ecr_repository" "The ECR Repository data source allows the ARN, Repository URI and Registry ID to be retrieved for an ECR repository.")
    ("aws_ecs_cluster" "The ECS Cluster data source allows access to details of a specific cluster within an AWS ECS service.")
    ("aws_ecs_container_definition" "The ECS container definition data source allows access to details of a specific container within an AWS ECS service.")
    ("aws_ecs_task_definition" "The ECS task definition data source allows access to details of a specific AWS ECS task definition.")
    ("aws_efs_file_system" "Provides information about an Elastic File System (EFS).")
    ("aws_efs_mount_target" "Provides information about an Elastic File System Mount Target (EFS).")
    ("aws_eip" "aws_eip provides details about a specific Elastic IP.\n\nThis resource can prove useful when a module accepts an allocation ID or public IP as an input variable and needs to determine the other.")
    ("aws_elastic_beanstalk_hosted_zone" "Use this data source to get the ID of an elastic beanstalk hosted zone.")
    ("aws_elastic_beanstalk_solution_stack" "Use this data source to get the name of a elastic beanstalk solution stack.")
    ("aws_elasticache_cluster" "Use this data source to get information about an Elasticache Cluster")
    ("aws_elasticache_replication_group" "Use this data source to get information about an Elasticache Replication Group.")
    ("aws_elb" "Provides information about a \"classic\" Elastic Load Balancer (ELB). See LB Data Source if you are looking for \"v2\" Application Load Balancer (ALB) or Network Load Balancer (NLB).\n\nThis data source can prove useful when a module accepts an LB as an input variable and needs to, for example, determine the security groups associated with it, etc.")
    ("aws_elb_hosted_zone_id" "Use this data source to get the HostedZoneId of the AWS Elastic Load Balancing HostedZoneId in a given region for the purpose of using in an AWS Route53 Alias.")
    ("aws_elb_service_account" "Use this data source to get the Account ID of the AWS Elastic Load Balancing Service Account in a given region for the purpose of whitelisting in S3 bucket policy.")
    ("aws_iam_account_alias" "The IAM Account Alias data source allows access to the account alias for the effective account in which Terraform is working.")
    ("aws_iam_group" "This data source can be used to fetch information about a specific IAM group. By using this data source, you can reference IAM group properties without having to hard code ARNs as input.")
    ("aws_iam_instance_profile" "This data source can be used to fetch information about a specific IAM instance profile. By using this data source, you can reference IAM instance profile properties without having to hard code ARNs as input.")
    ("aws_iam_policy" "This data source can be used to fetch information about a specific IAM policy.")
    ("aws_iam_policy_document" "Generates an IAM policy document in JSON format.\n\nThis is a data source which can be used to construct a JSON representation of an IAM policy document, for use with resources which expect policy documents, such as the aws_iam_policy resource.\n\ndata \"aws_iam_policy_document\" \"example\" {   statement {     sid = \"1\"      actions = [       \"s3:ListAllMyBuckets\",       \"s3:GetBucketLocation\",     ]      resources = [       \"arn:aws:s3:::*\",     ]   }    statement {     actions = [       \"s3:ListBucket\",     ]      resources = [       \"arn:aws:s3:::${var.s3_bucket_name}\",     ]      condition {       test     = \"StringLike\"       variable = \"s3:prefix\"        values = [         \"\",         \"home/\",         \"home/&{aws:username}/\",       ]     }   }    statement {     actions = [       \"s3:*\",     ]      resources = [       \"arn:aws:s3:::${var.s3_bucket_name}/home/&{aws:username}\",       \"arn:aws:s3:::${var.s3_bucket_name}/home/&{aws:username}/*\",     ]   } }  resource \"aws_iam_policy\" \"example\" {   name   = \"example_policy\"   path   = \"/\"   policy = \"${data.aws_iam_policy_document.example.json}\" } \n\nUsing this data source to generate policy documents is optional. It is also valid to use literal JSON strings within your configuration, or to use the file interpolation function to read a raw JSON policy document from a file.")
    ("aws_iam_role" "This data source can be used to fetch information about a specific IAM role. By using this data source, you can reference IAM role properties without having to hard code ARNs as input.")
    ("aws_iam_server_certificate" "Use this data source to lookup information about IAM Server Certificates.")
    ("aws_iam_user" "This data source can be used to fetch information about a specific IAM user. By using this data source, you can reference IAM user properties without having to hard code ARNs or unique IDs as input.")
    ("aws_inspector_rules_packages" "The AWS Inspector Rules Packages data source allows access to the list of AWS Inspector Rules Packages which can be used by AWS Inspector within the region configured in the provider.")
    ("aws_instance" "Use this data source to get the ID of an Amazon EC2 Instance for use in other resources.")
    ("aws_instances" "Use this data source to get IDs or IPs of Amazon EC2 instances to be referenced elsewhere, e.g. to allow easier migration from another management solution or to make it easier for an operator to connect through bastion host(s).\n\n Note: It's a best practice to expose instance details via outputs and remote state and use terraform_remote_state data source instead if you manage referenced instances via Terraform. \n\n Note: It's strongly discouraged to use this data source for querying ephemeral instances (e.g. managed via autoscaling group), as the output may change at any time and you'd need to re-run apply every time an instance comes up or dies.")
    ("aws_internet_gateway" "aws_internet_gateway provides details about a specific Internet Gateway.")
    ("aws_iot_endpoint" "Returns a unique endpoint specific to the AWS account making the call.")
    ("aws_ip_ranges" "Use this data source to get the IP ranges of various AWS products and services.")
    ("aws_kinesis_stream" "Use this data source to get information about a Kinesis Stream for use in other resources.\n\nFor more details, see the Amazon Kinesis Documentation.")
    ("aws_kms_alias" "Use this data source to get the ARN of a KMS key alias. By using this data source, you can reference key alias without having to hard code the ARN as input.")
    ("aws_kms_key" "Use this data source to get detailed information about  the specified KMS Key with flexible key id input.  This can be useful to reference key alias  without having to hard code the ARN as input.")
    ("aws_kms_ciphertext" "The KMS ciphertext data source allows you to encrypt plaintext into ciphertext by using an AWS KMS customer master key.\n\n Note: All arguments including the plaintext be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("aws_kms_secret" "The KMS secret data source allows you to use data encrypted with the AWS KMS service within your resource definitions.\n\n NOTE: Using this data provider will allow you to conceal secret data within your resource definitions but does not take care of protecting that data in the logging output, plan output or state output. \n\nPlease take care to secure your secret data outside of resource definitions.")
    ("aws_lambda_invocation" "Use this data source to invoke custom lambda functions as data source. The lambda function is invoked with RequestResponse invocation type.")
    ("aws_nat_gateway" "Provides details about a specific Nat Gateway.")
    ("aws_network_interface" "Use this data source to get information about a Network Interface.")
    ("aws_lambda_function" "Provides information about a Lambda Function.")
    ("aws_lb" "Note: aws_alb is known as aws_lb. The functionality is identical. \n\nProvides information about a Load Balancer.\n\nThis data source can prove useful when a module accepts an LB as an input variable and needs to, for example, determine the security groups associated with it, etc.")
    ("aws_lb_listener" "Note: aws_alb_listener is known as aws_lb_listener. The functionality is identical. \n\nProvides information about a Load Balancer Listener.\n\nThis data source can prove useful when a module accepts an LB Listener as an input variable and needs to know the LB it is attached to, or other information specific to the listener in question.")
    ("aws_lb_target_group" "Note: aws_alb_target_group is known as aws_lb_target_group. The functionality is identical. \n\nProvides information about a Load Balancer Target Group.\n\nThis data source can prove useful when a module accepts an LB Target Group as an input variable and needs to know its attributes. It can also be used to get the ARN of an LB Target Group for use in other resources, given LB Target Group name.")
    ("aws_mq_broker" "Provides information about a MQ Broker.")
    ("aws_partition" "Use this data source to lookup current AWS partition in which Terraform is working")
    ("aws_prefix_list" "aws_prefix_list provides details about a specific prefix list (PL) in the current region.\n\nThis can be used both to validate a prefix list given in a variable and to obtain the CIDR blocks (IP address ranges) for the associated AWS service. The latter may be useful e.g. for adding network ACL rules.")
    ("aws_rds_cluster" "Provides information about a RDS cluster.")
    ("aws_redshift_cluster" "Provides details about a specific redshift cluster.")
    ("aws_redshift_service_account" "Use this data source to get the Account ID of the AWS Redshift Service Account in a given region for the purpose of allowing Redshift to store audit data in S3.")
    ("aws_region" "aws_region provides details about a specific AWS region.\n\nAs well as validating a given region name this resource can be used to discover the name of the region configured within the provider. The latter can be useful in a child module which is inheriting an AWS provider configuration from its parent module.")
    ("aws_route53_zone" "aws_route53_zone provides details about a specific Route 53 Hosted Zone.\n\nThis data source allows to find a Hosted Zone ID given Hosted Zone name and certain search criteria.")
    ("aws_route_table" "aws_route_table provides details about a specific Route Table.\n\nThis resource can prove useful when a module accepts a Subnet id as an input variable and needs to, for example, add a route in the Route Table.")
    ("aws_s3_bucket" "Provides details about a specific S3 bucket.\n\nThis resource may prove useful when setting up a Route53 record, or an origin for a CloudFront Distribution.")
    ("aws_s3_bucket_object" "The S3 object data source allows access to the metadata and optionally (see below) content of an object stored inside S3 bucket.\n\n Note: The content of an object (body field) is available only for objects which have a human-readable Content-Type (text/* and application/json). This is to prevent printing unsafe characters and potentially downloading large amount of data which would be thrown away in favour of metadata.")
    ("aws_secretsmanager_secret" "Retrieve metadata information about a Secrets Manager secret. To retrieve a secret value, see the aws_secretsmanager_secret_version data source.")
    ("aws_secretsmanager_secret_version" "Retrieve information about a Secrets Manager secret version includings its secret value. To retrieve secret metadata, see the aws_secretsmanager_secret data source.")
    ("aws_security_group" "aws_security_group provides details about a specific Security Group.\n\nThis resource can prove useful when a module accepts a Security Group id as an input variable and needs to, for example, determine the id of the VPC that the security group belongs to.")
    ("aws_sqs_queue" "Use this data source to get the ARN and URL of queue in AWS Simple Queue Service (SQS). By using this data source, you can reference SQS queues without having to hardcode the ARNs as input.")
    ("aws_sns_topic" "Use this data source to get the ARN of a topic in AWS Simple Notification Service (SNS). By using this data source, you can reference SNS topics without having to hard code the ARNs as input.")
    ("aws_ssm_parameter" "Provides an SSM Parameter data source.")
    ("aws_subnet" "aws_subnet provides details about a specific VPC subnet.\n\nThis resource can prove useful when a module accepts a subnet id as an input variable and needs to, for example, determine the id of the VPC that the subnet belongs to.")
    ("aws_subnet_ids" "aws_subnet_ids provides a list of ids for a vpc_id\n\nThis resource can be useful for getting back a list of subnet ids for a vpc.")
    ("aws_vpc" "aws_vpc provides details about a specific VPC.\n\nThis resource can prove useful when a module accepts a vpc id as an input variable and needs to, for example, determine the CIDR block of that VPC.")
    ("aws_vpc_endpoint" "The VPC Endpoint data source provides details about a specific VPC endpoint.")
    ("aws_vpc_endpoint_service" "The VPC Endpoint Service data source details about a specific service that can be specified when creating a VPC endpoint within the region configured in the provider.")
    ("aws_vpc_peering_connection" "The VPC Peering Connection data source provides details about a specific VPC peering connection.")
    ("aws_vpn_gateway" "The VPN Gateway data source provides details about a specific VPN gateway.")
    ("azurerm_application_security_group" "Get information about an Application Security Group.\n\n Note: Application Security Groups are currently in Public Preview on an opt-in basis. More information, including how you can register for the Preview, and which regions Application Security Groups are available in are available here")
    ("azurerm_app_service" "Use this data source to obtain information about an App Service.")
    ("azurerm_app_service_plan" "Use this data source to obtain information about an App Service Plan (formerly known as a Server Farm).")
    ("azurerm_builtin_role_definition" "Use this data source to access the properties of a built-in Role Definition. To access information about a custom Role Definition, please see the azurerm_role_definition data source instead.")
    ("azurerm_cdn_profile" "Use this data source to access information about a CDN Profile.")
    ("azurerm_client_config" "Use this data source to access the configuration of the Azure Resource Manager provider.")
    ("azurerm_cosmosdb_account" "Use this data source to access the properties of an Azure CosmosDB (formally DocumentDB) Account.")
    ("azurerm_dns_zone" "Use this data source to obtain information about a DNS Zone.")
    ("azurerm_eventhub_namespace" "Use this data source to obtain information about an EventHub Namespace.")
    ("azurerm_image" "Use this data source to access information about an Image.")
    ("azurerm_key_vault" "Gets information about a Key Vault.")
    ("azurerm_key_vault_access_policy" "Use this data source to access information about the permissions from the Management Key Vault Templates.")
    ("azurerm_key_vault_secret" "Returns information about the specified Key Vault Secret.\n\n Note: All arguments including the secret value will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_kubernetes_cluster" "Gets information about a managed Kubernetes Cluster (AKS)\n\n Note: All arguments including the client secret will be stored in the raw state as plain-text. Read more about sensitive data in state.")
    ("azurerm_managed_disk" "Use this data source to access the properties of an existing Azure Managed Disk.")
    ("azurerm_network_interface" "Use this data source to access the properties of an Azure Network Interface.")
    ("azurerm_network_security_group" "Use this data source to access the properties of a Network Security Group.")
    ("azurerm_platform_image" "Use this data source to access the properties of an Azure Platform Image.")
    ("azurerm_public_ip" "Use this data source to access the properties of an existing Azure Public IP Address.")
    ("azurerm_public_ips" "Use this data source to access a filtered list of Public IP Addresses")
    ("azurerm_recovery_services_vault" "Use this data source to access the properties of a Recovery Services Vault.")
    ("azurerm_resource_group" "Use this data source to access the properties of an Azure resource group.")
    ("azurerm_role_definition" "Use this data source to access the properties of a custom Role Definition. To access information about a built-in Role Definition, please see the azurerm_builtin_role_definition data source instead.")
    ("azurerm_route_table" "Gets information about a Route Table")
    ("azurerm_scheduler_job_collection" "Use this data source to access the properties of an Azure scheduler job collection.")
    ("azurerm_storage_account" "Gets information about the specified Storage Account.")
    ("azurerm_subnet" "Use this data source to access the properties of an Azure Subnet located within a Virtual Network.")
    ("azurerm_subscription" "Use this data source to access the properties of an Azure subscription.")
    ("azurerm_subscriptions" "Use this data source to access a list of all Azure subscription currently available.")
    ("azurerm_traffic_manager_geographical_location" "Use this data source to access the ID of a specified Traffic Manager Geographical Location within the Geographical Hierarchy.")
    ("azurerm_virtual_network" "Use this data source to access the properties of an Azure Virtual Network.")
    ("azurerm_virtual_network_gateway" "Use this data source to access the properties of an Azure Virtual Network Gateway.")
    ("circonus_account" "circonus_account provides details about a specific Circonus Account.\n\nThe circonus_account data source can be used for pulling various attributes about a specific Circonus Account.")
    ("circonus_collector" "circonus_collector provides details about a specific Circonus Collector.\n\nAs well as validating a given Circonus ID, this resource can be used to discover the additional details about a collector configured within the provider.  The results of a circonus_collector API call can return more than one collector per Circonus ID.  Details of each individual collector in the group of collectors can be found via the details attribute described below.\n\n NOTE regarding cirocnus_collector: The circonus_collector data source actually queries and operates on Circonus \"brokers\" at the broker group level. The circonus_collector is simply a renamed Circonus \"broker\" to make it clear what the function of the \"broker\" actually does: act as a fan-in agent that either pulls or has metrics pushed into it and funneled back through Circonus.")
    ("cloudflare_ip_ranges" "Use this data source to get the IP ranges of CloudFlare edge nodes.")
    ("cloudstack_template" "Use this datasource to get the ID of a template for use in other resources.\n\n »   Example Usage \n\ndata \"cloudstack_template\" \"my_template\" {   template_filter = \"featured\"    filter {     name = \"name\"     value = \"CentOS 7\\\\.1\"   }    filter {     name = \"hypervisor\"     value = \"KVM\"   } } \n\n »   Argument Reference \n\n template_filter - (Required) The template filter. Possible values are featured, self, selfexecutable, sharedexecutable, executable and community (see the Cloudstack API listTemplate command documentation).  filter - (Required) One or more name/value pairs to filter off of. You can apply filters on any exported attributes.")
    ("consul_agent_self" "The consul_agent_self data source returns configuration and status data from the agent specified in the provider.")
    ("consul_catalog_nodes" "The consul_catalog_nodes data source returns a list of Consul nodes that have been registered with the Consul cluster in a given datacenter.  By specifying a different datacenter in the query_options it is possible to retrieve a list of nodes from a different WAN-attached Consul datacenter.")
    ("consul_catalog_service" "consul_catalog_service provides details about a specific Consul service in a given datacenter.  The results include a list of nodes advertising the specified service, the node's IP address, port number, node ID, etc.  By specifying a different datacenter in the query_options it is possible to retrieve a list of services from a different WAN-attached Consul datacenter.\n\nThis data source is different from the consul_catalog_services (plural) data source, which provides a summary of the current Consul services.")
    ("consul_catalog_services" "The consul_catalog_services data source returns a list of Consul services that have been registered with the Consul cluster in a given datacenter.  By specifying a different datacenter in the query_options it is possible to retrieve a list of services from a different WAN-attached Consul datacenter.\n\nThis data source is different from the consul_catalog_service (singular) data source, which provides a detailed response about a specific Consul service.")
    ("consul_keys" "The consul_keys resource reads values from the Consul key/value store. This is a powerful way dynamically set values in templates.")
    ("digitalocean_image" "Get information on an snapshot images. The aim of this datasource is to enable you to build droplets based on snapshot names.\n\nAn error is triggered if zero or more than one result is returned by the query.")
    ("dns_a_record_set" "Use this data source to get DNS A records of the host.")
    ("dns_aaaa_record_set" "Use this data source to get DNS AAAA records of the host.")
    ("dns_cname_record_set" "Use this data source to get DNS CNAME record set of the host.")
    ("dns_txt_record_set" "Use this data source to get DNS TXT record set of the host.")
    ("docker_registry_image" "Note: The initial (current) version of this data source can reliably read only public images from the official Docker Hub Registry. \n\nReads the image metadata from a Docker Registry. Used in conjunction with the docker_image resource to keep an image up to date on the latest available version of the tag.")
    ("Data Source" "The external data source allows an external program implementing a specific protocol (defined below) to act as a data source, exposing arbitrary data for use elsewhere in the Terraform configuration.\n\n Warning This mechanism is provided as an \"escape hatch\" for exceptional situations where a first-class Terraform provider is not more appropriate. Its capabilities are limited in comparison to a true data source, and implementing a data source via an external program is likely to hurt the portability of your Terraform configuration by creating dependencies on external programs and libraries that may not be available (or may need to be used differently) on different operating systems. \n\n Warning Terraform Enterprise does not guarantee availability of any particular language runtimes or external programs beyond standard shell utilities, so it is not recommended to use this data source within configurations that are applied within Terraform Enterprise.")
    ("fastly_ip_ranges" "Use this data source to get the IP ranges of Fastly edge nodes.")
    ("github_ip_ranges" "Use this data source to retrieve information about a Github's IP addresses.")
    ("github_user" "Use this data source to retrieve information about a Github user.")
    ("github_team" "Use this data source to retrieve information about a Github team.")
    ("google_billing_account" "Use this data source to get information about a Google Billing Account.\n\ndata \"google_billing_account\" \"acct\" {   display_name = \"My Billing Account\"   open         = true }  resource \"google_project\" \"my_project\" {   name       = \"My Project\"   project_id = \"your-project-id\"   org_id     = \"1234567\"    billing_account = \"${data.google_billing_account.acct.id}\" }")
    ("google_client_config" "Use this data source to access the configuration of the Google Cloud provider.")
    ("google_cloudfunctions_function" "Get information about a Google Cloud Function. For more information see the official documentation and API.")
    ("google_compute_address" "Get the IP address from a static address. For more information see the official API documentation.")
    ("google_compute_default_service_account" "Use this data source to retrieve default service account for this project")
    ("google_compute_image" "Get information about a Google Compute Image. Check that your service account has the compute.imageUser role if you want to share custom images from another project. If you want to use public images, do not forget to specify the dedicated project. For more information see the official documentation and its API.")
    ("google_compute_forwarding_rule" "Get a forwarding rule within GCE from its name.")
    ("google_compute_global_address" "Get the IP address from a static address reserved for a Global Forwarding Rule which are only used for HTTP load balancing. For more information see the official API documentation.")
    ("google_compute_network" "Get a network within GCE from its name.")
    ("Data Source" "The http data source makes an HTTP GET request to the given URL and exports information about the response.\n\nThe given URL may be either an http or https URL. At present this resource can only retrieve data from URLs that respond with text/* or application/json content types, and expects the result to be UTF-8 encoded regardless of the returned content type header.\n\n Important Although https URLs can be used, there is currently no mechanism to authenticate the remote server except for general verification of the server certificate's chain of trust. Data retrieved from servers not under your control should be treated as untrustworthy.")
    ("ignition_config" "Renders an ignition configuration as JSON. It  contains all the disks, partitions, arrays, filesystems, files, users, groups and units.")
    ("ignition_disk" "Describes the desired state of a system’s disk.")
    ("ignition_raid" "Describes the desired state of the system’s RAID.")
    ("ignition_filesystem" "Describes the desired state of a the system’s filesystems to be configured and/or used with the ignition_file resource.")
    ("ignition_file" "Describes a file to be written in a particular filesystem.")
    ("ignition_link" "Describes a link to be created in a particular filesystem.")
    ("ignition_directory" "Describes a directory to be created in a particular filesystem.")
    ("ignition_systemd_unit" "Describes the desired state of the systemd units.")
    ("ignition_networkd_unit" "Describes the desired state of the networkd units.")
    ("ignition_user" "Describes the desired user additions to the passwd database.")
    ("ignition_group" "Describes the desired group additions to the passwd database.")
    ("kubernetes_service" "A Service is an abstraction which defines a logical set of pods and a policy by which to access them - sometimes called a micro-service. This data source allows you to pull data about such service.")
    ("kubernetes_storage_class" "Storage class is the foundation of dynamic provisioning, allowing cluster administrators to define abstractions for the underlying storage platform.\n\nRead more at http://blog.kubernetes.io/2017/03/dynamic-provisioning-and-storage-classes-kubernetes.html")
    ("file" "local_file reads a file from the local filesystem.")
    ("logentries_logset" "Use this data source to get information (like ID) of already existing Logentries LogSets.")
    ("logicmonitor_collectors" "Use this datasource to get the ID of an available collector.")
    ("logicmonitor_device_group" "Use this datasource to get the ID of an available device group.")
    ("newrelic_application" "Use this data source to get information about a specific application in New Relic.")
    ("key_transaction" "Use this data source to get information about a specific key transaction in New Relic.")
    ("nomad_regions" "Retrieve a list of regions available in Nomad.")
    ("openstack_compute_flavor_v2" "Use this data source to get the ID of an available OpenStack flavor.")
    ("openstack_compute_keypair_v2" "Use this data source to get the ID and public key of an OpenStack keypair.")
    ("openstack_dns_zone_v2" "Use this data source to get the ID of an available OpenStack DNS zone.")
    ("openstack_identity_project_v3" "Use this data source to get the ID of an OpenStack project.")
    ("openstack_identity_role_v3" "Use this data source to get the ID of an OpenStack role.")
    ("openstack_identity_user_v3" "Use this data source to get the ID of an OpenStack user.")
    ("openstack_identity_auth_scope_v3" "Use this data source to get authentication information about the current auth scope in use. This can be used as self-discovery or introspection of the username or project name currently in use.")
    ("openstack_images_image_v2" "Use this data source to get the ID of an available OpenStack image.")
    ("openstack_networking_network_v2" "Use this data source to get the ID of an available OpenStack network.")
    ("openstack_networking_secgroup_v2" "Use this data source to get the ID of an available OpenStack security group.")
    ("openstack_networking_subnet_v2" "Use this data source to get the ID of an available OpenStack subnet.")
    ("openstack_networking_subnetpool_v2" "Use this data source to get the ID of an available OpenStack subnetpool.")
    ("opentelekomcloud_images_image_v2" "Use this data source to get the ID of an available OpenTelekomCloud image.")
    ("opentelekomcloud_networking_network_v2" "Use this data source to get the ID of an available OpenTelekomCloud network.")
    ("opentelekomcloud_networking_secgroup_v2" "Use this data source to get the ID of an available OpenTelekomCloud security group.")
    ("opsgenie_user" "Use this data source to get information about a specific user within OpsGenie.")
    ("opc_compute_image_list_entry" "Use this data source to access the configuration of an Image List Entry.")
    ("opc_compute_machine_image" "Use this data source to access the configuration of an Machine Image.")
    ("opc_compute_network_interface" "Use this data source to access the configuration of an instance's network interface")
    ("opc_compute_storage_volume_snapshot" "Use this data source to access the configuration of a storage volume snapshot.")
    ("opc_compute_vnic" "Use this data source to access the configuration of a Virtual NIC.")
    ("oraclepaas_database_service_instance" "Use this data source to access the configuration of a Database Service Instance")
    ("precreated_ip_block" "Use this data source to get CIDR expression for precreated IPv6 and IPv4 blocks in Packet. You can then use the cidrsubnet TF builtin function to derive subnets.")
    ("pagerduty_escalation_policy" "Use this data source to get information about a specific escalation policy that you can use for other PagerDuty resources.")
    ("pagerduty_extension_schema" "Use this data source to get information about a specific extension vendor that you can use for a service (e.g: Slack, Generic Webhook, ServiceNow).")
    ("pagerduty_schedule" "Use this data source to get information about a specific schedule that you can use for other PagerDuty resources.")
    ("pagerduty_user" "Use this data source to get information about a specific user that you can use for other PagerDuty resources.")
    ("pagerduty_team" "Use this data source to get information about a specific team that you can use for other PagerDuty resources.")
    ("pagerduty_vendor" "Use this data source to get information about a specific vendor that you can use for a service integration (e.g Amazon Cloudwatch, Splunk, Datadog).")
    ("panos_system_info" "Use this data source to retrieve \"show system info\" from the NGFW or Panorama.\n\nAll contents of \"show system info\" are saved to the info variable.  In addition, the version number of PAN-OS encountered is saved to multiple fields for ease of access.")
    ("rancher_certificate" "Use this data source to retrieve information about a Rancher certificate.")
    ("rancher_environment" "Use this data source to retrieve information about a Rancher environment.")
    ("rancher_setting" "Use this data source to retrieve information about a Rancher setting.")
    ("scaleway_bootscript" "Use this data source to get the ID of a registered Bootscript for use with the scaleway_server resource.")
    ("scaleway_image" "Use this data source to get the ID of a registered Image for use with the scaleway_server resource.")
    ("template_file" "Renders a template from a file.")
    ("template_cloudinit_config" "Renders a multi-part cloud-init config from source files.")
    ("terraform_remote_state" "Retrieves state meta data from a remote backend")
    ("tls_public_key" "Use this data source to get the public key from a PEM-encoded private key for use in other resources.")
    ("triton_account" "The triton_account data source queries Triton for Account information.\n\n NOTE: This data source uses the name of the Account currently configured in the Trition provider.")
    ("triton_datacenter" "The triton_datacenter data source queries Triton for Data Center information.\n\n NOTE: This data source uses the endpoint URL of the Data Center currently configured in the Trition provider.")
    ("triton_image" "The triton_image data source queries the Triton Image API for an image ID based on a variety of different parameters.")
    ("triton_network" "The triton_network data source queries Triton for Network information (e.g., Network ID, etc.) based on the name of the Network.")
    ("triton_fabric_vlan" "The triton_fabric_vlan data source queries Triton for Fabric VLAN information (e.g., VLAN ID, etc.) based either on the name, VLAN ID or description of the Fabric VLAN.")
    ("triton_fabric_network" "The triton_fabric_network data source queries Triton for Fabric Network information (e.g., subnet CIDR, gateway, state routes, etc.) based on the name of the Fabric Network and ID of the VLAN on which the network has been created.")
    ("vault_approle_auth_backend_role_id" "Reads the Role ID of an AppRole from a Vault server.")
    ("vault_aws_access_credentials" "Reads AWS credentials from an AWS secret backend in Vault.\n\n Important All data retrieved from Vault will be written in cleartext to state file generated by Terraform, will appear in the console output when Terraform runs, and may be included in plan files if secrets are interpolated into any resource attributes. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("vault_generic_secret" "Reads arbitrary data from a given path in Vault.\n\nThis resource is primarily intended to be used with Vault's \"generic\" secret backend, but it is also compatible with any other Vault endpoint that supports the vault read command.\n\n Important All data retrieved from Vault will be written in cleartext to state file generated by Terraform, will appear in the console output when Terraform runs, and may be included in plan files if secrets are interpolated into any resource attributes. Protect these artifacts accordingly. See the main provider documentation for more details.")
    ("nsxt_edge_cluster" "This data source provides information about Edge clusters configured in NSX. An Edge cluster is a collection of Edge nodes which can be deployed as either VM form-factor or bare-metal form-factor machines for connectivity between overlay logical switches and non-NSX underlay networking for north/south layer 2 or layer 3 connectivity. Each T0 router will be placed on one ore more Edge nodes in an Edge cluster therefore this data source is needed for the creation of T0 logical routers.")
    ("nsxt_logical_tier0_router" "This data source provides information about logical Tier 0 routers configured in NSX. A Tier 0 router is used to connect NSX networking with traditional physical networking. Tier 0 routers are placed on an Edge cluster and will exist on one or more Edge node depending on deployment settings (i.e. active/active or active/passive). A Tier 0 router forwards layer 3 IP packets and typically peers with a traditional physical router using BGP or can use static routing.")
    ("nsxt_ns_serivce" "This data source provides information about a network and security (NS) service configured in NSX. NS services are either factory defined in NSX or can be defined by the NSX administrator. They provide a convenience name for a port/protocol pair that is often used in fire walling or load balancing.")
    ("nsxt_switching_profile" "The switching profile data source provides information about switching profiles configured in NSX. A switching profile is a template that defines the settings of one or more logical switches. There can be both factory default and user defined switching profiles. One example of a switching profile is a quality of service (QoS) profile which defines the QoS settings of all switches that use the defined switch profile.")
    ("nsxt_transport_zone" "This data source provides information about Transport Zones (TZ) configured in NSX. A Transport Zone defines the scope to which a network can extend in NSX. For example an overlay based Transport Zone is associated with both hypervisors and logical switches and defines which hypervisors will be able to serve the defined logical switch. Virtual machines on the hypervisor associated with a Transport Zone can be attached to logical switches in that same Transport Zone.")
    ("vsphere_compute_cluster" "The vsphere_compute_cluster data source can be used to discover the ID of a cluster in vSphere. This is useful to fetch the ID of a cluster that you want to use for virtual machine placement via the vsphere_virtual_machine resource, allowing you to specify the cluster's root resource pool directly versus using the alias available through the vsphere_resource_pool data source.\n\n You may also wish to see the vsphere_compute_cluster resource for further details about clusters or how to work with them in Terraform.")
    ("vsphere_custom_attribute" "The vsphere_custom_attribute data source can be used to reference custom  attributes that are not managed by Terraform. Its attributes are exactly the  same as the vsphere_custom_attribute resource,  and, like importing, the data source takes a name to search on. The id and  other attributes are then populated with the data found by the search.\n\n NOTE: Custom attributes are unsupported on direct ESXi connections  and require vCenter.")
    ("vsphere_datacenter" "The vsphere_datacenter data source can be used to discover the ID of a vSphere datacenter. This can then be used with resources or data sources that require a datacenter, such as the vsphere_host data source.")
    ("vsphere_datastore" "The vsphere_datastore data source can be used to discover the ID of a datastore in vSphere. This is useful to fetch the ID of a datastore that you want to use to create virtual machines in using the vsphere_virtual_machine resource.")
    ("vsphere_datastore_cluster" "The vsphere_datastore_cluster data source can be used to discover the ID of a datastore cluster in vSphere. This is useful to fetch the ID of a datastore cluster that you want to use to assign datastores to using the vsphere_nas_datastore or vsphere_vmfs_datastore resources, or create virtual machines in using the vsphere_virtual_machine resource.")
    ("vsphere_distributed_virtual_switch" "The vsphere_distributed_virtual_switch data source can be used to discover the ID and uplink data of a of a vSphere distributed virtual switch (DVS). This can then be used with resources or data sources that require a DVS, such as the vsphere_distributed_port_group resource, for which an example is shown below.\n\n NOTE: This data source requires vCenter and is not available on direct ESXi connections.")
    ("vsphere_host" "The vsphere_host data source can be used to discover the ID of a vSphere host. This can then be used with resources or data sources that require a host managed object reference ID.")
    ("vsphere_network" "The vsphere_network data source can be used to discover the ID of a network in vSphere. This can be any network that can be used as the backing for a network interface for vsphere_virtual_machine or any other vSphere resource that requires a network. This includes standard (host-based) port groups, DVS port groups, or opaque networks such as those managed by NSX.")
    ("vsphere_resource_pool" "The vsphere_resource_pool data source can be used to discover the ID of a resource pool in vSphere. This is useful to fetch the ID of a resource pool that you want to use to create virtual machines in using the vsphere_virtual_machine resource.")
    ("vsphere_tag" "The vsphere_tag data source can be used to reference tags that are not managed by Terraform. Its attributes are exactly the same as the vsphere_tag resource, and, like importing, the data source takes a name and category to search on. The id and other attributes are then populated with the data found by the search.\n\n NOTE: Tagging support is unsupported on direct ESXi connections and requires vCenter 6.0 or higher.")
    ("vsphere_tag_category" "The vsphere_tag_category data source can be used to reference tag categories that are not managed by Terraform. Its attributes are exactly the same as the vsphere_tag_category resource, and, like importing, the data source takes a name to search on. The id and other attributes are then populated with the data found by the search.\n\n NOTE: Tagging support is unsupported on direct ESXi connections and requires vCenter 6.0 or higher.")
    ("vsphere_virtual_machine" "The vsphere_virtual_machine data source can be used to find the UUID of an existing virtual machine or template. Its most relevant purpose is for finding the UUID of a template to be used as the source for cloning into a new vsphere_virtual_machine resource. It also reads the guest ID so that can be supplied as well.")
    ("vsphere_vmfs_disks" "The vsphere_vmfs_disks data source can be used to discover the storage devices available on an ESXi host. This data source can be combined with the vsphere_vmfs_datastore resource to create VMFS datastores based off a set of discovered disks.")
   ))

(puthash "alicloud_regions" '(
    ("name" "name - (Optional) The full name of the region to select.")
    ("current" "current - (Optional) Set to true to match only the region configured in the provider.")
    ("output_file" "output_file - (Optional) The name of file that can save regions data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_instance_types" '(
    ("availability_zone" "availability_zone - (Optional) The Zone that supports available instance types.")
    ("cpu_core_count" "cpu_core_count - (Optional) Limit search to specific cpu core count.")
    ("memory_size" "memory_size - (Optional) Limit search to specific memory size.")
    ("instance_type_family" "instance_type_family - (Optional) Allows to filter list of Instance Types based on their family name, for example 'ecs.n4'.")
    ("is_outdated" "is_outdated - (Optional) Whether to export outdated instance types. Default to false.")
    ("output_file" "output_file - (Optional) The name of file that can save instance types data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_images" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the image list returned by Alicloud.")
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent image.")
    ("owners" "owners - (Optional) Limit search to specific image owners. Valid items are system, self, others, marketplace.")
    ("output_file" "output_file - (Optional) The name of file that can save images data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_zones" '(
    ("available_instance_type" "available_instance_type - (Optional) Limit search to specific instance type.")
    ("available_resource_creation" "available_resource_creation - (Optional) Limit search to specific resource type. The following values are allowed Instance, Disk, VSwitch and Rds.")
    ("available_disk_category" "available_disk_category - (Optional) Limit search to specific disk category. Can be either cloud, cloud_efficiency, cloud_ssd.")
    ("multi" "multi - (Optional) Whether to retrieve multiple availability. Default to false. Multiple zone usually is used to launch RDS.")
    ("output_file" "output_file - (Optional) The name of file that can save zones data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_key_pairs" '(
    ("name_regex" "name_regex - A regex string to apply to the key pair list returned by Alicloud.")
    ("finger_print" "finger_print - A finger print used to retrieve specified key pair.")
    ("output_file" "output_file - (Optional) The name of file that can save key pairs data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_kms_keys" '(
    ("ids" "ids - (Optional) A list of KMS key ID.")
    ("description_regex" "description_regex - (Optional) A regex string of the KMS key description.")
    ("status" "status - (Optional) The status of KMS key. Valid values: \"Enabled\", \"Disabled\", \"PendingDeletion\". Default to nil to get all keys.")
    ("output_file" "output_file - (Optional) The name of file that can save KMS keys data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_instances" '(
    ("ids" "ids - (Optional) A list of ECS instance ID.")
    ("name_regex" "name_regex - (Optional) A regex string to apply to the instance list returned by Alicloud.")
    ("image_id" "image_id - (Optional) The image ID of some ECS instance used.")
    ("status" "status - (Optional) List specified status instances. Valid values: \"Creating\", \"Starting\", \"Running\", \"Stopping\" and \"Stopped\". Default to list all status.")
    ("vpc_id" "vpc_id - (Optional) List several instances in the specified VPC.")
    ("vswitch_id" "vswitch_id - (Optional) List several instances in the specified VSwitch.")
    ("availability_zone" "availability_zone - (Optional) List several instances in the specified availability zone.")
    ("tags" "tags - (Optional) A mapping of tags marked ECS instanes.")
    ("output_file" "output_file - (Optional) The name of file that can save instances data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_vpcs" '(
    ("cidr_block" "cidr_block - (Optional) Limit search to specific cidr block,like \"172.16.0.0/12\".")
    ("status" "status - (Optional) Limit search to specific status - valid value is \"Pending\" or \"Available\".")
    ("name_regex" "name_regex - (Optional) A regex string of VPC name.")
    ("is_default" "is_default - (Optional) Whether the VPC is the default VPC in the specified region - valid value is true or false.")
    ("vswitch_id" "vswitch_id - (Optional) Retrieving VPC according to the specified VSwitch.")
    ("output_file" "output_file - (Optional) The name of file that can save vpcs data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_vswitches" '(
    ("cidr_block" "cidr_block - (Optional) Limit search to specific cidr block,like \"172.16.0.0/12\".")
    ("zone_id" "zone_id - (Optional) The availability zone for one vswitch.")
    ("name_regex" "name_regex - (Optional) A regex string of VSwitch name.")
    ("is_default" "is_default - (Optional) Whether the Vswitch is created by system - valid value is true or false.")
    ("vpc_id" "vpc_id - (Optional) VPC ID in which vswitch belongs.")
    ("output_file" "output_file - (Optional) The name of file that can save vswitches data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_eips" '(
    ("ids" "ids - (Optional) A list of EIP allocation ID.")
    ("ip_addresses" "ip_addresses - (Optional) A list of EIP ip address ID.")
    ("in_use" "in_use - (Deprecated) It has been deprecated from provider version 1.8.0.")
    ("output_file" "output_file - (Optional) The name of file that can save eips data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_security_groups" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the security groups list returned by Alicloud.")
    ("vpc_id" "vpc_id - (Optional) Used to retrieve security groups belong to specified VPC ID.")
    ("output_file" "output_file - (Optional) The name of file that can save security groups data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_security_group_rules" '(
    ("group_id" "group_id - (Required) The id of security group wich owns the rules.")
    ("nic_type" "nic_type - (Optional) Refers to the network type. Can be either internet or intranet. The default value is internet.")
    ("direction" "direction - (Optional) Authorization direction, ingress or egress.")
    ("ip_protocol" "ip_protocol - (Optional) The protocol. Can be tcp, udp, icmp, gre or all.")
    ("policy" "policy - (Optional) Authorization policy. Can be either accept or drop. The default value is accept.")
    ("output_file" "output_file - (Optional) The name of file that can save security group rules after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_dns_domain_groups" '(

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_dns_domain_records" '(

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_dns_groups" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the group list returned by Alicloud.")
    ("output_file" "output_file - (Optional) The name of file that can save groups data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_dns_records" '(
    ("domain_name" "domain_name - (Required) A domain name which is the necessary parameter for the records query.")
    ("host_record_regex" "host_record_regex - (Optional) Limit search to provide host record regex.")
    ("value_regex" "value_regex - (Optional) Limit search to provide host record value regex.")
    ("type" "type - (Optional) Limit search to specific record type. Valid items are A, NS, MX, TXT, CNAME, SRV, AAAA, REDIRECT_URL, FORWORD_URL .")
    ("line" "line - (Optional) Limit search to specific parsing line. Valid items are default, telecom, unicom, mobile, oversea, edu.")
    ("status" "status - (Optional) Limit search to specific record status. Valid items are ENABLE and DISABLE.")
    ("is_locked" "is_locked - (Optional, type: bool) Limit search to specific record lock status.")
    ("output_file" "output_file - (Optional) The name of file that can save records data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_dns_domains" '(
    ("domain_name_regex" "domain_name_regex - (Optional) A regex string to apply to the domain list returned by Alicloud.")
    ("group_name_regex" "group_name_regex - (Optional)  Limit search to provide group name regex.")
    ("ali_domain" "ali_domain - (Optional, type: bool) Limit search to specific whether it is Alicloud domain.")
    ("instance_id" "instance_id - (Optional) Limit search to specific cloud analysis product ID.")
    ("version_code" "version_code - (Optional) Limit search to specific cloud analysis version code.")
    ("output_file" "output_file - (Optional) The name of file that can save domains data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_ram_account_aliases" '(
    ("output_file" "output_file - (Optional) The name of file that can save alias data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_ram_account_alias" '(

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_ram_groups" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the group list returned by Alicloud.")
    ("user_name" "user_name - (Optional) Limit search to specific the user name. Found the groups for the specified user.")
    ("policy_type" "policy_type - (Optional) Limit search to specific the policy type. Valid items are Custom and System. If you set this parameter, you must set policy_name at one time.")
    ("policy_name" "policy_name - (Optional) Limit search to specific the policy name. If you set this parameter without set policy_type, we will specified it as System. Found the groups which attached with the specified policy.")
    ("output_file" "output_file - (Optional) The name of file that can save groups data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_ram_policies" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the policy list returned by Alicloud.")
    ("type" "type - (Optional) Limit search to specific the policy type. Valid items are Custom and System.")
    ("user_name" "user_name - (Optional) Limit search to specific the user name. Found the policies which attached with the specified user.")
    ("group_name" "group_name - (Optional) Limit search to specific the group name. Found the policies which attached with the specified group.")
    ("role_name" "role_name - (Optional) Limit search to specific the role name. Found the policies which attached with the specified role.")
    ("output_file" "output_file - (Optional) The name of file that can save policies data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_ram_roles" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the role list returned by Alicloud.")
    ("policy_type" "policy_type - (Optional) Limit search to specific the policy type. Valid items are Custom and System. If you set this parameter, you must set policy_name at one time.")
    ("policy_name" "policy_name - (Optional) Limit search to specific the policy name. If you set this parameter without set policy_type, we will specified it as System. Found the roles which attached with the specified policy.")
    ("output_file" "output_file - (Optional) The name of file that can save roles data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_ram_users" '(
    ("name_regex" "name_regex - (Optional) A regex string to apply to the user list returned by Alicloud.")
    ("group_name" "group_name - (Optional) Limit search to specific the group name. Found the users which in the specified group.")
    ("policy_type" "policy_type - (Optional) Limit search to specific the policy type. Valid items are Custom and System. If you set this parameter, you must set policy_name at one time.")
    ("policy_name" "policy_name - (Optional) Limit search to specific the policy name. If you set this parameter without set policy_type, we will specified it as System. Found the users which attached with the specified policy.")
    ("output_file" "output_file - (Optional) The name of file that can save users data source after running terraform plan.")

  ) company-terraform-data-arguments-hash)

(puthash "archive_file" '(
    ("type" "type - (Required) The type of archive to generate. NOTE: zip is supported.")
    ("output_path" "output_path - (Required) The output of the archive file.")
    ("source_content" "source_content - (Optional) Add only this content to the archive with source_content_filename as the filename.")
    ("source_content_filename" "source_content_filename - (Optional) Set this as the filename when using source_content.")
    ("source_file" "source_file - (Optional) Package this file into the archive.")
    ("source_dir" "source_dir - (Optional) Package entire contents of this directory into the archive.")
    ("source" "source - (Optional) Specifies attributes of a single source file to include into the archive.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_acm_certificate" '(
    ("domain" "domain - (Required) The domain of the certificate to look up. If no certificate is found with this name, an error will be returned.")
    ("statuses" "statuses - (Optional) A list of statuses on which to filter the returned list. Valid values are PENDING_VALIDATION, ISSUED, INACTIVE, EXPIRED, VALIDATION_TIMED_OUT, REVOKED and FAILED. If no value is specified, only certificates in the ISSUED state are returned.")
    ("types" "types - (Optional) A list of types on which to filter the returned list. Valid values are AMAZON_ISSUED and IMPORTED.")
    ("most_recent" "most_recent - (Optional) If set to true, it sorts the certificates matched by previous criteria by the NotBefore field, returning only the most recent one. If set to false, it returns an error if more than one certificate is found. Defaults to false.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_acmpca_certificate_authority" '(
    ("arn" "arn - (Required) Amazon Resource Name (ARN) of the certificate authority.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_alb" '(
    ("arn" "arn - (Optional) The full ARN of the load balancer.")
    ("name" "name - (Optional) The unique name of the load balancer.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_alb_listener" '(
    ("arn" "arn - (Optional) The arn of the listener. Required if load_balancer_arn and port is not set.")
    ("load_balancer_arn" "load_balancer_arn - (Optional) The arn of the load balander. Required if arn is not set.")
    ("port" "port - (Optional) The port of the listener. Required if arn is not set.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_alb_target_group" '(
    ("arn" "arn - (Optional) The full ARN of the target group.")
    ("name" "name - (Optional) The unique name of the target group.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ami" '(
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent AMI.")
    ("executable_users" "executable_users - (Optional) Limit search to users with explicit launch permission on the image. Valid items are the numeric account ID or self.")
    ("filter" "filter - (Optional) One or more name/value pairs to filter off of. There are several valid keys, for a full reference, check out describe-images in the AWS CLI reference.")
    ("owners" "owners - (Optional) Limit search to specific AMI owners. Valid items are the numeric account ID, amazon, or self.")
    ("name_regex" "name_regex - (Optional) A regex string to apply to the AMI list returned by AWS. This allows more advanced filtering not supported from the AWS API. This filtering is done locally on what AWS returns, and could have a performance impact if the result is large. It is recommended to combine this with other options to narrow down the list AWS returns.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ami_ids" '(
    ("executable_users" "executable_users - (Optional) Limit search to users with explicit launch permission on  the image. Valid items are the numeric account ID or self.")
    ("filter" "filter - (Optional) One or more name/value pairs to filter off of. There are several valid keys, for a full reference, check out describe-images in the AWS CLI reference.")
    ("owners" "owners - (Optional) Limit search to specific AMI owners. Valid items are the numeric account ID, amazon, or self.")
    ("name_regex" "name_regex - (Optional) A regex string to apply to the AMI list returned by AWS. This allows more advanced filtering not supported from the AWS API. This filtering is done locally on what AWS returns, and could have a performance impact if the result is large. It is recommended to combine this with other options to narrow down the list AWS returns.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_api_gateway_rest_api" '(
    ("name" "name - (Required) The name of the REST API to look up. If no REST API is found with this name, an error will be returned.  If multiple REST APIs are found with this name, an error will be returned.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_arn" '(
    ("arn" "arn - (Required) The ARN to parse.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_autoscaling_groups" '(
    ("filter" "filter - (Optional) A filter used to scope the list e.g. by tags. See related docs.   name - (Required) The name of the filter. The valid values are: auto-scaling-group, key, value, and propagate-at-launch.  values - (Required) The value of the filter.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_availability_zone" '(
    ("name" "name - (Optional) The full name of the availability zone to select.")
    ("state" "state - (Optional) A specific availability zone state to require. May be any of \"available\", \"information\" or \"impaired\".")

  ) company-terraform-data-arguments-hash)

(puthash "aws_availability_zones" '(
    ("state" "state - (Optional) Allows to filter list of Availability Zones based on their current state. Can be either \"available\", \"information\", \"impaired\" or \"unavailable\". By default the list includes a complete set of Availability Zones to which the underlying AWS account has access, regardless of their state.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_batch_compute_environment" '(
    ("compute_environment_name" "compute_environment_name - (Required) The name of the Batch Compute Environment")

  ) company-terraform-data-arguments-hash)

(puthash "aws_batch_job_queue" '(
    ("name" "name - (Required) The name of the job queue.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_billing_service_account" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_caller_identity" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_canonical_user_id" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_cloudformation_stack" '(
    ("name" "name - (Required) The name of the stack")

  ) company-terraform-data-arguments-hash)

(puthash "aws_cloudtrail_service_account" '(
    ("region" "region - (Optional) Name of the region whose AWS CloudTrail account ID is desired. Defaults to the region from the AWS provider configuration.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_cloudwatch_log_group" '(
    ("name" "name - (Required) The name of the Cloudwatch log group")

  ) company-terraform-data-arguments-hash)

(puthash "aws_cognito_user_pools" '(
    ("name" "name - (required) Name of the cognito user pools. Name is not a unique attribute for cognito user pool, so multiple pools might be returned with given name.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_db_instance" '(
    ("db_instance_identifier" "db_instance_identifier - (Required) The name of the RDS instance")

  ) company-terraform-data-arguments-hash)

(puthash "aws_db_snapshot" '(
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent Snapshot.")
    ("db_instance_identifier" "db_instance_identifier - (Optional) Returns the list of snapshots created by the specific db_instance")
    ("db_snapshot_identifier" "db_snapshot_identifier - (Optional) Returns information on a specific snapshot_id.")
    ("snapshot_type" "snapshot_type - (Optional) The type of snapshots to be returned. If you don't specify a SnapshotType value, then both automated and manual snapshots are returned. Shared and public DB snapshots are not included in the returned results by default. Possible values are, automated, manual, shared and public.")
    ("include_shared" "include_shared - (Optional) Set this value to true to include shared manual DB snapshots from other AWS accounts that this AWS account has been given permission to copy or restore, otherwise set this value to false. The default is false.")
    ("include_public" "include_public - (Optional) Set this value to true to include manual DB snapshots that are public and can be copied or restored by any AWS account, otherwise set this value to false. The default is false.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_dynamodb_table" '(
    ("name" "name - (Required) The name of the DynamoDB table.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ebs_snapshot" '(
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent snapshot.")
    ("owners" "owners - (Optional) Returns the snapshots owned by the specified owner id. Multiple owners can be specified.")
    ("snapshot_ids" "snapshot_ids - (Optional) Returns information on a specific snapshot_id.")
    ("restorable_by_user_ids" "restorable_by_user_ids - (Optional) One or more AWS accounts IDs that can create volumes from the snapshot.")
    ("filter" "filter - (Optional) One or more name/value pairs to filter off of. There are several valid keys, for a full reference, check out describe-snapshots in the AWS CLI reference.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ebs_snapshot_ids" '(
    ("owners" "owners - (Optional) Returns the snapshots owned by the specified owner id. Multiple owners can be specified.")
    ("restorable_by_user_ids" "restorable_by_user_ids - (Optional) One or more AWS accounts IDs that can create volumes from the snapshot.")
    ("filter" "filter - (Optional) One or more name/value pairs to filter off of. There are several valid keys, for a full reference, check out describe-volumes in the AWS CLI reference.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ebs_volume" '(
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent Volume.")
    ("filter" "filter - (Optional) One or more name/value pairs to filter off of. There are several valid keys, for a full reference, check out describe-volumes in the AWS CLI reference.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ecr_repository" '(
    ("name" "name - (Required) The name of the ECR Repository.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ecs_cluster" '(
    ("cluster_name" "cluster_name - (Required) The name of the ECS Cluster")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ecs_container_definition" '(
    ("task_definition" "task_definition - (Required) The ARN of the task definition which contains the container")
    ("container_name" "container_name - (Required) The name of the container definition")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ecs_task_definition" '(
    ("task_definition" "task_definition - (Required) The family for the latest ACTIVE revision, family and revision (family:revision) for a specific revision in the family, the ARN of the task definition to access to.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_efs_file_system" '(
    ("file_system_id" "file_system_id - (Optional) The ID that identifies the file system (e.g. fs-ccfc0d65).")
    ("creation_token" "creation_token - (Optional) Restricts the list to the file system with this creation token.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_efs_mount_target" '(
    ("mount_target_id" "mount_target_id - (Required) ID of the mount target that you want to have described")

  ) company-terraform-data-arguments-hash)

(puthash "aws_eip" '(
    ("id" "id - (Optional) The allocation id of the specific EIP to retrieve.")
    ("public_ip" "public_ip - (Optional) The public IP of the specific EIP to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elastic_beanstalk_hosted_zone" '(
    ("region" "region - (Optional) The region you'd like the zone for. By default, fetches the current region.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elastic_beanstalk_solution_stack" '(
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent solution stack.")
    ("name_regex" "name_regex - A regex string to apply to the solution stack list returned by AWS. See Elastic Beanstalk Supported Platforms from AWS documentation for reference solution stack names.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elasticache_cluster" '(
    ("cluster_id" "cluster_id – (Required) Group identifier.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elasticache_replication_group" '(
    ("replication_group_id" "replication_group_id – (Required) The identifier for the replication group.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elb" '(
    ("name" "name - (Required) The unique name of the load balancer.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elb_hosted_zone_id" '(
    ("region" "region - (Optional) Name of the region whose AWS ELB HostedZoneId is desired. Defaults to the region from the AWS provider configuration.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_elb_service_account" '(
    ("region" "region - (Optional) Name of the region whose AWS ELB account ID is desired. Defaults to the region from the AWS provider configuration.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_account_alias" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_group" '(
    ("group_name" "group_name - (Required) The friendly IAM group name to match.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_instance_profile" '(
    ("name" "name - (Required) The friendly IAM instance profile name to match.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_policy" '(
    ("arn" "arn - (Required) ARN of the IAM policy.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_policy_document" '(
    ("policy_id" "policy_id (Optional) - An ID for the policy document.")
    ("source_json" "source_json (Optional) - An IAM policy document to import as a base for the current policy document.  Statements with non-blank sids in the current policy document will overwrite statements with the same sid in the source json.  Statements without an sid cannot be overwritten.")
    ("override_json" "override_json (Optional) - An IAM policy document to import and override the current policy document.  Statements with non-blank sids in the override document will overwrite statements with the same sid in the current document. Statements without an sid cannot be overwritten.")
    ("statement" "statement (Required) - A nested configuration block (described below) configuring one statement to be included in the policy document.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_role" '(
    ("name" "name - (Required) The friendly IAM role name to match.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_server_certificate" '(
    ("name_prefix" "name_prefix - prefix of cert to filter by")
    ("path_prefix" "path_prefix - prefix of path to filter by")
    ("name" "name - exact name of the cert to lookup")
    ("latest" "latest - sort results by expiration date. returns the certificate with expiration date in furthest in the future.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iam_user" '(
    ("user_name" "user_name - (Required) The friendly IAM user name to match.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_inspector_rules_packages" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_instance" '(
    ("instance_id" "instance_id - (Optional) Specify the exact Instance ID with which to populate the data source.")
    ("instance_tags" "instance_tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired Instance.")
    ("filter" "filter - (Optional) One or more name/value pairs to use as filters. There are several valid keys, for a full reference, check out describe-instances in the AWS CLI reference.")
    ("get_password_data" "get_password_data - (Optional) If true, wait for password data to become available and retrieve it. Useful for getting the administrator password for instances running Microsoft Windows. The password data is exported to the password_data attribute. See GetPasswordData for more information.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_instances" '(
    ("instance_tags" "instance_tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on desired instances.")
    ("filter" "filter - (Optional) One or more name/value pairs to use as filters. There are several valid keys, for a full reference, check out describe-instances in the AWS CLI reference.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_internet_gateway" '(
    ("internet_gateway_id" "internet_gateway_id - (Optional) The id of the specific Internet Gateway to retrieve.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired Internet Gateway.")
    ("filter" "filter - (Optional) Custom filter block as described below.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_iot_endpoint" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_ip_ranges" '(
    ("regions" "regions - (Optional) Filter IP ranges by regions (or include all regions, if omitted). Valid items are global (for cloudfront) as well as all AWS regions (e.g. eu-central-1)")
    ("services" "services - (Required) Filter IP ranges by services. Valid items are amazon (for amazon.com), cloudfront, codebuild, ec2, route53, route53_healthchecks and S3.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_kinesis_stream" '(
    ("name" "name - (Required) The name of the Kinesis Stream.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_kms_alias" '(
    ("name" "name - (Required) The display name of the alias. The name must start with the word \"alias\" followed by a forward slash (alias/)")

  ) company-terraform-data-arguments-hash)

(puthash "aws_kms_key" '(
    ("key_id" "key_id - (Required) Key identifier which can be one of the following format:   Key ID. E.g: 1234abcd-12ab-34cd-56ef-1234567890ab  Key ARN. E.g.: arn:aws:kms:us-east-1:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab  Alias name. E.g.: alias/my-key  Alias ARN: E.g.: arn:aws:kms:us-east-1:111122223333:alias/my-key")
    ("grant_tokens" "grant_tokens - (Optional) List of grant tokens")

  ) company-terraform-data-arguments-hash)

(puthash "aws_kms_ciphertext" '(
    ("plaintext" "plaintext - (Required) Data to be encrypted. Note that this may show up in logs, and it will be stored in the state file.")
    ("key_id" "key_id - (Required) Globally unique key ID for the customer master key.")
    ("context" "context - (Optional) An optional mapping that makes up the encryption context.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_kms_secret" '(
    ("secret" "secret - (Required) One or more encrypted payload definitions from the KMS service.  See the Secret Definitions below.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_lambda_invocation" '(
    ("function_name" "function_name - (Required) The name of the lambda function.")
    ("input" "input - (Required) A string in JSON format that is passed as payload to the lambda function.")
    ("qualifier" "qualifier - (Optional) The qualifier (a.k.a version) of the lambda function. Defaults to $LATEST.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_nat_gateway" '(
    ("id" "id - (Optional) The id of the specific Nat Gateway to retrieve.")
    ("subnet_id" "subnet_id - (Optional) The id of subnet that the Nat Gateway resides in.")
    ("vpc_id" "vpc_id - (Optional) The id of the VPC that the Nat Gateway resides in.")
    ("state" "state - (Optional) The state of the NAT gateway (pending | failed | available | deleting | deleted ).")
    ("filter" "filter - (Optional) Custom filter block as described below. More complex filters can be expressed using one or more filter sub-blocks, which take the following arguments:")
    ("name" "name - (Required) The name of the field to filter by, as defined by the underlying AWS API.")
    ("values" "values - (Required) Set of values that are accepted for the given field. An Nat Gateway will be selected if any one of the given values matches.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_network_interface" '(
    ("id" "id – (Optional) The identifier for the network interface.")
    ("filter" "filter – (Optional) One or more name/value pairs to filter off of. There are several valid keys, for a full reference, check out describe-network-interfaces in the AWS CLI reference.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_lambda_function" '(
    ("function_name" "function_name - (Required) Name of the lambda function.")
    ("qualifier" "qualifier - (Optional) Qualifier of the lambda function. Defaults to $LATEST.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_lb" '(
    ("arn" "arn - (Optional) The full ARN of the load balancer.")
    ("name" "name - (Optional) The unique name of the load balancer.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_lb_listener" '(
    ("arn" "arn - (Optional) The arn of the listener. Required if load_balancer_arn and port is not set.")
    ("load_balancer_arn" "load_balancer_arn - (Optional) The arn of the load balander. Required if arn is not set.")
    ("port" "port - (Optional) The port of the listener. Required if arn is not set.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_lb_target_group" '(
    ("arn" "arn - (Optional) The full ARN of the target group.")
    ("name" "name - (Optional) The unique name of the target group.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_mq_broker" '(
    ("broker_id" "broker_id - (Optional) The unique id of the mq broker.")
    ("broker_name" "broker_name - (Optional) The unique name of the mq broker.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_partition" '(

  ) company-terraform-data-arguments-hash)

(puthash "aws_prefix_list" '(
    ("prefix_list_id" "prefix_list_id - (Optional) The ID of the prefix list to select.")
    ("name" "name - (Optional) The name of the prefix list to select.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_rds_cluster" '(
    ("cluster_identifier" "cluster_identifier - (Required) The cluster identifier of the RDS cluster.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_redshift_cluster" '(
    ("cluster_identifier" "cluster_identifier - (Required) The cluster identifier")

  ) company-terraform-data-arguments-hash)

(puthash "aws_redshift_service_account" '(
    ("region" "region - (Optional) Name of the region whose AWS Redshift account ID is desired. Defaults to the region from the AWS provider configuration.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_region" '(
    ("name" "name - (Optional) The full name of the region to select.")
    ("endpoint" "endpoint - (Optional) The EC2 endpoint of the region to select.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_route53_zone" '(
    ("zone_id" "zone_id - (Optional) The Hosted Zone id of the desired Hosted Zone.")
    ("name" "name - (Optional) The Hosted Zone name of the desired Hosted Zone.")
    ("private_zone" "private_zone - (Optional) Used with name field to get a private Hosted Zone.")
    ("vpc_id" "vpc_id - (Optional) Used with name field to get a private Hosted Zone associated with the vpc_id (in this case, private_zone is not mandatory).")
    ("tags" "tags - (Optional) Used with name field. A mapping of tags, each pair of which must exactly match a pair on the desired Hosted Zone.  »   Attributes Reference")

  ) company-terraform-data-arguments-hash)

(puthash "aws_route_table" '(
    ("filter" "filter - (Optional) Custom filter block as described below.")
    ("route_table_id" "route_table_id - (Optional) The id of the specific Route Table to retrieve.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired Route Table.")
    ("vpc_id" "vpc_id - (Optional) The id of the VPC that the desired Route Table belongs to.")
    ("subnet_id" "subnet_id - (Optional) The id of a Subnet which is connected to the Route Table (not be exported if not given in parameter).")

  ) company-terraform-data-arguments-hash)

(puthash "aws_s3_bucket" '(
    ("bucket" "bucket - (Required) The name of the bucket")

  ) company-terraform-data-arguments-hash)

(puthash "aws_s3_bucket_object" '(
    ("bucket" "bucket - (Required) The name of the bucket to read the object from")
    ("key" "key - (Required) The full path to the object inside the bucket")
    ("version_id" "version_id - (Optional) Specific version ID of the object returned (defaults to latest version)")

  ) company-terraform-data-arguments-hash)

(puthash "aws_secretsmanager_secret" '(
    ("arn" "arn - (Optional) The Amazon Resource Name (ARN) of the secret to retrieve.")
    ("name" "name - (Optional) The name of the secret to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_secretsmanager_secret_version" '(
    ("secret_id" "secret_id - (Required) Specifies the secret containing the version that you want to retrieve. You can specify either the Amazon Resource Name (ARN) or the friendly name of the secret.")
    ("version_id" "version_id - (Optional) Specifies the unique identifier of the version of the secret that you want to retrieve. Overrides version_stage.")
    ("version_stage" "version_stage - (Optional) Specifies the secret version that you want to retrieve by the staging label attached to the version. Defaults to AWSCURRENT.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_security_group" '(
    ("filter" "filter - (Optional) Custom filter block as described below.")
    ("id" "id - (Optional) The id of the specific security group to retrieve.")
    ("name" "name - (Optional) The name that the desired security group must have.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired security group.")
    ("vpc_id" "vpc_id - (Optional) The id of the VPC that the desired security group belongs to.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_sqs_queue" '(
    ("name" "name - (Required) The name of the queue to match.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_sns_topic" '(
    ("name" "name - (Required) The friendly name of the topic to match.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_ssm_parameter" '(
    ("name" "name - (Required) The name of the parameter.")
    ("with_decryption" "with_decryption - (Optional) Whether to return decrypted SecureString value. Defaults to true.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_subnet" '(
    ("availability_zone" "availability_zone - (Optional) The availability zone where the subnet must reside.")
    ("cidr_block" "cidr_block - (Optional) The cidr block of the desired subnet.")
    ("ipv6_cidr_block" "ipv6_cidr_block - (Optional) The Ipv6 cidr block of the desired subnet")
    ("default_for_az" "default_for_az - (Optional) Boolean constraint for whether the desired subnet must be the default subnet for its associated availability zone.")
    ("filter" "filter - (Optional) Custom filter block as described below.")
    ("id" "id - (Optional) The id of the specific subnet to retrieve.")
    ("state" "state - (Optional) The state that the desired subnet must have.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired subnet.")
    ("vpc_id" "vpc_id - (Optional) The id of the VPC that the desired subnet belongs to.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_subnet_ids" '(
    ("vpc_id" "vpc_id - (Required) The VPC ID that you want to filter from.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired subnets.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_vpc" '(
    ("cidr_block" "cidr_block - (Optional) The cidr block of the desired VPC.")
    ("dhcp_options_id" "dhcp_options_id - (Optional) The DHCP options id of the desired VPC.")
    ("default" "default - (Optional) Boolean constraint on whether the desired VPC is the default VPC for the region.")
    ("filter" "filter - (Optional) Custom filter block as described below.")
    ("id" "id - (Optional) The id of the specific VPC to retrieve.")
    ("state" "state - (Optional) The current state of the desired VPC. Can be either \"pending\" or \"available\".")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired VPC.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_vpc_endpoint" '(
    ("id" "id - (Optional) The ID of the specific VPC Endpoint to retrieve.")
    ("state" "state - (Optional) The state of the specific VPC Endpoint to retrieve.")
    ("vpc_id" "vpc_id - (Optional) The ID of the VPC in which the specific VPC Endpoint is used.")
    ("service_name" "service_name - (Optional) The AWS service name of the specific VPC Endpoint to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_vpc_endpoint_service" '(
    ("service" "service - (Optional) The common name of an AWS service (e.g. s3).")
    ("service_name" "service_name - (Optional) The service name that can be specified when creating a VPC endpoint.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_vpc_peering_connection" '(
    ("id" "id - (Optional) The ID of the specific VPC Peering Connection to retrieve.")
    ("status" "status - (Optional) The status of the specific VPC Peering Connection to retrieve.")
    ("vpc_id" "vpc_id - (Optional) The ID of the requester VPC of the specific VPC Peering Connection to retrieve.")
    ("owner_id" "owner_id - (Optional) The AWS account ID of the owner of the requester VPC of the specific VPC Peering Connection to retrieve.")
    ("cidr_block" "cidr_block - (Optional) The CIDR block of the requester VPC of the specific VPC Peering Connection to retrieve.")
    ("region" "region - (Optional) The region of the requester VPC of the specific VPC Peering Connection to retrieve.")
    ("peer_vpc_id" "peer_vpc_id - (Optional) The ID of the accepter VPC of the specific VPC Peering Connection to retrieve.")
    ("peer_owner_id" "peer_owner_id - (Optional) The AWS account ID of the owner of the accepter VPC of the specific VPC Peering Connection to retrieve.")
    ("peer_cidr_block" "peer_cidr_block - (Optional) The CIDR block of the accepter VPC of the specific VPC Peering Connection to retrieve.")
    ("peer_region" "peer_region - (Optional) The region of the accepter VPC of the specific VPC Peering Connection to retrieve.")
    ("filter" "filter - (Optional) Custom filter block as described below.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired VPC Peering Connection.")

  ) company-terraform-data-arguments-hash)

(puthash "aws_vpn_gateway" '(
    ("id" "id - (Optional) The ID of the specific VPN Gateway to retrieve.")
    ("state" "state - (Optional) The state of the specific VPN Gateway to retrieve.")
    ("availability_zone" "availability_zone - (Optional) The Availability Zone of the specific VPN Gateway to retrieve.")
    ("attached_vpc_id" "attached_vpc_id - (Optional) The ID of a VPC attached to the specific VPN Gateway to retrieve.")
    ("filter" "filter - (Optional) Custom filter block as described below.")
    ("tags" "tags - (Optional) A mapping of tags, each pair of which must exactly match a pair on the desired VPN Gateway.")
    ("amazon_side_asn" "amazon_side_asn - (Optional) The Autonomous System Number (ASN) for the Amazon side of the specific VPN Gateway to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_application_security_group" '(
    ("name" "name - The name of the Application Security Group.")
    ("resource_group_name" "resource_group_name - The name of the resource group in which the Application Security Group exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_app_service" '(
    ("name" "name - (Required) The name of the App Service.")
    ("resource_group_name" "resource_group_name - (Required) The Name of the Resource Group where the App Service exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_app_service_plan" '(
    ("name" "name - (Required) The name of the App Service Plan.")
    ("resource_group_name" "resource_group_name - (Required) The Name of the Resource Group where the App Service Plan exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_builtin_role_definition" '(
    ("name" "name - (Required) Specifies the name of the built-in Role Definition. Possible values are: Contributor, Owner, Reader and VirtualMachineContributor.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_cdn_profile" '(
    ("name" "name - (Required) The name of the CDN Profile.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the CDN Profile exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_client_config" '(

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_cosmosdb_account" '(
    ("name" "name - (Required) Specifies the name of the CosmosDB Account.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group in which the CosmosDB Account resides.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_dns_zone" '(
    ("name" "name - (Required) The name of the DNS Zone.")
    ("resource_group_name" "resource_group_name - (Required) The Name of the Resource Group where the DNS Zone exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_eventhub_namespace" '(
    ("name" "name - (Required) The name of the EventHub Namespace.")
    ("resource_group_name" "resource_group_name - (Required) The Name of the Resource Group where the EventHub Namespace exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_image" '(
    ("name" "name - (Optional) The name of the Image.")
    ("name_regex" "name_regex - (Optional) Regex pattern of the image to match.")
    ("sort_descending" "sort_descending - (Optional) By default when matching by regex, images are sorted by name in ascending order and the first match is chosen, to sort descending, set this flag.")
    ("resource_group_name" "resource_group_name - (Required) The Name of the Resource Group where this Image exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_key_vault" '(
    ("name" "name - (Required) Specifies the name of the Key Vault.")
    ("resource_group_name" "resource_group_name - (Required) The name of the Resource Group in which the Key Vault exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_key_vault_access_policy" '(
    ("name" "name - (Required) Specifies the name of the Management Tempalte. Possible values are: Key Management, Secret Management, Certificate Management, Key & Secret Management, Key & Certificate Management, Secret & Certificate Management,  Key, Secret, & Certificate Management")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_key_vault_secret" '(
    ("name" "name - (Required) Specifies the name of the Key Vault Secret.")
    ("vault_uri" "vault_uri - (Required) Specifies the URI used to access the Key Vault instance, available on the azurerm_key_vault Data Source / Resource.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_kubernetes_cluster" '(
    ("name" "name - (Required) The name of the managed Kubernetes Cluster.")
    ("resource_group_name" "resource_group_name - (Required) The name of the Resource Group in which the managed Kubernetes Cluster exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_managed_disk" '(
    ("name" "name - (Required) Specifies the name of the Managed Disk.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_network_interface" '(
    ("name" "name - (Required) Specifies the name of the Network Interface.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group the Network Interface is located in.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_network_security_group" '(
    ("name" "name - (Required) Specifies the Name of the Network Security Group.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the Name of the Resource Group within which the Network Security Group exists")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_platform_image" '(
    ("location" "location - (Required) Specifies the Location to pull information about this Platform Image from.")
    ("publisher" "publisher - (Required) Specifies the Publisher associated with the Platform Image.")
    ("offer" "offer - (Required) Specifies the Offer associated with the Platform Image.")
    ("sku" "sku - (Required) Specifies the SKU of the Platform Image.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_public_ip" '(
    ("name" "name - (Required) Specifies the name of the public IP address.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_public_ips" '(
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group.")
    ("attached" "attached - (Optional) Filter to include IP Addresses which are attached to a device, such as a VM/LB (true) or unattached (false).")
    ("name_prefix" "name_prefix - (Optional) A prefix match used for the IP Addresses name field, case sensitive.")
    ("allocation_type" "allocation_type - (Optional) The Allocation Type for the Public IP Address. Possible values include Static or Dynamic.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_recovery_services_vault" '(
    ("name" "name - (Required) Specifies the name of the Recovery Services Vault.")
    ("resource_group_name" "resource_group_name - (Required) The name of the resource group in which the Recovery Services Vault resides.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_resource_group" '(
    ("name" "name - (Required) Specifies the name of the resource group.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_role_definition" '(
    ("role_definition_id" "role_definition_id - (Required) Specifies the ID of the Role Definition as a UUID/GUID.")
    ("scope" "scope - (Required) Specifies the Scope at which the Custom Role Definition exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_route_table" '(
    ("name" "name - (Required) The name of the Route Table.")
    ("resource_group_name" "resource_group_name - (Required) The name of the Resource Group in which the Route Table exists.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_scheduler_job_collection" '(
    ("name" "name - (Required) Specifies the name of the Scheduler Job Collection.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group in which the Scheduler Job Collection resides.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_storage_account" '(
    ("name" "name - (Required) Specifies the name of the Storage Account")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group the Storage Account is located in.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_subnet" '(
    ("name" "name - (Required) Specifies the name of the Subnet.")
    ("virtual_network_name" "virtual_network_name - (Required) Specifies the name of the Virtual Network this Subnet is located within.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group the Virtual Network is located in.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_subscription" '(
    ("subscription_id" "subscription_id - (Optional) Specifies the ID of the subscription. If this argument is omitted, the subscription ID of the current Azure Resource Manager provider is used.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_subscriptions" '(

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_traffic_manager_geographical_location" '(
    ("name" "name - (Required) Specifies the name of the Location, for example World, Europe or Germany.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_virtual_network" '(
    ("name" "name - (Required) Specifies the name of the Virtual Network.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group the Virtual Network is located in.")

  ) company-terraform-data-arguments-hash)

(puthash "azurerm_virtual_network_gateway" '(
    ("name" "name - (Required) Specifies the name of the Virtual Network Gateway.")
    ("resource_group_name" "resource_group_name - (Required) Specifies the name of the resource group the Virtual Network Gateway is located in.")

  ) company-terraform-data-arguments-hash)

(puthash "circonus_account" '(
    ("id" "id - (Optional) The Circonus ID of a given account.")
    ("current" "current - (Optional) Automatically use the current Circonus Account attached to the API token making the request.")

  ) company-terraform-data-arguments-hash)

(puthash "circonus_collector" '(
    ("id" "id - (Optional) The Circonus ID of a given collector.")

  ) company-terraform-data-arguments-hash)

(puthash "cloudflare_ip_ranges" '(

  ) company-terraform-data-arguments-hash)

(puthash "cloudstack_template" '(

  ) company-terraform-data-arguments-hash)

(puthash "consul_agent_self" '(

  ) company-terraform-data-arguments-hash)

(puthash "consul_catalog_nodes" '(
    ("datacenter" "datacenter - (Optional) The Consul datacenter to query.  Defaults to the same value found in query_options parameter specified below, or if that is empty, the datacenter value found in the Consul agent that this provider is configured to talk to.")
    ("query_options" "query_options - (Optional) See below.")

  ) company-terraform-data-arguments-hash)

(puthash "consul_catalog_service" '(
    ("datacenter" "datacenter - (Optional) The Consul datacenter to query.  Defaults to the same value found in query_options parameter specified below, or if that is empty, the datacenter value found in the Consul agent that this provider is configured to talk to.")
    ("name" "name - (Required) The service name to select.")
    ("query_options" "query_options - (Optional) See below.")
    ("tag" "tag - (Optional) A single tag that can be used to filter the list of nodes to return based on a single matching tag..")

  ) company-terraform-data-arguments-hash)

(puthash "consul_catalog_services" '(
    ("datacenter" "datacenter - (Optional) The Consul datacenter to query.  Defaults to the same value found in query_options parameter specified below, or if that is empty, the datacenter value found in the Consul agent that this provider is configured to talk to.")
    ("query_options" "query_options - (Optional) See below.")

  ) company-terraform-data-arguments-hash)

(puthash "consul_keys" '(
    ("datacenter" "datacenter - (Optional) The datacenter to use. This overrides the datacenter in the provider setup and the agent's default datacenter.")
    ("token" "token - (Optional) The ACL token to use. This overrides the token that the agent provides by default.")
    ("key" "key - (Required) Specifies a key in Consul to be read or written. Supported values documented below.")

  ) company-terraform-data-arguments-hash)

(puthash "digitalocean_image" '(
    ("name" "name - The name of the image.")

  ) company-terraform-data-arguments-hash)

(puthash "dns_a_record_set" '(
    ("host" "host - (required): Host to look up")

  ) company-terraform-data-arguments-hash)

(puthash "dns_aaaa_record_set" '(
    ("host" "host - (required): Host to look up")

  ) company-terraform-data-arguments-hash)

(puthash "dns_cname_record_set" '(
    ("host" "host - (required): Host to look up")

  ) company-terraform-data-arguments-hash)

(puthash "dns_txt_record_set" '(
    ("host" "host - (required): Host to look up")

  ) company-terraform-data-arguments-hash)

(puthash "docker_registry_image" '(
    ("name" "name - (Required, string) The name of the Docker image, including any tags. e.g. alpine:latest")

  ) company-terraform-data-arguments-hash)

(puthash "Data Source" '(
    ("program" "program - (Required) A list of strings, whose first element is the program to run and whose subsequent elements are optional command line arguments to the program. Terraform does not execute the program through a shell, so it is not necessary to escape shell metacharacters nor add quotes around arguments containing spaces.")
    ("query" "query - (Optional) A map of string values to pass to the external program as the query arguments. If not supplied, the program will receive an empty object as its input.")

  ) company-terraform-data-arguments-hash)

(puthash "fastly_ip_ranges" '(

  ) company-terraform-data-arguments-hash)

(puthash "github_ip_ranges" '(

  ) company-terraform-data-arguments-hash)

(puthash "github_user" '(
    ("username" "username - (Required) The username.")

  ) company-terraform-data-arguments-hash)

(puthash "github_team" '(
    ("slug" "slug - (Required) The team slug.")

  ) company-terraform-data-arguments-hash)

(puthash "google_billing_account" '(
    ("billing_account" "billing_account (Optional) - The name of the billing account in the form {billing_account_id} or billingAccounts/{billing_account_id}.")
    ("display_name" "display_name (Optional) - The display name of the billing account.")
    ("open" "open (Optional) - true if the billing account is open, false if the billing account is closed.")

  ) company-terraform-data-arguments-hash)

(puthash "google_client_config" '(

  ) company-terraform-data-arguments-hash)

(puthash "google_cloudfunctions_function" '(
    ("name" "name - (Required) The name of a Cloud Function.")

  ) company-terraform-data-arguments-hash)

(puthash "google_compute_address" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE.")

  ) company-terraform-data-arguments-hash)

(puthash "google_compute_default_service_account" '(
    ("project" "project - (Optional) The project ID. If it is not provided, the provider project is used.")

  ) company-terraform-data-arguments-hash)

(puthash "google_compute_image" '(
    ("name" "name or family - (Required) The name of a specific image or a family. Exactly one of name of family must be specified. If name is specified, it will fetch the corresponding image. If family is specified, it will returns the latest image that is part of an image family and is not deprecated.")

  ) company-terraform-data-arguments-hash)

(puthash "google_compute_forwarding_rule" '(
    ("name" "name - (Required) The name of the forwarding rule.")

  ) company-terraform-data-arguments-hash)

(puthash "google_compute_global_address" '(
    ("name" "name - (Required) A unique name for the resource, required by GCE.")

  ) company-terraform-data-arguments-hash)

(puthash "google_compute_network" '(
    ("name" "name - (Required) The name of the network.")

  ) company-terraform-data-arguments-hash)

(puthash "Data Source" '(
    ("url" "url - (Required) The URL to request data from. This URL must respond with a 200 OK response and a text/* or application/json Content-Type.")
    ("request_headers" "request_headers - (Optional) A map of strings representing additional HTTP headers to include in the request.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_config" '(
    ("disks" "disks - (Optional) The list of disks to be configured and their options.")
    ("arrays" "arrays - (Optional) The list of RAID arrays to be configured.")
    ("filesystems" "filesystems - (Optional) The list of filesystems to be configured and/or used in the ignition_file resource.")
    ("files" "files - (Optional) The list of files, rooted in this particular filesystem, to be written.")
    ("systemd" "systemd - (Optional) The list of systemd units. Describes the desired state of the systemd units.")
    ("networkd" "networkd - (Optional) The list of networkd units. Describes the desired state of the networkd files.")
    ("users" "users - (Optional) The list of accounts to be added.")
    ("groups" "groups - (Optional) The list of groups to be added.")
    ("append" "append - (Optional) Any number of blocks with the configs to be appended to the current config.")
    ("replace" "replace - (Optional) A block with config that will replace the current.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_disk" '(
    ("device" "device - (Required) The absolute path to the device. Devices are typically referenced by the /dev/disk/by-* symlinks.")
    ("wipe_table" "wipe_table - (Optional) Whether or not the partition tables shall be wiped. When true, the partition tables are erased before any further manipulation. Otherwise, the existing entries are left intact.")
    ("partition" "partition - (Optional) The list of partitions and their configuration for this particular disk..")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_raid" '(
    ("name" "name - (Required) The name to use for the resulting md device.")
    ("level" "level - (Required) The redundancy level of the array (e.g. linear, raid1, raid5, etc.).")
    ("devices" "devices - (Required) The list of devices (referenced by their absolute path) in the array.")
    ("spares" "spares - (Optional) The number of spares (if applicable) in the array.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_filesystem" '(
    ("name" "name - (Optional) The identifier for the filesystem, internal to Ignition. This is only required if the filesystem needs to be referenced in the a ignition_files resource.")
    ("mount" "mount - (Optional) Contains the set of mount and formatting options for the filesystem. A non-null entry indicates that the filesystem should be mounted before it is used by Ignition.")
    ("path" "path - (Optional) The mount-point of the filesystem. A non-null entry indicates that the filesystem has already been mounted by the system at the specified path. This is really only useful for /sysroot.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_file" '(
    ("filesystem" "filesystem - (Optional) The internal identifier of the filesystem. This matches the last filesystem with the given identifier. This should be a valid name from a ignition_filesystem resource.")
    ("path" "path - (Optional) The absolute path to the file.")
    ("content" "content - (Optional) Block to provide the file content inline.")
    ("source" "source - (Optional) Block to retrieve the file content from a remote location. Note: content and source are mutually exclusive")
    ("mode" "mode - (Optional) The list of partitions and their configuration for this particular disk..")
    ("uid" "uid - (Optional) The user ID of the owner.")
    ("gid" "gid - (Optional) The group ID of the owner.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_link" '(
    ("filesystem" "filesystem - (Required) The internal identifier of the filesystem. This matches the last filesystem with the given identifier. This should be a valid name from a ignition_filesystem resource.")
    ("path" "path - (Required) The absolute path to the link.")
    ("target" "target - (Required) The target path of the link.")
    ("hard" "hard - (Optional) A symbolic link is created if this is false, a hard one if this is true.")
    ("uid" "uid - (Optional) The user ID of the owner.")
    ("gid" "gid - (Optional) The group ID of the owner.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_directory" '(
    ("filesystem" "filesystem - (Required) The internal identifier of the filesystem. This matches the last filesystem with the given identifier. This should be a valid name from a ignition_filesystem resource.")
    ("path" "path - (Required) The absolute path to the directory.")
    ("mode" "mode - (Optional) The list of partitions and their configuration for this particular disk..")
    ("uid" "uid - (Optional) The user ID of the owner.")
    ("gid" "gid - (Optional) The group ID of the owner.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_systemd_unit" '(
    ("name" "name - (Required) Tthe name of the unit. This must be suffixed with a valid unit type (e.g. thing.service).")
    ("enabled" "enabled - (Optional) Whether or not the service shall be enabled. When true, the service is enabled. In order for this to have any effect, the unit must have an install section. (default true)")
    ("mask" "mask - (Optional) Whether or not the service shall be masked. When true, the service is masked by symlinking it to /dev/null.")
    ("content" "content - (Optional) The contents of the unit.")
    ("dropin" "dropin - (Optional) The list of drop-ins for the unit.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_networkd_unit" '(
    ("name" "name - (Required) The name of the file. This must be suffixed with a valid unit type (e.g. 00-eth0.network).")
    ("content" "content - (Required) The contents of the networkd file.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_user" '(
    ("name" "name - (Required) The username for the account.")
    ("password_hash" "password_hash - (Optional) The encrypted password for the account.")
    ("ssh_authorized_keys" "ssh_authorized_keys - (Optional) A list of SSH keys to be added to the user’s authorized_keys.")
    ("uid" "uid - (Optional) The user ID of the new account.")
    ("gecos" "gecos - (Optional) The GECOS field of the new account.")
    ("home_dir" "home_dir - (Optional) The home directory of the new account.")
    ("no_create_home" "no_create_home - (Optional) Whether or not to create the user’s home directory.")
    ("primary_group" "primary_group - (Optional) The name or ID of the primary group of the new account.")
    ("groups" "groups - (Optional) The list of supplementary groups of the new account.")
    ("no_user_group" "no_user_group - (Optional) Whether or not to create a group with the same name as the user.")
    ("no_log_init" "no_log_init - (Optional) Whether or not to add the user to the lastlog and faillog databases.")
    ("shell" "shell - (Optional) The login shell of the new account.")
    ("system" "system - (Optional) Whether or not to make the account a system account. This only has an effect if the account doesn't exist yet.")

  ) company-terraform-data-arguments-hash)

(puthash "ignition_group" '(
    ("name" "name - (Required) The groupname for the account.")
    ("password_hash" "password_hash - (Optional) The encrypted password for the account.")
    ("gid" "gid - (Optional) The group ID of the new account.")

  ) company-terraform-data-arguments-hash)

(puthash "kubernetes_service" '(
    ("metadata" "metadata - (Required) Standard service's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")

  ) company-terraform-data-arguments-hash)

(puthash "kubernetes_storage_class" '(
    ("metadata" "metadata - (Required) Standard storage class's metadata. More info: https://github.com/kubernetes/community/blob/master/contributors/devel/api-conventions.md#metadata")

  ) company-terraform-data-arguments-hash)

(puthash "file" '(
    ("filename" "filename - (Required) The path to the file that will be read. The data source will return an error if the file does not exist.")

  ) company-terraform-data-arguments-hash)

(puthash "logentries_logset" '(

  ) company-terraform-data-arguments-hash)

(puthash "logicmonitor_collectors" '(
    ("size" "size - (Optional) The number of results to display. Max is 1000. Default is 50")
    ("offset" "offset - (Optional) The number of results to offset the displayed results by. Default is 0")
    ("most_recent" "most_recent - (Optional) The most recent collector installed that is online")
    ("filters" "filters - (Optional) Filters the response according to the operator and value specified. Note that you can use * to match on more than one character. More Info: https://www.logicmonitor.com/support/rest-api-developers-guide/device-groups/get-device-groups/")

  ) company-terraform-data-arguments-hash)

(puthash "logicmonitor_device_group" '(
    ("size" "size - (Optional) The number of results to display. Max is 1000. Default is 50")
    ("offset" "offset - (Optional) The number of results to offset the displayed results by. Default is 0")
    ("filters" "filters - (Optional) Filters the response according to the operator and value specified. Note that you can use * to match on more than one character. More Info: https://www.logicmonitor.com/support/rest-api-developers-guide/device-groups/get-device-groups/")

  ) company-terraform-data-arguments-hash)

(puthash "newrelic_application" '(
    ("name" "name - (Required) The name of the application in New Relic.")

  ) company-terraform-data-arguments-hash)

(puthash "key_transaction" '(
    ("name" "name - (Required) The name of the application in New Relic.")

  ) company-terraform-data-arguments-hash)

(puthash "nomad_regions" '(

  ) company-terraform-data-arguments-hash)

(puthash "openstack_compute_flavor_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. If omitted, the region argument of the provider is used.")
    ("name" "name - (Optional) The name of the flavor.")
    ("min_ram" "min_ram - (Optional) The minimum amount of RAM (in megabytes).")
    ("ram" "ram - (Optional) The exact amount of RAM (in megabytes).")
    ("min_disk" "min_disk - (Optional) The minimum amount of disk (in gigabytes).")
    ("disk" "disk - (Optional) The exact amount of disk (in gigabytes).")
    ("vcpus" "vcpus - (Optional) The amount of VCPUs.")
    ("swap" "swap - (Optional) The amount of swap (in gigabytes).")
    ("rx_tx_factor" "rx_tx_factor - (Optional) The rx_tx_factor of the flavor.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_compute_keypair_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Compute client. If omitted, the region argument of the provider is used.")
    ("name" "name - (Required) The unique name of the keypair.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_dns_zone_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 DNS client. A DNS client is needed to retrieve zone ids. If omitted, the region argument of the provider is used.")
    ("name" "name - (Optional) The name of the zone.")
    ("description" "description - (Optional) A description of the zone.")
    ("email" "email - (Optional) The email contact for the zone record.")
    ("status" "status - (Optional) The zone's status.")
    ("ttl" "ttl - (Optional) The time to live (TTL) of the zone.")
    ("type" "type - (Optional) The type of the zone. Can either be PRIMARY or SECONDARY.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_identity_project_v3" '(
    ("domain_id" "domain_id - (Optional) The domain this project belongs to.")
    ("enabled" "enabled - (Optional) Whether the project is enabled or disabled. Valid values are true and false.")
    ("is_domain" "is_domain - (Optional) Whether this project is a domain. Valid values are true and false.")
    ("name" "name - (Optional) The name of the project.")
    ("parent_id" "parent_id - (Optional) The parent of this project.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_identity_role_v3" '(
    ("name" "name - The name of the role.")
    ("domain_id" "domain_id - (Optional) The domain the role belongs to.")
    ("region" "region - (Optional) The region in which to obtain the V3 Keystone client. If omitted, the region argument of the provider is used.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_identity_user_v3" '(
    ("description" "description - (Optional) A description of the user.")
    ("default_project_id" "default_project_id - (Optional) The default project this user belongs to.")
    ("domain_id" "domain_id - (Optional) The domain this user belongs to.")
    ("enabled" "enabled - (Optional) Whether the user is enabled or disabled. Valid values are true and false.")
    ("idp_id" "idp_id - (Optional) The identity provider ID of the user.")
    ("name" "name - (Optional) The name of the user.")
    ("password_expires_at" "password_expires_at - (Optional) Query for expired passwords. See the OpenStack API docs for more information on the query format.")
    ("protocol_id" "protocol_id - (Optional) The protocol ID of the user.")
    ("unique_id" "unique_id - (Optional) The unique ID of the user.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_identity_auth_scope_v3" '(
    ("name" "name - (Required) The name of the scope. This is an arbitrary name which is only used as a unique identifier so an actual token isn't used as the ID.")
    ("region" "region - (Optional) The region in which to obtain the V3 Identity client. A Identity client is needed to retrieve tokens IDs. If omitted, the region argument of the provider is used.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_images_image_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Glance client. A Glance client is needed to create an Image that can be used with a compute instance. If omitted, the region argument of the provider is used.")
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent image.")
    ("name" "name - (Optional) The name of the image.")
    ("owner" "owner - (Optional) The owner (UUID) of the image.")
    ("properties" "properties - (Optional) a map of key/value pairs to match an image with. All specified properties must be matched.")
    ("size_min" "size_min - (Optional) The minimum size (in bytes) of the image to return.")
    ("size_max" "size_max - (Optional) The maximum size (in bytes) of the image to return.")
    ("sort_direction" "sort_direction - (Optional) Order the results in either asc or desc.")
    ("sort_key" "sort_key - (Optional) Sort images based on a certain key. Defaults to name.")
    ("tag" "tag - (Optional) Search for images with a specific tag.")
    ("visibility" "visibility - (Optional) The visibility of the image. Must be one of \"public\", \"private\", \"community\", or \"shared\". Defaults to \"private\".")
    ("member_status" "member_status - (Optional) The status of the image. Must be one of \"accepted\", \"pending\", \"rejected\", or \"all\".")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_networking_network_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Neutron client. A Neutron client is needed to retrieve networks ids. If omitted, the region argument of the provider is used.")
    ("network_id" "network_id - (Optional) The ID of the network.")
    ("name" "name - (Optional) The name of the network.")
    ("status" "status - (Optional) The status of the network.")
    ("matching_subnet_cidr" "matching_subnet_cidr - (Optional) The CIDR of a subnet within the network.")
    ("tenant_id" "tenant_id - (Optional) The owner of the network.")
    ("availability_zone_hints" "availability_zone_hints - (Optional) The availability zone candidates for the network.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_networking_secgroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Neutron client. A Neutron client is needed to retrieve security groups ids. If omitted, the region argument of the provider is used.")
    ("secgroup_id" "secgroup_id - (Optional) The ID of the security group.")
    ("name" "name - (Optional) The name of the security group.")
    ("tenant_id" "tenant_id - (Optional) The owner of the security group.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_networking_subnet_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Neutron client. A Neutron client is needed to retrieve subnet ids. If omitted, the region argument of the provider is used.")
    ("name" "name - (Optional) The name of the subnet.")
    ("dhcp_enabled" "dhcp_enabled - (Optional) If the subnet has DHCP enabled.")
    ("dhcp_disabled" "dhcp_disabled - (Optional) If the subnet has DHCP disabled.")
    ("ip_version" "ip_version - (Optional) The IP version of the subnet (either 4 or 6).")
    ("ipv6_address_mode" "ipv6_address_mode - (Optional) The IPv6 address mode. Valid values are dhcpv6-stateful, dhcpv6-stateless, or slaac.")
    ("ipv6_ra_mode" "ipv6_ra_mode - (Optional) The IPv6 Router Advertisement mode. Valid values are dhcpv6-stateful, dhcpv6-stateless, or slaac.")
    ("gateway_ip" "gateway_ip - (Optional) The IP of the subnet's gateway.")
    ("cidr" "cidr - (Optional) The CIDR of the subnet.")
    ("subnet_id" "subnet_id - (Optional) The ID of the subnet.")
    ("subnetpool_id" "subnetpool_id - (Optional) The ID of the subnetpool associated with the subnet.")
    ("network_id" "network_id - (Optional) The ID of the network the subnet belongs to.")
    ("tenant_id" "tenant_id - (Optional) The owner of the subnet.")

  ) company-terraform-data-arguments-hash)

(puthash "openstack_networking_subnetpool_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Networking client. A Networking client is needed to retrieve a subnetpool id. If omitted, the region argument of the provider is used.")
    ("name" "name - (Optional) The name of the subnetpool.")
    ("default_quota" "default_quota - (Optional) The per-project quota on the prefix space that can be allocated from the subnetpool for project subnets.")
    ("project_id" "project_id - (Optional) The owner of the subnetpool.")
    ("prefixes" "prefixes - (Optional) A list of subnet prefixes that are assigned to the subnetpool.")
    ("default_prefixlen" "default_prefixlen - (Optional) The size of the subnetpool default prefix length.")
    ("min_prefixlen" "min_prefixlen - (Optional) The size of the subnetpool min prefix length.")
    ("max_prefixlen" "max_prefixlen - (Optional) The size of the subnetpool max prefix length.")
    ("address_scope_id" "address_scope_id - (Optional) The Neutron address scope that subnetpools is assigned to.")
    ("ip_version" "ip_version - The IP protocol version.")
    ("shared" "shared - (Optional) Whether this subnetpool is shared across all projects.")
    ("description" "description - (Optional) The human-readable description for the subnetpool.")
    ("is_default" "is_default - (Optional) Whether the subnetpool is default subnetpool or not.")

  ) company-terraform-data-arguments-hash)

(puthash "opentelekomcloud_images_image_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Glance client. A Glance client is needed to create an Image that can be used with a compute instance. If omitted, the region argument of the provider is used.")
    ("most_recent" "most_recent - (Optional) If more than one result is returned, use the most recent image.")
    ("name" "name - (Optional) The name of the image.")
    ("owner" "owner - (Optional) The owner (UUID) of the image.")
    ("size_min" "size_min - (Optional) The minimum size (in bytes) of the image to return.")
    ("size_max" "size_max - (Optional) The maximum size (in bytes) of the image to return.")
    ("sort_direction" "sort_direction - (Optional) Order the results in either asc or desc.")
    ("sort_key" "sort_key - (Optional) Sort images based on a certain key. Defaults to name.")
    ("tag" "tag - (Optional) Search for images with a specific tag.")
    ("visibility" "visibility - (Optional) The visibility of the image. Must be one of \"public\", \"private\", \"community\", or \"shared\". Defaults to \"private\".")

  ) company-terraform-data-arguments-hash)

(puthash "opentelekomcloud_networking_network_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Neutron client. A Neutron client is needed to retrieve networks ids. If omitted, the region argument of the provider is used.")
    ("network_id" "network_id - (Optional) The ID of the network.")
    ("name" "name - (Optional) The name of the network.")
    ("matching_subnet_cidr" "matching_subnet_cidr - (Optional) The CIDR of a subnet within the network.")
    ("tenant_id" "tenant_id - (Optional) The owner of the network.")

  ) company-terraform-data-arguments-hash)

(puthash "opentelekomcloud_networking_secgroup_v2" '(
    ("region" "region - (Optional) The region in which to obtain the V2 Neutron client. A Neutron client is needed to retrieve security groups ids. If omitted, the region argument of the provider is used.")
    ("secgroup_id" "secgroup_id - (Optional) The ID of the security group.")
    ("name" "name - (Optional) The name of the security group.")
    ("tenant_id" "tenant_id - (Optional) The owner of the security group.")

  ) company-terraform-data-arguments-hash)

(puthash "opsgenie_user" '(
    ("username" "username - (Required) The username (email) to use to find a user in OpsGenie.")

  ) company-terraform-data-arguments-hash)

(puthash "opc_compute_image_list_entry" '(
    ("image_list" "image_list - (Required) - The name of the image list to lookup.")
    ("version" "version - (Required) - The version (integer) of the Image List to use.")
    ("entry" "entry - (Optional) - Which machine image to use. See Entry below for more details")

  ) company-terraform-data-arguments-hash)

(puthash "opc_compute_machine_image" '(
    ("account" "account - (Required) The two part name of the compute object storage account in the format /Compute-{identity_domain}/cloud_storage")
    ("name" "name - (Required) The name of the Machine Image.")

  ) company-terraform-data-arguments-hash)

(puthash "opc_compute_network_interface" '(
    ("instance_name" "instance_name is the name of the instance.")
    ("instance_id" "instance_id is the id of the instance.")
    ("interface" "interface is the name of the attached interface. eth0, eth1, ... eth9.")

  ) company-terraform-data-arguments-hash)

(puthash "opc_compute_storage_volume_snapshot" '(
    ("name" "name is the name of the storage volume snapshot.")

  ) company-terraform-data-arguments-hash)

(puthash "opc_compute_vnic" '(
    ("name" "name is the name of the Virtual NIC.")

  ) company-terraform-data-arguments-hash)

(puthash "oraclepaas_database_service_instance" '(
    ("name" "name - (Required) The name of the Database Service Instance")

  ) company-terraform-data-arguments-hash)

(puthash "precreated_ip_block" '(
    ("project_id" "project_id - (Required) ID of the project where the searched block should be.")
    ("address_family" "address_family - (Required) 4 or 6, depending on which block you are looking for.")
    ("public" "public - (Required) Whether to look for public or private block.")
    ("facility" "facility - (Required) Facility of the searched block.")

  ) company-terraform-data-arguments-hash)

(puthash "pagerduty_escalation_policy" '(
    ("name" "name - (Required) The name to use to find an escalation policy in the PagerDuty API.")

  ) company-terraform-data-arguments-hash)

(puthash "pagerduty_extension_schema" '(
    ("name" "name - (Required) The extension name to use to find an extension vendor in the PagerDuty API.")

  ) company-terraform-data-arguments-hash)

(puthash "pagerduty_schedule" '(
    ("name" "name - (Required) The name to use to find a schedule in the PagerDuty API.")

  ) company-terraform-data-arguments-hash)

(puthash "pagerduty_user" '(
    ("email" "email - (Required) The email to use to find a user in the PagerDuty API.")

  ) company-terraform-data-arguments-hash)

(puthash "pagerduty_team" '(
    ("name" "name - (Required) The name of the team to find in the PagerDuty API.")

  ) company-terraform-data-arguments-hash)

(puthash "pagerduty_vendor" '(
    ("name" "name - (Required) The vendor name to use to find a vendor in the PagerDuty API.")

  ) company-terraform-data-arguments-hash)

(puthash "panos_system_info" '(

  ) company-terraform-data-arguments-hash)

(puthash "rancher_certificate" '(
    ("name" "name - (Required) The setting name.")
    ("environment_id" "environment_id - (Required) The ID of the environment.")

  ) company-terraform-data-arguments-hash)

(puthash "rancher_environment" '(
    ("name" "name - (Required) The setting name.")

  ) company-terraform-data-arguments-hash)

(puthash "rancher_setting" '(
    ("name" "name - (Required) The setting name.")

  ) company-terraform-data-arguments-hash)

(puthash "scaleway_bootscript" '(
    ("architecture" "architecture - (Optional) any supported Scaleway architecture, e.g. x86_64, arm")
    ("name_filter" "name_filter - (Optional) Regexp to match Bootscript name by")
    ("name" "name - (Optional) Exact name of desired Bootscript")

  ) company-terraform-data-arguments-hash)

(puthash "scaleway_image" '(
    ("architecture" "architecture - (Required) any supported Scaleway architecture, e.g. x86_64, arm")
    ("name_filter" "name_filter - (Optional) Regexp to match Image name by")
    ("name" "name - (Optional) Exact name of desired Image")

  ) company-terraform-data-arguments-hash)

(puthash "template_file" '(
    ("template" "template - (Required) The contents of the template. These can be loaded from a file on disk using the file() interpolation function.")
    ("vars" "vars - (Optional) Variables for interpolation within the template. Note that variables must all be primitives. Direct references to lists or maps will cause a validation error.")

  ) company-terraform-data-arguments-hash)

(puthash "template_cloudinit_config" '(
    ("gzip" "gzip - (Optional) Specify whether or not to gzip the rendered output. Default to true")
    ("base64_encode" "base64_encode - (Optional) Base64 encoding of the rendered output. Default to true")
    ("part" "part - (Required) One may specify this many times, this creates a fragment of the rendered cloud-init config file. The order of the parts is maintained in the configuration is maintained in the rendered template.")

  ) company-terraform-data-arguments-hash)

(puthash "terraform_remote_state" '(
    ("backend" "backend - (Required) The remote backend to use.")
    ("environment" "environment - (Optional) The Terraform environment to use.")
    ("config" "config - (Optional) The configuration of the remote backend.")
    ("defaults" "defaults - (Optional) default value for outputs in case state file is empty or it does not have the output.   Remote state config docs can be found here")

  ) company-terraform-data-arguments-hash)

(puthash "tls_public_key" '(
    ("private_key_pem" "private_key_pem - (Required) The private key to use. Currently-supported key types are \"RSA\" or \"ECDSA\".")

  ) company-terraform-data-arguments-hash)

(puthash "triton_account" '(

  ) company-terraform-data-arguments-hash)

(puthash "triton_datacenter" '(

  ) company-terraform-data-arguments-hash)

(puthash "triton_image" '(
    ("name" "name - (string) The name of the image")
    ("os" "os - (string) The underlying operating system for the image")
    ("version" "version - (string) The version for the image")
    ("public" "public - (boolean) Whether to return public as well as private images")
    ("state" "state - (string) The state of the image. By default, only active images are shown. Must be one of: active, unactivated, disabled, creating, failed or all, though the default is sufficient in almost every case.")
    ("owner" "owner - (string) The UUID of the account which owns the image")
    ("type" "type - (string) The image type. Must be one of: zone-dataset, lx-dataset, zvol, docker or other.")
    ("most_recent" "most_recent - (bool) If more than one result is returned, use the most recent Image.")

  ) company-terraform-data-arguments-hash)

(puthash "triton_network" '(
    ("name" "name - (string) Required. The name of the Network.")

  ) company-terraform-data-arguments-hash)

(puthash "triton_fabric_vlan" '(
    ("name" "name - (string) Optional. The name of the Fabric VLAN.")
    ("vlan_id" "vlan_id - (integer) Optional. The unique identifier (VLAN ID) of the Fabric VLAN.")
    ("description" "description - (string) Optional. The description of the Fabric VLAN.")

  ) company-terraform-data-arguments-hash)

(puthash "triton_fabric_network" '(
    ("name" "name - (string) Required. The name of the Fabric Network.")
    ("vlan_id" "vlan_id - (integer) Required. The unique identifier (VLAN ID) of the Fabric VLAN.")

  ) company-terraform-data-arguments-hash)

(puthash "vault_approle_auth_backend_role_id" '(
    ("role_name" "role_name - (Required) The name of the role to retrieve the Role ID for.")
    ("backend" "backend - (Optional) The unique name for the AppRole backend the role to retrieve a RoleID for resides in. Defaults to \"approle\".")

  ) company-terraform-data-arguments-hash)

(puthash "vault_aws_access_credentials" '(
    ("backend" "backend - (Required) The path to the AWS secret backend to read credentials from, with no leading or trailing /s.")
    ("role" "role - (Required) The name of the AWS secret backend role to read credentials from, with no leading or trailing /s.")
    ("type" "type - (Optional) The type of credentials to read. Defaults to \"creds\", which just returns an AWS Access Key ID and Secret Key. Can also be set to \"sts\", which will return a security token in addition to the keys.")

  ) company-terraform-data-arguments-hash)

(puthash "vault_generic_secret" '(
    ("path" "path - (Required) The full logical path from which to request data. To read data from the \"generic\" secret backend mounted in Vault by default, this should be prefixed with secret/. Reading from other backends with this data source is possible; consult each backend's documentation to see which endpoints support the GET method.")

  ) company-terraform-data-arguments-hash)

(puthash "nsxt_edge_cluster" '(
    ("id" "id - (Optional) The ID of Edge Cluster to retrieve.")
    ("display_name" "display_name - (Optional) The Display Name prefix of the Edge Cluster to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "nsxt_logical_tier0_router" '(
    ("id" "id - (Optional) The ID of Logical Tier 0 Router to retrieve.")
    ("display_name" "display_name - (Optional) The Display Name prefix of the Logical Tier 0 Router to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "nsxt_ns_serivce" '(
    ("id" "id - (Optional) The ID of NS service to retrieve")
    ("display_name" "display_name - (Optional) The Display Name of the NS service to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "nsxt_switching_profile" '(
    ("id" "id - (Optional) The ID of Switching Profile to retrieve.")
    ("display_name" "display_name - (Optional) The Display Name of the Switching Profile to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "nsxt_transport_zone" '(
    ("id" "id - (Optional) The ID of Transport Zone to retrieve.")
    ("display_name" "display_name - (Optional) The Display Name prefix of the Transport Zone to retrieve.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_compute_cluster" '(
    ("name" "name - (Required) The name or absolute path to the cluster.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the cluster is located in.  This can be omitted if the search path used in name is an absolute path.  For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_custom_attribute" '(
    ("name" "name - (Required) The name of the custom attribute.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_datacenter" '(
    ("name" "name - (Optional) The name of the datacenter. This can be a name or path. Can be omitted if there is only one datacenter in your inventory.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_datastore" '(
    ("name" "name - (Required) The name of the datastore. This can be a name or path.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the datastore is located in. This can be omitted if the search path used in name is an absolute path. For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_datastore_cluster" '(
    ("name" "name - (Required) The name or absolute path to the datastore cluster.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the datastore cluster is located in. This can be omitted if the search path used in name is an absolute path. For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_distributed_virtual_switch" '(
    ("name" "name - (Required) The name of the distributed virtual switch. This can be a name or path.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the DVS is located in. This can be omitted if the search path used in name is an absolute path. For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_host" '(
    ("datacenter_id" "datacenter_id - (Required) The managed object reference ID of a datacenter.")
    ("name" "name - (Optional) The name of the host. This can be a name or path. Can be omitted if there is only one host in your inventory.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_network" '(
    ("name" "name - (Required) The name of the network. This can be a name or path.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the network is located in. This can be omitted if the search path used in name is an absolute path. For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_resource_pool" '(
    ("name" "name - (Optional) The name of the resource pool. This can be a name or path. This is required when using vCenter.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the resource pool is located in. This can be omitted if the search path used in name is an absolute path. For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_tag" '(
    ("name" "name - (Required) The name of the tag.")
    ("category_id" "category_id - (Required) The ID of the tag category the tag is located in.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_tag_category" '(
    ("name" "name - (Required) The name of the tag category.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_virtual_machine" '(
    ("name" "name - (Required) The name of the virtual machine. This can be a name or path.")
    ("datacenter_id" "datacenter_id - (Optional) The managed object reference ID of the datacenter the virtual machine is located in. This can be omitted if the search path used in name is an absolute path. For default datacenters, use the id attribute from an empty vsphere_datacenter data source.")
    ("scsi_controller_scan_count" "scsi_controller_scan_count - (Optional) The number of SCSI controllers to scan for disk attributes and controller types on. Default: 1.")

  ) company-terraform-data-arguments-hash)

(puthash "vsphere_vmfs_disks" '(
    ("host_system_id" "host_system_id - (Required) The managed object ID of the host to look for disks on.")
    ("rescan" "rescan - (Optional) Whether or not to rescan storage adapters before searching for disks. This may lengthen the time it takes to perform the search. Default: false.")
    ("filter" "filter - (Optional) A regular expression to filter the disks against. Only disks with canonical names that match will be included.")

  ) company-terraform-data-arguments-hash)

(puthash "alicloud_regions" '(
    ("id" "id - ID of the region.")
    ("local_name" "local_name - Name of the region in the local language.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_instance_types" '(
    ("id" "id - ID of the instance type.")
    ("cpu_core_count" "cpu_core_count - Number of CPU cores.")
    ("memory_size" "memory_size - Size of memory, measured in GB.")
    ("family" "family - The instance type family.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_images" '(
    ("id" "id - ID of the image.")
    ("architecture" "architecture - Platform type of the image system:i386 | x86_64.")
    ("creation_time" "creation_time - Time of creation.")
    ("description" "description - Description of the image.")
    ("image_owner_alias" "image_owner_alias - Alias of the image owner.")
    ("os_name" "os_name - Display name of the OS.")
    ("status" "status - Status of the image, with possible values: UnAvailable, Available, Creating or CreateFailed.")
    ("size" "size - Size of the image.")
    ("disk_device_mappings" "disk_device_mappings - Description of the system with disks and snapshots under an image.   device - Device information of the created disk: such as /dev/xvdb.  size - Size of the created disk.  snapshot_id - Snapshot ID.")
    ("product_code" "product_code - Product code of the image on the image market.")
    ("is_subscribed" "is_subscribed - Whether the user has subscribed to the terms of service for the image product corresponding to the ProductCode.")
    ("image_version" "image_version - Version of the image.")
    ("progress" "progress - Progress of image creation, presented in percentages.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_zones" '(
    ("id" "id - ID of the zone.")
    ("local_name" "local_name - Name of the zone in the local language.")
    ("available_instance_types" "available_instance_types - Instance types allowed.")
    ("available_resource_creation" "available_resource_creation - Type of resource that can be created.")
    ("available_disk_categories" "available_disk_categories - Set of supported disk categories.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_key_pairs" '(
    ("id" "id - ID of the key pair.")
    ("key_name" "key_name - Name of the key pair.")
    ("finger_print" "finger_print - Finger print of the key pair.")
    ("instances" "instances - A List of ECS instances that has been bound a specified key pair.   availability_zone - The ID of availability zone that ECS instance launched.  instance_id - The ID of ECS instance.  instance_name - The name of ECS instance.  vswitch_id - The ID of VSwitch that ECS instance launched.  public_ip - The public IP address or EIP of the ECS instance.  private_ip - The private IP address of the ECS instance.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_kms_keys" '(
    ("id" "id - ID of the key.")
    ("arn" "arn - The Alicloud Resource Name (ARN) of the key.")
    ("description" "description - Description of the key.")
    ("status" "status - Status of the key, with possible values: \"Enabled\", \"Disabled\", \"PendingDeletion\".")
    ("creation_date" "creation_date - Creation date of key.")
    ("delete_date" "delete_date - Delete date of key.")
    ("creator" "creator - The createor to key belongs.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_instances" '(
    ("instances" "instances A list of instnaces. It contains several attributes to Block Instances.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_vpcs" '(
    ("id" "id - ID of the VPC.")
    ("region_id" "region_id - ID of the region where VPC belongs.")
    ("status" "status - Status of the VPC.")
    ("vpc_name" "vpc_name - Name of the VPC.")
    ("vswitch_ids" "vswitch_ids - List of VSwitch IDs in the specified VPC")
    ("cidr_block" "cidr_block - CIDR block of the VPC.")
    ("vrouter_id" "vrouter_id - ID of the VRouter")
    ("route_table_id" "route_table_id - Route table ID of the VRouter")
    ("description" "description - Description of the VPC")
    ("is_default" "is_default - Whether the VPC is the default VPC in the belonging region.")
    ("creation_time" "creation_time - Time of creation.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_vswitches" '(
    ("vswitches" "vswitches A list of vswitches. It contains several attributes to Block VSwitches.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_eips" '(
    ("eips" "eips A list of eips. It contains several attributes to Block EIPs.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_security_groups" '(
    ("id" "id - The ID of the security group.")
    ("name" "name - The name of the security group.")
    ("description" "description - The description of the security group.")
    ("vpc_id" "vpc_id - The ID of the VPC.")
    ("inner_access" "inner_access - Whether to allow inner network access.")
    ("creation_time" "creation_time - Creation time of the security group.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_security_group_rules" '(
    ("group_name" "group_name - The name of the security group which owns the rules.")
    ("group_desc" "group_desc - The description of the security group which owns the rules.")
    ("rules" "rules - A list of security group rules. Its every element contains the following attributes:   ip_protocol - The protocol. Can be tcp, udp, icmp, gre or all.  port_range - The range of port numbers.  source_cidr_ip - Source ip address segment for ingress authorization.  source_security_group_id - Source security group id for ingress authorization.  source_group_owner_account - Alibaba Cloud account of the source security group.  dest_cidr_ip - Target ip address segment for egress authorization.  dest_security_group_id - Target security group id for ingress authorization.  dest_group_owner_account - Alibaba Cloud account of the target security group.  policy - Authorization policy. Can be either accept or drop.  nic_type - Network type, internet or intranet.  priority - Rule priority.  direction - Authorization direction, ingress or egress.  description - The description of the rule.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_dns_domain_groups" '(

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_dns_domain_records" '(

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_dns_groups" '(
    ("group_id" "group_id - Id of the group .")
    ("group_name" "group_name - Name of the group .")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_dns_records" '(
    ("record_id" "record_id - ID of the record.")
    ("domain_name" "domain_name - Name of the domain which the record belong to.")
    ("host_record" "host_record - Host record of the record.")
    ("value" "value - Host record value of the record.")
    ("type" "type - Type of the record.")
    ("ttl" "ttl - TTL of the record.")
    ("priority" "priority - Priority of the MX record.")
    ("line" "line - Parsing line of the record.")
    ("status" "status - Status of the record.")
    ("locked" "locked - Indicates whether the record is locked.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_dns_domains" '(
    ("domain_id" "domain_id - ID of the domain.")
    ("domain_name" "domain_name - Name of the domain.")
    ("ali_domain" "ali_domain - Indicates whether the domain is Alicloud domain.")
    ("group_id" "group_id - Id of group which the domain in.")
    ("group_name" "group_name - Name of group which the domain in.")
    ("instance_id" "instance_id - Cloud analysis product id of the domain.")
    ("version_code" "version_code - Cloud analysis version code of the domain.")
    ("puny_code" "puny_code - Punycode of the Chinese domain.")
    ("dns_servers" "dns_servers - DNS list of the domain in the analysis system.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_ram_account_aliases" '(
    ("account_alias" "account_alias - Alias of the account.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_ram_account_alias" '(

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_ram_groups" '(
    ("name" "name - Name of the group.")
    ("comments" "comments - Comments of the group.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_ram_policies" '(
    ("name" "name - Name of the policy.")
    ("type" "type - Type of the policy.")
    ("description" "description - Description of the policy.")
    ("default_version" "default_version - Default version of the policy.")
    ("create_date" "create_date - Create date of the policy.")
    ("update_date" "update_date - Update date of the policy.")
    ("attachment_count" "attachment_count - Attachment count of the policy.")
    ("document" "document - Policy document of the policy.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_ram_roles" '(
    ("id" "id - Id of the role.")
    ("name" "name - Name of the role.")
    ("arn" "arn - Resource descriptor of the role.")
    ("description" "description - Description of the role.")
    ("assume_role_policy_document" "assume_role_policy_document - Authorization strategy of the role. This parameter is deprecated and replaced by document.")
    ("document" "document - Authorization strategy of the role.")
    ("create_date" "create_date - Create date of the role.")
    ("update_date" "update_date - Update date of the role.")

  ) company-terraform-data-attributes-hash)

(puthash "alicloud_ram_users" '(
    ("id" "id - Id of the user.")
    ("name" "name - Name of the user.")
    ("create_date" "create_date - Create date of the user.")
    ("last_login_date" "last_login_date - Last login date of the user.")

  ) company-terraform-data-attributes-hash)

(puthash "archive_file" '(
    ("output_size" "output_size - The size of the output archive file.")
    ("output_sha" "output_sha - The SHA1 checksum of output archive file.")
    ("output_base64sha256" "output_base64sha256 - The base64-encoded SHA256 checksum of output archive file.")
    ("output_md5" "output_md5 - The MD5 checksum of output archive file.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_acm_certificate" '(
    ("arn" "arn - Set to the ARN of the found certificate, suitable for referencing in other resources that support ACM certificates.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_acmpca_certificate_authority" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_alb" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_alb_listener" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_alb_target_group" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_ami" '(
    ("architecture" "architecture - The OS architecture of the AMI (ie: i386 or x86_64).")
    ("block_device_mappings" "block_device_mappings - The block device mappings of the AMI.   block_device_mappings.#.device_name - The physical name of the device.  block_device_mappings.#.ebs.delete_on_termination - true if the EBS volume will be deleted on termination.  block_device_mappings.#.ebs.encrypted - true if the EBS volume is encrypted.  block_device_mappings.#.ebs.iops - 0 if the EBS volume is not a provisioned IOPS image, otherwise the supported IOPS count.  block_device_mappings.#.ebs.snapshot_id - The ID of the snapshot.  block_device_mappings.#.ebs.volume_size - The size of the volume, in GiB.  block_device_mappings.#.ebs.volume_type - The volume type.  block_device_mappings.#.no_device - Suppresses the specified device included in the block device mapping of the AMI.  block_device_mappings.#.virtual_name - The virtual device name (for instance stores).")
    ("creation_date" "creation_date - The date and time the image was created.")
    ("description" "description - The description of the AMI that was provided during image creation.")
    ("hypervisor" "hypervisor - The hypervisor type of the image.")
    ("image_id" "image_id - The ID of the AMI. Should be the same as the resource id.")
    ("image_location" "image_location - The location of the AMI.")
    ("image_owner_alias" "image_owner_alias - The AWS account alias (for example, amazon, self) or the AWS account ID of the AMI owner.")
    ("image_type" "image_type - The type of image.")
    ("kernel_id" "kernel_id - The kernel associated with the image, if any. Only applicable for machine images.")
    ("name" "name - The name of the AMI that was provided during image creation.")
    ("owner_id" "owner_id - The AWS account ID of the image owner.")
    ("platform" "platform - The value is Windows for Windows AMIs; otherwise blank.")
    ("product_codes" "product_codes - Any product codes associated with the AMI.   product_codes.#.product_code_id - The product code.  product_codes.#.product_code_type - The type of product code.")
    ("public" "public - true if the image has public launch permissions.")
    ("ramdisk_id" "ramdisk_id - The RAM disk associated with the image, if any. Only applicable for machine images.")
    ("root_device_name" "root_device_name - The device name of the root device.")
    ("root_device_type" "root_device_type - The type of root device (ie: ebs or instance-store).")
    ("root_snapshot_id" "root_snapshot_id - The snapshot id associated with the root device, if any (only applies to ebs root devices).")
    ("sriov_net_support" "sriov_net_support - Specifies whether enhanced networking is enabled.")
    ("state" "state - The current state of the AMI. If the state is available, the image is successfully registered and can be used to launch an instance.")
    ("state_reason" "state_reason - Describes a state change. Fields are UNSET if not available.   state_reason.code - The reason code for the state change.  state_reason.message - The message for the state change.")
    ("tags" "tags - Any tags assigned to the image.   tags.#.key - The key name of the tag.  tags.#.value - The value of the tag.")
    ("virtualization_type" "virtualization_type - The type of virtualization of the AMI (ie: hvm or paravirtual).")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ami_ids" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_api_gateway_rest_api" '(
    ("id" "id - Set to the ID of the found REST API.")
    ("root_resource_id" "root_resource_id - Set to the ID of the API Gateway Resource on the found REST API where the route matches '/'.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_arn" '(
    ("partition" "partition - The partition that the resource is in.")
    ("service" "service - The service namespace that identifies the AWS product.")
    ("region" "region - The region the resource resides in. Note that the ARNs for some resources do not require a region, so this component might be omitted.")
    ("account" "account - The ID of the AWS account that owns the resource, without the hyphens.")
    ("resource" "resource - The content of this part of the ARN varies by service. It often includes an indicator of the type of resource—for example, an IAM user or Amazon RDS database —followed by a slash (/) or a colon (:), followed by the resource name itself.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_autoscaling_groups" '(
    ("names" "names - A list of the Autoscaling Groups in the current region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_availability_zone" '(
    ("name" "name - The name of the selected availability zone.")
    ("region" "region - The region where the selected availability zone resides. This is always the region selected on the provider, since this data source searches only within that region.")
    ("name_suffix" "name_suffix - The part of the AZ name that appears after the region name, uniquely identifying the AZ within its region.")
    ("state" "state - The current state of the AZ.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_availability_zones" '(
    ("names" "names - A list of the Availability Zone names available to the account.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_batch_compute_environment" '(
    ("arn" "arn - The ARN of the compute environment.")
    ("ecs_cluster_arn" "ecs_cluster_arn - The ARN of the underlying Amazon ECS cluster used by the compute environment.")
    ("service_role" "service_role - The ARN of the IAM role that allows AWS Batch to make calls to other AWS services on your behalf.")
    ("type" "type - The type of the compute environment (for example, MANAGED or UNMANAGED).")
    ("status" "status - The current status of the compute environment (for example, CREATING or VALID).")
    ("status_reason" "status_reason - A short, human-readable string to provide additional details about the current status of the compute environment.")
    ("state" "state - The state of the compute environment (for example, ENABLED or DISABLED). If the state is ENABLED, then the compute environment accepts jobs from a queue and can scale out automatically based on queues.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_batch_job_queue" '(
    ("arn" "arn - The ARN of the job queue.")
    ("status" "status - The current status of the job queue (for example, CREATING or VALID).")
    ("status_reason" "status_reason - A short, human-readable string to provide additional details about the current status of the job queue.")
    ("state" "state - Describes the ability of the queue to accept new jobs (for example, ENABLED or DISABLED).")
    ("priority" "priority - The priority of the job queue. Job queues with a higher priority are evaluated first when associated with the same compute environment.")
    ("compute_environment_order" "compute_environment_order - The compute environments that are attached to the job queue and the order in which job placement is preferred. Compute environments are selected for job placement in ascending order.   compute_environment_order.#.order - The order of the compute environment.  compute_environment_order.#.compute_environment - The ARN of the compute environment.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_billing_service_account" '(
    ("id" "id - The ID of the AWS billing service account.")
    ("arn" "arn - The ARN of the AWS billing service account.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_caller_identity" '(
    ("account_id" "account_id - The AWS Account ID number of the account that owns or contains the calling entity.")
    ("arn" "arn - The AWS ARN associated with the calling entity.")
    ("user_id" "user_id - The unique identifier of the calling entity.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_canonical_user_id" '(
    ("id" "id - The canonical user ID associated with the AWS account.")
    ("display_name" "display_name - The human-friendly name linked to the canonical user ID.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_cloudformation_stack" '(
    ("capabilities" "capabilities - A list of capabilities")
    ("description" "description - Description of the stack")
    ("disable_rollback" "disable_rollback - Whether the rollback of the stack is disabled when stack creation fails")
    ("notification_arns" "notification_arns - A list of SNS topic ARNs to publish stack related events")
    ("outputs" "outputs - A map of outputs from the stack.")
    ("parameters" "parameters - A map of parameters that specify input parameters for the stack.")
    ("tags" "tags - A map of tags associated with this stack.")
    ("template_body" "template_body - Structure containing the template body.")
    ("iam_role_arn" "iam_role_arn - The ARN of the IAM role used to create the stack.")
    ("timeout_in_minutes" "timeout_in_minutes - The amount of time that can pass before the stack status becomes CREATE_FAILED")

  ) company-terraform-data-attributes-hash)

(puthash "aws_cloudtrail_service_account" '(
    ("id" "id - The ID of the AWS CloudTrail service account in the selected region.")
    ("arn" "arn - The ARN of the AWS CloudTrail service account in the selected region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_cloudwatch_log_group" '(
    ("arn" "arn - The ARN of the Cloudwatch log group")
    ("creation_time" "creation_time - The creation time of the log group, expressed as the number of milliseconds after Jan 1, 1970 00:00:00 UTC.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_cognito_user_pools" '(
    ("ids" "ids - The list of cognito user pool ids.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_db_instance" '(
    ("address" "address - The address of the RDS instance.")
    ("allocated_storage" "allocated_storage - Specifies the allocated storage size specified in gigabytes.")
    ("auto_minor_version_upgrade" "auto_minor_version_upgrade - Indicates that minor version patches are applied automatically.")
    ("availability_zone" "availability_zone - Specifies the name of the Availability Zone the DB instance is located in.")
    ("backup_retention_period" "backup_retention_period - Specifies the number of days for which automatic DB snapshots are retained.")
    ("db_cluster_identifier" "db_cluster_identifier - If the DB instance is a member of a DB cluster, contains the name of the DB cluster that the DB instance is a member of.")
    ("db_instance_arn" "db_instance_arn - The Amazon Resource Name (ARN) for the DB instance.")
    ("db_instance_class" "db_instance_class - Contains the name of the compute and memory capacity class of the DB instance.")
    ("db_name" "db_name - Contains the name of the initial database of this instance that was provided at create time, if one was specified when the DB instance was created. This same name is returned for the life of the DB instance.")
    ("db_parameter_groups" "db_parameter_groups - Provides the list of DB parameter groups applied to this DB instance.")
    ("db_security_groups" "db_security_groups - Provides List of DB security groups associated to this DB instance.")
    ("db_subnet_group" "db_subnet_group - Specifies the name of the subnet group associated with the DB instance.")
    ("db_instance_port" "db_instance_port - Specifies the port that the DB instance listens on.")
    ("endpoint" "endpoint - The connection endpoint.")
    ("engine" "engine - Provides the name of the database engine to be used for this DB instance.")
    ("engine_version" "engine_version - Indicates the database engine version.")
    ("hosted_zone_id" "hosted_zone_id - The canonical hosted zone ID of the DB instance (to be used in a Route 53 Alias record).")
    ("iops" "iops - Specifies the Provisioned IOPS (I/O operations per second) value.")
    ("kms_key_id" "kms_key_id - If StorageEncrypted is true, the KMS key identifier for the encrypted DB instance.")
    ("license_model" "license_model - License model information for this DB instance.")
    ("master_username" "master_username - Contains the master username for the DB instance.")
    ("monitoring_interval" "monitoring_interval - The interval, in seconds, between points when Enhanced Monitoring metrics are collected for the DB instance.")
    ("monitoring_role_arn" "monitoring_role_arn - The ARN for the IAM role that permits RDS to send Enhanced Monitoring metrics to CloudWatch Logs.")
    ("multi_az" "multi_az - Specifies if the DB instance is a Multi-AZ deployment.")
    ("option_group_memberships" "option_group_memberships - Provides the list of option group memberships for this DB instance.")
    ("port" "port - The database port.")
    ("preferred_backup_window" "preferred_backup_window - Specifies the daily time range during which automated backups are created.")
    ("preferred_maintenance_window" "preferred_maintenance_window -  Specifies the weekly time range during which system maintenance can occur in UTC.")
    ("publicly_accessible" "publicly_accessible - Specifies the accessibility options for the DB instance.")
    ("storage_encrypted" "storage_encrypted - Specifies whether the DB instance is encrypted.")
    ("storage_type" "storage_type - Specifies the storage type associated with DB instance.")
    ("timezone" "timezone - The time zone of the DB instance.")
    ("vpc_security_groups" "vpc_security_groups - Provides a list of VPC security group elements that the DB instance belongs to.")
    ("replicate_source_db" "replicate_source_db - The identifier of the source DB that this is a replica of.")
    ("ca_cert_identifier" "ca_cert_identifier - Specifies the identifier of the CA certificate for the DB instance.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_db_snapshot" '(
    ("id" "id - The snapshot ID.")
    ("allocated_storage" "allocated_storage - Specifies the allocated storage size in gigabytes (GB).")
    ("availability_zone" "availability_zone - Specifies the name of the Availability Zone the DB instance was located in at the time of the DB snapshot.")
    ("db_snapshot_arn" "db_snapshot_arn - The Amazon Resource Name (ARN) for the DB snapshot.")
    ("encrypted" "encrypted - Specifies whether the DB snapshot is encrypted.")
    ("engine" "engine - Specifies the name of the database engine.")
    ("engine_version" "engine_version - Specifies the version of the database engine.")
    ("iops" "iops - Specifies the Provisioned IOPS (I/O operations per second) value of the DB instance at the time of the snapshot.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("license_model" "license_model - License model information for the restored DB instance.")
    ("option_group_name" "option_group_name - Provides the option group name for the DB snapshot.")
    ("source_db_snapshot_identifier" "source_db_snapshot_identifier - The DB snapshot Arn that the DB snapshot was copied from. It only has value in case of cross customer or cross region copy.")
    ("source_region" "source_region - The region that the DB snapshot was created in or copied from.")
    ("status" "status - Specifies the status of this DB snapshot.")
    ("storage_type" "storage_type - Specifies the storage type associated with DB snapshot.")
    ("vpc_id" "vpc_id - Specifies the storage type associated with DB snapshot.")
    ("snapshot_create_time" "snapshot_create_time - Provides the time when the snapshot was taken, in Universal Coordinated Time (UTC).")

  ) company-terraform-data-attributes-hash)

(puthash "aws_dynamodb_table" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_ebs_snapshot" '(
    ("id" "id - The snapshot ID (e.g. snap-59fcb34e).")
    ("snapshot_id" "snapshot_id - The snapshot ID (e.g. snap-59fcb34e).")
    ("description" "description - A description for the snapshot")
    ("owner_id" "owner_id - The AWS account ID of the EBS snapshot owner.")
    ("owner_alias" "owner_alias - Value from an Amazon-maintained list (amazon, aws-marketplace, microsoft) of snapshot owners.")
    ("volume_id" "volume_id - The volume ID (e.g. vol-59fcb34e).")
    ("encrypted" "encrypted - Whether the snapshot is encrypted.")
    ("volume_size" "volume_size - The size of the drive in GiBs.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("data_encryption_key_id" "data_encryption_key_id - The data encryption key identifier for the snapshot.")
    ("state" "state - The snapshot state.")
    ("tags" "tags - A mapping of tags for the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ebs_snapshot_ids" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_ebs_volume" '(
    ("id" "id - The volume ID (e.g. vol-59fcb34e).")
    ("volume_id" "volume_id - The volume ID (e.g. vol-59fcb34e).")
    ("arn" "arn - The volume ARN (e.g. arn:aws:ec2:us-east-1:0123456789012:volume/vol-59fcb34e).")
    ("availability_zone" "availability_zone - The AZ where the EBS volume exists.")
    ("encrypted" "encrypted - Whether the disk is encrypted.")
    ("iops" "iops - The amount of IOPS for the disk.")
    ("size" "size - The size of the drive in GiBs.")
    ("snapshot_id" "snapshot_id - The snapshot_id the EBS volume is based off.")
    ("volume_type" "volume_type - The type of EBS volume.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("tags" "tags - A mapping of tags for the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ecr_repository" '(
    ("arn" "arn - Full ARN of the repository.")
    ("registry_id" "registry_id - The registry ID where the repository was created.")
    ("repository_url" "repository_url - The URL of the repository (in the form aws_account_id.dkr.ecr.region.amazonaws.com/repositoryName).")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ecs_cluster" '(
    ("arn" "arn - The ARN of the ECS Cluster")
    ("status" "status - The status of the ECS Cluster")
    ("pending_tasks_count" "pending_tasks_count - The number of pending tasks for the ECS Cluster")
    ("running_tasks_count" "running_tasks_count - The number of running tasks for the ECS Cluster")
    ("registered_container_instances_count" "registered_container_instances_count - The number of registered container instances for the ECS Cluster")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ecs_container_definition" '(
    ("image" "image - The docker image in use, including the digest")
    ("image_digest" "image_digest - The digest of the docker image in use")
    ("cpu" "cpu - The CPU limit for this container definition")
    ("memory" "memory - The memory limit for this container definition")
    ("memory_reservation" "memory_reservation - The soft limit (in MiB) of memory to reserve for the container. When system memory is under contention, Docker attempts to keep the container memory to this soft limit")
    ("environment" "environment - The environment in use")
    ("disable_networking" "disable_networking - Indicator if networking is disabled")
    ("docker_labels" "docker_labels - Set docker labels")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ecs_task_definition" '(
    ("family" "family - The family of this task definition")
    ("network_mode" "network_mode - The Docker networking mode to use for the containers in this task.")
    ("revision" "revision - The revision of this task definition")
    ("status" "status - The status of this task definition")
    ("task_role_arn" "task_role_arn - The ARN of the IAM role that containers in this task can assume")

  ) company-terraform-data-attributes-hash)

(puthash "aws_efs_file_system" '(
    ("performance_mode" "performance_mode - The PerformanceMode of the file system.")
    ("tags" "tags - The list of tags assigned to the file system.")
    ("encrypted" "encrypted - Whether EFS is encrypted.")
    ("kms_key_id" "kms_key_id - The ARN for the KMS encryption key.")
    ("dns_name" "dns_name - The DNS name for the filesystem per documented convention.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_efs_mount_target" '(
    ("file_system_id" "file_system_id - ID of the file system for which the mount target is intended.")
    ("subnet_id" "subnet_id - ID of the mount target's subnet.")
    ("ip_address" "ip_address - Address at which the file system may be mounted via the mount target.")
    ("security_groups" "security_groups - List of VPC security group IDs attached to the mount target.")
    ("dns_name" "dns_name - The DNS name for the given subnet/AZ per documented convention.")
    ("network_interface_id" "network_interface_id - The ID of the network interface that Amazon EFS created when it created the mount target.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_eip" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_elastic_beanstalk_hosted_zone" '(
    ("id" "id - The ID of the hosted zone.")
    ("region" "region - The region of the hosted zone.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_elastic_beanstalk_solution_stack" '(
    ("name" "name - The name of the solution stack.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_elasticache_cluster" '(
    ("node_type" "node_type – The cluster node type.")
    ("num_cache_nodes" "num_cache_nodes – The number of cache nodes that the cache cluster has.")
    ("engine" "engine – Name of the cache engine.")
    ("engine_version" "engine_version – Version number of the cache engine.")
    ("subnet_group_name" "subnet_group_name – Name of the subnet group associated to the cache cluster.")
    ("security_group_names" "security_group_names – List of security group names associated with this cache cluster.")
    ("security_group_ids" "security_group_ids – List VPC security groups associated with the cache cluster.")
    ("parameter_group_name" "parameter_group_name – Name of the parameter group associated with this cache cluster.")
    ("replication_group_id" "replication_group_id - The replication group to which this cache cluster belongs.")
    ("maintenance_window" "maintenance_window – Specifies the weekly time range for when maintenance on the cache cluster is performed.")
    ("snapshot_window" "snapshot_window - The daily time range (in UTC) during which ElastiCache will begin taking a daily snapshot of the cache cluster.")
    ("snapshot_retention_limit" "snapshot_retention_limit - The number of days for which ElastiCache will retain automatic cache cluster snapshots before deleting them.")
    ("availability_zone" "availability_zone - The Availability Zone for the cache cluster.")
    ("notification_topic_arn" "notification_topic_arn – An Amazon Resource Name (ARN) of an SNS topic that ElastiCache notifications get sent to.")
    ("port" "port – The port number on which each of the cache nodes will accept connections.")
    ("configuration_endpoint" "configuration_endpoint - The configuration endpoint to allow host discovery.")
    ("cluster_address" "cluster_address - The DNS name of the cache cluster without the port appended.")
    ("cache_nodes" "cache_nodes - List of node objects including id, address, port and availability_zone. Referenceable e.g. as ${data.aws_elasticache_cluster.bar.cache_nodes.0.address}")
    ("tags" "tags - The tags assigned to the resource")

  ) company-terraform-data-attributes-hash)

(puthash "aws_elasticache_replication_group" '(
    ("replication_group_id" "replication_group_id - The identifier for the replication group.")
    ("replication_group_description" "replication_group_description - The description of the replication group.")
    ("auth_token_enabled" "auth_token_enabled - A flag that enables using an AuthToken (password) when issuing Redis commands.")
    ("automatic_failover_enabled" "automatic_failover_enabled - A flag whether a read-only replica will be automatically promoted to read/write primary if the existing primary fails.")
    ("node_type" "node_type – The cluster node type.")
    ("number_cache_clusters" "number_cache_clusters – The number of cache clusters that the replication group has.")
    ("snapshot_window" "snapshot_window - The daily time range (in UTC) during which ElastiCache begins taking a daily snapshot of your node group (shard).")
    ("snapshot_retention_limit" "snapshot_retention_limit - The number of days for which ElastiCache retains automatic cache cluster snapshots before deleting them.")
    ("port" "port – The port number on which the configuration endpoint will accept connections.")
    ("configuration_endpoint_address" "configuration_endpoint_address - The configuration endpoint address to allow host discovery.")
    ("primary_endpoint_address" "primary_endpoint_address - The endpoint of the primary node in this node group (shard).")

  ) company-terraform-data-attributes-hash)

(puthash "aws_elb" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_elb_hosted_zone_id" '(
    ("id" "id - The ID of the AWS ELB HostedZoneId in the selected region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_elb_service_account" '(
    ("id" "id - The ID of the AWS ELB service account in the selected region.")
    ("arn" "arn - The ARN of the AWS ELB service account in the selected region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_account_alias" '(
    ("account_alias" "account_alias - The alias associated with the AWS account.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_group" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the group.")
    ("path" "path - The path to the group.")
    ("group_id" "group_id - The stable and unique string identifying the group.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_instance_profile" '(
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the instance profile.")
    ("create_date" "create_date - The string representation of the date the instance profile was created.")
    ("path" "path - The path to the instance profile.")
    ("role_arn" "role_arn - The role arn associated with this instance profile.")
    ("role_id" "role_id - The role id associated with this instance profile.")
    ("role_name" "role_name - The role name associated with this instance profile.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_policy" '(
    ("name" "name - The name of the IAM policy.")
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the policy.")
    ("path" "path - The path to the policy.")
    ("description" "description - The description of the policy.")
    ("policy" "policy - The policy document of the policy.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_policy_document" '(
    ("json" "json - The above arguments serialized as a standard JSON policy document.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_role" '(
    ("id" "id - The friendly IAM role name to match.")
    ("arn" "arn - The Amazon Resource Name (ARN) specifying the role.")
    ("assume_role_policy" "assume_role_policy - The policy document associated with the role.")
    ("path" "path - The path to the role.")
    ("unique_id" "unique_id - The stable and unique string identifying the role.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_server_certificate" '(
    ("arn" "arn is set to the ARN of the IAM Server Certificate")
    ("path" "path is set to the path of the IAM Server Certificate")
    ("expiration_date" "expiration_date is set to the expiration date of the IAM Server Certificate")
    ("upload_date" "upload_date is the date when the server certificate was uploaded")
    ("certificate_body" "certificate_body is the public key certificate (PEM-encoded). This is useful when configuring back-end instance authentication policy for load balancer")
    ("certificate_chain" "certificate_chain is the public key certificate chain (PEM-encoded) if exists, empty otherwise")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iam_user" '(
    ("arn" "arn - The Amazon Resource Name (ARN) assigned by AWS for this user.")
    ("path" "path - Path in which this user was created.")
    ("user_id" "user_id - The unique ID assigned by AWS for this user.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_inspector_rules_packages" '(
    ("arns" "arns - A list of the AWS Inspector Rules Packages arns available in the AWS region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_instance" '(
    ("ami" "ami - The ID of the AMI used to launch the instance.")
    ("associate_public_ip_address" "associate_public_ip_address - Whether or not the Instance is associated with a public IP address or not (Boolean).")
    ("availability_zone" "availability_zone - The availability zone of the Instance.")
    ("ebs_block_device" "ebs_block_device - The EBS block device mappings of the Instance.   delete_on_termination - If the EBS volume will be deleted on termination.  device_name - The physical name of the device.  encrypted - If the EBS volume is encrypted.  iops - 0 If the EBS volume is not a provisioned IOPS image, otherwise the supported IOPS count.  snapshot_id - The ID of the snapshot.  volume_size - The size of the volume, in GiB.  volume_type - The volume type.")
    ("ebs_optimized" "ebs_optimized - Whether the Instance is EBS optimized or not (Boolean).")
    ("ephemeral_block_device" "ephemeral_block_device - The ephemeral block device mappings of the Instance.   device_name - The physical name of the device.  no_device - Whether the specified device included in the device mapping was suppressed or not (Boolean).  virtual_name - The virtual device name.")
    ("iam_instance_profile" "iam_instance_profile - The name of the instance profile associated with the Instance.")
    ("ipv6_addresses" "ipv6_addresses - The IPv6 addresses associated to the Instance, if applicable. NOTE: Unlike the IPv4 address, this doesn't change if you attach an EIP to the instance.")
    ("instance_type" "instance_type - The type of the Instance.")
    ("key_name" "key_name - The key name of the Instance.")
    ("monitoring" "monitoring - Whether detailed monitoring is enabled or disabled for the Instance (Boolean).")
    ("network_interface_id" "network_interface_id - The ID of the network interface that was created with the Instance.")
    ("password_data" "password_data - Base-64 encoded encrypted password data for the instance. Useful for getting the administrator password for instances running Microsoft Windows. This attribute is only exported if get_password_data is true. See GetPasswordData for more information.")
    ("placement_group" "placement_group - The placement group of the Instance.")
    ("private_dns" "private_dns - The private DNS name assigned to the Instance. Can only be used inside the Amazon EC2, and only available if you've enabled DNS hostnames for your VPC.")
    ("private_ip" "private_ip - The private IP address assigned to the Instance.")
    ("public_dns" "public_dns - The public DNS name assigned to the Instance. For EC2-VPC, this is only available if you've enabled DNS hostnames for your VPC.")
    ("public_ip" "public_ip - The public IP address assigned to the Instance, if applicable. NOTE: If you are using an aws_eip with your instance, you should refer to the EIP's address directly and not use public_ip, as this field will change after the EIP is attached.")
    ("root_block_device" "root_block_device - The root block device mappings of the Instance   delete_on_termination - If the root block device will be deleted on termination.  iops - 0 If the volume is not a provisioned IOPS image, otherwise the supported IOPS count.  volume_size - The size of the volume, in GiB.  volume_type - The type of the volume.")
    ("security_groups" "security_groups - The associated security groups.")
    ("source_dest_check" "source_dest_check - Whether the network interface performs source/destination checking (Boolean).")
    ("subnet_id" "subnet_id - The VPC subnet ID.")
    ("user_data" "user_data - The User Data supplied to the Instance.")
    ("tags" "tags - A mapping of tags assigned to the Instance.")
    ("tenancy" "tenancy - The tenancy of the instance: dedicated, default, host.")
    ("vpc_security_group_ids" "vpc_security_group_ids - The associated security groups in a non-default VPC.")
    ("credit_specification" "credit_specification - The credit specification of the Instance.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_instances" '(
    ("ids" "ids - IDs of instances found through the filter")
    ("private_ips" "private_ips - Private IP addresses of instances found through the filter")
    ("public_ips" "public_ips - Public IP addresses of instances found through the filter")

  ) company-terraform-data-attributes-hash)

(puthash "aws_internet_gateway" '(
    ("state" "state - The current state of the attachment between the gateway and the VPC. Present only if a VPC is attached")
    ("vpc_id" "vpc_id - The ID of an attached VPC.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_iot_endpoint" '(
    ("endpoint_address" "endpoint_address - The endpoint. The format of the endpoint is as follows: IDENTIFIER.iot.REGION.amazonaws.com.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ip_ranges" '(
    ("cidr_blocks" "cidr_blocks - The lexically ordered list of CIDR blocks.")
    ("create_date" "create_date - The publication time of the IP ranges (e.g. 2016-08-03-23-46-05).")
    ("sync_token" "sync_token - The publication time of the IP ranges, in Unix epoch time format (e.g. 1470267965).")

  ) company-terraform-data-attributes-hash)

(puthash "aws_kinesis_stream" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the Kinesis Stream (same as id).")
    ("name" "name - The name of the Kinesis Stream.")
    ("creation_timestamp" "creation_timestamp - The approximate UNIX timestamp that the stream was created.")
    ("status" "status - The current status of the stream. The stream status is one of CREATING, DELETING, ACTIVE, or UPDATING.")
    ("retention_period" "retention_period - Length of time (in hours) data records are accessible after they are added to the stream.")
    ("open_shards" "open_shards - The list of shard ids in the OPEN state. See Shard State for more.")
    ("closed_shards" "closed_shards - The list of shard ids in the CLOSED state. See Shard State for more.")
    ("shard_level_metrics" "shard_level_metrics - A list of shard-level CloudWatch metrics which are enabled for the stream. See Monitoring with CloudWatch for more.")
    ("tags" "tags - A mapping of tags to assigned to the stream.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_kms_alias" '(
    ("arn" "arn - The Amazon Resource Name(ARN) of the key alias.")
    ("target_key_id" "target_key_id - Key identifier pointed to by the alias.")
    ("target_key_arn" "target_key_arn - ARN pointed to by the alias.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_kms_key" '(
    ("id" "id: The globally unique identifier for the key")
    ("arn" "arn: The Amazon Resource Name (ARN) of the key")
    ("aws_account_id" "aws_account_id: The twelve-digit account ID of the AWS account that owns the key")
    ("creation_date" "creation_date: The date and time when the key was created")
    ("deletion_date" "deletion_date: The date and time after which AWS KMS deletes the key. This value is present only when key_state is PendingDeletion, otherwise this value is 0")
    ("description" "description: The description of the key.")
    ("enabled" "enabled: Specifies whether the key is enabled. When key_state is Enabled this value is true, otherwise it is false")
    ("expiration_model" "expiration_model: Specifies whether the Key's key material expires. This value is present only when origin is EXTERNAL, otherwise this value is empty")
    ("key_manager" "key_manager: The key's manager")
    ("key_state" "key_state: The state of the key")
    ("key_usage" "key_usage: Currently the only allowed value is ENCRYPT_DECRYPT")
    ("origin" "origin: When this value is AWS_KMS, AWS KMS created the key material. When this value is EXTERNAL, the key material was imported from your existing key management infrastructure or the CMK lacks key material")
    ("valid_to" "valid_to: The time at which the imported key material expires. This value is present only when origin is EXTERNAL and whose expiration_model is KEY_MATERIAL_EXPIRES, otherwise this value is 0")

  ) company-terraform-data-attributes-hash)

(puthash "aws_kms_ciphertext" '(
    ("ciphertext_blob" "ciphertext_blob - Base64 encoded ciphertext")

  ) company-terraform-data-attributes-hash)

(puthash "aws_kms_secret" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_lambda_invocation" '(
    ("result" "result - A result of the lambda function invocation.")
    ("result_map" "result_map - This field is set only if result is a map of primitive types.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_nat_gateway" '(
    ("allocation_id" "allocation_id - The Id of the EIP allocated to the selected Nat Gateway.")
    ("network_interface_id" "network_interface_id - The Id of the ENI allocated to the selected Nat Gateway.")
    ("private_ip" "private_ip - The private Ip address of the selected Nat Gateway.")
    ("public_ip" "public_ip - The public Ip (EIP) address of the selected Nat Gateway.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_network_interface" '(
    ("association" "association - The association information for an Elastic IP address (IPv4) associated with the network interface. See supported fields below.")
    ("availability_zone" "availability_zone - The Availability Zone.")
    ("interface_type" "interface_type - The type of interface.")
    ("ipv6_addresses" "ipv6_addresses - List of IPv6 addresses to assign to the ENI.")
    ("mac_address" "mac_address - The MAC address.")
    ("owner_id" "owner_id - The AWS account ID of the owner of the network interface.")
    ("requester_id" "requester_id - The ID of the entity that launched the instance on your behalf.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_lambda_function" '(
    ("arn" "arn - The Amazon Resource Name (ARN) identifying your Lambda Function.")
    ("dead_letter_config" "dead_letter_config - Configure the function's dead letter queue.")
    ("description" "description - Description of what your Lambda Function does.")
    ("environment" "environment - The Lambda environment's configuration settings.")
    ("handler" "handler - The function entrypoint in your code.")
    ("invoke_arn" "invoke_arn - The ARN to be used for invoking Lambda Function from API Gateway.")
    ("kms_key_arn" "kms_key_arn - The ARN for the KMS encryption key.")
    ("last_modified" "last_modified - The date this resource was last modified.")
    ("memory_size" "memory_size - Amount of memory in MB your Lambda Function can use at runtime.")
    ("qualified_arn" "qualified_arn - The Amazon Resource Name (ARN) identifying your Lambda Function Version")
    ("reserved_concurrent_executions" "reserved_concurrent_executions - The amount of reserved concurrent executions for this lambda function.")
    ("role" "role - IAM role attached to the Lambda Function.")
    ("runtime" "runtime - The runtime environment for the Lambda function..")
    ("source_code_hash" "source_code_hash - Base64-encoded representation of raw SHA-256 sum of the zip file.")
    ("source_code_size" "source_code_size - The size in bytes of the function .zip file.")
    ("timeout" "timeout - The function execution time at which Lambda should terminate the function.")
    ("tracing_config" "tracing_config - Tracing settings of the function.")
    ("version" "version - The version of the Lambda function.")
    ("vpc_config" "vpc_config - VPC configuration associated with your Lambda function.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_lb" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_lb_listener" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_lb_target_group" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_mq_broker" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_partition" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_prefix_list" '(
    ("id" "id - The ID of the selected prefix list.")
    ("name" "name - The name of the selected prefix list.")
    ("cidr_blocks" "cidr_blocks - The list of CIDR blocks for the AWS service associated with the prefix list.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_rds_cluster" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_redshift_cluster" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_redshift_service_account" '(
    ("id" "id - The ID of the AWS Redshift service account in the selected region.")
    ("arn" "arn - The ARN of the AWS Redshift service account in the selected region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_region" '(
    ("name" "name - The name of the selected region.")
    ("current" "current - true if the selected region is the one configured on the provider, or false otherwise.")
    ("endpoint" "endpoint - The EC2 endpoint for the selected region.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_route53_zone" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_route_table" '(
    ("cidr_block" "cidr_block - The CIDR block of the route.")
    ("ipv6_cidr_block" "ipv6_cidr_block - The IPv6 CIDR block of the route.")
    ("egress_only_gateway_id" "egress_only_gateway_id - The ID of the Egress Only Internet Gateway.")
    ("gateway_id" "gateway_id - The Internet Gateway ID.")
    ("nat_gateway_id" "nat_gateway_id - The NAT Gateway ID.")
    ("instance_id" "instance_id - The EC2 instance ID.")
    ("vpc_peering_connection_id" "vpc_peering_connection_id - The VPC Peering ID.")
    ("network_interface_id" "network_interface_id - The ID of the elastic network interface (eni) to use.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_s3_bucket" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_s3_bucket_object" '(
    ("body" "body - Object data (see limitations above to understand cases in which this field is actually available)")
    ("cache_control" "cache_control - Specifies caching behavior along the request/reply chain.")
    ("content_disposition" "content_disposition - Specifies presentational information for the object.")
    ("content_encoding" "content_encoding - Specifies what content encodings have been applied to the object and thus what decoding mechanisms must be applied to obtain the media-type referenced by the Content-Type header field.")
    ("content_language" "content_language - The language the content is in.")
    ("content_length" "content_length - Size of the body in bytes.")
    ("content_type" "content_type - A standard MIME type describing the format of the object data.")
    ("etag" "etag - ETag generated for the object (an MD5 sum of the object content in case it's not encrypted)")
    ("expiration" "expiration - If the object expiration is configured (see object lifecycle management), the field includes this header. It includes the expiry-date and rule-id key value pairs providing object expiration information. The value of the rule-id is URL encoded.")
    ("expires" "expires - The date and time at which the object is no longer cacheable.")
    ("last_modified" "last_modified - Last modified date of the object in RFC1123 format (e.g. Mon, 02 Jan 2006 15:04:05 MST)")
    ("metadata" "metadata - A map of metadata stored with the object in S3")
    ("server_side_encryption" "server_side_encryption - If the object is stored using server-side encryption (KMS or Amazon S3-managed encryption key), this field includes the chosen encryption and algorithm used.")
    ("sse_kms_key_id" "sse_kms_key_id - If present, specifies the ID of the Key Management Service (KMS) master encryption key that was used for the object.")
    ("storage_class" "storage_class - Storage class information of the object. Available for all objects except for Standard storage class objects.")
    ("version_id" "version_id - The latest version ID of the object returned.")
    ("website_redirect_location" "website_redirect_location - If the bucket is configured as a website, redirects requests for this object to another object in the same bucket or to an external URL. Amazon S3 stores the value of this header in the object metadata.")
    ("tags" "tags  - A mapping of tags assigned to the object.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_secretsmanager_secret" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the secret.")
    ("description" "description - A description of the secret.")
    ("kms_key_id" "kms_key_id - The Key Management Service (KMS) Customer Master Key (CMK) associated with the secret.")
    ("id" "id - The Amazon Resource Name (ARN) of the secret.")
    ("rotation_enabled" "rotation_enabled - Whether rotation is enabled or not.")
    ("rotation_lambda_arn" "rotation_lambda_arn - Rotation Lambda function Amazon Resource Name (ARN) if rotation is enabled.")
    ("rotation_rules" "rotation_rules - Rotation rules if rotation is enabled.")
    ("tags" "tags - Tags of the secret.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_secretsmanager_secret_version" '(
    ("id" "id - The unique identifier of this version of the secret.")
    ("secret_string" "secret_string - The decrypted part of the protected secret information that was originally provided as a string.")
    ("version_id" "version_id - The unique identifier of this version of the secret.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_security_group" '(
    ("description" "description - The description of the security group.")
    ("arn" "arn - The computed ARN of the security group.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_sqs_queue" '(
    ("arn" "arn - The Amazon Resource Name (ARN) of the queue.")
    ("url" "url - The URL of the queue.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_sns_topic" '(
    ("arn" "arn - Set to the ARN of the found topic, suitable for referencing in other resources that support SNS topics.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_ssm_parameter" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_subnet" '(

  ) company-terraform-data-attributes-hash)

(puthash "aws_subnet_ids" '(
    ("ids" "ids - A list of all the subnet ids found. This data source will fail if none are found.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_vpc" '(
    ("instance_tenancy" "instance_tenancy - The allowed tenancy of instances launched into the selected VPC. May be any of \"default\", \"dedicated\", or \"host\".")
    ("ipv6_association_id" "ipv6_association_id - The association ID for the IPv6 CIDR block.")
    ("ipv6_cidr_block" "ipv6_cidr_block - The IPv6 CIDR block.")
    ("enable_dns_support" "enable_dns_support - Whether or not the VPC has DNS support")
    ("enable_dns_hostnames" "enable_dns_hostnames - Whether or not the VPC has DNS hostname support")

  ) company-terraform-data-attributes-hash)

(puthash "aws_vpc_endpoint" '(
    ("vpc_endpoint_type" "vpc_endpoint_type - The VPC Endpoint type, Gateway or Interface.")
    ("policy" "policy - The policy document associated with the VPC Endpoint. Applicable for endpoints of type Gateway.")
    ("route_table_ids" "route_table_ids - One or more route tables associated with the VPC Endpoint. Applicable for endpoints of type Gateway.")
    ("prefix_list_id" "prefix_list_id - The prefix list ID of the exposed AWS service. Applicable for endpoints of type Gateway.")
    ("cidr_blocks" "cidr_blocks - The list of CIDR blocks for the exposed AWS service. Applicable for endpoints of type Gateway.")
    ("subnet_ids" "subnet_ids - One or more subnets in which the VPC Endpoint is located. Applicable for endpoints of type Interface.")
    ("network_interface_ids" "network_interface_ids - One or more network interfaces for the VPC Endpoint. Applicable for endpoints of type Interface.")
    ("security_group_ids" "security_group_ids - One or more security groups associated with the network interfaces. Applicable for endpoints of type Interface.")
    ("private_dns_enabled" "private_dns_enabled - Whether or not the VPC is associated with a private hosted zone - true or false. Applicable for endpoints of type Interface.")
    ("dns_entry" "dns_entry - The DNS entries for the VPC Endpoint. Applicable for endpoints of type Interface. DNS blocks are documented below.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_vpc_endpoint_service" '(
    ("service_type" "service_type - The service type, Gateway or Interface.")
    ("owner" "owner - The AWS account ID of the service owner or amazon.")
    ("vpc_endpoint_policy_supported" "vpc_endpoint_policy_supported - Whether or not the service supports endpoint policies - true or false.")
    ("acceptance_required" "acceptance_required - Whether or not VPC endpoint connection requests to the service must be accepted by the service owner - true or false.")
    ("availability_zones" "availability_zones - The Availability Zones in which the service is available.")
    ("private_dns_name" "private_dns_name - The private DNS name for the service.")
    ("base_endpoint_dns_names" "base_endpoint_dns_names - The DNS names for the service.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_vpc_peering_connection" '(
    ("accepter" "accepter - A configuration block that describes VPC Peering Connection options set for the accepter VPC.")
    ("requester" "requester - A configuration block that describes VPC Peering Connection options set for the requester VPC.")

  ) company-terraform-data-attributes-hash)

(puthash "aws_vpn_gateway" '(

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_application_security_group" '(
    ("id" "id - The ID of the Application Security Group.")
    ("location" "location - The supported Azure location where the Application Security Group exists.")
    ("tags" "tags - A mapping of tags assigned to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_app_service" '(
    ("id" "id - The ID of the App Service.")
    ("location" "location - The Azure location where the App Service exists.")
    ("app_service_plan_id" "app_service_plan_id - The ID of the App Service Plan within which the App Service exists.")
    ("app_settings" "app_settings - A key-value pair of App Settings for the App Service.")
    ("connection_string" "connection_string - An connection_string block as defined below.")
    ("client_affinity_enabled" "client_affinity_enabled - Does the App Service send session affinity cookies, which route client requests in the same session to the same instance?")
    ("enabled" "enabled - Is the App Service Enabled?")
    ("https_only" "https_only - Can the App Service only be accessed via HTTPS?")
    ("site_config" "site_config - A site_config object as defined below.")
    ("tags" "tags - A mapping of tags to assign to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_app_service_plan" '(
    ("id" "id - The ID of the App Service Plan.")
    ("location" "location - The Azure location where the App Service Plan exists")
    ("kind" "kind - The Operating System type of the App Service Plan")
    ("sku" "sku - A sku block as documented below.")
    ("properties" "properties - A properties block as documented below.")
    ("tags" "tags - A mapping of tags assigned to the resource.")
    ("maximum_number_of_workers" "maximum_number_of_workers - The maximum number of workers supported with the App Service Plan's sku.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_builtin_role_definition" '(
    ("id" "id - the ID of the built-in Role Definition.")
    ("description" "description - the Description of the built-in Role.")
    ("type" "type - the Type of the Role.")
    ("permissions" "permissions - a permissions block as documented below.")
    ("assignable_scopes" "assignable_scopes - One or more assignable scopes for this Role Definition, such as /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333, /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup, or /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup/providers/Microsoft.Compute/virtualMachines/myVM.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_cdn_profile" '(
    ("location" "location - The Azure Region where the resource exists.")
    ("sku" "sku - The pricing related information of current CDN profile.")
    ("tags" "tags - A mapping of tags assigned to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_client_config" '(
    ("client_id" "client_id is set to the Azure Client ID (Application Object ID).")
    ("tenant_id" "tenant_id is set to the Azure Tenant ID.")
    ("subscription_id" "subscription_id is set to the Azure Subscription ID.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_cosmosdb_account" '(
    ("id" "id - The ID of the CosmosDB Account.")
    ("location" "location - The Azure location where the resource exists.")
    ("tags" "tags - A mapping of tags assigned to the resource.")
    ("offer_type" "offer_type - The Offer Type to used by this CosmosDB Account.")
    ("kind" "kind - The Kind of the CosmosDB account.")
    ("ip_range_filter" "ip_range_filter - The current IP Filter for this CosmosDB account")
    ("enable_automatic_failover" "enable_automatic_failover - If automatic failover is enabled for this CosmosDB Account.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_dns_zone" '(
    ("id" "id - The ID of the DNS Zone.")
    ("max_number_of_record_sets" "max_number_of_record_sets - Maximum number of Records in the zone.")
    ("number_of_record_sets" "number_of_record_sets - The number of records already in the zone.")
    ("name_servers" "name_servers - A list of values that make up the NS record for the zone.")
    ("tags" "tags - A mapping of tags to assign to the EventHub Namespace.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_eventhub_namespace" '(
    ("id" "id - The ID of the EventHub Namespace.")
    ("location" "location - The Azure location where the EventHub Namespace exists")
    ("sku" "sku - Defines which tier to use.")
    ("capacity" "capacity - The Capacity / Throughput Units for a Standard SKU namespace.")
    ("auto_inflate_enabled" "auto_inflate_enabled - Is Auto Inflate enabled for the EventHub Namespace?")
    ("maximum_throughput_units" "maximum_throughput_units -  Specifies the maximum number of throughput units when Auto Inflate is Enabled.")
    ("tags" "tags - A mapping of tags to assign to the EventHub Namespace.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_image" '(
    ("name" "name - the name of the Image.")
    ("location" "location - the Azure Location where this Image exists.")
    ("os_disk" "os_disk - a os_disk block as defined below.")
    ("data_disk" "data_disk - a collection of data_disk blocks as defined below.")
    ("tags" "tags - a mapping of tags to assigned to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_key_vault" '(
    ("id" "id - The Vault ID.")
    ("vault_uri" "vault_uri - The URI of the vault for performing operations on keys and secrets.")
    ("location" "location - The Azure Region in which the Key Vault exists.")
    ("sku" "sku - A sku block as described below.")
    ("tenant_id" "tenant_id - The Azure Active Directory Tenant ID used for authenticating requests to the Key Vault.")
    ("access_policy" "access_policy - One or more access_policy blocks as defined below.")
    ("enabled_for_deployment" "enabled_for_deployment - Can Azure Virtual Machines retrieve certificates stored as secrets from the Key Vault?")
    ("enabled_for_disk_encryption" "enabled_for_disk_encryption - Can Azure Disk Encryption retrieve secrets from the Key Vault?")
    ("enabled_for_template_deployment" "enabled_for_template_deployment - Can Azure Resource Manager retrieve secrets from the Key Vault?")
    ("tags" "tags - A mapping of tags assigned to the Key Vault.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_key_vault_access_policy" '(
    ("id" "id - the ID of the Key Vault Access Policy")
    ("key_permissions" "key_permissions - the key permissions for the access policy")
    ("secret_permissions" "secret_permissions - the secret permissions for the access policy")
    ("certificate_permissions" "certificate_permissions - the certificate permissions for the access policy")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_key_vault_secret" '(
    ("id" "id - The Key Vault Secret ID.")
    ("value" "value - The value of the Key Vault Secret.")
    ("version" "version - The current version of the Key Vault Secret.")
    ("content_type" "content_type - The content type for the Key Vault Secret.")
    ("tags" "tags - Any tags assigned to this resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_kubernetes_cluster" '(
    ("id" "id - The Kubernetes Managed Cluster ID.")
    ("fqdn" "fqdn - The FQDN of the Azure Kubernetes Managed Cluster.")
    ("kube_config_raw" "kube_config_raw - Base64 encoded Kubernetes configuration.")
    ("kube_config" "kube_config - A kube_config block as defined below.")
    ("location" "location - The Azure Region in which the managed Kubernetes Cluster exists.")
    ("dns_prefix" "dns_prefix - The DNS Prefix of the managed Kubernetes cluster.")
    ("kubernetes_version" "kubernetes_version - The version of Kubernetes used on the managed Kubernetes Cluster.")
    ("linux_profile" "linux_profile - A linux_profile block as documented below.")
    ("agent_pool_profile" "agent_pool_profile - One or more agent_profile_pool blocks as documented below.")
    ("service_principal" "service_principal - A service_principal block as documented below.")
    ("tags" "tags - A mapping of tags assigned to this resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_managed_disk" '(
    ("storage_account_type" "storage_account_type - The storage account type for the managed disk.")
    ("source_uri" "source_uri - The source URI for the managed disk")
    ("source_resource_id" "source_resource_id - ID of an existing managed disk that the current resource was created from.")
    ("os_type" "os_type - The operating system for managed disk. Valid values are Linux or Windows")
    ("disk_size_gb" "disk_size_gb - The size of the managed disk in gigabytes.")
    ("tags" "tags - A mapping of tags assigned to the resource.")
    ("zones" "zones - (Optional) A collection containing the availability zone the managed disk is allocated in.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_network_interface" '(
    ("applied_dns_servers" "applied_dns_servers - List of DNS servers applied to the specified network interface.")
    ("dns_servers" "dns_servers - The list of DNS servers used by the specified network interface.")
    ("enable_accelerated_networking" "enable_accelerated_networking - Indicates if accelerated networking is set on the specified network interface.")
    ("enable_ip_forwarding" "enable_ip_forwarding - Indicate if IP forwarding is set on the specified network interface.")
    ("id" "id - The ID of the virtual network that the specified network interface is associated to.")
    ("internal_dns_name_label" "internal_dns_name_label - The internal dns name label of the specified network interface.")
    ("internal_fqdn" "internal_fqdn - The internal FQDN associated to the specified network interface.")
    ("ip_configuration" "ip_configuration - The list of IP configurations associated to the specified network interface.")
    ("location" "location - The location of the specified network interface.")
    ("network_security_group_id" "network_security_group_id - The ID of the network security group associated to the specified network interface.")
    ("mac_address" "mac_address - The MAC address used by the specified network interface.")
    ("private_ip_address" "private_ip_address - The primary private ip address associated to the specified network interface.")
    ("private_ip_addresses" "private_ip_addresses - The list of private ip addresses associates to the specified network interface.")
    ("tags" "tags - List the tags assocatied to the specified network interface.")
    ("virtual_machine_id" "virtual_machine_id - The ID of the virtual machine that the specified network interface is attached to.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_network_security_group" '(
    ("id" "id - The ID of the Network Security Group.")
    ("location" "location - The supported Azure location where the resource exists.")
    ("security_rule" "security_rule - One or more security_rule blocks as defined below.")
    ("tags" "tags - A mapping of tags assigned to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_platform_image" '(
    ("id" "id - The ID of the Platform Image.")
    ("version" "version - The latest version of the Platform Image.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_public_ip" '(
    ("domain_name_label" "domain_name_label - The label for the Domain Name.")
    ("idle_timeout_in_minutes" "idle_timeout_in_minutes - Specifies the timeout for the TCP idle connection.")
    ("fqdn" "fqdn - Fully qualified domain name of the A DNS record associated with the public IP. This is the concatenation of the domainNameLabel and the regionalized DNS zone.")
    ("ip_address" "ip_address - The IP address value that was allocated.")
    ("tags" "tags - A mapping of tags to assigned to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_public_ips" '(
    ("public_ips" "public_ips - A List of public_ips blocks as defined below filtered by the criteria above.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_recovery_services_vault" '(
    ("id" "id - The ID of the Recovery Services Vault.")
    ("location" "location - The Azure location where the resource resides.")
    ("tags" "tags - A mapping of tags assigned to the resource.")
    ("sku" "sku - The vault's current SKU.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_resource_group" '(
    ("location" "location - The location of the resource group.")
    ("tags" "tags - A mapping of tags assigned to the resource group.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_role_definition" '(
    ("id" "id - the ID of the built-in Role Definition.")
    ("description" "description - the Description of the built-in Role.")
    ("type" "type - the Type of the Role.")
    ("permissions" "permissions - a permissions block as documented below.")
    ("assignable_scopes" "assignable_scopes - One or more assignable scopes for this Role Definition, such as /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333, /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup, or /subscriptions/0b1f6471-1bf0-4dda-aec3-111122223333/resourceGroups/myGroup/providers/Microsoft.Compute/virtualMachines/myVM.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_route_table" '(
    ("id" "id - The Route Table ID.")
    ("location" "location - The Azure Region in which the Route Table exists.")
    ("route" "route - One or more route blocks as documented below.")
    ("subnets" "subnets - The collection of Subnets associated with this route table.")
    ("tags" "tags - A mapping of tags assigned to the Route Table.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_scheduler_job_collection" '(
    ("id" "id - The ID of the Scheduler Job Collection.")
    ("location" "location - The Azure location where the resource exists.")
    ("tags" "tags - A mapping of tags assigned to the resource.")
    ("sku" "sku - The Job Collection's pricing level's SKU.")
    ("state" "state - The Job Collection's state.")
    ("quota" "quota - The Job collection quotas as documented in the quota block below.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_storage_account" '(
    ("id" "id - The ID of the Storage Account.")
    ("location" "location - The Azure location where the Storage Account exists")
    ("account_kind" "account_kind - Defines the Kind of account, either BlobStorage or Storage.")
    ("account_tier" "account_tier - Defines the Tier of this storage account.")
    ("account_replication_type" "account_replication_type - Defines the type of replication used for this storage account.")
    ("access_tier" "access_tier - Defines the access tier for BlobStorage accounts.")
    ("enable_blob_encryption" "enable_blob_encryption - Are Encryption Services are enabled for Blob storage? See here for more information.")
    ("enable_file_encryption" "enable_file_encryption - Are Encryption Services are enabled for File storage? See here for more information.")
    ("enable_https_traffic_only" "enable_https_traffic_only - Is traffic only allowed via HTTPS? See here for more information.")
    ("account_encryption_source" "account_encryption_source - The Encryption Source for this Storage Account.")
    ("custom_domain" "custom_domain - A custom_domain block as documented below.")
    ("tags" "tags - A mapping of tags to assigned to the resource.")
    ("primary_location" "primary_location - The primary location of the Storage Account.")
    ("secondary_location" "secondary_location - The secondary location of the Storage Account.")
    ("primary_blob_endpoint" "primary_blob_endpoint - The endpoint URL for blob storage in the primary location.")
    ("secondary_blob_endpoint" "secondary_blob_endpoint - The endpoint URL for blob storage in the secondary location.")
    ("primary_queue_endpoint" "primary_queue_endpoint - The endpoint URL for queue storage in the primary location.")
    ("secondary_queue_endpoint" "secondary_queue_endpoint - The endpoint URL for queue storage in the secondary location.")
    ("primary_table_endpoint" "primary_table_endpoint - The endpoint URL for table storage in the primary location.")
    ("secondary_table_endpoint" "secondary_table_endpoint - The endpoint URL for table storage in the secondary location.")
    ("primary_file_endpoint" "primary_file_endpoint - The endpoint URL for file storage in the primary location.")
    ("primary_access_key" "primary_access_key - The primary access key for the Storage Account.")
    ("secondary_access_key" "secondary_access_key - The secondary access key for the Storage Account.")
    ("primary_connection_string" "primary_connection_string - The connection string associated with the primary location")
    ("secondary_connection_string" "secondary_connection_string - The connection string associated with the secondary location")
    ("primary_blob_connection_string" "primary_blob_connection_string - The connection string associated with the primary blob location")
    ("secondary_blob_connection_string" "secondary_blob_connection_string - The connection string associated with the secondary blob location")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_subnet" '(
    ("id" "id - The ID of the Subnet.")
    ("address_prefix" "address_prefix - The address prefix used for the subnet.")
    ("network_security_group_id" "network_security_group_id - The ID of the Network Security Group associated with the subnet.")
    ("route_table_id" "route_table_id - The ID of the Route Table associated with this subnet.")
    ("ip_configurations" "ip_configurations - The collection of IP Configurations with IPs within this subnet.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_subscription" '(
    ("display_name" "display_name - The subscription display name.")
    ("state" "state - The subscription state. Possible values are Enabled, Warned, PastDue, Disabled, and Deleted.")
    ("location_placement_id" "location_placement_id - The subscription location placement ID.")
    ("quota_id" "quota_id - The subscription quota ID.")
    ("spending_limit" "spending_limit - The subscription spending limit.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_subscriptions" '(
    ("subscriptions" "subscriptions - One or more subscription blocks as defined below.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_traffic_manager_geographical_location" '(
    ("id" "id - The ID of this Location, also known as the Code of this Location.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_virtual_network" '(
    ("id" "id - The ID of the virtual network.")
    ("address_spaces" "address_spaces - The list of address spaces used by the virtual network.")
    ("dns_servers" "dns_servers - The list of DNS servers used by the virtual network.")
    ("subnets" "subnets - The list of name of the subnets that are attached to this virtual network.")
    ("vnet_peerings" "vnet_peerings - A mapping of name - virtual network id of the virtual network peerings.")

  ) company-terraform-data-attributes-hash)

(puthash "azurerm_virtual_network_gateway" '(
    ("id" "id - The ID of the Virtual Network Gateway.")
    ("location" "location - The location/region where the Virtual Network Gateway is located.")
    ("type" "type - The type of the Virtual Network Gateway.")
    ("vpn_type" "vpn_type - The routing type of the Virtual Network Gateway.")
    ("enable_bgp" "enable_bgp - Will BGP (Border Gateway Protocol) will be enabled for this Virtual Network Gateway.")
    ("active_active" "active_active - (Optional) Is this an Active-Active Gateway?")
    ("default_local_network_gateway_id" "default_local_network_gateway_id -  The ID of the local network gateway through which outbound Internet traffic from the virtual network in which the gateway is created will be routed (forced tunneling). Refer to the Azure documentation on forced tunneling.")
    ("sku" "sku - Configuration of the size and capacity of the Virtual Network Gateway.")
    ("ip_configuration" "ip_configuration - One or two ip_configuration blocks documented below.")
    ("vpn_client_configuration" "vpn_client_configuration - A vpn_client_configuration block which is documented below.")
    ("tags" "tags - A mapping of tags assigned to the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "circonus_account" '(
    ("address1" "address1 - The first line of the address associated with the account.")
    ("address2" "address2 - The second line of the address associated with the account.")
    ("cc_email" "cc_email - An optionally specified email address used in the CC line of invoices.")
    ("id" "id - The Circonus ID of the selected Account.")
    ("city" "city - The city part of the address associated with the account.")
    ("contact_groups" "contact_groups - A list of IDs for each contact group in the account.")
    ("country" "country - The country of the user's address.")
    ("description" "description - Description of the account.")
    ("invites" "invites - An list of users invited to use the platform.  Each element in the list has both an email and role attribute.")
    ("name" "name - The name of the account.")
    ("owner" "owner - The Circonus ID of the user who owns this account.")
    ("state_prov" "state_prov - The state or province of the address associated with the account.")
    ("timezone" "timezone - The timezone that events will be displayed in the web interface for this account.")
    ("ui_base_url" "ui_base_url - The base URL of this account.")
    ("usage" "usage - A list of account usage limits.  Each element in the list will have a limit attribute, a limit type, and a used attribute.")
    ("users" "users - A list of users who have access to this account.  Each element in the list has both an id and a role.  The id is a Circonus ID referencing the user.")

  ) company-terraform-data-attributes-hash)

(puthash "circonus_collector" '(
    ("id" "id - The Circonus ID of the selected Collector.")
    ("details" "details - A list of details about the individual Collector instances that make up the group of collectors.  See below for a list of attributes within each collector.")
    ("latitude" "latitude - The latitude of the selected Collector.")
    ("longitude" "longitude - The longitude of the selected Collector.")
    ("name" "name - The name of the selected Collector.")
    ("tags" "tags - A list of tags assigned to the selected Collector.")
    ("type" "type - The of the selected Collector.  This value is either circonus for a Circonus-managed, public Collector, or enterprise for a private collector that is private to an account.")

  ) company-terraform-data-attributes-hash)

(puthash "cloudflare_ip_ranges" '(
    ("cidr_blocks" "cidr_blocks - The lexically ordered list of all CIDR blocks.")
    ("ipv4_cidr_blocks" "ipv4_cidr_blocks - The lexically ordered list of only the IPv4 CIDR blocks.")
    ("ipv6_cidr_blocks" "ipv6_cidr_blocks - The lexically ordered list of only the IPv6 CIDR blocks.")

  ) company-terraform-data-attributes-hash)

(puthash "cloudstack_template" '(
    ("id" "id - The template ID.")
    ("account" "account - The account name to which the template belongs.")
    ("created" "created - The date this template was created.")
    ("display_text" "display_text - The template display text.")
    ("format" "format - The format of the template.")
    ("hypervisor" "hypervisor - The hypervisor on which the templates runs.")
    ("name" "name - The template name.")
    ("size" "size - The size of the template.")
    ("tags" "tags - The tags associated with this template.")

  ) company-terraform-data-attributes-hash)

(puthash "consul_agent_self" '(
    ("acl_datacenter" "acl_datacenter")
    ("acl_default_policy" "acl_default_policy")
    ("acl_disabled_ttl" "acl_disabled_ttl")
    ("acl_down_policy" "acl_down_policy")
    ("acl_enforce_0_8_semantics" "acl_enforce_0_8_semantics")
    ("acl_ttl" "acl_ttl")
    ("addresses" "addresses")
    ("advertise_addr" "advertise_addr")
    ("advertise_addr_wan" "advertise_addr_wan")
    ("advertise_addrs" "advertise_addrs")
    ("atlas_join" "atlas_join")
    ("bind_addr" "bind_addr")
    ("bootstrap_expect" "bootstrap_expect")
    ("bootstrap_mode" "bootstrap_mode")
    ("check_deregister_interval_min" "check_deregister_interval_min")
    ("check_reap_interval" "check_reap_interval")
    ("check_update_interval" "check_update_interval")
    ("client_addr" "client_addr")
    ("dns" "dns - A map of DNS configuration attributes.  See below for details on the contents of the dns attribute.")
    ("dns_recursors" "dns_recursors - A list of all DNS recursors.")
    ("data_dir" "data_dir")
    ("datacenter" "datacenter")
    ("dev_mode" "dev_mode")
    ("domain" "domain")
    ("enable_anonymous_signature" "enable_anonymous_signature")
    ("enable_coordinates" "enable_coordinates")
    ("enable_debug" "enable_debug")
    ("enable_remote_exec" "enable_remote_exec")
    ("enable_syslog" "enable_syslog")
    ("enable_ui" "enable_ui")
    ("enable_update_check" "enable_update_check")
    ("id" "id")
    ("leave_on_int" "leave_on_int")
    ("leave_on_term" "leave_on_term")
    ("log_level" "log_level")
    ("name" "name")
    ("performance" "performance")
    ("pid_file" "pid_file")
    ("ports" "ports")
    ("protocol_version" "protocol_version")
    ("reconnect_timeout_lan" "reconnect_timeout_lan")
    ("reconnect_timeout_wan" "reconnect_timeout_wan")
    ("rejoin_after_leave" "rejoin_after_leave")
    ("retry_join" "retry_join")
    ("retry_join_ec2" "retry_join_ec2 - A map of EC2 retry attributes.  See below for details on the available information.")
    ("retry_join_gce" "retry_join_gce - A map of GCE retry attributes.  See below for details on the available information.")
    ("retry_join_wan" "retry_join_wan")
    ("retry_max_attempts" "retry_max_attempts")
    ("retry_max_attempts_wan" "retry_max_attempts_wan")
    ("serf_lan_bind_addr" "serf_lan_bind_addr")
    ("serf_wan_bind_addr" "serf_wan_bind_addr")
    ("server_mode" "server_mode")
    ("server_name" "server_name")
    ("session_ttl_min" "session_ttl_min")
    ("start_join" "start_join")
    ("start_join_wan" "start_join_wan")
    ("syslog_facility" "syslog_facility")
    ("tls_ca_file" "tls_ca_file")
    ("tls_cert_file" "tls_cert_file")
    ("tls_key_file" "tls_key_file")
    ("tls_min_version" "tls_min_version")
    ("tls_verify_incoming" "tls_verify_incoming")
    ("tls_verify_outgoing" "tls_verify_outgoing")
    ("tls_verify_server_hostname" "tls_verify_server_hostname")
    ("tagged_addresses" "tagged_addresses")
    ("telemetry" "telemetry - A map of telemetry configuration.")
    ("translate_wan_addrs" "translate_wan_addrs")
    ("ui_dir" "ui_dir")
    ("unix_sockets" "unix_sockets")
    ("version" "version - The version of the Consul agent.")
    ("version_prerelease" "version_prerelease")
    ("version_revision" "version_revision")

  ) company-terraform-data-attributes-hash)

(puthash "consul_catalog_nodes" '(
    ("datacenter" "datacenter - The datacenter the keys are being read from to.")
    ("node_ids" "node_ids - A list of the Consul node IDs.")
    ("node_names" "node_names - A list of the Consul node names.")
    ("nodes" "nodes - A list of nodes and details about each Consul agent.  The list of per-node attributes is detailed below.")

  ) company-terraform-data-attributes-hash)

(puthash "consul_catalog_service" '(
    ("datacenter" "datacenter - The datacenter the keys are being read from to.")
    ("name" "name - The name of the service")
    ("tag" "tag - The name of the tag used to filter the list of nodes in service.")
    ("service" "service - A list of nodes and details about each endpoint advertising a service.  Each element in the list is a map of attributes that correspond to each individual node.  The list of per-node attributes is detailed below.")

  ) company-terraform-data-attributes-hash)

(puthash "consul_catalog_services" '(
    ("datacenter" "datacenter - The datacenter the keys are being read from to.")
    ("names" "names - A list of the Consul services found.  This will always contain the list of services found.")
    ("services.<service>" "services.<service> - For each name given, the corresponding attribute is a Terraform map of services and their tags.  The value is an alphanumerically sorted, whitespace delimited set of tags associated with the service.")
    ("tags" "tags - A map of the tags found for each service.  If more than one service shares the same tag, unique service names will be joined by whitespace (this is the inverse of services and can be used to lookup the services that match a single tag).")

  ) company-terraform-data-attributes-hash)

(puthash "consul_keys" '(
    ("datacenter" "datacenter - The datacenter the keys are being read from to.")
    ("var.<name>" "var.<name> - For each name given, the corresponding attribute has the value of the key.")

  ) company-terraform-data-attributes-hash)

(puthash "digitalocean_image" '(
    ("name" "name - See Argument Reference above.")
    ("image" "image - The id of the image.")
    ("min_disk_size" "min_disk_size: The minimum 'disk' required for the image.")
    ("private" "private - Is image a public image or not. Public images represents Linux distributions or Application, while non-public images represent snapshots and backups and are only available within your account.")
    ("regions" "regions: The regions that the image is available in.")
    ("size_gigabytes" "size_gigabytes: The size of the image in gigabytes.")
    ("type" "type: Type of the image. Can be \"snapshot\" or \"backup\".")

  ) company-terraform-data-attributes-hash)

(puthash "dns_a_record_set" '(
    ("id" "id - Set to host.")
    ("addrs" "addrs - A list of IP addresses. IP addresses are always sorted to avoid constant changing plans.")

  ) company-terraform-data-attributes-hash)

(puthash "dns_aaaa_record_set" '(
    ("id" "id - Set to host.")
    ("addrs" "addrs - A list of IP addresses. IP addresses are always sorted to avoid constant changing plans.")

  ) company-terraform-data-attributes-hash)

(puthash "dns_cname_record_set" '(
    ("id" "id - Set to host.")
    ("cname" "cname - A CNAME record associated with host.")

  ) company-terraform-data-attributes-hash)

(puthash "dns_txt_record_set" '(
    ("id" "id - Set to host.")
    ("record" "record - The first TXT record.")
    ("records" "records - A list of TXT records.")

  ) company-terraform-data-attributes-hash)

(puthash "docker_registry_image" '(
    ("sha256_digest" "sha256_digest (string) - The content digest of the image, as stored on the registry.")

  ) company-terraform-data-attributes-hash)

(puthash "Data Source" '(
    ("result" "result - A map of string values returned from the external program.")

  ) company-terraform-data-attributes-hash)

(puthash "fastly_ip_ranges" '(
    ("cidr_blocks" "cidr_blocks - The lexically ordered list of CIDR blocks.")

  ) company-terraform-data-attributes-hash)

(puthash "github_ip_ranges" '(
    ("hooks" "hooks - An Array of IP addresses in CIDR format specifying the addresses that incoming service hooks will originate from.")
    ("git" "git - An Array of IP addresses in CIDR format specifying the Git servers.")
    ("pages" "pages - An Array of IP addresses in CIDR format specifying the A records for GitHub Pages.")

  ) company-terraform-data-attributes-hash)

(puthash "github_user" '(
    ("login" "login - the user's login.")
    ("avatar_url" "avatar_url - the user's avatar URL.")
    ("gravatar_id" "gravatar_id - the user's gravatar ID.")
    ("site_admin" "site_admin - whether the user is a Github admin.")
    ("name" "name - the user's full name.")
    ("company" "company - the user's company name.")
    ("blog" "blog - the user's blog location.")
    ("location" "location - the user's location.")
    ("email" "email - the user's email.")
    ("gpg_keys" "gpg_keys - list of user's GPG keys")
    ("ssh_keys" "ssh_keys - list of user's SSH keys")
    ("bio" "bio - the user's bio.")
    ("public_repos" "public_repos - the number of public repositories.")
    ("public_gists" "public_gists - the number of public gists.")
    ("followers" "followers - the number of followers.")
    ("following" "following - the number of following users.")
    ("created_at" "created_at - the creation date.")
    ("updated_at" "updated_at - the update date.")

  ) company-terraform-data-attributes-hash)

(puthash "github_team" '(
    ("id" "id - the ID of the team.")
    ("name" "name - the team's full name.")
    ("description" "description - the team's description.")
    ("privacy" "privacy - the team's privacy type.")
    ("permission" "permission - the team's permission level.")
    ("members" "members - List of team members")

  ) company-terraform-data-attributes-hash)

(puthash "google_billing_account" '(
    ("id" "id - The billing account ID.")
    ("name" "name - The resource name of the billing account in the form billingAccounts/{billing_account_id}.")
    ("project_ids" "project_ids - The IDs of any projects associated with the billing account.")

  ) company-terraform-data-attributes-hash)

(puthash "google_client_config" '(
    ("project" "project - The ID of the project to apply any resources to.")
    ("region" "region - The region to operate under.")
    ("access_token" "access_token - The OAuth2 access token used by the client to authenticate against the Google Cloud API.")

  ) company-terraform-data-attributes-hash)

(puthash "google_cloudfunctions_function" '(
    ("name" "name - The name of the Cloud Function.")
    ("source_archive_bucket" "source_archive_bucket - The GCS bucket containing the zip archive which contains the function.")
    ("source_archive_object" "source_archive_object - The source archive object (file) in archive bucket.")
    ("description" "description - Description of the function.")
    ("available_memory_mb" "available_memory_mb - Available memory (in MB) to the function.")
    ("timeout" "timeout - Function execution timeout (in seconds).")
    ("entry_point" "entry_point - Name of a JavaScript function that will be executed when the Google Cloud Function is triggered.")
    ("trigger_http" "trigger_http - If function is triggered by HTTP, this boolean is set.")
    ("trigger_bucket" "trigger_bucket - If function is triggered by bucket, bucket name is set here.")
    ("trigger_topic" "trigger_topic - If function is triggered by Pub/Sub topic, name of topic is set here.")
    ("https_trigger_url" "https_trigger_url - If function is triggered by HTTP, trigger URL is set here.")
    ("labels" "labels - A map of labels applied to this function.")

  ) company-terraform-data-attributes-hash)

(puthash "google_compute_address" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("address" "address - The IP of the created resource.")
    ("status" "status - Indicates if the address is used. Possible values are: RESERVED or IN_USE.")

  ) company-terraform-data-attributes-hash)

(puthash "google_compute_default_service_account" '(
    ("email" "email - Email address of the default service account used by VMs running in this project")

  ) company-terraform-data-attributes-hash)

(puthash "google_compute_image" '(
    ("self_link" "self_link - The URI of the image.")
    ("name" "name - The name of the image.")
    ("family" "family - The family name of the image.")
    ("disk_size_gb" "disk_size_gb - The size of the image when restored onto a persistent disk in gigabytes.")
    ("archive_size_bytes" "archive_size_bytes - The size of the image tar.gz archive stored in Google Cloud Storage in bytes.")
    ("image_id" "image_id - The unique identifier for the image.")
    ("image_encryption_key_sha256" "image_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this image.")
    ("source_image_id" "source_image_id - The ID value of the image used to create this image.")
    ("source_disk" "source_disk - The URL of the source disk used to create this image.")
    ("source_disk_encryption_key_sha256" "source_disk_encryption_key_sha256 - The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this image.")
    ("source_disk_id" "source_disk_id - The ID value of the disk used to create this image.")
    ("creation_timestamp" "creation_timestamp - The creation timestamp in RFC3339 text format.")
    ("description" "description - An optional description of this image.")
    ("labels" "labels - A map of labels applied to this image.")
    ("label_fingerprint" "label_fingerprint - A fingerprint for the labels being applied to this image.")
    ("licenses" "licenses - A list of applicable license URI.")
    ("status" "status - The status of the image. Possible values are FAILED, PENDING, or READY.")

  ) company-terraform-data-attributes-hash)

(puthash "google_compute_forwarding_rule" '(
    ("description" "description - Description of this forwarding rule.")
    ("network" "network - Network of this forwarding rule.")
    ("subnetwork" "subnetwork - Subnetwork of this forwarding rule.")
    ("ip_address" "ip_address - IP address of this forwarding rule.")
    ("ip_protocol" "ip_protocol - IP protocol of this forwarding rule.")
    ("ports" "ports - List of ports to use for internal load balancing, if this forwarding rule has any.")
    ("port_range" "port_range - Port range, if this forwarding rule has one.")
    ("target" "target - URL of the target pool, if this forwarding rule has one.")
    ("backend_service" "backend_service - Backend service, if this forwarding rule has one.")
    ("load_balancing_scheme" "load_balancing_scheme - Type of load balancing of this forwarding rule.")
    ("region" "region - Region of this forwarding rule.")
    ("self_link" "self_link - The URI of the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "google_compute_global_address" '(
    ("self_link" "self_link - The URI of the created resource.")
    ("address" "address - The IP of the created resource.")
    ("status" "status - Indicates if the address is used. Possible values are: RESERVED or IN_USE.")

  ) company-terraform-data-attributes-hash)

(puthash "google_compute_network" '(
    ("network" "network - The network name or resource link to the parent network of this network.")
    ("description" "description - Description of this network.")
    ("gateway_ipv4" "gateway_ipv4 - The IP address of the gateway.")
    ("subnetworks_self_links" "subnetworks_self_links - the list of subnetworks which belong to the network")
    ("self_link" "self_link - The URI of the resource.")

  ) company-terraform-data-attributes-hash)

(puthash "Data Source" '(
    ("body" "body - The raw body of the HTTP response.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_config" '(
    ("rendered" "rendered - The final rendered template.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_disk" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_raid" '(
    ("id" "id - ID used to reference this resource in ignition_config")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_filesystem" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_file" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_link" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_directory" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_systemd_unit" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_networkd_unit" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_user" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "ignition_group" '(
    ("id" "id - ID used to reference this resource in ignition_config.")

  ) company-terraform-data-attributes-hash)

(puthash "kubernetes_service" '(

  ) company-terraform-data-attributes-hash)

(puthash "kubernetes_storage_class" '(

  ) company-terraform-data-attributes-hash)

(puthash "file" '(

  ) company-terraform-data-attributes-hash)

(puthash "logentries_logset" '(
    ("name" "name - Name of the LogSet to query.")

  ) company-terraform-data-attributes-hash)

(puthash "logicmonitor_collectors" '(

  ) company-terraform-data-attributes-hash)

(puthash "logicmonitor_device_group" '(

  ) company-terraform-data-attributes-hash)

(puthash "newrelic_application" '(
    ("id" "id - The ID of the application.")
    ("instance_ids" "instance_ids - A list of instance IDs associated with the application.")
    ("host_ids" "host_ids - A list of host IDs associated with the application.")

  ) company-terraform-data-attributes-hash)

(puthash "key_transaction" '(
    ("id" "id - The ID of the application.")

  ) company-terraform-data-attributes-hash)

(puthash "nomad_regions" '(

  ) company-terraform-data-attributes-hash)

(puthash "openstack_compute_flavor_v2" '(
    ("is_public" "is_public - Whether the flavor is public or private.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_compute_keypair_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("public_key" "public_key - The OpenSSH-formatted public key of the keypair.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_dns_zone_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("email" "email - See Argument Reference above.")
    ("type" "type - See Argument Reference above.")
    ("ttl" "ttl - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("status" "status - See Argument Reference above.")
    ("attributes" "attributes - Attributes of the DNS Service scheduler.")
    ("masters" "masters - An array of master DNS servers. When type is  SECONDARY.")
    ("created_at" "created_at - The time the zone was created.")
    ("updated_at" "updated_at - The time the zone was last updated.")
    ("transferred_at" "transferred_at - The time the zone was transferred.")
    ("version" "version - The version of the zone.")
    ("serial" "serial - The serial number of the zone.")
    ("pool_id" "pool_id - The ID of the pool hosting the zone.")
    ("project_id" "project_id - The project ID that owns the zone.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_identity_project_v3" '(
    ("description" "description - The description of the project.")
    ("domain_id" "domain_id - See Argument Reference above.")
    ("enabled" "enabled - See Argument Reference above.")
    ("is_domain" "is_domain - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("parent_id" "parent_id - See Argument Reference above.")
    ("region" "region - The region the project is located in.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_identity_role_v3" '(
    ("name" "name - See Argument Reference above.")
    ("domain_id" "domain_id - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_identity_user_v3" '(
    ("default_project_id" "default_project_id - See Argument Reference above.")
    ("domain_id" "domain_id - See Argument Reference above.")
    ("enabled" "enabled - See Argument Reference above.")
    ("idp_id" "idp_id - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("password_expires_at" "password_expires_at - See Argument Reference above.")
    ("protocol_id" "protocol_id - See Argument Reference above.")
    ("region" "region - The region the user is located in.")
    ("unique_id" "unique_id - See Argument Reference above.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_identity_auth_scope_v3" '(
    ("user_name" "user_name - The username of the scope.")
    ("user_id" "user_id - The user ID the of the scope.")
    ("user_domain_name" "user_domain_name - The domain name of the user.")
    ("user_domain_id" "user_domain_id - The domain ID of the user.")
    ("project_name" "project_name - The project name of the scope.")
    ("project_id" "project_id - The project ID of the scope.")
    ("project_domain_name" "project_domain_name - The domain name of the project.")
    ("project_domain_id" "project_domain_id - The domain ID of the project.")
    ("roles" "roles - A list of roles in the current scope. See reference below.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_images_image_v2" '(
    ("checksum" "checksum - The checksum of the data associated with the image.")
    ("created_at" "created_at - The date the image was created.")
    ("container_format" "container_format: The format of the image's container.")
    ("disk_format" "disk_format: The format of the image's disk.")
    ("file" "file - the trailing path after the glance endpoint that represent the location of the image or the path to retrieve it.")
    ("metadata" "metadata - The metadata associated with the image. Image metadata allow for meaningfully define the image properties and tags. See http://docs.openstack.org/developer/glance/metadefs-concepts.html.")
    ("min_disk_gb" "min_disk_gb - The minimum amount of disk space required to use the image.")
    ("min_ram_mb" "min_ram_mb - The minimum amount of ram required to use the image.")
    ("properties" "properties - Freeform information about the image.")
    ("protected" "protected - Whether or not the image is protected.")
    ("schema" "schema - The path to the JSON-schema that represent the image or image")
    ("size_bytes" "size_bytes - The size of the image (in bytes).")
    ("tags" "tags - See Argument Reference above.")
    ("update_at" "update_at - The date the image was last updated.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_networking_network_v2" '(
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the network.")
    ("name" "name - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")
    ("shared" "shared - (Optional)  Specifies whether the network resource can be accessed by any tenant or not.")
    ("availability_zone_hints" "availability_zone_hints - (Optional) The availability zone candidates for the network.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_networking_secgroup_v2" '(
    ("name" "name - See Argument Reference above.")
    ("description" "description- The description of the security group.")
    ("region" "region - See Argument Reference above.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_networking_subnet_v2" '(
    ("allocation_pools" "allocation_pools - Allocation pools of the subnet.")
    ("enable_dhcp" "enable_dhcp - Whether the subnet has DHCP enabled or not.")
    ("dns_nameservers" "dns_nameservers - DNS Nameservers of the subnet.")
    ("host_routes" "host_routes - Host Routes of the subnet.")
    ("region" "region - See Argument Reference above.")

  ) company-terraform-data-attributes-hash)

(puthash "openstack_networking_subnetpool_v2" '(
    ("region" "region - See Argument Reference above.")
    ("name" "name - See Argument Reference above.")
    ("default_quota" "default_quota - See Argument Reference above.")
    ("project_id" "project_id - See Argument Reference above.")
    ("created_at" "created_at -  The time at which subnetpool was created.")
    ("updated_at" "updated_at - The time at which subnetpool was created.")
    ("prefixes" "prefixes - See Argument Reference above.")
    ("default_prefixlen" "default_prefixlen - See Argument Reference above.")
    ("min_prefixlen" "min_prefixlen - See Argument Reference above.")
    ("max_prefixlen" "max_prefixlen - See Argument Reference above.")
    ("address_scope_id" "address_scope_id - See Argument Reference above.")
    ("ip_version" "ip_version -The IP protocol version.")
    ("shared" "shared - See Argument Reference above.")
    ("description" "description - See Argument Reference above.")
    ("is_default" "is_default - See Argument Reference above.")
    ("revision_number" "revision_number - The revision number of the subnetpool.")

  ) company-terraform-data-attributes-hash)

(puthash "opentelekomcloud_images_image_v2" '(
    ("checksum" "checksum - The checksum of the data associated with the image.")
    ("created_at" "created_at - The date the image was created.")
    ("container_format" "container_format: The format of the image's container.")
    ("disk_format" "disk_format: The format of the image's disk.")
    ("file" "file - the trailing path after the glance endpoint that represent the location of the image or the path to retrieve it.")
    ("metadata" "metadata - The metadata associated with the image. Image metadata allow for meaningfully define the image properties and tags. See http://docs.openstack.org/developer/glance/metadefs-concepts.html.")
    ("min_disk_gb" "min_disk_gb: The minimum amount of disk space required to use the image.")
    ("min_ram_mb" "min_ram_mb: The minimum amount of ram required to use the image.")
    ("protected" "protected - Whether or not the image is protected.")
    ("schema" "schema - The path to the JSON-schema that represent the image or image")
    ("size_bytes" "size_bytes - The size of the image (in bytes).")
    ("tags" "tags - See Argument Reference above.")
    ("update_at" "update_at - The date the image was last updated.")

  ) company-terraform-data-attributes-hash)

(puthash "opentelekomcloud_networking_network_v2" '(
    ("admin_state_up" "admin_state_up - (Optional) The administrative state of the network.")
    ("name" "name - See Argument Reference above.")
    ("region" "region - See Argument Reference above.")
    ("shared" "shared - (Optional)  Specifies whether the network resource can be accessed by any tenant or not.")

  ) company-terraform-data-attributes-hash)

(puthash "opentelekomcloud_networking_secgroup_v2" '(
    ("name" "name - See Argument Reference above.")
    ("description" "description- The description of the security group.")
    ("region" "region - See Argument Reference above.")

  ) company-terraform-data-attributes-hash)

(puthash "opsgenie_user" '(
    ("full_name" "full_name - The full name of the found user.")
    ("role" "role - The role of the found user.")

  ) company-terraform-data-attributes-hash)

(puthash "opc_compute_image_list_entry" '(
    ("dns" "dns - Array of DNS servers for the interface.")
    ("attributes" "attributes - JSON object of all of the image list's attributes")
    ("machine_images" "machine_images - An array of machine images as strings")
    ("uri" "uri - The URI of the image list")

  ) company-terraform-data-attributes-hash)

(puthash "opc_compute_machine_image" '(
    ("file" "file - The name of the Machine Image .tar.gz file in the compute_images storage container.")
    ("description" "description - A description of the Machine Image.")
    ("attributes" "attributes - An optional JSON object of arbitrary attributes to be made available to the instance. These are user-defined tags. After defining attributes, you can view them from within an instance at http://192.0.0.192/")
    ("error_reason" "error_reason - Description of the state of the machine image if there is an error.")
    ("hypervisor" "hypervisor -  Dictionary of hypervisor-specific attributes.")
    ("image_format" "image_format - The format of the image.")
    ("platform" "platform - The OS platform of the image.")
    ("state" "state - The state of the uploaded machine image.")
    ("uri" "uri - The Uniform Resource Identifier for the Machine Image.")

  ) company-terraform-data-attributes-hash)

(puthash "opc_compute_network_interface" '(
    ("dns" "dns - Array of DNS servers for the interface.")
    ("ip_address" "ip_address - IP Address assigned to the interface.")
    ("ip_network" "ip_network - The IP Network assigned to the interface.")
    ("is_default_gateway" "is_default_gateway - Whether or not the the interface is the default gateway.")
    ("mac_address" "mac_address - The MAC address of the interface.")
    ("model" "model - The model of the NIC card used.")
    ("name_servers" "name_servers - Array of name servers for the interface.")
    ("nat" "nat - The IP Reservation (in IP Networks) associated with the interface.")
    ("search_domains" "search_domains - The search domains that are sent through DHCP as option 119.")
    ("sec_lists" "sec_lists - The security lists the interface is added to.")
    ("shared_network" "shared_network - Whether or not the interface is inside the Shared Network or an IP Network.")
    ("vnic" "vnic - The name of the vNIC created for the IP Network.")
    ("vnic_sets" "vnic_sets - The array of vNIC Sets the interface was added to.")

  ) company-terraform-data-attributes-hash)

(puthash "opc_compute_storage_volume_snapshot" '(
    ("account" "account - Account of the snapshot.")
    ("collocated" "collocated - Boolean specifying whether the snapshot is collocated or remote.")
    ("description" "description - The description of the storage volume snapshot.")
    ("machine_image_name" "machine_image_name - The name of the machine image that's used in the boot volume from which this snapshot is taken.")
    ("parent_volume_bootable" "parent_volume_bootable - Boolean specifying whether or not the snapshot's parent volume was bootable.")
    ("property" "property - Where the snapshot is stored, whether collocated, or in the Oracle Storage Cloud Service instance.")
    ("platform" "platform - The OS platform this snapshot is compatible with")
    ("size" "size - The size of the snapshot in GB.")
    ("snapshot_timestamp" "snapshot_timestamp - Timestamp of the storage snapshot, generated by storage server. The snapshot will contain data written to the original volume before this time.")
    ("snapshot_id" "snapshot_id - The Oracle ID of the snapshot.")
    ("start_timestamp" "start_timestamp - Timestamp when the snapshot was started.")
    ("status" "status - Status of the snapshot.")
    ("status_detail" "status_detail - Details about the latest state of the storage volume snapshot.")
    ("status_timestamp" "status_timestamp - Indicates the time that the current view of the storage volume snapshot was generated.")
    ("tags" "tags - Comma-separated strings that tag the storage volume.")
    ("uri" "uri - Uniform Resource Identifier")
    ("volume_name" "volume_name - The name of the storage volume that the snapshot was created from")

  ) company-terraform-data-attributes-hash)

(puthash "opc_compute_vnic" '(
    ("description" "description is a description of the Virtual NIC.")
    ("mac_address" "mac_address is the MAC Address of the Virtual NIC.")
    ("tags" "tags is a list of Tags associated with the Virtual NIC.")
    ("transit_flag" "transit_flag is true if the Virtual NIC is of the type transit.")
    ("uri" "uri is the Unique Resource Locator of the Virtual NIC.")

  ) company-terraform-data-attributes-hash)

(puthash "oraclepaas_database_service_instance" '(
    ("apex_url" "apex_url - The URL to use to connect to Oracle Application Express on the service instance.")
    ("availability_domain" "availability_domain - Name of the availability domain within the region where the Oracle Database Cloud Service instance is provisioned.")
    ("backup_destination" "backup_destination- The backup configuration of the service instance.")
    ("character_set" "character_set - The database character set of the database.")
    ("cloud_storage_container" "cloud_storage_container - The Oracle Storage Cloud container for backups.")
    ("compute_site_name" "compute_site_name - The Oracle Cloud location housing the service instance.")
    ("description" "description - The description of the service instance.")
    ("edition" "edition - The software edition of the service instance.")
    ("enterprise_manager_url" "enterprise_manager_url - The URL to use to connect to Enterprise Manager on the service instance.")
    ("failover_database" "failover_database - Indicates whether the service instance hosts an Oracle Data Guard configuration.")
    ("glassfish_url" "glassfish_url - The URL to use to connect to the Oracle GlassFish Server Administration Console on the service instance.")
    ("hybrid_disaster_recovery_ip" "hybrid_disaster_recovery_ip - Data Guard Role of the on-premise instance in Oracle Hybrid Disaster Recovery configuration.")
    ("identity_domain" "identity_domain - The identity domain housing the service instance.")
    ("ip_network" "ip_network - The three-part name of an IP network to which the service instance is added.")
    ("ip_reservations" "ip_reservations - Groups one or more IP reservations in use on this service instance.")
    ("bring_your_own_license" "bring_your_own_license - Indicates whether service instance was provisioned with the 'Bring Your Own License' option.")
    ("level" "level - The service level of the service instance.")
    ("listener_port" "listener_port - The listener port for Oracle Net Services (SQL*Net) connections.")
    ("monitor_url" "monitor_url - The URL to use to connect to Oracle DBaaS Monitor on the service instance.")
    ("national_character_set" "national_character_set - The national character set of the database.")
    ("pluggable_database_name" "pluggable_database_name - The name of the default PDB (pluggable database) created when the service instance was created.")
    ("region" "region - Location where the service instance is provisioned.")
    ("shape" "shape - The Oracle Compute Cloud shape of the service instance.")
    ("high_performance_storage" "high_performance_storage - Indicates whether the service instance was provisioned with high performance storage.")
    ("uri" "uri - The REST endpoint URI of the service instance.")
    ("version" "version - The Oracle Database version on the service instance.")

  ) company-terraform-data-attributes-hash)

(puthash "precreated_ip_block" '(
    ("cidr_notation" "cidr_notation - CIDR notation of the looked up block.")

  ) company-terraform-data-attributes-hash)

(puthash "pagerduty_escalation_policy" '(
    ("name" "name - The short name of the found escalation policy.")

  ) company-terraform-data-attributes-hash)

(puthash "pagerduty_extension_schema" '(
    ("name" "name - The short name of the found extension vendor.")
    ("type" "type - The generic service type for this extension vendor.")

  ) company-terraform-data-attributes-hash)

(puthash "pagerduty_schedule" '(
    ("name" "name - The short name of the found schedule.")

  ) company-terraform-data-attributes-hash)

(puthash "pagerduty_user" '(
    ("name" "name - The short name of the found user.")

  ) company-terraform-data-attributes-hash)

(puthash "pagerduty_team" '(
    ("name" "name - The name of the team.")
    ("description" "description - A description of the team.")

  ) company-terraform-data-attributes-hash)

(puthash "pagerduty_vendor" '(
    ("name" "name - The short name of the found vendor.")
    ("type" "type - The generic service type for this vendor.")

  ) company-terraform-data-attributes-hash)

(puthash "panos_system_info" '(

  ) company-terraform-data-attributes-hash)

(puthash "rancher_certificate" '(
    ("id" "id - The ID of the resource.")
    ("cn" "cn - The certificate CN.")
    ("algorithm" "algorithm - The certificate algorithm.")
    ("cert_fingerprint" "cert_fingerprint - The certificate fingerprint.")
    ("expires_at" "expires_at - The certificate expiration date.")
    ("issued_at" "issued_at - The certificate creation date.")
    ("issuer" "issuer - The certificate issuer.")
    ("serial_number" "serial_number - The certificate serial number.")
    ("subject_alternative_names" "subject_alternative_names - The list of certificate Subject Alternative Names.")
    ("version" "version - The certificate version.")

  ) company-terraform-data-attributes-hash)

(puthash "rancher_environment" '(
    ("id" "id - The ID of the resource.")
    ("description" "description - The environment description.")
    ("orchestration" "orchestration - The environment orchestration engine.")
    ("project_template_id" "project_template_id - The environment project template ID.")
    ("member" "member - The environment members.")

  ) company-terraform-data-attributes-hash)

(puthash "rancher_setting" '(
    ("value" "value - the settting's value.")

  ) company-terraform-data-attributes-hash)

(puthash "scaleway_bootscript" '(
    ("architecture" "architecture - architecture of the Bootscript, e.g. arm or x86_64")
    ("organization" "organization - uuid of the organization owning this Bootscript")
    ("public" "public - is this a public bootscript")
    ("boot_cmd_args" "boot_cmd_args - command line arguments used for booting")
    ("dtb" "dtb - path to Device Tree Blob detailing hardware information")
    ("initrd" "initrd - URL to initial ramdisk content")
    ("kernel" "kernel - URL to used kernel")

  ) company-terraform-data-attributes-hash)

(puthash "scaleway_image" '(
    ("architecture" "architecture - architecture of the Image, e.g. arm or x86_64")
    ("organization" "organization - uuid of the organization owning this Image")
    ("public" "public - is this a public bootscript")
    ("creation_date" "creation_date - date when image was created")

  ) company-terraform-data-attributes-hash)

(puthash "template_file" '(
    ("template" "template - See Argument Reference above.")
    ("vars" "vars - See Argument Reference above.")
    ("rendered" "rendered - The final rendered template.")

  ) company-terraform-data-attributes-hash)

(puthash "template_cloudinit_config" '(
    ("rendered" "rendered - The final rendered multi-part cloudinit config.")

  ) company-terraform-data-attributes-hash)

(puthash "terraform_remote_state" '(
    ("backend" "backend - See Argument Reference above.")
    ("config" "config - See Argument Reference above.")

  ) company-terraform-data-attributes-hash)

(puthash "tls_public_key" '(
    ("private_key_pem" "private_key_pem - The private key data in PEM format.")
    ("public_key_pem" "public_key_pem - The public key data in PEM format.")
    ("public_key_openssh" "public_key_openssh - The public key data in OpenSSH authorized_keys format, if the selected private key format is compatible. All RSA keys are supported, and ECDSA keys with curves \"P256\", \"P384\" and \"P251\" are supported. This attribute is empty if an incompatible ECDSA curve is selected.")

  ) company-terraform-data-attributes-hash)

(puthash "triton_account" '(

  ) company-terraform-data-attributes-hash)

(puthash "triton_datacenter" '(

  ) company-terraform-data-attributes-hash)

(puthash "triton_image" '(

  ) company-terraform-data-attributes-hash)

(puthash "triton_network" '(

  ) company-terraform-data-attributes-hash)

(puthash "triton_fabric_vlan" '(

  ) company-terraform-data-attributes-hash)

(puthash "triton_fabric_network" '(

  ) company-terraform-data-attributes-hash)

(puthash "vault_approle_auth_backend_role_id" '(
    ("role_id" "role_id - The RoleID of the role.")

  ) company-terraform-data-attributes-hash)

(puthash "vault_aws_access_credentials" '(
    ("access_key" "access_key - The AWS Access Key ID returned by Vault.")
    ("secret_key" "secret_key - The AWS Secret Key returned by Vault.")
    ("security_token" "security_token - The STS token returned by Vault, if any.")
    ("lease_id" "lease_id - The lease identifier assigned by Vault.")
    ("lease_duration" "lease_duration - The duration of the secret lease, in seconds relative to the time the data was requested. Once this time has passed any plan generated with this data may fail to apply.")
    ("lease_start_time" "lease_start_time - As a convenience, this records the current time on the computer where Terraform is running when the data is requested. This can be used to approximate the absolute time represented by lease_duration, though users must allow for any clock drift and response latency relative to the Vault server.")
    ("lease_renewable" "lease_renewable - true if the lease can be renewed using Vault's sys/renew/{lease-id} endpoint. Terraform does not currently support lease renewal, and so it will request a new lease each time this data source is refreshed.")

  ) company-terraform-data-attributes-hash)

(puthash "vault_generic_secret" '(
    ("data_json" "data_json - A string containing the full data payload retrieved from Vault, serialized in JSON format.")
    ("data" "data - A mapping whose keys are the top-level data keys returned from Vault and whose values are the corresponding values. This map can only represent string data, so any non-string values returned from Vault are serialized as JSON.")
    ("lease_id" "lease_id - The lease identifier assigned by Vault, if any.")
    ("lease_duration" "lease_duration - The duration of the secret lease, in seconds relative to the time the data was requested. Once this time has passed any plan generated with this data may fail to apply.")
    ("lease_start_time" "lease_start_time - As a convenience, this records the current time on the computer where Terraform is running when the data is requested. This can be used to approximate the absolute time represented by lease_duration, though users must allow for any clock drift and response latency relative to to the Vault server.")
    ("lease_renewable" "lease_renewable - true if the lease can be renewed using Vault's sys/renew/{lease-id} endpoint. Terraform does not currently support lease renewal, and so it will request a new lease each time this data source is refreshed.")

  ) company-terraform-data-attributes-hash)

(puthash "nsxt_edge_cluster" '(
    ("description" "description - The description of the edge cluster.")
    ("deployment_type" "deployment_type - This field could show deployment_type of members. It would return UNKNOWN if there is no members, and return VIRTUAL_MACHINE|PHYSICAL_MACHINE if all Edge members are VIRTUAL_MACHINE|PHYSICAL_MACHINE.")
    ("member_node_type" "member_node_type - An Edge cluster is homogeneous collection of NSX transport nodes used for north/south connectivity between NSX logical networking and physical networking. Hence all transport nodes of the cluster must be of same type. This field shows the type of transport node,")

  ) company-terraform-data-attributes-hash)

(puthash "nsxt_logical_tier0_router" '(
    ("description" "description - The description of the logical Tier 0 router.")
    ("edge_cluster_id" "edge_cluster_id - The id of the Edge cluster where this logical router is placed.")
    ("high_availability_mode" "high_availability_mode - The high availability mode of this logical router.")

  ) company-terraform-data-attributes-hash)

(puthash "nsxt_ns_serivce" '(
    ("description" "description - The description of the NS service.")

  ) company-terraform-data-attributes-hash)

(puthash "nsxt_switching_profile" '(
    ("resource_type" "resource_type - The resource type representing the specific type of this switching profile.")
    ("description" "description - The description of the switching profile.")

  ) company-terraform-data-attributes-hash)

(puthash "nsxt_transport_zone" '(
    ("description" "description - The description of the Transport Zone.")
    ("host_switch_name" "host_switch_name - The name of the N-VDS (host switch) on all Transport Nodes in this Transport Zone that will be used to run NSX network traffic.")
    ("transport_type" "transport_type - The transport type of this transport zone (OVERLAY or VLAN).")

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_compute_cluster" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_custom_attribute" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_datacenter" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_datastore" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_datastore_cluster" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_distributed_virtual_switch" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_host" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_network" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_resource_pool" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_tag" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_tag_category" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_virtual_machine" '(

  ) company-terraform-data-attributes-hash)

(puthash "vsphere_vmfs_disks" '(

  ) company-terraform-data-attributes-hash)

(defconst company-terraform-interpolation-functions  '(
    ("abs" "abs(float) - Returns the absolute value of a given float. Example: abs(1) returns 1, and abs(-1) would also return 1, whereas abs(-3.14) would return 3.14. See also the signum function.")
    ("basename" "basename(path) - Returns the last element of a path.")
    ("base64decode" "base64decode(string) - Given a base64-encoded string, decodes it and returns the original string.")
    ("base64encode" "base64encode(string) - Returns a base64-encoded representation of the given string.")
    ("base64gzip" "base64gzip(string) - Compresses the given string with gzip and then encodes the result to base64. This can be used with certain resource arguments that allow binary data to be passed with base64 encoding, since Terraform strings are required to be valid UTF-8.")
    ("base64sha256" "base64sha256(string) - Returns a base64-encoded representation of raw SHA-256 sum of the given string. This is not equivalent of base64encode(sha256(string)) since sha256() returns hexadecimal representation.")
    ("base64sha512" "base64sha512(string) - Returns a base64-encoded representation of raw SHA-512 sum of the given string. This is not equivalent of base64encode(sha512(string)) since sha512() returns hexadecimal representation.")
    ("bcrypt" "bcrypt(password, cost) - Returns the Blowfish encrypted hash of the string  at the given cost. A default cost of 10 will be used if not provided.")
    ("ceil" "ceil(float) - Returns the least integer value greater than or equal   to the argument.")
    ("chomp" "chomp(string) - Removes trailing newlines from the given string.")
    ("chunklist" "chunklist(list, size) - Returns the list items chunked by size. Examples:  chunklist(aws_subnet.foo.*.id, 1): will outputs [[\"id1\"], [\"id2\"], [\"id3\"]]  chunklist(var.list_of_strings, 2): will outputs [[\"id1\", \"id2\"], [\"id3\", \"id4\"], [\"id5\"]]")
    ("cidrhost" "cidrhost(iprange, hostnum) - Takes an IP address range in CIDR notation and creates an IP address with the given host number. If given host number is negative, the count starts from the end of the range. For example, cidrhost(\"10.0.0.0/8\", 2) returns 10.0.0.2 and cidrhost(\"10.0.0.0/8\", -2) returns 10.255.255.254.")
    ("cidrnetmask" "cidrnetmask(iprange) - Takes an IP address range in CIDR notation and returns the address-formatted subnet mask format that some systems expect for IPv4 interfaces. For example, cidrnetmask(\"10.0.0.0/8\") returns 255.0.0.0. Not applicable to IPv6 networks since CIDR notation is the only valid notation for IPv6.")
    ("cidrsubnet" "cidrsubnet(iprange, newbits, netnum) - Takes an IP address range in CIDR notation (like 10.0.0.0/8) and extends its prefix to include an additional subnet number. For example, cidrsubnet(\"10.0.0.0/8\", 8, 2) returns 10.2.0.0/16; cidrsubnet(\"2607:f298:6051:516c::/64\", 8, 2) returns 2607:f298:6051:516c:200::/72.")
    ("coalesce" "coalesce(string1, string2, ...) - Returns the first non-empty value from the given arguments. At least two arguments must be provided.")
    ("coalescelist" "coalescelist(list1, list2, ...) - Returns the first non-empty list from the given arguments. At least two arguments must be provided.")
    ("compact" "compact(list) - Removes empty string elements from a list. This can be  useful in some cases, for example when passing joined lists as module  variables or when parsing module outputs.  Example: compact(module.my_asg.load_balancer_names)")
    ("concat" "concat(list1, list2, ...) - Combines two or more lists into a single list.  Example: concat(aws_instance.db.*.tags.Name, aws_instance.web.*.tags.Name)")
    ("contains" "contains(list, element) - Returns true if a list contains the given element  and returns false otherwise. Examples: contains(var.list_of_strings, \"an_element\")")
    ("dirname" "dirname(path) - Returns all but the last element of path, typically the path's directory.")
    ("distinct" "distinct(list) - Removes duplicate items from a list. Keeps the first  occurrence of each element, and removes subsequent occurrences. This  function is only valid for flat lists. Example: distinct(var.usernames)")
    ("element" "element(list, index) - Returns a single element from a list   at the given index. If the index is greater than the number of   elements, this function will wrap using a standard mod algorithm.   This function only works on flat lists. Examples:  element(aws_subnet.foo.*.id, count.index)  element(var.list_of_strings, 2)")
    ("file" "file(path) - Reads the contents of a file into the string. Variables   in this file are not interpolated. The contents of the file are   read as-is. The path is interpreted relative to the working directory.   Path variables can be used to reference paths relative   to other base locations. For example, when using file() from inside a   module, you generally want to make the path relative to the module base,   like this: file(\"${path.module}/file\").")
    ("floor" "floor(float) - Returns the greatest integer value less than or equal to   the argument.")
    ("flatten" "flatten(list of lists) - Flattens lists of lists down to a flat list of    primitive values, eliminating any nested lists recursively. Examples:  flatten(data.github_user.user.*.gpg_keys)")
    ("format" "format(format, args, ...) - Formats a string according to the given   format. The syntax for the format is standard sprintf syntax.   Good documentation for the syntax can be found here.   Example to zero-prefix a count, used commonly for naming servers:   format(\"web-%03d\", count.index + 1).")
    ("formatlist" "formatlist(format, args, ...) - Formats each element of a list   according to the given format, similarly to format, and returns a list.   Non-list arguments are repeated for each list element.   For example, to convert a list of DNS addresses to a list of URLs, you might use:   formatlist(\"https://%s:%s/\", aws_instance.foo.*.public_dns, var.port).   If multiple args are lists, and they have the same number of elements, then the formatting is applied to the elements of the lists in parallel.   Example:   formatlist(\"instance %v has private ip %v\", aws_instance.foo.*.id, aws_instance.foo.*.private_ip).   Passing lists with different lengths to formatlist results in an error.")
    ("indent" "indent(numspaces, string) - Prepends the specified number of spaces to all but the first   line of the given multi-line string. May be useful when inserting a multi-line string   into an already-indented context. The first line is not indented, to allow for the   indented string to be placed after some sort of already-indented preamble.   Example: \"    \\\"items\\\": ${ indent(4, \"[\\n    \\\"item1\\\"\\n]\") },\"")
    ("index" "index(list, elem) - Finds the index of a given element in a list.   This function only works on flat lists.   Example: index(aws_instance.foo.*.tags.Name, \"foo-test\")")
    ("join" "join(delim, list) - Joins the list with the delimiter for a resultant string.   This function works only on flat lists.   Examples:  join(\",\", aws_instance.foo.*.id)  join(\",\", var.ami_list)")
    ("jsonencode" "jsonencode(value) - Returns a JSON-encoded representation of the given   value, which can contain arbitrarily-nested lists and maps. Note that if   the value is a string then its value will be placed in quotes.")
    ("keys" "keys(map) - Returns a lexically sorted list of the map keys.")
    ("length" "length(list) - Returns the number of members in a given list or map, or the number of characters in a given string.  ${length(split(\",\", \"a,b,c\"))} = 3  ${length(\"a,b,c\")} = 5  ${length(map(\"key\", \"val\"))} = 1")
    ("list" "list(items, ...) - Returns a list consisting of the arguments to the function.   This function provides a way of representing list literals in interpolation.  ${list(\"a\", \"b\", \"c\")} returns a list of \"a\", \"b\", \"c\".  ${list()} returns an empty list.")
    ("log" "log(x, base) - Returns the logarithm of x.")
    ("lookup" "lookup(map, key, [default]) - Performs a dynamic lookup into a map   variable. The map parameter should be another variable, such   as var.amis. If key does not exist in map, the interpolation will   fail unless you specify a third argument, default, which should be a   string value to return if no key is found in map. This function   only works on flat maps and will return an error for maps that   include nested lists or maps.")
    ("lower" "lower(string) - Returns a copy of the string with all Unicode letters mapped to their lower case.")
    ("map" "map(key, value, ...) - Returns a map consisting of the key/value pairs specified as arguments. Every odd argument must be a string key, and every even argument must have the same type as the other values specified. Duplicate keys are not allowed. Examples:  map(\"hello\", \"world\")  map(\"us-east\", list(\"a\", \"b\", \"c\"), \"us-west\", list(\"b\", \"c\", \"d\"))")
    ("matchkeys" "matchkeys(values, keys, searchset) - For two lists values and keys of   equal length, returns all elements from values where the corresponding   element from keys exists in the searchset list.  E.g.   matchkeys(aws_instance.example.*.id,   aws_instance.example.*.availability_zone, list(\"us-west-2a\")) will return a   list of the instance IDs of the aws_instance.example instances in   \"us-west-2a\". No match will result in empty list. Items of keys are   processed sequentially, so the order of returned values is preserved.")
    ("max" "max(float1, float2, ...) - Returns the largest of the floats.")
    ("merge" "merge(map1, map2, ...) - Returns the union of 2 or more maps. The maps are consumed in the order provided, and duplicate keys overwrite previous entries.  ${merge(map(\"a\", \"b\"), map(\"c\", \"d\"))} returns {\"a\": \"b\", \"c\": \"d\"}")
    ("min" "min(float1, float2, ...) - Returns the smallest of the floats.")
    ("md5" "md5(string) - Returns a (conventional) hexadecimal representation of the MD5 hash of the given string.")
    ("pathexpand" "pathexpand(string) - Returns a filepath string with ~ expanded to the home directory. Note: This will create a plan diff between two different hosts, unless the filepaths are the same.")
    ("pow" "pow(x, y) - Returns the base x of exponential y as a float. Example:  ${pow(3,2)} = 9  ${pow(4,0)} = 1")
    ("replace" "replace(string, search, replace) - Does a search and replace on the   given string. All instances of search are replaced with the value   of replace. If search is wrapped in forward slashes, it is treated   as a regular expression. If using a regular expression, replace   can reference subcaptures in the regular expression by using $n where   n is the index or name of the subcapture. If using a regular expression,   the syntax conforms to the re2 regular expression syntax.")
    ("rsadecrypt" "rsadecrypt(string, key) - Decrypts string using RSA. The padding scheme PKCS #1 v1.5 is used. The string must be base64-encoded. key must be an RSA private key in PEM format. You may use file() to load it from a file.")
    ("sha1" "sha1(string) - Returns a (conventional) hexadecimal representation of the SHA-1 hash of the given string. Example: \"${sha1(\"${aws_vpc.default.tags.customer}-s3-bucket\")}\"")
    ("sha256" "sha256(string) - Returns a (conventional) hexadecimal representation of the SHA-256 hash of the given string. Example: \"${sha256(\"${aws_vpc.default.tags.customer}-s3-bucket\")}\"")
    ("sha512" "sha512(string) - Returns a (conventional) hexadecimal representation of the SHA-512 hash of the given string. Example: \"${sha512(\"${aws_vpc.default.tags.customer}-s3-bucket\")}\"")
    ("signum" "signum(integer) - Returns -1 for negative numbers, 0 for 0 and 1 for positive numbers.   This function is useful when you need to set a value for the first resource and   a different value for the rest of the resources.   Example: element(split(\",\", var.r53_failover_policy), signum(count.index))   where the 0th index points to PRIMARY and 1st to FAILOVER")
    ("slice" "slice(list, from, to) - Returns the portion of list between from (inclusive) and to (exclusive).   Example: slice(var.list_of_strings, 0, length(var.list_of_strings) - 1)")
    ("sort" "sort(list) - Returns a lexographically sorted list of the strings contained in   the list passed as an argument. Sort may only be used with lists which contain only   strings.   Examples: sort(aws_instance.foo.*.id), sort(var.list_of_strings)")
    ("split" "split(delim, string) - Splits the string previously created by join   back into a list. This is useful for pushing lists through module   outputs since they currently only support string values. Depending on the   use, the string this is being performed within may need to be wrapped   in brackets to indicate that the output is actually a list, e.g.   a_resource_param = [\"${split(\",\", var.CSV_STRING)}\"].   Example: split(\",\", module.amod.server_ids)")
    ("substr" "substr(string, offset, length) - Extracts a substring from the input string. A negative offset is interpreted as being equivalent to a positive offset measured backwards from the end of the string. A length of -1 is interpreted as meaning \"until the end of the string\".")
    ("timestamp" "timestamp() - Returns a UTC timestamp string in RFC 3339 format. This string will change with every invocation of the function, so in order to prevent diffs on every plan & apply, it must be used with the ignore_changes lifecycle attribute.")
    ("timeadd" "timeadd(time, duration) - Returns a UTC timestamp string corresponding to adding a given duration to time in RFC 3339 format. For example, timeadd(\"2017-11-22T00:00:00Z\", \"10m\") produces a value \"2017-11-22T00:10:00Z\".")
    ("title" "title(string) - Returns a copy of the string with the first characters of all the words capitalized.")
    ("transpose" "transpose(map) - Swaps the keys and list values in a map of lists of strings. For example, transpose(map(\"a\", list(\"1\", \"2\"), \"b\", list(\"2\", \"3\")) produces a value equivalent to map(\"1\", list(\"a\"), \"2\", list(\"a\", \"b\"), \"3\", list(\"b\")).")
    ("trimspace" "trimspace(string) - Returns a copy of the string with all leading and trailing white spaces removed.")
    ("upper" "upper(string) - Returns a copy of the string with all Unicode letters mapped to their upper case.")
    ("urlencode" "urlencode(string) - Returns an URL-safe copy of the string.")
    ("uuid" "uuid() - Returns a UUID string in RFC 4122 v4 format. This string will change with every invocation of the function, so in order to prevent diffs on every plan & apply, it must be used with the ignore_changes lifecycle attribute.")
    ("values" "values(map) - Returns a list of the map values, in the order of the keys returned by the keys function. This function only works on flat maps and will return an error for maps that include nested lists or maps.")
    ("zipmap" "zipmap(list, list) - Creates a map from a list of keys and a list of   values. The keys must all be of type string, and the length of the lists   must be the same.   For example, to output a mapping of AWS IAM user names to the fingerprint   of the key used to encrypt their initial password, you might use:   zipmap(aws_iam_user.users.*.name, aws_iam_user_login_profile.users.*.key_fingerprint).")
   ))


(provide 'company-terraform-data)
;;; company-terraform-data.el ends here
